/*! For license information please see module.js.LICENSE.txt */
define(["@grafana/data","rxjs","@grafana/runtime","lodash","react","@grafana/ui","@emotion/css","moment","redux","react-redux"],((e,t,r,n,o,i,a,l,s,u)=>(()=>{var c={8572:(e,t,r)=>{"use strict";r.r(t),r.d(t,{AND:()=>h,AS:()=>f,ASC:()=>c,BY:()=>s,COMPARISON_OPERATORS:()=>E,DESC:()=>u,EQUALS:()=>m,FROM:()=>o,GROUP:()=>a,LIMIT:()=>d,LOGICAL_OPERATORS:()=>y,NOT_EQUALS:()=>b,OR:()=>g,ORDER:()=>l,SCHEMA:()=>v,SELECT:()=>n,STD_OPERATORS:()=>O,WHERE:()=>i,WITH:()=>p,conf:()=>S,language:()=>T});const n="select",o="from",i="where",a="group",l="order",s="by",u="desc",c="asc",d="limit",p="with",f="as",v="schema",h="AND",g="OR",y=[h,g],m="=",b="!=",E=[m,b],O=[...E],S={comments:{lineComment:"--",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}]},T={defaultToken:"",tokenPostfix:".sql",ignoreCase:!0,brackets:[{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"}],keywords:["ABORT","ABSOLUTE","ACTION","ADA","ADD","AFTER","ALL","ALLOCATE","ALTER","ALWAYS","ANALYZE","AND","ANY","ARE","AS","ASC","ASSERTION","AT","ATTACH","AUTHORIZATION","AUTOINCREMENT","AVG","BACKUP","BEFORE","BEGIN","BETWEEN","BIT","BIT_LENGTH","BOTH","BREAK","BROWSE","BULK","BY","CASCADE","CASCADED","CASE","CAST","CATALOG","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CHECKPOINT","CLOSE","CLUSTERED","COALESCE","COLLATE","COLLATION","COLUMN","COMMIT","COMPUTE","CONFLICT","CONNECT","CONNECTION","CONSTRAINT","CONSTRAINTS","CONTAINS","CONTAINSTABLE","CONTINUE","CONVERT","CORRESPONDING","COUNT","CREATE","CROSS","CURRENT","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATE","DAY","DBCC","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFERRABLE","DEFERRED","DELETE","DENY","DESC","DESCRIBE","DESCRIPTOR","DETACH","DIAGNOSTICS","DISCONNECT","DISK","DISTINCT","DISTRIBUTED","DO","DOMAIN","DOUBLE","DROP","DUMP","EACH","ELSE","END","END-EXEC","ERRLVL","ESCAPE","EXCEPT","EXCEPTION","EXCLUDE","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXPLAIN","EXTERNAL","EXTRACT","FAIL","FALSE","FETCH","FILE","FILLFACTOR","FILTER","FIRST","FLOAT","FOLLOWING","FOR","FOREIGN","FORTRAN","FOUND","FREETEXT","FREETEXTTABLE","FROM","FULL","FUNCTION","GENERATED","GET","GLOB","GLOBAL","GO","GOTO","GRANT","GROUP","GROUPS","HAVING","HOLDLOCK","HOUR","IDENTITY","IDENTITYCOL","IDENTITY_INSERT","IF","IGNORE","IMMEDIATE","IN","INCLUDE","INDEX","INDEXED","INDICATOR","INITIALLY","INNER","INPUT","INSENSITIVE","INSERT","INSTEAD","INT","INTEGER","INTERSECT","INTERVAL","INTO","IS","ISNULL","ISOLATION","JOIN","KEY","KILL","LANGUAGE","LAST","LEADING","LEFT","LEVEL","LIKE","LIMIT","LINENO","LOAD","LOCAL","LOWER","MATCH","MATERIALIZED","MAX","MERGE","MIN","MINUTE","MODULE","MONTH","NAMES","NATIONAL","NATURAL","NCHAR","NEXT","NO","NOCHECK","NONCLUSTERED","NONE","NOT","NOTHING","NOTNULL","NULL","NULLIF","NULLS","NUMERIC","OCTET_LENGTH","OF","OFF","OFFSET","OFFSETS","ON","ONLY","OPEN","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","OPTION","OR","ORDER","OTHERS","OUTER","OUTPUT","OVER","OVERLAPS","PAD","PARTIAL","PARTITION","PASCAL","PERCENT","PIVOT","PLAN","POSITION","PRAGMA","PRECEDING","PRECISION","PREPARE","PRESERVE","PRIMARY","PRINT","PRIOR","PRIVILEGES","PROC","PROCEDURE","PUBLIC","QUERY","RAISE","RAISERROR","RANGE","READ","READTEXT","REAL","RECONFIGURE","RECURSIVE","REFERENCES","REGEXP","REINDEX","RELATIVE","RELEASE","RENAME","REPLACE","REPLICATION","RESTORE","RESTRICT","RETURN","RETURNING","REVERT","REVOKE","RIGHT","ROLLBACK","ROW","ROWCOUNT","ROWGUIDCOL","ROWS","RULE","SAVE","SAVEPOINT","SCHEMA","SCROLL","SECOND","SECTION","SECURITYAUDIT","SELECT","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","SESSION","SESSION_USER","SET","SETUSER","SHUTDOWN","SIZE","SMALLINT","SOME","SPACE","SQL","SQLCA","SQLCODE","SQLERROR","SQLSTATE","SQLWARNING","STATISTICS","SUBSTRING","SUM","SYSTEM_USER","TABLE","TABLESAMPLE","TEMP","TEMPORARY","TEXTSIZE","THEN","TIES","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TOP","TRAILING","TRAN","TRANSACTION","TRANSLATE","TRANSLATION","TRIGGER","TRIM","TRUE","TRUNCATE","TRY_CONVERT","TSEQUAL","UNBOUNDED","UNION","UNIQUE","UNKNOWN","UNPIVOT","UPDATE","UPDATETEXT","UPPER","USAGE","USE","USER","USING","VACUUM","VALUE","VALUES","VARCHAR","VARYING","VIEW","VIRTUAL","WAITFOR","WHEN","WHENEVER","WHERE","WHILE","WINDOW","WITH","WITHIN GROUP","WITHOUT","WORK","WRITE","WRITETEXT","YEAR","ZONE"],operators:["EXCEPT","INTERSECT","UNION","APPLY","CROSS","FULL","INNER","JOIN","LEFT","OUTER","RIGHT","CONTAINS","FREETEXT","IS","NULL","PIVOT","UNPIVOT","MATCHED"],logicalOperators:["ALL","AND","ANY","BETWEEN","EXISTS","IN","LIKE","NOT","OR","SOME"],comparisonOperators:["<>",">","<",">=","<=","=","!=","&","~","^","%"],builtinFunctions:["AVG","CHECKSUM_AGG","COUNT","COUNT_BIG","GROUPING","GROUPING_ID","MAX","MIN","SUM","STDEV","STDEVP","VAR","VARP","CUME_DIST","FIRST_VALUE","LAG","LAST_VALUE","LEAD","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","COLLATE","COLLATIONPROPERTY","TERTIARY_WEIGHTS","FEDERATION_FILTERING_VALUE","CAST","CONVERT","PARSE","TRY_CAST","TRY_CONVERT","TRY_PARSE","ASYMKEY_ID","ASYMKEYPROPERTY","CERTPROPERTY","CERT_ID","CRYPT_GEN_RANDOM","DECRYPTBYASYMKEY","DECRYPTBYCERT","DECRYPTBYKEY","DECRYPTBYKEYAUTOASYMKEY","DECRYPTBYKEYAUTOCERT","DECRYPTBYPASSPHRASE","ENCRYPTBYASYMKEY","ENCRYPTBYCERT","ENCRYPTBYKEY","ENCRYPTBYPASSPHRASE","HASHBYTES","IS_OBJECTSIGNED","KEY_GUID","KEY_ID","KEY_NAME","SIGNBYASYMKEY","SIGNBYCERT","SYMKEYPROPERTY","VERIFYSIGNEDBYCERT","VERIFYSIGNEDBYASYMKEY","CURSOR_STATUS","DATALENGTH","IDENT_CURRENT","IDENT_INCR","IDENT_SEED","IDENTITY","SQL_VARIANT_PROPERTY","CURRENT_TIMESTAMP","DATEADD","DATEDIFF","DATEFROMPARTS","DATENAME","DATEPART","DATETIME2FROMPARTS","DATETIMEFROMPARTS","DATETIMEOFFSETFROMPARTS","DAY","EOMONTH","GETDATE","GETUTCDATE","ISDATE","MONTH","SMALLDATETIMEFROMPARTS","SWITCHOFFSET","SYSDATETIME","SYSDATETIMEOFFSET","SYSUTCDATETIME","TIMEFROMPARTS","TODATETIMEOFFSET","YEAR","CHOOSE","COALESCE","IIF","NULLIF","ABS","ACOS","ASIN","ATAN","ATN2","CEILING","COS","COT","DEGREES","EXP","FLOOR","LOG","LOG10","PI","POWER","RADIANS","RAND","ROUND","SIGN","SIN","SQRT","SQUARE","TAN","APP_NAME","APPLOCK_MODE","APPLOCK_TEST","ASSEMBLYPROPERTY","COL_LENGTH","COL_NAME","COLUMNPROPERTY","DATABASE_PRINCIPAL_ID","DATABASEPROPERTYEX","DB_ID","DB_NAME","FILE_ID","FILE_IDEX","FILE_NAME","FILEGROUP_ID","FILEGROUP_NAME","FILEGROUPPROPERTY","FILEPROPERTY","FULLTEXTCATALOGPROPERTY","FULLTEXTSERVICEPROPERTY","INDEX_COL","INDEXKEY_PROPERTY","INDEXPROPERTY","OBJECT_DEFINITION","OBJECT_ID","OBJECT_NAME","OBJECT_SCHEMA_NAME","OBJECTPROPERTY","OBJECTPROPERTYEX","ORIGINAL_DB_NAME","PARSENAME","SCHEMA_ID","SCHEMA_NAME","SCOPE_IDENTITY","SERVERPROPERTY","STATS_DATE","TYPE_ID","TYPE_NAME","TYPEPROPERTY","DENSE_RANK","NTILE","RANK","ROW_NUMBER","PUBLISHINGSERVERNAME","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","CERTENCODED","CERTPRIVATEKEY","CURRENT_USER","HAS_DBACCESS","HAS_PERMS_BY_NAME","IS_MEMBER","IS_ROLEMEMBER","IS_SRVROLEMEMBER","LOGINPROPERTY","ORIGINAL_LOGIN","PERMISSIONS","PWDENCRYPT","PWDCOMPARE","SESSION_USER","SESSIONPROPERTY","SUSER_ID","SUSER_NAME","SUSER_SID","SUSER_SNAME","SYSTEM_USER","USER","USER_ID","USER_NAME","ASCII","CHAR","CHARINDEX","CONCAT","DIFFERENCE","FORMAT","LEFT","LEN","LOWER","LTRIM","NCHAR","PATINDEX","QUOTENAME","REPLACE","REPLICATE","REVERSE","RIGHT","RTRIM","SOUNDEX","SPACE","STR","STUFF","SUBSTRING","UNICODE","UPPER","BINARY_CHECKSUM","CHECKSUM","CONNECTIONPROPERTY","CONTEXT_INFO","CURRENT_REQUEST_ID","ERROR_LINE","ERROR_NUMBER","ERROR_MESSAGE","ERROR_PROCEDURE","ERROR_SEVERITY","ERROR_STATE","FORMATMESSAGE","GETANSINULL","GET_FILESTREAM_TRANSACTION_CONTEXT","HOST_ID","HOST_NAME","ISNULL","ISNUMERIC","MIN_ACTIVE_ROWVERSION","NEWID","NEWSEQUENTIALID","ROWCOUNT_BIG","XACT_STATE","TEXTPTR","TEXTVALID","COLUMNS_UPDATED","EVENTDATA","TRIGGER_NESTLEVEL","UPDATE","CHANGETABLE","CHANGE_TRACKING_CONTEXT","CHANGE_TRACKING_CURRENT_VERSION","CHANGE_TRACKING_IS_COLUMN_IN_MASK","CHANGE_TRACKING_MIN_VALID_VERSION","CONTAINSTABLE","FREETEXTTABLE","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","FILETABLEROOTPATH","GETFILENAMESPACEPATH","GETPATHLOCATOR","PATHNAME","GET_TRANSMISSION_STATUS"],builtinVariables:["@@DATEFIRST","@@DBTS","@@LANGID","@@LANGUAGE","@@LOCK_TIMEOUT","@@MAX_CONNECTIONS","@@MAX_PRECISION","@@NESTLEVEL","@@OPTIONS","@@REMSERVER","@@SERVERNAME","@@SERVICENAME","@@SPID","@@TEXTSIZE","@@VERSION","@@CURSOR_ROWS","@@FETCH_STATUS","@@DATEFIRST","@@PROCID","@@ERROR","@@IDENTITY","@@ROWCOUNT","@@TRANCOUNT","@@CONNECTIONS","@@CPU_BUSY","@@IDLE","@@IO_BUSY","@@PACKET_ERRORS","@@PACK_RECEIVED","@@PACK_SENT","@@TIMETICKS","@@TOTAL_ERRORS","@@TOTAL_READ","@@TOTAL_WRITE"],pseudoColumns:["$ACTION","$IDENTITY","$ROWGUID","$PARTITION"],tokenizer:{root:[{include:"@templateVariables"},{include:"@macros"},{include:"@comments"},{include:"@whitespace"},{include:"@pseudoColumns"},{include:"@numbers"},{include:"@strings"},{include:"@complexIdentifiers"},{include:"@scopes"},{include:"@schemaTable"},[/[;,.]/,"delimiter"],[/[()]/,"@brackets"],[/[\w@#$|<|>|=|!|%|&|+|\|-|*|/|~|^]+/,{cases:{"@operators":"operator","@comparisonOperators":"operator","@logicalOperators":"operator","@builtinVariables":"predefined","@builtinFunctions":"predefined","@keywords":"keyword","@default":"identifier"}}]],templateVariables:[[/\$[a-zA-Z0-9]+/,"variable"]],macros:[[/\$__[a-zA-Z0-9-_]+/,"type"]],schemaTable:[[/(\w+)\./,"identifier"],[/(\w+\.\w+)/,"identifier"]],whitespace:[[/\s+/,"white"]],comments:[[/--+.*/,"comment"],[/\/\*/,{token:"comment.quote",next:"@comment"}]],comment:[[/[^*/]+/,"comment"],[/\*\//,{token:"comment.quote",next:"@pop"}],[/./,"comment"]],pseudoColumns:[[/[$][A-Za-z_][\w@#$]*/,{cases:{"@pseudoColumns":"predefined","@default":"identifier"}}]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/N'/,{token:"string",next:"@string"}],[/'/,{token:"string",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string",next:"@pop"}]],complexIdentifiers:[[/\[/,{token:"identifier.quote",next:"@bracketedIdentifier"}],[/"/,{token:"identifier.quote",next:"@quotedIdentifier"}]],bracketedIdentifier:[[/[^\]]+/,"identifier"],[/]]/,"identifier"],[/]/,{token:"identifier.quote",next:"@pop"}]],quotedIdentifier:[[/[^"]+/,"identifier"],[/""/,"identifier"],[/"/,{token:"identifier.quote",next:"@pop"}]],scopes:[[/BEGIN\s+(DISTRIBUTED\s+)?TRAN(SACTION)?\b/i,"keyword"],[/BEGIN\s+TRY\b/i,{token:"keyword.try"}],[/END\s+TRY\b/i,{token:"keyword.try"}],[/BEGIN\s+CATCH\b/i,{token:"keyword.catch"}],[/END\s+CATCH\b/i,{token:"keyword.catch"}],[/(BEGIN|CASE)\b/i,{token:"keyword.block"}],[/END\b/i,{token:"keyword.block"}],[/WHEN\b/i,{token:"keyword.choice"}],[/THEN\b/i,{token:"keyword.choice"}]]}}},3523:e=>{var t=function(){"use strict";function e(e,t){return null!=t&&e instanceof t}var t,r,n;try{t=Map}catch(e){t=function(){}}try{r=Set}catch(e){r=function(){}}try{n=Promise}catch(e){n=function(){}}function o(i,l,s,u,c){"object"==typeof l&&(s=l.depth,u=l.prototype,c=l.includeNonEnumerable,l=l.circular);var d=[],p=[],f="undefined"!=typeof Buffer;return void 0===l&&(l=!0),void 0===s&&(s=1/0),function i(s,v){if(null===s)return null;if(0===v)return s;var h,g;if("object"!=typeof s)return s;if(e(s,t))h=new t;else if(e(s,r))h=new r;else if(e(s,n))h=new n((function(e,t){s.then((function(t){e(i(t,v-1))}),(function(e){t(i(e,v-1))}))}));else if(o.__isArray(s))h=[];else if(o.__isRegExp(s))h=new RegExp(s.source,a(s)),s.lastIndex&&(h.lastIndex=s.lastIndex);else if(o.__isDate(s))h=new Date(s.getTime());else{if(f&&Buffer.isBuffer(s))return h=Buffer.allocUnsafe?Buffer.allocUnsafe(s.length):new Buffer(s.length),s.copy(h),h;e(s,Error)?h=Object.create(s):void 0===u?(g=Object.getPrototypeOf(s),h=Object.create(g)):(h=Object.create(u),g=u)}if(l){var y=d.indexOf(s);if(-1!=y)return p[y];d.push(s),p.push(h)}for(var m in e(s,t)&&s.forEach((function(e,t){var r=i(t,v-1),n=i(e,v-1);h.set(r,n)})),e(s,r)&&s.forEach((function(e){var t=i(e,v-1);h.add(t)})),s){var b;g&&(b=Object.getOwnPropertyDescriptor(g,m)),b&&null==b.set||(h[m]=i(s[m],v-1))}if(Object.getOwnPropertySymbols){var E=Object.getOwnPropertySymbols(s);for(m=0;m<E.length;m++){var O=E[m];(!(T=Object.getOwnPropertyDescriptor(s,O))||T.enumerable||c)&&(h[O]=i(s[O],v-1),T.enumerable||Object.defineProperty(h,O,{enumerable:!1}))}}if(c){var S=Object.getOwnPropertyNames(s);for(m=0;m<S.length;m++){var T,_=S[m];(T=Object.getOwnPropertyDescriptor(s,_))&&T.enumerable||(h[_]=i(s[_],v-1),Object.defineProperty(h,_,{enumerable:!1}))}}return h}(i,s)}function i(e){return Object.prototype.toString.call(e)}function a(e){var t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),t}return o.clonePrototype=function(e){if(null===e)return null;var t=function(){};return t.prototype=e,new t},o.__objToStr=i,o.__isDate=function(e){return"object"==typeof e&&"[object Date]"===i(e)},o.__isArray=function(e){return"object"==typeof e&&"[object Array]"===i(e)},o.__isRegExp=function(e){return"object"==typeof e&&"[object RegExp]"===i(e)},o.__getRegExpFlags=a,o}();e.exports&&(e.exports=t)},4221:(e,t,r)=>{"use strict";var n=r(1882),o={"text/plain":"Text","text/html":"Url",default:"Text"};e.exports=function(e,t){var r,i,a,l,s,u,c=!1;t||(t={}),r=t.debug||!1;try{if(a=n(),l=document.createRange(),s=document.getSelection(),(u=document.createElement("span")).textContent=e,u.style.all="unset",u.style.position="fixed",u.style.top=0,u.style.clip="rect(0, 0, 0, 0)",u.style.whiteSpace="pre",u.style.webkitUserSelect="text",u.style.MozUserSelect="text",u.style.msUserSelect="text",u.style.userSelect="text",u.addEventListener("copy",(function(n){if(n.stopPropagation(),t.format)if(n.preventDefault(),void 0===n.clipboardData){r&&console.warn("unable to use e.clipboardData"),r&&console.warn("trying IE specific stuff"),window.clipboardData.clearData();var i=o[t.format]||o.default;window.clipboardData.setData(i,e)}else n.clipboardData.clearData(),n.clipboardData.setData(t.format,e);t.onCopy&&(n.preventDefault(),t.onCopy(n.clipboardData))})),document.body.appendChild(u),l.selectNodeContents(u),s.addRange(l),!document.execCommand("copy"))throw new Error("copy command was unsuccessful");c=!0}catch(n){r&&console.error("unable to copy using execCommand: ",n),r&&console.warn("trying IE specific stuff");try{window.clipboardData.setData(t.format||"text",e),t.onCopy&&t.onCopy(window.clipboardData),c=!0}catch(n){r&&console.error("unable to copy using clipboardData: ",n),r&&console.error("falling back to prompt"),i=function(e){var t=(/mac os x/i.test(navigator.userAgent)?"⌘":"Ctrl")+"+C";return e.replace(/#{\s*key\s*}/g,t)}("message"in t?t.message:"Copy to clipboard: #{key}, Enter"),window.prompt(i,e)}}finally{s&&("function"==typeof s.removeRange?s.removeRange(l):s.removeAllRanges()),u&&document.body.removeChild(u),a()}return c}},502:function(e,t,r){var n,o;n=function(){"use strict";Array.isArray||(Array.isArray=function(e){return"[object Array]"===Object.prototype.toString.call(e)});var e={},t={"==":function(e,t){return e==t},"===":function(e,t){return e===t},"!=":function(e,t){return e!=t},"!==":function(e,t){return e!==t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},"<":function(e,t,r){return void 0===r?e<t:e<t&&t<r},"<=":function(e,t,r){return void 0===r?e<=t:e<=t&&t<=r},"!!":function(t){return e.truthy(t)},"!":function(t){return!e.truthy(t)},"%":function(e,t){return e%t},log:function(e){return console.log(e),e},in:function(e,t){return!(!t||void 0===t.indexOf)&&-1!==t.indexOf(e)},cat:function(){return Array.prototype.join.call(arguments,"")},substr:function(e,t,r){if(r<0){var n=String(e).substr(t);return n.substr(0,n.length+r)}return String(e).substr(t,r)},"+":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)+parseFloat(t,10)}),0)},"*":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)*parseFloat(t,10)}))},"-":function(e,t){return void 0===t?-e:e-t},"/":function(e,t){return e/t},min:function(){return Math.min.apply(this,arguments)},max:function(){return Math.max.apply(this,arguments)},merge:function(){return Array.prototype.reduce.call(arguments,(function(e,t){return e.concat(t)}),[])},var:function(e,t){var r=void 0===t?null:t,n=this;if(void 0===e||""===e||null===e)return n;for(var o=String(e).split("."),i=0;i<o.length;i++){if(null==n)return r;if(void 0===(n=n[o[i]]))return r}return n},missing:function(){for(var t=[],r=Array.isArray(arguments[0])?arguments[0]:arguments,n=0;n<r.length;n++){var o=r[n],i=e.apply({var:o},this);null!==i&&""!==i||t.push(o)}return t},missing_some:function(t,r){var n=e.apply({missing:r},this);return r.length-n.length>=t?[]:n}};return e.is_logic=function(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length},e.truthy=function(e){return!(Array.isArray(e)&&0===e.length||!e)},e.get_operator=function(e){return Object.keys(e)[0]},e.get_values=function(t){return t[e.get_operator(t)]},e.apply=function(r,n){if(Array.isArray(r))return r.map((function(t){return e.apply(t,n)}));if(!e.is_logic(r))return r;var o,i,a,l,s,u=e.get_operator(r),c=r[u];if(Array.isArray(c)||(c=[c]),"if"===u||"?:"==u){for(o=0;o<c.length-1;o+=2)if(e.truthy(e.apply(c[o],n)))return e.apply(c[o+1],n);return c.length===o+1?e.apply(c[o],n):null}if("and"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),!e.truthy(i))return i;return i}if("or"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),e.truthy(i))return i;return i}if("filter"===u)return l=e.apply(c[0],n),a=c[1],Array.isArray(l)?l.filter((function(t){return e.truthy(e.apply(a,t))})):[];if("map"===u)return l=e.apply(c[0],n),a=c[1],Array.isArray(l)?l.map((function(t){return e.apply(a,t)})):[];if("reduce"===u)return l=e.apply(c[0],n),a=c[1],s=void 0!==c[2]?c[2]:null,Array.isArray(l)?l.reduce((function(t,r){return e.apply(a,{current:r,accumulator:t})}),s):s;if("all"===u){if(l=e.apply(c[0],n),a=c[1],!Array.isArray(l)||!l.length)return!1;for(o=0;o<l.length;o+=1)if(!e.truthy(e.apply(a,l[o])))return!1;return!0}if("none"===u){if(l=e.apply(c[0],n),a=c[1],!Array.isArray(l)||!l.length)return!0;for(o=0;o<l.length;o+=1)if(e.truthy(e.apply(a,l[o])))return!1;return!0}if("some"===u){if(l=e.apply(c[0],n),a=c[1],!Array.isArray(l)||!l.length)return!1;for(o=0;o<l.length;o+=1)if(e.truthy(e.apply(a,l[o])))return!0;return!1}if(c=c.map((function(t){return e.apply(t,n)})),t.hasOwnProperty(u)&&"function"==typeof t[u])return t[u].apply(n,c);if(u.indexOf(".")>0){var d=String(u).split("."),p=t;for(o=0;o<d.length;o++){if(!p.hasOwnProperty(d[o]))throw new Error("Unrecognized operation "+u+" (failed at "+d.slice(0,o+1).join(".")+")");p=p[d[o]]}return p.apply(n,c)}throw new Error("Unrecognized operation "+u)},e.uses_data=function(t){var r=[];if(e.is_logic(t)){var n=e.get_operator(t),o=t[n];Array.isArray(o)||(o=[o]),"var"===n?r.push(o[0]):o.forEach((function(t){r.push.apply(r,e.uses_data(t))}))}return function(e){for(var t=[],r=0,n=e.length;r<n;r++)-1===t.indexOf(e[r])&&t.push(e[r]);return t}(r)},e.add_operation=function(e,r){t[e]=r},e.rm_operation=function(e){delete t[e]},e.rule_like=function(t,r){if(r===t)return!0;if("@"===r)return!0;if("number"===r)return"number"==typeof t;if("string"===r)return"string"==typeof t;if("array"===r)return Array.isArray(t)&&!e.is_logic(t);if(e.is_logic(r)){if(e.is_logic(t)){var n=e.get_operator(r),o=e.get_operator(t);if("@"===n||n===o)return e.rule_like(e.get_values(t,!1),e.get_values(r,!1))}return!1}if(Array.isArray(r)){if(Array.isArray(t)){if(r.length!==t.length)return!1;for(var i=0;i<r.length;i+=1)if(!e.rule_like(t[i],r[i]))return!1;return!0}return!1}return!1},e},void 0===(o=n.call(t,r,t,e))||(e.exports=o)},5948:(e,t,r)=>{var n=r(2062)(r(9965),"DataView");e.exports=n},4845:(e,t,r)=>{var n=r(5504),o=r(5270),i=r(4769),a=r(2637),l=r(1077);function s(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}s.prototype.clear=n,s.prototype.delete=o,s.prototype.get=i,s.prototype.has=a,s.prototype.set=l,e.exports=s},1999:(e,t,r)=>{var n=r(7718),o=r(4272),i=r(5107),a=r(1055),l=r(4647);function s(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}s.prototype.clear=n,s.prototype.delete=o,s.prototype.get=i,s.prototype.has=a,s.prototype.set=l,e.exports=s},5455:(e,t,r)=>{var n=r(2062)(r(9965),"Map");e.exports=n},1549:(e,t,r)=>{var n=r(6400),o=r(7014),i=r(1793),a=r(6429),l=r(821);function s(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}s.prototype.clear=n,s.prototype.delete=o,s.prototype.get=i,s.prototype.has=a,s.prototype.set=l,e.exports=s},6420:(e,t,r)=>{var n=r(2062)(r(9965),"Promise");e.exports=n},2833:(e,t,r)=>{var n=r(2062)(r(9965),"Set");e.exports=n},8283:(e,t,r)=>{var n=r(1549),o=r(228),i=r(3683);function a(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new n;++t<r;)this.add(e[t])}a.prototype.add=a.prototype.push=o,a.prototype.has=i,e.exports=a},8545:(e,t,r)=>{var n=r(1999),o=r(5052),i=r(4250),a=r(4773),l=r(6921),s=r(5745);function u(e){var t=this.__data__=new n(e);this.size=t.size}u.prototype.clear=o,u.prototype.delete=i,u.prototype.get=a,u.prototype.has=l,u.prototype.set=s,e.exports=u},2609:(e,t,r)=>{var n=r(9965).Symbol;e.exports=n},3604:(e,t,r)=>{var n=r(9965).Uint8Array;e.exports=n},8143:(e,t,r)=>{var n=r(2062)(r(9965),"WeakMap");e.exports=n},1929:e=>{e.exports=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}},6433:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n&&!1!==t(e[r],r,e););return e}},9386:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=0,i=[];++r<n;){var a=e[r];t(a,r,e)&&(i[o++]=a)}return i}},6791:(e,t,r)=>{var n=r(2784),o=r(5196),i=r(4913),a=r(4264),l=r(6665),s=r(5087),u=Object.prototype.hasOwnProperty;e.exports=function(e,t){var r=i(e),c=!r&&o(e),d=!r&&!c&&a(e),p=!r&&!c&&!d&&s(e),f=r||c||d||p,v=f?n(e.length,String):[],h=v.length;for(var g in e)!t&&!u.call(e,g)||f&&("length"==g||d&&("offset"==g||"parent"==g)||p&&("buffer"==g||"byteLength"==g||"byteOffset"==g)||l(g,h))||v.push(g);return v}},1428:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}},8256:e=>{e.exports=function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}},9272:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}},237:(e,t,r)=>{var n=r(2464),o=r(6424);e.exports=function(e,t,r){(void 0!==r&&!o(e[t],r)||void 0===r&&!(t in e))&&n(e,t,r)}},8131:(e,t,r)=>{var n=r(2464),o=r(6424),i=Object.prototype.hasOwnProperty;e.exports=function(e,t,r){var a=e[t];i.call(e,t)&&o(a,r)&&(void 0!==r||t in e)||n(e,t,r)}},3481:(e,t,r)=>{var n=r(6424);e.exports=function(e,t){for(var r=e.length;r--;)if(n(e[r][0],t))return r;return-1}},4861:(e,t,r)=>{var n=r(4735),o=r(3790);e.exports=function(e,t){return e&&n(t,o(t),e)}},7838:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e,t){return e&&n(t,o(t),e)}},2464:(e,t,r)=>{var n=r(9611);e.exports=function(e,t,r){"__proto__"==t&&n?n(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}},5725:e=>{e.exports=function(e,t,r){return e==e&&(void 0!==r&&(e=e<=r?e:r),void 0!==t&&(e=e>=t?e:t)),e}},6575:(e,t,r)=>{var n=r(8545),o=r(6433),i=r(8131),a=r(4861),l=r(7838),s=r(8986),u=r(1231),c=r(1711),d=r(1476),p=r(130),f=r(869),v=r(6053),h=r(509),g=r(1343),y=r(1225),m=r(4913),b=r(4264),E=r(146),O=r(7453),S=r(8696),T=r(3790),_=r(5961),w="[object Arguments]",R="[object Function]",I="[object Object]",A={};A[w]=A["[object Array]"]=A["[object ArrayBuffer]"]=A["[object DataView]"]=A["[object Boolean]"]=A["[object Date]"]=A["[object Float32Array]"]=A["[object Float64Array]"]=A["[object Int8Array]"]=A["[object Int16Array]"]=A["[object Int32Array]"]=A["[object Map]"]=A["[object Number]"]=A[I]=A["[object RegExp]"]=A["[object Set]"]=A["[object String]"]=A["[object Symbol]"]=A["[object Uint8Array]"]=A["[object Uint8ClampedArray]"]=A["[object Uint16Array]"]=A["[object Uint32Array]"]=!0,A["[object Error]"]=A[R]=A["[object WeakMap]"]=!1,e.exports=function e(t,r,C,N,L,j){var x,P=1&r,F=2&r,D=4&r;if(C&&(x=L?C(t,N,L,j):C(t)),void 0!==x)return x;if(!O(t))return t;var k=m(t);if(k){if(x=h(t),!P)return u(t,x)}else{var M=v(t),V=M==R||"[object GeneratorFunction]"==M;if(b(t))return s(t,P);if(M==I||M==w||V&&!L){if(x=F||V?{}:y(t),!P)return F?d(t,l(x,t)):c(t,a(x,t))}else{if(!A[M])return L?t:{};x=g(t,M,P)}}j||(j=new n);var U=j.get(t);if(U)return U;j.set(t,x),S(t)?t.forEach((function(n){x.add(e(n,r,C,n,t,j))})):E(t)&&t.forEach((function(n,o){x.set(o,e(n,r,C,o,t,j))}));var B=k?void 0:(D?F?f:p:F?_:T)(t);return o(B||t,(function(n,o){B&&(n=t[o=n]),i(x,o,e(n,r,C,o,t,j))})),x}},3088:(e,t,r)=>{var n=r(7453),o=Object.create,i=function(){function e(){}return function(t){if(!n(t))return{};if(o)return o(t);e.prototype=t;var r=new e;return e.prototype=void 0,r}}();e.exports=i},3323:e=>{e.exports=function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}},1360:(e,t,r)=>{var n=r(8256),o=r(5043);e.exports=function e(t,r,i,a,l){var s=-1,u=t.length;for(i||(i=o),l||(l=[]);++s<u;){var c=t[s];r>0&&i(c)?r>1?e(c,r-1,i,a,l):n(l,c):a||(l[l.length]=c)}return l}},6057:(e,t,r)=>{var n=r(5845)();e.exports=n},5473:(e,t,r)=>{var n=r(6057),o=r(3790);e.exports=function(e,t){return e&&n(e,t,o)}},2718:(e,t,r)=>{var n=r(2361),o=r(8197);e.exports=function(e,t){for(var r=0,i=(t=n(t,e)).length;null!=e&&r<i;)e=e[o(t[r++])];return r&&r==i?e:void 0}},8359:(e,t,r)=>{var n=r(8256),o=r(4913);e.exports=function(e,t,r){var i=t(e);return o(e)?i:n(i,r(e))}},9048:(e,t,r)=>{var n=r(2609),o=r(2899),i=r(7222),a=n?n.toStringTag:void 0;e.exports=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":a&&a in Object(e)?o(e):i(e)}},3613:e=>{e.exports=function(e,t){return null!=e&&t in Object(e)}},9555:(e,t,r)=>{var n=r(3323),o=r(8967),i=r(5951);e.exports=function(e,t,r){return t==t?i(e,t,r):n(e,o,r)}},3070:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return o(e)&&"[object Arguments]"==n(e)}},590:(e,t,r)=>{var n=r(9132),o=r(9466);e.exports=function e(t,r,i,a,l){return t===r||(null==t||null==r||!o(t)&&!o(r)?t!=t&&r!=r:n(t,r,i,a,e,l))}},9132:(e,t,r)=>{var n=r(8545),o=r(4807),i=r(898),a=r(3409),l=r(6053),s=r(4913),u=r(4264),c=r(5087),d="[object Arguments]",p="[object Array]",f="[object Object]",v=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,h,g,y){var m=s(e),b=s(t),E=m?p:l(e),O=b?p:l(t),S=(E=E==d?f:E)==f,T=(O=O==d?f:O)==f,_=E==O;if(_&&u(e)){if(!u(t))return!1;m=!0,S=!1}if(_&&!S)return y||(y=new n),m||c(e)?o(e,t,r,h,g,y):i(e,t,E,r,h,g,y);if(!(1&r)){var w=S&&v.call(e,"__wrapped__"),R=T&&v.call(t,"__wrapped__");if(w||R){var I=w?e.value():e,A=R?t.value():t;return y||(y=new n),g(I,A,r,h,y)}}return!!_&&(y||(y=new n),a(e,t,r,h,g,y))}},2052:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Map]"==n(e)}},7799:(e,t,r)=>{var n=r(8545),o=r(590);e.exports=function(e,t,r,i){var a=r.length,l=a,s=!i;if(null==e)return!l;for(e=Object(e);a--;){var u=r[a];if(s&&u[2]?u[1]!==e[u[0]]:!(u[0]in e))return!1}for(;++a<l;){var c=(u=r[a])[0],d=e[c],p=u[1];if(s&&u[2]){if(void 0===d&&!(c in e))return!1}else{var f=new n;if(i)var v=i(d,p,c,e,t,f);if(!(void 0===v?o(p,d,3,i,f):v))return!1}}return!0}},8967:e=>{e.exports=function(e){return e!=e}},4363:(e,t,r)=>{var n=r(1866),o=r(3248),i=r(7453),a=r(3761),l=/^\[object .+?Constructor\]$/,s=Function.prototype,u=Object.prototype,c=s.toString,d=u.hasOwnProperty,p=RegExp("^"+c.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=function(e){return!(!i(e)||o(e))&&(n(e)?p:l).test(a(e))}},5206:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Set]"==n(e)}},9653:(e,t,r)=>{var n=r(9048),o=r(582),i=r(9466),a={};a["[object Float32Array]"]=a["[object Float64Array]"]=a["[object Int8Array]"]=a["[object Int16Array]"]=a["[object Int32Array]"]=a["[object Uint8Array]"]=a["[object Uint8ClampedArray]"]=a["[object Uint16Array]"]=a["[object Uint32Array]"]=!0,a["[object Arguments]"]=a["[object Array]"]=a["[object ArrayBuffer]"]=a["[object Boolean]"]=a["[object DataView]"]=a["[object Date]"]=a["[object Error]"]=a["[object Function]"]=a["[object Map]"]=a["[object Number]"]=a["[object Object]"]=a["[object RegExp]"]=a["[object Set]"]=a["[object String]"]=a["[object WeakMap]"]=!1,e.exports=function(e){return i(e)&&o(e.length)&&!!a[n(e)]}},3245:(e,t,r)=>{var n=r(8271),o=r(4458),i=r(912),a=r(4913),l=r(6711);e.exports=function(e){return"function"==typeof e?e:null==e?i:"object"==typeof e?a(e)?o(e[0],e[1]):n(e):l(e)}},6504:(e,t,r)=>{var n=r(5735),o=r(9458),i=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return o(e);var t=[];for(var r in Object(e))i.call(e,r)&&"constructor"!=r&&t.push(r);return t}},9399:(e,t,r)=>{var n=r(7453),o=r(5735),i=r(2693),a=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return i(e);var t=o(e),r=[];for(var l in e)("constructor"!=l||!t&&a.call(e,l))&&r.push(l);return r}},8271:(e,t,r)=>{var n=r(7799),o=r(520),i=r(7405);e.exports=function(e){var t=o(e);return 1==t.length&&t[0][2]?i(t[0][0],t[0][1]):function(r){return r===e||n(r,e,t)}}},4458:(e,t,r)=>{var n=r(590),o=r(5612),i=r(4055),a=r(6394),l=r(2308),s=r(7405),u=r(8197);e.exports=function(e,t){return a(e)&&l(t)?s(u(e),t):function(r){var a=o(r,e);return void 0===a&&a===t?i(r,e):n(t,a,3)}}},9058:(e,t,r)=>{var n=r(8545),o=r(237),i=r(6057),a=r(8120),l=r(7453),s=r(5961),u=r(4302);e.exports=function e(t,r,c,d,p){t!==r&&i(r,(function(i,s){if(p||(p=new n),l(i))a(t,r,s,c,e,d,p);else{var f=d?d(u(t,s),i,s+"",t,r,p):void 0;void 0===f&&(f=i),o(t,s,f)}}),s)}},8120:(e,t,r)=>{var n=r(237),o=r(8986),i=r(7961),a=r(1231),l=r(1225),s=r(5196),u=r(4913),c=r(7965),d=r(4264),p=r(1866),f=r(7453),v=r(5219),h=r(5087),g=r(4302),y=r(5148);e.exports=function(e,t,r,m,b,E,O){var S=g(e,r),T=g(t,r),_=O.get(T);if(_)n(e,r,_);else{var w=E?E(S,T,r+"",e,t,O):void 0,R=void 0===w;if(R){var I=u(T),A=!I&&d(T),C=!I&&!A&&h(T);w=T,I||A||C?u(S)?w=S:c(S)?w=a(S):A?(R=!1,w=o(T,!0)):C?(R=!1,w=i(T,!0)):w=[]:v(T)||s(T)?(w=S,s(S)?w=y(S):f(S)&&!p(S)||(w=l(T))):R=!1}R&&(O.set(T,w),b(w,T,m,E,O),O.delete(T)),n(e,r,w)}}},1:(e,t,r)=>{var n=r(9916),o=r(4055);e.exports=function(e,t){return n(e,t,(function(t,r){return o(e,r)}))}},9916:(e,t,r)=>{var n=r(2718),o=r(3746),i=r(2361);e.exports=function(e,t,r){for(var a=-1,l=t.length,s={};++a<l;){var u=t[a],c=n(e,u);r(c,u)&&o(s,i(u,e),c)}return s}},645:e=>{e.exports=function(e){return function(t){return null==t?void 0:t[e]}}},5319:(e,t,r)=>{var n=r(2718);e.exports=function(e){return function(t){return n(t,e)}}},9383:e=>{var t=Math.ceil,r=Math.max;e.exports=function(e,n,o,i){for(var a=-1,l=r(t((n-e)/(o||1)),0),s=Array(l);l--;)s[i?l:++a]=e,e+=o;return s}},1459:e=>{var t=Math.floor;e.exports=function(e,r){var n="";if(!e||r<1||r>9007199254740991)return n;do{r%2&&(n+=e),(r=t(r/2))&&(e+=e)}while(r);return n}},1110:(e,t,r)=>{var n=r(912),o=r(709),i=r(7281);e.exports=function(e,t){return i(o(e,t,n),e+"")}},3746:(e,t,r)=>{var n=r(8131),o=r(2361),i=r(6665),a=r(7453),l=r(8197);e.exports=function(e,t,r,s){if(!a(e))return e;for(var u=-1,c=(t=o(t,e)).length,d=c-1,p=e;null!=p&&++u<c;){var f=l(t[u]),v=r;if("__proto__"===f||"constructor"===f||"prototype"===f)return e;if(u!=d){var h=p[f];void 0===(v=s?s(h,f,p):void 0)&&(v=a(h)?h:i(t[u+1])?[]:{})}n(p,f,v),p=p[f]}return e}},4450:(e,t,r)=>{var n=r(6534),o=r(9611),i=r(912),a=o?function(e,t){return o(e,"toString",{configurable:!0,enumerable:!1,value:n(t),writable:!0})}:i;e.exports=a},312:e=>{e.exports=function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}},2784:e=>{e.exports=function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}},9764:(e,t,r)=>{var n=r(2609),o=r(1428),i=r(4913),a=r(7386),l=n?n.prototype:void 0,s=l?l.toString:void 0;e.exports=function e(t){if("string"==typeof t)return t;if(i(t))return o(t,e)+"";if(a(t))return s?s.call(t):"";var r=t+"";return"0"==r&&1/t==-1/0?"-0":r}},7248:(e,t,r)=>{var n=r(1272),o=/^\s+/;e.exports=function(e){return e?e.slice(0,n(e)+1).replace(o,""):e}},277:e=>{e.exports=function(e){return function(t){return e(t)}}},6744:(e,t,r)=>{var n=r(2361),o=r(8906),i=r(2473),a=r(8197);e.exports=function(e,t){return t=n(t,e),null==(e=i(e,t))||delete e[a(o(t))]}},1282:(e,t,r)=>{var n=r(1428);e.exports=function(e,t){return n(t,(function(t){return e[t]}))}},3840:e=>{e.exports=function(e,t){return e.has(t)}},2361:(e,t,r)=>{var n=r(4913),o=r(6394),i=r(266),a=r(3158);e.exports=function(e,t){return n(e)?e:o(e,t)?[e]:i(a(e))}},7749:(e,t,r)=>{var n=r(3604);e.exports=function(e){var t=new e.constructor(e.byteLength);return new n(t).set(new n(e)),t}},8986:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o?n.Buffer:void 0,l=a?a.allocUnsafe:void 0;e.exports=function(e,t){if(t)return e.slice();var r=e.length,n=l?l(r):new e.constructor(r);return e.copy(n),n}},3081:(e,t,r)=>{var n=r(7749);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}},6945:e=>{var t=/\w*$/;e.exports=function(e){var r=new e.constructor(e.source,t.exec(e));return r.lastIndex=e.lastIndex,r}},6952:(e,t,r)=>{var n=r(2609),o=n?n.prototype:void 0,i=o?o.valueOf:void 0;e.exports=function(e){return i?Object(i.call(e)):{}}},7961:(e,t,r)=>{var n=r(7749);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}},1231:e=>{e.exports=function(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}},4735:(e,t,r)=>{var n=r(8131),o=r(2464);e.exports=function(e,t,r,i){var a=!r;r||(r={});for(var l=-1,s=t.length;++l<s;){var u=t[l],c=i?i(r[u],e[u],u,r,e):void 0;void 0===c&&(c=e[u]),a?o(r,u,c):n(r,u,c)}return r}},1711:(e,t,r)=>{var n=r(4735),o=r(6600);e.exports=function(e,t){return n(e,o(e),t)}},1476:(e,t,r)=>{var n=r(4735),o=r(8455);e.exports=function(e,t){return n(e,o(e),t)}},2489:(e,t,r)=>{var n=r(9965)["__core-js_shared__"];e.exports=n},9511:(e,t,r)=>{var n=r(1110),o=r(3632);e.exports=function(e){return n((function(t,r){var n=-1,i=r.length,a=i>1?r[i-1]:void 0,l=i>2?r[2]:void 0;for(a=e.length>3&&"function"==typeof a?(i--,a):void 0,l&&o(r[0],r[1],l)&&(a=i<3?void 0:a,i=1),t=Object(t);++n<i;){var s=r[n];s&&e(t,s,n,a)}return t}))}},5845:e=>{e.exports=function(e){return function(t,r,n){for(var o=-1,i=Object(t),a=n(t),l=a.length;l--;){var s=a[e?l:++o];if(!1===r(i[s],s,i))break}return t}}},8580:(e,t,r)=>{var n=r(9383),o=r(3632),i=r(1144);e.exports=function(e){return function(t,r,a){return a&&"number"!=typeof a&&o(t,r,a)&&(r=a=void 0),t=i(t),void 0===r?(r=t,t=0):r=i(r),a=void 0===a?t<r?1:-1:i(a),n(t,r,a,e)}}},2050:(e,t,r)=>{var n=r(5219);e.exports=function(e){return n(e)?void 0:e}},9611:(e,t,r)=>{var n=r(2062),o=function(){try{var e=n(Object,"defineProperty");return e({},"",{}),e}catch(e){}}();e.exports=o},4807:(e,t,r)=>{var n=r(8283),o=r(9272),i=r(3840);e.exports=function(e,t,r,a,l,s){var u=1&r,c=e.length,d=t.length;if(c!=d&&!(u&&d>c))return!1;var p=s.get(e),f=s.get(t);if(p&&f)return p==t&&f==e;var v=-1,h=!0,g=2&r?new n:void 0;for(s.set(e,t),s.set(t,e);++v<c;){var y=e[v],m=t[v];if(a)var b=u?a(m,y,v,t,e,s):a(y,m,v,e,t,s);if(void 0!==b){if(b)continue;h=!1;break}if(g){if(!o(t,(function(e,t){if(!i(g,t)&&(y===e||l(y,e,r,a,s)))return g.push(t)}))){h=!1;break}}else if(y!==m&&!l(y,m,r,a,s)){h=!1;break}}return s.delete(e),s.delete(t),h}},898:(e,t,r)=>{var n=r(2609),o=r(3604),i=r(6424),a=r(4807),l=r(9885),s=r(6295),u=n?n.prototype:void 0,c=u?u.valueOf:void 0;e.exports=function(e,t,r,n,u,d,p){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new o(e),new o(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return i(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var f=l;case"[object Set]":var v=1&n;if(f||(f=s),e.size!=t.size&&!v)return!1;var h=p.get(e);if(h)return h==t;n|=2,p.set(e,t);var g=a(f(e),f(t),n,u,d,p);return p.delete(e),g;case"[object Symbol]":if(c)return c.call(e)==c.call(t)}return!1}},3409:(e,t,r)=>{var n=r(130),o=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,i,a,l){var s=1&r,u=n(e),c=u.length;if(c!=n(t).length&&!s)return!1;for(var d=c;d--;){var p=u[d];if(!(s?p in t:o.call(t,p)))return!1}var f=l.get(e),v=l.get(t);if(f&&v)return f==t&&v==e;var h=!0;l.set(e,t),l.set(t,e);for(var g=s;++d<c;){var y=e[p=u[d]],m=t[p];if(i)var b=s?i(m,y,p,t,e,l):i(y,m,p,e,t,l);if(!(void 0===b?y===m||a(y,m,r,i,l):b)){h=!1;break}g||(g="constructor"==p)}if(h&&!g){var E=e.constructor,O=t.constructor;E==O||!("constructor"in e)||!("constructor"in t)||"function"==typeof E&&E instanceof E&&"function"==typeof O&&O instanceof O||(h=!1)}return l.delete(e),l.delete(t),h}},8496:(e,t,r)=>{var n=r(9234),o=r(709),i=r(7281);e.exports=function(e){return i(o(e,void 0,n),e+"")}},6392:(e,t,r)=>{var n="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g;e.exports=n},130:(e,t,r)=>{var n=r(8359),o=r(6600),i=r(3790);e.exports=function(e){return n(e,i,o)}},869:(e,t,r)=>{var n=r(8359),o=r(8455),i=r(5961);e.exports=function(e){return n(e,i,o)}},3707:(e,t,r)=>{var n=r(9178);e.exports=function(e,t){var r=e.__data__;return n(t)?r["string"==typeof t?"string":"hash"]:r.map}},520:(e,t,r)=>{var n=r(2308),o=r(3790);e.exports=function(e){for(var t=o(e),r=t.length;r--;){var i=t[r],a=e[i];t[r]=[i,a,n(a)]}return t}},2062:(e,t,r)=>{var n=r(4363),o=r(5240);e.exports=function(e,t){var r=o(e,t);return n(r)?r:void 0}},6607:(e,t,r)=>{var n=r(8303)(Object.getPrototypeOf,Object);e.exports=n},2899:(e,t,r)=>{var n=r(2609),o=Object.prototype,i=o.hasOwnProperty,a=o.toString,l=n?n.toStringTag:void 0;e.exports=function(e){var t=i.call(e,l),r=e[l];try{e[l]=void 0;var n=!0}catch(e){}var o=a.call(e);return n&&(t?e[l]=r:delete e[l]),o}},6600:(e,t,r)=>{var n=r(9386),o=r(8721),i=Object.prototype.propertyIsEnumerable,a=Object.getOwnPropertySymbols,l=a?function(e){return null==e?[]:(e=Object(e),n(a(e),(function(t){return i.call(e,t)})))}:o;e.exports=l},8455:(e,t,r)=>{var n=r(8256),o=r(6607),i=r(6600),a=r(8721),l=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)n(t,i(e)),e=o(e);return t}:a;e.exports=l},6053:(e,t,r)=>{var n=r(5948),o=r(5455),i=r(6420),a=r(2833),l=r(8143),s=r(9048),u=r(3761),c="[object Map]",d="[object Promise]",p="[object Set]",f="[object WeakMap]",v="[object DataView]",h=u(n),g=u(o),y=u(i),m=u(a),b=u(l),E=s;(n&&E(new n(new ArrayBuffer(1)))!=v||o&&E(new o)!=c||i&&E(i.resolve())!=d||a&&E(new a)!=p||l&&E(new l)!=f)&&(E=function(e){var t=s(e),r="[object Object]"==t?e.constructor:void 0,n=r?u(r):"";if(n)switch(n){case h:return v;case g:return c;case y:return d;case m:return p;case b:return f}return t}),e.exports=E},5240:e=>{e.exports=function(e,t){return null==e?void 0:e[t]}},1518:(e,t,r)=>{var n=r(2361),o=r(5196),i=r(4913),a=r(6665),l=r(582),s=r(8197);e.exports=function(e,t,r){for(var u=-1,c=(t=n(t,e)).length,d=!1;++u<c;){var p=s(t[u]);if(!(d=null!=e&&r(e,p)))break;e=e[p]}return d||++u!=c?d:!!(c=null==e?0:e.length)&&l(c)&&a(p,c)&&(i(e)||o(e))}},5504:(e,t,r)=>{var n=r(8034);e.exports=function(){this.__data__=n?n(null):{},this.size=0}},5270:e=>{e.exports=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}},4769:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;if(n){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return o.call(t,e)?t[e]:void 0}},2637:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;return n?void 0!==t[e]:o.call(t,e)}},1077:(e,t,r)=>{var n=r(8034);e.exports=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=n&&void 0===t?"__lodash_hash_undefined__":t,this}},509:e=>{var t=Object.prototype.hasOwnProperty;e.exports=function(e){var r=e.length,n=new e.constructor(r);return r&&"string"==typeof e[0]&&t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}},1343:(e,t,r)=>{var n=r(7749),o=r(3081),i=r(6945),a=r(6952),l=r(7961);e.exports=function(e,t,r){var s=e.constructor;switch(t){case"[object ArrayBuffer]":return n(e);case"[object Boolean]":case"[object Date]":return new s(+e);case"[object DataView]":return o(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return l(e,r);case"[object Map]":case"[object Set]":return new s;case"[object Number]":case"[object String]":return new s(e);case"[object RegExp]":return i(e);case"[object Symbol]":return a(e)}}},1225:(e,t,r)=>{var n=r(3088),o=r(6607),i=r(5735);e.exports=function(e){return"function"!=typeof e.constructor||i(e)?{}:n(o(e))}},5043:(e,t,r)=>{var n=r(2609),o=r(5196),i=r(4913),a=n?n.isConcatSpreadable:void 0;e.exports=function(e){return i(e)||o(e)||!!(a&&e&&e[a])}},6665:e=>{var t=/^(?:0|[1-9]\d*)$/;e.exports=function(e,r){var n=typeof e;return!!(r=null==r?9007199254740991:r)&&("number"==n||"symbol"!=n&&t.test(e))&&e>-1&&e%1==0&&e<r}},3632:(e,t,r)=>{var n=r(6424),o=r(7134),i=r(6665),a=r(7453);e.exports=function(e,t,r){if(!a(r))return!1;var l=typeof t;return!!("number"==l?o(r)&&i(t,r.length):"string"==l&&t in r)&&n(r[t],e)}},6394:(e,t,r)=>{var n=r(4913),o=r(7386),i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;e.exports=function(e,t){if(n(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!o(e))||a.test(e)||!i.test(e)||null!=t&&e in Object(t)}},9178:e=>{e.exports=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}},3248:(e,t,r)=>{var n,o=r(2489),i=(n=/[^.]+$/.exec(o&&o.keys&&o.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"";e.exports=function(e){return!!i&&i in e}},5735:e=>{var t=Object.prototype;e.exports=function(e){var r=e&&e.constructor;return e===("function"==typeof r&&r.prototype||t)}},2308:(e,t,r)=>{var n=r(7453);e.exports=function(e){return e==e&&!n(e)}},7718:e=>{e.exports=function(){this.__data__=[],this.size=0}},4272:(e,t,r)=>{var n=r(3481),o=Array.prototype.splice;e.exports=function(e){var t=this.__data__,r=n(t,e);return!(r<0||(r==t.length-1?t.pop():o.call(t,r,1),--this.size,0))}},5107:(e,t,r)=>{var n=r(3481);e.exports=function(e){var t=this.__data__,r=n(t,e);return r<0?void 0:t[r][1]}},1055:(e,t,r)=>{var n=r(3481);e.exports=function(e){return n(this.__data__,e)>-1}},4647:(e,t,r)=>{var n=r(3481);e.exports=function(e,t){var r=this.__data__,o=n(r,e);return o<0?(++this.size,r.push([e,t])):r[o][1]=t,this}},6400:(e,t,r)=>{var n=r(4845),o=r(1999),i=r(5455);e.exports=function(){this.size=0,this.__data__={hash:new n,map:new(i||o),string:new n}}},7014:(e,t,r)=>{var n=r(3707);e.exports=function(e){var t=n(this,e).delete(e);return this.size-=t?1:0,t}},1793:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).get(e)}},6429:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).has(e)}},821:(e,t,r)=>{var n=r(3707);e.exports=function(e,t){var r=n(this,e),o=r.size;return r.set(e,t),this.size+=r.size==o?0:1,this}},9885:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}},7405:e=>{e.exports=function(e,t){return function(r){return null!=r&&r[e]===t&&(void 0!==t||e in Object(r))}}},2848:(e,t,r)=>{var n=r(3272);e.exports=function(e){var t=n(e,(function(e){return 500===r.size&&r.clear(),e})),r=t.cache;return t}},8034:(e,t,r)=>{var n=r(2062)(Object,"create");e.exports=n},9458:(e,t,r)=>{var n=r(8303)(Object.keys,Object);e.exports=n},2693:e=>{e.exports=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t}},1977:(e,t,r)=>{e=r.nmd(e);var n=r(6392),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o&&n.process,l=function(){try{return i&&i.require&&i.require("util").types||a&&a.binding&&a.binding("util")}catch(e){}}();e.exports=l},7222:e=>{var t=Object.prototype.toString;e.exports=function(e){return t.call(e)}},8303:e=>{e.exports=function(e,t){return function(r){return e(t(r))}}},709:(e,t,r)=>{var n=r(1929),o=Math.max;e.exports=function(e,t,r){return t=o(void 0===t?e.length-1:t,0),function(){for(var i=arguments,a=-1,l=o(i.length-t,0),s=Array(l);++a<l;)s[a]=i[t+a];a=-1;for(var u=Array(t+1);++a<t;)u[a]=i[a];return u[t]=r(s),n(e,this,u)}}},2473:(e,t,r)=>{var n=r(2718),o=r(312);e.exports=function(e,t){return t.length<2?e:n(e,o(t,0,-1))}},9965:(e,t,r)=>{var n=r(6392),o="object"==typeof self&&self&&self.Object===Object&&self,i=n||o||Function("return this")();e.exports=i},4302:e=>{e.exports=function(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}},228:e=>{e.exports=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}},3683:e=>{e.exports=function(e){return this.__data__.has(e)}},6295:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}},7281:(e,t,r)=>{var n=r(4450),o=r(435)(n);e.exports=o},435:e=>{var t=Date.now;e.exports=function(e){var r=0,n=0;return function(){var o=t(),i=16-(o-n);if(n=o,i>0){if(++r>=800)return arguments[0]}else r=0;return e.apply(void 0,arguments)}}},5052:(e,t,r)=>{var n=r(1999);e.exports=function(){this.__data__=new n,this.size=0}},4250:e=>{e.exports=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}},4773:e=>{e.exports=function(e){return this.__data__.get(e)}},6921:e=>{e.exports=function(e){return this.__data__.has(e)}},5745:(e,t,r)=>{var n=r(1999),o=r(5455),i=r(1549);e.exports=function(e,t){var r=this.__data__;if(r instanceof n){var a=r.__data__;if(!o||a.length<199)return a.push([e,t]),this.size=++r.size,this;r=this.__data__=new i(a)}return r.set(e,t),this.size=r.size,this}},5951:e=>{e.exports=function(e,t,r){for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}},266:(e,t,r)=>{var n=r(2848),o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,i=/\\(\\)?/g,a=n((function(e){var t=[];return 46===e.charCodeAt(0)&&t.push(""),e.replace(o,(function(e,r,n,o){t.push(n?o.replace(i,"$1"):r||e)})),t}));e.exports=a},8197:(e,t,r)=>{var n=r(7386);e.exports=function(e){if("string"==typeof e||n(e))return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}},3761:e=>{var t=Function.prototype.toString;e.exports=function(e){if(null!=e){try{return t.call(e)}catch(e){}try{return e+""}catch(e){}}return""}},1272:e=>{var t=/\s/;e.exports=function(e){for(var r=e.length;r--&&t.test(e.charAt(r)););return r}},6534:e=>{e.exports=function(e){return function(){return e}}},9517:(e,t,r)=>{var n=r(7453),o=r(2220),i=r(3662),a=Math.max,l=Math.min;e.exports=function(e,t,r){var s,u,c,d,p,f,v=0,h=!1,g=!1,y=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function m(t){var r=s,n=u;return s=u=void 0,v=t,d=e.apply(n,r)}function b(e){var r=e-f;return void 0===f||r>=t||r<0||g&&e-v>=c}function E(){var e=o();if(b(e))return O(e);p=setTimeout(E,function(e){var r=t-(e-f);return g?l(r,c-(e-v)):r}(e))}function O(e){return p=void 0,y&&s?m(e):(s=u=void 0,d)}function S(){var e=o(),r=b(e);if(s=arguments,u=this,f=e,r){if(void 0===p)return function(e){return v=e,p=setTimeout(E,t),h?m(e):d}(f);if(g)return clearTimeout(p),p=setTimeout(E,t),m(f)}return void 0===p&&(p=setTimeout(E,t)),d}return t=i(t)||0,n(r)&&(h=!!r.leading,c=(g="maxWait"in r)?a(i(r.maxWait)||0,t):c,y="trailing"in r?!!r.trailing:y),S.cancel=function(){void 0!==p&&clearTimeout(p),v=0,s=f=u=p=void 0},S.flush=function(){return void 0===p?d:O(o())},S}},6424:e=>{e.exports=function(e,t){return e===t||e!=e&&t!=t}},8472:(e,t,r)=>{var n=r(3158),o=/[\\^$.*+?()[\]{}|]/g,i=RegExp(o.source);e.exports=function(e){return(e=n(e))&&i.test(e)?e.replace(o,"\\$&"):e}},9234:(e,t,r)=>{var n=r(1360);e.exports=function(e){return null!=e&&e.length?n(e,1):[]}},5612:(e,t,r)=>{var n=r(2718);e.exports=function(e,t,r){var o=null==e?void 0:n(e,t);return void 0===o?r:o}},4055:(e,t,r)=>{var n=r(3613),o=r(1518);e.exports=function(e,t){return null!=e&&o(e,t,n)}},912:e=>{e.exports=function(e){return e}},1283:(e,t,r)=>{var n=r(9555),o=r(7134),i=r(8951),a=r(5729),l=r(1624),s=Math.max;e.exports=function(e,t,r,u){e=o(e)?e:l(e),r=r&&!u?a(r):0;var c=e.length;return r<0&&(r=s(c+r,0)),i(e)?r<=c&&e.indexOf(t,r)>-1:!!c&&n(e,t,r)>-1}},5196:(e,t,r)=>{var n=r(3070),o=r(9466),i=Object.prototype,a=i.hasOwnProperty,l=i.propertyIsEnumerable,s=n(function(){return arguments}())?n:function(e){return o(e)&&a.call(e,"callee")&&!l.call(e,"callee")};e.exports=s},4913:e=>{var t=Array.isArray;e.exports=t},7134:(e,t,r)=>{var n=r(1866),o=r(582);e.exports=function(e){return null!=e&&o(e.length)&&!n(e)}},7965:(e,t,r)=>{var n=r(7134),o=r(9466);e.exports=function(e){return o(e)&&n(e)}},4264:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=r(9375),i=t&&!t.nodeType&&t,a=i&&e&&!e.nodeType&&e,l=a&&a.exports===i?n.Buffer:void 0,s=(l?l.isBuffer:void 0)||o;e.exports=s},7969:(e,t,r)=>{var n=r(6504),o=r(6053),i=r(5196),a=r(4913),l=r(7134),s=r(4264),u=r(5735),c=r(5087),d=Object.prototype.hasOwnProperty;e.exports=function(e){if(null==e)return!0;if(l(e)&&(a(e)||"string"==typeof e||"function"==typeof e.splice||s(e)||c(e)||i(e)))return!e.length;var t=o(e);if("[object Map]"==t||"[object Set]"==t)return!e.size;if(u(e))return!n(e).length;for(var r in e)if(d.call(e,r))return!1;return!0}},1866:(e,t,r)=>{var n=r(9048),o=r(7453);e.exports=function(e){if(!o(e))return!1;var t=n(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}},582:e=>{e.exports=function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}},146:(e,t,r)=>{var n=r(2052),o=r(277),i=r(1977),a=i&&i.isMap,l=a?o(a):n;e.exports=l},7453:e=>{e.exports=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}},9466:e=>{e.exports=function(e){return null!=e&&"object"==typeof e}},5219:(e,t,r)=>{var n=r(9048),o=r(6607),i=r(9466),a=Function.prototype,l=Object.prototype,s=a.toString,u=l.hasOwnProperty,c=s.call(Object);e.exports=function(e){if(!i(e)||"[object Object]"!=n(e))return!1;var t=o(e);if(null===t)return!0;var r=u.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&s.call(r)==c}},8696:(e,t,r)=>{var n=r(5206),o=r(277),i=r(1977),a=i&&i.isSet,l=a?o(a):n;e.exports=l},8951:(e,t,r)=>{var n=r(9048),o=r(4913),i=r(9466);e.exports=function(e){return"string"==typeof e||!o(e)&&i(e)&&"[object String]"==n(e)}},7386:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return"symbol"==typeof e||o(e)&&"[object Symbol]"==n(e)}},5087:(e,t,r)=>{var n=r(9653),o=r(277),i=r(1977),a=i&&i.isTypedArray,l=a?o(a):n;e.exports=l},3790:(e,t,r)=>{var n=r(6791),o=r(6504),i=r(7134);e.exports=function(e){return i(e)?n(e):o(e)}},5961:(e,t,r)=>{var n=r(6791),o=r(9399),i=r(7134);e.exports=function(e){return i(e)?n(e,!0):o(e)}},8906:e=>{e.exports=function(e){var t=null==e?0:e.length;return t?e[t-1]:void 0}},1612:(e,t,r)=>{var n=r(2464),o=r(5473),i=r(3245);e.exports=function(e,t){var r={};return t=i(t,3),o(e,(function(e,o,i){n(r,o,t(e,o,i))})),r}},3272:(e,t,r)=>{var n=r(1549);function o(e,t){if("function"!=typeof e||null!=t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a)||i,a};return r.cache=new(o.Cache||n),r}o.Cache=n,e.exports=o},4308:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r){n(e,t,r)}));e.exports=o},2815:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r,o){n(e,t,r,o)}));e.exports=o},2220:(e,t,r)=>{var n=r(9965);e.exports=function(){return n.Date.now()}},7027:(e,t,r)=>{var n=r(1428),o=r(6575),i=r(6744),a=r(2361),l=r(4735),s=r(2050),u=r(8496),c=r(869),d=u((function(e,t){var r={};if(null==e)return r;var u=!1;t=n(t,(function(t){return t=a(t,e),u||(u=t.length>1),t})),l(e,c(e),r),u&&(r=o(r,7,s));for(var d=t.length;d--;)i(r,t[d]);return r}));e.exports=d},8831:(e,t,r)=>{var n=r(1),o=r(8496)((function(e,t){return null==e?{}:n(e,t)}));e.exports=o},350:(e,t,r)=>{var n=r(1428),o=r(3245),i=r(9916),a=r(869);e.exports=function(e,t){if(null==e)return{};var r=n(a(e),(function(e){return[e]}));return t=o(t),i(e,r,(function(e,r){return t(e,r[0])}))}},6711:(e,t,r)=>{var n=r(645),o=r(5319),i=r(6394),a=r(8197);e.exports=function(e){return i(e)?n(a(e)):o(e)}},2285:(e,t,r)=>{var n=r(8580)();e.exports=n},9901:(e,t,r)=>{var n=r(1459),o=r(3632),i=r(5729),a=r(3158);e.exports=function(e,t,r){return t=(r?o(e,t,r):void 0===t)?1:i(t),n(a(e),t)}},3547:(e,t,r)=>{var n=r(5725),o=r(9764),i=r(5729),a=r(3158);e.exports=function(e,t,r){return e=a(e),r=null==r?0:n(i(r),0,e.length),t=o(t),e.slice(r,r+t.length)==t}},8721:e=>{e.exports=function(){return[]}},9375:e=>{e.exports=function(){return!1}},1144:(e,t,r)=>{var n=r(3662),o=1/0;e.exports=function(e){return e?(e=n(e))===o||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:0===e?e:0}},5729:(e,t,r)=>{var n=r(1144);e.exports=function(e){var t=n(e),r=t%1;return t==t?r?t-r:t:0}},3662:(e,t,r)=>{var n=r(7248),o=r(7453),i=r(7386),a=/^[-+]0x[0-9a-f]+$/i,l=/^0b[01]+$/i,s=/^0o[0-7]+$/i,u=parseInt;e.exports=function(e){if("number"==typeof e)return e;if(i(e))return NaN;if(o(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=o(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=n(e);var r=l.test(e);return r||s.test(e)?u(e.slice(2),r?2:8):a.test(e)?NaN:+e}},5148:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e){return n(e,o(e))}},3158:(e,t,r)=>{var n=r(9764);e.exports=function(e){return null==e?"":n(e)}},1624:(e,t,r)=>{var n=r(1282),o=r(3790);e.exports=function(e){return null==e?[]:n(e,o(e))}},4790:(e,t,r)=>{"use strict";var n=r(4621);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var l=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw l.name="Invariant Violation",l}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},7028:(e,t,r)=>{e.exports=r(4790)()},4621:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},1777:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(5053));t.A=function(e,t){void 0===t&&(t=[]);var r=i.default(e,t,{loading:!0}),n=r[0],a=r[1];return o.useEffect((function(){a()}),[a]),n}},5053:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(7016),o=r(5959),i=n.__importDefault(r(9812));t.default=function(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var a=o.useRef(0),l=i.default(),s=o.useState(r),u=s[0],c=s[1],d=o.useCallback((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o=++a.current;return u.loading||c((function(e){return n.__assign(n.__assign({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return l()&&o===a.current&&c({value:e,loading:!1}),e}),(function(e){return l()&&o===a.current&&c({error:e,loading:!1}),e}))}),t);return[u,d]}},990:(e,t,r)=>{"use strict";var n=r(7016),o=r(5959),i=n.__importDefault(r(1854));t.A=function(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var n=i.default(e,t),a=n[0],l=n[1],s=n[2];return o.useEffect(s,r),[a,l]}},9812:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(){var e=n.useRef(!1),t=n.useCallback((function(){return e.current}),[]);return n.useEffect((function(){return e.current=!0,function(){e.current=!1}}),[]),t}},1854:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(e,t){void 0===t&&(t=0);var r=n.useRef(!1),o=n.useRef(),i=n.useRef(e),a=n.useCallback((function(){return r.current}),[]),l=n.useCallback((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),s=n.useCallback((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return n.useEffect((function(){i.current=e}),[e]),n.useEffect((function(){return l(),s}),[t]),[a,s,l]}},8044:(e,t,r)=>{"use strict";var n=r(5959),o=Symbol.for("react.element"),i=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,l=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,s={key:!0,ref:!0,__self:!0,__source:!0};function u(e,t,r){var n,i={},u=null,c=null;for(n in void 0!==r&&(u=""+r),void 0!==t.key&&(u=""+t.key),void 0!==t.ref&&(c=t.ref),t)a.call(t,n)&&!s.hasOwnProperty(n)&&(i[n]=t[n]);if(e&&e.defaultProps)for(n in t=e.defaultProps)void 0===i[n]&&(i[n]=t[n]);return{$$typeof:o,type:e,key:u,ref:c,props:i,_owner:l.current}}t.Fragment=i,t.jsx=u,t.jsxs=u},9728:(e,t,r)=>{"use strict";e.exports=r(8044)},138:function(e){var t;t=function(){return function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{configurable:!1,enumerable:!0,get:n})},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=3)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelNode={create:function(e,t){var r,n={},o=e||"Abstract",i=[],a=null;if(n._type=o,n.getType=function(){return o},n.setType=function(e){o=e},n.getChildren=function(){return i},n.addChild=function(e){if(e){if(!e.setParent)throw{name:"Error",message:"Trying to add a child which is not a node: "+JSON.stringify(e)};e.setParent(n),i.push(e)}},n.getParent=function(){return a},n.setParent=function(e){a=e},n.getContext=function(e){return r||e.activeContext.peek()},n.setContext=function(e){r=e},n.getStartPosition=function(){return t>>16},n.getEndPosition=function(){return 65535&t},n.getValue=function(){throw{name:"MethodNotImplementedException",message:"SpelNode#getValue() must be overridden."}},n.toString=function(){var e="Kind: "+n.getType();e+=", Children: [";for(var t=0,r=n.getChildren().length;t<r;t+=1)e+="{"+n.getChildren()[t]+"}, ";return e+"]"},0===t)throw{name:"Error",message:"Position cannot be 0"};for(var l=arguments.length,s=Array(l>2?l-2:0),u=2;u<l;u++)s[u-2]=arguments[u];return s&&s.forEach((function(e){n.addChild(e)})),n}}},function(e,t,r){"use strict";function n(e){this.elements=e||[]}Object.defineProperty(t,"__esModule",{value:!0}),t.Stack=n,n.prototype.push=function(e){return this.elements.push(e),e},n.prototype.pop=function(){return this.elements.pop()},n.prototype.peek=function(){return this.elements[this.elements.length-1]},n.prototype.empty=function(){return this.elements.length>0},n.prototype.search=function(e){return this.elements.length-this.elements.indexOf(e)}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n={LITERAL_INT:1,LITERAL_LONG:2,LITERAL_HEXINT:3,LITERAL_HEXLONG:4,LITERAL_STRING:5,LITERAL_REAL:6,LITERAL_REAL_FLOAT:7,LPAREN:"(",RPAREN:")",COMMA:",",IDENTIFIER:0,COLON:":",HASH:"#",RSQUARE:"]",LSQUARE:"[",LCURLY:"{",RCURLY:"}",DOT:".",PLUS:"+",STAR:"*",MINUS:"-",SELECT_FIRST:"^[",SELECT_LAST:"$[",QMARK:"?",PROJECT:"![",DIV:"/",GE:">=",GT:">",LE:"<=",LT:"<",EQ:"==",NE:"!=",MOD:"%",NOT:"!",ASSIGN:"=",INSTANCEOF:"instanceof",MATCHES:"matches",BETWEEN:"between",SELECT:"?[",POWER:"^",ELVIS:"?:",SAFE_NAVI:"?.",BEAN_REF:"@",SYMBOLIC_OR:"||",SYMBOLIC_AND:"&&",INC:"++",DEC:"--"};function o(e){this.type=e,this.tokenChars=n[e],this._hasPayload="string"!=typeof n[e],"number"==typeof n[e]&&(this._ordinal=n[e])}for(var i in n)n.hasOwnProperty(i)&&(o[i]=new o(i));o.prototype.toString=function(){return this.type+(0!==this.tokenChars.length?"("+this.tokenChars+")":"")},o.prototype.getLength=function(){return this.tokenChars.length},o.prototype.hasPayload=function(){return this._hasPayload},o.prototype.valueOf=function(e){for(var t in n)if(n.hasOwnProperty(t)&&n[t]===e)return o[t]},o.prototype.ordinal=function(){return this._ordinal},t.TokenKind=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext=t.SpelExpressionEvaluator=void 0;var n=r(4),o=r(50);t.SpelExpressionEvaluator=n.SpelExpressionEvaluator,t.StandardContext=o.StandardContext},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionEvaluator=void 0;var n=r(5),o=r(1),i={compile:function(e){var t=(0,n.SpelExpressionParser)().parse(e);return{eval:function(e,r){return function(e,t,r){var n,i=new o.Stack;return t||(t={}),i.push(t),n={rootContext:t,activeContext:i,locals:r},e.getValue(n)}(t,e,r)},_compiledExpression:t}},eval:function(e,t,r){return i.compile(e).eval(t,r)}};t.SpelExpressionEvaluator=i},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionParser=void 0;var n=r(2),o=r(6),i=r(8),a=r(9),l=r(10),s=r(11),u=r(12),c=r(13),d=r(14),p=r(15),f=r(16),v=r(17),h=r(18),g=r(19),y=r(20),m=r(21),b=r(22),E=r(23),O=r(24),S=r(25),T=r(26),_=r(27),w=r(28),R=r(29),I=r(30),A=r(31),C=r(32),N=r(33),L=r(34),j=r(35),x=r(36),P=r(37),F=r(38),D=r(39),k=r(40),M=r(41),V=r(42),U=r(43),B=r(44),G=r(45),q=r(46),K=r(47),W=r(48),z=r(49);t.SpelExpressionParser=function(){var e,t,r,H,$=new RegExp("[\\p{L}\\p{N}_$]+"),Y=[];function Q(){var e=X();if(Se()){var t=_e();if(t.getKind()===n.TokenKind.ASSIGN){null===e&&(e=s.NullLiteral.create(Ce(t.startPos-1,t.endPos-1))),Te();var r=X();return h.Assign.create(Ae(t),e,r)}if(t.getKind()===n.TokenKind.ELVIS){null===e&&(e=s.NullLiteral.create(Ce(t.startPos-1,t.endPos-2))),Te();var o=Q();return null===o&&(o=s.NullLiteral.create(Ce(t.startPos+1,t.endPos+1))),F.Elvis.create(Ae(t),e,o)}if(t.getKind()===n.TokenKind.QMARK){null===e&&(e=s.NullLiteral.create(Ce(t.startPos-1,t.endPos-1))),Te();var i=Q();ye(n.TokenKind.COLON);var a=Q();return P.Ternary.create(Ae(t),e,i,a)}}return e}function X(){for(var e=J();Oe("or")||me(n.TokenKind.SYMBOLIC_OR);){var t=Te(),r=J();Re(t,e,r),e=j.OpOr.create(Ae(t),e,r)}return e}function J(){for(var e=Z();Oe("and")||me(n.TokenKind.SYMBOLIC_AND);){var t=Te(),r=Z();Re(t,e,r),e=L.OpAnd.create(Ae(t),e,r)}return e}function Z(){var e=ee(),t=function(){var e=_e();if(null===e)return null;if(e.isNumericRelationalOperator())return e;if(e.isIdentifier()){var t=e.stringValue();if("instanceof"===t.toLowerCase())return e.asInstanceOfToken();if("matches"===t.toLowerCase())return e.asMatchesToken();if("between"===t.toLowerCase())return e.asBetweenToken()}return null}();if(null!==t){var r=Te(),o=ee();Re(r,e,o);var i=t.kind;if(t.isNumericRelationalOperator()){var a=Ae(r);return i===n.TokenKind.GT?b.OpGT.create(a,e,o):i===n.TokenKind.LT?O.OpLT.create(a,e,o):i===n.TokenKind.LE?E.OpLE.create(a,e,o):i===n.TokenKind.GE?m.OpGE.create(a,e,o):i===n.TokenKind.EQ?g.OpEQ.create(a,e,o):y.OpNE.create(a,e,o)}return i===n.TokenKind.INSTANCEOF?U.OpInstanceof.create(Ae(r),e,o):i===n.TokenKind.MATCHES?x.OpMatches.create(Ae(r),e,o):B.OpBetween.create(Ae(r),e,o)}return e}function ee(){for(var e=te();Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.INC);){var t=Te(),r=te();Ie(t,r),t.getKind()===n.TokenKind.PLUS?e=S.OpPlus.create(Ae(t),e,r):t.getKind()===n.TokenKind.MINUS&&(e=T.OpMinus.create(Ae(t),e,r))}return e}function te(){for(var e=re();Ee(n.TokenKind.STAR,n.TokenKind.DIV,n.TokenKind.MOD);){var t=Te(),r=re();Re(t,e,r),e=t.getKind()===n.TokenKind.STAR?_.OpMultiply.create(Ae(t),e,r):t.getKind()===n.TokenKind.DIV?w.OpDivide.create(Ae(t),e,r):R.OpModulus.create(Ae(t),e,r)}return e}function re(){var e,t=ne();if(me(n.TokenKind.POWER)){e=Te();var r=ne();return Ie(e,r),I.OpPower.create(Ae(e),t,r)}return null!==t&&Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te()).getKind()===n.TokenKind.INC?A.OpInc.create(Ae(e),!0,t):C.OpDec.create(Ae(e),!0,t):t}function ne(){var e,t;return Ee(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.NOT)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.NOT?N.OpNot.create(Ae(e),t):e.getKind()===n.TokenKind.PLUS?S.OpPlus.create(Ae(e),t):T.OpMinus.create(Ae(e),t)):Ee(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.INC?A.OpInc.create(Ae(e),!1,t):C.OpDec.create(Ae(e),!1,t)):function(){var e=[],t=function(){var e=_e();if(null===e)return!1;if(e.getKind()===n.TokenKind.LITERAL_INT||e.getKind()===n.TokenKind.LITERAL_LONG)he(a.NumberLiteral.create(parseInt(e.stringValue(),10),Ae(e)));else if(e.getKind()===n.TokenKind.LITERAL_REAL||e.getKind()===n.TokenKind.LITERAL_REAL_FLOAT)he(a.NumberLiteral.create(parseFloat(e.stringValue()),Ae(e)));else if(e.getKind()===n.TokenKind.LITERAL_HEXINT||e.getKind()===n.TokenKind.LITERAL_HEXLONG)he(a.NumberLiteral.create(parseInt(e.stringValue(),16),Ae(e)));else if(Oe("true"))he(i.BooleanLiteral.create(!0,Ae(e)));else if(Oe("false"))he(i.BooleanLiteral.create(!1,Ae(e)));else{if(e.getKind()!==n.TokenKind.LITERAL_STRING)return!1;he(l.StringLiteral.create(e.stringValue(),Ae(e)))}return Te(),!0}()||function(){if(me(n.TokenKind.LPAREN)){Te();var e=Q();return ye(n.TokenKind.RPAREN),he(e),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();if("T"!==e.stringValue())return!1;var t=Te();if(me(n.TokenKind.RSQUARE))return he(d.PropertyReference.create(t.stringValue(),Ae(t))),!0;ye(n.TokenKind.LPAREN);for(var r=pe(),o=0;be(n.TokenKind.LSQUARE,!0);)ye(n.TokenKind.RSQUARE),o++;return ye(n.TokenKind.RPAREN),he(G.TypeReference.create(Ae(e),r,o)),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();return"null"===e.stringValue().toLowerCase()&&(Te(),he(s.NullLiteral.create(Ae(e))),!0)}return!1}()||function(){if(Oe("new")){var e=Te();if(me(n.TokenKind.RSQUARE))return he(d.PropertyReference.create(e.stringValue(),Ae(e))),!0;var t=pe(),r=[];if(r.push(t),me(n.TokenKind.LSQUARE)){for(var o=[];be(n.TokenKind.LSQUARE,!0);)me(n.TokenKind.RSQUARE)?o.push(null):o.push(Q()),ye(n.TokenKind.RSQUARE);ue()&&r.push(ge()),he(z.ConstructorReference.create(Ae(e),o,r))}else i=r,me(n.TokenKind.LPAREN)||we(Ae(_e()),"MISSING_CONSTRUCTOR_ARGS"),le(i),ye(n.TokenKind.RPAREN),he(z.ConstructorReference.create(Ae(e),r));return!0}var i;return!1}()||ve(!1)||ie()||function(){if(me(n.TokenKind.BEAN_REF)){var e=Te(),t=null,r=null;return me(n.TokenKind.IDENTIFIER)?r=(t=ye(n.TokenKind.IDENTIFIER)).data:me(n.TokenKind.LITERAL_STRING)?r=(r=(t=ye(n.TokenKind.LITERAL_STRING)).stringValue()).substring(1,r.length()-1):we(e.startPos,"INVALID_BEAN_REFERENCE"),he(q.BeanReference.create(Ae(t),r)),!0}return!1}()||se(!1)||de(!1)||ce()||ue()?ge():null;for(e.push(t);oe();)e.push(ge());return 1===e.length?e[0]:f.CompoundExpression.create(Ce(t.getStartPosition(),e[e.length-1].getEndPosition()),e)}()}function oe(){var e,t,r;return null!==(r=Ee(n.TokenKind.DOT,n.TokenKind.SAFE_NAVI)?ve(t=(e=Te()).getKind()===n.TokenKind.SAFE_NAVI)||ie()||se(t)||de(t)?ge():(null===_e()?we(e.startPos,"OOD"):we(e.startPos,"UNEXPECTED_DATA_AFTER_DOT",function(e){return e.getKind().hasPayload()?e.stringValue():e.getKind().toString().toLowerCase()}(_e())),null):me(n.TokenKind.LSQUARE)&&ce()?ge():null)&&(he(r),!0)}function ie(){if(!me(n.TokenKind.HASH))return!1;var e=Te(),t=ye(n.TokenKind.IDENTIFIER),r=ae();return null===r?(he(p.VariableReference.create(t.data,Ce(e.startPos,t.endPos))),!0):(he(u.FunctionReference.create(t.data,Ce(e.startPos,t.endPos),r)),!0)}function ae(){if(!me(n.TokenKind.LPAREN))return null;var e=[];return le(e),ye(n.TokenKind.RPAREN),e}function le(e){var t,r=_e().startPos;do{Te();var o=_e();null===o&&we(r,"RUN_OUT_OF_ARGUMENTS"),o.getKind()!==n.TokenKind.RPAREN&&e.push(Q()),t=_e()}while(null!==t&&t.kind===n.TokenKind.COMMA);null===t&&we(r,"RUN_OUT_OF_ARGUMENTS")}function se(e){var t=_e();if(!be(n.TokenKind.PROJECT,!0))return!1;var r=Q();return ye(n.TokenKind.RSQUARE),he(V.Projection.create(e,Ae(t),r)),!0}function ue(){var e=_e(),t=[];if(!be(n.TokenKind.LCURLY,!0))return!1;var r=null,o=_e();if(be(n.TokenKind.RCURLY,!0))r=D.InlineList.create(Ce(e.startPos,o.endPos));else if(be(n.TokenKind.COLON,!0))o=ye(n.TokenKind.RCURLY),r=k.InlineMap.create(Ce(e.startPos,o.endPos));else{var i=Q();if(me(n.TokenKind.RCURLY))t.push(i),o=ye(n.TokenKind.RCURLY),r=D.InlineList.create(Ce(e.startPos,o.endPos),t);else if(be(n.TokenKind.COMMA,!0)){t.push(i);do{t.push(Q())}while(be(n.TokenKind.COMMA,!0));o=ye(n.TokenKind.RCURLY),r=D.InlineList.create(Ae(e.startPos,o.endPos),t)}else if(be(n.TokenKind.COLON,!0)){var a=[];for(a.push(i),a.push(Q());be(n.TokenKind.COMMA,!0);)a.push(Q()),ye(n.TokenKind.COLON),a.push(Q());o=ye(n.TokenKind.RCURLY),r=k.InlineMap.create(Ce(e.startPos,o.endPos),a)}else we(e.startPos,"OOD")}return he(r),!0}function ce(){var e=_e();if(!be(n.TokenKind.LSQUARE,!0))return!1;var t=Q();return ye(n.TokenKind.RSQUARE),he(v.Indexer.create(Ae(e),t)),!0}function de(e){var t=_e();if(!function(){if(!Se())return!1;var e=_e();return e.getKind()===n.TokenKind.SELECT||e.getKind()===n.TokenKind.SELECT_FIRST||e.getKind()===n.TokenKind.SELECT_LAST}())return!1;Te();var r=Q();return null===r&&we(Ae(t),"MISSING_SELECTION_EXPRESSION"),ye(n.TokenKind.RSQUARE),t.getKind()===n.TokenKind.SELECT_FIRST?he(M.Selection.create(e,M.Selection.FIRST,Ae(t),r)):t.getKind()===n.TokenKind.SELECT_LAST?he(M.Selection.create(e,M.Selection.LAST,Ae(t),r)):he(M.Selection.create(e,M.Selection.ALL,Ae(t),r)),!0}function pe(){for(var t=[],r=_e();fe(r);)Te(),r.kind!==n.TokenKind.DOT&&t.push(K.Identifier.create(r.stringValue(),Ae(r))),r=_e();t.length||(null===r&&we(e.length(),"OOD"),we(r.startPos,"NOT_EXPECTED_TOKEN","qualified ID",r.getKind().toString().toLowerCase()));var o=Ce(t[0].getStartPosition(),t[t.length-1].getEndPosition());return W.QualifiedIdentifier.create(o,t)}function fe(e){if(null===e||e.kind===n.TokenKind.LITERAL_STRING)return!1;if(e.kind===n.TokenKind.DOT||e.kind===n.TokenKind.IDENTIFIER)return!0;var t=e.stringValue();return t&&t.length&&$.test(t)}function ve(e){if(me(n.TokenKind.IDENTIFIER)){var t=Te(),r=ae();return null===r?(he(d.PropertyReference.create(e,t.stringValue(),Ae(t))),!0):(he(c.MethodReference.create(e,t.stringValue(),Ae(t),r)),!0)}return!1}function he(e){Y.push(e)}function ge(){return Y.pop()}function ye(t){var r=Te();return null===r&&we(e.length,"OOD"),r.getKind()!==t&&we(r.startPos,"NOT_EXPECTED_TOKEN",t.toString().toLowerCase(),r.getKind().toString().toLowerCase()),r}function me(e){return be(e,!1)}function be(e,t){if(!Se())return!1;var r=_e();return r.getKind()===e?(t&&H++,!0):e===n.TokenKind.IDENTIFIER&&r.getKind().ordinal()>=n.TokenKind.DIV.ordinal()&&r.getKind().ordinal()<=n.TokenKind.NOT.ordinal()&&null!==r.data}function Ee(){if(!Se())return!1;for(var e=_e(),t=Array.prototype.slice.call(arguments),r=0,n=t.length;r<n;r+=1)if(e.getKind()===t[r])return!0;return!1}function Oe(e){if(!Se())return!1;var t=_e();return t.getKind()===n.TokenKind.IDENTIFIER&&t.stringValue().toLowerCase()===e.toLowerCase()}function Se(){return H<t.length}function Te(){return H>=r?null:t[H++]}function _e(){return H>=r?null:t[H]}function we(t,r,n,o){throw n&&(r+="\nExpected: "+n),o&&(r+="\nActual: "+o),{name:"InternalParseException",message:"Error occurred while attempting to parse expression '"+e+"' at position "+t+". Message: "+r}}function Re(e,t,r){!function(e,t){null===t&&we(e.startPos,"LEFT_OPERAND_PROBLEM")}(e,t),Ie(e,r)}function Ie(e,t){null===t&&we(e.startPos,"RIGHT_OPERAND_PROBLEM")}function Ae(e){return(e.startPos<<16)+e.endPos}function Ce(e,t){return(e<<16)+t}return{setConfiguration:function(e){},parse:function(n,i){try{e=n,t=o.Tokenizer.tokenize(n),r=t.length,H=0,Y=[];var a=Q();return Se()&&we(_e().startPos,"MORE_INPUT",Te().toString()),a}catch(e){throw e.message}}}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Tokenizer=void 0;var n=r(7),o=r(2),i=["DIV","EQ","GE","GT","LE","LT","MOD","NE","NOT"],a=[];!function(){var e;for(e="0".charCodeAt(0);e<="9".charCodeAt(0);e+=1)a[e]|=3;for(e="A".charCodeAt(0);e<="F".charCodeAt(0);e+=1)a[e]|=2;for(e="a".charCodeAt(0);e<="f".charCodeAt(0);e+=1)a[e]|=2;for(e="A".charCodeAt(0);e<="Z".charCodeAt(0);e+=1)a[e]|=4;for(e="a".charCodeAt(0);e<="z".charCodeAt(0);e+=1)a[e]|=4}(),t.Tokenizer={tokenize:function(e){var t=e,r=e+"\0",l=r.length,s=0,u=[];function c(){for(var e,i=s,a=!1;!a;)if("'"===(e=r[s+=1])&&("'"===r[s+1]?s+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating quoted string in expression ("+t+") at position "+s};s+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,s),i,s))}function d(){for(var e,i=s,a=!1;!a;)if('"'===(e=r[s+=1])&&('"'===r[s+1]?s+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating double-quoted string in expression ("+t+") at position "+s};s+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,s),i,s))}function p(e){var n,o,i,a=!1,l=s,u=r[s+1];if(!e||"x"!==u&&"X"!==u){do{s+=1}while(_(r[s]));if("."===(u=r[s])){a=!0,n=s;do{s+=1}while(_(r[s]));if(s===n+1)return void v(y(l,s=n),!1,l,s)}if(o=s,O("L","l")){if(a)throw{name:"SpelParseException",message:"Real cannot be long in expression ("+t+") at position "+s};v(y(l,o),!0,l,o),s+=1}else if(function(e){return"e"===e||"E"===e}(r[s])){a=!0,function(e){return"+"===e||"-"===e}(r[s+=1])&&(s+=1);do{s+=1}while(_(r[s]));i=!1,S(r[s])?(i=!0,o=s+=1):T(r[s])&&(o=s+=1),g(y(l,s),i,l,s)}else i=!1,S(u=r[s])?(a=!0,i=!0,o=s+=1):T(u)&&(a=!0,o=s+=1),a?g(y(l,o),i,l,o):v(y(l,o),!1,l,o)}else{s+=1;do{s+=1}while(R(r[s]));O("L","l")?(h(y(l+2,s),!0,l,s),s+=1):h(y(l+2,s),!1,l,s)}}function f(){var e,t,a,l=s;do{s+=1}while(w(a=r[s])||_(a)||"_"===a||"$"===a);e=y(l,s),(s-l==2||s-l==3)&&(t=e.toUpperCase(),i.indexOf(t)>=0)?function(e,t,r){u.push(new n.Token(e,r,t,t+e.getLength()))}(o.TokenKind.valueOf(t),l,e):u.push(new n.Token(o.TokenKind.IDENTIFIER,e.replace("\0",""),l,s))}function v(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_LONG,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_INT,e,r,i))}function h(e,r,i,a){if(0===e.length)throw r?{name:"SpelParseException",message:"Not a long in expression ("+t+") at position "+s}:{name:"SpelParseException",message:"Not an int in expression ("+t+") at position "+s};r?u.push(new n.Token(o.TokenKind.LITERAL_HEXLONG,e,i,a)):u.push(new n.Token(o.TokenKind.LITERAL_HEXINT,e,i,a))}function g(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_REAL_FLOAT,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_REAL,e,r,i))}function y(e,t){return r.substring(e,t)}function m(e){return 2===e.tokenChars.length&&r[s]===e.tokenChars[0]&&r[s+1]===e.tokenChars[1]}function b(e){u.push(new n.Token(e,null,s,s+1)),s+=1}function E(e){u.push(new n.Token(e,null,s,s+2)),s+=2}function O(e,t){var n=r[s];return n===e||n===t}function S(e){return"f"===e||"F"===e}function T(e){return"d"===e||"D"===e}function _(e){return!(e.charCodeAt(0)>255||!(1&a[e.charCodeAt(0)]))}function w(e){return!(e.charCodeAt(0)>255||!(4&a[e.charCodeAt(0)]))}function R(e){return!(e.charCodeAt(0)>255||!(2&a[e.charCodeAt(0)]))}return function(){for(var e;s<l;)if(w(e=r[s]))f();else switch(e){case"+":m(o.TokenKind.INC)?E(o.TokenKind.INC):b(o.TokenKind.PLUS);break;case"_":f();break;case"-":m(o.TokenKind.DEC)?E(o.TokenKind.DEC):b(o.TokenKind.MINUS);break;case":":b(o.TokenKind.COLON);break;case".":b(o.TokenKind.DOT);break;case",":b(o.TokenKind.COMMA);break;case"*":b(o.TokenKind.STAR);break;case"/":b(o.TokenKind.DIV);break;case"%":b(o.TokenKind.MOD);break;case"(":b(o.TokenKind.LPAREN);break;case")":b(o.TokenKind.RPAREN);break;case"[":b(o.TokenKind.LSQUARE);break;case"#":b(o.TokenKind.HASH);break;case"]":b(o.TokenKind.RSQUARE);break;case"{":b(o.TokenKind.LCURLY);break;case"}":b(o.TokenKind.RCURLY);break;case"@":b(o.TokenKind.BEAN_REF);break;case"^":m(o.TokenKind.SELECT_FIRST)?E(o.TokenKind.SELECT_FIRST):b(o.TokenKind.POWER);break;case"!":m(o.TokenKind.NE)?E(o.TokenKind.NE):m(o.TokenKind.PROJECT)?E(o.TokenKind.PROJECT):b(o.TokenKind.NOT);break;case"=":m(o.TokenKind.EQ)?E(o.TokenKind.EQ):b(o.TokenKind.ASSIGN);break;case"&":if(!m(o.TokenKind.SYMBOLIC_AND))throw{name:"SpelParseException",message:"Missing character '&' in expression ("+t+") at position "+s};E(o.TokenKind.SYMBOLIC_AND);break;case"|":if(!m(o.TokenKind.SYMBOLIC_OR))throw{name:"SpelParseException",message:"Missing character '|' in expression ("+t+") at position "+s};E(o.TokenKind.SYMBOLIC_OR);break;case"?":m(o.TokenKind.SELECT)?E(o.TokenKind.SELECT):m(o.TokenKind.ELVIS)?E(o.TokenKind.ELVIS):m(o.TokenKind.SAFE_NAVI)?E(o.TokenKind.SAFE_NAVI):b(o.TokenKind.QMARK);break;case"$":m(o.TokenKind.SELECT_LAST)?E(o.TokenKind.SELECT_LAST):f();break;case">":m(o.TokenKind.GE)?E(o.TokenKind.GE):b(o.TokenKind.GT);break;case"<":m(o.TokenKind.LE)?E(o.TokenKind.LE):b(o.TokenKind.LT);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":p("0"===e);break;case" ":case"\t":case"\r":case"\n":case"\0":s+=1;break;case"'":c();break;case'"':d();break;case"\\":throw{name:"SpelParseException",message:"Unexpected escape character in expression ("+t+") at position "+s};default:throw{name:"SpelParseException",message:"Cannot handle character '"+e+"' in expression ("+t+") at position "+s}}}(),u}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Token=void 0;var n=r(2);function o(e,t,r,n){this.kind=e,this.startPos=r,this.endPos=n,t&&(this.data=t)}o.prototype.getKind=function(){return this.kind},o.prototype.toString=function(){var e="[";return e+=this.kind.toString(),this.kind.hasPayload()&&(e+=":"+this.data),(e+="]")+"("+this.startPos+","+this.endPos+")"},o.prototype.isIdentifier=function(){return this.kind===n.TokenKind.IDENTIFIER},o.prototype.isNumericRelationalOperator=function(){return this.kind===n.TokenKind.GT||this.kind===n.TokenKind.GE||this.kind===n.TokenKind.LT||this.kind===n.TokenKind.LE||this.kind===n.TokenKind.EQ||this.kind===n.TokenKind.NE},o.prototype.stringValue=function(){return this.data},o.prototype.asInstanceOfToken=function(){return new o(n.TokenKind.INSTANCEOF,this.startPos,this.endPos)},o.prototype.asMatchesToken=function(){return new o(n.TokenKind.MATCHES,this.startPos,this.endPos)},o.prototype.asBetweenToken=function(){return new o(n.TokenKind.BETWEEN,this.startPos,this.endPos)},o.prototype.getStartPosition=function(){return this.startPos},o.prototype.getEndPosition=function(){return this.endPos},t.Token=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BooleanLiteral=void 0;var n=r(0);t.BooleanLiteral={create:function(e,t){var r=n.SpelNode.create("boolean",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NumberLiteral=void 0;var n=r(0);t.NumberLiteral={create:function(e,t){var r=n.SpelNode.create("number",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringLiteral=void 0;var n=r(0);t.StringLiteral={create:function(e,t){var r=n.SpelNode.create("string",t);return e=function(e){return("'"===e[0]&&"'"===e[e.length-1]||'"'===e[0]&&'"'===e[e.length-1])&&(e=e.substring(1,e.length-1)),e.replace(/''/g,"'").replace(/""/g,'"')}(e),r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullLiteral=void 0;var n=r(0);t.NullLiteral={create:function(e,t){var r=n.SpelNode.create("null",t);return r.getValue=function(){return null},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FunctionReference=void 0;var n=r(0),o=r(1);t.FunctionReference={create:function(e,t,r){var i=n.SpelNode.create("function",t);return i.getRaw=function(){return{functionName:e,args:r}},i.getValue=function(t){var n=t.locals||{},i=t.rootContext,a=[];if(r.forEach((function(e){var r=t.activeContext;t.activeContext=new o.Stack,t.activeContext.push(t.rootContext),a.push(e.getValue(t)),t.activeContext=r})),n[e])return n[e].apply(i,a);throw{name:"FunctionDoesNotExistException",message:"Function '"+e+"' does not exist."}},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MethodReference=void 0;var n=r(0),o=r(1);t.MethodReference={create:function(e,t,r,i){var a=n.SpelNode.create("method",r);return a.getRaw=function(){return{methodName:t,args:i}},a.getValue=function(r){var n,a=r.activeContext.peek(),l=[];if(!a)throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."};function s(r){if(null==r){if(e)return null;throw{name:"NullPointerException",message:"Method "+t+" does not exist."}}return r}if(i.forEach((function(e){var t=r.activeContext;r.activeContext=new o.Stack,r.activeContext.push(r.rootContext),l.push(e.getValue(r)),r.activeContext=t})),"get"===t.substr(0,3)&&!a[t])return s(a[t.charAt(3).toLowerCase()+t.substring(4)]);if("set"===t.substr(0,3)&&!a[t])return a[t.charAt(3).toLowerCase()+t.substring(4)]=l[0];if(Array.isArray(a)){if("size"===t)return a.length;if("contains"===t)return a.includes(l[0])}return(n=s(a[t]))?n.apply(a,l):null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyReference=void 0;var n=r(0);t.PropertyReference={create:function(e,t,r){var o=n.SpelNode.create("property",r);return o.getRaw=function(){return t},o.getValue=function(r){var n=r.activeContext.peek();if(!n){if(e)return null;throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."}}if(void 0===n[t]||null===n[t]){if(e)return null;if("size"===t&&Array.isArray(n))return n.length;throw{name:"NullPointerException",message:"Property '"+t+"' does not exist."}}return n[t]},o.setValue=function(e,r){var n=r.activeContext.peek();if(!n)throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t+"' for an undefined context."};return n[t]=e},o.getName=function(){return t},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VariableReference=void 0;var n=r(0);t.VariableReference={create:function(e,t){var r=n.SpelNode.create("variable",t);return r.getRaw=function(){return e},r.getValue=function(t){var r=t.activeContext.peek(),n=t.locals;if(!r)throw{name:"ContextDoesNotExistException",message:"Attempting to look up variable '"+e+"' for an undefined context."};return"this"===e?r:"root"===e?t.rootContext:n[e]},r.setValue=function(t,r){return r.locals[e]=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CompoundExpression=void 0;var n=r(0);t.CompoundExpression={create:function(e,t){var r=n.SpelNode.create.apply(null,["compound",e].concat(t));function o(e){var t,n=r.getChildren().length;for(t=0;t<n;t+=1)"indexer"===r.getChildren()[t].getType()?e.activeContext.push(e.activeContext.peek()[r.getChildren()[t].getValue(e)]):e.activeContext.push(r.getChildren()[t].getValue(e));return function(){for(t=0;t<n;t+=1)e.activeContext.pop()}}return r.getValue=function(e){var t;if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};var r=o(e);return t=e.activeContext.peek(),r(),t},r.setValue=function(e,t){var n=o(t),i=r.getChildren().length;return t.activeContext.pop(),e=r.getChildren()[i-1].setValue(e,t),t.activeContext.push(null),n(),e},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Indexer=void 0;var n=r(0),o=r(1);t.Indexer={create:function(e,t){var r=n.SpelNode.create.apply(null,["indexer",e].concat(t));return r.getValue=function(e){var t,n,i=e.activeContext,a=r.getChildren().length;if(e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};for(t=0;t<a;t+=1)e.activeContext.push(r.getChildren()[t].getValue(e));for(n=e.activeContext.peek(),t=0;t<a;t+=1)e.activeContext.pop();return e.activeContext=i,n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Assign=void 0;var n=r(0);t.Assign={create:function(e,t,r){var o=n.SpelNode.create("assign",e,t,r);return o.getValue=function(e){if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t.getValue(e)+"' for an undefined context."};return t.setValue(r.getValue(e),e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpEQ=void 0;var n=r(0);t.OpEQ={create:function(e,t,r){var o=n.SpelNode.create("op-eq",e,t,r);return o.getValue=function(e){return t.getValue(e)===r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNE=void 0;var n=r(0);t.OpNE={create:function(e,t,r){var o=n.SpelNode.create("op-ne",e,t,r);return o.getValue=function(e){return t.getValue(e)!==r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGE=void 0;var n=r(0);t.OpGE={create:function(e,t,r){var o=n.SpelNode.create("op-ge",e,t,r);return o.getValue=function(e){return t.getValue(e)>=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGT=void 0;var n=r(0);t.OpGT={create:function(e,t,r){var o=n.SpelNode.create("op-gt",e,t,r);return o.getValue=function(e){return t.getValue(e)>r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLE=void 0;var n=r(0);t.OpLE={create:function(e,t,r){var o=n.SpelNode.create("op-le",e,t,r);return o.getValue=function(e){return t.getValue(e)<=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLT=void 0;var n=r(0);t.OpLT={create:function(e,t,r){var o=n.SpelNode.create("op-lt",e,t,r);return o.getValue=function(e){return t.getValue(e)<r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPlus=void 0;var n=r(0);t.OpPlus={create:function(e,t,r){var o=n.SpelNode.create("op-plus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)+r.getValue(e):+t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMinus=void 0;var n=r(0);t.OpMinus={create:function(e,t,r){var o=n.SpelNode.create("op-minus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)-r.getValue(e):-t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMultiply=void 0;var n=r(0);t.OpMultiply={create:function(e,t,r){var o=n.SpelNode.create("op-multiply",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);if("number"==typeof n&&"number"==typeof o)return n*o;if("string"==typeof n&&"number"==typeof o){for(var i="",a=0;a<o;a+=1)i+=n;return i}return null},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDivide=void 0;var n=r(0);t.OpDivide={create:function(e,t,r){var o=n.SpelNode.create("op-divide",e,t,r);return o.getValue=function(e){return t.getValue(e)/r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpModulus=void 0;var n=r(0);t.OpModulus={create:function(e,t,r){var o=n.SpelNode.create("op-modulus",e,t,r);return o.getValue=function(e){return t.getValue(e)%r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPower=void 0;var n=r(0);t.OpPower={create:function(e,t,r){var o=n.SpelNode.create("op-power",e,t,r);return o.getValue=function(e){return Math.pow(t.getValue(e),r.getValue(e))},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInc=void 0;var n=r(0);t.OpInc={create:function(e,t,r){var o=n.SpelNode.create("op-inc",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n+1,e),t?n:n+1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDec=void 0;var n=r(0);t.OpDec={create:function(e,t,r){var o=n.SpelNode.create("op-dec",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n-1,e),t?n:n-1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNot=void 0;var n=r(0);t.OpNot={create:function(e,t){var r=n.SpelNode.create("op-not",e,t);return r.getValue=function(e){return!t.getValue(e)},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpAnd=void 0;var n=r(0);t.OpAnd={create:function(e,t,r){var o=n.SpelNode.create("op-and",e,t,r);return o.getValue=function(e){return!!t.getValue(e)&&!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpOr=void 0;var n=r(0);t.OpOr={create:function(e,t,r){var o=n.SpelNode.create("op-or",e,t,r);return o.getValue=function(e){return!!t.getValue(e)||!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMatches=void 0;var n=r(0);t.OpMatches={create:function(e,t,r){var o=n.SpelNode.create("matches",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);try{return!!new RegExp(o).exec(n)}catch(e){throw{name:"EvaluationException",message:e.toString()}}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ternary=void 0;var n=r(0);t.Ternary={create:function(e,t,r,o){var i=n.SpelNode.create("ternary",e,t,r,o);return i.getValue=function(e){return t.getValue(e)?r.getValue(e):o.getValue(e)},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Elvis=void 0;var n=r(0);t.Elvis={create:function(e,t,r){var o=n.SpelNode.create("elvis",e,t,r);return o.getValue=function(e){return null!==t.getValue(e)?t.getValue(e):r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineList=void 0;var n=r(0);t.InlineList={create:function(e,t){var r=n.SpelNode.create("list",e),o=[].concat(t||[]);return r.getRaw=function(){return o},r.getValue=function(e){return o.map((function(t){return t.getValue(e)}))},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineMap=void 0;var n=r(0);t.InlineMap={create:function(e,t){var r=n.SpelNode.create("map",e),o=[].concat(t||[]);return r.getValue=function(e){var t=!0,r=null,n={};return o.forEach((function(o){t?r="property"===o.getType()?o.getName():o.getValue(e):n[r]=o.getValue(e),t=!t})),n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}t.Selection={create:function(e,t,r,a){var l=o.SpelNode.create("selection",r,a);return l.getValue=function(e){var r=e.activeContext.peek();if(r){if(Array.isArray(r))return function(e,t,r,n){var o=e.filter((function(e){return i(e,r,n)}));switch(t){case"ALL":return o;case"FIRST":return o[0]||null;case"LAST":return o.length?o[o.length-1]:null}}(r,t,a,e);if("object"===(void 0===r?"undefined":n(r)))return function(e,t,r,n){var o,a,l={},s=[],u={};for(a in e)e.hasOwnProperty(a)&&i(o={key:a,value:e[a]},r,n)&&s.push(o);switch(t){case"ALL":return s.forEach((function(e){l[e.key]=e.value})),l;case"FIRST":return s.length?(u[s[0].key]=s[0].value,u):null;case"LAST":return s.length?(u[s[s.length-1].key]=s[s.length-1].value,u):null}s.forEach((function(e){l[e.key]=e.value}))}(r,t,a,e)}return null},l},FIRST:"FIRST",LAST:"LAST",ALL:"ALL"}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Projection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){return e.map((function(e){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}))}t.Projection={create:function(e,t,r){var a=o.SpelNode.create("projection",t,r);return a.getValue=function(e){var t,o=e.activeContext.peek(),a=[];if(Array.isArray(o))return i(o,r,e);if("object"===(void 0===o?"undefined":n(o))){for(t in o)o.hasOwnProperty(t)&&a.push(o[t]);return i(a,r,e)}return null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInstanceof=void 0;var n=r(0);t.OpInstanceof={create:function(e,t,r){var o=n.SpelNode.create("instanceof",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpInstanceOf: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpBetween=void 0;var n=r(0);t.OpBetween={create:function(e,t,r){var o=n.SpelNode.create("between",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpBetween: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TypeReference=void 0;var n=r(0);t.TypeReference={create:function(e,t,r){return(t=n.SpelNode.create("typeref",e,t)).getValue=function(e){throw{name:"MethodNotImplementedException",message:"TypeReference: Not implemented"}},t}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BeanReference=void 0;var n=r(0);t.BeanReference={create:function(e,t){var r=n.SpelNode.create("beanref",e);return r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"BeanReference: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Identifier=void 0;var n=r(0);t.Identifier={create:function(e,t){var r=n.SpelNode.create("identifier",t);return r.getRaw=function(){return e},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"Identifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QualifiedIdentifier=void 0;var n=r(0);t.QualifiedIdentifier={create:function(e,t){var r=n.SpelNode.create.apply(n.SpelNode,["qualifiedidentifier",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(t)));return r.getRaw=function(){return t.map((function(e){return e.getRaw()}))},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"QualifiedIdentifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConstructorReference=void 0;var n=r(0),o=r(1);t.ConstructorReference={create:function(e,t,r){var i,a=void 0!==r;a?i=t.length&&t[0]&&"number"===t[0].getType()?t[0].getValue():null:(r=t,t=void 0);var l,s=(l=r,Array.isArray(l)?l:Array.from(l)),u=(s[0],s.slice(1)),c=n.SpelNode.create.apply(n.SpelNode,["constructorref",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(r)));return c.getRaw=function(){return i},c.getValue=function(e){if(a&&u.length<=1){var t=[];return u.forEach((function(r){var n=e.activeContext;e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),t.push(r.getValue(e)),e.activeContext=n})),1===u.length?t[0]:i?new Array(i):[]}throw{name:"MethodNotImplementedException",message:"ConstructorReference: Not implemented"}},c}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext={create:function(e,t){var r={};return r.authentication=e||{},r.principal=t||{},r.hasRole=function(e){var t=!1;return!!e&&!(!r.authentication&&!Array.isArray(r.authentication.authorities))&&(r.authentication.authorities.forEach((function(r){r.authority.toLowerCase()===e.toLowerCase()&&(t=!0)})),t)},r.hasPermission=function(){var e=Array.prototype.slice.call(arguments);if(1===e.length)return r.hasRole(e[0])},r}}}])},e.exports=t()},9157:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=s(r(1283)),o=s(r(1025)),i=s(r(2520)),a=s(r(9137)),l=s(r(9429));function s(e){return e&&e.__esModule?e:{default:e}}function u(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var c=function(e){return e.replace(/[\t ]+$/,"")},d=function(){function e(t,r,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t||{},this.indentation=new i.default(this.cfg.indent),this.inlineBlock=new a.default,this.params=new l.default(this.cfg.params),this.tokenizer=r,this.tokenOverride=n,this.previousReservedWord={},this.tokens=[],this.index=0}var t,r;return t=e,r=[{key:"format",value:function(e){return this.tokens=this.tokenizer.tokenize(e),this.getFormattedQueryFromTokens().trim()}},{key:"getFormattedQueryFromTokens",value:function(){var e=this,t="";return this.tokens.forEach((function(r,n){e.index=n,e.tokenOverride&&(r=e.tokenOverride(r,e.previousReservedWord)||r),r.type===o.default.WHITESPACE||(r.type===o.default.LINE_COMMENT?t=e.formatLineComment(r,t):r.type===o.default.BLOCK_COMMENT?t=e.formatBlockComment(r,t):r.type===o.default.RESERVED_TOP_LEVEL?(t=e.formatTopLevelReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_TOP_LEVEL_NO_INDENT?(t=e.formatTopLevelReservedWordNoIndent(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_NEWLINE?(t=e.formatNewlineReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED?(t=e.formatWithSpaces(r,t),e.previousReservedWord=r):t=r.type===o.default.OPEN_PAREN?e.formatOpeningParentheses(r,t):r.type===o.default.CLOSE_PAREN?e.formatClosingParentheses(r,t):r.type===o.default.PLACEHOLDER?e.formatPlaceholder(r,t):","===r.value?e.formatComma(r,t):":"===r.value?e.formatWithSpaceAfter(r,t):"."===r.value?e.formatWithoutSpaces(r,t):";"===r.value?e.formatQuerySeparator(r,t):e.formatWithSpaces(r,t))})),t}},{key:"formatLineComment",value:function(e,t){return this.addNewline(t+e.value)}},{key:"formatBlockComment",value:function(e,t){return this.addNewline(this.addNewline(t)+this.indentComment(e.value))}},{key:"indentComment",value:function(e){return e.replace(/\n[\t ]*/g,"\n"+this.indentation.getIndent()+" ")}},{key:"formatTopLevelReservedWordNoIndent",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatTopLevelReservedWord",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t),this.indentation.increaseTopLevel(),t+=this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatNewlineReservedWord",value:function(e,t){return this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value))+" "}},{key:"equalizeWhitespace",value:function(e){return e.replace(/[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+/g," ")}},{key:"formatOpeningParentheses",value:function(e,t){var r=[o.default.WHITESPACE,o.default.OPEN_PAREN,o.default.LINE_COMMENT];return(0,n.default)(r,this.previousToken().type)||(t=c(t)),t+=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.beginIfPossible(this.tokens,this.index),this.inlineBlock.isActive()||(this.indentation.increaseBlockLevel(),t=this.addNewline(t)),t}},{key:"formatClosingParentheses",value:function(e,t){return e.value=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.isActive()?(this.inlineBlock.end(),this.formatWithSpaceAfter(e,t)):(this.indentation.decreaseBlockLevel(),this.formatWithSpaces(e,this.addNewline(t)))}},{key:"formatPlaceholder",value:function(e,t){return t+this.params.get(e)+" "}},{key:"formatComma",value:function(e,t){return t=c(t)+e.value+" ",this.inlineBlock.isActive()||/^LIMIT$/i.test(this.previousReservedWord.value)?t:this.addNewline(t)}},{key:"formatWithSpaceAfter",value:function(e,t){return c(t)+e.value+" "}},{key:"formatWithoutSpaces",value:function(e,t){return c(t)+e.value}},{key:"formatWithSpaces",value:function(e,t){return t+("reserved"===e.type?this.formatReservedWord(e.value):e.value)+" "}},{key:"formatReservedWord",value:function(e){return this.cfg.uppercase?e.toUpperCase():e}},{key:"formatQuerySeparator",value:function(e,t){return this.indentation.resetIndentation(),c(t)+e.value+"\n".repeat(this.cfg.linesBetweenQueries||1)}},{key:"addNewline",value:function(e){return(e=c(e)).endsWith("\n")||(e+="\n"),e+this.indentation.getIndent()}},{key:"previousToken",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.tokens[this.index-e]||{}}}],r&&u(t.prototype,r),e}();t.default=d,e.exports=t.default},2520:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9901)),o=i(r(8906));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l="top-level",s=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.indent=t||"  ",this.indentTypes=[]}var t,r;return t=e,(r=[{key:"getIndent",value:function(){return(0,n.default)(this.indent,this.indentTypes.length)}},{key:"increaseTopLevel",value:function(){this.indentTypes.push(l)}},{key:"increaseBlockLevel",value:function(){this.indentTypes.push("block-level")}},{key:"decreaseTopLevel",value:function(){(0,o.default)(this.indentTypes)===l&&this.indentTypes.pop()}},{key:"decreaseBlockLevel",value:function(){for(;this.indentTypes.length>0&&this.indentTypes.pop()===l;);}},{key:"resetIndentation",value:function(){this.indentTypes=[]}}])&&a(t.prototype,r),e}();t.default=s,e.exports=t.default},9137:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n,o=(n=r(1025))&&n.__esModule?n:{default:n};function i(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.level=0}var t,r;return t=e,(r=[{key:"beginIfPossible",value:function(e,t){0===this.level&&this.isInlineBlock(e,t)?this.level=1:this.level>0?this.level++:this.level=0}},{key:"end",value:function(){this.level--}},{key:"isActive",value:function(){return this.level>0}},{key:"isInlineBlock",value:function(e,t){for(var r=0,n=0,i=t;i<e.length;i++){var a=e[i];if((r+=a.value.length)>50)return!1;if(a.type===o.default.OPEN_PAREN)n++;else if(a.type===o.default.CLOSE_PAREN&&0==--n)return!0;if(this.isForbiddenToken(a))return!1}return!1}},{key:"isForbiddenToken",value:function(e){var t=e.type,r=e.value;return t===o.default.RESERVED_TOP_LEVEL||t===o.default.RESERVED_NEWLINE||t===o.default.COMMENT||t===o.default.BLOCK_COMMENT||";"===r}}])&&i(t.prototype,r),e}();t.default=a,e.exports=t.default},9429:(e,t)=>{"use strict";function r(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.params=t,this.index=0}var t,n;return t=e,(n=[{key:"get",value:function(e){var t=e.key,r=e.value;return this.params?t?this.params[t]:this.params[this.index++]:r}}])&&r(t.prototype,n),e}();t.default=n,e.exports=t.default},3202:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(7969)),o=a(r(8472)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function l(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.WHITESPACE_REGEX=/^([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+)/,this.NUMBER_REGEX=/^((\x2D[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*)?[0-9]+(\.[0-9]+)?|0x[0-9A-Fa-f]+|0b[01]+)\b/,this.OPERATOR_REGEX=/^(!=|<>|==|<=|>=|!<|!>|\|\||::|\x2D>>|\x2D>|~~\*|~~|!~~\*|!~~|~\*|!~\*|!~|:=|(?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))/,this.BLOCK_COMMENT_REGEX=/^(\/\*(?:[\0-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*?(?:\*\/|$))/,this.LINE_COMMENT_REGEX=this.createLineCommentRegex(t.lineCommentTypes),this.RESERVED_TOP_LEVEL_REGEX=this.createReservedWordRegex(t.reservedTopLevelWords),this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX=this.createReservedWordRegex(t.reservedTopLevelWordsNoIndent),this.RESERVED_NEWLINE_REGEX=this.createReservedWordRegex(t.reservedNewlineWords),this.RESERVED_PLAIN_REGEX=this.createReservedWordRegex(t.reservedWords),this.WORD_REGEX=this.createWordRegex(t.specialWordChars),this.STRING_REGEX=this.createStringRegex(t.stringTypes),this.OPEN_PAREN_REGEX=this.createParenRegex(t.openParens),this.CLOSE_PAREN_REGEX=this.createParenRegex(t.closeParens),this.INDEXED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.indexedPlaceholderTypes,"[0-9]*"),this.IDENT_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,"[a-zA-Z0-9._$]+"),this.STRING_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,this.createStringPattern(t.stringTypes))}var t,r;return t=e,r=[{key:"createLineCommentRegex",value:function(e){return new RegExp("^((?:".concat(e.map((function(e){return(0,o.default)(e)})).join("|"),").*?(?:\r\n|\r|\n|$))"),"u")}},{key:"createReservedWordRegex",value:function(e){var t=e.join("|").replace(/ /g,"\\s+");return new RegExp("^(".concat(t,")\\b"),"iu")}},{key:"createWordRegex",value:function(){return new RegExp("^([\\p{Alphabetic}\\p{Mark}\\p{Decimal_Number}\\p{Connector_Punctuation}\\p{Join_Control}".concat((arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).join(""),"]+)"),"u")}},{key:"createStringRegex",value:function(e){return new RegExp("^("+this.createStringPattern(e)+")","u")}},{key:"createStringPattern",value:function(e){var t={"``":"((`[^`]*($|`))+)","[]":"((\\[[^\\]]*($|\\]))(\\][^\\]]*($|\\]))*)",'""':'(("[^"\\\\]*(?:\\\\.[^"\\\\]*)*("|$))+)',"''":"(('[^'\\\\]*(?:\\\\.[^'\\\\]*)*('|$))+)","N''":"((N'[^N'\\\\]*(?:\\\\.[^N'\\\\]*)*('|$))+)"};return e.map((function(e){return t[e]})).join("|")}},{key:"createParenRegex",value:function(e){var t=this;return new RegExp("^("+e.map((function(e){return t.escapeParen(e)})).join("|")+")","iu")}},{key:"escapeParen",value:function(e){return 1===e.length?(0,o.default)(e):"\\b"+e+"\\b"}},{key:"createPlaceholderRegex",value:function(e,t){if((0,n.default)(e))return!1;var r=e.map(o.default).join("|");return new RegExp("^((?:".concat(r,")(?:").concat(t,"))"),"u")}},{key:"tokenize",value:function(e){if(!e)return[];for(var t,r=[];e.length;)t=this.getNextToken(e,t),e=e.substring(t.value.length),r.push(t);return r}},{key:"getNextToken",value:function(e,t){return this.getWhitespaceToken(e)||this.getCommentToken(e)||this.getStringToken(e)||this.getOpenParenToken(e)||this.getCloseParenToken(e)||this.getPlaceholderToken(e)||this.getNumberToken(e)||this.getReservedWordToken(e,t)||this.getWordToken(e)||this.getOperatorToken(e)}},{key:"getWhitespaceToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WHITESPACE,regex:this.WHITESPACE_REGEX})}},{key:"getCommentToken",value:function(e){return this.getLineCommentToken(e)||this.getBlockCommentToken(e)}},{key:"getLineCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.LINE_COMMENT,regex:this.LINE_COMMENT_REGEX})}},{key:"getBlockCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.BLOCK_COMMENT,regex:this.BLOCK_COMMENT_REGEX})}},{key:"getStringToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.STRING,regex:this.STRING_REGEX})}},{key:"getOpenParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPEN_PAREN,regex:this.OPEN_PAREN_REGEX})}},{key:"getCloseParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.CLOSE_PAREN,regex:this.CLOSE_PAREN_REGEX})}},{key:"getPlaceholderToken",value:function(e){return this.getIdentNamedPlaceholderToken(e)||this.getStringNamedPlaceholderToken(e)||this.getIndexedPlaceholderToken(e)}},{key:"getIdentNamedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.IDENT_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getStringNamedPlaceholderToken",value:function(e){var t=this;return this.getPlaceholderTokenWithKey({input:e,regex:this.STRING_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return t.getEscapedPlaceholderKey({key:e.slice(2,-1),quoteChar:e.slice(-1)})}})}},{key:"getIndexedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.INDEXED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getPlaceholderTokenWithKey",value:function(e){var t=e.input,r=e.regex,n=e.parseKey,o=this.getTokenOnFirstMatch({input:t,regex:r,type:i.default.PLACEHOLDER});return o&&(o.key=n(o.value)),o}},{key:"getEscapedPlaceholderKey",value:function(e){var t=e.key,r=e.quoteChar;return t.replace(new RegExp((0,o.default)("\\"+r),"gu"),r)}},{key:"getNumberToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.NUMBER,regex:this.NUMBER_REGEX})}},{key:"getOperatorToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPERATOR,regex:this.OPERATOR_REGEX})}},{key:"getReservedWordToken",value:function(e,t){if(!t||!t.value||"."!==t.value)return this.getTopLevelReservedToken(e)||this.getNewlineReservedToken(e)||this.getTopLevelReservedTokenNoIndent(e)||this.getPlainReservedToken(e)}},{key:"getTopLevelReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL,regex:this.RESERVED_TOP_LEVEL_REGEX})}},{key:"getNewlineReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_NEWLINE,regex:this.RESERVED_NEWLINE_REGEX})}},{key:"getTopLevelReservedTokenNoIndent",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL_NO_INDENT,regex:this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX})}},{key:"getPlainReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED,regex:this.RESERVED_PLAIN_REGEX})}},{key:"getWordToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WORD,regex:this.WORD_REGEX})}},{key:"getTokenOnFirstMatch",value:function(e){var t=e.input,r=e.type,n=e.regex,o=t.match(n);if(o)return{type:r,value:o[1]}}}],r&&l(t.prototype,r),e}();t.default=s,e.exports=t.default},1025:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default={WHITESPACE:"whitespace",WORD:"word",STRING:"string",RESERVED:"reserved",RESERVED_TOP_LEVEL:"reserved-top-level",RESERVED_TOP_LEVEL_NO_INDENT:"reserved-top-level-no-indent",RESERVED_NEWLINE:"reserved-newline",OPERATOR:"operator",OPEN_PAREN:"open-paren",CLOSE_PAREN:"close-paren",LINE_COMMENT:"line-comment",BLOCK_COMMENT:"block-comment",NUMBER:"number",PLACEHOLDER:"placeholder"},e.exports=t.default},4377:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,s=["ABS","ACTIVATE","ALIAS","ALL","ALLOCATE","ALLOW","ALTER","ANY","ARE","ARRAY","AS","ASC","ASENSITIVE","ASSOCIATE","ASUTIME","ASYMMETRIC","AT","ATOMIC","ATTRIBUTES","AUDIT","AUTHORIZATION","AUX","AUXILIARY","AVG","BEFORE","BEGIN","BETWEEN","BIGINT","BINARY","BLOB","BOOLEAN","BOTH","BUFFERPOOL","BY","CACHE","CALL","CALLED","CAPTURE","CARDINALITY","CASCADED","CASE","CAST","CCSID","CEIL","CEILING","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CLOB","CLONE","CLOSE","CLUSTER","COALESCE","COLLATE","COLLECT","COLLECTION","COLLID","COLUMN","COMMENT","COMMIT","CONCAT","CONDITION","CONNECT","CONNECTION","CONSTRAINT","CONTAINS","CONTINUE","CONVERT","CORR","CORRESPONDING","COUNT","COUNT_BIG","COVAR_POP","COVAR_SAMP","CREATE","CROSS","CUBE","CUME_DIST","CURRENT","CURRENT_DATE","CURRENT_DEFAULT_TRANSFORM_GROUP","CURRENT_LC_CTYPE","CURRENT_PATH","CURRENT_ROLE","CURRENT_SCHEMA","CURRENT_SERVER","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_TIMEZONE","CURRENT_TRANSFORM_GROUP_FOR_TYPE","CURRENT_USER","CURSOR","CYCLE","DATA","DATABASE","DATAPARTITIONNAME","DATAPARTITIONNUM","DATE","DAY","DAYS","DB2GENERAL","DB2GENRL","DB2SQL","DBINFO","DBPARTITIONNAME","DBPARTITIONNUM","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFAULTS","DEFINITION","DELETE","DENSERANK","DENSE_RANK","DEREF","DESCRIBE","DESCRIPTOR","DETERMINISTIC","DIAGNOSTICS","DISABLE","DISALLOW","DISCONNECT","DISTINCT","DO","DOCUMENT","DOUBLE","DROP","DSSIZE","DYNAMIC","EACH","EDITPROC","ELEMENT","ELSE","ELSEIF","ENABLE","ENCODING","ENCRYPTION","END","END-EXEC","ENDING","ERASE","ESCAPE","EVERY","EXCEPTION","EXCLUDING","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXP","EXPLAIN","EXTENDED","EXTERNAL","EXTRACT","FALSE","FENCED","FETCH","FIELDPROC","FILE","FILTER","FINAL","FIRST","FLOAT","FLOOR","FOR","FOREIGN","FREE","FULL","FUNCTION","FUSION","GENERAL","GENERATED","GET","GLOBAL","GOTO","GRANT","GRAPHIC","GROUP","GROUPING","HANDLER","HASH","HASHED_VALUE","HINT","HOLD","HOUR","HOURS","IDENTITY","IF","IMMEDIATE","IN","INCLUDING","INCLUSIVE","INCREMENT","INDEX","INDICATOR","INDICATORS","INF","INFINITY","INHERIT","INNER","INOUT","INSENSITIVE","INSERT","INT","INTEGER","INTEGRITY","INTERSECTION","INTERVAL","INTO","IS","ISOBID","ISOLATION","ITERATE","JAR","JAVA","KEEP","KEY","LABEL","LANGUAGE","LARGE","LATERAL","LC_CTYPE","LEADING","LEAVE","LEFT","LIKE","LINKTYPE","LN","LOCAL","LOCALDATE","LOCALE","LOCALTIME","LOCALTIMESTAMP","LOCATOR","LOCATORS","LOCK","LOCKMAX","LOCKSIZE","LONG","LOOP","LOWER","MAINTAINED","MATCH","MATERIALIZED","MAX","MAXVALUE","MEMBER","MERGE","METHOD","MICROSECOND","MICROSECONDS","MIN","MINUTE","MINUTES","MINVALUE","MOD","MODE","MODIFIES","MODULE","MONTH","MONTHS","MULTISET","NAN","NATIONAL","NATURAL","NCHAR","NCLOB","NEW","NEW_TABLE","NEXTVAL","NO","NOCACHE","NOCYCLE","NODENAME","NODENUMBER","NOMAXVALUE","NOMINVALUE","NONE","NOORDER","NORMALIZE","NORMALIZED","NOT","NULL","NULLIF","NULLS","NUMERIC","NUMPARTS","OBID","OCTET_LENGTH","OF","OFFSET","OLD","OLD_TABLE","ON","ONLY","OPEN","OPTIMIZATION","OPTIMIZE","OPTION","ORDER","OUT","OUTER","OVER","OVERLAPS","OVERLAY","OVERRIDING","PACKAGE","PADDED","PAGESIZE","PARAMETER","PART","PARTITION","PARTITIONED","PARTITIONING","PARTITIONS","PASSWORD","PATH","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","PIECESIZE","PLAN","POSITION","POWER","PRECISION","PREPARE","PREVVAL","PRIMARY","PRIQTY","PRIVILEGES","PROCEDURE","PROGRAM","PSID","PUBLIC","QUERY","QUERYNO","RANGE","RANK","READ","READS","REAL","RECOVERY","RECURSIVE","REF","REFERENCES","REFERENCING","REFRESH","REGR_AVGX","REGR_AVGY","REGR_COUNT","REGR_INTERCEPT","REGR_R2","REGR_SLOPE","REGR_SXX","REGR_SXY","REGR_SYY","RELEASE","RENAME","REPEAT","RESET","RESIGNAL","RESTART","RESTRICT","RESULT","RESULT_SET_LOCATOR","RETURN","RETURNS","REVOKE","RIGHT","ROLE","ROLLBACK","ROLLUP","ROUND_CEILING","ROUND_DOWN","ROUND_FLOOR","ROUND_HALF_DOWN","ROUND_HALF_EVEN","ROUND_HALF_UP","ROUND_UP","ROUTINE","ROW","ROWNUMBER","ROWS","ROWSET","ROW_NUMBER","RRN","RUN","SAVEPOINT","SCHEMA","SCOPE","SCRATCHPAD","SCROLL","SEARCH","SECOND","SECONDS","SECQTY","SECURITY","SENSITIVE","SEQUENCE","SESSION","SESSION_USER","SIGNAL","SIMILAR","SIMPLE","SMALLINT","SNAN","SOME","SOURCE","SPECIFIC","SPECIFICTYPE","SQL","SQLEXCEPTION","SQLID","SQLSTATE","SQLWARNING","SQRT","STACKED","STANDARD","START","STARTING","STATEMENT","STATIC","STATMENT","STAY","STDDEV_POP","STDDEV_SAMP","STOGROUP","STORES","STYLE","SUBMULTISET","SUBSTRING","SUM","SUMMARY","SYMMETRIC","SYNONYM","SYSFUN","SYSIBM","SYSPROC","SYSTEM","SYSTEM_USER","TABLE","TABLESAMPLE","TABLESPACE","THEN","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TRAILING","TRANSACTION","TRANSLATE","TRANSLATION","TREAT","TRIGGER","TRIM","TRUE","TRUNCATE","TYPE","UESCAPE","UNDO","UNIQUE","UNKNOWN","UNNEST","UNTIL","UPPER","USAGE","USER","USING","VALIDPROC","VALUE","VARCHAR","VARIABLE","VARIANT","VARYING","VAR_POP","VAR_SAMP","VCAT","VERSION","VIEW","VOLATILE","VOLUMES","WHEN","WHENEVER","WHILE","WIDTH_BUCKET","WINDOW","WITH","WITHIN","WITHOUT","WLM","WRITE","XMLELEMENT","XMLEXISTS","XMLNAMESPACES","YEAR","YEARS"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INTERSECT","LIMIT","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS JOIN","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:s,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``","[]"],openParens:["("],closeParens:[")"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["#","@"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},9445:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,s=["ALL","ALTER","ANALYZE","AND","ANY","ARRAY","AS","ASC","BEGIN","BETWEEN","BINARY","BOOLEAN","BREAK","BUCKET","BUILD","BY","CALL","CASE","CAST","CLUSTER","COLLATE","COLLECTION","COMMIT","CONNECT","CONTINUE","CORRELATE","COVER","CREATE","DATABASE","DATASET","DATASTORE","DECLARE","DECREMENT","DELETE","DERIVED","DESC","DESCRIBE","DISTINCT","DO","DROP","EACH","ELEMENT","ELSE","END","EVERY","EXCEPT","EXCLUDE","EXECUTE","EXISTS","EXPLAIN","FALSE","FETCH","FIRST","FLATTEN","FOR","FORCE","FROM","FUNCTION","GRANT","GROUP","GSI","HAVING","IF","IGNORE","ILIKE","IN","INCLUDE","INCREMENT","INDEX","INFER","INLINE","INNER","INSERT","INTERSECT","INTO","IS","JOIN","KEY","KEYS","KEYSPACE","KNOWN","LAST","LEFT","LET","LETTING","LIKE","LIMIT","LSM","MAP","MAPPING","MATCHED","MATERIALIZED","MERGE","MISSING","NAMESPACE","NEST","NOT","NULL","NUMBER","OBJECT","OFFSET","ON","OPTION","OR","ORDER","OUTER","OVER","PARSE","PARTITION","PASSWORD","PATH","POOL","PREPARE","PRIMARY","PRIVATE","PRIVILEGE","PROCEDURE","PUBLIC","RAW","REALM","REDUCE","RENAME","RETURN","RETURNING","REVOKE","RIGHT","ROLE","ROLLBACK","SATISFIES","SCHEMA","SELECT","SELF","SEMI","SET","SHOW","SOME","START","STATISTICS","STRING","SYSTEM","THEN","TO","TRANSACTION","TRIGGER","TRUE","TRUNCATE","UNDER","UNION","UNIQUE","UNKNOWN","UNNEST","UNSET","UPDATE","UPSERT","USE","USER","USING","VALIDATE","VALUE","VALUED","VALUES","VIA","VIEW","WHEN","WHERE","WHILE","WITH","WITHIN","WORK","XOR"],u=["DELETE FROM","EXCEPT ALL","EXCEPT","EXPLAIN DELETE FROM","EXPLAIN UPDATE","EXPLAIN UPSERT","FROM","GROUP BY","HAVING","INFER","INSERT INTO","LET","LIMIT","MERGE","NEST","ORDER BY","PREPARE","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UNNEST","UPDATE","UPSERT","USE KEYS","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:s,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``"],openParens:["(","[","{"],closeParens:[")","]","}"],namedPlaceholderTypes:["$"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7881:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(9157)),o=a(r(3202)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function l(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,u=["A","ACCESSIBLE","AGENT","AGGREGATE","ALL","ALTER","ANY","ARRAY","AS","ASC","AT","ATTRIBUTE","AUTHID","AVG","BETWEEN","BFILE_BASE","BINARY_INTEGER","BINARY","BLOB_BASE","BLOCK","BODY","BOOLEAN","BOTH","BOUND","BREADTH","BULK","BY","BYTE","C","CALL","CALLING","CASCADE","CASE","CHAR_BASE","CHAR","CHARACTER","CHARSET","CHARSETFORM","CHARSETID","CHECK","CLOB_BASE","CLONE","CLOSE","CLUSTER","CLUSTERS","COALESCE","COLAUTH","COLLECT","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPILED","COMPRESS","CONNECT","CONSTANT","CONSTRUCTOR","CONTEXT","CONTINUE","CONVERT","COUNT","CRASH","CREATE","CREDENTIAL","CURRENT","CURRVAL","CURSOR","CUSTOMDATUM","DANGLING","DATA","DATE_BASE","DATE","DAY","DECIMAL","DEFAULT","DEFINE","DELETE","DEPTH","DESC","DETERMINISTIC","DIRECTORY","DISTINCT","DO","DOUBLE","DROP","DURATION","ELEMENT","ELSIF","EMPTY","END","ESCAPE","EXCEPTIONS","EXCLUSIVE","EXECUTE","EXISTS","EXIT","EXTENDS","EXTERNAL","EXTRACT","FALSE","FETCH","FINAL","FIRST","FIXED","FLOAT","FOR","FORALL","FORCE","FROM","FUNCTION","GENERAL","GOTO","GRANT","GROUP","HASH","HEAP","HIDDEN","HOUR","IDENTIFIED","IF","IMMEDIATE","IN","INCLUDING","INDEX","INDEXES","INDICATOR","INDICES","INFINITE","INSTANTIABLE","INT","INTEGER","INTERFACE","INTERVAL","INTO","INVALIDATE","IS","ISOLATION","JAVA","LANGUAGE","LARGE","LEADING","LENGTH","LEVEL","LIBRARY","LIKE","LIKE2","LIKE4","LIKEC","LIMITED","LOCAL","LOCK","LONG","MAP","MAX","MAXLEN","MEMBER","MERGE","MIN","MINUTE","MLSLABEL","MOD","MODE","MONTH","MULTISET","NAME","NAN","NATIONAL","NATIVE","NATURAL","NATURALN","NCHAR","NEW","NEXTVAL","NOCOMPRESS","NOCOPY","NOT","NOWAIT","NULL","NULLIF","NUMBER_BASE","NUMBER","OBJECT","OCICOLL","OCIDATE","OCIDATETIME","OCIDURATION","OCIINTERVAL","OCILOBLOCATOR","OCINUMBER","OCIRAW","OCIREF","OCIREFCURSOR","OCIROWID","OCISTRING","OCITYPE","OF","OLD","ON","ONLY","OPAQUE","OPEN","OPERATOR","OPTION","ORACLE","ORADATA","ORDER","ORGANIZATION","ORLANY","ORLVARY","OTHERS","OUT","OVERLAPS","OVERRIDING","PACKAGE","PARALLEL_ENABLE","PARAMETER","PARAMETERS","PARENT","PARTITION","PASCAL","PCTFREE","PIPE","PIPELINED","PLS_INTEGER","PLUGGABLE","POSITIVE","POSITIVEN","PRAGMA","PRECISION","PRIOR","PRIVATE","PROCEDURE","PUBLIC","RAISE","RANGE","RAW","READ","REAL","RECORD","REF","REFERENCE","RELEASE","RELIES_ON","REM","REMAINDER","RENAME","RESOURCE","RESULT_CACHE","RESULT","RETURN","RETURNING","REVERSE","REVOKE","ROLLBACK","ROW","ROWID","ROWNUM","ROWTYPE","SAMPLE","SAVE","SAVEPOINT","SB1","SB2","SB4","SEARCH","SECOND","SEGMENT","SELF","SEPARATE","SEQUENCE","SERIALIZABLE","SHARE","SHORT","SIZE_T","SIZE","SMALLINT","SOME","SPACE","SPARSE","SQL","SQLCODE","SQLDATA","SQLERRM","SQLNAME","SQLSTATE","STANDARD","START","STATIC","STDDEV","STORED","STRING","STRUCT","STYLE","SUBMULTISET","SUBPARTITION","SUBSTITUTABLE","SUBTYPE","SUCCESSFUL","SUM","SYNONYM","SYSDATE","TABAUTH","TABLE","TDO","THE","THEN","TIME","TIMESTAMP","TIMEZONE_ABBR","TIMEZONE_HOUR","TIMEZONE_MINUTE","TIMEZONE_REGION","TO","TRAILING","TRANSACTION","TRANSACTIONAL","TRIGGER","TRUE","TRUSTED","TYPE","UB1","UB2","UB4","UID","UNDER","UNIQUE","UNPLUG","UNSIGNED","UNTRUSTED","USE","USER","USING","VALIDATE","VALIST","VALUE","VARCHAR","VARCHAR2","VARIABLE","VARIANCE","VARRAY","VARYING","VIEW","VIEWS","VOID","WHENEVER","WHILE","WITH","WORK","WRAPPED","WRITE","YEAR","ZONE"],c=["ADD","ALTER COLUMN","ALTER TABLE","BEGIN","CONNECT BY","DECLARE","DELETE FROM","DELETE","END","EXCEPT","EXCEPTION","FETCH FIRST","FROM","GROUP BY","HAVING","INSERT INTO","INSERT","LIMIT","LOOP","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","START WITH","UPDATE","VALUES","WHERE"],d=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],p=["AND","CROSS APPLY","CROSS JOIN","ELSE","END","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],f=function(e,t){if(e.type===i.default.RESERVED_TOP_LEVEL&&"SET"===e.value&&"BY"===t.value)return e.type=i.default.RESERVED,e},v=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:u,reservedTopLevelWords:c,reservedNewlineWords:p,reservedTopLevelWordsNoIndent:d,stringTypes:['""',"N''","''","``"],openParens:["(","CASE","BEGIN"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["_","$","#",".","@"]})),new n.default(this.cfg,s,f).format(e)}}])&&l(t.prototype,r),e}();t.default=v,e.exports=t.default},1432:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,s=["ACCESSIBLE","ACTION","AGAINST","AGGREGATE","ALGORITHM","ALL","ALTER","ANALYSE","ANALYZE","AS","ASC","AUTOCOMMIT","AUTO_INCREMENT","BACKUP","BEGIN","BETWEEN","BINLOG","BOTH","CASCADE","CASE","CHANGE","CHANGED","CHARACTER SET","CHARSET","CHECK","CHECKSUM","COLLATE","COLLATION","COLUMN","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPRESSED","CONCURRENT","CONSTRAINT","CONTAINS","CONVERT","CREATE","CROSS","CURRENT_TIMESTAMP","DATABASE","DATABASES","DAY","DAY_HOUR","DAY_MINUTE","DAY_SECOND","DEFAULT","DEFINER","DELAYED","DELETE","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DO","DROP","DUMPFILE","DUPLICATE","DYNAMIC","ELSE","ENCLOSED","END","ENGINE","ENGINES","ENGINE_TYPE","ESCAPE","ESCAPED","EVENTS","EXEC","EXECUTE","EXISTS","EXPLAIN","EXTENDED","FAST","FETCH","FIELDS","FILE","FIRST","FIXED","FLUSH","FOR","FORCE","FOREIGN","FULL","FULLTEXT","FUNCTION","GLOBAL","GRANT","GRANTS","GROUP_CONCAT","HEAP","HIGH_PRIORITY","HOSTS","HOUR","HOUR_MINUTE","HOUR_SECOND","IDENTIFIED","IF","IFNULL","IGNORE","IN","INDEX","INDEXES","INFILE","INSERT","INSERT_ID","INSERT_METHOD","INTERVAL","INTO","INVOKER","IS","ISOLATION","KEY","KEYS","KILL","LAST_INSERT_ID","LEADING","LEVEL","LIKE","LINEAR","LINES","LOAD","LOCAL","LOCK","LOCKS","LOGS","LOW_PRIORITY","MARIA","MASTER","MASTER_CONNECT_RETRY","MASTER_HOST","MASTER_LOG_FILE","MATCH","MAX_CONNECTIONS_PER_HOUR","MAX_QUERIES_PER_HOUR","MAX_ROWS","MAX_UPDATES_PER_HOUR","MAX_USER_CONNECTIONS","MEDIUM","MERGE","MINUTE","MINUTE_SECOND","MIN_ROWS","MODE","MODIFY","MONTH","MRG_MYISAM","MYISAM","NAMES","NATURAL","NOT","NOW()","NULL","OFFSET","ON DELETE","ON UPDATE","ON","ONLY","OPEN","OPTIMIZE","OPTION","OPTIONALLY","OUTFILE","PACK_KEYS","PAGE","PARTIAL","PARTITION","PARTITIONS","PASSWORD","PRIMARY","PRIVILEGES","PROCEDURE","PROCESS","PROCESSLIST","PURGE","QUICK","RAID0","RAID_CHUNKS","RAID_CHUNKSIZE","RAID_TYPE","RANGE","READ","READ_ONLY","READ_WRITE","REFERENCES","REGEXP","RELOAD","RENAME","REPAIR","REPEATABLE","REPLACE","REPLICATION","RESET","RESTORE","RESTRICT","RETURN","RETURNS","REVOKE","RLIKE","ROLLBACK","ROW","ROWS","ROW_FORMAT","SECOND","SECURITY","SEPARATOR","SERIALIZABLE","SESSION","SHARE","SHOW","SHUTDOWN","SLAVE","SONAME","SOUNDS","SQL","SQL_AUTO_IS_NULL","SQL_BIG_RESULT","SQL_BIG_SELECTS","SQL_BIG_TABLES","SQL_BUFFER_RESULT","SQL_CACHE","SQL_CALC_FOUND_ROWS","SQL_LOG_BIN","SQL_LOG_OFF","SQL_LOG_UPDATE","SQL_LOW_PRIORITY_UPDATES","SQL_MAX_JOIN_SIZE","SQL_NO_CACHE","SQL_QUOTE_SHOW_CREATE","SQL_SAFE_UPDATES","SQL_SELECT_LIMIT","SQL_SLAVE_SKIP_COUNTER","SQL_SMALL_RESULT","SQL_WARNINGS","START","STARTING","STATUS","STOP","STORAGE","STRAIGHT_JOIN","STRING","STRIPED","SUPER","TABLE","TABLES","TEMPORARY","TERMINATED","THEN","TO","TRAILING","TRANSACTIONAL","TRUE","TRUNCATE","TYPE","TYPES","UNCOMMITTED","UNIQUE","UNLOCK","UNSIGNED","USAGE","USE","USING","VARIABLES","VIEW","WHEN","WITH","WORK","WRITE","YEAR_MONTH"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INSERT","LIMIT","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS APPLY","CROSS JOIN","ELSE","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:s,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"N''","''","``","[]"],openParens:["(","CASE"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:["@",":"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,l).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7409:(e,t,r)=>{"use strict";t.Ay=void 0;var n=l(r(4377)),o=l(r(9445)),i=l(r(7881)),a=l(r(1432));function l(e){return e&&e.__esModule?e:{default:e}}var s={format:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};switch(t.language){case"db2":return new n.default(t).format(e);case"n1ql":return new o.default(t).format(e);case"pl/sql":return new i.default(t).format(e);case"sql":case void 0:return new a.default(t).format(e);default:throw Error("Unsupported SQL dialect: ".concat(t.language))}}};t.Ay=s},358:(e,t,r)=>{e.exports=r(3231)},3231:(e,t)=>{var r=t,n=/`/g,o=/\./g,i=/[\0\b\t\n\r\x1a\"\'\\]/g,a={"\0":"\\0","\b":"\\b","\t":"\\t","\n":"\\n","\r":"\\r","":"\\Z",'"':'\\"',"'":"\\'","\\":"\\\\"};function l(e){for(var t,r=i.lastIndex=0,n="";t=i.exec(e);)n+=e.slice(r,t.index)+a[t[0]],r=i.lastIndex;return 0===r?"'"+e+"'":r<e.length?"'"+n+e.slice(r)+"'":"'"+n+"'"}function s(e,t){for(e=e.toString();e.length<t;)e="0"+e;return e}r.escapeId=function(e,t){if(Array.isArray(e)){for(var i="",a=0;a<e.length;a++)i+=(0===a?"":", ")+r.escapeId(e[a],t);return i}return t?"`"+String(e).replace(n,"``")+"`":"`"+String(e).replace(n,"``").replace(o,"`.`")+"`"},r.escape=function(e,t,n){if(null==e)return"NULL";switch(typeof e){case"boolean":return e?"true":"false";case"number":return e+"";case"object":return"[object Date]"===Object.prototype.toString.call(e)?r.dateToString(e,n||"local"):Array.isArray(e)?r.arrayToList(e,n):Buffer.isBuffer(e)?r.bufferToString(e):"function"==typeof e.toSqlString?String(e.toSqlString()):t?l(e.toString()):r.objectToValues(e,n);default:return l(e)}},r.arrayToList=function(e,t){for(var n="",o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?n+=(0===o?"":", ")+"("+r.arrayToList(i,t)+")":n+=(0===o?"":", ")+r.escape(i,!0,t)}return n},r.format=function(e,t,n,o){if(null==t)return e;Array.isArray(t)||(t=[t]);for(var i,a=0,l=/\?+/g,s="",u=0;u<t.length&&(i=l.exec(e));){var c=i[0].length;if(!(c>2)){var d=2===c?r.escapeId(t[u]):r.escape(t[u],n,o);s+=e.slice(a,i.index)+d,a=l.lastIndex,u++}}return 0===a?e:a<e.length?s+e.slice(a):s},r.dateToString=function(e,t){var r,n,o,i,a,u,c,d=new Date(e);if(isNaN(d.getTime()))return"NULL";if("local"===t)r=d.getFullYear(),n=d.getMonth()+1,o=d.getDate(),i=d.getHours(),a=d.getMinutes(),u=d.getSeconds(),c=d.getMilliseconds();else{var p=function(e){if("Z"===e)return 0;var t=e.match(/([\+\-\s])(\d\d):?(\d\d)?/);return!!t&&("-"===t[1]?-1:1)*(parseInt(t[2],10)+(t[3]?parseInt(t[3],10):0)/60)*60}(t);!1!==p&&0!==p&&d.setTime(d.getTime()+6e4*p),r=d.getUTCFullYear(),n=d.getUTCMonth()+1,o=d.getUTCDate(),i=d.getUTCHours(),a=d.getUTCMinutes(),u=d.getUTCSeconds(),c=d.getUTCMilliseconds()}return l(s(r,4)+"-"+s(n,2)+"-"+s(o,2)+" "+s(i,2)+":"+s(a,2)+":"+s(u,2)+"."+s(c,3))},r.bufferToString=function(e){return"X"+l(e.toString("hex"))},r.objectToValues=function(e,t){var n="";for(var o in e){var i=e[o];"function"!=typeof i&&(n+=(0===n.length?"":", ")+r.escapeId(o)+" = "+r.escape(i,!0,t))}return n},r.raw=function(e){if("string"!=typeof e)throw new TypeError("argument sql must be a string");return{toSqlString:function(){return e}}}},1882:e=>{e.exports=function(){var e=document.getSelection();if(!e.rangeCount)return function(){};for(var t=document.activeElement,r=[],n=0;n<e.rangeCount;n++)r.push(e.getRangeAt(n));switch(t.tagName.toUpperCase()){case"INPUT":case"TEXTAREA":t.blur();break;default:t=null}return e.removeAllRanges(),function(){"Caret"===e.type&&e.removeAllRanges(),e.rangeCount||r.forEach((function(t){e.addRange(t)})),t&&t.focus()}}},6089:e=>{"use strict";e.exports=a},7781:t=>{"use strict";t.exports=e},8531:e=>{"use strict";e.exports=r},2007:e=>{"use strict";e.exports=i},3241:e=>{"use strict";e.exports=n},2468:e=>{"use strict";e.exports=l},5959:e=>{"use strict";e.exports=o},200:e=>{"use strict";e.exports=u},7694:e=>{"use strict";e.exports=s},1269:e=>{"use strict";e.exports=t},8911:(e,t,r)=>{var n=r(5992).default;function o(){"use strict";e.exports=o=function(){return r},e.exports.__esModule=!0,e.exports.default=e.exports;var t,r={},i=Object.prototype,a=i.hasOwnProperty,l=Object.defineProperty||function(e,t,r){e[t]=r.value},s="function"==typeof Symbol?Symbol:{},u=s.iterator||"@@iterator",c=s.asyncIterator||"@@asyncIterator",d=s.toStringTag||"@@toStringTag";function p(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{p({},"")}catch(t){p=function(e,t,r){return e[t]=r}}function f(e,t,r,n){var o=t&&t.prototype instanceof E?t:E,i=Object.create(o.prototype),a=new x(n||[]);return l(i,"_invoke",{value:C(e,r,a)}),i}function v(e,t,r){try{return{type:"normal",arg:e.call(t,r)}}catch(e){return{type:"throw",arg:e}}}r.wrap=f;var h="suspendedStart",g="suspendedYield",y="executing",m="completed",b={};function E(){}function O(){}function S(){}var T={};p(T,u,(function(){return this}));var _=Object.getPrototypeOf,w=_&&_(_(P([])));w&&w!==i&&a.call(w,u)&&(T=w);var R=S.prototype=E.prototype=Object.create(T);function I(e){["next","throw","return"].forEach((function(t){p(e,t,(function(e){return this._invoke(t,e)}))}))}function A(e,t){function r(o,i,l,s){var u=v(e[o],e,i);if("throw"!==u.type){var c=u.arg,d=c.value;return d&&"object"==n(d)&&a.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,l,s)}),(function(e){r("throw",e,l,s)})):t.resolve(d).then((function(e){c.value=e,l(c)}),(function(e){return r("throw",e,l,s)}))}s(u.arg)}var o;l(this,"_invoke",{value:function(e,n){function i(){return new t((function(t,o){r(e,n,t,o)}))}return o=o?o.then(i,i):i()}})}function C(e,r,n){var o=h;return function(i,a){if(o===y)throw Error("Generator is already running");if(o===m){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var l=n.delegate;if(l){var s=N(l,n);if(s){if(s===b)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===h)throw o=m,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=y;var u=v(e,r,n);if("normal"===u.type){if(o=n.done?m:g,u.arg===b)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(o=m,n.method="throw",n.arg=u.arg)}}}function N(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,N(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a '"+n+"' method")),b;var i=v(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,b;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,b):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,b)}function L(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function j(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function x(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(L,this),this.reset(!0)}function P(e){if(e||""===e){var r=e[u];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function r(){for(;++o<e.length;)if(a.call(e,o))return r.value=e[o],r.done=!1,r;return r.value=t,r.done=!0,r};return i.next=i}}throw new TypeError(n(e)+" is not iterable")}return O.prototype=S,l(R,"constructor",{value:S,configurable:!0}),l(S,"constructor",{value:O,configurable:!0}),O.displayName=p(S,d,"GeneratorFunction"),r.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===O||"GeneratorFunction"===(t.displayName||t.name))},r.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,S):(e.__proto__=S,p(e,d,"GeneratorFunction")),e.prototype=Object.create(R),e},r.awrap=function(e){return{__await:e}},I(A.prototype),p(A.prototype,c,(function(){return this})),r.AsyncIterator=A,r.async=function(e,t,n,o,i){void 0===i&&(i=Promise);var a=new A(f(e,t,n,o),i);return r.isGeneratorFunction(t)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},I(R),p(R,d,"Generator"),p(R,u,(function(){return this})),p(R,"toString",(function(){return"[object Generator]"})),r.keys=function(e){var t=Object(e),r=[];for(var n in t)r.push(n);return r.reverse(),function e(){for(;r.length;){var n=r.pop();if(n in t)return e.value=n,e.done=!1,e}return e.done=!0,e}},r.values=P,x.prototype={constructor:x,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(j),!e)for(var r in this)"t"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function n(n,o){return l.type="throw",l.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],l=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var s=a.call(i,"catchLoc"),u=a.call(i,"finallyLoc");if(s&&u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(s){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&a.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,b):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),b},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.finallyLoc===e)return this.complete(r.completion,r.afterLoc),j(r),b}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.tryLoc===e){var n=r.completion;if("throw"===n.type){var o=n.arg;j(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:P(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),b}},r}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},5992:e=>{function t(r){return e.exports=t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},6834:(e,t,r)=>{var n=r(8911)();e.exports=n;try{regeneratorRuntime=n}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=n:Function("r","regeneratorRuntime = r")(n)}},2584:(e,t)=>{var r;!function(){"use strict";var n={}.hasOwnProperty;function o(){for(var e="",t=0;t<arguments.length;t++){var r=arguments[t];r&&(e=a(e,i(r)))}return e}function i(e){if("string"==typeof e||"number"==typeof e)return e;if("object"!=typeof e)return"";if(Array.isArray(e))return o.apply(null,e);if(e.toString!==Object.prototype.toString&&!e.toString.toString().includes("[native code]"))return e.toString();var t="";for(var r in e)n.call(e,r)&&e[r]&&(t=a(t,r));return t}function a(e,t){return t?e?e+" "+t:e+t:e}e.exports?(o.default=o,e.exports=o):void 0===(r=function(){return o}.apply(t,[]))||(e.exports=r)}()},7016:(e,t,r)=>{"use strict";r.r(t),r.d(t,{__addDisposableResource:()=>P,__assign:()=>i,__asyncDelegator:()=>w,__asyncGenerator:()=>_,__asyncValues:()=>R,__await:()=>T,__awaiter:()=>v,__classPrivateFieldGet:()=>L,__classPrivateFieldIn:()=>x,__classPrivateFieldSet:()=>j,__createBinding:()=>g,__decorate:()=>l,__disposeResources:()=>D,__esDecorate:()=>u,__exportStar:()=>y,__extends:()=>o,__generator:()=>h,__importDefault:()=>N,__importStar:()=>C,__makeTemplateObject:()=>I,__metadata:()=>f,__param:()=>s,__propKey:()=>d,__read:()=>b,__rest:()=>a,__rewriteRelativeImportExtension:()=>k,__runInitializers:()=>c,__setFunctionName:()=>p,__spread:()=>E,__spreadArray:()=>S,__spreadArrays:()=>O,__values:()=>m,default:()=>M});var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)};function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var i=function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},i.apply(this,arguments)};function a(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}function l(e,t,r,n){var o,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,n);else for(var l=e.length-1;l>=0;l--)(o=e[l])&&(a=(i<3?o(a):i>3?o(t,r,a):o(t,r))||a);return i>3&&a&&Object.defineProperty(t,r,a),a}function s(e,t){return function(r,n){t(r,n,e)}}function u(e,t,r,n,o,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var l,s=n.kind,u="getter"===s?"get":"setter"===s?"set":"value",c=!t&&e?n.static?e:e.prototype:null,d=t||(c?Object.getOwnPropertyDescriptor(c,n.name):{}),p=!1,f=r.length-1;f>=0;f--){var v={};for(var h in n)v[h]="access"===h?{}:n[h];for(var h in n.access)v.access[h]=n.access[h];v.addInitializer=function(e){if(p)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var g=(0,r[f])("accessor"===s?{get:d.get,set:d.set}:d[u],v);if("accessor"===s){if(void 0===g)continue;if(null===g||"object"!=typeof g)throw new TypeError("Object expected");(l=a(g.get))&&(d.get=l),(l=a(g.set))&&(d.set=l),(l=a(g.init))&&o.unshift(l)}else(l=a(g))&&("field"===s?o.unshift(l):d[u]=l)}c&&Object.defineProperty(c,n.name,d),p=!0}function c(e,t,r){for(var n=arguments.length>2,o=0;o<t.length;o++)r=n?t[o].call(e,r):t[o].call(e);return n?r:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function p(e,t,r){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:r?"".concat(r," ",t):t})}function f(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function v(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{s(n.next(e))}catch(e){i(e)}}function l(e){try{s(n.throw(e))}catch(e){i(e)}}function s(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,l)}s((n=n.apply(e,t||[])).next())}))}function h(e,t){var r,n,o,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]},a=Object.create(("function"==typeof Iterator?Iterator:Object).prototype);return a.next=l(0),a.throw=l(1),a.return=l(2),"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function l(l){return function(s){return function(l){if(r)throw new TypeError("Generator is already executing.");for(;a&&(a=0,l[0]&&(i=0)),i;)try{if(r=1,n&&(o=2&l[0]?n.return:l[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,l[1])).done)return o;switch(n=0,o&&(l=[2&l[0],o.value]),l[0]){case 0:case 1:o=l;break;case 4:return i.label++,{value:l[1],done:!1};case 5:i.label++,n=l[1],l=[0];continue;case 7:l=i.ops.pop(),i.trys.pop();continue;default:if(!((o=(o=i.trys).length>0&&o[o.length-1])||6!==l[0]&&2!==l[0])){i=0;continue}if(3===l[0]&&(!o||l[1]>o[0]&&l[1]<o[3])){i.label=l[1];break}if(6===l[0]&&i.label<o[1]){i.label=o[1],o=l;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(l);break}o[2]&&i.ops.pop(),i.trys.pop();continue}l=t.call(e,i)}catch(e){l=[6,e],n=0}finally{r=o=0}if(5&l[0])throw l[1];return{value:l[0]?l[1]:void 0,done:!0}}([l,s])}}}var g=Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]};function y(e,t){for(var r in e)"default"===r||Object.prototype.hasOwnProperty.call(t,r)||g(t,e,r)}function m(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function E(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function O(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),o=0;for(t=0;t<r;t++)for(var i=arguments[t],a=0,l=i.length;a<l;a++,o++)n[o]=i[a];return n}function S(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}function T(e){return this instanceof T?(this.v=e,this):new T(e)}function _(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,o=r.apply(e,t||[]),i=[];return n=Object.create(("function"==typeof AsyncIterator?AsyncIterator:Object).prototype),a("next"),a("throw"),a("return",(function(e){return function(t){return Promise.resolve(t).then(e,u)}})),n[Symbol.asyncIterator]=function(){return this},n;function a(e,t){o[e]&&(n[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||l(e,t)}))},t&&(n[e]=t(n[e])))}function l(e,t){try{(r=o[e](t)).value instanceof T?Promise.resolve(r.value.v).then(s,u):c(i[0][2],r)}catch(e){c(i[0][3],e)}var r}function s(e){l("next",e)}function u(e){l("throw",e)}function c(e,t){e(t),i.shift(),i.length&&l(i[0][0],i[0][1])}}function w(e){var t,r;return t={},n("next"),n("throw",(function(e){throw e})),n("return"),t[Symbol.iterator]=function(){return this},t;function n(n,o){t[n]=e[n]?function(t){return(r=!r)?{value:T(e[n](t)),done:!1}:o?o(t):t}:o}}function R(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e=m(e),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}}function I(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var A=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function C(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&g(t,e,r);return A(t,e),t}function N(e){return e&&e.__esModule?e:{default:e}}function L(e,t,r,n){if("a"===r&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===r?n:"a"===r?n.call(e):n?n.value:t.get(e)}function j(e,t,r,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!o:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(e,r):o?o.value=r:t.set(e,r),r}function x(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}function P(e,t,r){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var n,o;if(r){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");n=t[Symbol.asyncDispose]}if(void 0===n){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");n=t[Symbol.dispose],r&&(o=n)}if("function"!=typeof n)throw new TypeError("Object not disposable.");o&&(n=function(){try{o.call(this)}catch(e){return Promise.reject(e)}}),e.stack.push({value:t,dispose:n,async:r})}else r&&e.stack.push({async:!0});return t}var F="function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};function D(e){function t(t){e.error=e.hasError?new F(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}var r,n=0;return function o(){for(;r=e.stack.pop();)try{if(!r.async&&1===n)return n=0,e.stack.push(r),Promise.resolve().then(o);if(r.dispose){var i=r.dispose.call(r.value);if(r.async)return n|=2,Promise.resolve(i).then(o,(function(e){return t(e),o()}))}else n|=1}catch(e){t(e)}if(1===n)return e.hasError?Promise.reject(e.error):Promise.resolve();if(e.hasError)throw e.error}()}function k(e,t){return"string"==typeof e&&/^\.\.?\//.test(e)?e.replace(/\.(tsx)$|((?:\.d)?)((?:\.[^./]+?)?)\.([cm]?)ts$/i,(function(e,r,n,o,i){return r?t?".jsx":".js":!n||o&&i?n+o+"."+i.toLowerCase()+"js":e})):e}const M={__extends:o,__assign:i,__rest:a,__decorate:l,__param:s,__esDecorate:u,__runInitializers:c,__propKey:d,__setFunctionName:p,__metadata:f,__awaiter:v,__generator:h,__createBinding:g,__exportStar:y,__values:m,__read:b,__spread:E,__spreadArrays:O,__spreadArray:S,__await:T,__asyncGenerator:_,__asyncDelegator:w,__asyncValues:R,__makeTemplateObject:I,__importStar:C,__importDefault:N,__classPrivateFieldGet:L,__classPrivateFieldSet:j,__classPrivateFieldIn:x,__addDisposableResource:P,__disposeResources:D,__rewriteRelativeImportExtension:k}}},d={};function p(e){var t=d[e];if(void 0!==t)return t.exports;var r=d[e]={id:e,loaded:!1,exports:{}};return c[e].call(r.exports,r,r.exports,p),r.loaded=!0,r.exports}p.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return p.d(t,{a:t}),t},p.d=(e,t)=>{for(var r in t)p.o(t,r)&&!p.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},p.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),p.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),p.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},p.nmd=e=>(e.paths=[],e.children||(e.children=[]),e);var f={};return(()=>{"use strict";p.r(f),p.d(f,{plugin:()=>Kw});var e={};p.r(e),p.d(e,{applyToJS:()=>Fs,cleanJSX:()=>Ms,deepEqual:()=>Ns,deepFreeze:()=>Ks,escapeRegExp:()=>Ds,getFirstDefined:()=>Hs,getLogger:()=>zs,getOpCardinality:()=>Cs,isDirtyJSX:()=>Vs,isImmutable:()=>js,isImmutableList:()=>xs,isJSX:()=>Us,isJsonCompatible:()=>Ws,isJsonLogic:()=>Bs,isObject:()=>Rs,logger:()=>$s,mergeArraysSmart:()=>qs,mergeCustomizerNoArrays:()=>ks,omit:()=>As,opDefKeysToOmit:()=>ws,shallowCopy:()=>Is,shallowEqual:()=>Ls,sleep:()=>Gs,toImmutableList:()=>Ps,uuid:()=>Ss,widgetDefKeysToOmit:()=>_s});var t={};p.r(t),p.d(t,{getItemInListValues:()=>cu,getListValue:()=>hu,getTitleInListValues:()=>du,getValueInListValues:()=>pu,listValuesToArray:()=>uu,makeCustomListValue:()=>su,mapListValues:()=>fu,searchListValue:()=>vu,toListValue:()=>lu});var r={};p.r(r),p.d(r,{_fixImmutableValue:()=>Cu,expandTreePath:()=>gu,expandTreeSubpath:()=>yu,fixEmptyGroupsInTree:()=>Ou,fixPathsInTree:()=>Eu,getFlatTree:()=>Su,getItemByPath:()=>mu,getLightTree:()=>wu,getSwitchValues:()=>Ru,getTotalReordableNodesCountInTree:()=>Tu,getTotalRulesCountInTree:()=>_u,hasChildren:()=>Au,immutableToJs:()=>Fs,isEmptyTree:()=>Iu,isImmutable:()=>js,jsToImmutable:()=>Pu,removeIsLockedInTree:()=>bu,toImmutableList:()=>Ps});var n={};p.r(n),p.d(n,{SqlString:()=>fc,mongoEmptyValue:()=>hc,spelEscape:()=>yc,spelFixList:()=>gc,spelFormatConcat:()=>mc,spelImportConcat:()=>bc,sqlEmptyValue:()=>vc,stringifyForDisplay:()=>Ec,wrapWithBrackets:()=>Oc});var o={};p.r(o),p.d(o,{_loadFromJsonLogic:()=>Yu,_loadFromSpel:()=>Qc,getTree:()=>Nu,isImmutableTree:()=>ju,isJsonLogic:()=>Bs,isTree:()=>xu,jsToImmutable:()=>Pu,loadFromJsonLogic:()=>$u,loadFromSpel:()=>Yc,loadTree:()=>Lu});var i={};p.r(i),p.d(i,{createListFromArray:()=>Ld,createListWithOneElement:()=>Nd,defaultConjunction:()=>wd,defaultGroupConjunction:()=>_d,defaultGroupProperties:()=>Rd,defaultItemProperties:()=>Id,defaultOperatorOptions:()=>Sd,defaultRoot:()=>Cd,defaultRule:()=>Ad,defaultRuleProperties:()=>Td,emptyProperties:()=>jd,getDefaultField:()=>md,getDefaultFieldSrc:()=>Ed,getDefaultOperator:()=>Od,getDefaultSubField:()=>bd});var a={};p.r(a),p.d(a,{_validateTree:()=>Lf,checkTree:()=>If,getNewValueForFieldOp:()=>Bf,getTreeBadFields:()=>Rf,isValidTree:()=>wf,sanitizeTree:()=>Cf,translateValidation:()=>Ef,validateAndFixTree:()=>Nf,validateRange:()=>Uf,validateTree:()=>Af,validateValue:()=>Df});var l={};p.r(l),p.d(l,{completeFuncValue:()=>qf,getCompatibleArgsOnFuncChange:()=>Qf,setArgValue:()=>$f,setArgValueSrc:()=>Yf,setFunc:()=>Kf,setFuncDefaultArg:()=>zf});var s={};p.r(s),p.d(s,{calculateValueType:()=>tv,completeValue:()=>Ov,filterValueSourcesForField:()=>sv,formatFieldName:()=>dv,getFieldPartsConfigs:()=>ov,getFieldPathLabels:()=>nv,getFirstOperator:()=>ev,getFuncPathLabels:()=>rv,getOneChildOrDescendant:()=>Sv,getOperatorsForField:()=>Zf,getOperatorsForType:()=>Jf,getValueLabel:()=>iv,getValueSourcesForFieldOp:()=>uv,getWidgetForFieldOp:()=>cv,getWidgetsForFieldOp:()=>lv,isEmptyGroupChildren:()=>gv,isEmptyItem:()=>pv,isEmptyRuleGroupExtPropertiesAndChildren:()=>vv,isEmptyRuleProperties:()=>mv,selectTypes:()=>Xf,whatRulePropertiesAreCompleted:()=>bv});var u={};p.r(u),p.d(u,{_getFromConfigCache:()=>Uh,_saveToConfigCache:()=>Bh,_widgetDefKeysToOmit:()=>Rh,applyJsonLogic:()=>Lv,cleanJSX:()=>Ms,compileConfig:()=>Qv,compressConfig:()=>$v,configKeys:()=>Mv,createConfigMemo:()=>ph,decompressConfig:()=>Yv,extendConfig:()=>yh,findExtendedConfigInAllMemos:()=>dh,getCommonMemo:()=>ch,getFieldConfig:()=>qh,getFieldId:()=>Vh,getFieldParts:()=>kh,getFieldPath:()=>Dh,getFieldPathParts:()=>Mh,getFieldRawConfig:()=>Nh,getFieldSrc:()=>Gh,getFieldWidgetConfig:()=>Wh,getFirstField:()=>zh,getFuncArgConfig:()=>Ph,getFuncConfig:()=>xh,getFuncSignature:()=>jh,getOperatorConfig:()=>Kh,isDirtyJSX:()=>Vs,isFieldDescendantOfField:()=>Fh,isJSX:()=>Us,iterateFields:()=>Ah,iterateFuncs:()=>Ih,normalizeField:()=>Lh});var c={};p.r(c),p.d(c,{_mongodbFormat:()=>Eg,_spelFormat:()=>Cc,_sqlFormat:()=>jg,elasticSearchFormat:()=>Kg,jsonLogicFormat:()=>ng,mongodbFormat:()=>bg,queryBuilderFormat:()=>Yh,queryString:()=>kd,spelFormat:()=>Ac,sqlFormat:()=>Lg});var d={};p.r(d),p.d(d,{fixListValuesGroupOrder:()=>ry,getListValue:()=>hu,listValueToOption:()=>ty,mergeListValues:()=>Jg,optionToListValue:()=>Zg,optionsToListValues:()=>ey,simulateAsyncFetch:()=>Xg});var v={};p.r(v),p.d(v,{Autocomplete:()=>d,ConfigUtils:()=>u,DefaultUtils:()=>i,ExportUtils:()=>n,FuncUtils:()=>l,ListUtils:()=>t,OtherUtils:()=>e,RuleUtils:()=>s,TreeUtils:()=>r,Validation:()=>a,checkTree:()=>If,clone:()=>Rv(),compressConfig:()=>$v,decompressConfig:()=>Yv,getSwitchValues:()=>Ru,i18n:()=>Of,isValidTree:()=>wf,moment:()=>ku(),sanitizeTree:()=>Cf,uuid:()=>Ss,validateAndFixTree:()=>Nf,validateTree:()=>Af});var h={};p.r(h),p.d(h,{LINEAR_REGRESSION:()=>ly,LOWER:()=>iy,NOW:()=>ny,RELATIVE_DATETIME:()=>oy,UPPER:()=>ay});var g={};p.r(g),p.d(g,{addCaseGroup:()=>fm,addDefaultCaseGroup:()=>pm,addGroup:()=>vm,addRule:()=>cm,moveItem:()=>gm,removeGroup:()=>hm,removeRule:()=>dm,setTree:()=>um});var y={};p.r(y),p.d(y,{setConjunction:()=>ym,setLock:()=>bm,setNot:()=>mm});var m={};p.r(m),p.d(m,{setField:()=>Em,setFieldSrc:()=>Om,setFuncValue:()=>wm,setOperator:()=>Sm,setOperatorOption:()=>Rm,setValue:()=>Tm,setValueSrc:()=>_m});var b={};p.r(b),p.d(b,{bindActionCreators:()=>rb,isUsingLegacyReactDomRender:()=>Jm,liteShouldComponentUpdate:()=>Zm,pureShouldComponentUpdate:()=>eb,useOnPropsChanged:()=>tb});var E={};p.r(E),p.d(E,{FuncWidget:()=>JE,ValueFieldWidget:()=>eT,VanillaBooleanWidget:()=>tT,VanillaButton:()=>yT,VanillaButtonGroup:()=>bT,VanillaConjs:()=>hT,VanillaDateTimeWidget:()=>lT,VanillaDateWidget:()=>oT,VanillaFieldSelect:()=>vT,VanillaIcon:()=>mT,VanillaMultiSelectWidget:()=>uT,VanillaNumberWidget:()=>pT,VanillaProvider:()=>TT,VanillaSelectWidget:()=>dT,VanillaSliderWidget:()=>fT,VanillaSwitch:()=>OT,VanillaTextAreaWidget:()=>nT,VanillaTextWidget:()=>rT,VanillaTimeWidget:()=>iT,VanillaValueSources:()=>ET,vanillaConfirm:()=>ST});var O={};p.r(O),p.d(O,{ProximityOperator:()=>RT});var S,T=p(7781);!function(e){e.Timeseries="time_series",e.Table="table"}(S||(S={}));const _=[{label:"Time series",value:"time_series"},{label:"Table",value:"table"}],w=null!==T.toOption&&void 0!==T.toOption?T.toOption:e=>({label:e,value:e});var R=p(1269);function I(e){return"function"==typeof e}var A=function(e,t){return A=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},A(e,t)};function C(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}A(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}function N(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function L(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function j(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}Object.create,Object.create,"function"==typeof SuppressedError&&SuppressedError;var x,P,F=(x=function(e){return function(t){e(this),this.message=t?t.length+" errors occurred during unsubscription:\n"+t.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=t}},P=x((function(e){Error.call(e),e.stack=(new Error).stack})),P.prototype=Object.create(Error.prototype),P.prototype.constructor=P,P);function D(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}var k=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._finalizers=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,n,o;if(!this.closed){this.closed=!0;var i=this._parentage;if(i)if(this._parentage=null,Array.isArray(i))try{for(var a=N(i),l=a.next();!l.done;l=a.next())l.value.remove(this)}catch(t){e={error:t}}finally{try{l&&!l.done&&(t=a.return)&&t.call(a)}finally{if(e)throw e.error}}else i.remove(this);var s=this.initialTeardown;if(I(s))try{s()}catch(e){o=e instanceof F?e.errors:[e]}var u=this._finalizers;if(u){this._finalizers=null;try{for(var c=N(u),d=c.next();!d.done;d=c.next()){var p=d.value;try{M(p)}catch(e){o=null!=o?o:[],e instanceof F?o=j(j([],L(o)),L(e.errors)):o.push(e)}}}catch(e){r={error:e}}finally{try{d&&!d.done&&(n=c.return)&&n.call(c)}finally{if(r)throw r.error}}}if(o)throw new F(o)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)M(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._finalizers=null!==(r=this._finalizers)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&D(t,e)},e.prototype.remove=function(t){var r=this._finalizers;r&&D(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function M(e){I(e)?e():e.unsubscribe()}k.EMPTY;var V=null,U=null,B=!1,G=!1,q={setTimeout:function(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];var o=q.delegate;return(null==o?void 0:o.setTimeout)?o.setTimeout.apply(o,j([e,t],L(r))):setTimeout.apply(void 0,j([e,t],L(r)))},clearTimeout:function(e){var t=q.delegate;return((null==t?void 0:t.clearTimeout)||clearTimeout)(e)},delegate:void 0};function K(){}var W=z("C",void 0,void 0);function z(e,t,r){return{kind:e,value:t,error:r}}var H=function(e){function t(t){var r,n=e.call(this)||this;return n.isStopped=!1,t?(n.destination=t,((r=t)instanceof k||r&&"closed"in r&&I(r.remove)&&I(r.add)&&I(r.unsubscribe))&&t.add(n)):n.destination=ee,n}return C(t,e),t.create=function(e,t,r){return new X(e,t,r)},t.prototype.next=function(e){this.isStopped?Z(function(e){return z("N",e,void 0)}(e),this):this._next(e)},t.prototype.error=function(e){this.isStopped?Z(z("E",void 0,e),this):(this.isStopped=!0,this._error(e))},t.prototype.complete=function(){this.isStopped?Z(W,this):(this.isStopped=!0,this._complete())},t.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},t.prototype._next=function(e){this.destination.next(e)},t.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},t.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},t}(k),$=Function.prototype.bind;function Y(e,t){return $.call(e,t)}var Q=function(){function e(e){this.partialObserver=e}return e.prototype.next=function(e){var t=this.partialObserver;if(t.next)try{t.next(e)}catch(e){J(e)}},e.prototype.error=function(e){var t=this.partialObserver;if(t.error)try{t.error(e)}catch(e){J(e)}else J(e)},e.prototype.complete=function(){var e=this.partialObserver;if(e.complete)try{e.complete()}catch(e){J(e)}},e}(),X=function(e){function t(t,r,n){var o,i,a=e.call(this)||this;return I(t)||!t?o={next:null!=t?t:void 0,error:null!=r?r:void 0,complete:null!=n?n:void 0}:a&&G?((i=Object.create(t)).unsubscribe=function(){return a.unsubscribe()},o={next:t.next&&Y(t.next,i),error:t.error&&Y(t.error,i),complete:t.complete&&Y(t.complete,i)}):o=t,a.destination=new Q(o),a}return C(t,e),t}(H);function J(e){B||function(e){q.setTimeout((function(){if(!V)throw e;V(e)}))}(e)}function Z(e,t){var r=U;r&&q.setTimeout((function(){return r(e,t)}))}var ee={closed:!0,next:K,error:function(e){throw e},complete:K},te=function(e){function t(t,r,n,o,i,a){var l=e.call(this,t)||this;return l.onFinalize=i,l.shouldUnsubscribe=a,l._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,l._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,l._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,l}return C(t,e),t.prototype.unsubscribe=function(){var t;if(!this.shouldUnsubscribe||this.shouldUnsubscribe()){var r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))}},t}(H);function re(e,t){return r=function(r,n){var o=0;r.subscribe(new te(n,(function(r){n.next(e.call(t,r,o++))}),void 0,void 0,void 0))},function(e){if(function(e){return I(null==e?void 0:e.lift)}(e))return e.lift((function(e){try{return r(e,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")};var r}var ne=(e=>(e[e.Comparison=0]="Comparison",e[e.Logical=1]="Logical",e))(ne||{}),oe=(e=>(e[e.Value=0]="Value",e[e.Filter=1]="Filter",e[e.Group=2]="Group",e[e.Column=3]="Column",e[e.Table=4]="Table",e))(oe||{}),ie=(e=>(e.Parenthesis="delimiter.parenthesis.sql",e.Whitespace="white.sql",e.Keyword="keyword.sql",e.Delimiter="delimiter.sql",e.Operator="operator.sql",e.Identifier="identifier.sql",e.IdentifierQuote="identifier.quote.sql",e.Type="type.sql",e.Function="predefined.sql",e.Number="number.sql",e.String="string.sql",e.Variable="variable.sql",e))(ie||{}),ae=(e=>(e.Unknown="unknown",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.AfterSelectKeyword="afterSelectKeyword",e.AfterSelectArguments="afterSelectArguments",e.AfterSelectFuncFirstArgument="afterSelectFuncFirstArgument",e.SelectAlias="selectAlias",e.AfterFromKeyword="afterFromKeyword",e.AfterTable="afterTable",e.SchemaFuncFirstArgument="schemaFuncFirstArgument",e.SchemaFuncExtraArgument="schemaFuncExtraArgument",e.FromKeyword="fromKeyword",e.AfterFrom="afterFrom",e.WhereKeyword="whereKeyword",e.WhereComparisonOperator="whereComparisonOperator",e.WhereValue="whereValue",e.AfterWhereFunctionArgument="afterWhereFunctionArgument",e.AfterGroupByFunctionArgument="afterGroupByFunctionArgument",e.AfterWhereValue="afterWhereValue",e.AfterGroupByKeywords="afterGroupByKeywords",e.AfterGroupBy="afterGroupBy",e.AfterOrderByKeywords="afterOrderByKeywords",e.AfterOrderByFunction="afterOrderByFunction",e.AfterOrderByDirection="afterOrderByDirection",e.AfterIsOperator="afterIsOperator",e.AfterIsNotOperator="afterIsNotOperator",e.AfterSchema="afterSchema",e))(ae||{}),le=(e=>(e.Schemas="schemas",e.Tables="tables",e.Columns="columns",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.FunctionsWithArguments="functionsWithArguments",e.FromKeyword="fromKeyword",e.WhereKeyword="whereKeyword",e.GroupByKeywords="groupByKeywords",e.OrderByKeywords="orderByKeywords",e.FunctionsWithoutArguments="functionsWithoutArguments",e.LimitKeyword="limitKeyword",e.SortOrderDirectionKeyword="sortOrderDirectionKeyword",e.ComparisonOperators="comparisonOperators",e.LogicalOperators="logicalOperators",e.SelectMacro="selectMacro",e.TableMacro="tableMacro",e.FilterMacro="filterMacro",e.GroupMacro="groupMacro",e.BoolValues="boolValues",e.NullValue="nullValue",e.NotKeyword="notKeyword",e.TemplateVariables="templateVariables",e.StarWildCard="starWildCard",e))(le||{}),se=(e=>(e.High="a",e.MediumHigh="d",e.Medium="g",e.MediumLow="k",e.Low="q",e))(se||{}),ue=(e=>(e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet",e))(ue||{}),ce=(e=>(e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet",e))(ce||{}),de=(e=>(e.Builder="builder",e.Code="code",e))(de||{}),pe=p(8531),fe=p(3241);class ve{transformMetricFindResponse(e){const t=[],r=e.fields.find((e=>"__text"===e.name)),n=e.fields.find((e=>"__value"===e.name));if(r&&n)for(let e=0;e<r.values.length;e++)t.push({text:""+r.values[e],value:""+n.values[e]});else for(const r of e.fields)for(const e of r.values)t.push({text:e});return(0,fe.uniqBy)(t,"text")}}var he=p(9728),ge=p(5959),ye=p.n(ge),me=p(7016);function be(){var e=(0,ge.useRef)(!1),t=(0,ge.useCallback)((function(){return e.current}),[]);return(0,ge.useEffect)((function(){return e.current=!0,function(){e.current=!1}}),[]),t}function Ee(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var n=(0,ge.useRef)(0),o=be(),i=(0,ge.useState)(r),a=i[0],l=i[1],s=(0,ge.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var i=++n.current;return a.loading||l((function(e){return(0,me.__assign)((0,me.__assign)({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return o()&&i===n.current&&l({value:e,loading:!1}),e}),(function(e){return o()&&i===n.current&&l({error:e,loading:!1}),e}))}),t);return[a,s]}function Oe(e,t){void 0===t&&(t=[]);var r=Ee(e,t,{loading:!0}),n=r[0],o=r[1];return(0,ge.useEffect)((function(){o()}),[o]),n}var Se,Te,_e=p(2007);!function(e){e.String="string"}(Se||(Se={})),function(e){e.Property="property",e.Operator="operator",e.Or="or",e.And="and",e.GroupBy="groupBy",e.Function="function",e.FunctionParameter="functionParameter"}(Te||(Te={}));const we=e=>{if(!e)return!1;const t=e.some((e=>{var t,r;return(null===(t=e.parameters)||void 0===t?void 0:t.length)||(null===(r=e.parameters)||void 0===r?void 0:r.some((e=>e.name)))})),r=e.some((e=>e.name));return t||r};function Re(e){return{type:Te.GroupBy,property:{type:Se.String,name:e}}}function Ie(e){return{type:Te.Function,name:e,parameters:[]}}function Ae(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ce(e){let t=(null==e?void 0:e.editorMode)||de.Builder;var r;void 0===(null==e?void 0:e.editorMode)&&void 0!==(null==e?void 0:e.rawSql)&&(t=de.Code);const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ae(e,t,r[t])}))}return e}({},e),i=null!=(i={refId:(null==e?void 0:e.refId)||"A",format:void 0!==(null==e?void 0:e.format)?e.format:S.Table,rawSql:(null==e?void 0:e.rawSql)||"",editorMode:t,sql:null!==(r=null==e?void 0:e.sql)&&void 0!==r?r:{columns:[Ie()],groupBy:[Re()],limit:50}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;return n}var Ne=p(4221),Le=p.n(Ne);const je=function(){var e=be(),t=function(e){void 0===e&&(e={});var t=(0,ge.useState)(e),r=t[0],n=t[1];return[r,(0,ge.useCallback)((function(e){n((function(t){return Object.assign({},t,e instanceof Function?e(t):e)}))}),[])]}({value:void 0,error:void 0,noUserInteraction:!0}),r=t[0],n=t[1];return[r,(0,ge.useCallback)((function(t){var r,o;if(e())try{if("string"!=typeof t&&"number"!=typeof t){var i=new Error("Cannot copy typeof "+typeof t+" to clipboard, must be a string");return void n({value:t,error:i,noUserInteraction:!0})}if(""===t)return i=new Error("Cannot copy empty string to clipboard."),void n({value:t,error:i,noUserInteraction:!0});o=t.toString(),r=Le()(o),n({value:o,error:void 0,noUserInteraction:r})}catch(i){n({value:o,error:i,noUserInteraction:r})}}),[])]},xe={RadioButton:{container:"data-testid radio-button"},Breadcrumbs:{breadcrumb:e=>`data-testid ${e} breadcrumb`},TimePicker:{openButton:"data-testid TimePicker Open Button",overlayContent:"data-testid TimePicker Overlay Content",fromField:"data-testid Time Range from field",toField:"data-testid Time Range to field",applyTimeRange:"data-testid TimePicker submit button",copyTimeRange:"data-testid TimePicker copy button",pasteTimeRange:"data-testid TimePicker paste button",calendar:{label:"data-testid Time Range calendar",openButton:"data-testid Open time range calendar",closeButton:"data-testid Close time range Calendar"},absoluteTimeRangeTitle:"data-testid-absolute-time-range-narrow"},DataSourcePermissions:{form:()=>'form[name="addPermission"]',roleType:"Role to add new permission to",rolePicker:"Built-in role picker",permissionLevel:"Permission Level"},DateTimePicker:{input:"data-testid date-time-input"},DataSource:{TestData:{QueryTab:{scenarioSelectContainer:"Test Data Query scenario select container",scenarioSelect:"Test Data Query scenario select",max:"TestData max",min:"TestData min",noise:"TestData noise",seriesCount:"TestData series count",spread:"TestData spread",startValue:"TestData start value",drop:"TestData drop values"}},DataSourceHttpSettings:{urlInput:"data-testid Datasource HTTP settings url"},Jaeger:{traceIDInput:"Trace ID"},Prometheus:{configPage:{connectionSettings:"Data source connection URL",manageAlerts:"prometheus-alerts-manager",scrapeInterval:"data-testid scrape interval",queryTimeout:"data-testid query timeout",defaultEditor:"data-testid default editor",disableMetricLookup:"disable-metric-lookup",prometheusType:"data-testid prometheus type",prometheusVersion:"data-testid prometheus version",cacheLevel:"data-testid cache level",incrementalQuerying:"prometheus-incremental-querying",queryOverlapWindow:"data-testid query overlap window",disableRecordingRules:"disable-recording-rules",customQueryParameters:"data-testid custom query parameters",httpMethod:"data-testid http method",exemplarsAddButton:"data-testid Add exemplar config button",internalLinkSwitch:"data-testid Internal link switch",codeModeMetricNamesSuggestionLimit:"data-testid code mode metric names suggestion limit"},queryEditor:{explain:"data-testid prometheus explain switch wrapper",editorToggle:"data-testid QueryEditorModeToggle",options:"data-testid prometheus options",legend:"data-testid prometheus legend wrapper",format:"data-testid prometheus format",step:"prometheus-step",type:"data-testid prometheus type",exemplars:"prometheus-exemplars",builder:{metricSelect:"data-testid metric select",hints:"data-testid prometheus hints",metricsExplorer:"data-testid metrics explorer",queryAdvisor:"data-testid query advisor"},code:{queryField:"data-testid prometheus query field",metricsCountInfo:"data-testid metrics count disclaimer",metricsBrowser:{openButton:"data-testid open metrics browser",selectMetric:"data-testid select a metric",seriesLimit:"data-testid series limit",metricList:"data-testid metric list",labelNamesFilter:"data-testid label names filter",labelValuesFilter:"data-testid label values filter",useQuery:"data-testid use query",useAsRateQuery:"data-testid use as rate query",validateSelector:"data-testid validate selector",clear:"data-testid clear"}}},exemplarMarker:"data-testid Exemplar marker",variableQueryEditor:{queryType:"data-testid query type",labelnames:{metricRegex:"data-testid label names metric regex"},labelValues:{labelSelect:"data-testid label values label select"},metricNames:{metricRegex:"data-testid metric names metric regex"},varQueryResult:"data-testid variable query result",seriesQuery:"data-testid prometheus series query",classicQuery:"data-testid prometheus classic query"},annotations:{minStep:"prometheus-annotation-min-step",title:"data-testid prometheus annotation title",tags:"data-testid prometheus annotation tags",text:"data-testid prometheus annotation text",seriesValueAsTimestamp:"data-testid prometheus annotation series value as timestamp"}}},Menu:{MenuComponent:e=>`${e} menu`,MenuGroup:e=>`${e} menu group`,MenuItem:e=>`${e} menu item`,SubMenu:{container:"data-testid SubMenu container",icon:"data-testid SubMenu icon"}},Panels:{Panel:{title:e=>`data-testid Panel header ${e}`,content:"data-testid panel content",headerItems:e=>`data-testid Panel header item ${e}`,menuItems:e=>`data-testid Panel menu item ${e}`,menu:e=>`data-testid Panel menu ${e}`,containerByTitle:e=>`${e} panel`,headerCornerInfo:e=>`Panel header ${e}`,status:e=>`data-testid Panel status ${e}`,loadingBar:()=>"Panel loading bar",HoverWidget:{container:"data-testid hover-header-container",dragIcon:"data-testid drag-icon"},PanelDataErrorMessage:"data-testid Panel data error message"},Visualization:{Graph:{container:"Graph container",VisualizationTab:{legendSection:"Legend section"},Legend:{legendItemAlias:e=>`gpl alias ${e}`,showLegendSwitch:"gpl show legend"},xAxis:{labels:()=>"div.flot-x-axis > div.flot-tick-label"}},BarGauge:{value:"Bar gauge value",valueV2:"data-testid Bar gauge value"},PieChart:{svgSlice:"data testid Pie Chart Slice"},Text:{container:()=>".markdown-html"},Table:{header:"table header",footer:"table-footer",body:"data-testid table body"}}},VizLegend:{seriesName:e=>`data-testid VizLegend series ${e}`},Drawer:{General:{title:e=>`Drawer title ${e}`,expand:"Drawer expand",contract:"Drawer contract",close:"data-testid Drawer close",rcContentWrapper:()=>".rc-drawer-content-wrapper",subtitle:"data-testid drawer subtitle"},DashboardSaveDrawer:{saveButton:"data-testid Save dashboard drawer button",saveAsButton:"data-testid Save as dashboard drawer button",saveAsTitleInput:"Save dashboard title field"}},PanelEditor:{General:{content:"data-testid Panel editor content"},OptionsPane:{content:"data-testid Panel editor option pane content",select:"Panel editor option pane select",fieldLabel:e=>`${e} field property editor`,fieldInput:e=>`data-testid Panel editor option pane field input ${e}`},DataPane:{content:"data-testid Panel editor data pane content"},applyButton:"data-testid Apply changes and go back to dashboard",toggleVizPicker:"data-testid toggle-viz-picker",toggleVizOptions:"data-testid toggle-viz-options",toggleTableView:"data-testid toggle-table-view",showZoomField:"Map controls Show zoom control field property editor",showAttributionField:"Map controls Show attribution field property editor",showScaleField:"Map controls Show scale field property editor",showMeasureField:"Map controls Show measure tools field property editor",showDebugField:"Map controls Show debug field property editor",measureButton:"show measure tools"},PanelInspector:{Data:{content:"Panel inspector Data content"},Stats:{content:"Panel inspector Stats content"},Json:{content:"data-testid Panel inspector Json content"},Query:{content:"Panel inspector Query content",refreshButton:"Panel inspector Query refresh button",jsonObjectKeys:()=>".json-formatter-key"}},Tab:{title:e=>`data-testid Tab ${e}`,active:()=>'[class*="-activeTabStyle"]'},RefreshPicker:{runButton:"RefreshPicker run button",intervalButton:"RefreshPicker interval button",runButtonV2:"data-testid RefreshPicker run button",intervalButtonV2:"data-testid RefreshPicker interval button"},QueryTab:{content:"Query editor tab content",queryInspectorButton:"Query inspector button",queryHistoryButton:"data-testid query-history-button",addQuery:"data-testid query-tab-add-query",queryGroupTopSection:"data-testid query group top section",addExpression:"data-testid query-tab-add-expression"},QueryHistory:{queryText:"Query text"},QueryEditorRows:{rows:"Query editor row"},QueryEditorRow:{actionButton:e=>`data-testid ${e}`,title:e=>`Query editor row title ${e}`,container:e=>`Query editor row ${e}`},AlertTab:{content:"data-testid Alert editor tab content"},AlertRules:{groupToggle:"data-testid group-collapse-toggle",toggle:"data-testid collapse-toggle",expandedContent:"data-testid expanded-content",previewButton:"data-testid alert-rule preview-button",ruleNameField:"data-testid alert-rule name-field",newFolderButton:"data-testid alert-rule new-folder-button",newFolderNameField:"data-testid alert-rule name-folder-name-field",newFolderNameCreateButton:"data-testid alert-rule name-folder-name-create-button",newEvaluationGroupButton:"data-testid alert-rule new-evaluation-group-button",newEvaluationGroupName:"data-testid alert-rule new-evaluation-group-name",newEvaluationGroupInterval:"data-testid alert-rule new-evaluation-group-interval",newEvaluationGroupCreate:"data-testid alert-rule new-evaluation-group-create-button"},Alert:{alert:e=>`Alert ${e}`,alertV2:e=>`data-testid Alert ${e}`},TransformTab:{content:"data-testid Transform editor tab content",newTransform:e=>`data-testid New transform ${e}`,transformationEditor:e=>`data-testid Transformation editor ${e}`,transformationEditorDebugger:e=>`data-testid Transformation editor debugger ${e}`},Transforms:{card:e=>`data-testid New transform ${e}`,disableTransformationButton:"data-testid Disable transformation button",Reduce:{modeLabel:"data-testid Transform mode label",calculationsLabel:"data-testid Transform calculations label"},SpatialOperations:{actionLabel:"root Action field property editor",locationLabel:"root Location Mode field property editor",location:{autoOption:"Auto location option",coords:{option:"Coords location option",latitudeFieldLabel:"root Latitude field field property editor",longitudeFieldLabel:"root Longitude field field property editor"},geohash:{option:"Geohash location option",geohashFieldLabel:"root Geohash field field property editor"},lookup:{option:"Lookup location option",lookupFieldLabel:"root Lookup field field property editor",gazetteerFieldLabel:"root Gazetteer field property editor"}}},searchInput:"data-testid search transformations",noTransformationsMessage:"data-testid no transformations message",addTransformationButton:"data-testid add transformation button",removeAllTransformationsButton:"data-testid remove all transformations button"},NavBar:{Configuration:{button:"Configuration"},Toggle:{button:"data-testid Toggle menu"},Reporting:{button:"Reporting"}},NavMenu:{Menu:"data-testid navigation mega-menu",item:"data-testid Nav menu item"},NavToolbar:{container:"data-testid Nav toolbar",commandPaletteTrigger:"data-testid Command palette trigger",shareDashboard:"data-testid Share dashboard",markAsFavorite:"data-testid Mark as favorite",editDashboard:{editButton:"data-testid Edit dashboard button",saveButton:"data-testid Save dashboard button",exitButton:"data-testid Exit edit mode button",settingsButton:"data-testid Dashboard settings",addRowButton:"data-testid Add row button",addLibraryPanelButton:"data-testid Add a panel from the panel library button",addVisualizationButton:"data-testid Add new visualization menu item",pastePanelButton:"data-testid Paste panel button",discardChangesButton:"data-testid Discard changes button",discardLibraryPanelButton:"data-testid Discard library panel button",unlinkLibraryPanelButton:"data-testid Unlink library panel button",saveLibraryPanelButton:"data-testid Save library panel button",backToDashboardButton:"data-testid Back to dashboard button"}},PageToolbar:{container:()=>".page-toolbar",item:e=>`${e}`,itemButton:e=>`data-testid ${e}`},QueryEditorToolbarItem:{button:e=>`QueryEditor toolbar item button ${e}`},BackButton:{backArrow:"data-testid Go Back"},OptionsGroup:{group:e=>e?`data-testid Options group ${e}`:"data-testid Options group",toggle:e=>e?`data-testid Options group ${e} toggle`:"data-testid Options group toggle"},PluginVisualization:{item:e=>`Plugin visualization item ${e}`,current:()=>'[class*="-currentVisualizationItem"]'},Select:{option:"data-testid Select option",toggleAllOptions:"data-testid toggle all options",input:()=>'input[id*="time-options-input"]',singleValue:()=>'div[class*="-singleValue"]'},FieldConfigEditor:{content:"Field config editor content"},OverridesConfigEditor:{content:"Field overrides editor content"},FolderPicker:{container:"Folder picker select container",containerV2:"data-testid Folder picker select container",input:"data-testid folder-picker-input"},ReadonlyFolderPicker:{container:"data-testid Readonly folder picker select container"},DataSourcePicker:{container:"data-testid Data source picker select container",input:()=>'input[id="data-source-picker"]',inputV2:"data-testid Select a data source",dataSourceList:"data-testid Data source list dropdown",advancedModal:{dataSourceList:"data-testid Data source list",builtInDataSourceList:"data-testid Built in data source list"}},TimeZonePicker:{container:"Time zone picker select container",containerV2:"data-testid Time zone picker select container",changeTimeSettingsButton:"data-testid Time zone picker Change time settings button"},WeekStartPicker:{container:"Choose starting day of the week",containerV2:"data-testid Choose starting day of the week",placeholder:"Choose starting day of the week"},TraceViewer:{spanBar:"data-testid SpanBar--wrapper"},QueryField:{container:"data-testid Query field"},QueryBuilder:{queryPatterns:"data-testid Query patterns",labelSelect:"data-testid Select label",inputSelect:"data-testid Select label-input",valueSelect:"data-testid Select value",matchOperatorSelect:"data-testid Select match operator"},ValuePicker:{button:e=>`data-testid Value picker button ${e}`,select:e=>`data-testid Value picker select ${e}`},Search:{section:"Search section",sectionV2:"data-testid Search section",items:"Search items",itemsV2:"data-testid Search items",cards:"data-testid Search cards",collapseFolder:e=>`data-testid Collapse folder ${e}`,expandFolder:e=>`data-testid Expand folder ${e}`,dashboardItem:e=>`${xe.Search.dashboardItems} ${e}`,dashboardCard:e=>`data-testid Search card ${e}`,folderHeader:e=>`data-testid Folder header ${e}`,folderContent:e=>`data-testid Folder content ${e}`,dashboardItems:"data-testid Dashboard search item"},DashboardLinks:{container:"data-testid Dashboard link container",dropDown:"data-testid Dashboard link dropdown",link:"data-testid Dashboard link"},LoadingIndicator:{icon:"data-testid Loading indicator"},CallToActionCard:{button:e=>`Call to action button ${e}`,buttonV2:e=>`data-testid Call to action button ${e}`},DataLinksContextMenu:{singleLink:"data-testid Data link"},CodeEditor:{container:"data-testid Code editor container"},ReactMonacoEditor:{editorLazy:"data-testid ReactMonacoEditor editorLazy"},DashboardImportPage:{textarea:"data-testid-import-dashboard-textarea",submit:"data-testid-load-dashboard"},ImportDashboardForm:{name:"data-testid-import-dashboard-title",submit:"data-testid-import-dashboard-submit"},PanelAlertTabContent:{content:"data-testid Unified alert editor tab content"},VisualizationPreview:{card:e=>`data-testid suggestion-${e}`},ColorSwatch:{name:"data-testid-colorswatch"},DashboardRow:{title:e=>`data-testid dashboard-row-title-${e}`},UserProfile:{profileSaveButton:"data-testid-user-profile-save",preferencesSaveButton:"data-testid-shared-prefs-save",orgsTable:"data-testid-user-orgs-table",sessionsTable:"data-testid-user-sessions-table",extensionPointTabs:"data-testid-extension-point-tabs",extensionPointTab:e=>`data-testid-extension-point-tab-${e}`},FileUpload:{inputField:"data-testid-file-upload-input-field",fileNameSpan:"data-testid-file-upload-file-name"},DebugOverlay:{wrapper:"debug-overlay"},OrgRolePicker:{input:"Role"},AnalyticsToolbarButton:{button:"Dashboard insights"},Variables:{variableOption:"data-testid variable-option",variableLinkWrapper:"data-testid variable-link-wrapper"},Annotations:{annotationsTypeInput:"data-testid annotations-type-input",annotationsChoosePanelInput:"data-testid choose-panels-input",editor:{testButton:"data-testid annotations-test-button",resultContainer:"data-testid annotations-query-result-container"}},Tooltip:{container:"data-testid tooltip"},ReturnToPrevious:{buttonGroup:"data-testid dismissable button group",backButton:"data-testid back",dismissButton:"data-testid dismiss"},SQLQueryEditor:{selectColumn:"data-testid select-column",selectAggregation:"data-testid select-aggregation",selectAlias:"data-testid select-alias",filterConjunction:"data-testid filter-conjunction",filterField:"data-testid filter-field",filterOperator:"data-testid filter-operator",headerTableSelector:"data-testid header-table-selector",headerFilterSwitch:"data-testid header-filter-switch",headerGroupSwitch:"data-testid header-group-switch",headerOrderSwitch:"data-testid header-order-switch",headerPreviewSwitch:"data-testid header-preview-switch"},EntityNotFound:{container:"data-testid entity-not-found"}},Pe={pages:{Login:{url:"/login",username:"data-testid Username input field",password:"data-testid Password input field",submit:"data-testid Login button",skip:"data-testid Skip change password button"},Home:{url:"/"},DataSource:{name:"data-testid Data source settings page name input field",delete:"Data source settings page Delete button",readOnly:"data-testid Data source settings page read only message",saveAndTest:"data-testid Data source settings page Save and Test button",alert:"data-testid Data source settings page Alert"},DataSources:{url:"/datasources",dataSources:e=>`Data source list item ${e}`},EditDataSource:{url:e=>`/datasources/edit/${e}`,settings:"Datasource settings page basic settings"},AddDataSource:{url:"/datasources/new",dataSourcePlugins:e=>`Data source plugin item ${e}`,dataSourcePluginsV2:e=>`Add new data source ${e}`},ConfirmModal:{delete:"data-testid Confirm Modal Danger Button"},AddDashboard:{url:"/dashboard/new",itemButton:e=>`data-testid ${e}`,addNewPanel:"data-testid Add new panel",addNewRow:"data-testid Add new row",addNewPanelLibrary:"data-testid Add new panel from panel library"},Dashboard:{url:e=>`/d/${e}`,DashNav:{nav:"Dashboard navigation",navV2:"data-testid Dashboard navigation",publicDashboardTag:"data-testid public dashboard tag",shareButton:"data-testid share-button",scrollContainer:"data-testid Dashboard canvas scroll container",newShareButton:{container:"data-testid new share button",shareLink:"data-testid new share link-button",arrowMenu:"data-testid new share button arrow menu",menu:{container:"data-testid new share button menu",shareInternally:"data-testid new share button share internally",shareExternally:"data-testid new share button share externally",shareSnapshot:"data-testid new share button share snapshot"}},NewExportButton:{container:"data-testid new export button",arrowMenu:"data-testid new export button arrow menu",Menu:{container:"data-testid new export button menu",exportAsJson:"data-testid new export button export as json"}},playlistControls:{prev:"data-testid playlist previous dashboard button",stop:"data-testid playlist stop dashboard button",next:"data-testid playlist next dashboard button"}},Controls:"data-testid dashboard controls",SubMenu:{submenu:"Dashboard submenu",submenuItem:"data-testid template variable",submenuItemLabels:e=>`data-testid Dashboard template variables submenu Label ${e}`,submenuItemValueDropDownValueLinkTexts:e=>`data-testid Dashboard template variables Variable Value DropDown value link text ${e}`,submenuItemValueDropDownDropDown:"Variable options",submenuItemValueDropDownOptionTexts:e=>`data-testid Dashboard template variables Variable Value DropDown option text ${e}`,Annotations:{annotationsWrapper:"data-testid annotation-wrapper",annotationLabel:e=>`data-testid Dashboard annotations submenu Label ${e}`,annotationToggle:e=>`data-testid Dashboard annotations submenu Toggle ${e}`}},Settings:{Actions:{close:"data-testid dashboard-settings-close"},General:{deleteDashBoard:"data-testid Dashboard settings page delete dashboard button",sectionItems:e=>`Dashboard settings section item ${e}`,saveDashBoard:"Dashboard settings aside actions Save button",saveAsDashBoard:"Dashboard settings aside actions Save As button",timezone:"Time zone picker select container",title:"General"},Annotations:{List:{addAnnotationCTA:xe.CallToActionCard.button("Add annotation query"),addAnnotationCTAV2:xe.CallToActionCard.buttonV2("Add annotation query"),annotations:"data-testid list-annotations"},Settings:{name:"data-testid Annotations settings name input"},NewAnnotation:{panelFilterSelect:"data-testid annotations-panel-filter",showInLabel:"data-testid show-in-label",previewInDashboard:"data-testid annotations-preview",delete:"data-testid annotations-delete",apply:"data-testid annotations-apply",enable:"data-testid annotation-enable",hide:"data-testid annotation-hide"}},Variables:{List:{addVariableCTA:xe.CallToActionCard.button("Add variable"),addVariableCTAV2:xe.CallToActionCard.buttonV2("Add variable"),newButton:"Variable editor New variable button",table:"Variable editor Table",tableRowNameFields:e=>`Variable editor Table Name field ${e}`,tableRowDefinitionFields:e=>`Variable editor Table Definition field ${e}`,tableRowArrowUpButtons:e=>`Variable editor Table ArrowUp button ${e}`,tableRowArrowDownButtons:e=>`Variable editor Table ArrowDown button ${e}`,tableRowDuplicateButtons:e=>`Variable editor Table Duplicate button ${e}`,tableRowRemoveButtons:e=>`Variable editor Table Remove button ${e}`},Edit:{General:{headerLink:"Variable editor Header link",modeLabelNew:"Variable editor Header mode New",modeLabelEdit:"Variable editor Header mode Edit",generalNameInput:"Variable editor Form Name field",generalNameInputV2:"data-testid Variable editor Form Name field",generalTypeSelect:"Variable editor Form Type select",generalTypeSelectV2:"data-testid Variable editor Form Type select",generalLabelInput:"Variable editor Form Label field",generalLabelInputV2:"data-testid Variable editor Form Label field",generalHideSelect:"Variable editor Form Hide select",generalHideSelectV2:"data-testid Variable editor Form Hide select",selectionOptionsMultiSwitch:"data-testid Variable editor Form Multi switch",selectionOptionsIncludeAllSwitch:"data-testid Variable editor Form IncludeAll switch",selectionOptionsCustomAllInput:"data-testid Variable editor Form IncludeAll field",previewOfValuesOption:"data-testid Variable editor Preview of Values option",submitButton:"data-testid Variable editor Run Query button",applyButton:"data-testid Variable editor Apply button"},QueryVariable:{queryOptionsDataSourceSelect:xe.DataSourcePicker.inputV2,queryOptionsRefreshSelect:"Variable editor Form Query Refresh select",queryOptionsRefreshSelectV2:"data-testid Variable editor Form Query Refresh select",queryOptionsRegExInput:"Variable editor Form Query RegEx field",queryOptionsRegExInputV2:"data-testid Variable editor Form Query RegEx field",queryOptionsSortSelect:"Variable editor Form Query Sort select",queryOptionsSortSelectV2:"data-testid Variable editor Form Query Sort select",queryOptionsQueryInput:"data-testid Variable editor Form Default Variable Query Editor textarea",valueGroupsTagsEnabledSwitch:"Variable editor Form Query UseTags switch",valueGroupsTagsTagsQueryInput:"Variable editor Form Query TagsQuery field",valueGroupsTagsTagsValuesQueryInput:"Variable editor Form Query TagsValuesQuery field"},ConstantVariable:{constantOptionsQueryInput:"Variable editor Form Constant Query field",constantOptionsQueryInputV2:"data-testid Variable editor Form Constant Query field"},DatasourceVariable:{datasourceSelect:"data-testid datasource variable datasource type"},TextBoxVariable:{textBoxOptionsQueryInput:"Variable editor Form TextBox Query field",textBoxOptionsQueryInputV2:"data-testid Variable editor Form TextBox Query field"},CustomVariable:{customValueInput:"data-testid custom-variable-input"},IntervalVariable:{intervalsValueInput:"data-testid interval variable intervals input",autoEnabledCheckbox:"data-testid interval variable auto value checkbox",stepCountIntervalSelect:"data-testid interval variable step count input",minIntervalInput:"data-testid interval variable mininum interval input"},GroupByVariable:{dataSourceSelect:xe.DataSourcePicker.inputV2,infoText:"data-testid group by variable info text",modeToggle:"data-testid group by variable mode toggle"},AdHocFiltersVariable:{datasourceSelect:xe.DataSourcePicker.inputV2,infoText:"data-testid ad-hoc filters variable info text",modeToggle:"data-testid ad-hoc filters variable mode toggle"}}}},Annotations:{marker:"data-testid annotation-marker"},Rows:{Repeated:{ConfigSection:{warningMessage:"data-testid Repeated rows warning message"}}}},Dashboards:{url:"/dashboards",dashboards:e=>`Dashboard search item ${e}`},SaveDashboardAsModal:{newName:"Save dashboard title field",save:"Save dashboard button"},SaveDashboardModal:{save:"Dashboard settings Save Dashboard Modal Save button",saveVariables:"Dashboard settings Save Dashboard Modal Save variables checkbox",saveTimerange:"Dashboard settings Save Dashboard Modal Save timerange checkbox",saveRefresh:"Dashboard settings Save Dashboard Modal Save refresh checkbox"},SharePanelModal:{linkToRenderedImage:"Link to rendered image"},ShareDashboardModal:{PublicDashboard:{WillBePublicCheckbox:"data-testid public dashboard will be public checkbox",LimitedDSCheckbox:"data-testid public dashboard limited datasources checkbox",CostIncreaseCheckbox:"data-testid public dashboard cost may increase checkbox",PauseSwitch:"data-testid public dashboard pause switch",EnableAnnotationsSwitch:"data-testid public dashboard on off switch for annotations",CreateButton:"data-testid public dashboard create button",DeleteButton:"data-testid public dashboard delete button",CopyUrlInput:"data-testid public dashboard copy url input",CopyUrlButton:"data-testid public dashboard copy url button",SettingsDropdown:"data-testid public dashboard settings dropdown",TemplateVariablesWarningAlert:"data-testid public dashboard disabled template variables alert",UnsupportedDataSourcesWarningAlert:"data-testid public dashboard unsupported data sources alert",NoUpsertPermissionsWarningAlert:"data-testid public dashboard no upsert permissions alert",EnableTimeRangeSwitch:"data-testid public dashboard on off switch for time range",EmailSharingConfiguration:{Container:"data-testid email sharing config container",ShareType:"data-testid public dashboard share type",EmailSharingInput:"data-testid public dashboard email sharing input",EmailSharingInviteButton:"data-testid public dashboard email sharing invite button",EmailSharingList:"data-testid public dashboard email sharing list",DeleteEmail:"data-testid public dashboard delete email button",ReshareLink:"data-testid public dashboard reshare link button"}},SnapshotScene:{url:e=>`/dashboard/snapshot/${e}`,PublishSnapshot:"data-testid publish snapshot button",CopyUrlButton:"data-testid snapshot copy url button",CopyUrlInput:"data-testid snapshot copy url input"}},ShareDashboardDrawer:{ShareInternally:{container:"data-testid share internally drawer container",lockTimeRangeSwitch:"data-testid share internally lock time range switch",shortenUrlSwitch:"data-testid share internally shorten url switch",copyUrlButton:"data-testid share internally copy url button"},ShareExternally:{container:"data-testid share externally drawer container",publicAlert:"data-testid public share alert",emailSharingAlert:"data-testid email share alert",shareTypeSelect:"data-testid share externally share type select",Creation:{PublicShare:{createButton:"data-testid public share dashboard create button",cancelButton:"data-testid public share dashboard cancel button"},EmailShare:{createButton:"data-testid email share dashboard create button",cancelButton:"data-testid email share dashboard cancel button"},willBePublicCheckbox:"data-testid share dashboard will be public checkbox"},Configuration:{enableTimeRangeSwitch:"data-testid share externally enable time range switch",enableAnnotationsSwitch:"data-testid share externally enable annotations switch",copyUrlButton:"data-testid share externally copy url button",revokeAccessButton:"data-testid share externally revoke access button",toggleAccessButton:"data-testid share externally pause or resume access button"}},ShareSnapshot:{url:e=>`/dashboard/snapshot/${e}`,container:"data-testid share snapshot drawer container",publishSnapshot:"data-testid share snapshot publish button",copyUrlButton:"data-testid share snapshot copy url button"}},ExportDashboardDrawer:{ExportAsJson:{container:"data-testid export as json drawer container",codeEditor:"data-testid export as json code editor",exportExternallyToggle:"data-testid export as json externally switch",saveToFileButton:"data-testid export as json save to file button",copyToClipboardButton:"data-testid export as json copy to clipboard button",cancelButton:"data-testid export as json cancel button"}},PublicDashboard:{page:"public-dashboard-page",NotAvailable:{container:"public-dashboard-not-available",title:"public-dashboard-title",pausedDescription:"public-dashboard-paused-description"},footer:"public-dashboard-footer"},PublicDashboardScene:{loadingPage:"public-dashboard-scene-loading-page",page:"public-dashboard-scene-page",controls:"public-dashboard-controls"},RequestViewAccess:{form:"request-view-access-form",recipientInput:"request-view-access-recipient-input",submitButton:"request-view-access-submit-button"},PublicDashboardConfirmAccess:{submitButton:"data-testid confirm-access-submit-button"},Explore:{url:"/explore",General:{container:"data-testid Explore",graph:"Explore Graph",table:"Explore Table",scrollView:"data-testid explorer scroll view"},QueryHistory:{container:"data-testid QueryHistory"}},SoloPanel:{url:e=>`/d-solo/${e}`},PluginsList:{page:"Plugins list page",list:"Plugins list",listItem:"Plugins list item",signatureErrorNotice:"data-testid Unsigned plugins notice"},PluginPage:{page:"Plugin page",signatureInfo:"data-testid Plugin signature info",disabledInfo:"data-testid Plugin disabled info"},PlaylistForm:{name:"Playlist name",interval:"Playlist interval",itemDelete:"data-testid playlist-form-delete-item"},BrowseDashboards:{table:{body:"data-testid browse-dashboards-table",row:e=>`data-testid browse dashboards row ${e}`,checkbox:e=>`data-testid ${e} checkbox`},NewFolderForm:{form:"data-testid new folder form",nameInput:"data-testid new-folder-name-input",createButton:"data-testid new-folder-create-button"}},Search:{url:"/?search=openn",FolderView:{url:"/?search=open&layout=folders"}},PublicDashboards:{ListItem:{linkButton:"public-dashboard-link-button",configButton:"public-dashboard-configuration-button",trashcanButton:"public-dashboard-remove-button",pauseSwitch:"data-testid public dashboard pause switch"}},UserListPage:{tabs:{allUsers:"data-testid all-users-tab",orgUsers:"data-testid org-users-tab",anonUserDevices:"data-testid anon-user-devices-tab",publicDashboardsUsers:"data-testid public-dashboards-users-tab",users:"data-testid users-tab"},org:{url:"/org/users"},admin:{url:"/admin/users"},publicDashboards:{container:"data-testid public-dashboards-users-list"},UserListAdminPage:{container:"data-testid user-list-admin-page"},UsersListPage:{container:"data-testid users-list-page"},UserAnonListPage:{container:"data-testid user-anon-list-page"},UsersListPublicDashboardsPage:{container:"data-testid users-list-public-dashboards-page",DashboardsListModal:{listItem:e=>`data-testid dashboards-list-item-${e}`}}},ProfilePage:{url:"/profile"}},components:xe};var Fe=p(6089);const De=({children:e})=>{const t=(0,_e.useStyles2)(ke);return ye().createElement("div",{className:t.root},e)},ke=e=>({root:(0,Fe.css)({display:"flex",flexWrap:"wrap",alignItems:"center",gap:e.spacing(3),minHeight:e.spacing(4)})});var Me=Object.defineProperty,Ve=Object.defineProperties,Ue=Object.getOwnPropertyDescriptors,Be=Object.getOwnPropertySymbols,Ge=Object.prototype.hasOwnProperty,qe=Object.prototype.propertyIsEnumerable,Ke=(e,t,r)=>t in e?Me(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,We=(e,t)=>{for(var r in t||(t={}))Ge.call(t,r)&&Ke(e,r,t[r]);if(Be)for(var r of Be(t))qe.call(t,r)&&Ke(e,r,t[r]);return e},ze=(e,t)=>Ve(e,Ue(t)),He=(e,t)=>{var r={};for(var n in e)Ge.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Be)for(var n of Be(e))t.indexOf(n)<0&&qe.call(e,n)&&(r[n]=e[n]);return r};function $e(e){var t=e,{label:r}=t,n=He(t,["label"]);const o=(0,_e.useStyles2)(Xe),[i]=(0,ge.useState)((()=>Math.random().toString(16).slice(2))),a={SelectContainer:Ye,ValueContainer:Qe,SingleValue:Qe};return ye().createElement("div",{className:o.root},r&&ye().createElement("label",{className:o.label,htmlFor:i},r,":"," "),ye().createElement(_e.Select,ze(We({openMenuOnFocus:!0,inputId:i},n),{components:a})))}const Ye=e=>{const{children:t}=e,r=(0,_e.useStyles2)(Xe);return ye().createElement(_e.SelectContainer,ze(We({},e),{className:(0,Fe.cx)(e.className,r.container)}),t)},Qe=e=>{const{className:t,children:r}=e,n=(0,_e.useStyles2)(Xe);return ye().createElement("div",{className:(0,Fe.cx)(t,n.valueContainer)},r)},Xe=e=>({root:(0,Fe.css)({display:"flex",fontSize:12,alignItems:"center"}),label:(0,Fe.css)({color:e.colors.text.secondary,whiteSpace:"nowrap"}),container:(0,Fe.css)({background:"none",borderColor:"transparent"}),valueContainer:(0,Fe.css)({display:"flex",alignItems:"center",flex:"initial",color:e.colors.text.secondary,fontSize:12})}),Je=({grow:e,shrink:t})=>ye().createElement("div",{style:{display:"block",flexGrow:e,flexShrink:t}});var Ze=Object.getOwnPropertySymbols,et=Object.prototype.hasOwnProperty,tt=Object.prototype.propertyIsEnumerable;const rt=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)et.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Ze)for(var n of Ze(e))t.indexOf(n)<0&&tt.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);const o=(0,_e.useStyles2)((0,ge.useCallback)((e=>nt(e,n)),[n]));return ye().createElement("div",{className:o.root},r)},nt=(e,t)=>{var r,n,o;return{root:(0,Fe.css)({display:"flex",flexDirection:null!=(r=t.direction)?r:"row",flexWrap:null==(n=t.wrap)||n?"wrap":void 0,alignItems:t.alignItems,gap:e.spacing(null!=(o=t.gap)?o:2),flexGrow:t.flexGrow})}},ot=({children:e})=>{const t=(0,_e.useStyles2)(it);return ye().createElement("div",{className:t.root},ye().createElement(rt,{gap:2},e))},it=e=>({root:(0,Fe.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(1)})}),at=({v:e=0,h:t=0,layout:r="block"})=>{const n=(0,_e.useStyles2)((0,ge.useCallback)((n=>lt(n,{v:e,h:t,layout:r})),[e,t,r]));return ye().createElement("span",{className:(0,Fe.cx)(n.wrapper)})},lt=(e,t)=>{var r,n;return{wrapper:(0,Fe.css)([{paddingRight:e.spacing(null!=(r=t.h)?r:0),paddingBottom:e.spacing(null!=(n=t.v)?n:0)},"inline"===t.layout&&{display:"inline-block"},"block"===t.layout&&{display:"block"}])}};var st=Object.defineProperty,ut=Object.getOwnPropertySymbols,ct=Object.prototype.hasOwnProperty,dt=Object.prototype.propertyIsEnumerable,pt=(e,t,r)=>t in e?st(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const ft=e=>{var t;const r=e,{label:n,optional:o,tooltip:i,tooltipInteractive:a,children:l,width:s}=r,u=((e,t)=>{var r={};for(var n in e)ct.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&ut)for(var n of ut(e))t.indexOf(n)<0&&dt.call(e,n)&&(r[n]=e[n]);return r})(r,["label","optional","tooltip","tooltipInteractive","children","width"]),c=(0,_e.useStyles2)((0,ge.useCallback)((e=>vt(e,s)),[s])),d=(null==u?void 0:u.htmlFor)||(null==(t=_e.ReactUtils)?void 0:t.getChildId(l)),p=ye().createElement(ye().Fragment,null,ye().createElement("label",{className:c.label,htmlFor:d},n,o&&ye().createElement("span",{className:c.optional}," - optional"),i&&ye().createElement(_e.Tooltip,{placement:"top",content:i,theme:"info",interactive:a},ye().createElement(_e.Icon,{tabIndex:0,name:"info-circle",size:"sm",className:c.icon}))),ye().createElement(at,{v:.5}));return ye().createElement("div",{className:c.root},ye().createElement(_e.Field,((e,t)=>{for(var r in t||(t={}))ct.call(t,r)&&pt(e,r,t[r]);if(ut)for(var r of ut(t))dt.call(t,r)&&pt(e,r,t[r]);return e})({className:c.field,label:p},u),l))},vt=(e,t)=>({root:(0,Fe.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,Fe.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,Fe.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,Fe.css)({marginBottom:0}),icon:(0,Fe.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})});function ht({isOpen:e,onCancel:t,onDiscard:r,onCopy:n}){const o=(0,ge.useRef)(null),i=(0,_e.useStyles2)(gt);return(0,ge.useEffect)((()=>{var t;e&&(null===(t=o.current)||void 0===t||t.focus())}),[e]),(0,he.jsxs)(_e.Modal,{title:(0,he.jsxs)("div",{className:i.modalHeaderTitle,children:[(0,he.jsx)(_e.Icon,{name:"exclamation-triangle",size:"lg"}),(0,he.jsx)("span",{className:i.titleText,children:"Warning"})]}),onDismiss:t,isOpen:e,children:[(0,he.jsx)("p",{children:"Builder mode does not display changes made in code. The query builder will display the last changes you made in builder mode."}),(0,he.jsx)("p",{children:"Do you want to copy your code to the clipboard?"}),(0,he.jsxs)(_e.Modal.ButtonRow,{children:[(0,he.jsx)(_e.Button,{type:"button",variant:"secondary",onClick:t,fill:"outline",children:"Cancel"}),(0,he.jsx)(_e.Button,{variant:"destructive",type:"button",onClick:r,ref:o,children:"Discard code and switch"}),(0,he.jsx)(_e.Button,{variant:"primary",onClick:n,children:"Copy code and switch"})]})]})}const gt=e=>({titleText:(0,Fe.css)({paddingLeft:e.spacing(2)}),modalHeaderTitle:(0,Fe.css)({fontSize:e.typography.size.lg,float:"left",paddingTop:e.spacing(1),margin:e.spacing(0,2)})}),yt=()=>!!pe.config.featureToggles.sqlDatasourceDatabaseSelection;function mt(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function bt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){mt(i,n,o,a,l,"next",e)}function l(e){mt(i,n,o,a,l,"throw",e)}a(void 0)}))}}const Et=({dataset:e,db:t,dialect:r,onChange:n,inputId:o,preconfiguredDataset:i})=>{const a=!!i||"postgres"===r,l=Oe(bt((function*(){return yt()&&a?(n(w(i)),[w(i)]):(e&&n(w(e)),(yield t.datasets()).map(w))})),[]);return(0,ge.useEffect)((()=>{yt()||(e?l.value&&void 0===l.value.find((t=>t.value===e))&&l.value.length>0&&n(l.value[0]):l.value&&l.value[0]&&n(l.value[0]))}),[l.value,n,e]),(0,he.jsx)(_e.Select,{"aria-label":"Dataset selector",inputId:o,value:e,options:l.value,onChange:n,disabled:l.loading,isLoading:l.loading,menuShouldPortal:!0})};function Ot(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function St(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Ot(i,n,o,a,l,"next",e)}function l(e){Ot(i,n,o,a,l,"throw",e)}a(void 0)}))}}const Tt=({db:e,dataset:t,table:r,className:n,onChange:o,inputId:i})=>{const a=Oe(St((function*(){return t?(yield e.tables(t)).map(T.toOption):[]})),[t]);return(0,he.jsx)(_e.Select,{className:n,disabled:a.loading,"aria-label":"Table selector",inputId:i,"data-testid":Pe.components.SQLQueryEditor.headerTableSelector,value:r,options:a.value,onChange:o,isLoading:a.loading,menuShouldPortal:!0,placeholder:a.loading?"Loading tables":"Select table"})};function _t(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function wt(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){_t(e,t,r[t])}))}return e}function Rt(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const It=[{label:"Builder",value:de.Builder},{label:"Code",value:de.Code}];function At({db:e,dialect:t,isQueryRunnable:r,onChange:n,onQueryRowChange:o,onRunQuery:i,preconfiguredDataset:a,query:l,queryRowFilter:s}){const{editorMode:u}=l,[c,d]=je(),[p,f]=(0,ge.useState)(!1),v=e.toRawSql,h=(0,ge.useId)(),g=(0,ge.useCallback)((e=>{var t;e===de.Code&&(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,selectedEditorMode:de.Code}),u!==de.Code?n(Rt(wt({},l),{editorMode:e})):f(!0)}),[u,n,l]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsxs)(De,{children:[(0,he.jsx)($e,{label:"Format",value:l.format,placeholder:"Select format",menuShouldPortal:!0,onChange:e=>{var t;const r=Rt(wt({},l),{format:void 0!==e.value?e.value:S.Table});(0,pe.reportInteraction)("grafana_sql_format_changed",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,selectedFormat:r.format}),n(r)},options:_}),u===de.Builder&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(_e.InlineSwitch,{id:`sql-filter-${h}`,label:"Filter","data-testid":Pe.components.SQLQueryEditor.headerFilterSwitch,transparent:!0,showLabel:!0,value:s.filter,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_filter_toggled",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(Rt(wt({},s),{filter:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-group-${h}`,label:"Group","data-testid":Pe.components.SQLQueryEditor.headerGroupSwitch,transparent:!0,showLabel:!0,value:s.group,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_group_toggled",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(Rt(wt({},s),{group:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-order-${h}`,label:"Order","data-testid":Pe.components.SQLQueryEditor.headerOrderSwitch,transparent:!0,showLabel:!0,value:s.order,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_order_toggled",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(Rt(wt({},s),{order:e.target.checked})))}}),(0,he.jsx)(_e.InlineSwitch,{id:`sql-preview-${h}`,label:"Preview","data-testid":Pe.components.SQLQueryEditor.headerPreviewSwitch,transparent:!0,showLabel:!0,value:s.preview,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_preview_toggled",{datasource:null===(t=l.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(Rt(wt({},s),{preview:e.target.checked})))}})]}),(0,he.jsx)(Je,{grow:1}),r?(0,he.jsx)(_e.Button,{icon:"play",variant:"primary",size:"sm",onClick:()=>i(),children:"Run query"}):(0,he.jsx)(_e.Tooltip,{theme:"error",content:(0,he.jsxs)(he.Fragment,{children:["Your query is invalid. Check below for details. ",(0,he.jsx)("br",{}),"However, you can still run this query."]}),placement:"top",children:(0,he.jsx)(_e.Button,{icon:"exclamation-triangle",variant:"secondary",size:"sm",onClick:()=>i(),children:"Run query"})}),(0,he.jsx)(_e.RadioButtonGroup,{options:It,size:"sm",value:u,onChange:g}),(0,he.jsx)(ht,{isOpen:p,onCopy:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=l.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"copy"}),f(!1),d(l.rawSql),n(Rt(wt({},l),{rawSql:v(l),editorMode:de.Builder}))},onDiscard:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=l.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"discard"}),f(!1),n(Rt(wt({},l),{rawSql:v(l),editorMode:de.Builder}))},onCancel:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=l.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"cancel"}),f(!1)}})]}),u===de.Builder&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(_e.Space,{v:.5}),(0,he.jsxs)(ot,{children:["influx"!==t&&!(!yt()&&"postgres"===t)&&(0,he.jsx)(ft,{label:"Dataset",width:25,children:(0,he.jsx)(Et,{db:e,inputId:`sql-dataset-${h}`,dataset:l.dataset,dialect:t,preconfiguredDataset:a,onChange:e=>{if(e.value===l.dataset)return;const t=Rt(wt({},l),{dataset:e.value,table:void 0,sql:void 0,rawSql:""});n(t)}})}),(0,he.jsx)(ft,{label:"Table",width:25,children:(0,he.jsx)(Tt,{db:e,inputId:`sql-tableselect-${h}`,dataset:l.dataset||a,table:l.table,onChange:e=>{if(e.value===l.table)return;const t=Rt(wt({},l),{table:e.value,sql:void 0,rawSql:""});n(t)}})})]})]})]})}var Ct=function(){},Nt="undefined"!=typeof window;const Lt=Nt?ge.useLayoutEffect:ge.useEffect;var jt={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};const xt=Nt&&void 0!==window.ResizeObserver?function(){var e=(0,ge.useState)(null),t=e[0],r=e[1],n=(0,ge.useState)(jt),o=n[0],i=n[1],a=(0,ge.useMemo)((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,a=t.height,l=t.top,s=t.left,u=t.bottom,c=t.right;i({x:r,y:n,width:o,height:a,top:l,left:s,bottom:u,right:c})}}))}),[]);return Lt((function(){if(t)return a.observe(t),function(){a.disconnect()}}),[t]),[r,o]}:function(){return[Ct,jt]};let Pt;Pt="undefined"!=typeof window?window:"undefined"!=typeof self?self:p.g;let Ft=null,Dt=null;const kt=Pt.clearTimeout,Mt=Pt.setTimeout,Vt=Pt.cancelAnimationFrame||Pt.mozCancelAnimationFrame||Pt.webkitCancelAnimationFrame,Ut=Pt.requestAnimationFrame||Pt.mozRequestAnimationFrame||Pt.webkitRequestAnimationFrame;null==Vt||null==Ut?(Ft=kt,Dt=function(e){return Mt(e,20)}):(Ft=function([e,t]){Vt(e),kt(t)},Dt=function(e){const t=Ut((function(){kt(r),e()})),r=Mt((function(){Vt(t),e()}),20);return[t,r]});class Bt extends ge.Component{constructor(...e){super(...e),this.state={height:this.props.defaultHeight||0,scaledHeight:this.props.defaultHeight||0,scaledWidth:this.props.defaultWidth||0,width:this.props.defaultWidth||0},this._autoSizer=null,this._detectElementResize=null,this._parentNode=null,this._resizeObserver=null,this._timeoutId=null,this._onResize=()=>{this._timeoutId=null;const{disableHeight:e,disableWidth:t,onResize:r}=this.props;if(this._parentNode){const n=window.getComputedStyle(this._parentNode)||{},o=parseFloat(n.paddingLeft||"0"),i=parseFloat(n.paddingRight||"0"),a=parseFloat(n.paddingTop||"0"),l=parseFloat(n.paddingBottom||"0"),s=this._parentNode.getBoundingClientRect(),u=s.height-a-l,c=s.width-o-i,d=this._parentNode.offsetHeight-a-l,p=this._parentNode.offsetWidth-o-i;(e||this.state.height===d&&this.state.scaledHeight===u)&&(t||this.state.width===p&&this.state.scaledWidth===c)||(this.setState({height:d,width:p,scaledHeight:u,scaledWidth:c}),"function"==typeof r&&r({height:d,scaledHeight:u,scaledWidth:c,width:p}))}},this._setRef=e=>{this._autoSizer=e}}componentDidMount(){const{nonce:e}=this.props,t=this._autoSizer?this._autoSizer.parentNode:null;if(null!=t&&t.ownerDocument&&t.ownerDocument.defaultView&&t instanceof t.ownerDocument.defaultView.HTMLElement){this._parentNode=t;const r=t.ownerDocument.defaultView.ResizeObserver;null!=r?(this._resizeObserver=new r((()=>{this._timeoutId=setTimeout(this._onResize,0)})),this._resizeObserver.observe(t)):(this._detectElementResize=function(e){let t,r,n,o,i,a,l;const s="undefined"!=typeof document&&document.attachEvent;if(!s){a=function(e){const t=e.__resizeTriggers__,r=t.firstElementChild,n=t.lastElementChild,o=r.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,o.style.width=r.offsetWidth+1+"px",o.style.height=r.offsetHeight+1+"px",r.scrollLeft=r.scrollWidth,r.scrollTop=r.scrollHeight},i=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height},l=function(e){if(e.target.className&&"function"==typeof e.target.className.indexOf&&e.target.className.indexOf("contract-trigger")<0&&e.target.className.indexOf("expand-trigger")<0)return;const t=this;a(this),this.__resizeRAF__&&Ft(this.__resizeRAF__),this.__resizeRAF__=Dt((function(){i(t)&&(t.__resizeLast__.width=t.offsetWidth,t.__resizeLast__.height=t.offsetHeight,t.__resizeListeners__.forEach((function(r){r.call(t,e)})))}))};let e=!1,s="";n="animationstart";const u="Webkit Moz O ms".split(" ");let c="webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "),d="";{const t=document.createElement("fakeelement");if(void 0!==t.style.animationName&&(e=!0),!1===e)for(let r=0;r<u.length;r++)if(void 0!==t.style[u[r]+"AnimationName"]){d=u[r],s="-"+d.toLowerCase()+"-",n=c[r],e=!0;break}}r="resizeanim",t="@"+s+"keyframes "+r+" { from { opacity: 0; } to { opacity: 0; } } ",o=s+"animation: 1ms "+r+"; "}return{addResizeListener:function(i,u){if(s)i.attachEvent("onresize",u);else{if(!i.__resizeTriggers__){const s=i.ownerDocument,u=Pt.getComputedStyle(i);u&&"static"===u.position&&(i.style.position="relative"),function(r){if(!r.getElementById("detectElementResize")){const n=(t||"")+".resize-triggers { "+(o||"")+'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',i=r.head||r.getElementsByTagName("head")[0],a=r.createElement("style");a.id="detectElementResize",a.type="text/css",null!=e&&a.setAttribute("nonce",e),a.styleSheet?a.styleSheet.cssText=n:a.appendChild(r.createTextNode(n)),i.appendChild(a)}}(s),i.__resizeLast__={},i.__resizeListeners__=[],(i.__resizeTriggers__=s.createElement("div")).className="resize-triggers";const c=s.createElement("div");c.className="expand-trigger",c.appendChild(s.createElement("div"));const d=s.createElement("div");d.className="contract-trigger",i.__resizeTriggers__.appendChild(c),i.__resizeTriggers__.appendChild(d),i.appendChild(i.__resizeTriggers__),a(i),i.addEventListener("scroll",l,!0),n&&(i.__resizeTriggers__.__animationListener__=function(e){e.animationName===r&&a(i)},i.__resizeTriggers__.addEventListener(n,i.__resizeTriggers__.__animationListener__))}i.__resizeListeners__.push(u)}},removeResizeListener:function(e,t){if(s)e.detachEvent("onresize",t);else if(e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(t),1),!e.__resizeListeners__.length){e.removeEventListener("scroll",l,!0),e.__resizeTriggers__.__animationListener__&&(e.__resizeTriggers__.removeEventListener(n,e.__resizeTriggers__.__animationListener__),e.__resizeTriggers__.__animationListener__=null);try{e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__)}catch(e){}}}}}(e),this._detectElementResize.addResizeListener(t,this._onResize)),this._onResize()}}componentWillUnmount(){this._parentNode&&(this._detectElementResize&&this._detectElementResize.removeResizeListener(this._parentNode,this._onResize),null!==this._timeoutId&&clearTimeout(this._timeoutId),this._resizeObserver&&this._resizeObserver.disconnect())}render(){const{children:e,defaultHeight:t,defaultWidth:r,disableHeight:n=!1,disableWidth:o=!1,doNotBailOutOnEmptyChildren:i=!1,nonce:a,onResize:l,style:s={},tagName:u="div",...c}=this.props,{height:d,scaledHeight:p,scaledWidth:f,width:v}=this.state,h={overflow:"visible"},g={};let y=!1;return n||(0===d&&(y=!0),h.height=0,g.height=d,g.scaledHeight=p),o||(0===v&&(y=!0),h.width=0,g.width=v,g.scaledWidth=f),i&&(y=!1),(0,ge.createElement)(u,{ref:this._setRef,style:{...h,...s},...c},!y&&e(g))}}var Gt=Object.defineProperty,qt=Object.getOwnPropertySymbols,Kt=Object.prototype.hasOwnProperty,Wt=Object.prototype.propertyIsEnumerable,zt=(e,t,r)=>t in e?Gt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Ht=(e,t,r={})=>((e,t)=>{for(var r in t||(t={}))Kt.call(t,r)&&zt(e,r,t[r]);if(qt)for(var r of qt(t))Wt.call(t,r)&&zt(e,r,t[r]);return e})({label:e,insertText:e,kind:ue.Field,sortText:se.Medium,range:t},r);var $t=Object.defineProperty,Yt=Object.defineProperties,Qt=Object.getOwnPropertyDescriptors,Xt=Object.getOwnPropertySymbols,Jt=Object.prototype.hasOwnProperty,Zt=Object.prototype.propertyIsEnumerable,er=(e,t,r)=>t in e?$t(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,tr=(e,t)=>{for(var r in t||(t={}))Jt.call(t,r)&&er(e,r,t[r]);if(Xt)for(var r of Xt(t))Zt.call(t,r)&&er(e,r,t[r]);return e};const rr=()=>[{id:ae.SelectKeyword,name:ae.SelectKeyword,kind:[le.SelectKeyword]},{id:ae.WithKeyword,name:ae.WithKeyword,kind:[le.WithKeyword]},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,kind:[le.StarWildCard,le.FunctionsWithArguments,le.Columns,le.SelectMacro]},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,kind:[le.Columns]},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,kind:[le.Columns]},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,kind:[le.Columns]},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,kind:[le.Columns]},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,kind:[le.Schemas,le.Tables,le.TableMacro]},{id:ae.AfterSchema,name:ae.AfterSchema,kind:[le.Tables,le.TableMacro]},{id:ae.SelectAlias,name:ae.SelectAlias,kind:[le.Columns,le.FunctionsWithArguments]},{id:ae.FromKeyword,name:ae.FromKeyword,kind:[le.FromKeyword]},{id:ae.AfterFrom,name:ae.AfterFrom,kind:[le.WhereKeyword,le.GroupByKeywords,le.OrderByKeywords,le.LimitKeyword]},{id:ae.AfterTable,name:ae.AfterTable,kind:[le.WhereKeyword,le.GroupByKeywords,le.OrderByKeywords,le.LimitKeyword]},{id:ae.WhereKeyword,name:ae.WhereKeyword,kind:[le.Columns,le.FilterMacro,le.TemplateVariables]},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,kind:[le.ComparisonOperators]},{id:ae.WhereValue,name:ae.WhereValue,kind:[le.FilterMacro,le.TemplateVariables]},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,kind:[le.LogicalOperators,le.GroupByKeywords,le.OrderByKeywords,le.LimitKeyword,le.Columns,le.TemplateVariables]},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,kind:[le.GroupMacro,le.Columns]},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,kind:[le.OrderByKeywords,le.LimitKeyword]},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,kind:[le.Columns]},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,kind:[le.SortOrderDirectionKeyword,le.LimitKeyword]},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,kind:[le.LimitKeyword]},{id:ae.AfterIsOperator,name:ae.AfterOrderByDirection,kind:[le.NotKeyword,le.NullValue,le.BoolValues]},{id:ae.AfterIsNotOperator,name:ae.AfterOrderByDirection,kind:[le.NullValue,le.BoolValues]}];class nr{constructor(e,t,r,n,o){this.type=e,this.value=t,this.range=r,this.previous=n,this.next=o}isKeyword(){return this.type===ie.Keyword}isWhiteSpace(){return this.type===ie.Whitespace}isParenthesis(){return this.type===ie.Parenthesis}isIdentifier(){return this.type===ie.Identifier}isString(){return this.type===ie.String}isNumber(){return this.type===ie.Number}isDoubleQuotedString(){return this.type===ie.Type}isVariable(){return this.type===ie.Variable}isFunction(){return this.type===ie.Function}isOperator(){return this.type===ie.Operator}isTemplateVariable(){return this.type===ie.Variable}is(e,t){const r=this.type===e;return void 0!==t?r&&or(e,this,t):r}getPreviousNonWhiteSpaceToken(){let e=this.previous;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.previous}return null}getPreviousOfType(e,t){let r=this.previous;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&or(e,r,t):n)return r;r=r.previous}return null}getPreviousUntil(e,t,r){let n=[],o=this.previous;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.previous;continue}const i=o.type===e;if(void 0!==r?i&&or(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.previous}return n}getNextUntil(e,t,r){let n=[],o=this.next;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.next;continue}const i=o.type===e;if(void 0!==r?i&&or(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.next}return n}getPreviousKeyword(){let e=this.previous;for(;null!=e;){if(e.isKeyword())return e;e=e.previous}return null}getNextNonWhiteSpaceToken(){let e=this.next;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.next}return null}getNextOfType(e,t){let r=this.next;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&or(e,r,t):n)return r;r=r.next}return null}}function or(e,t,r){return e===ie.Keyword||e===ie.Operator?t.value.toLowerCase()===r.toString().toLowerCase():t.value===r}var ir=p(8572);const ar=e=>{var t;const r=(e=>{const t=(e=>{var t;return null!=(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,ir.SELECT))?t:null})(e);return null==t?void 0:t.getNextOfType(ie.Keyword,ir.FROM)})(e),n=null==r?void 0:r.getNextNonWhiteSpaceToken();return(null==n?void 0:n.isVariable())||(null==n?void 0:n.isKeyword())&&(null==(t=n.next)?void 0:t.is(ie.Parenthesis,"("))?null:n},lr=e=>{const t=null==e?void 0:e.value.split(".");return 1===(null==t?void 0:t.length)?{table:t[0]}:2===(null==t?void 0:t.length)?{schema:t[0],table:t[1]}:null},sr={id:"editor.action.triggerSuggest",title:""};var ur,cr=new Uint8Array(16);function dr(){if(!ur&&!(ur="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return ur(cr)}const pr=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var fr=[],vr=0;vr<256;++vr)fr.push((vr+256).toString(16).substr(1));const hr=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(fr[e[t+0]]+fr[e[t+1]]+fr[e[t+2]]+fr[e[t+3]]+"-"+fr[e[t+4]]+fr[e[t+5]]+"-"+fr[e[t+6]]+fr[e[t+7]]+"-"+fr[e[t+8]]+fr[e[t+9]]+"-"+fr[e[t+10]]+fr[e[t+11]]+fr[e[t+12]]+fr[e[t+13]]+fr[e[t+14]]+fr[e[t+15]]).toLowerCase();if(!function(e){return"string"==typeof e&&pr.test(e)}(r))throw TypeError("Stringified UUID is invalid");return r},gr=function(e,t,r){var n=(e=e||{}).random||(e.rng||dr)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t){r=r||0;for(var o=0;o<16;++o)t[r+o]=n[o];return t}return hr(n)},yr=(e,t,r)=>()=>[{id:le.SelectKeyword,name:le.SelectKeyword,suggestions:(e,t)=>Promise.resolve([{label:"SELECT <column>",insertText:"SELECT $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:sr,sortText:se.Medium},{label:"SELECT <column> FROM <table>",insertText:"SELECT $2 FROM $1",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:sr,sortText:se.Medium}])},{id:le.TemplateVariables,name:le.TemplateVariables,suggestions:(e,t)=>{const r=(0,pe.getTemplateSrv)();return r?Promise.resolve(r.getVariables().map((e=>{const t=`$${e.name}`,n=r.replace(t);return{label:t,detail:`(Template Variable) ${n}`,kind:ue.Snippet,documentation:`(Template Variable) ${n}`,insertText:`\\$${e.name} `,insertTextRules:ce.InsertAsSnippet,command:sr,sortText:se.Low}}))):Promise.resolve([])}},{id:le.SelectMacro,name:le.SelectMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Value||e.type===oe.Column)).map(mr)])},{id:le.TableMacro,name:le.TableMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Table)).map(mr)])},{id:le.GroupMacro,name:le.GroupMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Group)).map(mr)])},{id:le.FilterMacro,name:le.FilterMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Filter)).map(mr)])},{id:le.WithKeyword,name:le.WithKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WITH <alias> AS ( ... )",insertText:"WITH $1  AS ( $2 )",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:sr,sortText:se.Medium}])},{id:le.StarWildCard,name:le.StarWildCard,suggestions:(e,t)=>Promise.resolve([{label:"*",insertText:"* $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Field,command:sr,sortText:se.High}])},{id:le.FunctionsWithArguments,name:le.FunctionsWithArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}($0)`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:sr,sortText:se.MediumLow})))])},{id:le.FunctionsWithoutArguments,name:le.FunctionsWithoutArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}()`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:sr,sortText:se.MediumHigh})))])},{id:le.FromKeyword,name:le.FromKeyword,suggestions:(e,t)=>Promise.resolve([{label:"FROM",insertText:"FROM $0",command:sr,insertTextRules:ce.InsertAsSnippet,kind:ue.Keyword}])},{id:le.Schemas,name:le.Schemas,suggestions:(e,t)=>Promise.resolve([])},{id:le.Tables,name:le.Tables,suggestions:(e,t)=>Promise.resolve([])},{id:le.Columns,name:le.Columns,suggestions:(e,t)=>Promise.resolve([])},{id:le.LogicalOperators,name:le.LogicalOperators,suggestions:(e,r)=>Promise.resolve(t.list().filter((e=>e.type===ne.Logical)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:sr,sortText:se.MediumHigh,kind:ue.Operator}))))},{id:le.WhereKeyword,name:le.WhereKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WHERE",insertText:"WHERE ",command:sr,sortText:se.MediumHigh,kind:ue.Keyword}])},{id:le.ComparisonOperators,name:le.ComparisonOperators,suggestions:(e,r)=>Promise.resolve([...t.list().filter((e=>e.type===ne.Comparison)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:sr,sortText:se.MediumHigh,kind:ue.Operator}))),{label:"IN (...)",insertText:"IN ( $0 )",command:sr,sortText:se.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"NOT IN (...)",insertText:"NOT IN ( $0 )",command:sr,sortText:se.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"IS",insertText:"IS",command:sr,sortText:se.Medium,kind:ue.Operator},{label:"IS NOT",insertText:"IS NOT",command:sr,sortText:se.Medium,kind:ue.Operator}])},{id:le.GroupByKeywords,name:le.GroupByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"GROUP BY",insertText:"GROUP BY ",command:sr,sortText:se.MediumHigh,kind:ue.Keyword}])},{id:le.OrderByKeywords,name:le.OrderByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"ORDER BY",insertText:"ORDER BY ",command:sr,sortText:se.Medium,kind:ue.Keyword},{label:"ORDER BY(ascending)",insertText:"ORDER BY $1 ASC ",command:sr,sortText:se.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet},{label:"ORDER BY(descending)",insertText:"ORDER BY $1 DESC",command:sr,sortText:se.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet}])},{id:le.LimitKeyword,name:le.LimitKeyword,suggestions:(e,t)=>Promise.resolve([{label:"LIMIT",insertText:"LIMIT ",command:sr,sortText:se.MediumLow,kind:ue.Keyword}])},{id:le.SortOrderDirectionKeyword,name:le.SortOrderDirectionKeyword,suggestions:(e,t)=>Promise.resolve([ir.ASC,ir.DESC].map((e=>({label:e,insertText:`${e} `,command:sr,kind:ue.Keyword}))))},{id:le.NotKeyword,name:le.NotKeyword,suggestions:()=>Promise.resolve([{label:"NOT",insertText:"NOT",command:sr,kind:ue.Keyword,sortText:se.High}])},{id:le.BoolValues,name:le.BoolValues,suggestions:()=>Promise.resolve(["TRUE","FALSE"].map((e=>({label:e,insertText:`${e}`,command:sr,kind:ue.Keyword,sortText:se.Medium}))))},{id:le.NullValue,name:le.NullValue,suggestions:()=>Promise.resolve(["NULL"].map((e=>({label:e,insertText:`${e}`,command:sr,kind:ue.Keyword,sortText:se.Low}))))}];function mr(e){return{label:e.name,insertText:`${"\\"+e.text}${t=e.args,t?"(".concat(t.map(((e,t)=>`\${${t}:${e}}`)).join(", ")).concat(")"):"()"} `,insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,documentation:e.description,command:sr};var t}function br(){return[{id:ae.SelectKeyword,name:ae.SelectKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,ir.SELECT)||e.is(ie.Keyword,ir.SELECT)&&null===e.previous||n||e.isIdentifier()&&(n||null===(null==e?void 0:e.previous))||e.isIdentifier()&&ir.SELECT.startsWith(e.value.toLowerCase()))},{id:ae.WithKeyword,name:ae.WithKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,ir.WITH)&&null===e.previous||e.isIdentifier()&&ir.WITH.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,resolve:(e,t,r,n)=>Boolean((null==r?void 0:r.value.toLowerCase())===ir.SELECT)},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.SELECT&&","===(null==r?void 0:r.value))},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,resolve:(e,t,r,n)=>Boolean(((null==t?void 0:t.value.toLowerCase())===ir.SELECT||(null==t?void 0:t.value.toLowerCase())===ir.AS)&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,ir.WHERE))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,ir.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,ir.GROUP))&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))))}},{id:ae.SelectAlias,name:ae.SelectAlias,resolve:(e,t,r,n)=>","===(null==r?void 0:r.value)&&(null==t?void 0:t.value.toLowerCase())===ir.AS},{id:ae.FromKeyword,name:ae.FromKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.SELECT&&","!==(null==r?void 0:r.value)||((null==e?void 0:e.isKeyword())||(null==e?void 0:e.isIdentifier()))&&ir.FROM.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,resolve:(e,t,r,n)=>Boolean(!(null==e?void 0:e.value.includes("."))&&(null==r?void 0:r.value.toLowerCase())===ir.FROM)},{id:ae.AfterSchema,name:ae.AfterSchema,resolve:(e,t,r,n)=>((null==e?void 0:e.isWhiteSpace())&&(null==e?void 0:e.next)&&(r=(e=null==e?void 0:e.previous).getPreviousNonWhiteSpaceToken()),Boolean((null==e?void 0:e.isIdentifier())&&(null==e?void 0:e.value.endsWith("."))&&(null==r?void 0:r.value.toLowerCase())===ir.FROM))},{id:ae.AfterFrom,name:ae.AfterFrom,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.FROM&&(null==r?void 0:r.isDoubleQuotedString())||(null==t?void 0:t.value.toLowerCase())===ir.FROM&&(null==r?void 0:r.isIdentifier())||(null==t?void 0:t.value.toLowerCase())===ir.FROM&&(null==r?void 0:r.isVariable()))},{id:ae.AfterTable,name:ae.AfterTable,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.FROM&&((null==r?void 0:r.isVariable())||""!==(null==r?void 0:r.value)&&(null==r?void 0:r.value.toLowerCase())!==ir.FROM))},{id:ae.WhereKeyword,name:ae.WhereKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.WHERE&&((null==r?void 0:r.isKeyword())||(null==r?void 0:r.is(ie.Parenthesis,"("))||(null==r?void 0:r.is(ie.Operator,ir.AND))))},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.value.toLowerCase())===ir.WHERE&&!(null==(o=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:o.isOperator())&&!(null==e?void 0:e.is(ie.Delimiter,"."))&&!(null==e?void 0:e.isParenthesis())&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())))}},{id:ae.WhereValue,name:ae.WhereValue,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===ir.WHERE&&(null==r?void 0:r.isOperator()))},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,resolve:(e,t,r,n)=>{var o,i,a;return Boolean((null==t?void 0:t.value.toLowerCase())===ir.WHERE&&((null==r?void 0:r.is(ie.Operator,"and"))||(null==r?void 0:r.is(ie.Operator,"or"))||(null==r?void 0:r.isString())||(null==r?void 0:r.isNumber())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))||(null==r?void 0:r.isTemplateVariable())||(null==r?void 0:r.is(ie.IdentifierQuote))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Identifier))&&(null==(a=null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.getPreviousNonWhiteSpaceToken())?void 0:a.is(ie.IdentifierQuote))))}},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,ir.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,ir.GROUP))&&((null==r?void 0:r.is(ie.Keyword,ir.BY))||(null==r?void 0:r.is(ie.Delimiter,","))))}},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,ir.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,ir.GROUP))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))}},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Keyword,ir.BY))&&(null==(o=null==r?void 0:r.getPreviousKeyword())?void 0:o.is(ie.Keyword,ir.ORDER)))}},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,resolve:(e,t,r,n)=>{var o,i;return Boolean((null==t?void 0:t.is(ie.Keyword,ir.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,ir.ORDER))&&(null==r?void 0:r.is(ie.Parenthesis))&&(null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.is(ie.Function)))}},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,ir.DESC))||(null==t?void 0:t.is(ie.Keyword,ir.ASC)))},{id:ae.AfterIsOperator,name:ae.AfterIsOperator,resolve:(e,t,r,n)=>Boolean(null==r?void 0:r.is(ie.Operator,"IS"))},{id:ae.AfterIsNotOperator,name:ae.AfterIsNotOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Operator,"NOT"))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Operator,"IS")))}}]}let Er={logger:()=>{}},Or=()=>{};_e.attachDebugger&&_e.createLogger&&(Er=(0,_e.createLogger)("SQLEditor"),Or=Er.logger,(0,_e.attachDebugger)("sqleditor",void 0,Er));const Sr="column",Tr=[{id:"$__timeFilter(dateColumn)",name:"$__timeFilter(dateColumn)",text:"$__timeFilter",args:[Sr],type:oe.Filter,description:"Will be replaced by a time range filter using the specified column name. For example, dateColumn BETWEEN FROM_UNIXTIME(1494410783) AND FROM_UNIXTIME(1494410983)"},{id:"$__timeFrom()",name:"$__timeFrom()",text:"$__timeFrom",args:[],type:oe.Filter,description:"Will be replaced by the start of the currently active time selection. For example, FROM_UNIXTIME(1494410783)"},{id:"$__timeTo()",name:"$__timeTo()",text:"$__timeTo",args:[],type:oe.Filter,description:"Will be replaced by the end of the currently active time selection. For example, FROM_UNIXTIME(1494410983)"},{id:"$__timeGroup(dateColumn, '5m')",name:"$__timeGroup(dateColumn, '5m')",text:"$__timeGroup",args:[Sr,"'5m'"],type:oe.Value,description:"Will be replaced by an expression usable in GROUP BY clause. For example, *cast(cast(UNIX_TIMESTAMP(dateColumn)/(300) as signed)*300 as signed),*"},{id:"$__table",name:"$__table",text:"$__table",args:[],type:oe.Table,description:"Will be replaced by the query table."},{id:"$__column",name:"$__column",text:"$__column",args:[],type:oe.Column,description:"Will be replaced by the query column."}];function _r(e,t){var r,n,o;const i={triggerCharacters:["."," ","$",",","(","'"]};t&&Array.isArray(t.builtinFunctions)&&(i.supportedFunctions=()=>t.builtinFunctions.map((e=>({id:e,name:e}))));const a=[];return(null==(r=null==t?void 0:t.comparisonOperators)?void 0:r.length)&&a.push(...t.comparisonOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Comparison})))),t.logicalOperators=null!=(n=t.logicalOperators)?n:t.operators,(null==(o=null==t?void 0:t.logicalOperators)?void 0:o.length)&&a.push(...t.logicalOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Logical})))),i.supportedOperators=()=>a,i.supportedMacros=()=>Tr,i}const wr={id:"standardSql",extensions:[".sql"],aliases:["sql"],mimetypes:[],loader:()=>Promise.resolve().then(p.bind(p,8572)),completionProvider:_r};var Rr=Object.defineProperty,Ir=Object.defineProperties,Ar=Object.getOwnPropertyDescriptors,Cr=Object.getOwnPropertySymbols,Nr=Object.prototype.hasOwnProperty,Lr=Object.prototype.propertyIsEnumerable,jr=(e,t,r)=>t in e?Rr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,xr=(e,t)=>{for(var r in t||(t={}))Nr.call(t,r)&&jr(e,r,t[r]);if(Cr)for(var r of Cr(t))Lr.call(t,r)&&jr(e,r,t[r]);return e},Pr=(e,t)=>Ir(e,Ar(t));const Fr=new Map,Dr=new Map,kr=({children:e,onBlur:t,onChange:r,query:n,language:o={id:"sql"},width:i,height:a})=>{const l=(0,ge.useRef)(null),s=(0,ge.useRef)(),u=(0,ge.useMemo)((()=>{const e=gr(),t=`${o.id}-${e}`;return s.current=t,t}),[o.id]);(0,ge.useEffect)((()=>()=>{s.current&&Dr.delete(s.current),Or(`Removing instance cache ${s.current}`,!1,Dr)}),[]);const c=(0,ge.useCallback)((()=>{l.current&&l.current.getAction("editor.action.formatDocument").run()}),[]);return ye().createElement("div",{style:{width:i}},ye().createElement(_e.CodeEditor,{height:a||"240px",width:i?i-2+"px":void 0,language:u,value:n,onBlur:e=>{r&&r(e,!1),t&&t(e)},showMiniMap:!1,showLineNumbers:!0,onEditorDidMount:(e,t)=>{l.current=e,e.onDidChangeModelContent((t=>{const n=e.getValue();r&&r(n,!1)})),e.addCommand(t.KeyMod.CtrlCmd|t.KeyCode.Enter,(()=>{const t=e.getValue();r&&r(t,!0)})),e.onKeyUp((t=>{84===t.keyCode&&e.trigger(sr.id,sr.id,{})})),Mr(t,o,u)}}),e&&e({formatQuery:c}))},Mr=async(e,t,r)=>{const n=((e,t)=>{if("sql"!==(null==t?void 0:t.id)&&!t.loader){Or(`Loading language '${null==t?void 0:t.id}' from Monaco registry`,!1);const r=e.languages.getLanguages().find((({id:e})=>e===(null==t?void 0:t.id)));if(!r)throw Error(`Unknown Monaco language ${null==t?void 0:t.id}`);return xr(xr({completionProvider:_r},r),t)}return xr(xr({},wr),t)})(e,t);if(!n.loader)return;const{language:o,conf:i}=await n.loader(e);if(e.languages.register({id:r}),e.languages.setMonarchTokensProvider(r,xr({},o)),e.languages.setLanguageConfiguration(r,xr({},i)),n.formatter&&e.languages.registerDocumentFormattingEditProvider(r,{provideDocumentFormattingEdits:e=>{var r;const n=null==(r=t.formatter)?void 0:r.call(t,e.getValue());return[{range:e.getFullModelRange(),text:n||""}]}}),n.completionProvider){const i=n.completionProvider(e,o);!function(e,t,r){var n;Fr.has(e)||function(e){Fr.has(e)||Fr.set(e,{functions:new T.Registry,operators:new T.Registry,suggestionKinds:new T.Registry(rr),positionResolvers:new T.Registry(br),macros:new T.Registry}),Fr.get(e)}(e);const o=Fr.get(e);Dr.has(t)||Dr.set(t,new T.Registry(yr(o.functions,o.operators,o.macros)));const i=Dr.get(t);if(r.supportedFunctions)for(const e of r.supportedFunctions())o.functions.getIfExists(e.id)||o.functions.register(e);if(r.supportedOperators)for(const e of r.supportedOperators())o.operators.getIfExists(e.id)||o.operators.register(Pr(xr({},e),{name:e.id}));if(r.supportedMacros)for(const e of r.supportedMacros())o.macros.getIfExists(e.id)||o.macros.register(Pr(xr({},e),{name:e.id}));if(r.customStatementPlacement)for(const e of r.customStatementPlacement()){const t=o.positionResolvers.getIfExists(e.id);if(t){const r=t.resolve;t.resolve=(...t)=>{const n=e.resolve(...t);return e.overrideDefault?n:r(...t)||n}}else o.positionResolvers.register(Pr(xr({},e),{id:e.id,name:e.id})),o.suggestionKinds.register({id:e.id,name:e.id,kind:[]})}if(r.customSuggestionKinds)for(const e of r.customSuggestionKinds()){if(null==(n=e.applyTo)||n.forEach((t=>{const r=o.suggestionKinds.getIfExists(t);r&&-1===r.kind.indexOf(e.id)&&r.kind.push(e.id)})),e.overrideDefault){const t=i.get(e.id);if(void 0!==t){t.suggestions=e.suggestionsResolver;continue}}i.register({id:e.id,name:e.id,suggestions:e.suggestionsResolver})}if(r.schemas){const e=i.get(le.Schemas),t=e.suggestions;e.suggestions=async(e,n)=>{const o=await t(e,n);if(!r.schemas)return[...o];const i=(await r.schemas.resolve()).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}.`,command:sr,kind:ue.Module,sortText:se.High}}));return[...o,...i]}}if(r.tables){const e=i.get(le.Tables),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a,l,s;const u=await t(e,n),c=ar(e.currentToken),d=(null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:lr)(c);return[...u,...(null!=(s=await(null==(l=null==(a=r.tables)?void 0:a.resolve)?void 0:l.call(a,d)))?s:[]).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}${e.completion===e.name?" $0":""}`,insertTextRules:ce.InsertAsSnippet,command:sr,kind:ue.Field,sortText:se.MediumHigh}}))]}}if(r.columns){const e=i.get(le.Columns),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a;const l=await t(e,n),s=ar(e.currentToken);let u;const c=null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:lr;s&&s.value&&(u=c(s));let d=[];if(u){const e=await(null==(a=r.columns)?void 0:a.resolve(u));d=e?e.map((e=>{var t;return{label:e.name,insertText:null!=(t=e.completion)?t:e.name,kind:ue.Field,sortText:se.High,detail:e.type,documentation:e.description}})):[]}return[...l,...d]}}}(t.id,r,i);const a=Fr.get(t.id),l=Dr.get(r),s=async(t,n,o,i)=>{const s=function(e,t,r,n="sql"){var o;let i=null,a=null;const l=e.editor.tokenize(null!=(o=t.getValue())?o:"",n);for(let o=0;o<l.length;o++){const s=l[o];if(!s.length&&a){const e={offset:0,type:ie.Whitespace,language:n,_tokenBrand:void 0};s.push(e)}for(let n=0;n<s.length;n++){const l=s[n];let u=s.length>n+1?s[n+1].offset+1:t.getLineLength(o+1)+1;const c={startLineNumber:o+1,startColumn:0===l.offset?0:l.offset+1,endLineNumber:o+1,endColumn:u},d=t.getValueInRange(c),p=new nr(l.type,d,c,a,null);e.Range.containsPosition(c,r)&&(i=p),a&&(a.next=p),a=p}}return i}(e,t,n,r),u=function(e,t){var r;const n=null==e?void 0:e.getPreviousNonWhiteSpaceToken(),o=null==e?void 0:e.getPreviousKeyword(),i=null==(r=null==e?void 0:e.getPreviousNonWhiteSpaceToken())?void 0:r.is(ie.Operator,"/"),a=t.list(),l=[];for(const t of a)t.resolve(e,null!=o?o:null,null!=n?n:null,Boolean(i))&&l.push(t.id);return 0===l.length?[ae.Unknown]:l}(s,a.positionResolvers),c=function(e,t){let r=[];for(let n=0;n<e.length;n++){const o=t.getIfExists(e[n]);o&&(r=r.concat(o.kind))}return r}(u,a.suggestionKinds);Or("Statement position",!1,u),Or("Suggestion kinds",!1,c);const d={position:n,currentToken:s,statementPosition:u,kind:c,range:e.Range.fromPositions(n)},p=await(async(e,t,r,n,o)=>{let i=[];const a=(null==t?void 0:t.isWhiteSpace())||(null==t?void 0:t.isParenthesis())||(null==t?void 0:t.isIdentifier())&&t.value.endsWith(".")||!(null==t?void 0:t.range)?e.Range.fromPositions(n.position):null==t?void 0:t.range;for(const t of[...new Set(r)]){const r=o.getIfExists(t);if(r){const t=await r.suggestions((l=tr({},n),s={range:a},Yt(l,Qt(s))),e);i=[...i,...t.map((e=>Ht(e.label,a,tr({kind:e.kind},e))))]}}var l,s;return Promise.resolve(i)})(e,s,c,d,l);return{suggestions:p}};e.languages.registerCompletionItemProvider(r,Pr(xr({},i),{provideCompletionItems:s}))}};function Vr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Ur({children:e,onChange:t,query:r,width:n,height:o,editorLanguageDefinition:i}){const a=(0,ge.useRef)(r);(0,ge.useEffect)((()=>{a.current=r}),[r]);const l=(0,ge.useCallback)(((e,r)=>{const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Vr(e,t,r[t])}))}return e}({},a.current),i=null!=(i={rawQuery:!0,rawSql:e})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;t(n,r)}),[t]);return(0,he.jsx)(kr,{width:n,height:o,query:r.rawSql,onChange:l,language:i,children:e})}var Br=p(990);function Gr(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function qr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Gr(i,n,o,a,l,"next",e)}function l(e){Gr(i,n,o,a,l,"throw",e)}a(void 0)}))}}function Kr({db:e,query:t,onValidate:r,range:n}){var o;const[i,a]=(0,ge.useState)(),l=(0,_e.useTheme2)(),s=(0,ge.useMemo)((()=>(0,T.getValueFormat)("bytes")),[]),u=(0,ge.useMemo)((()=>({error:(0,Fe.css)({color:l.colors.error.text,fontSize:l.typography.bodySmall.fontSize,fontFamily:l.typography.fontFamilyMonospace}),valid:(0,Fe.css)({color:l.colors.success.text}),info:(0,Fe.css)({color:l.colors.text.secondary})})),[l]),[c,d]=Ee((p=qr((function*(t){var r;return""===(null===(r=t.rawSql)||void 0===r?void 0:r.trim())?null:yield e.validateQuery(t,n)})),function(e){return p.apply(this,arguments)}),[e]);var p;const[]=(0,Br.A)(qr((function*(){const e=yield d(t);return e&&a(e),null})),1e3,[t,d]);if((0,ge.useEffect)((()=>{(null==i?void 0:i.isError)&&r(!1),(null==i?void 0:i.isValid)&&r(!0)}),[i,r]),!c.value&&!c.loading)return null;const f=(null===(o=c.value)||void 0===o?void 0:o.error)?function(e){const t=e.split(":");return t.length>2?t.slice(2).join(":"):e}(c.value.error):"";return(0,he.jsxs)(he.Fragment,{children:[c.loading&&(0,he.jsxs)("div",{className:u.info,children:[(0,he.jsx)(_e.Spinner,{inline:!0,size:"xs"})," Validating query..."]}),!c.loading&&c.value&&(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(he.Fragment,{children:c.value.isValid&&c.value.statistics&&(0,he.jsxs)("div",{className:u.valid,children:[(0,he.jsx)(_e.Icon,{name:"check"})," This query will process"," ",(0,he.jsx)("strong",{children:(0,T.formattedValueToString)(s(c.value.statistics.TotalBytesProcessed))})," ","when run."]})}),(0,he.jsx)(he.Fragment,{children:c.value.isError&&(0,he.jsx)("div",{className:u.error,children:f})})]})]})}function Wr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function zr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Wr(e,t,r[t])}))}return e}function Hr(e){var{showTools:t,onFormatCode:r,onExpand:n,isExpanded:o}=e,i=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["showTools","onFormatCode","onExpand","isExpanded"]);const a=(0,_e.useTheme2)(),[l,s]=(0,ge.useState)(),u=(0,ge.useMemo)((()=>({container:(0,Fe.css)({border:`1px solid ${a.colors.border.medium}`,borderTop:"none",padding:a.spacing(.5,.5,.5,.5),display:"flex",flexGrow:1,justifyContent:"space-between",fontSize:a.typography.bodySmall.fontSize}),error:(0,Fe.css)({color:a.colors.error.text,fontSize:a.typography.bodySmall.fontSize,fontFamily:a.typography.fontFamilyMonospace}),valid:(0,Fe.css)({color:a.colors.success.text}),info:(0,Fe.css)({color:a.colors.text.secondary}),hint:(0,Fe.css)({color:a.colors.text.disabled,whiteSpace:"nowrap",cursor:"help"})})),[a]);let c={};return t||void 0!==l||(c={height:0,padding:0,visibility:"hidden"}),(0,he.jsxs)("div",{className:u.container,style:c,children:[(0,he.jsx)("div",{children:i.onValidate&&(0,he.jsx)(Kr,(d=zr({},i),p={onValidate:e=>{s(e),i.onValidate(e)}},p=null!=p?p:{},Object.getOwnPropertyDescriptors?Object.defineProperties(d,Object.getOwnPropertyDescriptors(p)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(p)).forEach((function(e){Object.defineProperty(d,e,Object.getOwnPropertyDescriptor(p,e))})),d))}),t&&(0,he.jsx)("div",{children:(0,he.jsxs)(_e.HorizontalGroup,{spacing:"sm",children:[r&&(0,he.jsx)(_e.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_query_formatted",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type}),r()},name:"brackets-curly",size:"xs",tooltip:"Format query"}),n&&(0,he.jsx)(_e.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type,expanded:!o}),n(!o)},name:o?"angle-up":"angle-down",size:"xs",tooltip:o?"Collapse editor":"Expand editor"}),(0,he.jsx)(_e.Tooltip,{content:"Hit CTRL/CMD+Return to run query",children:(0,he.jsx)(_e.Icon,{className:u.hint,name:"keyboard"})})]})})]});var d,p}function $r({db:e,query:t,onChange:r,onRunQuery:n,onValidate:o,queryToValidate:i,range:a}){const l=(0,_e.useTheme2)(),s=(0,_e.useStyles2)(Yr),[u,c]=(0,ge.useState)(!1),[d,p]=xt(),[f,v]=xt(),h=(0,ge.useMemo)((()=>e.getEditorLanguageDefinition()),[e]),g=(n,l)=>(0,he.jsx)(Ur,{editorLanguageDefinition:h,query:t,width:n,height:l?l-p.height:void 0,onChange:r,children:({formatQuery:t})=>(0,he.jsx)("div",{ref:d,children:(0,he.jsx)(Hr,{db:e,query:i,onValidate:o,onFormatCode:t,showTools:!0,range:a,onExpand:c,isExpanded:u})})}),y=(e=!1)=>e?(0,he.jsx)(Bt,{children:({width:e,height:t})=>g(e,t)}):(0,he.jsx)("div",{ref:f,children:g()});return(0,he.jsxs)(he.Fragment,{children:[u?(0,he.jsx)("div",{style:{width:v.width,height:v.height,background:l.colors.background.primary,display:"flex",alignItems:"center",justifyContent:"center"},children:"Editing in expanded code editor"}):y(),u&&(0,he.jsx)(_e.Modal,{title:`Query ${t.refId}`,closeOnBackdropClick:!1,closeOnEscape:!1,className:s.modal,contentClassName:s.modalContent,isOpen:u,onDismiss:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=t.datasource)||void 0===e?void 0:e.type,expanded:!1}),c(!1)},children:y(!0)})]})}function Yr(e){return{modal:(0,Fe.css)({width:"95vw",height:"95vh"}),modalContent:(0,Fe.css)({height:"100%",paddingTop:0})}}const Qr=({children:e})=>ye().createElement(rt,{gap:.5,direction:"column"},e);var Xr=p(7409);function Jr(e){return Xr.Ay.format(e).replace(/(\$ \{ .* \})|(\$ __)|(\$ \w+)/g,(e=>e.replace(/\s/g,"")))}function Zr({rawSql:e,datasourceType:t}){const[r,n]=je(),o=(0,_e.useStyles2)(en),i=(0,he.jsxs)("div",{className:o.labelWrapper,children:[(0,he.jsx)("span",{className:o.label,children:"Preview"}),(0,he.jsx)(_e.IconButton,{tooltip:"Copy to clipboard",onClick:()=>(e=>{n(e),(0,pe.reportInteraction)("grafana_sql_preview_copied",{datasource:t})})(e),name:"copy"})]});return(0,he.jsx)(_e.Field,{label:i,className:o.grow,children:(0,he.jsx)(_e.CodeEditor,{language:"sql",height:80,value:Jr(e),monacoOptions:{scrollbar:{vertical:"hidden"},scrollBeyondLastLine:!1},readOnly:!0,showMiniMap:!1})})}function en(e){return{grow:(0,Fe.css)({flexGrow:1}),label:(0,Fe.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),labelWrapper:(0,Fe.css)({display:"flex",justifyContent:"space-between",paddingBottom:e.spacing(.5)})}}function tn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function rn({query:e,onQueryChange:t,db:r}){const n=(0,ge.useCallback)((n=>{const o=(0,r.toRawSql)({sql:n,dataset:e.dataset,table:e.table,refId:e.refId}),i=(a=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){tn(e,t,r[t])}))}return e}({},e),l=null!=(l={sql:n,rawSql:o})?l:{},Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(l)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(l)).forEach((function(e){Object.defineProperty(a,e,Object.getOwnPropertyDescriptor(l,e))})),a);var a,l;t(i)}),[r,t,e]);return{onSqlChange:n}}const nn=ye().forwardRef((function({items:e,renderItem:t,onChange:r},n){return ye().createElement(rt,null,e.map(((n,o)=>ye().createElement("div",{key:o},t(n,(t=>((t,n)=>{const o=[...e];o[t]=n,r(o)})(o,t)),(()=>(t=>{const n=[...e];n.splice(t,1),r(n)})(o)))))),ye().createElement(_e.Button,{ref:n,onClick:()=>{const t=[...e,{}];r(t)},variant:"secondary",size:"md",icon:"plus","aria-label":"Add",type:"button"}))})),on=({children:e})=>{const t=(0,_e.useStyles2)(ln),r=ge.Children.map(e,(e=>(0,ge.isValidElement)(e)&&e.props.invalid?(0,ge.cloneElement)(e,{className:(0,Fe.cx)(e.props.className,t.invalidChild)}):e));return ye().createElement("div",{className:t.root},r)},an=["","base","hovered","invalid","focused"],ln=()=>({root:(0,Fe.css)({display:"flex","> *":{"&:not(:first-child)":{marginLeft:-1},"&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0},"&:not(:first-child):not(:last-child)":{borderRadius:0},position:"relative",zIndex:an.indexOf("base"),"&:hover":{zIndex:an.indexOf("hovered")},"&:focus-within":{zIndex:an.indexOf("focused")}}}),invalidChild:(0,Fe.css)({zIndex:an.indexOf("invalid")})});var sn=Object.defineProperty,un=Object.defineProperties,cn=Object.getOwnPropertyDescriptors,dn=Object.getOwnPropertySymbols,pn=Object.prototype.hasOwnProperty,fn=Object.prototype.propertyIsEnumerable,vn=(e,t,r)=>t in e?sn(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const hn=e=>{var t=e,{className:r}=t,n=((e,t)=>{var r={};for(var n in e)pn.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&dn)for(var n of dn(e))t.indexOf(n)<0&&fn.call(e,n)&&(r[n]=e[n]);return r})(t,["className"]);const o=(0,_e.useStyles2)(gn);return ye().createElement(_e.Button,(i=((e,t)=>{for(var r in t||(t={}))pn.call(t,r)&&vn(e,r,t[r]);if(dn)for(var r of dn(t))fn.call(t,r)&&vn(e,r,t[r]);return e})({},n),a={className:(0,Fe.cx)(r,o.button)},un(i,cn(a))));var i,a},gn=e=>({button:(0,Fe.css)({paddingLeft:e.spacing(1.5),paddingRight:e.spacing(1.5)})});function yn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function mn({sql:e,columns:t,onSqlChange:r}){const n=(0,ge.useCallback)((t=>{const n=t.map((e=>{var t;return Re(null===(t=e.property)||void 0===t?void 0:t.name)})),o=(i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){yn(e,t,r[t])}))}return e}({},e),a=null!=(a={groupBy:n})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;r(o)}),[r,e]);return(0,he.jsx)(nn,{items:e.groupBy,onChange:n,renderItem:bn({options:t})})}function bn({options:e}){return function(t,r,n){var o;return(0,he.jsxs)(on,{children:[(0,he.jsx)(_e.Select,{value:(null===(o=t.property)||void 0===o?void 0:o.name)?(0,T.toOption)(t.property.name):null,"aria-label":"Group by",options:e,menuShouldPortal:!0,onChange:({value:e})=>e&&r(Re(e))}),(0,he.jsx)(hn,{title:"Remove group by column",icon:"times",variant:"secondary",onClick:n})]})}}function En({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=rn({query:t,onQueryChange:r,db:n});return(0,he.jsx)(mn,{columns:e,sql:t.sql,onSqlChange:o})}function On(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Sn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){On(e,t,r[t])}))}return e}function Tn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const _n=[{description:"Sort by ascending",value:"ASC",icon:"sort-amount-up"},{description:"Sort by descending",value:"DESC",icon:"sort-amount-down"}];function wn({sql:e,onSqlChange:t,columns:r,showOffset:n}){var o,i;const a=(0,ge.useCallback)((r=>{const n=Tn(Sn({},e),{orderByDirection:r});t(n)}),[t,e]),l=(0,ge.useCallback)((r=>{const n=Tn(Sn({},e),{limit:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),s=(0,ge.useCallback)((r=>{const n=Tn(Sn({},e),{offset:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),u=(0,ge.useCallback)((r=>{const n=Tn(Sn({},e),{orderBy:(o=null==r?void 0:r.value,{type:Te.Property,property:{type:Se.String,name:o}})});var o;null===r&&(n.orderByDirection=void 0),t(n)}),[t,e]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(ft,{label:"Order by",width:25,children:(0,he.jsxs)(on,{children:[(0,he.jsx)(_e.Select,{"aria-label":"Order by",options:r,value:(null===(o=e.orderBy)||void 0===o?void 0:o.property.name)?(0,T.toOption)(e.orderBy.property.name):null,isClearable:!0,menuShouldPortal:!0,onChange:u}),(0,he.jsx)(_e.Space,{h:1.5}),(0,he.jsx)(_e.RadioButtonGroup,{options:_n,disabled:!(null==e||null===(i=e.orderBy)||void 0===i?void 0:i.property.name),value:e.orderByDirection,onChange:a})]})}),(0,he.jsx)(ft,{label:"Limit",optional:!0,width:25,children:(0,he.jsx)(_e.Input,{type:"number",min:0,id:(0,fe.uniqueId)("limit-"),value:e.limit||"",onChange:l})}),n&&(0,he.jsx)(ft,{label:"Offset",optional:!0,width:25,children:(0,he.jsx)(_e.Input,{type:"number",id:(0,fe.uniqueId)("offset-"),value:e.offset||"",onChange:s})})]})}function Rn({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=rn({query:t,onQueryChange:r,db:n});let i=[];if(e){var a,l;const r=null===(l=t.sql)||void 0===l||null===(a=l.columns)||void 0===a?void 0:a.map(((e,t)=>{var r,n;const o=e.name?`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>e.name))})`:null===(n=e.parameters)||void 0===n?void 0:n.map((e=>e.name));return{value:o,label:`${t+1} - ${o}`}}));i=[{value:"",label:"Selected columns",options:r,expanded:!0},...e]}return(0,he.jsx)(wn,{sql:t.sql,onSqlChange:o,columns:i})}const In=["AVG","COUNT","MAX","MIN","SUM"],An=["$__time","$__timeEpoch","$__timeFilter","$__timeFrom","$__timeTo","$__timeGroup","$__timeGroupAlias","$__unixEpochFilter","$__unixEpochNanoFilter","$__unixEpochNanoFrom","$__unixEpochNanoTo","$__unixEpochGroup","$__unixEpochGroupAlias"];function Cn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Nn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Cn(e,t,r[t])}))}return e}function Ln(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const jn={label:"*",value:"*"};function xn({sql:e,format:t,columns:r,onSqlChange:n,functions:o}){var i;const a=(0,_e.useStyles2)(Pn),l=[jn,...r||[]],s=[];t===S.Timeseries&&(s.push({label:"time",value:"time"}),s.push({label:"value",value:"value"}));const u=(0,ge.useCallback)(((t,r)=>o=>{var i,a;let l=Nn({},t);(null===(i=t.parameters)||void 0===i?void 0:i.length)?l.parameters=t.parameters.map((e=>e.type===Te.FunctionParameter?Ln(Nn({},e),{name:o.value}):e)):l.parameters=[{type:Te.FunctionParameter,name:o.value}];const s=Ln(Nn({},e),{columns:null===(a=e.columns)||void 0===a?void 0:a.map(((e,t)=>t===r?l:e))});n(s)}),[n,e]),c=(0,ge.useCallback)(((t,r)=>o=>{var i;const a=Ln(Nn({},t),{name:null==o?void 0:o.value}),l=Ln(Nn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(l)}),[n,e]),d=(0,ge.useCallback)(((t,r)=>o=>{var i;let a=Nn({},t);var l;null!==o?a=Ln(Nn({},t),{alias:`"${null==o||null===(l=o.value)||void 0===l?void 0:l.trim()}"`}):delete a.alias;const s=Ln(Nn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(s)}),[n,e]),p=(0,ge.useCallback)((t=>()=>{const r=[...e.columns];r.splice(t,1);const o=Ln(Nn({},e),{columns:r});n(o)}),[n,e]),f=(0,ge.useCallback)((()=>{const t=Ln(Nn({},e),{columns:[...e.columns,Ie()]});n(t)}),[n,e]);return(0,he.jsxs)(rt,{gap:2,wrap:!0,direction:"column",children:[null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>(0,he.jsx)("div",{children:(0,he.jsxs)(rt,{gap:2,alignItems:"end",children:[(0,he.jsx)(ft,{label:"Column",width:25,children:(0,he.jsx)(_e.Select,{value:Fn(e),"data-testid":Pe.components.SQLQueryEditor.selectColumn,options:l,inputId:`select-column-${t}-${(0,fe.uniqueId)()}`,menuShouldPortal:!0,allowCustomValue:!0,onChange:u(e,t)})}),(0,he.jsx)(ft,{label:"Aggregation",optional:!0,width:25,children:(0,he.jsx)(_e.Select,{value:e.name?(0,T.toOption)(e.name):null,inputId:`select-aggregation-${t}-${(0,fe.uniqueId)()}`,"data-testid":Pe.components.SQLQueryEditor.selectAggregation,isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0,options:o,onChange:c(e,t)})}),(0,he.jsx)(ft,{label:"Alias",optional:!0,width:15,children:(0,he.jsx)(_e.Select,{value:e.alias?(0,T.toOption)(e.alias):null,inputId:`select-alias-${t}-${(0,fe.uniqueId)()}`,"data-testid":Pe.components.SQLQueryEditor.selectAlias,options:s,onChange:d(e,t),isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0})}),(0,he.jsx)(_e.Button,{title:"Remove column",type:"button",icon:"trash-alt",variant:"secondary",size:"md",onClick:p(t)})]})},t))),(0,he.jsx)(_e.Button,{type:"button",onClick:f,variant:"secondary",title:"Add column",size:"md",icon:"plus",className:a.addButton})]})}const Pn=()=>({addButton:(0,Fe.css)({alignSelf:"flex-start"})});function Fn({parameters:e}){const t=null==e?void 0:e.find((e=>e.type===Te.FunctionParameter));return(null==t?void 0:t.name)?(0,T.toOption)(t.name):null}function Dn({fields:e,query:t,onQueryChange:r,db:n}){var o;const{onSqlChange:i}=rn({query:t,onQueryChange:r,db:n}),a=[...In,...(null===(o=n.functions)||void 0===o?void 0:o.call(n))||[]].map(T.toOption);return(0,he.jsx)(xn,{columns:e,sql:t.sql,format:t.format,functions:a,onSqlChange:i})}var kn=p(1777);function Mn(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function Vn(e){return Vn="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Vn(e)}function Un(e){var t=function(e,t){if("object"!=Vn(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,"string");if("object"!=Vn(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"==Vn(t)?t:t+""}function Bn(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,Un(n.key),n)}}function Gn(e,t,r){return t&&Bn(e.prototype,t),r&&Bn(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function qn(e,t){if(t&&("object"==Vn(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e)}function Kn(e){return Kn=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},Kn(e)}function Wn(e,t){return Wn=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},Wn(e,t)}function zn(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&Wn(e,t)}function Hn(e,t,r){return(t=Un(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function $n(e){if(Array.isArray(e))return e}function Yn(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=Array(t);r<t;r++)n[r]=e[r];return n}function Qn(e,t){if(e){if("string"==typeof e)return Yn(e,t);var r={}.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Yn(e,t):void 0}}function Xn(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function Jn(e,t){return $n(e)||function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,l=[],s=!0,u=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;s=!1}else for(;!(s=(n=i.call(r)).done)&&(l.push(n.value),l.length!==t);s=!0);}catch(e){u=!0,o=e}finally{try{if(!s&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(u)throw o}}return l}}(e,t)||Qn(e,t)||Xn()}function Zn(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function eo(e){return function(e){if(Array.isArray(e))return Yn(e)}(e)||Zn(e)||Qn(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var to="delete",ro=5,no=1<<ro,oo=no-1,io={};function ao(e){e&&(e.value=!0)}function lo(){}function so(e){return void 0===e.size&&(e.size=e.__iterate(co)),e.size}function uo(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?so(e)+t:t}function co(){return!0}function po(e,t,r){return(0===e&&!go(e)||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function fo(e,t){return ho(e,t,0)}function vo(e,t){return ho(e,t,t)}function ho(e,t,r){return void 0===e?r:go(e)?t===1/0?t:0|Math.max(0,t+e):void 0===t||t===e?e:0|Math.min(t,e)}function go(e){return e<0||0===e&&1/e==-1/0}var yo="@@__IMMUTABLE_ITERABLE__@@";function mo(e){return Boolean(e&&e[yo])}var bo="@@__IMMUTABLE_KEYED__@@";function Eo(e){return Boolean(e&&e[bo])}var Oo="@@__IMMUTABLE_INDEXED__@@";function So(e){return Boolean(e&&e[Oo])}function To(e){return Eo(e)||So(e)}var _o=function(e){return mo(e)?e:Qo(e)},wo=function(e){function t(e){return Eo(e)?e:Xo(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(_o),Ro=function(e){function t(e){return So(e)?e:Jo(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(_o),Io=function(e){function t(e){return mo(e)&&!To(e)?e:Zo(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(_o);_o.Keyed=wo,_o.Indexed=Ro,_o.Set=Io;var Ao="@@__IMMUTABLE_SEQ__@@";function Co(e){return Boolean(e&&e[Ao])}var No="@@__IMMUTABLE_RECORD__@@";function Lo(e){return Boolean(e&&e[No])}function jo(e){return mo(e)||Lo(e)}var xo="@@__IMMUTABLE_ORDERED__@@";function Po(e){return Boolean(e&&e[xo])}var Fo=0,Do=1,ko=2,Mo="function"==typeof Symbol&&Symbol.iterator,Vo="@@iterator",Uo=Mo||Vo,Bo=function(e){this.next=e};function Go(e,t,r,n){var o=0===e?t:1===e?r:[t,r];return n?n.value=o:n={value:o,done:!1},n}function qo(){return{value:void 0,done:!0}}function Ko(e){return!!Array.isArray(e)||!!Ho(e)}function Wo(e){return e&&"function"==typeof e.next}function zo(e){var t=Ho(e);return t&&t.call(e)}function Ho(e){var t=e&&(Mo&&e[Mo]||e[Vo]);if("function"==typeof t)return t}Bo.prototype.toString=function(){return"[Iterator]"},Bo.KEYS=Fo,Bo.VALUES=Do,Bo.ENTRIES=ko,Bo.prototype.inspect=Bo.prototype.toSource=function(){return this.toString()},Bo.prototype[Uo]=function(){return this};var $o=Object.prototype.hasOwnProperty;function Yo(e){return!(!Array.isArray(e)&&"string"!=typeof e)||e&&"object"==typeof e&&Number.isInteger(e.length)&&e.length>=0&&(0===e.length?1===Object.keys(e).length:e.hasOwnProperty(e.length-1))}var Qo=function(e){function t(e){return null==e?oi():jo(e)?e.toSeq():function(e){var t,r,n=li(e);if(n)return(r=Ho(t=e))&&r===t.entries?n.fromEntrySeq():function(e){var t=Ho(e);return t&&t===e.keys}(e)?n.toSetSeq():n;if("object"==typeof e)return new ti(e);throw new TypeError("Expected Array or collection object of values, or keyed object: "+e)}(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq {","}")},t.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},t.prototype.__iterate=function(e,t){var r=this._cache;if(r){for(var n=r.length,o=0;o!==n;){var i=r[t?n-++o:o++];if(!1===e(i[1],i[0],this))break}return o}return this.__iterateUncached(e,t)},t.prototype.__iterator=function(e,t){var r=this._cache;if(r){var n=r.length,o=0;return new Bo((function(){if(o===n)return{value:void 0,done:!0};var i=r[t?n-++o:o++];return Go(e,i[0],i[1])}))}return this.__iteratorUncached(e,t)},t}(_o),Xo=function(e){function t(e){return null==e?oi().toKeyedSeq():mo(e)?Eo(e)?e.toSeq():e.fromEntrySeq():Lo(e)?e.toSeq():ii(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toKeyedSeq=function(){return this},t}(Qo),Jo=function(e){function t(e){return null==e?oi():mo(e)?Eo(e)?e.entrySeq():e.toIndexedSeq():Lo(e)?e.toSeq().entrySeq():ai(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toIndexedSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq [","]")},t}(Qo),Zo=function(e){function t(e){return(mo(e)&&!To(e)?e:Jo(e)).toSetSeq()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toSetSeq=function(){return this},t}(Qo);Qo.isSeq=Co,Qo.Keyed=Xo,Qo.Set=Zo,Qo.Indexed=Jo,Qo.prototype[Ao]=!0;var ei=function(e){function t(e){this._array=e,this.size=e.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this.has(e)?this._array[uo(this,e)]:t},t.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length,o=0;o!==n;){var i=t?n-++o:o++;if(!1===e(r[i],i,this))break}return o},t.prototype.__iterator=function(e,t){var r=this._array,n=r.length,o=0;return new Bo((function(){if(o===n)return{value:void 0,done:!0};var i=t?n-++o:o++;return Go(e,i,r[i])}))},t}(Jo),ti=function(e){function t(e){var t=Object.keys(e).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e):[]);this._object=e,this._keys=t,this.size=t.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},t.prototype.has=function(e){return $o.call(this._object,e)},t.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,o=n.length,i=0;i!==o;){var a=n[t?o-++i:i++];if(!1===e(r[a],a,this))break}return i},t.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,o=n.length,i=0;return new Bo((function(){if(i===o)return{value:void 0,done:!0};var a=n[t?o-++i:i++];return Go(e,a,r[a])}))},t}(Xo);ti.prototype[xo]=!0;var ri,ni=function(e){function t(e){this._collection=e,this.size=e.length||e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=zo(this._collection),n=0;if(Wo(r))for(var o;!(o=r.next()).done&&!1!==e(o.value,n++,this););return n},t.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=zo(this._collection);if(!Wo(r))return new Bo(qo);var n=0;return new Bo((function(){var t=r.next();return t.done?t:Go(e,n++,t.value)}))},t}(Jo);function oi(){return ri||(ri=new ei([]))}function ii(e){var t=li(e);if(t)return t.fromEntrySeq();if("object"==typeof e)return new ti(e);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+e)}function ai(e){var t=li(e);if(t)return t;throw new TypeError("Expected Array or collection object of values: "+e)}function li(e){return Yo(e)?new ei(e):Ko(e)?new ni(e):void 0}var si="@@__IMMUTABLE_MAP__@@";function ui(e){return Boolean(e&&e[si])}function ci(e){return ui(e)&&Po(e)}function di(e){return Boolean(e&&"function"==typeof e.equals&&"function"==typeof e.hashCode)}function pi(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!!(di(e)&&di(t)&&e.equals(t))}var fi="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function vi(e){return e>>>1&1073741824|3221225471&e}var hi=Object.prototype.valueOf;function gi(e){if(null==e)return yi(e);if("function"==typeof e.hashCode)return vi(e.hashCode(e));var t,r,n,o=(t=e).valueOf!==hi&&"function"==typeof t.valueOf?t.valueOf(t):t;if(null==o)return yi(o);switch(typeof o){case"boolean":return o?1108378657:1108378656;case"number":return function(e){if(e!=e||e===1/0)return 0;var t=0|e;for(t!==e&&(t^=4294967295*e);e>4294967295;)t^=e/=4294967295;return vi(t)}(o);case"string":return o.length>Ii?(void 0===(n=Ni[r=o])&&(n=mi(r),Ci===Ai&&(Ci=0,Ni={}),Ci++,Ni[r]=n),n):mi(o);case"object":case"function":return function(e){var t;if(Ti&&void 0!==(t=Si.get(e)))return t;if(void 0!==(t=e[Ri]))return t;if(!Ei){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[Ri]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=Oi(),Ti)Si.set(e,t);else{if(void 0!==bi&&!1===bi(e))throw new Error("Non-extensible objects are not allowed as keys.");if(Ei)Object.defineProperty(e,Ri,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[Ri]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[Ri]=t}}return t}(o);case"symbol":return function(e){var t=_i[e];return void 0!==t||(t=Oi(),_i[e]=t),t}(o);default:if("function"==typeof o.toString)return mi(o.toString());throw new Error("Value type "+typeof o+" cannot be hashed.")}}function yi(e){return null===e?1108378658:1108378659}function mi(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return vi(t)}var bi=Object.isExtensible,Ei=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();function Oi(){var e=++wi;return 1073741824&wi&&(wi=0),e}var Si,Ti="function"==typeof WeakMap;Ti&&(Si=new WeakMap);var _i=Object.create(null),wi=0,Ri="__immutablehash__";"function"==typeof Symbol&&(Ri=Symbol(Ri));var Ii=16,Ai=255,Ci=0,Ni={},Li=function(e){function t(e,t){this._iter=e,this._useKeys=t,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this._iter.get(e,t)},t.prototype.has=function(e){return this._iter.has(e)},t.prototype.valueSeq=function(){return this._iter.valueSeq()},t.prototype.reverse=function(){var e=this,t=ki(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},t.prototype.map=function(e,t){var r=this,n=Di(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t,n){return e(t,n,r)}),t)},t.prototype.__iterator=function(e,t){return this._iter.__iterator(e,t)},t}(Xo);Li.prototype[xo]=!0;var ji=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.includes=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this,n=0;return t&&so(this),this._iter.__iterate((function(o){return e(o,t?r.size-++n:n++,r)}),t)},t.prototype.__iterator=function(e,t){var r=this,n=this._iter.__iterator(Do,t),o=0;return t&&so(this),new Bo((function(){var i=n.next();return i.done?i:Go(e,t?r.size-++o:o++,i.value,i)}))},t}(Jo),xi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.has=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(Do,t);return new Bo((function(){var t=r.next();return t.done?t:Go(e,t.value,t.value,t)}))},t}(Zo),Pi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.entrySeq=function(){return this._iter.toSeq()},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){if(t){Hi(t);var n=mo(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(Do,t);return new Bo((function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){Hi(n);var o=mo(n);return Go(e,o?n.get(0):n[0],o?n.get(1):n[1],t)}}}))},t}(Xo);function Fi(e){var t=Yi(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=Qi,t.__iterateUncached=function(t,r){var n=this;return e.__iterate((function(e,r){return!1!==t(r,e,n)}),r)},t.__iteratorUncached=function(t,r){if(t===ko){var n=e.__iterator(t,r);return new Bo((function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e}))}return e.__iterator(t===Do?Fo:Do,r)},t}function Di(e,t,r){var n=Yi(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,o){var i=e.get(n,io);return i===io?o:t.call(r,i,n,e)},n.__iterateUncached=function(n,o){var i=this;return e.__iterate((function(e,o,a){return!1!==n(t.call(r,e,o,a),o,i)}),o)},n.__iteratorUncached=function(n,o){var i=e.__iterator(ko,o);return new Bo((function(){var o=i.next();if(o.done)return o;var a=o.value,l=a[0];return Go(n,l,t.call(r,a[1],l,e),o)}))},n}function ki(e,t){var r=this,n=Yi(e);return n._iter=e,n.size=e.size,n.reverse=function(){return e},e.flip&&(n.flip=function(){var t=Fi(e);return t.reverse=function(){return e.flip()},t}),n.get=function(r,n){return e.get(t?r:-1-r,n)},n.has=function(r){return e.has(t?r:-1-r)},n.includes=function(t){return e.includes(t)},n.cacheResult=Qi,n.__iterate=function(r,n){var o=this,i=0;return n&&so(e),e.__iterate((function(e,a){return r(e,t?a:n?o.size-++i:i++,o)}),!n)},n.__iterator=function(n,o){var i=0;o&&so(e);var a=e.__iterator(ko,!o);return new Bo((function(){var e=a.next();if(e.done)return e;var l=e.value;return Go(n,t?l[0]:o?r.size-++i:i++,l[1],e)}))},n}function Mi(e,t,r,n){var o=Yi(e);return n&&(o.has=function(n){var o=e.get(n,io);return o!==io&&!!t.call(r,o,n,e)},o.get=function(n,o){var i=e.get(n,io);return i!==io&&t.call(r,i,n,e)?i:o}),o.__iterateUncached=function(o,i){var a=this,l=0;return e.__iterate((function(e,i,s){if(t.call(r,e,i,s))return l++,o(e,n?i:l-1,a)}),i),l},o.__iteratorUncached=function(o,i){var a=e.__iterator(ko,i),l=0;return new Bo((function(){for(;;){var i=a.next();if(i.done)return i;var s=i.value,u=s[0],c=s[1];if(t.call(r,c,u,e))return Go(o,n?u:l++,c,i)}}))},o}function Vi(e,t,r,n){var o=e.size;if(po(t,r,o))return e;if(void 0===o&&(t<0||r<0))return Vi(e.toSeq().cacheResult(),t,r,n);var i,a=fo(t,o),l=vo(r,o)-a;l==l&&(i=l<0?0:l);var s=Yi(e);return s.size=0===i?i:e.size&&i||void 0,!n&&Co(e)&&i>=0&&(s.get=function(t,r){return(t=uo(this,t))>=0&&t<i?e.get(t+a,r):r}),s.__iterateUncached=function(t,r){var o=this;if(0===i)return 0;if(r)return this.cacheResult().__iterate(t,r);var l=0,s=!0,u=0;return e.__iterate((function(e,r){if(!s||!(s=l++<a))return u++,!1!==t(e,n?r:u-1,o)&&u!==i})),u},s.__iteratorUncached=function(t,r){if(0!==i&&r)return this.cacheResult().__iterator(t,r);if(0===i)return new Bo(qo);var o=e.__iterator(t,r),l=0,s=0;return new Bo((function(){for(;l++<a;)o.next();if(++s>i)return{value:void 0,done:!0};var e=o.next();return n||t===Do||e.done?e:Go(t,s-1,t===Fo?void 0:e.value[1],e)}))},s}function Ui(e,t,r,n){var o=Yi(e);return o.__iterateUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterate(o,i);var l=!0,s=0;return e.__iterate((function(e,i,u){if(!l||!(l=t.call(r,e,i,u)))return s++,o(e,n?i:s-1,a)})),s},o.__iteratorUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterator(o,i);var l=e.__iterator(ko,i),s=!0,u=0;return new Bo((function(){var e,i,c;do{if((e=l.next()).done)return n||o===Do?e:Go(o,u++,o===Fo?void 0:e.value[1],e);var d=e.value;i=d[0],c=d[1],s&&(s=t.call(r,c,i,a))}while(s);return o===ko?e:Go(o,i,c,e)}))},o}function Bi(e,t,r){var n=Yi(e);return n.__iterateUncached=function(o,i){if(i)return this.cacheResult().__iterate(o,i);var a=0,l=!1;return function e(s,u){s.__iterate((function(i,s){return(!t||u<t)&&mo(i)?e(i,u+1):(a++,!1===o(i,r?s:a-1,n)&&(l=!0)),!l}),i)}(e,0),a},n.__iteratorUncached=function(n,o){if(o)return this.cacheResult().__iterator(n,o);var i=e.__iterator(n,o),a=[],l=0;return new Bo((function(){for(;i;){var e=i.next();if(!1===e.done){var s=e.value;if(n===ko&&(s=s[1]),t&&!(a.length<t)||!mo(s))return r?e:Go(n,l++,s,e);a.push(i),i=s.__iterator(n,o)}else i=a.pop()}return{value:void 0,done:!0}}))},n}function Gi(e,t,r){t||(t=Xi);var n=Eo(e),o=0,i=e.toSeq().map((function(t,n){return[n,t,o++,r?r(t,n,e):t]})).valueSeq().toArray();return i.sort((function(e,r){return t(e[3],r[3])||e[2]-r[2]})).forEach(n?function(e,t){i[t].length=2}:function(e,t){i[t]=e[1]}),n?Xo(i):So(e)?Jo(i):Zo(i)}function qi(e,t,r){if(t||(t=Xi),r){var n=e.toSeq().map((function(t,n){return[t,r(t,n,e)]})).reduce((function(e,r){return Ki(t,e[1],r[1])?r:e}));return n&&n[0]}return e.reduce((function(e,r){return Ki(t,e,r)?r:e}))}function Ki(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function Wi(e,t,r,n){var o=Yi(e),i=new ei(r).map((function(e){return e.size}));return o.size=n?i.max():i.min(),o.__iterate=function(e,t){for(var r,n=this.__iterator(Do,t),o=0;!(r=n.next()).done&&!1!==e(r.value,o++,this););return o},o.__iteratorUncached=function(e,o){var i=r.map((function(e){return e=_o(e),zo(o?e.reverse():e)})),a=0,l=!1;return new Bo((function(){var r;return l||(r=i.map((function(e){return e.next()})),l=n?r.every((function(e){return e.done})):r.some((function(e){return e.done}))),l?{value:void 0,done:!0}:Go(e,a++,t.apply(null,r.map((function(e){return e.value}))))}))},o}function zi(e,t){return e===t?e:Co(e)?t:e.constructor(t)}function Hi(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function $i(e){return Eo(e)?wo:So(e)?Ro:Io}function Yi(e){return Object.create((Eo(e)?Xo:So(e)?Jo:Zo).prototype)}function Qi(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):Qo.prototype.cacheResult.call(this)}function Xi(e,t){return void 0===e&&void 0===t?0:void 0===e?1:void 0===t?-1:e>t?1:e<t?-1:0}function Ji(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),o=0;o<r;o++)n[o]=e[o+t];return n}function Zi(e,t){if(!e)throw new Error(t)}function ea(e){Zi(e!==1/0,"Cannot perform this action with an infinite size.")}function ta(e){if(Yo(e)&&"string"!=typeof e)return e;if(Po(e))return e.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+e)}ji.prototype.cacheResult=Li.prototype.cacheResult=xi.prototype.cacheResult=Pi.prototype.cacheResult=Qi;var ra=Object.prototype.toString;function na(e){if(!e||"object"!=typeof e||"[object Object]"!==ra.call(e))return!1;var t=Object.getPrototypeOf(e);if(null===t)return!0;for(var r=t,n=Object.getPrototypeOf(t);null!==n;)r=n,n=Object.getPrototypeOf(r);return r===t}function oa(e){return"object"==typeof e&&(jo(e)||Array.isArray(e)||na(e))}function ia(e){try{return"string"==typeof e?JSON.stringify(e):String(e)}catch(t){return JSON.stringify(e)}}function aa(e,t){return jo(e)?e.has(t):oa(e)&&$o.call(e,t)}function la(e,t,r){return jo(e)?e.get(t,r):aa(e,t)?"function"==typeof e.get?e.get(t):e[t]:r}function sa(e){if(Array.isArray(e))return Ji(e);var t={};for(var r in e)$o.call(e,r)&&(t[r]=e[r]);return t}function ua(e,t){if(!oa(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(jo(e)){if(!e.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+e);return e.remove(t)}if(!$o.call(e,t))return e;var r=sa(e);return Array.isArray(r)?r.splice(t,1):delete r[t],r}function ca(e,t,r){if(!oa(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(jo(e)){if(!e.set)throw new TypeError("Cannot update immutable value without .set() method: "+e);return e.set(t,r)}if($o.call(e,t)&&r===e[t])return e;var n=sa(e);return n[t]=r,n}function da(e,t,r,n){n||(n=r,r=void 0);var o=pa(jo(e),e,ta(t),0,r,n);return o===io?r:o}function pa(e,t,r,n,o,i){var a=t===io;if(n===r.length){var l=a?o:t,s=i(l);return s===l?t:s}if(!a&&!oa(t))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(ia)+"]: "+t);var u=r[n],c=a?io:la(t,u,io),d=pa(c===io?e:jo(c),c,r,n+1,o,i);return d===c?t:d===io?ua(t,u):ca(a?e?Wa():{}:t,u,d)}function fa(e,t,r){return da(e,t,io,(function(){return r}))}function va(e,t){return fa(this,e,t)}function ha(e,t){return da(e,t,(function(){return io}))}function ga(e){return ha(this,e)}function ya(e,t,r,n){return da(e,[t],r,n)}function ma(e,t,r){return 1===arguments.length?e(this):ya(this,e,t,r)}function ba(e,t,r){return da(this,e,t,r)}function Ea(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Sa(this,e)}function Oa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];if("function"!=typeof e)throw new TypeError("Invalid merger function: "+e);return Sa(this,t,e)}function Sa(e,t,r){for(var n=[],o=0;o<t.length;o++){var i=wo(t[o]);0!==i.size&&n.push(i)}return 0===n.length?e:0!==e.toSeq().size||e.__ownerID||1!==n.length?e.withMutations((function(e){for(var t=r?function(t,n){ya(e,n,io,(function(e){return e===io?t:r(e,t,n)}))}:function(t,r){e.set(r,t)},o=0;o<n.length;o++)n[o].forEach(t)})):e.constructor(n[0])}function Ta(e,t,r){return _a(e,t,function(e){return function t(r,n,o){return oa(r)&&oa(n)&&(i=n,a=Qo(r),l=Qo(i),So(a)===So(l)&&Eo(a)===Eo(l))?_a(r,[n],t):e?e(r,n,o):n;var i,a,l}}(r))}function _a(e,t,r){if(!oa(e))throw new TypeError("Cannot merge into non-data-structure value: "+e);if(jo(e))return"function"==typeof r&&e.mergeWith?e.mergeWith.apply(e,[r].concat(t)):e.merge?e.merge.apply(e,t):e.concat.apply(e,t);for(var n=Array.isArray(e),o=e,i=n?Ro:wo,a=n?function(t){o===e&&(o=sa(o)),o.push(t)}:function(t,n){var i=$o.call(o,n),a=i&&r?r(o[n],t,n):t;i&&a===o[n]||(o===e&&(o=sa(o)),o[n]=a)},l=0;l<t.length;l++)i(t[l]).forEach(a);return o}function wa(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Ta(this,e)}function Ra(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Ta(this,t,e)}function Ia(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return da(this,e,Wa(),(function(e){return _a(e,t)}))}function Aa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return da(this,e,Wa(),(function(e){return Ta(e,t)}))}function Ca(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this}function Na(){return this.__ownerID?this:this.__ensureOwner(new lo)}function La(){return this.__ensureOwner()}function ja(){return this.__altered}var xa=function(e){function t(t){return null==t?Wa():ui(t)&&!Po(t)?t:Wa().withMutations((function(r){var n=e(t);ea(n.size),n.forEach((function(e,t){return r.set(t,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Wa().withMutations((function(t){for(var r=0;r<e.length;r+=2){if(r+1>=e.length)throw new Error("Missing value for key: "+e[r]);t.set(e[r],e[r+1])}}))},t.prototype.toString=function(){return this.__toString("Map {","}")},t.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},t.prototype.set=function(e,t){return za(this,e,t)},t.prototype.remove=function(e){return za(this,e,io)},t.prototype.deleteAll=function(e){var t=_o(e);return 0===t.size?this:this.withMutations((function(e){t.forEach((function(t){return e.remove(t)}))}))},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):Wa()},t.prototype.sort=function(e){return yl(Gi(this,e))},t.prototype.sortBy=function(e,t){return yl(Gi(this,t,e))},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){n.forEach((function(o,i){n.set(i,e.call(t,o,i,r))}))}))},t.prototype.__iterator=function(e,t){return new Ba(this,e,t)},t.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate((function(t){return n++,e(t[1],t[0],r)}),t),n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Ka(this.size,this._root,e,this.__hash):0===this.size?Wa():(this.__ownerID=e,this.__altered=!1,this)},t}(wo);xa.isMap=ui;var Pa=xa.prototype;Pa[si]=!0,Pa[to]=Pa.remove,Pa.removeAll=Pa.deleteAll,Pa.setIn=va,Pa.removeIn=Pa.deleteIn=ga,Pa.update=ma,Pa.updateIn=ba,Pa.merge=Pa.concat=Ea,Pa.mergeWith=Oa,Pa.mergeDeep=wa,Pa.mergeDeepWith=Ra,Pa.mergeIn=Ia,Pa.mergeDeepIn=Aa,Pa.withMutations=Ca,Pa.wasAltered=ja,Pa.asImmutable=La,Pa["@@transducer/init"]=Pa.asMutable=Na,Pa["@@transducer/step"]=function(e,t){return e.set(t[0],t[1])},Pa["@@transducer/result"]=function(e){return e.asImmutable()};var Fa=function(e,t){this.ownerID=e,this.entries=t};Fa.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(pi(r,o[i][0]))return o[i][1];return n},Fa.prototype.update=function(e,t,r,n,o,i,a){for(var l=o===io,s=this.entries,u=0,c=s.length;u<c&&!pi(n,s[u][0]);u++);var d=u<c;if(d?s[u][1]===o:l)return this;if(ao(a),(l||!d)&&ao(i),!l||1!==s.length){if(!d&&!l&&s.length>=Ja)return function(e,t,r,n){e||(e=new lo);for(var o=new Va(e,gi(r),[r,n]),i=0;i<t.length;i++){var a=t[i];o=o.update(e,0,void 0,a[0],a[1])}return o}(e,s,n,o);var p=e&&e===this.ownerID,f=p?s:Ji(s);return d?l?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Fa(e,f)}};var Da=function(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r};Da.prototype.get=function(e,t,r,n){void 0===t&&(t=gi(r));var o=1<<((0===e?t:t>>>e)&oo),i=this.bitmap;return i&o?this.nodes[Qa(i&o-1)].get(e+ro,t,r,n):n},Da.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=gi(n));var l=(0===t?r:r>>>t)&oo,s=1<<l,u=this.bitmap,c=!!(u&s);if(!c&&o===io)return this;var d=Qa(u&s-1),p=this.nodes,f=c?p[d]:void 0,v=Ha(f,e,t+ro,r,n,o,i,a);if(v===f)return this;if(!c&&v&&p.length>=Za)return function(e,t,r,n,o){for(var i=0,a=new Array(no),l=0;0!==r;l++,r>>>=1)a[l]=1&r?t[i++]:void 0;return a[n]=o,new ka(e,i+1,a)}(e,p,u,l,v);if(c&&!v&&2===p.length&&$a(p[1^d]))return p[1^d];if(c&&v&&1===p.length&&$a(v))return v;var h=e&&e===this.ownerID,g=c?v?u:u^s:u|s,y=c?v?Xa(p,d,v,h):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var o=new Array(n),i=0,a=0;a<n;a++)a===t&&(i=1),o[a]=e[a+i];return o}(p,d,h):function(e,t,r,n){var o=e.length+1;if(n&&t+1===o)return e[t]=r,e;for(var i=new Array(o),a=0,l=0;l<o;l++)l===t?(i[l]=r,a=-1):i[l]=e[l+a];return i}(p,d,v,h);return h?(this.bitmap=g,this.nodes=y,this):new Da(e,g,y)};var ka=function(e,t,r){this.ownerID=e,this.count=t,this.nodes=r};ka.prototype.get=function(e,t,r,n){void 0===t&&(t=gi(r));var o=(0===e?t:t>>>e)&oo,i=this.nodes[o];return i?i.get(e+ro,t,r,n):n},ka.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=gi(n));var l=(0===t?r:r>>>t)&oo,s=o===io,u=this.nodes,c=u[l];if(s&&!c)return this;var d=Ha(c,e,t+ro,r,n,o,i,a);if(d===c)return this;var p=this.count;if(c){if(!d&&--p<el)return function(e,t,r,n){for(var o=0,i=0,a=new Array(r),l=0,s=1,u=t.length;l<u;l++,s<<=1){var c=t[l];void 0!==c&&l!==n&&(o|=s,a[i++]=c)}return new Da(e,o,a)}(e,u,p,l)}else p++;var f=e&&e===this.ownerID,v=Xa(u,l,d,f);return f?(this.count=p,this.nodes=v,this):new ka(e,p,v)};var Ma=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r};Ma.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(pi(r,o[i][0]))return o[i][1];return n},Ma.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=gi(n));var l=o===io;if(r!==this.keyHash)return l?this:(ao(a),ao(i),Ya(this,e,t,r,[n,o]));for(var s=this.entries,u=0,c=s.length;u<c&&!pi(n,s[u][0]);u++);var d=u<c;if(d?s[u][1]===o:l)return this;if(ao(a),(l||!d)&&ao(i),l&&2===c)return new Va(e,this.keyHash,s[1^u]);var p=e&&e===this.ownerID,f=p?s:Ji(s);return d?l?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Ma(e,this.keyHash,f)};var Va=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r};Va.prototype.get=function(e,t,r,n){return pi(r,this.entry[0])?this.entry[1]:n},Va.prototype.update=function(e,t,r,n,o,i,a){var l=o===io,s=pi(n,this.entry[0]);return(s?o===this.entry[1]:l)?this:(ao(a),l?void ao(i):s?e&&e===this.ownerID?(this.entry[1]=o,this):new Va(e,this.keyHash,[n,o]):(ao(i),Ya(this,e,t,gi(n),[n,o])))},Fa.prototype.iterate=Ma.prototype.iterate=function(e,t){for(var r=this.entries,n=0,o=r.length-1;n<=o;n++)if(!1===e(r[t?o-n:n]))return!1},Da.prototype.iterate=ka.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,o=r.length-1;n<=o;n++){var i=r[t?o-n:n];if(i&&!1===i.iterate(e,t))return!1}},Va.prototype.iterate=function(e,t){return e(this.entry)};var Ua,Ba=function(e){function t(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&qa(e._root)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r=t.node,n=t.index++,o=void 0;if(r.entry){if(0===n)return Ga(e,r.entry)}else if(r.entries){if(n<=(o=r.entries.length-1))return Ga(e,r.entries[this._reverse?o-n:n])}else if(n<=(o=r.nodes.length-1)){var i=r.nodes[this._reverse?o-n:n];if(i){if(i.entry)return Ga(e,i.entry);t=this._stack=qa(i,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}},t}(Bo);function Ga(e,t){return Go(e,t[0],t[1])}function qa(e,t){return{node:e,index:0,__prev:t}}function Ka(e,t,r,n){var o=Object.create(Pa);return o.size=e,o._root=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Wa(){return Ua||(Ua=Ka(0))}function za(e,t,r){var n,o;if(e._root){var i={value:!1},a={value:!1};if(n=Ha(e._root,e.__ownerID,0,void 0,t,r,i,a),!a.value)return e;o=e.size+(i.value?r===io?-1:1:0)}else{if(r===io)return e;o=1,n=new Fa(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=o,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?Ka(o,n):Wa()}function Ha(e,t,r,n,o,i,a,l){return e?e.update(t,r,n,o,i,a,l):i===io?e:(ao(l),ao(a),new Va(t,n,[o,i]))}function $a(e){return e.constructor===Va||e.constructor===Ma}function Ya(e,t,r,n,o){if(e.keyHash===n)return new Ma(t,n,[e.entry,o]);var i,a=(0===r?e.keyHash:e.keyHash>>>r)&oo,l=(0===r?n:n>>>r)&oo,s=a===l?[Ya(e,t,r+ro,n,o)]:(i=new Va(t,n,o),a<l?[e,i]:[i,e]);return new Da(t,1<<a|1<<l,s)}function Qa(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,127&(e+=e>>8)+(e>>16)}function Xa(e,t,r,n){var o=n?e:Ji(e);return o[t]=r,o}var Ja=no/4,Za=no/2,el=no/4,tl="@@__IMMUTABLE_LIST__@@";function rl(e){return Boolean(e&&e[tl])}var nl=function(e){function t(t){var r=cl();if(null==t)return r;if(rl(t))return t;var n=e(t),o=n.size;return 0===o?r:(ea(o),o>0&&o<no?ul(0,o,ro,null,new il(n.toArray())):r.withMutations((function(e){e.setSize(o),n.forEach((function(t,r){return e.set(r,t)}))})))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("List [","]")},t.prototype.get=function(e,t){if((e=uo(this,e))>=0&&e<this.size){var r=fl(this,e+=this._origin);return r&&r.array[e&oo]}return t},t.prototype.set=function(e,t){return function(e,t,r){if((t=uo(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations((function(e){t<0?vl(e,t).set(0,r):vl(e,0,t+1).set(t,r)}));t+=e._origin;var n=e._tail,o=e._root,i={value:!1};return t>=hl(e._capacity)?n=dl(n,e.__ownerID,0,t,r,i):o=dl(o,e.__ownerID,e._level,t,r,i),i.value?e.__ownerID?(e._root=o,e._tail=n,e.__hash=void 0,e.__altered=!0,e):ul(e._origin,e._capacity,e._level,o,n):e}(this,e,t)},t.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},t.prototype.insert=function(e,t){return this.splice(e,0,t)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=ro,this._root=this._tail=this.__hash=void 0,this.__altered=!0,this):cl()},t.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations((function(r){vl(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])}))},t.prototype.pop=function(){return vl(this,0,-1)},t.prototype.unshift=function(){var e=arguments;return this.withMutations((function(t){vl(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])}))},t.prototype.shift=function(){return vl(this,1)},t.prototype.concat=function(){for(var t=arguments,r=[],n=0;n<arguments.length;n++){var o=t[n],i=e("string"!=typeof o&&Ko(o)?o:[o]);0!==i.size&&r.push(i)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations((function(e){r.forEach((function(t){return t.forEach((function(t){return e.push(t)}))}))})):this.constructor(r[0])},t.prototype.setSize=function(e){return vl(this,0,e)},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){for(var o=0;o<r.size;o++)n.set(o,e.call(t,n.get(o),o,r))}))},t.prototype.slice=function(e,t){var r=this.size;return po(e,t,r)?this:vl(this,fo(e,r),vo(t,r))},t.prototype.__iterator=function(e,t){var r=t?this.size:0,n=sl(this,t);return new Bo((function(){var o=n();return o===ll?{value:void 0,done:!0}:Go(e,t?--r:r++,o)}))},t.prototype.__iterate=function(e,t){for(var r,n=t?this.size:0,o=sl(this,t);(r=o())!==ll&&!1!==e(r,t?--n:n++,this););return n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?ul(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):0===this.size?cl():(this.__ownerID=e,this.__altered=!1,this)},t}(Ro);nl.isList=rl;var ol=nl.prototype;ol[tl]=!0,ol[to]=ol.remove,ol.merge=ol.concat,ol.setIn=va,ol.deleteIn=ol.removeIn=ga,ol.update=ma,ol.updateIn=ba,ol.mergeIn=Ia,ol.mergeDeepIn=Aa,ol.withMutations=Ca,ol.wasAltered=ja,ol.asImmutable=La,ol["@@transducer/init"]=ol.asMutable=Na,ol["@@transducer/step"]=function(e,t){return e.push(t)},ol["@@transducer/result"]=function(e){return e.asImmutable()};var il=function(e,t){this.array=e,this.ownerID=t};il.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&oo;if(n>=this.array.length)return new il([],e);var o,i=0===n;if(t>0){var a=this.array[n];if((o=a&&a.removeBefore(e,t-ro,r))===a&&i)return this}if(i&&!o)return this;var l=pl(this,e);if(!i)for(var s=0;s<n;s++)l.array[s]=void 0;return o&&(l.array[n]=o),l},il.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,o=r-1>>>t&oo;if(o>=this.array.length)return this;if(t>0){var i=this.array[o];if((n=i&&i.removeAfter(e,t-ro,r))===i&&o===this.array.length-1)return this}var a=pl(this,e);return a.array.splice(o+1),n&&(a.array[o]=n),a};var al,ll={};function sl(e,t){var r=e._origin,n=e._capacity,o=hl(n),i=e._tail;return function e(a,l,s){return 0===l?function(e,a){var l=a===o?i&&i.array:e&&e.array,s=a>r?0:r-a,u=n-a;return u>no&&(u=no),function(){if(s===u)return ll;var e=t?--u:s++;return l&&l[e]}}(a,s):function(o,i,a){var l,s=o&&o.array,u=a>r?0:r-a>>i,c=1+(n-a>>i);return c>no&&(c=no),function(){for(;;){if(l){var r=l();if(r!==ll)return r;l=null}if(u===c)return ll;var n=t?--c:u++;l=e(s&&s[n],i-ro,a+(n<<i))}}}(a,l,s)}(e._root,e._level,0)}function ul(e,t,r,n,o,i,a){var l=Object.create(ol);return l.size=t-e,l._origin=e,l._capacity=t,l._level=r,l._root=n,l._tail=o,l.__ownerID=i,l.__hash=a,l.__altered=!1,l}function cl(){return al||(al=ul(0,0,ro))}function dl(e,t,r,n,o,i){var a,l=n>>>r&oo,s=e&&l<e.array.length;if(!s&&void 0===o)return e;if(r>0){var u=e&&e.array[l],c=dl(u,t,r-ro,n,o,i);return c===u?e:((a=pl(e,t)).array[l]=c,a)}return s&&e.array[l]===o?e:(i&&ao(i),a=pl(e,t),void 0===o&&l===a.array.length-1?a.array.pop():a.array[l]=o,a)}function pl(e,t){return t&&e&&t===e.ownerID?e:new il(e?e.array.slice():[],t)}function fl(e,t){if(t>=hl(e._capacity))return e._tail;if(t<1<<e._level+ro){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&oo],n-=ro;return r}}function vl(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new lo,o=e._origin,i=e._capacity,a=o+t,l=void 0===r?i:r<0?i+r:o+r;if(a===o&&l===i)return e;if(a>=l)return e.clear();for(var s=e._level,u=e._root,c=0;a+c<0;)u=new il(u&&u.array.length?[void 0,u]:[],n),c+=1<<(s+=ro);c&&(a+=c,o+=c,l+=c,i+=c);for(var d=hl(i),p=hl(l);p>=1<<s+ro;)u=new il(u&&u.array.length?[u]:[],n),s+=ro;var f=e._tail,v=p<d?fl(e,l-1):p>d?new il([],n):f;if(f&&p>d&&a<i&&f.array.length){for(var h=u=pl(u,n),g=s;g>ro;g-=ro){var y=d>>>g&oo;h=h.array[y]=pl(h.array[y],n)}h.array[d>>>ro&oo]=f}if(l<i&&(v=v&&v.removeAfter(n,0,l)),a>=p)a-=p,l-=p,s=ro,u=null,v=v&&v.removeBefore(n,0,a);else if(a>o||p<d){for(c=0;u;){var m=a>>>s&oo;if(m!==p>>>s&oo)break;m&&(c+=(1<<s)*m),s-=ro,u=u.array[m]}u&&a>o&&(u=u.removeBefore(n,s,a-c)),u&&p<d&&(u=u.removeAfter(n,s,p-c)),c&&(a-=c,l-=c)}return e.__ownerID?(e.size=l-a,e._origin=a,e._capacity=l,e._level=s,e._root=u,e._tail=v,e.__hash=void 0,e.__altered=!0,e):ul(a,l,s,u,v)}function hl(e){return e<no?0:e-1>>>ro<<ro}var gl,yl=function(e){function t(e){return null==e?bl():ci(e)?e:bl().withMutations((function(t){var r=wo(e);ea(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this.__altered=!0,this):bl()},t.prototype.set=function(e,t){return El(this,e,t)},t.prototype.remove=function(e){return El(this,e,io)},t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate((function(t){return t&&e(t[1],t[0],r)}),t)},t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?ml(t,r,e,this.__hash):0===this.size?bl():(this.__ownerID=e,this.__altered=!1,this._map=t,this._list=r,this)},t}(xa);function ml(e,t,r,n){var o=Object.create(yl.prototype);return o.size=e?e.size:0,o._map=e,o._list=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function bl(){return gl||(gl=ml(Wa(),cl()))}function El(e,t,r){var n,o,i=e._map,a=e._list,l=i.get(t),s=void 0!==l;if(r===io){if(!s)return e;a.size>=no&&a.size>=2*i.size?(n=(o=a.filter((function(e,t){return void 0!==e&&l!==t}))).toKeyedSeq().map((function(e){return e[0]})).flip().toMap(),e.__ownerID&&(n.__ownerID=o.__ownerID=e.__ownerID)):(n=i.remove(t),o=l===a.size-1?a.pop():a.set(l,void 0))}else if(s){if(r===a.get(l)[1])return e;n=i,o=a.set(l,[t,r])}else n=i.set(t,a.size),o=a.set(a.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=o,e.__hash=void 0,e.__altered=!0,e):ml(n,o)}yl.isOrderedMap=ci,yl.prototype[xo]=!0,yl.prototype[to]=yl.prototype.remove;var Ol="@@__IMMUTABLE_STACK__@@";function Sl(e){return Boolean(e&&e[Ol])}var Tl=function(e){function t(e){return null==e?Il():Sl(e)?e:Il().pushAll(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("Stack [","]")},t.prototype.get=function(e,t){var r=this._head;for(e=uo(this,e);r&&e--;)r=r.next;return r?r.value:t},t.prototype.peek=function(){return this._head&&this._head.value},t.prototype.push=function(){var e=arguments;if(0===arguments.length)return this;for(var t=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:e[n],next:r};return this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):Rl(t,r)},t.prototype.pushAll=function(t){if(0===(t=e(t)).size)return this;if(0===this.size&&Sl(t))return t;ea(t.size);var r=this.size,n=this._head;return t.__iterate((function(e){r++,n={value:e,next:n}}),!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):Rl(r,n)},t.prototype.pop=function(){return this.slice(1)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):Il()},t.prototype.slice=function(t,r){if(po(t,r,this.size))return this;var n=fo(t,this.size);if(vo(r,this.size)!==this.size)return e.prototype.slice.call(this,t,r);for(var o=this.size-n,i=this._head;n--;)i=i.next;return this.__ownerID?(this.size=o,this._head=i,this.__hash=void 0,this.__altered=!0,this):Rl(o,i)},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Rl(this.size,this._head,e,this.__hash):0===this.size?Il():(this.__ownerID=e,this.__altered=!1,this)},t.prototype.__iterate=function(e,t){var r=this;if(t)return new ei(this.toArray()).__iterate((function(t,n){return e(t,n,r)}),t);for(var n=0,o=this._head;o&&!1!==e(o.value,n++,this);)o=o.next;return n},t.prototype.__iterator=function(e,t){if(t)return new ei(this.toArray()).__iterator(e,t);var r=0,n=this._head;return new Bo((function(){if(n){var t=n.value;return n=n.next,Go(e,r++,t)}return{value:void 0,done:!0}}))},t}(Ro);Tl.isStack=Sl;var _l,wl=Tl.prototype;function Rl(e,t,r,n){var o=Object.create(wl);return o.size=e,o._head=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Il(){return _l||(_l=Rl(0))}wl[Ol]=!0,wl.shift=wl.pop,wl.unshift=wl.push,wl.unshiftAll=wl.pushAll,wl.withMutations=Ca,wl.wasAltered=ja,wl.asImmutable=La,wl["@@transducer/init"]=wl.asMutable=Na,wl["@@transducer/step"]=function(e,t){return e.unshift(t)},wl["@@transducer/result"]=function(e){return e.asImmutable()};var Al="@@__IMMUTABLE_SET__@@";function Cl(e){return Boolean(e&&e[Al])}function Nl(e){return Cl(e)&&Po(e)}function Ll(e,t){if(e===t)return!0;if(!mo(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||Eo(e)!==Eo(t)||So(e)!==So(t)||Po(e)!==Po(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!To(e);if(Po(e)){var n=e.entries();return t.every((function(e,t){var o=n.next().value;return o&&pi(o[1],e)&&(r||pi(o[0],t))}))&&n.next().done}var o=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{o=!0;var i=e;e=t,t=i}var a=!0,l=t.__iterate((function(t,n){if(r?!e.has(t):o?!pi(t,e.get(n,io)):!pi(e.get(n,io),t))return a=!1,!1}));return a&&e.size===l}function jl(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}function xl(e){if(!e||"object"!=typeof e)return e;if(!mo(e)){if(!oa(e))return e;e=Qo(e)}if(Eo(e)){var t={};return e.__iterate((function(e,r){t[r]=xl(e)})),t}var r=[];return e.__iterate((function(e){r.push(xl(e))})),r}var Pl=function(e){function t(t){return null==t?Vl():Cl(t)&&!Po(t)?t:Vl().withMutations((function(r){var n=e(t);ea(n.size),n.forEach((function(e){return r.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(wo(e).keySeq())},t.intersect=function(e){return(e=_o(e).toArray()).length?Dl.intersect.apply(t(e.pop()),e):Vl()},t.union=function(e){return(e=_o(e).toArray()).length?Dl.union.apply(t(e.pop()),e):Vl()},t.prototype.toString=function(){return this.__toString("Set {","}")},t.prototype.has=function(e){return this._map.has(e)},t.prototype.add=function(e){return kl(this,this._map.set(e,e))},t.prototype.remove=function(e){return kl(this,this._map.remove(e))},t.prototype.clear=function(){return kl(this,this._map.clear())},t.prototype.map=function(e,t){var r=this,n=!1,o=kl(this,this._map.mapEntries((function(o){var i=o[1],a=e.call(t,i,i,r);return a!==i&&(n=!0),[a,a]}),t));return n?o:this},t.prototype.union=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return 0===(t=t.filter((function(e){return 0!==e.size}))).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations((function(r){for(var n=0;n<t.length;n++)"string"==typeof t[n]?r.add(t[n]):e(t[n]).forEach((function(e){return r.add(e)}))})):this.constructor(t[0])},t.prototype.intersect=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.every((function(t){return t.includes(e)}))||n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.subtract=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.some((function(t){return t.includes(e)}))&&n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.sort=function(e){return os(Gi(this,e))},t.prototype.sortBy=function(e,t){return os(Gi(this,t,e))},t.prototype.wasAltered=function(){return this._map.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){return this._map.__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):0===this.size?this.__empty():(this.__ownerID=e,this._map=t,this)},t}(Io);Pl.isSet=Cl;var Fl,Dl=Pl.prototype;function kl(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function Ml(e,t){var r=Object.create(Dl);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function Vl(){return Fl||(Fl=Ml(Wa()))}Dl[Al]=!0,Dl[to]=Dl.remove,Dl.merge=Dl.concat=Dl.union,Dl.withMutations=Ca,Dl.asImmutable=La,Dl["@@transducer/init"]=Dl.asMutable=Na,Dl["@@transducer/step"]=function(e,t){return e.add(t)},Dl["@@transducer/result"]=function(e){return e.asImmutable()},Dl.__empty=Vl,Dl.__make=Ml;var Ul,Bl=function(e){function t(e,r,n){if(!(this instanceof t))return new t(e,r,n);if(Zi(0!==n,"Cannot step a Range by 0"),e=e||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<e&&(n=-n),this._start=e,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-e)/n-1)+1),0===this.size){if(Ul)return Ul;Ul=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},t.prototype.get=function(e,t){return this.has(e)?this._start+uo(this,e)*this._step:t},t.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},t.prototype.slice=function(e,r){return po(e,r,this.size)?this:(e=fo(e,this.size),(r=vo(r,this.size))<=e?new t(0,0):new t(this.get(e,this._end),this.get(r,this._end),this._step))},t.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},t.prototype.lastIndexOf=function(e){return this.indexOf(e)},t.prototype.__iterate=function(e,t){for(var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;i!==r&&!1!==e(o,t?r-++i:i++,this);)o+=t?-n:n;return i},t.prototype.__iterator=function(e,t){var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;return new Bo((function(){if(i===r)return{value:void 0,done:!0};var a=o;return o+=t?-n:n,Go(e,t?r-++i:i++,a)}))},t.prototype.equals=function(e){return e instanceof t?this._start===e._start&&this._end===e._end&&this._step===e._step:Ll(this,e)},t}(Jo);function Gl(e,t,r){for(var n=ta(t),o=0;o!==n.length;)if((e=la(e,n[o++],io))===io)return r;return e}function ql(e,t){return Gl(this,e,t)}function Kl(e,t){return Gl(e,t,io)!==io}function Wl(){ea(this.size);var e={};return this.__iterate((function(t,r){e[r]=t})),e}_o.isIterable=mo,_o.isKeyed=Eo,_o.isIndexed=So,_o.isAssociative=To,_o.isOrdered=Po,_o.Iterator=Bo,jl(_o,{toArray:function(){ea(this.size);var e=new Array(this.size||0),t=Eo(this),r=0;return this.__iterate((function(n,o){e[r++]=t?[o,n]:n})),e},toIndexedSeq:function(){return new ji(this)},toJS:function(){return xl(this)},toKeyedSeq:function(){return new Li(this,!0)},toMap:function(){return xa(this.toKeyedSeq())},toObject:Wl,toOrderedMap:function(){return yl(this.toKeyedSeq())},toOrderedSet:function(){return os(Eo(this)?this.valueSeq():this)},toSet:function(){return Pl(Eo(this)?this.valueSeq():this)},toSetSeq:function(){return new xi(this)},toSeq:function(){return So(this)?this.toIndexedSeq():Eo(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return Tl(Eo(this)?this.valueSeq():this)},toList:function(){return nl(Eo(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return zi(this,function(e,t){var r=Eo(e),n=[e].concat(t).map((function(e){return mo(e)?r&&(e=wo(e)):e=r?ii(e):ai(Array.isArray(e)?e:[e]),e})).filter((function(e){return 0!==e.size}));if(0===n.length)return e;if(1===n.length){var o=n[0];if(o===e||r&&Eo(o)||So(e)&&So(o))return o}var i=new ei(n);return r?i=i.toKeyedSeq():So(e)||(i=i.toSetSeq()),(i=i.flatten(!0)).size=n.reduce((function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}}),0),i}(this,e))},includes:function(e){return this.some((function(t){return pi(t,e)}))},entries:function(){return this.__iterator(ko)},every:function(e,t){ea(this.size);var r=!0;return this.__iterate((function(n,o,i){if(!e.call(t,n,o,i))return r=!1,!1})),r},filter:function(e,t){return zi(this,Mi(this,e,t,!0))},partition:function(e,t){return function(e,t,r){var n=Eo(e),o=[[],[]];e.__iterate((function(i,a){o[t.call(r,i,a,e)?1:0].push(n?[a,i]:i)}));var i=$i(e);return o.map((function(t){return zi(e,i(t))}))}(this,e,t)},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return ea(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){ea(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate((function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""})),t},keys:function(){return this.__iterator(Fo)},map:function(e,t){return zi(this,Di(this,e,t))},reduce:function(e,t,r){return Ql(this,e,t,r,arguments.length<2,!1)},reduceRight:function(e,t,r){return Ql(this,e,t,r,arguments.length<2,!0)},reverse:function(){return zi(this,ki(this,!0))},slice:function(e,t){return zi(this,Vi(this,e,t,!0))},some:function(e,t){ea(this.size);var r=!1;return this.__iterate((function(n,o,i){if(e.call(t,n,o,i))return r=!0,!1})),r},sort:function(e){return zi(this,Gi(this,e))},values:function(){return this.__iterator(Do)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(e,t){return so(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=xa().asMutable();return e.__iterate((function(o,i){n.update(t.call(r,o,i,e),0,(function(e){return e+1}))})),n.asImmutable()}(this,e,t)},equals:function(e){return Ll(this,e)},entrySeq:function(){var e=this;if(e._cache)return new ei(e._cache);var t=e.toSeq().map(Jl).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(Zl(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate((function(r,o,i){if(e.call(t,r,o,i))return n=[o,r],!1})),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(e){return this.find(co,null,e)},flatMap:function(e,t){return zi(this,function(e,t,r){var n=$i(e);return e.toSeq().map((function(o,i){return n(t.call(r,o,i,e))})).flatten(!0)}(this,e,t))},flatten:function(e){return zi(this,Bi(this,e,!0))},fromEntrySeq:function(){return new Pi(this)},get:function(e,t){return this.find((function(t,r){return pi(r,e)}),void 0,t)},getIn:ql,groupBy:function(e,t){return function(e,t,r){var n=Eo(e),o=(Po(e)?yl():xa()).asMutable();e.__iterate((function(i,a){o.update(t.call(r,i,a,e),(function(e){return(e=e||[]).push(n?[a,i]:i),e}))}));var i=$i(e);return o.map((function(t){return zi(e,i(t))})).asImmutable()}(this,e,t)},has:function(e){return this.get(e,io)!==io},hasIn:function(e){return Kl(this,e)},isSubset:function(e){return e="function"==typeof e.includes?e:_o(e),this.every((function(t){return e.includes(t)}))},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:_o(e)).isSubset(this)},keyOf:function(e){return this.findKey((function(t){return pi(t,e)}))},keySeq:function(){return this.toSeq().map(Xl).toIndexedSeq()},last:function(e){return this.toSeq().reverse().first(e)},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return qi(this,e)},maxBy:function(e,t){return qi(this,t,e)},min:function(e){return qi(this,e?es(e):rs)},minBy:function(e,t){return qi(this,t?es(t):rs,e)},rest:function(){return this.slice(1)},skip:function(e){return 0===e?this:this.slice(Math.max(0,e))},skipLast:function(e){return 0===e?this:this.slice(0,-Math.max(0,e))},skipWhile:function(e,t){return zi(this,Ui(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(Zl(e),t)},sortBy:function(e,t){return zi(this,Gi(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return this.slice(-Math.max(0,e))},takeWhile:function(e,t){return zi(this,function(e,t,r){var n=Yi(e);return n.__iterateUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterate(n,o);var a=0;return e.__iterate((function(e,o,l){return t.call(r,e,o,l)&&++a&&n(e,o,i)})),a},n.__iteratorUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterator(n,o);var a=e.__iterator(ko,o),l=!0;return new Bo((function(){if(!l)return{value:void 0,done:!0};var e=a.next();if(e.done)return e;var o=e.value,s=o[0],u=o[1];return t.call(r,u,s,i)?n===ko?e:Go(n,s,u,e):(l=!1,{value:void 0,done:!0})}))},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(Zl(e),t)},update:function(e){return e(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=Po(e),r=Eo(e),n=t?1:0;return function(e,t){return t=fi(t,3432918353),t=fi(t<<15|t>>>-15,461845907),t=fi(t<<13|t>>>-13,5),t=fi((t=t+3864292196^e)^t>>>16,2246822507),t=vi((t=fi(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+ns(gi(e),gi(t))|0}:function(e,t){n=n+ns(gi(e),gi(t))|0}:t?function(e){n=31*n+gi(e)|0}:function(e){n=n+gi(e)|0}),n)}(this))}});var zl=_o.prototype;zl[yo]=!0,zl[Uo]=zl.values,zl.toJSON=zl.toArray,zl.__toStringMapper=ia,zl.inspect=zl.toSource=function(){return this.toString()},zl.chain=zl.flatMap,zl.contains=zl.includes,jl(wo,{flip:function(){return zi(this,Fi(this))},mapEntries:function(e,t){var r=this,n=0;return zi(this,this.toSeq().map((function(o,i){return e.call(t,[i,o],n++,r)})).fromEntrySeq())},mapKeys:function(e,t){var r=this;return zi(this,this.toSeq().flip().map((function(n,o){return e.call(t,n,o,r)})).flip())}});var Hl=wo.prototype;Hl[bo]=!0,Hl[Uo]=zl.entries,Hl.toJSON=Wl,Hl.__toStringMapper=function(e,t){return ia(t)+": "+ia(e)},jl(Ro,{toKeyedSeq:function(){return new Li(this,!1)},filter:function(e,t){return zi(this,Mi(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return zi(this,ki(this,!1))},slice:function(e,t){return zi(this,Vi(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(t||0,0),0===r||2===r&&!t)return this;e=fo(e,e<0?this.count():this.size);var n=this.slice(0,e);return zi(this,1===r?n:n.concat(Ji(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(e){return this.get(0,e)},flatten:function(e){return zi(this,Bi(this,e,!1))},get:function(e,t){return(e=uo(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find((function(t,r){return r===e}),void 0,t)},has:function(e){return(e=uo(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return zi(this,function(e,t){var r=Yi(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var o=this,i=0;return e.__iterate((function(e){return(!i||!1!==r(t,i++,o))&&!1!==r(e,i++,o)}),n),i},r.__iteratorUncached=function(r,n){var o,i=e.__iterator(Do,n),a=0;return new Bo((function(){return(!o||a%2)&&(o=i.next()).done?o:a%2?Go(r,a++,t):Go(r,a++,o.value,o)}))},r}(this,e))},interleave:function(){var e=[this].concat(Ji(arguments)),t=Wi(this.toSeq(),Jo.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),zi(this,r)},keySeq:function(){return Bl(0,this.size)},last:function(e){return this.get(-1,e)},skipWhile:function(e,t){return zi(this,Ui(this,e,t,!1))},zip:function(){return zi(this,Wi(this,ts,[this].concat(Ji(arguments))))},zipAll:function(){return zi(this,Wi(this,ts,[this].concat(Ji(arguments)),!0))},zipWith:function(e){var t=Ji(arguments);return t[0]=this,zi(this,Wi(this,e,t))}});var $l=Ro.prototype;$l[Oo]=!0,$l[xo]=!0,jl(Io,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}});var Yl=Io.prototype;function Ql(e,t,r,n,o,i){return ea(e.size),e.__iterate((function(e,i,a){o?(o=!1,r=e):r=t.call(n,r,e,i,a)}),i),r}function Xl(e,t){return t}function Jl(e,t){return[t,e]}function Zl(e){return function(){return!e.apply(this,arguments)}}function es(e){return function(){return-e.apply(this,arguments)}}function ts(){return Ji(arguments)}function rs(e,t){return e<t?1:e>t?-1:0}function ns(e,t){return e^t+2654435769+(e<<6)+(e>>2)}Yl.has=zl.includes,Yl.contains=Yl.includes,Yl.keys=Yl.values,jl(Xo,Hl),jl(Jo,$l),jl(Zo,Yl);var os=function(e){function t(e){return null==e?ss():Nl(e)?e:ss().withMutations((function(t){var r=Io(e);ea(r.size),r.forEach((function(e){return t.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(wo(e).keySeq())},t.prototype.toString=function(){return this.__toString("OrderedSet {","}")},t}(Pl);os.isOrderedSet=Nl;var is,as=os.prototype;function ls(e,t){var r=Object.create(as);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function ss(){return is||(is=ls(bl()))}as[xo]=!0,as.zip=$l.zip,as.zipWith=$l.zipWith,as.zipAll=$l.zipAll,as.__empty=ss,as.__make=ls;var us=function(e,t){var r;!function(e){if(Lo(e))throw new Error("Can not call `Record` with an immutable Record as default values. Use a plain javascript object instead.");if(jo(e))throw new Error("Can not call `Record` with an immutable Collection as default values. Use a plain javascript object instead.");if(null===e||"object"!=typeof e)throw new Error("Can not call `Record` with a non-object as default values. Use a plain javascript object instead.")}(e);var n=function(i){var a=this;if(i instanceof n)return i;if(!(this instanceof n))return new n(i);if(!r){r=!0;var l=Object.keys(e),s=o._indices={};o._name=t,o._keys=l,o._defaultValues=e;for(var u=0;u<l.length;u++){var c=l[u];s[c]=u,o[c]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+ps(this)+' with property "'+c+'" since that property name is part of the Record API.'):vs(o,c)}}return this.__ownerID=void 0,this._values=nl().withMutations((function(e){e.setSize(a._keys.length),wo(i).forEach((function(t,r){e.set(a._indices[r],t===a._defaultValues[r]?void 0:t)}))})),this},o=n.prototype=Object.create(cs);return o.constructor=n,t&&(n.displayName=t),n};us.prototype.toString=function(){for(var e,t=ps(this)+" { ",r=this._keys,n=0,o=r.length;n!==o;n++)t+=(n?", ":"")+(e=r[n])+": "+ia(this.get(e));return t+" }"},us.prototype.equals=function(e){return this===e||Lo(e)&&fs(this).equals(fs(e))},us.prototype.hashCode=function(){return fs(this).hashCode()},us.prototype.has=function(e){return this._indices.hasOwnProperty(e)},us.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._indices[e],n=this._values.get(r);return void 0===n?this._defaultValues[e]:n},us.prototype.set=function(e,t){if(this.has(e)){var r=this._values.set(this._indices[e],t===this._defaultValues[e]?void 0:t);if(r!==this._values&&!this.__ownerID)return ds(this,r)}return this},us.prototype.remove=function(e){return this.set(e)},us.prototype.clear=function(){var e=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:ds(this,e)},us.prototype.wasAltered=function(){return this._values.wasAltered()},us.prototype.toSeq=function(){return fs(this)},us.prototype.toJS=function(){return xl(this)},us.prototype.entries=function(){return this.__iterator(ko)},us.prototype.__iterator=function(e,t){return fs(this).__iterator(e,t)},us.prototype.__iterate=function(e,t){return fs(this).__iterate(e,t)},us.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._values.__ensureOwner(e);return e?ds(this,t,e):(this.__ownerID=e,this._values=t,this)},us.isRecord=Lo,us.getDescriptiveName=ps;var cs=us.prototype;function ds(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._values=t,n.__ownerID=r,n}function ps(e){return e.constructor.displayName||e.constructor.name||"Record"}function fs(e){return ii(e._keys.map((function(t){return[t,e.get(t)]})))}function vs(e,t){try{Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){Zi(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}catch(e){}}cs[No]=!0,cs[to]=cs.remove,cs.deleteIn=cs.removeIn=ga,cs.getIn=ql,cs.hasIn=zl.hasIn,cs.merge=Ea,cs.mergeWith=Oa,cs.mergeIn=Ia,cs.mergeDeep=wa,cs.mergeDeepWith=Ra,cs.mergeDeepIn=Aa,cs.setIn=va,cs.update=ma,cs.updateIn=ba,cs.withMutations=Ca,cs.asMutable=Na,cs.asImmutable=La,cs[Uo]=cs.entries,cs.toJSON=cs.toObject=zl.toObject,cs.inspect=cs.toSource=function(){return this.toString()};var hs,gs=function(e){function t(e,r){if(!(this instanceof t))return new t(e,r);if(this._value=e,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(hs)return hs;hs=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},t.prototype.get=function(e,t){return this.has(e)?this._value:t},t.prototype.includes=function(e){return pi(this._value,e)},t.prototype.slice=function(e,r){var n=this.size;return po(e,r,n)?this:new t(this._value,vo(r,n)-fo(e,n))},t.prototype.reverse=function(){return this},t.prototype.indexOf=function(e){return pi(this._value,e)?0:-1},t.prototype.lastIndexOf=function(e){return pi(this._value,e)?this.size:-1},t.prototype.__iterate=function(e,t){for(var r=this.size,n=0;n!==r&&!1!==e(this._value,t?r-++n:n++,this););return n},t.prototype.__iterator=function(e,t){var r=this,n=this.size,o=0;return new Bo((function(){return o===n?{value:void 0,done:!0}:Go(e,t?n-++o:o++,r._value)}))},t.prototype.equals=function(e){return e instanceof t?pi(this._value,e._value):Ll(this,e)},t}(Jo);function ys(e,t){return ms([],t||bs,e,"",t&&t.length>2?[]:void 0,{"":e})}function ms(e,t,r,n,o,i){if("string"!=typeof r&&!jo(r)&&(Yo(r)||Ko(r)||na(r))){if(~e.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");e.push(r),o&&""!==n&&o.push(n);var a=t.call(i,n,Qo(r).map((function(n,i){return ms(e,t,n,i,o,r)})),o&&o.slice());return e.pop(),o&&o.pop(),a}return r}function bs(e,t){return So(t)?t.toList():Eo(t)?t.toMap():t.toSet()}const Es={version:"4.3.7",Collection:_o,Iterable:_o,Seq:Qo,Map:xa,OrderedMap:yl,List:nl,Stack:Tl,Set:Pl,OrderedSet:os,PairSorting:{LeftThenRight:-1,RightThenLeft:1},Record:us,Range:Bl,Repeat:gs,is:pi,fromJS:ys,hash:gi,isImmutable:jo,isCollection:mo,isKeyed:Eo,isIndexed:So,isAssociative:To,isOrdered:Po,isValueObject:di,isPlainObject:na,isSeq:Co,isList:rl,isMap:ui,isOrderedMap:ci,isStack:Sl,isSet:Cl,isOrderedSet:Nl,isRecord:Lo,get:la,getIn:Gl,has:aa,hasIn:Kl,merge:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return _a(e,t)},mergeDeep:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Ta(e,t)},mergeWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return _a(t,r,e)},mergeDeepWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return Ta(t,r,e)},remove:ua,removeIn:ha,set:ca,setIn:fa,update:ya,updateIn:da};var Os=0;const Ss=function(){var e=((new Date).getTime().toString(16)+"FF").substr(0,11);return"ssssssss-xxxx-4xxx-yxxx-x".replace(/[xys]/g,(function(e){var t="s"===e?Math.floor(16*Math.random()):15&Os++;return("x"===e?t:3&t|8).toString(16)}))+e};function Ts(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var _s=["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue","spelImportFuncs","spelImportValue"],ws=["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"],Rs=function(e){return"object"===Vn(e)&&null!==e&&"[object Object]"===Object.prototype.toString.call(e)},Is=function(e){if("object"===Vn(e)&&null!==e){if(Array.isArray(e))return eo(e);if(Rs(e))return function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ts(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ts(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},e)}return e},As=function(e,t){return Object.fromEntries(Object.entries(e).filter((function(e){var r=Jn(e,1)[0];return!t.includes(r)})))},Cs=function(e){var t;return null!==(t=null==e?void 0:e.cardinality)&&void 0!==t?t:1},Ns=function(e,t){return e===t||(xa.isMap(e)?e.equals(t):JSON.stringify(e)==JSON.stringify(t))},Ls=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?Ls(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):xa.isMap(e)?e.equals(t):"object"==Vn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var l=n[a];if(!(r?Ls(e[l],t[l],r):e[l]===t[l]))return!1}return!0}(e,t,r):e===t)};var js=function(e){return"object"===Vn(e)&&null!==e&&"function"==typeof e.toJS},xs=function(e){return js(e)&&Es.isList(e)};function Ps(e){return xs(e)?e:new Es.List(e)}function Fs(e){return js(e)?e.toJS():e}var Ds=function(e){return e.replace(/[.*+?^${}()|[\]\\/]/g,"\\$&")},ks=function(e,t,r,n,o,i){if(Array.isArray(e))return t},Ms=function e(t){var r;if(t instanceof Array)return t.map((function(t,r){return e(t)}));if("object"===Vn(t)&&null!==t&&Vs(t)){var n,o=As(t,["$$typeof","_owner","_store","ref","key"]);return o.type&&(o.type="string"==typeof(r=o.type)?r:"function"==typeof r?r.name:r),null!=o&&null!==(n=o.props)&&void 0!==n&&n.children&&(o.props.children=e(o.props.children)),o}return t},Vs=function(e){return"object"===Vn(e)&&null!==e&&!Array.isArray(e)&&Object.keys(e).includes("type")&&Object.keys(e).includes("props")&&Object.keys(e).includes("key")&&Object.keys(e).includes("ref")&&Object.keys(e).includes("$$typeof")},Us=function(e){return"object"===Vn(e)&&null!==e&&!Array.isArray(e)&&"string"==typeof e.type&&Object.keys(e).includes("props")},Bs=function(e){return"object"===Vn(e)&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length};function Gs(e){return new Promise((function(t){setTimeout(t,e)}))}function qs(e,t){return e||(e=[]),t||(t=[]),t.map((function(t){return[t,e.indexOf(t)]})).map((function(e,t,r){var n=Jn(e,2),o=n[0];if(-1==n[1]){var i=r.slice(t+1),a=r.slice(0,t).reverse().find((function(e){var t=Jn(e,2);return t[0],-1!=t[1]})),l=i.find((function(e){var t=Jn(e,2);return t[0],-1!=t[1]}));return l?[o,"before",l[0]]:a?[o,"after",a[0]]:[o,"append",null]}return null})).filter((function(e){return null!==e})).reduce((function(e,t){var r=Jn(t,3),n=r[0],o=r[1],i=r[2],a=e.indexOf(i);return-1==e.indexOf(n)&&(a>-1?e.splice(a+("after"==o?1:0),0,n):e.splice("append"==o?1/0:0,0,n)),e}),e.slice())}var Ks=function e(t){"object"!==Vn(t)||null===t||Vs(t)||(Object.keys(t).forEach((function(r){"__cache"!==r&&e(t[r])})),Object.freeze(t))},Ws=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(Rs(t)){if(t.var)return n[t.var]=r,!0;if(!Rs(r))return!1;for(var i in t)if(!e(t[i],r[i],n,[].concat(eo(o),[i])))return!1;return!0}if(Array.isArray(t)){if(!Array.isArray(r))return!1;for(var a=0;a<t.length;a++)if(!e(t[a],r[a],n,[].concat(eo(o),[a])))return!1;return!0}return t===r},zs=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}},Hs=function(){for(var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=0;r<t.length;r++){var n=t[r];if(void 0!==n){e=n;break}}return e},$s=zs(),Ys=p(6834),Qs=p.n(Ys),Xs=p(8831),Js=p.n(Xs),Zs=p(8906),eu=p.n(Zs),tu=p(7027),ru=p.n(tu);function nu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function ou(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function iu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?ou(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):ou(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var au=function(e){return"object"==Vn(e)&&null!==e&&!Array.isArray(e)},lu=function(e,t){return null==e||""==e?void 0:au(e)?iu(iu({},e),{},{title:e.title||e.value}):{value:e,title:void 0!==t?t:""+e}},su=function(e){var t=lu(e);return au(t)?iu(iu({},lu(e)),{},{isCustom:!0}):t},uu=function(e){if(Array.isArray(e))return e.map((function(e){return lu(e)}));if(!au(e))return e;var t=[];for(var r in e){var n=e[r];t.push(lu(r,n))}return t},cu=function(e,t){return Array.isArray(e)?e.map((function(e){return lu(e)})).find((function(e){return""+e.value==""+t})):void 0!==e[t]?lu(t,e[t]):void 0},du=function(e,t){if(null==e)return t;var r=cu(e,t);return void 0!==r?r.title:t},pu=function(e,t){if(null==e)return t;var r=cu(e,t);return void 0!==r?r.value:t},fu=function(e,t){var r=[];if(Array.isArray(e)){var n,o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return nu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?nu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(e);try{for(o.s();!(n=o.n()).done;){var i=n.value,a=t(lu(i));null!=a&&r.push(a)}}catch(e){o.e(e)}finally{o.f()}}else for(var l in e){var s=t(lu(l,e[l]));null!=s&&r.push(s)}return r},vu=function(e,t){return fu(t,(function(t){return-1!="".concat(t.value).indexOf(e)||-1!=t.title.indexOf(e)?t:null})).filter((function(e){return null!==e})).shift()},hu=function(e,t){return fu(t,(function(t){return""+t.value==""+e?t:null})).filter((function(e){return null!==e})).shift()},gu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.skip(1),e.push.apply(e,r),e}))},yu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.push.apply(e,r),e}))},mu=function(e,t){var r=new Es.OrderedMap(Hn({},e.get("id"),e)),n=e;return t.forEach((function(e){var t;n=r.get(e),r=null===(t=n)||void 0===t?void 0:t.get("children1")})),n},bu=function(e){var t=e;return function e(r,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=n.push(r.get("id")),a=r.getIn(["properties","isLocked"]);o&&a&&(t=t.deleteIn(gu(i,"properties","isLocked")));var l=r.get("children1");l&&l.map((function(t,r){e(t,i,a||o)}))}(e,new Es.List),t},Eu=function(e){var t=e;return function e(r,n,o,i){if(r){var a=r.get("path"),l=r.get("id"),s=l||i||Ss(),u=n.push(s);a&&a.equals(u)||(t=t.setIn(gu(u,"path"),u)),l||(t=t.setIn(gu(u,"id"),s));var c=r.get("children1");c&&("Map"===c.constructor.name&&(t=t.setIn(gu(u,"children1"),new Es.OrderedMap(c))),c.map((function(t,r){e(t,u,o+1,r)})))}}(e,new Es.List,0),t},Ou=function(e){var t=e;return function e(r,n,o,i){if(!r)return!1;var a=r.get("id")||i,l=n.push(a),s=r.get("children1");if(s){var u=s.map((function(t,r){return e(t,l,o+1,r)})).reduce((function(e,t){return e&&t}),!0);if((0==s.size||u)&&o>0)return t=t.deleteIn(gu(l)),!0}return!1}(e,new Es.List,0),t},Su=function(e){var t=[],r={},n=[],o=0,i=0,a=0,l={};!function s(u,c,d,p,f,v,h,g){var y=u===e,m=u.get("type"),b=u.get("collapsed"),E=u.get("id"),O=u.get("children1"),S=u.getIn(["properties","isLocked"]),T=O?O.map((function(e,t){return t})).valueSeq().toArray():null,_="rule_group"===m,w="rule"===m,R="group"===m,I="case_group"===m,A=!f&&(!O||_),C=(null==T?void 0:T.length)>0,N=c.length?c[c.length-1]:null,L=I?E:h;I&&(n.push(E),i=0,a=0,l={});var j,x=L?n.indexOf(L):null,P=t.length,F=o;y||((j={}).caseNo=x,j.globalNoByType=I?x:l[m]||0,j.indexPath=[].concat(eo(c.slice(1).map((function(e){return r[e].childNo}))),[g]),w?j.globalLeafNo=i:R&&(j.globalGroupNo=a)),t.push(E),r[E]={node:u,index:P,id:E,type:m,parent:N,parentType:N?r[N].type:null,children:T,childNo:g,caseId:L,caseNo:x,path:c.concat(E),lev:v,isLeaf:!O,isAtomicRule:A,isLocked:S||p,top:d?null:F,isDefaultCase:I?!O:void 0,atomicRulesCountInCase:I?0:void 0,position:j,collapsed:b,_top:P,leaf:!O};var D=0,k=0;d||(o+=1,D+=1,!C||b||_||(k+=1),y||I||(R&&a++,w&&i++,l[m]=(l[m]||0)+1)),h&&A&&r[h].atomicRulesCountInCase++;var M=0,V=0;if(C){var U=0;O.map((function(e,t){if(e){s(e,c.concat(E),d||b,p||S,f||_,v+1,L,U);var n=r[t];M=Math.max(M,n.depth||0),V+=n.height,U++}}))}D+=V,k+=M;var B=t.length-P,G=d?null:F+D;Object.assign(r[E],{depth:O?k:void 0,_height:B,height:D,bottom:G})}(e,[],!1,!1,!1,0,null,null);for(var s=0;s<t.length;s++){var u=s>0?t[s-1]:null,c=s<t.length-1?t[s+1]:null,d=r[t[s]];d.prev=u,d.next=c}return{flat:t,items:r,cases:n}},Tu=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,l;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),l=r.get("type")):(i=r.id,a=r.children1,l=r.type),t++,a&&"rule_group"!=l&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t-1},_u=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,l;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),l=r.get("type")):(i=r.id,a=r.children1,l=r.type),"rule"==l||"rule_group"==l?t++:a&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t},wu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=e;return function e(n,o){t&&n.path&&delete n.path,t&&!r&&o&&delete n.id;var i=n.properties;i&&null==i.operatorOptions&&delete i.operatorOptions;var a=n.children1;if(a){for(var l in a)a[l]&&e(a[l],l);r&&(n.children1=Object.values(a))}}(e,null),n},Ru=function(e){var t=[],r=e.get("children1");return r&&r.map((function(e){var r,n=e.getIn(["properties","value"]);n&&1==n.size?(r=n.get(0),Array.isArray(r)&&0==r.length&&(r=null)):r=null,t=[].concat(eo(t),[r])})),t},Iu=function(e){return!e.get("children1")||0==e.get("children1").size},Au=function(e,t){return e.getIn(gu(t,"children1")).size>0},Cu=function(e){if(null!=e&&e.toJS){var t,r=null==e||null===(t=e.toJS)||void 0===t?void 0:t.call(e);return null!=r&&r.func?e.toOrderedMap():r}return e},Nu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(e){var n=e;return n=n.toJS(),wu(n,t,r)}},Lu=function(e){if(ju(e))return e;if(xu(e))return Eu(Pu(e));if("string"==typeof e&&e.startsWith('["~#iM"'))throw new Error("You are trying to load query in obsolete serialization format (Immutable string) which is not supported in versions starting from 2.1.17");if("string"==typeof e)return Eu(Pu(JSON.parse(e)));throw new Error("Can't load tree!")},ju=function(e){return xa.isMap(e)},xu=function(e){return"object"==Vn(e)&&("group"==e.type||"switch_group"==e.type)};function Pu(e){var t=ys(e,(function(e,t,r){var n,o=r&&r.length>3&&"value"===r[r.length-1]&&"args"===r[r.length-3],i=r&&r.length>3&&"value"===r[r.length-1]&&"properties"===r[r.length-2];if("properties"==e){n=t.toOrderedMap();for(var a=0;a<2;a++){var l,s,u;null===(null===(l=n.get("value"))||void 0===l||null===(s=(u=l).get)||void 0===s?void 0:s.call(u,a))&&(n=n.setIn(["value",a],void 0))}}else n=o?Cu(t):(r?i:"value"==e)&&Es.Iterable.isIndexed(t)?t.map(Cu).toList():"asyncListValues"==e?t.toJS():"children1"==e&&Es.Iterable.isIndexed(t)?new Es.OrderedMap(t.map((function(e){return[(null==e?void 0:e.get("id"))||Ss(),e]}))):Es.Iterable.isIndexed(t)?t.toList():t.toOrderedMap();return n}));return t}function Fu(e){return $n(e)||Zn(e)||Qn(e)||Xn()}var Du=p(2468),ku=p.n(Du);function Mu(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Vu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Mu(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Mu(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Uu(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Bu(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Bu(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function Bu(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var Gu="jlField",qu="jlArgs",Ku=["==","!="],Wu=["<","<=",">",">="],zu=["multiselect_equals","multiselect_not_equals","multiselect_contains","multiselect_not_contains"],Hu=function(e){return{errors:[],settings:null==e?void 0:e.settings}},$u=function(e,t){return Yu(e,t,!1)},Yu=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=Hu();n.settings={allowUnknownFields:!1,returnErrors:r};var o=yh(t,void 0,!1),i=Qu(o),a=e?Zu(e,i,o,["rule","group","switch"],n):void 0,l=a?Lu(a):void 0;return r?[l,n.errors]:(n.errors.length&&console.warn("Errors while importing from JsonLogic:",n.errors),l)},Qu=function(e){var t={},r={};for(var n in e.operators){var o=e.operators[n];if("string"==typeof o.jsonLogic){var i=o.jsonLogic+"/"+Cs(o);t[i]||(t[i]=[]),t[i].push(n)}else if("string"==typeof o.jsonLogic2){var a=o.jsonLogic2+"/"+Cs(o);t[a]||(t[a]=[]),t[a].push(n),r[n]||(r[n]={}),r[n]={template:o.jsonLogic(Gu,n,qu),jsonLogic2:o.jsonLogic2,_jsonLogicIsExclamationOp:!!o._jsonLogicIsExclamationOp}}}var l={};for(var s in e.conjunctions)l[e.conjunctions[s].jsonLogicConj||s.toLowerCase()]=s;var u,c={},d=Uu(Ih(e));try{for(d.s();!(u=d.n()).done;){var p=Jn(u.value,2),f=p[0],v=p[1],h=void 0;v.jsonLogicIsMethod?h="#"+v.jsonLogic:"string"==typeof v.jsonLogic&&(h=v.jsonLogic),h&&(c[h]||(c[h]=[]),c[h].push(f))}}catch(e){d.e(e)}finally{d.f()}var g=e.settings.jsonLogic;return{operators:t,conjunctions:l,funcs:c,varKeys:["var",g.groupVarKey,g.altVarKey],combinationOperators:r}},Xu=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(null!=t&&t.combinationOperators)for(var i=0,a=Object.entries(t.combinationOperators);i<a.length;i++){var l=Jn(a[i],2),s=l[0],u=l[1];if(null==o||o.includes(s)){var c=Ju(u.template,e);c.match&&(n?r.errors.push("Operator matched against 2 templates: ".concat(n.newOp," and ").concat(s)):n=c,n.newOp=u.jsonLogic2)}}return n},Ju=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{match:!0,jlField:null,jlArgs:[]};if(null==t||null==r)return n.match=!1,n;var o=Object.keys(t),i=Object.keys(r);if(o.length!==i.length)return n.match=!1,n;for(var a=0;a<o.length;a++){var l=o[a],s=t[l];if(l!==i[a])return n.match=!1,n;if(s===Gu&&Bs(r[l]))n.jlField=r[l];else if(s===qu)n.jlArgs.push(r[l]);else if("object"===Vn(s)&&null!==s||Array.isArray(s))n=e(s,r[l],n);else if(s!==r[l])return n.match=!1,n}return n},Zu=function e(t,r,n,o,i){var a,l,s,u=arguments.length>5&&void 0!==arguments[5]&&arguments[5],c=arguments.length>6?arguments[6]:void 0,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;Bs(t)&&(a=Object.keys(t)[0],l=t[a],Array.isArray(l)||(l=[l]));var f=i.errors.length,v=n.settings.jsonLogic.lockedOp,h="!"==a&&1==l.length&&l[0]&&Bs(l[0])&&r.varKeys.includes(Object.keys(l[0])[0]),g=Xu(t,r,i);g&&((l=[])[0]=g.jlField,g.jlArgs.forEach((function(e){return l.push(e)})),a=g.newOp);var y="!"==a&&!h,m=v&&a==v,b=o.includes("switch");m?s=e(l[0],r,n,o,i,u,c,d,p,!0):y?s=e(l[0],r,n,o,i,!u,c,d,p):o.includes("val")?s=tc(a,l,r,n,u,i,p)||rc(a,l,r,n,u,c,i,p)||ec(t,c,d,n,i):(o.includes("switch")&&(s=lc(a,l,r,n,u,i,p)),null==s&&o.includes("group")&&(s=nc(a,l,r,n,u,i,p,!1)),null==s&&o.includes("rule")&&(s=ac(a,l,r,n,u,i,p)),s&&b&&!["group","switch_group"].includes(s.type)&&(s=oc(s,n)));var E=i.errors.length;return"!"!=a&&void 0===s&&E==f&&i.errors.push("Can't parse logic ".concat(JSON.stringify(t))),m&&(s.properties.isLocked=!0),s},ec=function(e,t,r,n,o){var i;if(void 0===e&&(e=null==t?void 0:t.defaultValue),void 0!==e){r=r||(null==t?void 0:t.mainWidget);var a=n.widgets[r],l=null==t?void 0:t.type;if(!l||a){if(!Bs(e)){if("time"===l&&"number"==typeof e){var s=Math.floor(e/60/60)%24,u=Math.floor(e/60)%60,c=e%60,d=a.valueFormat;if(d){var p=new Date(e);p.setMilliseconds(0),p.setHours(s),p.setMinutes(u),p.setSeconds(c),e=ku()(p).format(d)}else e="".concat(s,":").concat(u,":").concat(c)}if(["date","datetime"].includes(l)&&e&&!(e instanceof Date))try{var f=new Date(e);f instanceof Date&&f.toISOString()===e&&(e=f)}catch(t){o.errors.push("Can't convert value ".concat(e," as Date")),e=void 0}if(e instanceof Date&&t){var v=a.valueFormat;v&&(e=ku()(e).format(v))}var h;if(e&&null!=t&&null!==(i=t.fieldSettings)&&void 0!==i&&i.asyncFetch&&(h=Array.isArray(e)?e:[e]),null!=a&&a.jsonLogicImport)try{e=a.jsonLogicImport.call(n.ctx,e)}catch(t){var g;o.errors.push("Can't import value ".concat(e," using import func of widget ").concat(r,": ").concat(null!==(g=null==t?void 0:t.message)&&void 0!==g?g:t)),e=void 0}return{valueSrc:"value",value:e,valueType:null==a?void 0:a.type,asyncListValues:h}}o.errors.push("Unexpected logic in value: ".concat(JSON.stringify(e)))}else o.errors.push("No widget for type ".concat(l))}},tc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(r.varKeys.includes(e)&&"string"==typeof t[0]){var l,s=Lh(n,t[0],a),u=qh(n,s);return u||null!==(l=i.settings)&&void 0!==l&&l.allowUnknownFields?{valueSrc:"field",value:s,valueType:null==u?void 0:u.type}:void i.errors.push("No config for field ".concat(s))}},rc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6?arguments[6]:void 0,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;if(e){var s,u,c,d="method"==e;if(d){var p,f,v=Fu(t);p=v[0],s=v[1],f=v.slice(2),u=[p].concat(eo(f))}else s=e,u=t;var h=(d?"#":"")+s,g=(null==i?void 0:i.type)||(null==i?void 0:i.returnType),y=(r.funcs[h]||[]).filter((function(e){return!i||xh(n,e).returnType==g}));if(y.length)c=y[0];else{var m,b=Hn({},e,t),E=Uu(Ih(n));try{for(E.s();!(m=E.n()).done;){var O=Jn(m.value,2),S=O[0],T=O[1];if(T.jsonLogicImport&&(!g||T.returnType==g)){var _=void 0;try{_=T.jsonLogicImport(b)}catch(e){}_&&(c=S,u=_)}}}catch(e){E.e(e)}finally{E.f()}}if(c&&c){var w=xh(n,c),R=Object.keys(w.args||{}),I=u.reduce((function(e,t,o){var i,s=R[o],u=w.args[s];return u&&(i=Zu(t,r,n,["val"],a,!1,u,null,l)),void 0!==i?Vu(Vu({},e),{},Hn({},s,i)):e}),{});for(var A in w.args){var C,N=w.args[A],L=I[A];if(void 0===L)if(void 0!==(L=null==N?void 0:N.defaultValue)&&(L={value:L,valueSrc:null!==(C=L)&&void 0!==C&&C.func?"func":"value",valueType:N.type}),void 0===L){if(null==N||!N.isOptional)return void a.errors.push("No value for arg ".concat(A," of func ").concat(c))}else I[A]=L}return{valueSrc:"func",value:{func:c,args:I},valueType:w.returnType}}}},nc=function(e,t,r,n,o,i){var a,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,s=r.conjunctions[e],u=n.settings.fieldSeparator;if(s){var c=t.map((function(e){return Zu(e,r,n,["rule","group"],i,!1,null,null,l)})).filter((function(e){return void 0!==e})).reduce((function(e,t){return Vu(Vu({},e),{},Hn({},t.id,t))}),{}),d=Object.values(c).map((function(e){var t,r;return"field"==(null==e||null===(t=e.properties)||void 0===t?void 0:t.fieldSrc)&&(null==e||null===(r=e.properties)||void 0===r?void 0:r.field)})).filter((function(e){var t;return null==e||null===(t=e.includes)||void 0===t?void 0:t.call(e,u)})),p=Object.fromEntries((a=d,Array.from(new Set(a))).map((function(e){var t=e.split(u),r=Object.fromEntries(t.slice(0,-1).map((function(e,t,r){return[].concat(eo(r.slice(0,t)),[e])})).map((function(e){return[e.join(u),qh(n,e)]})).filter((function(e){var t=Jn(e,2),r=(t[0],t[1]);return"!group"==(null==r?void 0:r.type)})));return[e,Object.keys(r)]}))),f={conjunction:s,not:o},v=Ss(),h={},g={};return Object.entries(c).map((function(e){var t=Jn(e,2),r=t[0],o=t[1];if("group"==(null==o?void 0:o.type)||"rule_group"==(null==o?void 0:o.type))h[r]=o;else{var i,a=null==o||null===(i=o.properties)||void 0===i?void 0:i.field,c=p[a]||[],d=c[c.length-1];if(d){var f=h,v=kh(l,n),y=kh(d,n);Ls(v,y.slice(0,v.length))||(v=[]);var m=d.split(u).slice(v.length).map((function(e,t,r){return[].concat(eo(v),eo(r.slice(0,t)),[e]).join(u)})).map((function(e){return{f:e,fc:qh(n,e)||{}}})).filter((function(e){return"!struct"!=e.fc.type}));m.map((function(e,t){var r=e.f,n=e.fc,o=g[r];o||(o=Ss(),g[r]=o,f[o]={type:"rule_group",id:o,children1:{},properties:{conjunction:s,not:!1,field:r,fieldSrc:"field",mode:n.mode}}),f=f[o].children1})),f[r]=o}else o&&(h[r]=o)}})),{type:"group",id:v,children1:h,properties:f}}},oc=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Ss(),children1:Hn({},e.id,e),properties:{conjunction:wd(t),not:r}}},ic=function(e,t,r,n,o,i,a){var l,s=zu.map((function(e){var t;return null===(t=i.operators[e])||void 0===t?void 0:t.jsonLogic2})).includes(e),u=i.settings.groupOperators.includes(e)&&!s,c=u?0:t-1;u?c=0:Ku.includes(e)&&1==c&&null===r[1]&&(t=1,c=0,r=[r[0]]);var d=e+"/"+c,p=o.operators[d];if(p){var f,v=[];if(Wu.includes(e)&&3==t)f=r[1],v=[r[0],r[2]];else{var h=Fu(r);f=h[0],v=h.slice(1)}if(Bs(f)){var g=function(e,t,r,n,o){var i,a,l,s,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null,f=Object.keys(t)[0],v=Object.values(t)[0],h=function(e,t){return function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;Array.isArray(t)||(t=[t]);var l=tc(e,t,r,n,o,i,a);if(l)return{fieldSrc:"field",field:l.value}}(e,t,n,o,u,d,p)||function(e,t,r,n,o){var i=rc(e,t,r,n,o,arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,arguments.length>6?arguments[6]:void 0,arguments.length>7&&void 0!==arguments[7]?arguments[7]:null);if(i)return{fieldSrc:"func",field:i.value}}(e,t,n,o,u,c,d,p)},g=d.errors.length,y=h(f,v);if(y&&(i=y.field,a=y.fieldSrc),e&&(s=!0,l=r[0],r=[]),"reduce"==f&&Array.isArray(v)&&3==v.length){var m=Jn(v,3),b=m[0],E=m[1],O=m[2];if(Bs(b)&&0==O&&Bs(E)&&Array.isArray(E["+"])&&1==E["+"][0]&&Bs(E["+"][1])&&"accumulator"==E["+"][1].var)if(f=Object.keys(b)[0],v=Object.values(b)[0],"filter"==f){var S=Jn(v,2),T=S[0],_=S[1];if(Bs(T)){var w=h(f=Object.keys(T)[0],v=Object.values(T)[0]);w&&(i=w.field,a=w.fieldSrc,l=_,s=!0)}}else{var R=h(f,v);R&&(i=R.field,a=R.fieldSrc,s=!0)}}var I=d.errors.length;if(i||I!=g||d.errors.push("Unknown LHS ".concat(JSON.stringify(t))),i)return{field:i,fieldSrc:a,having:l,isGroup:s,args:r}}(u,f,v,o,i,null,null,a,n);if(g){var y=g.field,m=g.fieldSrc,b=g.having,E=(g.isGroup,g.args),O=qh(i,y);if(O||null!==(l=a.settings)&&void 0!==l&&l.allowUnknownFields){var S=p[0];if(p.length>1&&O&&O.operators){if(0==(p=p.filter((function(e){return O.operators.includes(e)}))).length)return void a.errors.push("No corresponding ops for LHS ".concat(y));S=p[0]}return{field:y,fieldSrc:m,fieldConfig:O,opKey:S,args:E,having:b}}a.errors.push("No config for LHS ".concat(y))}}else a.errors.push("Incorrect operands for ".concat(e,": ").concat(JSON.stringify(r)))}},ac=function e(t,r,n,o,i,a){var l,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(t){var c=Object.values(o.conjunctions).map((function(e){return e.jsonLogicConj})),d=function(e,t,r,n,o,i,a){var l=Hu(a),s=ic(e,t,r,n,o,i,l);if(s)return s;a.errors.push(l.errors.join("; ")||"Unknown op ".concat(e,"/").concat(t))}(t,r.length,r,s,n,o,a);if(d){var p,f,v=d.field,h=d.fieldSrc,g=d.fieldConfig,y=d.opKey,m=d.args,b=d.having,E=qh(o,s),O=o.operators[y],S=!!o.operators[null===(l=O)||void 0===l?void 0:l.reversedOp],T="!group"==g.type,_="!group"==(null==E?void 0:E.type),w=S&&(!!o.settings.reverseOperatorsForNot||T&&!b||!T&&_&&!u),R=i&&w||!1,I=!1,A=!!o.settings.reverseOperatorsForNot;if("!group"==(null==g?void 0:g.type)&&b){p=Object.keys(b)[0],f=b[p],Array.isArray(f)||(f=[f]);for(var C=Xu(b,n,a);"!"==p&&!C&&!("!"==p&&1==f.length&&f[0]&&Bs(f[0])&&n.varKeys.includes(Object.keys(f[0])[0]));){I=!I,b=b["!"],p=Object.keys(b)[0],f=b[p],A&&c.includes(p)&&1==f.length&&(b=b[p][0],p=Object.keys(b)[0],f=b[p]),C=Xu(b,n,a)||C}Array.isArray(f)||(f=[f]),C&&((f=[])[0]=C.jlField,C.jlArgs.forEach((function(e){return f.push(e)})),p=C.newOp)}R&&(i=!i,y=O.reversedOp,O=o.operators[y]);var N=cv(o,v,y,null),L=m.map((function(e){return Zu(e,n,o,["val"],a,!1,g,N,s)}));if(!L.filter((function(e){return void 0===e})).length){var j,x=null==g?void 0:g.type;if("!group"!==x&&"!struct"!==x||(x=null),"!group"==(null==g?void 0:g.type)&&b){var P;if(void 0!==n.conjunctions[p]?j=nc(p,f,n,o,I,a,v,!0):(j=e(p,f,n,o,I,a,v,!0))&&("rule_group"===j.type&&(null===(P=j.properties)||void 0===P?void 0:P.field)!==v&&(j=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0,i=arguments.length>5&&void 0!==arguments[5]&&arguments[5];if(e)return{type:"rule_group",id:Ss(),children1:Hn({},e.id,e),properties:{conjunction:o||_d(n,r),not:i,field:t}}}(j,v,g,o)),Object.assign(j.properties,{conjunction:_d(o,g)})),!j)return;j.type="rule_group",Object.assign(j.properties,{field:v,mode:g.mode,operator:y}),"array"==g.mode&&Object.assign(j.properties,{value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))}),i&&(j=oc(j,o,i))}else if("!group"!=(null==g?void 0:g.type)||b){var F=L.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),D=F.length?F[0]:void 0;j={type:"rule",id:Ss(),properties:Vu({field:v,fieldSrc:h,operator:y,value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))},D?{asyncListValues:D}:{})},(i||u)&&(j=oc(j,o,i))}else j={type:"rule_group",id:Ss(),children1:{},properties:{conjunction:_d(o,g),not:!1,mode:g.mode,field:v,operator:y}},"array"===g.mode&&Object.assign(j.properties,{value:L.map((function(e){return e.value})),valueSrc:L.map((function(e){return e.valueSrc})),valueType:L.map((function(e){return e.valueType}))}),i&&(j=oc(j,o,i));return j}}}},lc=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("if"===(null==e?void 0:e.toLowerCase())){var l=sc(t).map((function(e){var t=Jn(e,2),o=t[0],l=t[1];return[o?Zu(o,r,n,["rule","group"],i,!1,null,null,a):null,cc(n,i,r,l)]})).map((function(e){var t=Jn(e,2),r=t[0],o=t[1];return uc(r,o,n,i)}));return{type:"switch_group",id:Ss(),children1:l,properties:{}}}},sc=function(e){var t=[];return function e(r){var n=Jn(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]);var l=Bs(a)?Object.keys(a)[0]:null;"if"===(null==l?void 0:l.toLowerCase())?e(a[l]):t.push([void 0,a])}(e),t},uc=function(e,t,r,n){var o;return e?(o=Vu({},e)).type?("group"!=o.type&&(o=oc(o,r)),o.type="case_group"):(n.errors.push("Unexpected case: ".concat(JSON.stringify(o))),o=void 0):o={id:Ss(),type:"case_group",properties:{}},o&&(o.properties=Vu(Vu({},o.properties),t)),o},cc=function(e,t,r,n){var o=qh(e,"!case_value");if(o){var i=o.mainWidget,a=e.widgets[i];if(a){var l=Zu(n,r,e,["val","case_val"],t,!1,o,i);if(null!=l){var s=l.value,u=l.valueSrc,c=l.valueType;return{value:[s],valueSrc:[null!=u?u:"value"],valueType:[null!=c?c:null==a?void 0:a.type],field:"!case_value"}}}else t.errors.push("No widget ".concat(i," for case value"))}else t.errors.push("Missing caseValueField in settings")},dc=p(138),pc=p(358),fc=p.n(pc)();fc.trim=function(e){return"'"==e.charAt(0)?e.substring(1,e.length-1):e},fc.escapeLike=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=fc.escape(e);return"'"+(n=(t?"%":"")+(n=(n=fc.trim(n)).replace(/[%_]/g,"\\$&"))+(r?"%":""))+"'"};var vc=function(e){var t="''",r=null==e?void 0:e.type;return"date"==r?t="'0000-00-00'":"datetime"==r?t="'0000-00-00 00:00'":"time"==r?t="'00:00'":"number"==r&&(t="0"),t},hc=function(e){var t="";return"number"==(null==e?void 0:e.type)&&(t=0),t},gc=function(e){return"".concat(e,".?[true]")},yc=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==e)return"null";switch(Vn(e)){case"boolean":return e?"true":"false";case"number":if(!Number.isFinite(e)||isNaN(e))return;return e+(!Number.isInteger(e)||t?"f":"");case"object":if(Array.isArray(e))return function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=["int","float"];return e.map((function(e){if(null!=e){if("string"==typeof e)r="String";else{if("number"!=typeof e)throw new Error("spelEscape: Can't use value ".concat(e," in array"));r=Number.isInteger(e)?"int":"float"}if(t){if(t!=r){if(!i.includes(t)||!i.includes(r))throw new Error("spelEscape: Can't use different types in array: found ".concat(t," and ").concat(r));t="float"}}else t=r}})),t||(t="String"),n="float"==t?e.map((function(e){return yc(e,!0)})):e.map((function(e){return yc(e)})),o?"new ".concat(t,"[]{").concat(n.join(", "),"}"):"{".concat(n.join(", "),"}")}(e,r);throw new Error("spelEscape: Object is not supported");default:return function(e){return"'"+e.replace(/'/g,"''")+"'"}(e)}},mc=function(e){return e&&Array.isArray(e)&&e.length?e.map((function(e){return"const"==e.type?yc(e.value):"property"==e.type?""+e.value:"variable"==e.type?"#"+e.value:void 0})).filter((function(e){return null!=e})).join(" + "):"null"},bc=function(e){if(null==e)return[void 0,[]];var t=[],r="case_value"==e.valueType?e.value:e;return[(Array.isArray(r)?r:[r]).map((function(e){return"value"===e.valueSrc?null===e.value?void 0:{type:"const",value:e.value}:"field"===e.valueSrc?{type:e.isVariable?"variable":"property",value:e.value}:void t.push("Unsupported valueSrc ".concat(e.valueSrc," in concatenation"))})).filter((function(e){return null!=e})),t]},Ec=function(e){return null==e?"NULL":e.toString()},Oc=function(e){return null==e||"("===(null==e?void 0:e[0])&&")"===(null==e?void 0:e[(null==e?void 0:e.length)-1])?e:"("+e+")"};function Sc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Tc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Tc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function Tc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function _c(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function wc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_c(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_c(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Rc="${0}.compareTo(${1})",Ic={datetime:!0,time:!0,date:!0},Ac=function(e,t){return Cc(e,t,!1)},Cc=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=yh(t,void 0,!1),i=Nc(e,o,n,null);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SpEL:",n.errors),i)},Nc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return"group"===o||"rule_group"===o?xc(e,t,r,n):"rule"===o?Dc(e,t,r,n):"switch_group"==o?jc(e,t,r,n):"case_group"==o?Lc(e,t,r,n):void 0}},Lc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type");if("case_group"==o){var i=e.get("properties")||new xa,a=Jn(Mc(t,i,r,null,n,"!case_value"),3),l=a[0];return a[1],a[2],[xc(e,t,r,n),l]}r.errors.push("Unexpected child of type ".concat(o," inside switch"))},jc=function(e,t,r){e.get("properties")||new xa;var n=e.get("children1");if(n){var o=n.map((function(e){return Lc(e,t,r,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray();if(o.length){if(1==o.length&&!o[0][0])return o[0][1];for(var i=[],a=0;a<o.length;a++)a==o.length-1||o[a][0]?(i.push(o[a]),a==o.length-1&&o[a][0]&&i.push([void 0,null])):r.errors.push("No condition for case ".concat(a));for(var l="",s="",u=0;u<i.length;u++){var c=Jn(i[u],2),d=c[0],p=c[1];null==p&&(p="null"),null==d&&(d="true"),u!=i.length-1?(l+="(".concat(d," ? ").concat(p," : "),s+=")"):l+="".concat(p)}return l+s}}},xc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type"),i=e.get("properties")||new xa,a=i.get("mode"),l=e.get("children1")||new nl,s=i.get("field"),u=i.get("conjunction");u||(u=wd(t));var c=t.conjunctions[u],d=i.get("not"),p="rule_group"===o,f=p&&"struct"!=a,v=f?s:n,h=(qh(t,v)||{}).isSpelArray,g=t.settings.fieldSeparator,y=i.get("operator");y||a&&"some"!=a||(y="some");var m=Fc(t,y,s),b=m!=y,E=y&&Kh(t,m,s)||null,O=p&&(!m||0==E.cardinality),S=Jn(Mc(t,i,r,m,n,null),3),T=S[0],_=S[1],w=S[2],R=l.map((function(e){return Nc(e,t,r,v)})).filter((function(e){return void 0!==e}));if(f&&!O){if(null==T)return}else if(!R.size)return;var I,A=p,C=R.size?c.spelFormatConj.call(t.ctx,R,u,d,A):null;if(f){var N=Uc(r,t,s,n),L=(g||".")+(h?"length":"size()"),j="".concat(N).concat(L),x=C?"".concat(N,".?[").concat(C,"]").concat(L):j;I=Pc(r,t,i,x,O?j:T,m,_,w,b)}else I=C;return I},Pc=function(e,t,r,n,o,i,a,l){var s=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=r.get("field"),c=Kh(t,i,u)||{},d=qh(t,u)||{},p=r.get("operatorOptions"),f=c.spelFormatOp||function(e,t,r){var n=t.spelOp;if(n){var o,i=n.includes("${0}"),a=Ic[r],l=n,s=Cs(t);return a?o=function(e,t,r,n,o,i,a,u){var c=Rc.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:s>1?r[n-1]:r}));return"".concat(c," ").concat(l," 0")}:i?o=function(e,t,r,o,i,a,l,u){return n.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:s>1?r[n-1]:r}))}:0==s?o=function(e,t,r,n,o,i,a,s){return"".concat(e," ").concat(l)}:1==s&&(o=function(e,t,r,n,o,i,a,s){return"".concat(e," ").concat(l," ").concat(r)}),o}}(0,c,l);if(f){var v,h=[n,i,o,a,l,As(c,ws),p,d];return v=f.call.apply(f,[t.ctx].concat(h)),s&&(v=t.settings.spelFormatReverse.call(t.ctx,v)),void 0===v&&e.errors.push("Operator ".concat(i," is not supported for value source ").concat(a)),v}e.errors.push("Operator ".concat(i," is not supported"))},Fc=function(e,t,r){if(t){var n=Kh(e,t,r)||{},o=n.reversedOp,i=Kh(e,o,r)||{},a=n.spelOp||n.spelFormatOp,l=i.spelOp||i.spelFormatOp;if(a||l){if(!a&&l){var s=[o,t];t=s[0],o=s[1];var u=[i,n];n=u[0],i=u[1]}return t}}},Dc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new xa,i=o.get("field"),a=o.get("fieldSrc"),l=o.get("operator");if(null!=i&&null!=l){var s=Fc(t,l,i);if(s){var u=s!=l,c=Jn(Mc(t,o,r,s,n,null),3),d=c[0],p=c[1],f=c[2];if(void 0!==d){var v=kc(r,t,i,a,n);if(void 0!==v)return Pc(r,t,o,v,d,s,p,f,u)}}else r.errors.push("Operator ".concat(l," is not supported"))}},kc=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;return"func"===n?Bc(e,t,r,o):Uc(e,t,r,o)},Mc=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),l=t.get("valueSrc"),s=t.get("valueType");("!case_value"==i||s&&"case_value"==s.get(0))&&(a="!case_value");var u,c=qh(e,a)||{},d=Kh(e,n,a)||{},p=Cs(d),f=t.get("value"),v=t.get("asyncListValues"),h=[],g=[];if(null!=f){var y=f.map((function(t,i){var u=l?l.get(i):null,p=s?s.get(i):null,f=Ov(t,u,e),y=cv(e,a,n,u),m=Wh(e,a,n,y,u,{forExport:!0}),b=Vc(r,e,f,u,p,m,c,n,d,o,v);return void 0!==b&&(h.push(u),g.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;y.size<p||m||(u=p>1?y.toArray():1==p?y.first():null)}return[u,h.length>1?h:h[0],g.length>1?g:g[0]]},Vc=function(e,t,r,n,o,i,a,l,s){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"===n)d=Uc(e,t,r,u);else if("func"===n)d=Bc(e,t,r,u);else if("function"==typeof(null==i?void 0:i.spelFormatValue)){var p=i.spelFormatValue,f=[r,wc(wc({},Js()(a,["fieldSettings","listValues"])),{},{asyncListValues:c}),As(i,_s)];if(l&&(f.push(l),f.push(s)),"field"==n){var v=qh(t,r)||{};f.push(v)}d=p.call.apply(p,[t.ctx].concat(f))}else d=yc(r);return d}},Uc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(r){var o=t.settings.fieldSeparator,i=qh(t,r)||{},a=kh(r,t),l=ov(r,t,n),s=t.settings.formatSpelField,u=dv(r,t,e,n),c=l.map((function(e){var t,r=Jn(e,3),n=r[0],i=r[1],a=r[2];return a&&(t="!struct"==a.type||"!group"==a.type&&"struct"==a.mode?i.isSpelMap?"map":"class":"!group"==a.type?i.isSpelItemMap?"[map]":"[class]":"class"),{key:n,parent:t,isSpelVariable:null==i?void 0:i.isSpelVariable,fieldSeparator:o}}));return s.call(t.ctx,u,n,a,c,i,t)}},Bc=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),l=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),s=xh(t,a);if(s){var u={},c=[],d=[];for(var p in s.args){var f,v,h=s.args[p],g=qh(t,h),y=h.defaultValue,m=h.isOptional,b=null!=y&&y.func?"func":"value",E=l?l.get(p):void 0,O=E?E.get("value"):void 0,S=E?E.get("valueSrc"):void 0;"func"!==S&&null!==(f=O)&&void 0!==f&&f.toJS&&(O=O.toJS());var T=E?E.get("asyncListValues"):void 0,_=null===(v=h.spelEscapeForFormat)||void 0===v||v,w=null,R=cv(t,h,w,S),I=Wh(t,h,w,R,S,{forExport:!0}),A=Vc(e,t,O,S,h.type,I,g,null,null,i,T);if(null!=O&&void 0===A)return void("func"!=S&&e.errors.push("Can't format value of arg ".concat(p," for func ").concat(a)));var C=void 0;if(void 0===A&&!m&&null!=y){var N=cv(t,h,w,b),L=Wh(t,h,w,N,b,{forExport:!0});if(void 0===(C=Vc(e,t,y,b,h.type,L,g,null,null,i,T)))return void("func"!=b&&e.errors.push("Can't format default value of arg ".concat(p," for func ").concat(a)))}var j=null!=A?A:C;if(void 0!==j){var x;if(c.length){var P,F=Sc(c);try{for(F.s();!(P=F.n()).done;){var D=P.value;u[D]=void 0}}catch(e){F.e(e)}finally{F.f()}c=[]}u[p]=_?j:null!==(x=O)&&void 0!==x?x:y}else m||d.push(p),c.push(p)}if(!d.length){var k;if("function"==typeof s.spelFormatFunc){var M=s.spelFormatFunc,V=[u];k=M.call.apply(M,[t.ctx].concat(V))}else if(s.spelFunc){k=s.spelFunc.replace(/\${(\w+)}/g,(function(e,t){var r;return null!==(r=u[t])&&void 0!==r?r:e}));var U,B=Object.keys(s.args||{}).reverse().filter((function(e){return!!s.args[e].isOptional})),G=Sc(B);try{for(G.s();!(U=G.n()).done;){var q=U.value;if(null!=u[q])break;k=k.replace(new RegExp("(, )?\\${"+q+"}","g"),"")}}catch(e){G.e(e)}finally{G.f()}k=k.replace(/\${(\w+)}/g,"null")}else e.errors.push("Func ".concat(a," is not supported"));return k}}else e.errors.push("Func ".concat(a," is not defined in config"))};function Gc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return qc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?qc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function qc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Kc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Wc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Kc(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Kc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var zc={number:"number",string:"text",boolean:"boolean",null:"null"},Hc={String:"text"},$c=function(e){return"object"==Vn(e)&&null!==e&&!Array.isArray(e)},Yc=function(e,t){return Qc(e,t,!0)},Qc=function(e,t){var r,n,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i={errors:[]},a=yh(t,void 0,!1),l=Zc(a),s=void 0;try{r=dc.SpelExpressionEvaluator.compile(e)._compiledExpression}catch(e){i.errors.push(e)}r&&(n=Xc(r,i),$s.debug("convertedObj:",n,i),(s=ed(n,l,a,i))&&"group"!=s.type&&"switch_group"!=s.type&&(s=hd(s,a,n.not)),$s.debug("jsTree:",s));var u=s?Lu(s):void 0;return o?[u,i.errors]:(i.errors.length&&console.warn("Errors while importing from SpEL:",i.errors),u)},Xc=function e(t,r){var n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=t.getType(),a=t.getChildren().map((function(n){return e(n,r,t)}));if("op-or"!=i&&"op-and"!=i||(a=a.reduce((function(e,t){var r=t.type!=i||t.not?[t]:t.children;return[].concat(eo(e),eo(r))}),[])),"op-not"==i)return 1!=a.length&&r.errors.push("Operator NOT should have 1 child, but got ".concat(a.length,"}")),Wc(Wc({},a[0]),{},{not:!a[0].not});if("compound"==i){var l=(a=a.filter((function(e){return!("selection"==e.type&&1==e.children.length&&"boolean"==e.children[0].type&&1==e.children[0].val)}))).find((function(e){return"selection"==e.type}));l&&1!=l.children.length&&r.errors.push("Selection should have 1 child, but got ".concat(l.children.length));var s=l?l.children[0]:null,u=a[a.length-1],c="method"==u.type&&"size"==u.val.methodName||"!func"==u.type&&"size"==u.methodName,d="property"==u.type&&"length"==u.val,p=a.filter((function(e){return e!==l&&e!==u})),f={type:"compound",children:p};if((c||d)&&null!=rd(p))return{type:"!aggr",filter:s,source:f};if(a=(a=a.filter((function(e){var t="variable"==e.type&&"this"==e.val,r="variable"==e.type&&"root"==e.val;return!(t||r)}))).map((function(e){return"indexer"==e.type&&1==e.children.length?{type:"indexer",val:e.children[0].val,itype:e.children[0].type}:e})),"!func"==u.type){var v={},h=v;do{var g,y;Object.assign(h,u),a=a.filter((function(e){return e!==u})),"!func"==(null===(y=u=a[a.length-1])||void 0===y?void 0:y.type)?(h.obj={},h=h.obj):a.length>1?h.obj={type:"compound",children:a}:h.obj=u}while("!func"==(null===(g=u)||void 0===g?void 0:g.type));return v}}try{t.getRaw?n=t.getRaw():0==t.getValue.length&&(n=t.getValue())}catch(e){$s.error("[spel2js] Error in getValue()",e)}if("ternary"==i&&(n=Jc(a)),"object"===Vn(n)&&null!==n&&(n.methodName||n.functionName)&&(n.args=n.args.map((function(n){return e(n,r,t)}))),"list"==i&&(n=n.map((function(n){return e(n,r,t)})),!o&&1==n.length))return n[0];if("constructorref"==i){var m=a.find((function(e){return"qualifiedidentifier"==e.type})),b=null==m?void 0:m.val;return b?{type:"!new",cls:b,args:a.filter((function(e){return"qualifiedidentifier"!=e.type}))}:void r.errors.push("Can't find qualifiedidentifier in constructorref children: ".concat(JSON.stringify(a)))}if("typeref"==i){var E=a.find((function(e){return"qualifiedidentifier"==e.type})),O=null==E?void 0:E.val;return O?(a.filter((function(e){return"qualifiedidentifier"!=e.type})),{type:"!type",cls:O}):void r.errors.push("Can't find qualifiedidentifier in typeref children: ".concat(JSON.stringify(a)))}if("function"==i||"method"==i){var S=n,T=S.functionName,_=S.methodName,w=S.args;return{type:"!func",methodName:T||_,isVar:"function"==i,args:w}}return{type:i,children:a,val:n}},Jc=function(e){var t=[];return function e(r){var n=Jn(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]),"ternary"==(null==a?void 0:a.type)?e(a.children):t.push([void 0,a])}(e),t},Zc=function(e){var t={},r=function(r){var n=e.operators[r];if(n.spelOps)n.spelOps.forEach((function(e){var n=e;t[n]||(t[n]=[]),t[n].push(r)}));else if(n.spelOp){var o=n.spelOp;t[o]||(t[o]=[]),t[o].push(r)}else $s.log("[spel] No spelOp for operator ".concat(r))};for(var n in e.operators)r(n);var o={};for(var i in e.conjunctions)o[e.conjunctions[i].spelConj||i.toLowerCase()]=i;var a,l={},s=Gc(Ih(e));try{var u=function(){var e=Jn(a.value,2),t=e[0],r=e[1],n=[],o=r.spelFunc;if("string"==typeof o){var i=Object.keys(r.args||{}).reverse().filter((function(e){return!!r.args[e].isOptional||null!=r.args[e].defaultValue})),s=o.replace(/\${(\w+)}/g,(function(e,t){return"?"})),u=i.reduce((function(e,t){return[].concat(eo(e),[[t].concat(eo(e[e.length-1]||[]))])}),[]).map((function(e){return o.replace(/(?:, )?\${(\w+)}/g,(function(t,r){return e.includes(r)?"":t})).replace(/\${(\w+)}/g,(function(e,t){return"?"}))}));n=[s].concat(eo(u))}var c,d=Gc(n);try{for(d.s();!(c=d.n()).done;){var p=c.value;l[p]||(l[p]=[]),l[p].push(t)}}catch(e){d.e(e)}finally{d.f()}};for(s.s();!(a=s.n()).done;)u()}catch(e){s.e(e)}finally{s.f()}var c={};for(var d in e.widgets){var p=e.widgets[d],f=p.spelImportFuncs;if(p.type,f){var v,h=Gc(f);try{for(h.s();!(v=h.n()).done;){var g=v.value;if("string"==typeof g){var y=g.replace(/\${(\w+)}/g,(function(e,t){return"?"})),m=eo(g.matchAll(/\${(\w+)}/g)).map((function(e){var t=Jn(e,2);return t[0],t[1]}));c[y]||(c[y]=[]),c[y].push({w:d,argsOrder:m})}}}catch(e){h.e(e)}finally{h.f()}}}var b={};for(var E in e.operators){var O=e.operators[E].spelOp;if(null!=O&&O.includes("${0}")){var S=O.replace(/\${(\w+)}/g,(function(e,t){return"?"})),T=eo(O.matchAll(/\${(\w+)}/g)).map((function(e){var t=Jn(e,2);return t[0],t[1]}));b[S]||(b[S]=[]),b[S].push({op:E,argsOrder:T})}}return b[Rc.replace(/\${(\w+)}/g,(function(e,t){return"?"}))]=[{op:"!compare",argsOrder:["0","1"]}],{operators:t,conjunctions:o,funcs:l,valueFuncs:c,opFuncs:b}},ed=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(t){t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==a?void 0:a._groupField;var l,s=!0;if(0===t.type.indexOf("op-")||"matches"===t.type)l=td(t,r,n,o,a);else if("!aggr"==t.type){var u,c=e(t.source,r,n,o,t);t._groupField=null==c?void 0:c.value;var d=e(t.filter,r,n,o,t);"rule"==(null===(u=d)||void 0===u?void 0:u.type)&&(d=hd(d,n,t.filter.not)),l={groupFilter:d,groupFieldValue:c},a||(l=void 0,o.errors.push("Unexpected !aggr in root"),s=!1)}else if("ternary"==t.type){var p={};t.val.forEach((function(e){var i=Jn(e,2),a=i[0],l=i[1],s=pd(a,l,r,n,o,t);s&&(p[s.id]=s)})),l={type:"switch_group",id:Ss(),children1:p,properties:{}}}if(!l&&s&&(l=nd(t,r,n,o,a)),l&&!l.type&&!a){var f=dd(t,r,n,o);f?l=f:(l=void 0,o.errors.push("Can't convert rule of type ".concat(t.type,", it looks like var/literal")))}return l}},td=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,l=t.type.startsWith("op-")?t.type.slice(3):t.type;if(("minus"==l||"plus"==l)&&1==t.children.length){var s=t.negative;return"minus"==l&&(s=!s),t.children[0].negative=s,ed(t.children[0],r,n,o,a)}var u="and"==l&&2==t.children.length&&"op-ge"==t.children[0].type&&"op-le"==t.children[1].type,c="or"==l&&2==t.children.length&&"op-lt"==t.children[0].type&&"op-gt"==t.children[1].type;if(u||c){var d=Jn(t.children[0].children,2),p=d[0],f=d[1],v=Jn(t.children[1].children,2),h=v[0],g=v[1];if(cd(p,h,t,r,n,o,a)){f.val,g.val;var y={type:"op-between",children:[p,f,g],not:c};return y._groupField=null==a?void 0:a._groupField,e(y,r,n,o,a)}}var m=r.operators[l];"eq"==l&&"null"==t.children[1].type?m=["is_null"]:"ne"==l&&"null"==t.children[1].type?m=["is_not_null"]:"le"==l&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_empty"]:"gt"==l&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_not_empty"]:"between"==l&&(m=["between"]);var b=function(){var e,i=t.children.map((function(e){return ed(e,r,n,o,t)}));return i.length>=2&&"!compare"==(null===(e=i)||void 0===e||null===(e=e[0])||void 0===e?void 0:e.type)&&(i=i[0].children),i};if("and"==l||"or"==l){var E={};b().forEach((function(e){if(e){var t=Ss();e.id=t,null!=e.type?E[t]=e:o.errors.push("Bad item in AND/OR: ".concat(JSON.stringify(e)))}})),i={type:"group",id:Ss(),children1:E,properties:{conjunction:r.conjunctions[l],not:t.not}}}else if(m){var O,S,T,_=b(),w=_[0],R=_.slice(1),I=null==w||null===(O=w.groupFieldValue)||void 0===O?void 0:O.value,A=null===(S=R)||void 0===S?void 0:S[0],C=m[0];if(m.length>1){var N,L,j=(null===(N=_[0])||void 0===N?void 0:N.valueType)||(null===(L=_[1])||void 0===L?void 0:L.valueType),x=null==w?void 0:w.value,P=m.map((function(e){return{op:e,widget:cv(n,x,e)}}));if($s.warn("[spel] Spel operator ".concat(l," can be mapped to ").concat(m,"."),"widgets:",P,"vals:",_,"valueType=",j),"eq"==l||"ne"==l){var F=P.find((function(e){e.op;var t=e.widget;return t&&"field"!=t}));F&&(C=F.op)}}null!=w&&w.groupFieldValue&&(A&&A.groupFieldValue&&"field"==A.groupFieldValue.valueSrc&&A.groupFieldValue.value==I?(C="all",R=[]):"equal"==C&&"value"==A.valueSrc&&"number"==A.valueType&&0==A.value?(C="none",R=[]):"greater"==C&&"value"==A.valueSrc&&"number"==A.valueType&&0==A.value&&(C="some",R=[]));var D=n.operators[C],k=n.operators[null===(T=D)||void 0===T?void 0:T.reversedOp],M=t.not&&["between"].includes(C),V=!!k&&(!!n.settings.reverseOperatorsForNot||M);(t.not&&V||M)&&(C=D.reversedOp,D=n.operators[C],t.not=!t.not);var U=!!t.not;if(t.not=!1,w)if(w.groupFieldValue)"field"!=w.groupFieldValue.valueSrc&&o.errors.push("Expected group field ".concat(JSON.stringify(w))),i=ud(w,C,R,n,o);else{"field"!=w.valueSrc&&"func"!=w.valueSrc&&o.errors.push("Expected field/func at LHS, but got ".concat(JSON.stringify(w)));var B=w.value;i=sd(n,o,B,C,R,t)}U&&("group"!==i.type?i=hd(i,n,!0):i.properties.not=!i.properties.not)}else a||(i=dd(t,r,n,o));return i},rd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=e.map((function(e){if("variable"==e.type||"property"==e.type||"indexer"==e.type&&"string"==e.itype)return e.val;var o,i;n=!0,r&&(null==t||null===(o=t.errors)||void 0===o||null===(i=o.push)||void 0===i||i.call(o,"Unexpected item in field path compound: ".concat(JSON.stringify(e))))}));return n?void 0:o},nd=function e(t,r,n,o){var i,a,l=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(null!=t){var s=n.settings.fieldSeparator;if(t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==l?void 0:l._groupField,"variable"==t.type||"property"==t.type){var u=Lh(n,t.val,t._groupField),c=qh(n,u),d="variable"==t.type;return{valueSrc:"field",valueType:null==c?void 0:c.type,isVariable:d,value:u}}if("compound"==t.type){var p=rd(t.children,o);if(p){var f,v=Lh(n,p.join(s),t._groupField),h=qh(n,v),g="variable"==(null===(f=t.children)||void 0===f||null===(f=f[0])||void 0===f?void 0:f.type);return{valueSrc:"field",valueType:null==h?void 0:h.type,isVariable:g,value:v}}}else{if(zc[t.type]){var y=t.val,m=zc[t.type];return t.negative&&(y=-y),{valueSrc:"value",valueType:m,value:y}}if("!new"==t.type&&Hc[t.cls.at(-1)]){var b=t.args.map((function(i){return e(i,r,n,o,t)})),E=null==b?void 0:b[0],O=Hc[t.cls.at(-1)];return Wc(Wc({},E),{},{valueType:O})}if("list"==t.type){var S,T=t.val.map((function(i){return e(i,r,n,o,t)}));return T.length&&(null===(S=T[0])||void 0===S||S.valueType),{valueSrc:"value",valueType:"multiselect",value:T.map((function(e){return null==e?void 0:e.value}))}}if("op-plus"===t.type&&"ternary"===(null==l?void 0:l.type)&&"case_value"===(null===(a=n.settings.caseValueField)||void 0===a?void 0:a.type))return fd(t,r,n,o)}var _=id(t,r,n,o,l);if(void 0!==_)return _;o.errors.push("Can't convert arg of type ".concat(t.type))}},od=function e(t,r){var n,o=[],i="",a=t.type,l=t.methodName,s=(t.val,t.obj),u=t.args,c=t.isVar,d=t.cls,p=t.children,f=null==p?void 0:p[p.length-1],v=r[r.length-1];if("!func"===a){for(var h=s;h;){var g,y=Jn(e(Wc(Wc({},h),{},{obj:null}),[{}]),2),m=y[0],b=y[1];if("?"!==m){var E={s:v.s,params:eo(v.params),objs:eo(v.objs)};v.objs.unshift("?"),v.params.unshift(h),r.push(E),v=r[r.length-1]}v.objs.unshift(m),(g=v.params).unshift.apply(g,eo(b)),h="!func"===h.type?h.obj:null}var O,S=Gc(r);try{for(S.s();!(O=S.n()).done;){var T,_=O.value;o=[].concat(eo((null==_?void 0:_.params)||[]),eo(u||[])),i="",null!=_&&null!==(T=_.objs)&&void 0!==T&&T.length&&(i+=_.objs.join(".")+"."),i+=(c?"#":"")+l,i+="("+(u||[]).map((function(e){return"?"})).join(", ")+")",_.s=i,_.params=o}}catch(e){S.e(e)}finally{S.f()}}else"!new"===a?(o=u||[],i="new ".concat(d.join("."),"(").concat(o.map((function(e){return"?"})).join(", "),")")):"!type"===a?i="T(".concat(d.join("."),")"):"compound"===a&&"property"===f.type&&(n=f.val,["length"].includes(n))?i=p.map((function(t){var r;if(t===f)return t.val;var n=Jn(e(Wc(Wc({},t),{},{obj:null}),[{}]),2),i=n[0],a=n[1];return(r=o).push.apply(r,eo(a)),i})).join("."):(o=[t],i="?");return v&&(v.s=i,v.params=o),[i,o]},id=function(e,t,r,n){var o,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=function(o){return ed(o,t,r,n,e)},l=function(e){var t=[{s:"",params:[],objs:[]}];return od(e,t),t.map((function(e){return{s:e.s,params:e.params}})).reverse().filter((function(e){var t=e.s;return""!==t&&"?"!==t}))}(e),s=null==l||null===(o=l[0])||void 0===o?void 0:o.s;l.length&&$s.debug("Signatures for ",e,":",s,l);var u=ad(e,t,r,n,i,l,a);if(void 0!==u)return u;var c,d,p,f=ld(e,t,r,n,i,l,a);if(void 0!==f)return f;var v,h=Gc(l);try{var g=function(){var e=v.value,n=e.s,o=e.params,i=t.funcs[n];if(i){c=i[0];var l=(d=xh(r,c)).spelFunc,s=o.map(a),u=eo(l.matchAll(/\${(\w+)}/g)).map((function(e){var t=Jn(e,2);return t[0],t[1]}));return p=Object.fromEntries(u.map((function(e,t){return[e,s[t]]}))),1}};for(h.s();!(v=h.n()).done&&!g(););}catch(e){h.e(e)}finally{h.f()}if(!c){var y,m=Gc(Ih(r));try{for(m.s();!(y=m.n()).done;){var b=Jn(y.value,2),E=b[0],O=b[1];if(O.spelImport){var S=void 0;try{S=O.spelImport(e)}catch(e){}if(S)for(var T in d=xh(r,c=E),p={},S)p[T]=a(S[T])}}}catch(e){m.e(e)}finally{m.f()}}if(c){var _={};for(var w in d.args){var R,I=d.args[w],A=p[w];if(void 0===A)if(void 0===(A=null==I?void 0:I.defaultValue)){if(null==I||!I.isOptional)return void n.errors.push("No value for arg ".concat(w," of func ").concat(c))}else A={value:A,valueSrc:null!==(R=A)&&void 0!==R&&R.func?"func":"value",valueType:I.type};A&&(_[w]=A)}return{valueSrc:"func",value:{func:c,args:_},valueType:d.returnType}}e.methodName&&n.errors.push("Signature ".concat(s," - failed to convert"))},ad=function(e,t,r,n,o,i,a){var l,s,u,c=[];for(var d in r.widgets){var p=r.widgets[d].spelImportFuncs;if(p)for(var f=0;f<p.length;f++){var v=p[f];if($c(v)){var h={};if(Ws(v,e,h)){for(var g in h)h[g]=a(h[g]);c.push({s:"widgets.".concat(d,".spelImportFuncs[").concat(f,"]"),w:d,argsObj:h})}}}}var y,m=Gc(i);try{for(m.s();!(y=m.n()).done;){var b,E=y.value,O=E.s,S=E.params,T=Gc(t.valueFuncs[O]||[]);try{var _=function(){var e=b.value,t=e.w,r=e.argsOrder,n=S.map(a),o=Object.fromEntries(r.map((function(e,t){return[e,n[t]]})));c.push({s:O,w:t,argsObj:o})};for(T.s();!(b=T.n()).done;)_()}catch(e){T.e(e)}finally{T.f()}}}catch(e){m.e(e)}finally{m.f()}for(var w=0,R=c;w<R.length;w++){var I=R[w],A=I.s,C=I.w,N=I.argsObj,L=r.widgets[C],j=L.spelImportValue,x=L.type;for(var P in u=C,s=A,l=[],N)["value"].includes(N[P].valueSrc)||l.push("".concat(P," has unsupported value src ").concat(N[P].valueSrc));var F=N.v.value;if(j&&!l.length){var D=Jn(j.call(r.ctx,N.v,L,N),2);F=D[0],(l=D[1])&&!Array.isArray(l)&&(l=[l])}if(!l.length)return{valueSrc:"value",valueType:x,value:F}}u&&l.length&&n.errors.push("Signature ".concat(s," - looks like convertable to ").concat(u,", but: ").concat(l.join("; ")))},ld=function(e,t,r,n,o,i,a){var l,s,u,c,d=Gc(i);try{for(d.s();!(c=d.n()).done;){var p,f=c.value,v=f.s,h=f.params,g=Gc(t.opFuncs[v]||[]);try{var y,m=function(){var t,i=p.value,c=i.op,d=i.argsOrder,f=h.map(a);if(s=c,"!compare"===c){if(o.type.startsWith("op-")&&2==o.children.length&&"number"==o.children[1].type&&0===o.children[1].val)return{v:{type:"!compare",children:f}};l.push("Result of compareTo() should be compared to 0")}u=v,l=[];var g=r.operators[s],y=(g.spelOp,g.valueTypes),m=Object.fromEntries(d.map((function(e,t){return[e,f[t]]}))),b=m[0],E=Object.keys(m).filter((function(e){return parseInt(e)>0})).map((function(e){return m[e]})),O=null===(t=f.filter((function(e){return!!e})).find((function(e){return"value"===e.valueSrc})))||void 0===t?void 0:t.valueType;if(y&&O&&!y.includes(O)&&l.push("Op supports types ".concat(y,", but got ").concat(O)),!l.length)return{v:sd(r,n,b,s,E,e)}};for(g.s();!(p=g.n()).done;)if(y=m())return y.v}catch(e){g.e(e)}finally{g.f()}}}catch(e){d.e(e)}finally{d.f()}s&&l.length&&n.errors.push("Signature ".concat(u," - looks like convertable to ").concat(s,", but: ").concat(l.join("; ")))},sd=function(e,t,r,n,o,i){var a,l;if(!o.filter((function(e){return void 0===e})).length){var s=null!==(a=r)&&void 0!==a&&a.func?"func":"field";$c(r)&&r.valueSrc&&(s=r.valueSrc,r=r.value);var u=qh(e,r);if(u){var c=qh(e,null==i?void 0:i._groupField),d="!group"==u.type,p=(d&&u.mode,"!group"==(null==c?void 0:c.type)),f=e.operators[n],v=e.operators[null===(l=f)||void 0===l?void 0:l.reversedOp],h=(null==i?void 0:i.not)&&["between"].includes(n),g=!!v&&(!!e.settings.reverseOperatorsForNot||h||!d&&p);((null==i?void 0:i.not)&&g||h)&&(n=f.reversedOp,f=e.operators[n],i.not=!i.not);var y=!(null==i||!i.not),m=cv(e,r,n),b=e.widgets[m||u.mainWidget],E=o.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),O=E.length?E[0]:void 0,S={type:"rule",id:Ss(),properties:Wc({field:r,fieldSrc:s,operator:n,value:o.map((function(e){return e.value})),valueSrc:o.map((function(e){return e.valueSrc})),valueType:o.map((function(e){return"value"==e.valueSrc&&((null==b?void 0:b.type)||(null==u?void 0:u.type))||e.valueType}))},O?{asyncListValues:O}:{})};return y&&(S=hd(S,e,i.not)),S}t.errors.push("No config for field ".concat(r))}},ud=function(e,t,r,n,o){var i=e.groupFilter,a=e.groupFieldValue;if("field"!=a.valueSrc)throw"Bad groupFieldValue: ".concat(JSON.stringify(a));var l=a.value,s=sd(n,o,l,t,r);if(s){var u,c=qh(n,l),d=null==c?void 0:c.mode;return(u="group"===(null==i?void 0:i.type)?Wc(Wc({},i||{}),{},{type:"rule_group",properties:Wc(Wc(Wc({},s.properties),(null==i?void 0:i.properties)||{}),{},{mode:d})}):Wc(Wc({},s||{}),{},i?{type:"rule_group",children1:[i],properties:Wc(Wc({},s.properties),{},{mode:d})}:{type:"rule_group",properties:Wc(Wc({},s.properties),{},{mode:d})})).id||(u.id=Ss()),u}},cd=function(e,t,r,n,o,i){if(e.type==t.type){if("!aggr"==e.type){var a=Jn([e.source,t.source].map((function(e){return nd(e,n,o,i,r)})),2),l=a[0],s=a[1];return l.value==s.value}var u=Jn([e,t].map((function(e){return nd(e,n,o,i,r)})),2),c=u[0],d=u[1];return c.value==d.value}return!1},dd=function(e,t,r,n){var o={},i=pd(null,e,t,r,n);return i&&(o[i.id]=i),{type:"switch_group",id:Ss(),children1:o,properties:{}}},pd=function(e,t,r,n,o){var i,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,l=vd(n,o,r,t,a);return e?(i=ed(e,r,n,o,a))&&i.type?("group"!=i.type&&(i=hd(i,n)),i.type="case_group"):(o.errors.push("Unexpected case: ".concat(JSON.stringify(i))),i=void 0):i={id:Ss(),type:"case_group",properties:{}},i&&(i.properties=Wc(Wc({},i.properties),l)),i},fd=function(e,t,r,n){var o=[];return function i(a){a.map((function(a){if("op-plus"===a.type)i(a.children);else{var l=nd(a,t,r,n,e);l?o.push(l):n.errors.push("Can't convert ".concat(a.type," in concatenation"))}}))}(e.children),{valueSrc:"value",valueType:"case_value",value:o}},vd=function(e,t,r,n){var o,i,a,l,s,u,c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d={},p=qh(e,"!case_value");"op-plus"===(null==n?void 0:n.type)&&"case_value"===(null===(o=e.settings.caseValueField)||void 0===o?void 0:o.type)?(l="case_value",a=fd(n,r,e,t)):(l=null==p?void 0:p.mainWidget,s=e.widgets[l],(a=nd(n,r,e,t,c))&&"value"===a.valueSrc&&(a.valueType=(null===(u=s)||void 0===u?void 0:u.type)||(null==p?void 0:p.type)||a.valueType));var f=e.widgets[l];if("case_value"===l){var v=null==f?void 0:f.spelImportValue;if(v){var h,g=Jn(v.call(e.ctx,a),2),y=g[0];g[1].map((function(e){return t.errors.push(e)})),null!=y&&(d={value:[y],valueSrc:["value"],valueType:[null!==(h=null==f?void 0:f.type)&&void 0!==h?h:"case_value"],field:"!case_value"})}}else null!=a&&null!=(null===(i=a)||void 0===i?void 0:i.value)&&(d={value:[a.value],valueSrc:[a.valueSrc],valueType:[a.valueType],field:"!case_value"});return d},hd=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:Ss(),children1:Hn({},e.id,e),properties:{conjunction:wd(t),not:r||!1}}};function gd(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function yd(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?gd(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):gd(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var md=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=e.settings.defaultField,o=(r?bd(e,r):n)||t&&zh(e,r)||null;return null==o||"string"==typeof o||js(o)||(o=Pu(o)),o},bd=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!r)return null;var n=(null==e||null===(t=e.settings)||void 0===t?void 0:t.fieldSeparator)||".",o=qh(e,r),i=null==o?void 0:o.defaultField;return i&&(i=[].concat(eo(kh(r)),[i]).join(n)),i},Ed=function(e){var t;return(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(null===(t=e.settings.fieldSources)||void 0===t?void 0:t[0])||"field"},Od=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=qh(e,t),o=(null==n?void 0:n.operators)||[],i=e.settings.defaultOperator;i&&!o.includes(i)&&(i=null);var a=null==n?void 0:n.defaultOperator,l=null==n?void 0:n.ownDefaultOperator,s=r?ev(e,t):null;return l||i||a||s},Sd=function(e,t,r){var n=t?Kh(e,t,r):null;return n&&n.options?new Es.Map(n.options&&n.options.defaults||{}):null},Td=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],l=arguments.length>4&&void 0!==arguments[4]&&arguments[4],s=null,u=null,c=null,d=e.settings.showErrorMessage;i?(c=null==i||null===(t=i.properties)||void 0===t?void 0:t.fieldSrc,s=null==i||null===(r=i.properties)||void 0===r?void 0:r.field,u=null==i||null===(n=i.properties)||void 0===n?void 0:n.operator):a?(c=(s=md(e,l,o))?js(s)?"func":"field":Ed(e),u=Od(e,s,!0)):c=Ed(e);var p=new Es.Map({fieldSrc:c,field:s,operator:u,value:new Es.List,valueSrc:new Es.List,operatorOptions:Sd(e,u,s)});if(d&&(p=p.set("valueError",new Es.List)),s&&u){var f=Bf(e,e,p,s,u,"operator",!1),v=f.newValue,h=f.newValueSrc,g=f.newValueType,y=f.newValueError,m=f.newFieldError;p=p.set("value",v).set("valueSrc",h).set("valueType",g),d&&(p=p.set("valueError",y).set("fieldError",m))}return p},_d=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(t=qh(e,t))&&t.conjunctions||Object.keys(e.conjunctions);return 1==r.length?r[0]:e.settings.defaultGroupConjunction||e.settings.defaultConjunction||r[0]},wd=function(e){return e.settings.defaultConjunction||Object.keys(e.conjunctions)[0]},Rd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return new Es.Map({conjunction:_d(e,t),not:!1})},Id=function(e,t){var r;return t&&"group"==t.type?Rd(e,null==t||null===(r=t.properties)||void 0===r?void 0:r.field):Td(e,null,t)},Ad=function(e,t){return Hn({},e,new Es.Map({type:"rule",id:e,properties:Td(t)}))},Cd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];return new Es.Map({type:"group",id:Ss(),children1:new Es.OrderedMap(t?yd({},Ad(Ss(),e)):{}),properties:Rd(e)})},Nd=function(e){return xs(e)?e:Ld([e])},Ld=function(e){return xs(e)?e:new Es.List(e)},jd=function(){return new Es.Map};function xd(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Pd(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Pd(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function Pd(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Fd(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Dd(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Fd(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Fd(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var kd=function(e,t){var r={errors:[],settings:{isForDisplay:arguments.length>2&&void 0!==arguments[2]&&arguments[2],isDebugMode:arguments.length>3&&void 0!==arguments[3]&&arguments[3]}},n=yh(t,void 0,!1),o=Md(e,n,r,null);return r.errors.length&&console.warn("Errors while exporting to string:",r.errors),o},Md=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return e.get("children1"),"group"===o||"rule_group"===o?Vd(e,t,r,n):"rule"===o?Ud(e,t,r,n):void 0}},Vd=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=r.settings,l=a.isForDisplay,s=a.isDebugMode,u=e.get("type"),c=e.get("properties")||new xa,d=c.get("mode"),p=e.get("children1")||new nl,f="rule_group"===u,v=f&&"array"==d?c.get("field"):null,h="rule_group"===u?c.get("operator"):null,g=h?null!==(n=null===(o=t.operators[h])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1:void 0,y=f&&"array"===d&&g>=1,m=c.get("not"),b=p.map((function(e){return Md(e,t,r,v)})).filter((function(e){return void 0!==e}));if(y||b.size||s){var E=c.get("conjunction");E||(E=wd(t));var O,S=t.conjunctions[E],T=b.size?S.formatConj.call(t.ctx,b,E,m,l):null;if(v){var _=Ud(e,t,r,i,!0);if(_){var w,R=_.pop(),I=[T].concat(eo(_));O=(w=t.settings.formatAggr).call.apply(w,[t.ctx].concat(eo(I))),R&&(O=t.settings.formatReverse.call(t.ctx,O,null,null,null,null,l))}}else O=T;return s&&null==O&&(O="?"),O}},Ud=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=r.settings,a=i.isForDisplay,l=i.isDebugMode,s=e.get("properties")||new xa,u=s.get("field"),c=s.get("fieldSrc"),d=s.get("operator"),p=s.get("operatorOptions");if(null!=u&&null!=d||l){var f=qh(t,u)||{},v=Kh(t,d,u)||{},h=v.reversedOp,g=Kh(t,h,u)||{},y=!1,m=v.formatOp;if(!m&&h&&(m=g.formatOp)){y=!0;var b=[h,d];d=b[0],h=b[1];var E=[g,v];v=E[0],g=E[1]}if(l&&!d&&(d="?"),m||(m=function(e,t,r){var n,o=r.settings.isDebugMode,i=(null==t?void 0:t.labelForFormat)||e,a=Cs(t);return 0==a?n=function(e,t,r,n,o,a,l,s){return"".concat(e," ").concat(i)}:1==a?n=function(e,t,r,n,a,l,s,u){return o&&"?"===t&&"?"===r?e&&"?"!==e?"".concat(e," ?"):"?":"".concat(e," ").concat(i," ").concat(r)}:2==a&&(n=function(e,t,r,n,o,a,l,s){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(i," ").concat(d," AND ").concat(p)}),n}(d,v,r)),m){var O="func"===c?qd(t,r,u,n):Gd(t,r,u,n);if(null!=O){var S=function(e,t,r,n,o){var i,a,l=r.settings,s=(l.isForDisplay,l.isDebugMode),u=t.get("field"),c=t.get("valueSrc"),d=t.get("valueType"),p=qh(e,u)||{},f=n||t.get("operator"),v=Kh(e,f,u)||{},h=Cs(v),g=t.get("value"),y=t.get("asyncListValues"),m=[],b=[];return null!=g&&!((a=g.map((function(t,n){var i=c?c.get(n):null,a=d?d.get(n):null,l=s?t:Ov(t,i,e),h=cv(e,u,f,i),g=Wh(e,u,f,h,i,{forExport:!0}),E=Bd(e,r,l,i,a,g,p,f,v,o,y);return void 0!==E&&(m.push(i),b.push(a)),E}))).filter((function(e){return void 0===e})).size>0)&&a.size===h&&(i=1==h?a.first():a),s&&!i&&(i=h>1?new nl(Array.from({length:h}).map((function(e,t){var r,n;return null!==(r=null===(n=a)||void 0===n?void 0:n.get(t))&&void 0!==r?r:"?"}))):"?"),[i,m.length>1?m:m[0],b.length>1?b:b[0]]}(t,s,r,d,n),T=Jn(S,3),_=T[0],w=T[1],R=T[2];if(void 0!==_){var I=[O,d,_,w,R,As(v,ws),p,a,f,y];if(o)return I;var A,C=(A=m).call.apply(A,[t.ctx].concat(I));return y&&(C=t.settings.formatReverse.call(t.ctx,C,d,h,v,g,a)),C}}}}},Bd=function(e,t,r,n,o,i,a,l,s){var u,c=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,d=arguments.length>10?arguments[10]:void 0,p=t.settings,f=p.isForDisplay,v=p.isDebugMode;if(void 0===r)return v?"array"===(null==i?void 0:i.jsType)?[]:"?":void 0;if("field"==n)u=Gd(e,t,r,c);else if("func"==n)u=qd(e,t,r,c);else if("function"==typeof(null==i?void 0:i.formatValue)){var h=i.formatValue,g=[r,Dd(Dd({},Js()(a,["fieldSettings","listValues"])),{},{asyncListValues:d}),As(i,_s),f];if(l&&(g.push(l),g.push(s)),"field"==n){var y=qh(e,r)||{};g.push(y)}u=h.call.apply(h,[e.ctx].concat(g))}else u=r;return u},Gd=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=t.settings,a=i.isForDisplay,l=i.isDebugMode,s=e.settings,u=(s.fieldSeparator,s.fieldSeparatorDisplay),c=null;if(r){var d=qh(e,r)||{},p=kh(r,e),f=nv(r,e,o?n:null),v=f?f.join(u):null,h=d.label2||v;c=(0,e.settings.formatField)(dv(r,e,t,o?n:null,{useTableName:!0}),p,h,d,e,a)}else l&&(c="?");return c},qd=function(e,t,r){var n,o,i,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,l=t.settings,s=l.isForDisplay,u=l.isDebugMode,c=null==r||null===(n=r.get)||void 0===n?void 0:n.call(r,"func");if(!c)return u?"?()":void 0;var d=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),p=xh(e,c);if(p||u){var f,v=kh(c,e),h=v[v.length-1],g=s&&(null==p?void 0:p.label)||h,y={},m=[],b=[],E={},O=xd(p?Object.keys(p.args||{}):(null==d||null===(i=d.keySeq)||void 0===i?void 0:i.call(d).toArray())||[]);try{for(O.s();!(f=O.n()).done;){var S,T=f.value,_=null==p?void 0:p.args[T],w=qh(e,_),R=_||{},I=R.defaultValue,A=R.isOptional,C=null!=I&&I.func?"func":"value",N=s&&(null==_?void 0:_.label)||T,L=d?d.get(T):void 0,j=L?L.get("value"):void 0,x=L?L.get("valueSrc"):void 0;"func"!==x&&null!==(S=j)&&void 0!==S&&S.toJS&&(j=j.toJS());var P=L?L.get("asyncListValues"):void 0,F=Bd(e,t,j,x,null==_?void 0:_.type,w,_,null,null,a,P);null!=j&&void 0===F&&"func"!=x&&t.errors.push("Can't format value of arg ".concat(T," for func ").concat(c));var D=void 0;if(void 0===F&&!A&&null!=I&&void 0===(D=Bd(e,t,I,C,null==_?void 0:_.type,w,_,null,null,a,P)))return void("func"!=C&&t.errors.push("Can't format default value of arg ".concat(T," for func ").concat(c)));var k=null!=F?F:D;if(void 0!==k){if(m.length){var M,V=xd(T);try{for(V.s();!(M=V.n()).done;){var U=Jn(M.value,2),B=U[0];U[1],y[B]=void 0}}catch(e){V.e(e)}finally{V.f()}m=[]}y[T]=k,E[N]=k}else A||b.push(T),m.push([T,N])}}catch(e){O.e(e)}finally{O.f()}if(!b.length||u){var G=null;if("function"==typeof(null==p?void 0:p.formatFunc)){var q=p.formatFunc,K=[y,s];G=q.call.apply(q,[e.ctx].concat(K))}else{var W=Object.entries(s?E:y).map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return s?"".concat(r,": ").concat(n):"".concat(n)})).join(", ");G="".concat(g,"(").concat(W,")")}return G}}else t.errors.push("Func ".concat(c," is not defined in config"))},Kd="EMPTY_GROUP",Wd="EMPTY_RULE_GROUP",zd="EMPTY_QUERY",Hd="EMPTY_CASE",$d="NO_CONFIG_FOR_FIELD",Yd="NO_CONFIG_FOR_OPERATOR",Qd="NO_CONFIG_FOR_FUNCTION",Xd="INVALID_VALUE",Jd="INVALID_FUNC_ARG_VALUE",Zd="UNSUPPORTED_FIELD_TYPE",ep="UNSUPPORTED_OPERATOR_FOR_FIELD",tp="INVALID_VALUE_SRC",rp="INCOMPLETE_RULE",np="INCOMPLETE_LHS",op="INCOMPLETE_RHS",ip="BAD_MULTISELECT_VALUES",ap="BAD_SELECT_VALUE",lp="INCORRECT_VALUE_TYPE",sp="INCORRECT_VALUE_JS_TYPE",up="VALUE_LENGTH_CONSTRAINT_FAIL",cp="VALUE_MIN_CONSTRAINT_FAIL",dp="VALUE_MAX_CONSTRAINT_FAIL",pp="NO_CONFIG_FOR_FIELD_VALUE",fp="CANT_COMPARE_FIELD_WITH_ITSELF",vp="CANT_COMPARE_FIELD_WITH_FIELD",hp="INCORRECT_FIELD_TYPE",gp="UNSUPPORTED_FUNCTION_FOR_FIELD",yp="REQUIRED_FUNCTION_ARG",mp="INCORRECT_FUNCTION_RETURN_TYPE",bp="INVALID_RANGE",Ep="ITEM_POSITION",Op="ITEM_POSITION_ROOT",Sp="ITEM_POSITION_WITH_INDEX_PATH",Tp="ITEM_POSITION_IN_CASE",_p="range";const wp={type:"logger",log(e){this.output("log",e)},warn(e){this.output("warn",e)},error(e){this.output("error",e)},output(e,t){console&&console[e]&&console[e].apply(console,t)}};class Rp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.init(e,t)}init(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.prefix=t.prefix||"i18next:",this.logger=e||wp,this.options=t,this.debug=t.debug}log(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"log","",!0)}warn(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","",!0)}error(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"error","")}deprecate(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","WARNING DEPRECATED: ",!0)}forward(e,t,r,n){return n&&!this.debug?null:("string"==typeof e[0]&&(e[0]=`${r}${this.prefix} ${e[0]}`),this.logger[t](e))}create(e){return new Rp(this.logger,{prefix:`${this.prefix}:${e}:`,...this.options})}clone(e){return(e=e||this.options).prefix=e.prefix||this.prefix,new Rp(this.logger,e)}}var Ip=new Rp;class Ap{constructor(){this.observers={}}on(e,t){return e.split(" ").forEach((e=>{this.observers[e]||(this.observers[e]=new Map);const r=this.observers[e].get(t)||0;this.observers[e].set(t,r+1)})),this}off(e,t){this.observers[e]&&(t?this.observers[e].delete(t):delete this.observers[e])}emit(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];this.observers[e]&&Array.from(this.observers[e].entries()).forEach((e=>{let[t,n]=e;for(let e=0;e<n;e++)t(...r)})),this.observers["*"]&&Array.from(this.observers["*"].entries()).forEach((t=>{let[n,o]=t;for(let t=0;t<o;t++)n.apply(n,[e,...r])}))}}const Cp=()=>{let e,t;const r=new Promise(((r,n)=>{e=r,t=n}));return r.resolve=e,r.reject=t,r},Np=e=>null==e?"":""+e,Lp=/###/g,jp=e=>e&&e.indexOf("###")>-1?e.replace(Lp,"."):e,xp=e=>!e||"string"==typeof e,Pp=(e,t,r)=>{const n="string"!=typeof t?t:t.split(".");let o=0;for(;o<n.length-1;){if(xp(e))return{};const t=jp(n[o]);!e[t]&&r&&(e[t]=new r),e=Object.prototype.hasOwnProperty.call(e,t)?e[t]:{},++o}return xp(e)?{}:{obj:e,k:jp(n[o])}},Fp=(e,t,r)=>{const{obj:n,k:o}=Pp(e,t,Object);if(void 0!==n||1===t.length)return void(n[o]=r);let i=t[t.length-1],a=t.slice(0,t.length-1),l=Pp(e,a,Object);for(;void 0===l.obj&&a.length;)i=`${a[a.length-1]}.${i}`,a=a.slice(0,a.length-1),l=Pp(e,a,Object),l&&l.obj&&void 0!==l.obj[`${l.k}.${i}`]&&(l.obj=void 0);l.obj[`${l.k}.${i}`]=r},Dp=(e,t)=>{const{obj:r,k:n}=Pp(e,t);if(r)return r[n]},kp=(e,t,r)=>{for(const n in t)"__proto__"!==n&&"constructor"!==n&&(n in e?"string"==typeof e[n]||e[n]instanceof String||"string"==typeof t[n]||t[n]instanceof String?r&&(e[n]=t[n]):kp(e[n],t[n],r):e[n]=t[n]);return e},Mp=e=>e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&");var Vp={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;"};const Up=e=>"string"==typeof e?e.replace(/[&<>"'\/]/g,(e=>Vp[e])):e,Bp=[" ",",","?","!",";"],Gp=new class{constructor(e){this.capacity=e,this.regExpMap=new Map,this.regExpQueue=[]}getRegExp(e){const t=this.regExpMap.get(e);if(void 0!==t)return t;const r=new RegExp(e);return this.regExpQueue.length===this.capacity&&this.regExpMap.delete(this.regExpQueue.shift()),this.regExpMap.set(e,r),this.regExpQueue.push(e),r}}(20),qp=function(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:".";if(!e)return;if(e[t])return e[t];const n=t.split(r);let o=e;for(let e=0;e<n.length;){if(!o||"object"!=typeof o)return;let t,i="";for(let a=e;a<n.length;++a)if(a!==e&&(i+=r),i+=n[a],t=o[i],void 0!==t){if(["string","number","boolean"].indexOf(typeof t)>-1&&a<n.length-1)continue;e+=a-e+1;break}o=t}return o},Kp=e=>e&&e.indexOf("_")>0?e.replace("_","-"):e;class Wp extends Ap{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{ns:["translation"],defaultNS:"translation"};super(),this.data=e||{},this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),void 0===this.options.ignoreJSONStructure&&(this.options.ignoreJSONStructure=!0)}addNamespaces(e){this.options.ns.indexOf(e)<0&&this.options.ns.push(e)}removeNamespaces(e){const t=this.options.ns.indexOf(e);t>-1&&this.options.ns.splice(t,1)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=void 0!==n.keySeparator?n.keySeparator:this.options.keySeparator,i=void 0!==n.ignoreJSONStructure?n.ignoreJSONStructure:this.options.ignoreJSONStructure;let a;e.indexOf(".")>-1?a=e.split("."):(a=[e,t],r&&(Array.isArray(r)?a.push(...r):"string"==typeof r&&o?a.push(...r.split(o)):a.push(r)));const l=Dp(this.data,a);return!l&&!t&&!r&&e.indexOf(".")>-1&&(e=a[0],t=a[1],r=a.slice(2).join(".")),l||!i||"string"!=typeof r?l:qp(this.data&&this.data[e]&&this.data[e][t],r,o)}addResource(e,t,r,n){let o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{silent:!1};const i=void 0!==o.keySeparator?o.keySeparator:this.options.keySeparator;let a=[e,t];r&&(a=a.concat(i?r.split(i):r)),e.indexOf(".")>-1&&(a=e.split("."),n=t,t=a[1]),this.addNamespaces(t),Fp(this.data,a,n),o.silent||this.emit("added",e,t,r,n)}addResources(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{silent:!1};for(const n in r)("string"==typeof r[n]||Array.isArray(r[n]))&&this.addResource(e,t,n,r[n],{silent:!0});n.silent||this.emit("added",e,t,r)}addResourceBundle(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{silent:!1,skipCopy:!1},a=[e,t];e.indexOf(".")>-1&&(a=e.split("."),n=r,r=t,t=a[1]),this.addNamespaces(t);let l=Dp(this.data,a)||{};i.skipCopy||(r=JSON.parse(JSON.stringify(r))),n?kp(l,r,o):l={...l,...r},Fp(this.data,a,l),i.silent||this.emit("added",e,t,r)}removeResourceBundle(e,t){this.hasResourceBundle(e,t)&&delete this.data[e][t],this.removeNamespaces(t),this.emit("removed",e,t)}hasResourceBundle(e,t){return void 0!==this.getResource(e,t)}getResourceBundle(e,t){return t||(t=this.options.defaultNS),"v1"===this.options.compatibilityAPI?{...this.getResource(e,t)}:this.getResource(e,t)}getDataByLanguage(e){return this.data[e]}hasLanguageSomeTranslations(e){const t=this.getDataByLanguage(e);return!!(t&&Object.keys(t)||[]).find((e=>t[e]&&Object.keys(t[e]).length>0))}toJSON(){return this.data}}var zp={processors:{},addPostProcessor(e){this.processors[e.name]=e},handle(e,t,r,n,o){return e.forEach((e=>{this.processors[e]&&(t=this.processors[e].process(t,r,n,o))})),t}};const Hp={};class $p extends Ap{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};var r,n;super(),r=e,n=this,["resourceStore","languageUtils","pluralResolver","interpolator","backendConnector","i18nFormat","utils"].forEach((e=>{r[e]&&(n[e]=r[e])})),this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),this.logger=Ip.create("translator")}changeLanguage(e){e&&(this.language=e)}exists(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}};if(null==e)return!1;const r=this.resolve(e,t);return r&&void 0!==r.res}extractFromKey(e,t){let r=void 0!==t.nsSeparator?t.nsSeparator:this.options.nsSeparator;void 0===r&&(r=":");const n=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator;let o=t.ns||this.options.defaultNS||[];const i=r&&e.indexOf(r)>-1,a=!(this.options.userDefinedKeySeparator||t.keySeparator||this.options.userDefinedNsSeparator||t.nsSeparator||((e,t,r)=>{t=t||"",r=r||"";const n=Bp.filter((e=>t.indexOf(e)<0&&r.indexOf(e)<0));if(0===n.length)return!0;const o=Gp.getRegExp(`(${n.map((e=>"?"===e?"\\?":e)).join("|")})`);let i=!o.test(e);if(!i){const t=e.indexOf(r);t>0&&!o.test(e.substring(0,t))&&(i=!0)}return i})(e,r,n));if(i&&!a){const t=e.match(this.interpolator.nestingRegexp);if(t&&t.length>0)return{key:e,namespaces:o};const i=e.split(r);(r!==n||r===n&&this.options.ns.indexOf(i[0])>-1)&&(o=i.shift()),e=i.join(n)}return"string"==typeof o&&(o=[o]),{key:e,namespaces:o}}translate(e,t,r){if("object"!=typeof t&&this.options.overloadTranslationOptionHandler&&(t=this.options.overloadTranslationOptionHandler(arguments)),"object"==typeof t&&(t={...t}),t||(t={}),null==e)return"";Array.isArray(e)||(e=[String(e)]);const n=void 0!==t.returnDetails?t.returnDetails:this.options.returnDetails,o=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator,{key:i,namespaces:a}=this.extractFromKey(e[e.length-1],t),l=a[a.length-1],s=t.lng||this.language,u=t.appendNamespaceToCIMode||this.options.appendNamespaceToCIMode;if(s&&"cimode"===s.toLowerCase()){if(u){const e=t.nsSeparator||this.options.nsSeparator;return n?{res:`${l}${e}${i}`,usedKey:i,exactUsedKey:i,usedLng:s,usedNS:l,usedParams:this.getUsedParamsDetails(t)}:`${l}${e}${i}`}return n?{res:i,usedKey:i,exactUsedKey:i,usedLng:s,usedNS:l,usedParams:this.getUsedParamsDetails(t)}:i}const c=this.resolve(e,t);let d=c&&c.res;const p=c&&c.usedKey||i,f=c&&c.exactUsedKey||i,v=Object.prototype.toString.apply(d),h=void 0!==t.joinArrays?t.joinArrays:this.options.joinArrays,g=!this.i18nFormat||this.i18nFormat.handleAsObject;if(g&&d&&"string"!=typeof d&&"boolean"!=typeof d&&"number"!=typeof d&&["[object Number]","[object Function]","[object RegExp]"].indexOf(v)<0&&("string"!=typeof h||!Array.isArray(d))){if(!t.returnObjects&&!this.options.returnObjects){this.options.returnedObjectHandler||this.logger.warn("accessing an object - but returnObjects options is not enabled!");const e=this.options.returnedObjectHandler?this.options.returnedObjectHandler(p,d,{...t,ns:a}):`key '${i} (${this.language})' returned an object instead of string.`;return n?(c.res=e,c.usedParams=this.getUsedParamsDetails(t),c):e}if(o){const e=Array.isArray(d),r=e?[]:{},n=e?f:p;for(const e in d)if(Object.prototype.hasOwnProperty.call(d,e)){const i=`${n}${o}${e}`;r[e]=this.translate(i,{...t,joinArrays:!1,ns:a}),r[e]===i&&(r[e]=d[e])}d=r}}else if(g&&"string"==typeof h&&Array.isArray(d))d=d.join(h),d&&(d=this.extendTranslation(d,e,t,r));else{let n=!1,a=!1;const u=void 0!==t.count&&"string"!=typeof t.count,p=$p.hasDefaultValue(t),f=u?this.pluralResolver.getSuffix(s,t.count,t):"",v=t.ordinal&&u?this.pluralResolver.getSuffix(s,t.count,{ordinal:!1}):"",h=u&&!t.ordinal&&0===t.count&&this.pluralResolver.shouldUseIntlApi(),g=h&&t[`defaultValue${this.options.pluralSeparator}zero`]||t[`defaultValue${f}`]||t[`defaultValue${v}`]||t.defaultValue;!this.isValidLookup(d)&&p&&(n=!0,d=g),this.isValidLookup(d)||(a=!0,d=i);const y=(t.missingKeyNoValueFallbackToKey||this.options.missingKeyNoValueFallbackToKey)&&a?void 0:d,m=p&&g!==d&&this.options.updateMissing;if(a||n||m){if(this.logger.log(m?"updateKey":"missingKey",s,l,i,m?g:d),o){const e=this.resolve(i,{...t,keySeparator:!1});e&&e.res&&this.logger.warn("Seems the loaded translations were in flat JSON format instead of nested. Either set keySeparator: false on init or make sure your translations are published in nested format.")}let e=[];const r=this.languageUtils.getFallbackCodes(this.options.fallbackLng,t.lng||this.language);if("fallback"===this.options.saveMissingTo&&r&&r[0])for(let t=0;t<r.length;t++)e.push(r[t]);else"all"===this.options.saveMissingTo?e=this.languageUtils.toResolveHierarchy(t.lng||this.language):e.push(t.lng||this.language);const n=(e,r,n)=>{const o=p&&n!==d?n:y;this.options.missingKeyHandler?this.options.missingKeyHandler(e,l,r,o,m,t):this.backendConnector&&this.backendConnector.saveMissing&&this.backendConnector.saveMissing(e,l,r,o,m,t),this.emit("missingKey",e,l,r,d)};this.options.saveMissing&&(this.options.saveMissingPlurals&&u?e.forEach((e=>{const r=this.pluralResolver.getSuffixes(e,t);h&&t[`defaultValue${this.options.pluralSeparator}zero`]&&r.indexOf(`${this.options.pluralSeparator}zero`)<0&&r.push(`${this.options.pluralSeparator}zero`),r.forEach((r=>{n([e],i+r,t[`defaultValue${r}`]||g)}))})):n(e,i,g))}d=this.extendTranslation(d,e,t,c,r),a&&d===i&&this.options.appendNamespaceToMissingKey&&(d=`${l}:${i}`),(a||n)&&this.options.parseMissingKeyHandler&&(d="v1"!==this.options.compatibilityAPI?this.options.parseMissingKeyHandler(this.options.appendNamespaceToMissingKey?`${l}:${i}`:i,n?d:void 0):this.options.parseMissingKeyHandler(d))}return n?(c.res=d,c.usedParams=this.getUsedParamsDetails(t),c):d}extendTranslation(e,t,r,n,o){var i=this;if(this.i18nFormat&&this.i18nFormat.parse)e=this.i18nFormat.parse(e,{...this.options.interpolation.defaultVariables,...r},r.lng||this.language||n.usedLng,n.usedNS,n.usedKey,{resolved:n});else if(!r.skipInterpolation){r.interpolation&&this.interpolator.init({...r,interpolation:{...this.options.interpolation,...r.interpolation}});const a="string"==typeof e&&(r&&r.interpolation&&void 0!==r.interpolation.skipOnVariables?r.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables);let l;if(a){const t=e.match(this.interpolator.nestingRegexp);l=t&&t.length}let s=r.replace&&"string"!=typeof r.replace?r.replace:r;if(this.options.interpolation.defaultVariables&&(s={...this.options.interpolation.defaultVariables,...s}),e=this.interpolator.interpolate(e,s,r.lng||this.language||n.usedLng,r),a){const t=e.match(this.interpolator.nestingRegexp);l<(t&&t.length)&&(r.nest=!1)}!r.lng&&"v1"!==this.options.compatibilityAPI&&n&&n.res&&(r.lng=this.language||n.usedLng),!1!==r.nest&&(e=this.interpolator.nest(e,(function(){for(var e=arguments.length,n=new Array(e),a=0;a<e;a++)n[a]=arguments[a];return o&&o[0]===n[0]&&!r.context?(i.logger.warn(`It seems you are nesting recursively key: ${n[0]} in key: ${t[0]}`),null):i.translate(...n,t)}),r)),r.interpolation&&this.interpolator.reset()}const a=r.postProcess||this.options.postProcess,l="string"==typeof a?[a]:a;return null!=e&&l&&l.length&&!1!==r.applyPostProcessor&&(e=zp.handle(l,e,t,this.options&&this.options.postProcessPassResolved?{i18nResolved:{...n,usedParams:this.getUsedParamsDetails(r)},...r}:r,this)),e}resolve(e){let t,r,n,o,i,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return"string"==typeof e&&(e=[e]),e.forEach((e=>{if(this.isValidLookup(t))return;const l=this.extractFromKey(e,a),s=l.key;r=s;let u=l.namespaces;this.options.fallbackNS&&(u=u.concat(this.options.fallbackNS));const c=void 0!==a.count&&"string"!=typeof a.count,d=c&&!a.ordinal&&0===a.count&&this.pluralResolver.shouldUseIntlApi(),p=void 0!==a.context&&("string"==typeof a.context||"number"==typeof a.context)&&""!==a.context,f=a.lngs?a.lngs:this.languageUtils.toResolveHierarchy(a.lng||this.language,a.fallbackLng);u.forEach((e=>{this.isValidLookup(t)||(i=e,!Hp[`${f[0]}-${e}`]&&this.utils&&this.utils.hasLoadedNamespace&&!this.utils.hasLoadedNamespace(i)&&(Hp[`${f[0]}-${e}`]=!0,this.logger.warn(`key "${r}" for languages "${f.join(", ")}" won't get resolved as namespace "${i}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!")),f.forEach((r=>{if(this.isValidLookup(t))return;o=r;const i=[s];if(this.i18nFormat&&this.i18nFormat.addLookupKeys)this.i18nFormat.addLookupKeys(i,s,r,e,a);else{let e;c&&(e=this.pluralResolver.getSuffix(r,a.count,a));const t=`${this.options.pluralSeparator}zero`,n=`${this.options.pluralSeparator}ordinal${this.options.pluralSeparator}`;if(c&&(i.push(s+e),a.ordinal&&0===e.indexOf(n)&&i.push(s+e.replace(n,this.options.pluralSeparator)),d&&i.push(s+t)),p){const r=`${s}${this.options.contextSeparator}${a.context}`;i.push(r),c&&(i.push(r+e),a.ordinal&&0===e.indexOf(n)&&i.push(r+e.replace(n,this.options.pluralSeparator)),d&&i.push(r+t))}}let l;for(;l=i.pop();)this.isValidLookup(t)||(n=l,t=this.getResource(r,e,l,a))})))}))})),{res:t,usedKey:r,exactUsedKey:n,usedLng:o,usedNS:i}}isValidLookup(e){return!(void 0===e||!this.options.returnNull&&null===e||!this.options.returnEmptyString&&""===e)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};return this.i18nFormat&&this.i18nFormat.getResource?this.i18nFormat.getResource(e,t,r,n):this.resourceStore.getResource(e,t,r,n)}getUsedParamsDetails(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};const t=["defaultValue","ordinal","context","replace","lng","lngs","fallbackLng","ns","keySeparator","nsSeparator","returnObjects","returnDetails","joinArrays","postProcess","interpolation"],r=e.replace&&"string"!=typeof e.replace;let n=r?e.replace:e;if(r&&void 0!==e.count&&(n.count=e.count),this.options.interpolation.defaultVariables&&(n={...this.options.interpolation.defaultVariables,...n}),!r){n={...n};for(const e of t)delete n[e]}return n}static hasDefaultValue(e){for(const t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&"defaultValue"===t.substring(0,12)&&void 0!==e[t])return!0;return!1}}const Yp=e=>e.charAt(0).toUpperCase()+e.slice(1);class Qp{constructor(e){this.options=e,this.supportedLngs=this.options.supportedLngs||!1,this.logger=Ip.create("languageUtils")}getScriptPartFromCode(e){if(!(e=Kp(e))||e.indexOf("-")<0)return null;const t=e.split("-");return 2===t.length?null:(t.pop(),"x"===t[t.length-1].toLowerCase()?null:this.formatLanguageCode(t.join("-")))}getLanguagePartFromCode(e){if(!(e=Kp(e))||e.indexOf("-")<0)return e;const t=e.split("-");return this.formatLanguageCode(t[0])}formatLanguageCode(e){if("string"==typeof e&&e.indexOf("-")>-1){const t=["hans","hant","latn","cyrl","cans","mong","arab"];let r=e.split("-");return this.options.lowerCaseLng?r=r.map((e=>e.toLowerCase())):2===r.length?(r[0]=r[0].toLowerCase(),r[1]=r[1].toUpperCase(),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=Yp(r[1].toLowerCase()))):3===r.length&&(r[0]=r[0].toLowerCase(),2===r[1].length&&(r[1]=r[1].toUpperCase()),"sgn"!==r[0]&&2===r[2].length&&(r[2]=r[2].toUpperCase()),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=Yp(r[1].toLowerCase())),t.indexOf(r[2].toLowerCase())>-1&&(r[2]=Yp(r[2].toLowerCase()))),r.join("-")}return this.options.cleanCode||this.options.lowerCaseLng?e.toLowerCase():e}isSupportedCode(e){return("languageOnly"===this.options.load||this.options.nonExplicitSupportedLngs)&&(e=this.getLanguagePartFromCode(e)),!this.supportedLngs||!this.supportedLngs.length||this.supportedLngs.indexOf(e)>-1}getBestMatchFromCodes(e){if(!e)return null;let t;return e.forEach((e=>{if(t)return;const r=this.formatLanguageCode(e);this.options.supportedLngs&&!this.isSupportedCode(r)||(t=r)})),!t&&this.options.supportedLngs&&e.forEach((e=>{if(t)return;const r=this.getLanguagePartFromCode(e);if(this.isSupportedCode(r))return t=r;t=this.options.supportedLngs.find((e=>e===r?e:e.indexOf("-")<0&&r.indexOf("-")<0?void 0:e.indexOf("-")>0&&r.indexOf("-")<0&&e.substring(0,e.indexOf("-"))===r||0===e.indexOf(r)&&r.length>1?e:void 0))})),t||(t=this.getFallbackCodes(this.options.fallbackLng)[0]),t}getFallbackCodes(e,t){if(!e)return[];if("function"==typeof e&&(e=e(t)),"string"==typeof e&&(e=[e]),Array.isArray(e))return e;if(!t)return e.default||[];let r=e[t];return r||(r=e[this.getScriptPartFromCode(t)]),r||(r=e[this.formatLanguageCode(t)]),r||(r=e[this.getLanguagePartFromCode(t)]),r||(r=e.default),r||[]}toResolveHierarchy(e,t){const r=this.getFallbackCodes(t||this.options.fallbackLng||[],e),n=[],o=e=>{e&&(this.isSupportedCode(e)?n.push(e):this.logger.warn(`rejecting language code not found in supportedLngs: ${e}`))};return"string"==typeof e&&(e.indexOf("-")>-1||e.indexOf("_")>-1)?("languageOnly"!==this.options.load&&o(this.formatLanguageCode(e)),"languageOnly"!==this.options.load&&"currentOnly"!==this.options.load&&o(this.getScriptPartFromCode(e)),"currentOnly"!==this.options.load&&o(this.getLanguagePartFromCode(e))):"string"==typeof e&&o(this.formatLanguageCode(e)),r.forEach((e=>{n.indexOf(e)<0&&o(this.formatLanguageCode(e))})),n}}let Xp=[{lngs:["ach","ak","am","arn","br","fil","gun","ln","mfe","mg","mi","oc","pt","pt-BR","tg","tl","ti","tr","uz","wa"],nr:[1,2],fc:1},{lngs:["af","an","ast","az","bg","bn","ca","da","de","dev","el","en","eo","es","et","eu","fi","fo","fur","fy","gl","gu","ha","hi","hu","hy","ia","it","kk","kn","ku","lb","mai","ml","mn","mr","nah","nap","nb","ne","nl","nn","no","nso","pa","pap","pms","ps","pt-PT","rm","sco","se","si","so","son","sq","sv","sw","ta","te","tk","ur","yo"],nr:[1,2],fc:2},{lngs:["ay","bo","cgg","fa","ht","id","ja","jbo","ka","km","ko","ky","lo","ms","sah","su","th","tt","ug","vi","wo","zh"],nr:[1],fc:3},{lngs:["be","bs","cnr","dz","hr","ru","sr","uk"],nr:[1,2,5],fc:4},{lngs:["ar"],nr:[0,1,2,3,11,100],fc:5},{lngs:["cs","sk"],nr:[1,2,5],fc:6},{lngs:["csb","pl"],nr:[1,2,5],fc:7},{lngs:["cy"],nr:[1,2,3,8],fc:8},{lngs:["fr"],nr:[1,2],fc:9},{lngs:["ga"],nr:[1,2,3,7,11],fc:10},{lngs:["gd"],nr:[1,2,3,20],fc:11},{lngs:["is"],nr:[1,2],fc:12},{lngs:["jv"],nr:[0,1],fc:13},{lngs:["kw"],nr:[1,2,3,4],fc:14},{lngs:["lt"],nr:[1,2,10],fc:15},{lngs:["lv"],nr:[1,2,0],fc:16},{lngs:["mk"],nr:[1,2],fc:17},{lngs:["mnk"],nr:[0,1,2],fc:18},{lngs:["mt"],nr:[1,2,11,20],fc:19},{lngs:["or"],nr:[2,1],fc:2},{lngs:["ro"],nr:[1,2,20],fc:20},{lngs:["sl"],nr:[5,1,2,3],fc:21},{lngs:["he","iw"],nr:[1,2,20,21],fc:22}],Jp={1:e=>Number(e>1),2:e=>Number(1!=e),3:e=>0,4:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),5:e=>Number(0==e?0:1==e?1:2==e?2:e%100>=3&&e%100<=10?3:e%100>=11?4:5),6:e=>Number(1==e?0:e>=2&&e<=4?1:2),7:e=>Number(1==e?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2),8:e=>Number(1==e?0:2==e?1:8!=e&&11!=e?2:3),9:e=>Number(e>=2),10:e=>Number(1==e?0:2==e?1:e<7?2:e<11?3:4),11:e=>Number(1==e||11==e?0:2==e||12==e?1:e>2&&e<20?2:3),12:e=>Number(e%10!=1||e%100==11),13:e=>Number(0!==e),14:e=>Number(1==e?0:2==e?1:3==e?2:3),15:e=>Number(e%10==1&&e%100!=11?0:e%10>=2&&(e%100<10||e%100>=20)?1:2),16:e=>Number(e%10==1&&e%100!=11?0:0!==e?1:2),17:e=>Number(1==e||e%10==1&&e%100!=11?0:1),18:e=>Number(0==e?0:1==e?1:2),19:e=>Number(1==e?0:0==e||e%100>1&&e%100<11?1:e%100>10&&e%100<20?2:3),20:e=>Number(1==e?0:0==e||e%100>0&&e%100<20?1:2),21:e=>Number(e%100==1?1:e%100==2?2:e%100==3||e%100==4?3:0),22:e=>Number(1==e?0:2==e?1:(e<0||e>10)&&e%10==0?2:3)};const Zp=["v1","v2","v3"],ef=["v4"],tf={zero:0,one:1,two:2,few:3,many:4,other:5};class rf{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.languageUtils=e,this.options=t,this.logger=Ip.create("pluralResolver"),this.options.compatibilityJSON&&!ef.includes(this.options.compatibilityJSON)||"undefined"!=typeof Intl&&Intl.PluralRules||(this.options.compatibilityJSON="v3",this.logger.error("Your environment seems not to be Intl API compatible, use an Intl.PluralRules polyfill. Will fallback to the compatibilityJSON v3 format handling.")),this.rules=(()=>{const e={};return Xp.forEach((t=>{t.lngs.forEach((r=>{e[r]={numbers:t.nr,plurals:Jp[t.fc]}}))})),e})(),this.pluralRulesCache={}}addRule(e,t){this.rules[e]=t}clearCache(){this.pluralRulesCache={}}getRule(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(this.shouldUseIntlApi())try{const r=Kp("dev"===e?"en":e),n=t.ordinal?"ordinal":"cardinal",o=JSON.stringify({cleanedCode:r,type:n});if(o in this.pluralRulesCache)return this.pluralRulesCache[o];const i=new Intl.PluralRules(r,{type:n});return this.pluralRulesCache[o]=i,i}catch(e){return}return this.rules[e]||this.rules[this.languageUtils.getLanguagePartFromCode(e)]}needsPlural(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return this.shouldUseIntlApi()?r&&r.resolvedOptions().pluralCategories.length>1:r&&r.numbers.length>1}getPluralFormsOfKey(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this.getSuffixes(e,r).map((e=>`${t}${e}`))}getSuffixes(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return r?this.shouldUseIntlApi()?r.resolvedOptions().pluralCategories.sort(((e,t)=>tf[e]-tf[t])).map((e=>`${this.options.prepend}${t.ordinal?`ordinal${this.options.prepend}`:""}${e}`)):r.numbers.map((r=>this.getSuffix(e,r,t))):[]}getSuffix(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const n=this.getRule(e,r);return n?this.shouldUseIntlApi()?`${this.options.prepend}${r.ordinal?`ordinal${this.options.prepend}`:""}${n.select(t)}`:this.getSuffixRetroCompatible(n,t):(this.logger.warn(`no plural rule found for: ${e}`),"")}getSuffixRetroCompatible(e,t){const r=e.noAbs?e.plurals(t):e.plurals(Math.abs(t));let n=e.numbers[r];this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]&&(2===n?n="plural":1===n&&(n=""));const o=()=>this.options.prepend&&n.toString()?this.options.prepend+n.toString():n.toString();return"v1"===this.options.compatibilityJSON?1===n?"":"number"==typeof n?`_plural_${n.toString()}`:o():"v2"===this.options.compatibilityJSON||this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]?o():this.options.prepend&&r.toString()?this.options.prepend+r.toString():r.toString()}shouldUseIntlApi(){return!Zp.includes(this.options.compatibilityJSON)}}const nf=function(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:".",o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=((e,t,r)=>{const n=Dp(e,r);return void 0!==n?n:Dp(t,r)})(e,t,r);return!i&&o&&"string"==typeof r&&(i=qp(e,r,n),void 0===i&&(i=qp(t,r,n))),i},of=e=>e.replace(/\$/g,"$$$$");class af{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=Ip.create("interpolator"),this.options=e,this.format=e.interpolation&&e.interpolation.format||(e=>e),this.init(e)}init(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e.interpolation||(e.interpolation={escapeValue:!0});const{escape:t,escapeValue:r,useRawValueToEscape:n,prefix:o,prefixEscaped:i,suffix:a,suffixEscaped:l,formatSeparator:s,unescapeSuffix:u,unescapePrefix:c,nestingPrefix:d,nestingPrefixEscaped:p,nestingSuffix:f,nestingSuffixEscaped:v,nestingOptionsSeparator:h,maxReplaces:g,alwaysFormat:y}=e.interpolation;this.escape=void 0!==t?t:Up,this.escapeValue=void 0===r||r,this.useRawValueToEscape=void 0!==n&&n,this.prefix=o?Mp(o):i||"{{",this.suffix=a?Mp(a):l||"}}",this.formatSeparator=s||",",this.unescapePrefix=u?"":c||"-",this.unescapeSuffix=this.unescapePrefix?"":u||"",this.nestingPrefix=d?Mp(d):p||Mp("$t("),this.nestingSuffix=f?Mp(f):v||Mp(")"),this.nestingOptionsSeparator=h||",",this.maxReplaces=g||1e3,this.alwaysFormat=void 0!==y&&y,this.resetRegExp()}reset(){this.options&&this.init(this.options)}resetRegExp(){const e=(e,t)=>e&&e.source===t?(e.lastIndex=0,e):new RegExp(t,"g");this.regexp=e(this.regexp,`${this.prefix}(.+?)${this.suffix}`),this.regexpUnescape=e(this.regexpUnescape,`${this.prefix}${this.unescapePrefix}(.+?)${this.unescapeSuffix}${this.suffix}`),this.nestingRegexp=e(this.nestingRegexp,`${this.nestingPrefix}(.+?)${this.nestingSuffix}`)}interpolate(e,t,r,n){let o,i,a;const l=this.options&&this.options.interpolation&&this.options.interpolation.defaultVariables||{},s=e=>{if(e.indexOf(this.formatSeparator)<0){const o=nf(t,l,e,this.options.keySeparator,this.options.ignoreJSONStructure);return this.alwaysFormat?this.format(o,void 0,r,{...n,...t,interpolationkey:e}):o}const o=e.split(this.formatSeparator),i=o.shift().trim(),a=o.join(this.formatSeparator).trim();return this.format(nf(t,l,i,this.options.keySeparator,this.options.ignoreJSONStructure),a,r,{...n,...t,interpolationkey:i})};this.resetRegExp();const u=n&&n.missingInterpolationHandler||this.options.missingInterpolationHandler,c=n&&n.interpolation&&void 0!==n.interpolation.skipOnVariables?n.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables;return[{regex:this.regexpUnescape,safeValue:e=>of(e)},{regex:this.regexp,safeValue:e=>this.escapeValue?of(this.escape(e)):of(e)}].forEach((t=>{for(a=0;o=t.regex.exec(e);){const r=o[1].trim();if(i=s(r),void 0===i)if("function"==typeof u){const t=u(e,o,n);i="string"==typeof t?t:""}else if(n&&Object.prototype.hasOwnProperty.call(n,r))i="";else{if(c){i=o[0];continue}this.logger.warn(`missed to pass in variable ${r} for interpolating ${e}`),i=""}else"string"==typeof i||this.useRawValueToEscape||(i=Np(i));const l=t.safeValue(i);if(e=e.replace(o[0],l),c?(t.regex.lastIndex+=i.length,t.regex.lastIndex-=o[0].length):t.regex.lastIndex=0,a++,a>=this.maxReplaces)break}})),e}nest(e,t){let r,n,o,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const a=(e,t)=>{const r=this.nestingOptionsSeparator;if(e.indexOf(r)<0)return e;const n=e.split(new RegExp(`${r}[ ]*{`));let i=`{${n[1]}`;e=n[0],i=this.interpolate(i,o);const a=i.match(/'/g),l=i.match(/"/g);(a&&a.length%2==0&&!l||l.length%2!=0)&&(i=i.replace(/'/g,'"'));try{o=JSON.parse(i),t&&(o={...t,...o})}catch(t){return this.logger.warn(`failed parsing options string in nesting for key ${e}`,t),`${e}${r}${i}`}return o.defaultValue&&o.defaultValue.indexOf(this.prefix)>-1&&delete o.defaultValue,e};for(;r=this.nestingRegexp.exec(e);){let l=[];o={...i},o=o.replace&&"string"!=typeof o.replace?o.replace:o,o.applyPostProcessor=!1,delete o.defaultValue;let s=!1;if(-1!==r[0].indexOf(this.formatSeparator)&&!/{.*}/.test(r[1])){const e=r[1].split(this.formatSeparator).map((e=>e.trim()));r[1]=e.shift(),l=e,s=!0}if(n=t(a.call(this,r[1].trim(),o),o),n&&r[0]===e&&"string"!=typeof n)return n;"string"!=typeof n&&(n=Np(n)),n||(this.logger.warn(`missed to resolve ${r[1]} for nesting ${e}`),n=""),s&&(n=l.reduce(((e,t)=>this.format(e,t,i.lng,{...i,interpolationkey:r[1].trim()})),n.trim())),e=e.replace(r[0],n),this.regexp.lastIndex=0}return e}}const lf=e=>{const t={};return(r,n,o)=>{let i=o;o&&o.interpolationkey&&o.formatParams&&o.formatParams[o.interpolationkey]&&o[o.interpolationkey]&&(i={...i,[o.interpolationkey]:void 0});const a=n+JSON.stringify(i);let l=t[a];return l||(l=e(Kp(n),o),t[a]=l),l(r)}};class sf{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=Ip.create("formatter"),this.options=e,this.formats={number:lf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t});return e=>r.format(e)})),currency:lf(((e,t)=>{const r=new Intl.NumberFormat(e,{...t,style:"currency"});return e=>r.format(e)})),datetime:lf(((e,t)=>{const r=new Intl.DateTimeFormat(e,{...t});return e=>r.format(e)})),relativetime:lf(((e,t)=>{const r=new Intl.RelativeTimeFormat(e,{...t});return e=>r.format(e,t.range||"day")})),list:lf(((e,t)=>{const r=new Intl.ListFormat(e,{...t});return e=>r.format(e)}))},this.init(e)}init(e){const t=(arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}}).interpolation;this.formatSeparator=t.formatSeparator?t.formatSeparator:t.formatSeparator||","}add(e,t){this.formats[e.toLowerCase().trim()]=t}addCached(e,t){this.formats[e.toLowerCase().trim()]=lf(t)}format(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=t.split(this.formatSeparator);if(o.length>1&&o[0].indexOf("(")>1&&o[0].indexOf(")")<0&&o.find((e=>e.indexOf(")")>-1))){const e=o.findIndex((e=>e.indexOf(")")>-1));o[0]=[o[0],...o.splice(1,e)].join(this.formatSeparator)}return o.reduce(((e,t)=>{const{formatName:o,formatOptions:i}=(e=>{let t=e.toLowerCase().trim();const r={};if(e.indexOf("(")>-1){const n=e.split("(");t=n[0].toLowerCase().trim();const o=n[1].substring(0,n[1].length-1);"currency"===t&&o.indexOf(":")<0?r.currency||(r.currency=o.trim()):"relativetime"===t&&o.indexOf(":")<0?r.range||(r.range=o.trim()):o.split(";").forEach((e=>{if(e){const[t,...n]=e.split(":"),o=n.join(":").trim().replace(/^'+|'+$/g,""),i=t.trim();r[i]||(r[i]=o),"false"===o&&(r[i]=!1),"true"===o&&(r[i]=!0),isNaN(o)||(r[i]=parseInt(o,10))}}))}return{formatName:t,formatOptions:r}})(t);if(this.formats[o]){let t=e;try{const a=n&&n.formatParams&&n.formatParams[n.interpolationkey]||{},l=a.locale||a.lng||n.locale||n.lng||r;t=this.formats[o](e,l,{...i,...n,...a})}catch(e){this.logger.warn(e)}return t}return this.logger.warn(`there was no format function for ${o}`),e}),e)}}class uf extends Ap{constructor(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};super(),this.backend=e,this.store=t,this.services=r,this.languageUtils=r.languageUtils,this.options=n,this.logger=Ip.create("backendConnector"),this.waitingReads=[],this.maxParallelReads=n.maxParallelReads||10,this.readingCalls=0,this.maxRetries=n.maxRetries>=0?n.maxRetries:5,this.retryTimeout=n.retryTimeout>=1?n.retryTimeout:350,this.state={},this.queue=[],this.backend&&this.backend.init&&this.backend.init(r,n.backend,n)}queueLoad(e,t,r,n){const o={},i={},a={},l={};return e.forEach((e=>{let n=!0;t.forEach((t=>{const a=`${e}|${t}`;!r.reload&&this.store.hasResourceBundle(e,t)?this.state[a]=2:this.state[a]<0||(1===this.state[a]?void 0===i[a]&&(i[a]=!0):(this.state[a]=1,n=!1,void 0===i[a]&&(i[a]=!0),void 0===o[a]&&(o[a]=!0),void 0===l[t]&&(l[t]=!0)))})),n||(a[e]=!0)})),(Object.keys(o).length||Object.keys(i).length)&&this.queue.push({pending:i,pendingCount:Object.keys(i).length,loaded:{},errors:[],callback:n}),{toLoad:Object.keys(o),pending:Object.keys(i),toLoadLanguages:Object.keys(a),toLoadNamespaces:Object.keys(l)}}loaded(e,t,r){const n=e.split("|"),o=n[0],i=n[1];t&&this.emit("failedLoading",o,i,t),!t&&r&&this.store.addResourceBundle(o,i,r,void 0,void 0,{skipCopy:!0}),this.state[e]=t?-1:2,t&&r&&(this.state[e]=0);const a={};this.queue.forEach((r=>{((e,t,r,n)=>{const{obj:o,k:i}=Pp(e,t,Object);o[i]=o[i]||[],o[i].push(r)})(r.loaded,[o],i),((e,t)=>{void 0!==e.pending[t]&&(delete e.pending[t],e.pendingCount--)})(r,e),t&&r.errors.push(t),0!==r.pendingCount||r.done||(Object.keys(r.loaded).forEach((e=>{a[e]||(a[e]={});const t=r.loaded[e];t.length&&t.forEach((t=>{void 0===a[e][t]&&(a[e][t]=!0)}))})),r.done=!0,r.errors.length?r.callback(r.errors):r.callback())})),this.emit("loaded",a),this.queue=this.queue.filter((e=>!e.done))}read(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.retryTimeout,i=arguments.length>5?arguments[5]:void 0;if(!e.length)return i(null,{});if(this.readingCalls>=this.maxParallelReads)return void this.waitingReads.push({lng:e,ns:t,fcName:r,tried:n,wait:o,callback:i});this.readingCalls++;const a=(a,l)=>{if(this.readingCalls--,this.waitingReads.length>0){const e=this.waitingReads.shift();this.read(e.lng,e.ns,e.fcName,e.tried,e.wait,e.callback)}a&&l&&n<this.maxRetries?setTimeout((()=>{this.read.call(this,e,t,r,n+1,2*o,i)}),o):i(a,l)},l=this.backend[r].bind(this.backend);if(2!==l.length)return l(e,t,a);try{const r=l(e,t);r&&"function"==typeof r.then?r.then((e=>a(null,e))).catch(a):a(null,r)}catch(e){a(e)}}prepareLoading(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=arguments.length>3?arguments[3]:void 0;if(!this.backend)return this.logger.warn("No backend was added via i18next.use. Will not load resources."),n&&n();"string"==typeof e&&(e=this.languageUtils.toResolveHierarchy(e)),"string"==typeof t&&(t=[t]);const o=this.queueLoad(e,t,r,n);if(!o.toLoad.length)return o.pending.length||n(),null;o.toLoad.forEach((e=>{this.loadOne(e)}))}load(e,t,r){this.prepareLoading(e,t,{},r)}reload(e,t,r){this.prepareLoading(e,t,{reload:!0},r)}loadOne(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";const r=e.split("|"),n=r[0],o=r[1];this.read(n,o,"read",void 0,void 0,((r,i)=>{r&&this.logger.warn(`${t}loading namespace ${o} for language ${n} failed`,r),!r&&i&&this.logger.log(`${t}loaded namespace ${o} for language ${n}`,i),this.loaded(e,r,i)}))}saveMissing(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:()=>{};if(this.services.utils&&this.services.utils.hasLoadedNamespace&&!this.services.utils.hasLoadedNamespace(t))this.logger.warn(`did not save key "${r}" as the namespace "${t}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!");else if(null!=r&&""!==r){if(this.backend&&this.backend.create){const l={...i,isUpdate:o},s=this.backend.create.bind(this.backend);if(s.length<6)try{let o;o=5===s.length?s(e,t,r,n,l):s(e,t,r,n),o&&"function"==typeof o.then?o.then((e=>a(null,e))).catch(a):a(null,o)}catch(e){a(e)}else s(e,t,r,n,a,l)}e&&e[0]&&this.store.addResource(e[0],t,r,n)}}}const cf=()=>({debug:!1,initImmediate:!0,ns:["translation"],defaultNS:["translation"],fallbackLng:["dev"],fallbackNS:!1,supportedLngs:!1,nonExplicitSupportedLngs:!1,load:"all",preload:!1,simplifyPluralSuffix:!0,keySeparator:".",nsSeparator:":",pluralSeparator:"_",contextSeparator:"_",partialBundledLanguages:!1,saveMissing:!1,updateMissing:!1,saveMissingTo:"fallback",saveMissingPlurals:!0,missingKeyHandler:!1,missingInterpolationHandler:!1,postProcess:!1,postProcessPassResolved:!1,returnNull:!1,returnEmptyString:!0,returnObjects:!1,joinArrays:!1,returnedObjectHandler:!1,parseMissingKeyHandler:!1,appendNamespaceToMissingKey:!1,appendNamespaceToCIMode:!1,overloadTranslationOptionHandler:e=>{let t={};if("object"==typeof e[1]&&(t=e[1]),"string"==typeof e[1]&&(t.defaultValue=e[1]),"string"==typeof e[2]&&(t.tDescription=e[2]),"object"==typeof e[2]||"object"==typeof e[3]){const r=e[3]||e[2];Object.keys(r).forEach((e=>{t[e]=r[e]}))}return t},interpolation:{escapeValue:!0,format:e=>e,prefix:"{{",suffix:"}}",formatSeparator:",",unescapePrefix:"-",nestingPrefix:"$t(",nestingSuffix:")",nestingOptionsSeparator:",",maxReplaces:1e3,skipOnVariables:!0}}),df=e=>("string"==typeof e.ns&&(e.ns=[e.ns]),"string"==typeof e.fallbackLng&&(e.fallbackLng=[e.fallbackLng]),"string"==typeof e.fallbackNS&&(e.fallbackNS=[e.fallbackNS]),e.supportedLngs&&e.supportedLngs.indexOf("cimode")<0&&(e.supportedLngs=e.supportedLngs.concat(["cimode"])),e),pf=()=>{};class ff extends Ap{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0;var r;if(super(),this.options=df(e),this.services={},this.logger=Ip,this.modules={external:[]},r=this,Object.getOwnPropertyNames(Object.getPrototypeOf(r)).forEach((e=>{"function"==typeof r[e]&&(r[e]=r[e].bind(r))})),t&&!this.isInitialized&&!e.isClone){if(!this.options.initImmediate)return this.init(e,t),this;setTimeout((()=>{this.init(e,t)}),0)}}init(){var e=this;let t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=arguments.length>1?arguments[1]:void 0;this.isInitializing=!0,"function"==typeof t&&(r=t,t={}),!t.defaultNS&&!1!==t.defaultNS&&t.ns&&("string"==typeof t.ns?t.defaultNS=t.ns:t.ns.indexOf("translation")<0&&(t.defaultNS=t.ns[0]));const n=cf();this.options={...n,...this.options,...df(t)},"v1"!==this.options.compatibilityAPI&&(this.options.interpolation={...n.interpolation,...this.options.interpolation}),void 0!==t.keySeparator&&(this.options.userDefinedKeySeparator=t.keySeparator),void 0!==t.nsSeparator&&(this.options.userDefinedNsSeparator=t.nsSeparator);const o=e=>e?"function"==typeof e?new e:e:null;if(!this.options.isClone){let t;this.modules.logger?Ip.init(o(this.modules.logger),this.options):Ip.init(null,this.options),this.modules.formatter?t=this.modules.formatter:"undefined"!=typeof Intl&&(t=sf);const r=new Qp(this.options);this.store=new Wp(this.options.resources,this.options);const i=this.services;i.logger=Ip,i.resourceStore=this.store,i.languageUtils=r,i.pluralResolver=new rf(r,{prepend:this.options.pluralSeparator,compatibilityJSON:this.options.compatibilityJSON,simplifyPluralSuffix:this.options.simplifyPluralSuffix}),!t||this.options.interpolation.format&&this.options.interpolation.format!==n.interpolation.format||(i.formatter=o(t),i.formatter.init(i,this.options),this.options.interpolation.format=i.formatter.format.bind(i.formatter)),i.interpolator=new af(this.options),i.utils={hasLoadedNamespace:this.hasLoadedNamespace.bind(this)},i.backendConnector=new uf(o(this.modules.backend),i.resourceStore,i,this.options),i.backendConnector.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.languageDetector&&(i.languageDetector=o(this.modules.languageDetector),i.languageDetector.init&&i.languageDetector.init(i,this.options.detection,this.options)),this.modules.i18nFormat&&(i.i18nFormat=o(this.modules.i18nFormat),i.i18nFormat.init&&i.i18nFormat.init(this)),this.translator=new $p(this.services,this.options),this.translator.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.external.forEach((e=>{e.init&&e.init(this)}))}if(this.format=this.options.interpolation.format,r||(r=pf),this.options.fallbackLng&&!this.services.languageDetector&&!this.options.lng){const e=this.services.languageUtils.getFallbackCodes(this.options.fallbackLng);e.length>0&&"dev"!==e[0]&&(this.options.lng=e[0])}this.services.languageDetector||this.options.lng||this.logger.warn("init: no languageDetector is used and no lng is defined"),["getResource","hasResourceBundle","getResourceBundle","getDataByLanguage"].forEach((t=>{this[t]=function(){return e.store[t](...arguments)}})),["addResource","addResources","addResourceBundle","removeResourceBundle"].forEach((t=>{this[t]=function(){return e.store[t](...arguments),e}}));const i=Cp(),a=()=>{const e=(e,t)=>{this.isInitializing=!1,this.isInitialized&&!this.initializedStoreOnce&&this.logger.warn("init: i18next is already initialized. You should call init just once!"),this.isInitialized=!0,this.options.isClone||this.logger.log("initialized",this.options),this.emit("initialized",this.options),i.resolve(t),r(e,t)};if(this.languages&&"v1"!==this.options.compatibilityAPI&&!this.isInitialized)return e(null,this.t.bind(this));this.changeLanguage(this.options.lng,e)};return this.options.resources||!this.options.initImmediate?a():setTimeout(a,0),i}loadResources(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:pf;const r="string"==typeof e?e:this.language;if("function"==typeof e&&(t=e),!this.options.resources||this.options.partialBundledLanguages){if(r&&"cimode"===r.toLowerCase()&&(!this.options.preload||0===this.options.preload.length))return t();const e=[],n=t=>{t&&"cimode"!==t&&this.services.languageUtils.toResolveHierarchy(t).forEach((t=>{"cimode"!==t&&e.indexOf(t)<0&&e.push(t)}))};r?n(r):this.services.languageUtils.getFallbackCodes(this.options.fallbackLng).forEach((e=>n(e))),this.options.preload&&this.options.preload.forEach((e=>n(e))),this.services.backendConnector.load(e,this.options.ns,(e=>{e||this.resolvedLanguage||!this.language||this.setResolvedLanguage(this.language),t(e)}))}else t(null)}reloadResources(e,t,r){const n=Cp();return"function"==typeof e&&(r=e,e=void 0),"function"==typeof t&&(r=t,t=void 0),e||(e=this.languages),t||(t=this.options.ns),r||(r=pf),this.services.backendConnector.reload(e,t,(e=>{n.resolve(),r(e)})),n}use(e){if(!e)throw new Error("You are passing an undefined module! Please check the object you are passing to i18next.use()");if(!e.type)throw new Error("You are passing a wrong module! Please check the object you are passing to i18next.use()");return"backend"===e.type&&(this.modules.backend=e),("logger"===e.type||e.log&&e.warn&&e.error)&&(this.modules.logger=e),"languageDetector"===e.type&&(this.modules.languageDetector=e),"i18nFormat"===e.type&&(this.modules.i18nFormat=e),"postProcessor"===e.type&&zp.addPostProcessor(e),"formatter"===e.type&&(this.modules.formatter=e),"3rdParty"===e.type&&this.modules.external.push(e),this}setResolvedLanguage(e){if(e&&this.languages&&!(["cimode","dev"].indexOf(e)>-1))for(let e=0;e<this.languages.length;e++){const t=this.languages[e];if(!(["cimode","dev"].indexOf(t)>-1)&&this.store.hasLanguageSomeTranslations(t)){this.resolvedLanguage=t;break}}}changeLanguage(e,t){var r=this;this.isLanguageChangingTo=e;const n=Cp();this.emit("languageChanging",e);const o=e=>{this.language=e,this.languages=this.services.languageUtils.toResolveHierarchy(e),this.resolvedLanguage=void 0,this.setResolvedLanguage(e)},i=(e,i)=>{i?(o(i),this.translator.changeLanguage(i),this.isLanguageChangingTo=void 0,this.emit("languageChanged",i),this.logger.log("languageChanged",i)):this.isLanguageChangingTo=void 0,n.resolve((function(){return r.t(...arguments)})),t&&t(e,(function(){return r.t(...arguments)}))},a=t=>{e||t||!this.services.languageDetector||(t=[]);const r="string"==typeof t?t:this.services.languageUtils.getBestMatchFromCodes(t);r&&(this.language||o(r),this.translator.language||this.translator.changeLanguage(r),this.services.languageDetector&&this.services.languageDetector.cacheUserLanguage&&this.services.languageDetector.cacheUserLanguage(r)),this.loadResources(r,(e=>{i(e,r)}))};return e||!this.services.languageDetector||this.services.languageDetector.async?!e&&this.services.languageDetector&&this.services.languageDetector.async?0===this.services.languageDetector.detect.length?this.services.languageDetector.detect().then(a):this.services.languageDetector.detect(a):a(e):a(this.services.languageDetector.detect()),n}getFixedT(e,t,r){var n=this;const o=function(e,t){let i;if("object"!=typeof t){for(var a=arguments.length,l=new Array(a>2?a-2:0),s=2;s<a;s++)l[s-2]=arguments[s];i=n.options.overloadTranslationOptionHandler([e,t].concat(l))}else i={...t};i.lng=i.lng||o.lng,i.lngs=i.lngs||o.lngs,i.ns=i.ns||o.ns,""!==i.keyPrefix&&(i.keyPrefix=i.keyPrefix||r||o.keyPrefix);const u=n.options.keySeparator||".";let c;return c=i.keyPrefix&&Array.isArray(e)?e.map((e=>`${i.keyPrefix}${u}${e}`)):i.keyPrefix?`${i.keyPrefix}${u}${e}`:e,n.t(c,i)};return"string"==typeof e?o.lng=e:o.lngs=e,o.ns=t,o.keyPrefix=r,o}t(){return this.translator&&this.translator.translate(...arguments)}exists(){return this.translator&&this.translator.exists(...arguments)}setDefaultNamespace(e){this.options.defaultNS=e}hasLoadedNamespace(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!this.isInitialized)return this.logger.warn("hasLoadedNamespace: i18next was not initialized",this.languages),!1;if(!this.languages||!this.languages.length)return this.logger.warn("hasLoadedNamespace: i18n.languages were undefined or empty",this.languages),!1;const r=t.lng||this.resolvedLanguage||this.languages[0],n=!!this.options&&this.options.fallbackLng,o=this.languages[this.languages.length-1];if("cimode"===r.toLowerCase())return!0;const i=(e,t)=>{const r=this.services.backendConnector.state[`${e}|${t}`];return-1===r||0===r||2===r};if(t.precheck){const e=t.precheck(this,i);if(void 0!==e)return e}return!(!this.hasResourceBundle(r,e)&&this.services.backendConnector.backend&&(!this.options.resources||this.options.partialBundledLanguages)&&(!i(r,e)||n&&!i(o,e)))}loadNamespaces(e,t){const r=Cp();return this.options.ns?("string"==typeof e&&(e=[e]),e.forEach((e=>{this.options.ns.indexOf(e)<0&&this.options.ns.push(e)})),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}loadLanguages(e,t){const r=Cp();"string"==typeof e&&(e=[e]);const n=this.options.preload||[],o=e.filter((e=>n.indexOf(e)<0&&this.services.languageUtils.isSupportedCode(e)));return o.length?(this.options.preload=n.concat(o),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}dir(e){if(e||(e=this.resolvedLanguage||(this.languages&&this.languages.length>0?this.languages[0]:this.language)),!e)return"rtl";const t=this.services&&this.services.languageUtils||new Qp(cf());return["ar","shu","sqr","ssh","xaa","yhd","yud","aao","abh","abv","acm","acq","acw","acx","acy","adf","ads","aeb","aec","afb","ajp","apc","apd","arb","arq","ars","ary","arz","auz","avl","ayh","ayl","ayn","ayp","bbz","pga","he","iw","ps","pbt","pbu","pst","prp","prd","ug","ur","ydd","yds","yih","ji","yi","hbo","men","xmn","fa","jpr","peo","pes","prs","dv","sam","ckb"].indexOf(t.getLanguagePartFromCode(e))>-1||e.toLowerCase().indexOf("-arab")>1?"rtl":"ltr"}static createInstance(){return new ff(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},arguments.length>1?arguments[1]:void 0)}cloneInstance(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:pf;const r=e.forkResourceStore;r&&delete e.forkResourceStore;const n={...this.options,...e,isClone:!0},o=new ff(n);return void 0===e.debug&&void 0===e.prefix||(o.logger=o.logger.clone(e)),["store","services","language"].forEach((e=>{o[e]=this[e]})),o.services={...this.services},o.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},r&&(o.store=new Wp(this.store.data,n),o.services.resourceStore=o.store),o.translator=new $p(o.services,n),o.translator.on("*",(function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];o.emit(e,...r)})),o.init(n,t),o.translator.options=n,o.translator.backendConnector.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},o}toJSON(){return{options:this.options,store:this.store,language:this.language,languages:this.languages,resolvedLanguage:this.resolvedLanguage}}}const vf=ff.createInstance();vf.createInstance=ff.createInstance,vf.createInstance,vf.dir,vf.init,vf.loadResources,vf.reloadResources,vf.use,vf.changeLanguage,vf.getFixedT,vf.t,vf.exists,vf.setDefaultNamespace,vf.hasLoadedNamespace,vf.loadNamespaces,vf.loadLanguages;var hf,gf=(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(hf={},Kd,"Empty group"),Wd,"No conditions for group field {{field}}"),zd,"Empty query"),Hd,"Empty case"),$d,"No config for field {{field}}"),"FIXED_OPERATOR","Fixed operator {{from}} to {{to}} for field {{field}}"),Yd,"No config for operator {{operator}}"),Qd,"No config for function {{funcKey}}"),Xd,"Invalid value"),Jd,"Invalid value of arg {{argName}} for func {{funcName}}: {{argValidationError}}"),Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(hf,Zd,"Type of field {{field}} is not supported"),ep,"Operator {{operator}} is not supported for field {{field}}"),rp,"Incomplete rule"),np,"Incomplete LHS"),op,"Incomplete RHS"),tp,"Invalid value src {{valueSrcs, list}}"),ip+"_one","Value {{badValues, list}} is not in the list of allowed values"),ip+"_other","Values {{badValues, list}} are not in the list of allowed values"),ap,"Value {{value}} is not in the list of allowed values"),lp,"Value should have type {{wType}}, but got value of type {{valueType}}"),Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(hf,sp,"Value should have JS type {{jsType}}, but got value of type {{valueTypeof}}"),up,"Value {{value}} should have max length {{fieldSettings.maxLength}} but got {{length}}"),cp,"Value {{value}} should be greater than or equal to {{fieldSettings.min}}"),cp+"_"+_p,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),dp,"Value {{value}} should be less than or equal to {{fieldSettings.max}}"),dp+"_"+_p,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),pp,"No config for field {{field}}"),fp,"Can't compare field {{field}} with itself"),vp,"Can't compare field {{leftField}} with {{rightField}}"),hp,"Field {{field}} is of type {{type}}, but expected {{expected}}"),Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(Hn(hf,gp,"Unsupported function {{funcKey}} for field {{field}}"),yp,"Value of arg {{argName}} for func {{funcName}} is required"),mp,"Function {{funcKey}} should return value of type {{returnType}}, but got {{valueType}}"),bp,"Invalid range"),Op,"Root"),Ep+"__rule","Leaf #{{globalLeafNo}}"),Ep+"__group","Group #{{globalGroupNo}}"),Ep+"__rule_group","Rule-group #{{globalNoByType}}"),Ep+"__case_group","Case #{{globalNoByType}}"),Ep+"__rule__deleted","Deleted leaf #{{globalLeafNo}}"),Hn(Hn(Hn(Hn(Hn(hf,Ep+"__group__deleted","Deleted group #{{globalGroupNo}}"),Ep+"__rule_group__deleted","Deleted rule-group #{{globalNoByType}}"),Ep+"__case_group__deleted","Deleted case #{{globalNoByType}}"),Tp,"{{str}} in case #{{caseNo}}"),Sp,"{{str}} (index path: {{indexPath, list}})")),yf="raqbvalidation",mf="".concat(yf,":"),bf=vf.createInstance();bf.init({fallbackLng:"en"}),bf.addResources("en",yf,gf);var Ef=function e(t,r){return null!=t&&t.str?t.str:null!=t&&t.key?e(t.key,t.args):null===r?t:bf.t(t.includes(":")?t:mf+t,r)};const Of=bf;function Sf(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Tf(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Sf(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Sf(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var _f=function(e){return"object"===Vn(e)&&null!==e&&Array.isArray(e)?"array":Vn(e)},wf=function(e,t){return 0===Rf(e,t).length},Rf=function(e,t){var r=t.settings.showErrorMessage,n=[];return e&&function e(t,o,i){var a,l,s=t.get("id"),u=t.get("children1"),c=t.getIn(["properties","valueError"]),d=t.getIn(["properties","fieldError"]),p=t.getIn(["properties","field"]),f=null!==(a=null==p||null===(l=p.get)||void 0===l?void 0:l.call(p,"func"))&&void 0!==a?a:p;((null==c?void 0:c.size)>0&&c.filter((function(e){return null!=e})).size>0||!!d)&&r&&n.push(f),u&&u.map((function(t,r){t&&e(t,o.concat(s),i+1)}))}(e,[],0),Array.from(new Set(n))},If=function(e,t){var r=yh(t,void 0,!0),n={removeEmptyGroups:t.settings.removeEmptyGroupsOnLoad,removeIncompleteRules:t.settings.removeIncompleteRulesOnLoad,removeEmptyRules:t.settings.removeEmptyRulesOnLoad,forceFix:!1},o=Lf(e,null,r,r,n),i=o.fixedTree,a=o.allErrors;return o.isSanitized&&a.length&&console.warn("Tree check errors: ",a),i},Af=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=yh(t,void 0,!0),o=Tf(Tf({},r),{},{removeEmptyGroups:!1,removeEmptyRules:!1,removeIncompleteRules:!1,forceFix:!1});return Lf(e,null,n,n,o).allErrors},Cf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=yh(t,void 0,!0),o=Tf({removeEmptyGroups:!0,removeEmptyRules:!0,removeIncompleteRules:!0,forceFix:!1},r),i=Lf(e,null,n,n,o);return{fixedTree:i.fixedTree,fixedErrors:i.fixedErrors,nonFixedErrors:i.nonFixedErrors,allErrors:i.allErrors}},Nf=function(e,t,r,n,o,i,a){void 0===o&&(o=r.settings.removeEmptyGroupsOnLoad),void 0===i&&(i=r.settings.removeEmptyRulesOnLoad),void 0===a&&(a=r.settings.removeIncompleteRulesOnLoad);var l=Lf(e,t,r,n,{removeEmptyGroups:o,removeEmptyRules:i,removeIncompleteRules:a,forceFix:!1}),s=l.fixedTree,u=(l.allErrors,l.fixedErrors);return l.nonFixedErrors,l.isSanitized&&u.length&&console.warn("Fixed tree errors: ",u),Eu(s)},Lf=function(e,t,r,n,o){if(!e)return{fixedTree:e,allErrors:[],fixedErrors:[],nonFixedErrors:[],isSanitized:!1};var i,a,l=o||{},s=l.removeEmptyGroups,u=l.removeEmptyRules,c=l.removeIncompleteRules,d=l.forceFix,p=l.translateErrors,f=void 0===p||p,v=l.includeStringifiedItems,h=void 0===v||v,g=l.stringifyFixedItems,y=void 0!==g&&g,m=l.stringifyItemsUserFriendly,b=void 0===m||m,E=l.includeItemsPositions,O=void 0===E||E,S={errors:{}},T=Pf(e,[],null,S,{config:r,oldConfig:n,removeEmptyGroups:s,removeEmptyRules:u,removeIncompleteRules:c,forceFix:d}),_=S.sanitized,w=[];for(var R in O&&(i=Su(T).items),S.errors){var I=S.errors[R],A=I.path,C=I.errors;f&&(C=C.map((function(e){return Tf(Tf({},e),{},{str:Ef(e)})})));var N={path:A,errors:C};if(h){var L=mu(y?T:e,A);if(1!==A.length&&"group"!==L.get("type")){var j=kd(L,r,b,!0);N.itemStr=j}}if(O){var x=i[R],P=!x;if(P&&(a||(a=Su(e).items),x=a[R]),x){var F=Tf(Tf({},x.position),{},{index:x.index,type:x.type,isDeleted:P});N.itemPosition=F;var D=x.index?Ep+"__"+x.type+(P?"__deleted":""):Op,k=Tf({},F);if(b){for(var M,V=0,U=["caseNo","globalLeafNo","globalGroupNo","globalNoByType"];V<U.length;V++){var B=U[V];null!=k[B]&&(k[B]=k[B]+1)}k.indexPath=null===(M=F.indexPath)||void 0===M?void 0:M.map((function(e){return e+1}))}N.itemPositionStr=Ef(D,k),x.index&&(x.caseId&&"case_group"!==x.type&&(N.itemPositionStr=Ef(Tp,Tf(Tf({},k),{},{str:N.itemPositionStr}))),"case_group"!==x.type&&(N.itemPositionStr=Ef(Sp,Tf(Tf({},k),{},{str:N.itemPositionStr}))))}}w.push(N)}for(var G=[],q=[],K=0,W=w;K<W.length;K++){var z=W[K],H=z.errors.filter((function(e){return!!e.fixed})),$=z.errors.filter((function(e){return!e.fixed&&"EMPTY_QUERY"!==e.key}));H.length&&G.push(Tf(Tf({},z),{},{errors:H})),$.length&&q.push(Tf(Tf({},z),{},{errors:$}))}return{fixedTree:T,allErrors:w,fixedErrors:G,nonFixedErrors:q,isSanitized:_}};function jf(e,t,r,n){var o=t.get("id");e.errors[o]||(e.errors[o]={path:[].concat(eo(r),[o]),errors:[]}),e.errors[o].errors.push(n)}function xf(e,t){var r=t.get("id");e.errors[r]&&e.errors[r].errors.map((function(e){e.fixed=!0}))}function Pf(e,t,r,n,o){var i=null==e?void 0:e.get("type");return"group"===i||"rule_group"===i||"case_group"==i||"switch_group"==i?function(e,t,r,n,o){var i,a,l,s,u,c,d=o.removeEmptyGroups,p=o.removeIncompleteRules,f=(o.forceFix,o.config),v=(f.settings.showErrorMessage,e.get("id")),h=e.get("children1"),g=!t.length,y=h,m=e.get("type"),b=e.get("properties"),E=null==b?void 0:b.get("field"),O=null==b?void 0:b.get("mode"),S=null==b||null===(i=b.get)||void 0===i?void 0:i.call(b,"operator"),T="rule_group"===m&&"array"===O,_="case_group"===m,w=_&&null==h,R=S?null!==(a=null===(l=f.operators[S])||void 0===l?void 0:l.cardinality)&&void 0!==a?a:1:void 0,I=_?!w:T?0==R:d,A=T||_;!v&&r&&(v=r,e=e.set("id",v),n.sanitized=!0),A&&(e=Ff(e,t,r,n,o));var C={errors:{}},N=null===(u=h=null===(s=h)||void 0===s?void 0:s.map((function(e,r){return Pf(e,t.concat(v),r,C,o)})))||void 0===u?void 0:u.filter((function(e){return null!=e}));d&&(h=N);var L=C.sanitized||(null==y?void 0:y.size)!=(null===(c=h)||void 0===c?void 0:c.size),j=d&&!g;return T&&E&&(j=p),!(null!=N&&N.size)&&I&&(jf(n,e,t,{key:g?zd:_?Hd:T?Wd:Kd,args:{field:E},fixed:j}),j&&(xf(n,e),e=void 0)),L&&(n.sanitized=!0),L&&e&&(e=e.set("children1",h)),n.errors=Tf(Tf({},n.errors),(null==C?void 0:C.errors)||{}),e}(e,t,r,n,o):"rule"===i?Ff(e,t,r,n,o):e}function Ff(e,t,r,n,o){var i=o.removeIncompleteRules,a=o.removeEmptyRules,l=o.forceFix,s=o.config,u=o.oldConfig,c=s.settings.showErrorMessage,d=!c||l,p=e.get("id"),f="case_group"===e.get("type"),v=e.get("properties");if(!v){if(!f)return void jf(n,e,t,{key:rp,args:{},fixed:i||a});v=new Es.Map}var h=v.get("field")||null;f&&(h="!case_value");var g=v.get("fieldSrc")||null,y=v.get("operator")||null,m=v.get("operatorOptions"),b=v.get("valueSrc"),E=v.get("value"),O=v.get("valueError"),S=v.get("fieldError"),T=function(){var e,t;return{field:(null===(e=h)||void 0===e||null===(t=e.toJS)||void 0===t?void 0:t.call(e))||h,fieldSrc:g,operator:y,operatorOptions:m?m.toJS():{},valueSrc:b?b.toJS():null,value:E?E.toJS():null,valueError:O?O.toJS():null,fieldError:S||null}},_=T();!p&&r&&(p=r,e=e.set("id",p),n.sanitized=!0);var w=h?qh(s,h):null;h&&!w&&(jf(n,e,t,{key:$d,args:{field:h},side:"lhs",fixed:i||a}),h=null),null!=h||f||(v=["operator","operatorOptions","valueSrc","value","valueError","fieldError","field"].reduce((function(e,t){return e.delete(t)}),v),y=null),g||!h||f||(g=Gh(h),v=v.set("fieldSrc",g)),"range_between"!==y&&"range_not_between"!==y||(y="range_between"===y?"between":"not_between",v=v.set("operator",y));var R=y?Kh(s,y,h):null;y&&!R&&(jf(n,e,t,{key:Yd,args:{operator:y},side:"op",fixed:i||a}),y=null);var I=h?Zf(s,h):[];h&&!f&&(null!=I&&I.length?y&&-1==I.indexOf(y)&&("is_empty"===y||"is_not_empty"===y?(y="is_empty"===y?"is_null":"is_not_null",v=v.set("operator",y)):(jf(n,e,t,{key:ep,args:{operator:y,field:h},side:"lhs",fixed:i||a}),y=null)):(jf(n,e,t,{key:Zd,args:{field:h},side:"lhs",fixed:i||a}),y=null)),null!=y||f||(v=["operatorOptions","valueSrc","value","valueError"].reduce((function(e,t){return e.delete(t)}),v)),m=v.get("operatorOptions"),!y||m&&!R.options?(m=null,v=v.delete("operatorOptions")):y&&!m&&R.options&&(m=Sd(s,y,h),v=v.set("operatorOptions",m)),b=v.get("valueSrc"),E=v.get("value");var A=Bf(s,u,v,h,y,null,d,!0),C=A.newValue,N=A.newValueSrc,L=A.newValueError,j=A.validationErrors,x=A.newFieldError,P=A.fixedField;E=C,b=N,O=L,S=x,h=P,v=(v=(v=v.set("field",h)).set("value",E)).set("valueSrc",b),v=c?v.set("valueError",O).set("fieldError",S):v.delete("valueError").delete("fieldError");var F=T(),D=!Ns(_,F),k=bv(v.toObject(),s),M=f?k.parts.value:k.score>=3;if(D&&(n.sanitized=!0,e=e.set("properties",v)),null==j||j.map((function(r){return jf(n,e,t,r)})),!M)if(f);else{var V=k.score?i:a,U={key:rp,args:{}};if(k.parts.field){if(!k.parts.value){var B,G,q,K;U.key=op,U.side="rhs",null!==(B=F.valueSrc)&&void 0!==B&&B[0]&&(null===(G=F.valueSrc)||void 0===G?void 0:G[0])!=(null===(q=_.valueSrc)||void 0===q?void 0:q[0])&&null!=(null===(K=F.value)||void 0===K?void 0:K[0])&&(U.key=tp,U.args={valueSrcs:F.valueSrc})}}else U.key=np,U.side="lhs";U.fixed=V,jf(n,e,t,U),V&&(xf(n,e),e=void 0)}return e}var Df=function(e,t,r,n,o,i,a,l){var s=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=arguments.length>9&&void 0!==arguments[9]&&arguments[9],c=arguments.length>10&&void 0!==arguments[10]&&arguments[10],d=[],p=o;if(null!=o){var f,v,h,g;if("field"===a){var y=Jn(Mf(t,r,o,a,i,l,e,n,s,u),2);p=y[0],d=y[1]}else if("func"===a){var m=Jn(Vf(t,r,o,a,i,l,e,n,s,u,c),2);p=m[0],d=m[1]}else if("value"===a||!a){var b=Jn(kf(r,o,a,i,l,e,n,s,u),2);p=b[0],d=b[1]}var E=!(null!==(f=d)&&void 0!==f&&f.find((function(e){return!e.fixed})));if(r&&!["field","func"].includes(a)&&(null===(v=d)||void 0===v||!v.length||E)){var O=cv(e,r,n,a),S=n?Kh(e,n,r):null,T=Wh(e,r,n,O,a,{forExport:!0}),_="field"===a?qh(e,o):null,w=T,R=T.validateValue;if("function"==typeof R){var I=[p,w,n,S];"field"===a&&I.push(_);var A,C,N=R.call.apply(R,[e.ctx].concat(I));"object"!==Vn(N)||null===N||Array.isArray(N)?"boolean"==typeof N?0==N&&d.push({key:Xd,args:{}}):"string"==typeof N&&d.push({key:N,args:null}):(C=null!==(A=N.error)&&void 0!==A&&A.key?Tf({},N.error):{key:N.error,args:null},void 0!==N.fixedValue&&s&&(C.fixed=!0,C.fixedFrom=p,C.fixedTo=N.fixedValue,p=N.fixedValue),d.push(C))}}if(E=!(null!==(h=d)&&void 0!==h&&h.find((function(e){return!e.fixed}))),null!==(g=d)&&void 0!==g&&g.length&&!E&&s){var L=qh(e,r),j=null==L?void 0:L.fieldSettings,x=null==j?void 0:j.defaultValue;if(void 0!==x){var P=d[d.length-1];P.fixed=!0,P.fixedFrom=p,P.fixedTo=x,p=x,d.map((function(e){e.fixed=!0}))}}}return[p,d]},kf=function(e,t,r,n,o,i){var a,l,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7],c=[],d=t;if(e){var p=qh(i,e),f=cv(i,e,s,r),v=i.widgets[f],h=null==v?void 0:v.type,g=null==v?void 0:v.jsType,y=null==p?void 0:p.fieldSettings,m=(null==y?void 0:y.treeValues)||(null==y?void 0:y.listValues),b=!(null==y||!y.asyncFetch),E=m||b;if(n&&h&&n!=h)return c.push({key:lp,args:{wType:h,valueType:n}}),[t,c];if(g&&(l=g,_f(a=t)!==l&&("number"!==l||isNaN(a)))&&!E)return c.push({key:sp,args:{jsType:g,valueTypeof:_f(t)}}),[t,c];if(y){var O=o||m;if(O&&!y.allowCustomValues&&"case_value"!==f){var S=function(e,t,r,n,o){var i=Es.List.isList(e)?e.toJS():e instanceof Array?eo(e):void 0,a=e,l=[];if(i){var s=i.reduce((function(e,r){var n=Jn(e,2),o=n[0],i=n[1],a=cu(t,r);return null==a?[o,[].concat(eo(i),[r])]:[[].concat(eo(o),[a.value]),i]}),[[],[]]),u=Jn(s,2),c=u[0],d=u[1],p=d.length>0;if(a=(r=r||!0===o)&&p?c:e,d.length){var f=r&&p;l.push({key:ip,args:{badValues:d,count:d.length},fixed:f,fixedFrom:f?i:void 0,fixedTo:f?a:void 0})}return[a,l]}var v=cu(t,e);return null==v?(a=r?null:e,l.push({key:ap,args:{value:e},fixed:r,fixedFrom:r?e:void 0,fixedTo:r?a:void 0})):a=v.value,[a,l]}(t,O,u,0,i.settings.removeInvalidMultiSelectValuesOnLoad),T=Jn(S,2);d=T[0],c=T[1]}y.maxLength>0&&null!=t&&String(t).length>y.maxLength&&(d=u?String(t).substring(0,y.maxLength):t,c.push({key:up,args:{value:t,length:String(t).length,fieldSettings:y},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}));var _=null!=y.min&&null!=y.max?_p:void 0;null!=y.min&&t<y.min&&(d=u?y.min:t,c.push({key:cp,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0})),null!=y.max&&t>y.max&&(d=u?y.max:t,c.push({key:dp,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}))}}return[d,c]},Mf=function(e,t,r,n,o,i,a){var l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,s=[],u=a.settings,c=u.fieldSeparator,d=u.canCompareFieldWithField,p="object"==Vn(t)&&(null==t?void 0:t._isFuncArg),f=Array.isArray(e)?e.join(c):e,v=qh(a,e),h=Array.isArray(r)?r.join(c):r,g=qh(a,r);return g?e&&h===f&&!p?(s.push({key:fp,args:{field:f}}),[r,s]):o&&o!=g.type?(s.push({key:hp,args:{field:h,type:g.type,expected:o}}),[r,s]):e&&!p&&d&&!d(f,v,h,g,l)?(s.push({key:vp,args:{leftField:f,rightField:h}}),[r,s]):[r]:(s.push({key:pp,args:{field:h}}),[r,s])},Vf=function(e,t,r,n,o,i,a){var l,s,u=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],d=arguments.length>9&&void 0!==arguments[9]&&arguments[9],p=arguments.length>10&&void 0!==arguments[10]&&arguments[10],f=r,v=[];if(!r)return[r];var h=null===(l=r.get)||void 0===l?void 0:l.call(r,"func");if(!h)return[r];var g=qh(a,t);if(null!=g&&g.funcs&&!g.funcs.includes(h))return v.push({key:gp,args:{funcKey:h,field:t}}),[r,v];var y=xh(a,h);if(!y)return v.push({key:Qd,args:{funcKey:h}}),[r,v];var m=null!==(s=y.label)&&void 0!==s?s:h;if(o&&y.returnType!=o)return v.push({key:mp,args:{funcKey:h,funcName:m,returnType:y.returnType,valueType:o}}),[r,v];for(var b in c=c||p,y.args){var E,O=y.args[b],S=f.get("args"),T=S?S.get(b):void 0,_=qh(a,O),w=null!==(E=null==_?void 0:_.label)&&void 0!==E?E:b,R=T?T.get("value"):void 0,I=T?T.get("valueSrc"):void 0;if(void 0!==R){var A=Jn(Df(a,e,_,u,R,O.type,I,i,c,d,p),2),C=A[0],N=A[1],L=!(null!=N&&N.length),j=c&&C!==R,x=c&&!L&&!j&&(d||p);if(j&&(f=f.setIn(["args",b,"value"],C)),x&&(f=f.deleteIn(["args",b]),f=zf(a,f,y,b)),!L){var P,F,D=null!==(P=null!==(F=N.find((function(e){return!e.fixed&&!e.ignore})))&&void 0!==F?F:N.find((function(e){return!e.fixed})))&&void 0!==P?P:N[0],k=j||x,M=0===N.filter((function(e){return!e.ignore})).length;if(D){var V=Ef(D);v.push({key:Jd,args:{funcKey:h,funcName:m,argKey:b,argName:w,argValidationError:V,argErrors:N},ignore:M,fixed:k,fixedFrom:k?R:void 0,fixedTo:k?j?C:O.defaultValue:void 0})}}}else if(!O.isOptional&&(d||p)){var U=c&&void 0!==O.defaultValue&&(d||p);d&&v.push({key:yp,args:{funcKey:h,funcName:m,argKey:b,argName:w},fixed:U,fixedTo:U?O.defaultValue:void 0,ignore:!U}),U&&(f=f.deleteIn(["args",b]),f=zf(a,f,y,b))}}return[f,v]},Uf=function(e,t,r,n,o){var i,a=Kh(e,r,t),l=r?Cs(a):null,s=o.toJS?o.toJS():o,u=n.toJS?n.toJS():n,c=s.filter((function(e){return"value"==e||null==e})).length==l;if(null!=a&&a.validateValues&&c){var d=s[0],p=cv(e,t,r,d),f=Wh(e,t,r,p,d),v=null!=f&&f.toJS?u.map((function(t){var r=f.toJS.call(e.ctx,t,f);return r instanceof Date&&(r=r.getTime()),r})):u,h=a.validateValues(v);"boolean"==typeof h&&0==h&&(i={key:bp,args:{jsValues:v,values:u}})}return i},Bf=function(e){var t,r,n,o,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,a=arguments.length>2?arguments[2]:void 0,l=arguments.length>3?arguments[3]:void 0,s=arguments.length>4?arguments[4]:void 0,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]&&arguments[6],d=arguments.length>7&&void 0!==arguments[7]&&arguments[7],p=arguments.length>8&&void 0!==arguments[8]&&arguments[8];i||(i=e);var f=e.settings,v=f.keepInputOnChangeFieldSrc,h=f.convertableWidgets,g=f.clearValueOnChangeField,y=f.clearValueOnChangeOp,m="!case_value"==l,b=a.get("field");!b&&m&&(b=l);var E,O=a.get("fieldType"),S=a.get("fieldSrc"),T=a.get("operator"),_=a.get("value"),w=a.get("valueSrc",new Es.List),R=a.get("valueType",new Es.List),I=a.get("valueError",new Es.List),A=a.get("asyncListValues"),C=m,N=Kh(i,T),L=Kh(e,s,l),j=m?1:T?Cs(N):null,x=m?1:s?Cs(L):null,P=qh(i,b),F=qh(e,l),D=!b&&O&&v,k=(null==P?void 0:P.type)||O,M=(null==F?void 0:F.type)||!l&&D&&k,V=null==P?void 0:P.listValuesType,U=null==F?void 0:F.listValuesType,B=(null===(t=b)||void 0===t||null===(r=t.get)||void 0===r?void 0:r.call(t,"func"))||b,G=((null===(n=l)||void 0===n||null===(o=n.get)||void 0===o?void 0:o.call(n,"func"))||l)!=B,q=[],K=(b||D)&&(T&&s||C)&&null!=_;if((!k||!M||k!=M||"field"===u&&G&&g||"operator"===u&&y)&&(K=!1),G&&Xf.includes(M)&&(U&&U===V||(K=!1)),C||(null!=_&&_.size||!x)&&(null==_||!_.size||x)||(K=!1),"func"===S&&l){var W=Jn(Df(e,null,null,s,l,M,S,A,c,d,p),2),z=W[0],H=W[1],$=!(null!=H&&H.length),Y=z!==l,Q=!$&&Y&&!H.find((function(e){return!e.fixed})),X=c&&!$&&!Q&&!!u&&l!==b;if(X?l=b:Y&&(l=z),!$){var J=!$&&!Q&&!X,Z=H.find((function(e){return!e.fixed&&!e.ignore}));J&&Z&&(E=Ef(Z)),H.map((function(e){return q.push(Tf(Tf({side:"lhs"},e),{},{fixed:e.fixed||X||false}))}))}}for(var ee=0;ee<x;ee++){var te=w.get(ee)||null,re=cv(i,b,T,te),ne=cv(e,l,s,te),oe="value"===te?re:cv(i,b,T,"value"),ie="value"===te?ne:cv(e,l,s,"value");ie==oe||(h[oe]||[]).includes(ie)||!oe&&D||(K=!1)}T!=s&&[T,s].includes("proximity")&&(K=!1);var ae=w.first(),le=Wh(e,l,s,null,ae),se=uv(e,l,s,null);!l&&D&&(se=Object.keys(e.settings.valueSourcesInfo));var ue,ce=se[0];1===x&&le&&void 0!==le.type?ue=le.type:1===x&&F&&void 0!==F.type&&(ue="!group"===F.type?"number":F.type);var de=K&&"operator"===u&&1===j&&2===x,pe=[],fe=[],ve=[],he=Array.from({length:x},(function(){return null}));if(K)for(var ge=function(t){var r=_.get(t),n=R.get(t)||null,o=w.get(t)||null;de&&1===t&&(r=void 0!==pe[0]?pe[0]:_.get(0),pe[t]=r,n=R.get(0)||null,o=w.get(0)||null);var i=!o||void 0!==se.find((function(e){return e==o})),a=Jn(Df(e,l,l,s,r,n,o,A,c,d,p),2),u=a[0],f=a[1],v=!(null!=f&&f.length),h=u!==r,g=!v&&h&&!(null!=f&&f.find((function(e){return!e.fixed}))),y=!(null!=f&&f.find((function(e){return!e.fixed&&!e.ignore}))),m=!i||c&&!v&&!g&&(!y||G);v||null==f||f.map((function(e){return q.push(Tf(Tf({side:"rhs",delta:t},e),{},{fixed:e.fixed||m}))})),m&&(pe[t]=null,0===t&&delete pe[1]);var b=!v&&!h,E=null==f?void 0:f.find((function(e){return!e.fixed&&!e.ignore}));b&&E&&(he[t]=Ef(E)),h&&(pe[t]=u),!de||0!==t||v||h||(de=!1),de&&0===t&&["func","field"].includes(o)&&(de=!1)},ye=0;ye<x;ye++)ge(ye);if(!K)for(var me=0;me<x;me++)if(1===x){var be,Ee=Hs([null==F?void 0:F.defaultValue,null==F||null===(be=F.fieldSettings)||void 0===be?void 0:be.defaultValue,null==le?void 0:le.defaultValue]);pe[me]=Ee,null!=Ee&&Ee.func&&(fe[me]="func")}for(var Oe=0;Oe<x;Oe++){var Se,Te,_e=K&&w.get(Oe)||null,we=K&&R.get(Oe)||null;K&&de&&1===Oe&&(_e=null!==(Se=fe[Oe])&&void 0!==Se?Se:w.get(0),we=null!==(Te=ve[Oe])&&void 0!==Te?Te:R.get(0),fe[Oe]=_e,ve[Oe]=we),se.includes(_e)||(fe[Oe]=ce),we||(ve[Oe]=ue)}var Re=_;(pe.length>0||!K)&&(Re=new Es.List(Array.from({length:x},(function(e,t){return void 0!==pe[t]?pe[t]:K?_.get(t):void 0}))));var Ie=w;(fe.length>0||!K)&&(Ie=new Es.List(Array.from({length:x},(function(e,t){var r;return null!==(r=fe[t])&&void 0!==r?r:K&&w.get(t)||null}))));var Ae=R;(ve.length>0||!K)&&(Ae=new Es.List(Array.from({length:x},(function(e,t){var r;return null!==(r=ve[t])&&void 0!==r?r:K&&R.get(t)||null}))));var Ce=Uf(e,l,s,Re,Ie);if(Ce){var Ne=Ef(Ce),Le=c&&x>=2,je=Re;Le&&(pe[1]=Re.get(0),Re=Re.set(1,pe[1]),he[1]=he[0]),!Le&&he.push(Ne),q.push(Tf(Tf({side:"rhs",delta:-1},Ce),{},{fixed:Le,fixedFrom:Le?[je.get(0),je.get(1)]:void 0,fixedTo:Le?[Re.get(0),Re.get(1)]:void 0}))}var xe=I,Pe=(null==I?void 0:I.size)!==he.length||he.filter((function(e,t){return e!=I.get(t)})).length>0;return Pe&&(xe=new Es.List(he)),{canReuseValue:K,newValue:Re,newValueSrc:Ie,newValueType:Ae,operatorCardinality:x,fixedField:l,newValueError:xe,newFieldError:E,validationErrors:q}},Gf=function(e){return"object"==Vn(e)&&null!==e&&!Array.isArray(e)},qf=function(e,t){if(e){var r=e.get("func"),n=r&&xh(t,r);if(n){var o=e,i=!1;for(var a in n.args){var l=n.args[a],s=l.valueSources,u=l.isOptional,c=l.defaultValue,d=sv(t,s,l),p=o.get("args"),f=1==d.length?d[0]:void 0,v=p?p.get(a):void 0,h=v?v.get("value"):void 0,g=(v?v.get("valueSrc"):void 0)||f;if(void 0!==h){var y=Ov(h,g,t);if(void 0===y)return;if(y!==h&&(o=o.setIn(["args",a,"value"],y)),i)return}else if(void 0===c||Gf(c)){if(!u)return;i=!0}else o=(o=o.setIn(["args",a,"value"],Hf(l))).setIn(["args",a,"valueSrc"],"value")}return o}}},Kf=function(e,t,r,n){var o=r.settings.fieldSeparator;e=e||new Es.Map,Array.isArray(t)&&(t=t.join(o));var i=e.get("func"),a=e.get("args");e=e.set("func",t);var l=t&&xh(r,t),s=t&&jh(r,t),u=i&&jh(r,i),c=Qf(u,s,a,r,n);return e=c.length?Object.keys(s.args).filter((function(e){return!c.includes(e)})).reduce((function(e,t){return e.deleteIn(["args",t])}),e):e.set("args",new Es.Map),Wf(r,e,l)},Wf=function(e,t,r){if(r)for(var n in r.args)t=zf(e,t,r,n);return t},zf=function(e,t,r,n){var o=r.args[n],i=o.valueSources,a=o.defaultValue,l=sv(e,i,o),s=l.length?l[0]:void 0,u=(a?Gf(a)&&a.func?"func":"value":void 0)||s;return t.getIn(["args",n])||(void 0!==a&&(t=t.setIn(["args",n,"value"],Hf(o))),u&&(t=t.setIn(["args",n,"valueSrc"],u))),t},Hf=function(e){var t=e.defaultValue;return Gf(t)&&!Es.Map.isMap(t)&&t.func?Es.fromJS(t,(function(e,t){return Es.Iterable.isIndexed(t)?t.toList():t.toOrderedMap()})):t},$f=function(e,t,r,n,o){if(e&&e.get("func")){var i=(e=e.setIn(["args",t,"value"],r)).getIn(["args",t,"valueSrc"]),a=n.valueSources,l=sv(o,a,n),s=1==l.length?l[0]:void 0;!s&&l.includes("value")&&(s="value"),!i&&s&&(e=e.setIn(["args",t,"valueSrc"],s))}return e},Yf=function(e,t,r,n,o){return e&&e.get("func")&&(e=e.setIn(["args",t],new Es.Map({valueSrc:r}))),e},Qf=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];return(null==e?void 0:e.returnType)!=(null==t?void 0:t.returnType)?[]:Object.keys(t.args).filter((function(i,a){var l=t.args[i],s=e.args[i];if(Object.keys(e.args).indexOf(i),!s&&(void 0!==l.defaultValue||l.isOptional))return!0;if((null==s?void 0:s.type)!=l.type)return!1;if(Xf.includes(l.type)&&(!s.listValuesType||s.listValuesType!==l.listValuesType))return!1;if(r){var u,c=r.get(i),d=null==c?void 0:c.get("value"),p=null==c?void 0:c.get("valueSrc");if(p&&l.valueSources&&!l.valueSources.includes(p))return!1;var f=Jn(Df(n,null,l,null,d,l.type,p,null,o,!0),2),v=(f[0],f[1]);if(null!=v&&null!==(u=v.filter((function(e){return!e.fixed})))&&void 0!==u&&u.length)return!1}return!0}))},Xf=["select","multiselect","treeselect","treemultiselect"],Jf=function(e,t){var r;return(null===(r=e.types[t])||void 0===r?void 0:r.operators)||null},Zf=function(e,t){var r=qh(e,t);return r?r.operators:[]},ev=function(e,t){var r,n=Zf(e,t);return null!==(r=null==n?void 0:n[0])&&void 0!==r?r:null},tv=function(e,t,r){var n=null;if(e)if("field"===t){var o=qh(r,e);o&&(n=o.type)}else if("func"===t){var i=e.get("func");if(i){var a=xh(r,i);a&&(n=a.returnType||a.type)}}return n},rv=function(e,t){return nv(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,"funcs","subfields")},nv=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"fields",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"subfields";if(!e)return null;var i=t.settings.fieldSeparator,a=kh(e,t),l=kh(r,t);return a.slice(l.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return[].concat(eo(l),eo(e)).join(i)})).map((function(e){var r=Nh(t,e,n,o);return r&&r.label||eu()(e.split(i))})).filter((function(e){return null!=e}))},ov=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;var n=r&&Nh(t,r)||null,o=t.settings.fieldSeparator,i=kh(e,t),a=Fh(e,r,t)?kh(r,t):[];return i.slice(a.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return{part:[].concat(eo(a),eo(e)).join(o),key:e[e.length-1]}})).map((function(e){var r=e.part;return{key:e.key,cnf:Nh(t,r)}})).map((function(e,t,r){return[e.key,e.cnf,t>0?r[t-1].cnf:n]}))},iv=function(e,t,r,n){var o=arguments.length>5&&void 0!==arguments[5]&&arguments[5],i=Wh(e,t,r,null,arguments.length>4&&void 0!==arguments[4]?arguments[4]:null)||{},a=Kh(e,r,t)||{},l=null;if((o?1:a.cardinality)>1){var s=i.valueLabels||a.valueLabels;s&&(l=s[n]),l&&"object"!==Vn(l)&&(l={label:l,placeholder:l}),l||(l={label:e.settings.valueLabel+" "+(n+1),placeholder:e.settings.valuePlaceholder+" "+(n+1)})}else{var u=i.valueLabel,c=i.valuePlaceholder;l={label:u||e.settings.valueLabel,placeholder:c||e.settings.valuePlaceholder}}return l};function av(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=[],i=[];if(!t)return{widgets:o,valueSrcs:i};var a=Vh(t),l=a?"".concat(a,"__").concat(r,"__").concat(n):null,s=Uh(e,"_getWidgetsAndSrcsForFieldOp",l);if(s)return s;var u="object"===Vn(t)&&(!!t.func&&!!t.arg||t._isFuncArg),c=qh(e,t),d=r?e.operators[r]:null;if(null!=c&&c.widgets){var p=function(){var a=c.widgets[f];if(!e.widgets[f])return 1;var l=e.widgets[f].valueSrc||"value",s=!0;if("field"===f&&(s=s&&sv(e,["field"],c).length>0),"func"===f&&(s=s&&sv(e,["func"],c).length>0),"value"!==n||a.operators||u||"!case_value"===t||(s=!1),a.operators&&r&&(s=s&&-1!=a.operators.indexOf(r)),n&&n!=l&&"const"!==n&&(s=!1),d&&0==d.cardinality&&"value"!==l&&(s=!1),s){var p,v;o.push(f);var h=-1!=(null===(p=c.valueSources)||void 0===p?void 0:p.indexOf(l));-1==(null==d||null===(v=d.valueSources)||void 0===v?void 0:v.indexOf(l))&&(h=!1),h&&!i.find((function(e){return e==l}))&&i.push(l)}};for(var f in c.widgets)p()}var v=function(e){var t=0;return c.preferWidgets?c.preferWidgets.includes(e)&&(t+=10-c.preferWidgets.indexOf(e)):e==c.mainWidget&&(t+=100),"field"===e&&(t-=1),"func"===e&&(t-=2),t};o.sort((function(e,t){return v(t)-v(e)}));var h={widgets:o,valueSrcs:i};return Bh(e,"_getWidgetsAndSrcsForFieldOp",l,h),h}var lv=function(e,t,r){return av(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets},sv=function(e,t,r){var n;if(!r)return t;var o=null!==(n=r.type)&&void 0!==n?n:r.returnType;return"!group"===o&&(o="number"),t||(t=Object.keys(e.settings.valueSourcesInfo)),t.filter((function(t){var n=!0;if("field"===t&&e.__fieldsCntByType){var i=r._isFuncArg?0:1;n=n&&e.__fieldsCntByType[o]>i}return"func"===t&&(r.funcs&&(n=n&&r.funcs.length>0),e.__funcsCntByType&&(n=n&&e.__funcsCntByType[o]>0)),n}))},uv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=av(e,t,r,null).valueSrcs;return sv(e,o,n)},cv=function(e,t,r){var n=av(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets,o=null;return n.length&&(o=n[0]),o},dv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{};if(e){var i=qh(t,e)||{},a=t.settings.fieldSeparator,l=kh(e,t),s=Array.isArray(e)?e.join(a):e;if(null!=o&&o.useTableName&&i.tableName){var u=eo(l);u[0]=i.tableName,s=u.join(a)}if(i.fieldName&&(s=i.fieldName),n){qh(t,n);var c=n;0==s.indexOf(c+a)?s=s.slice((c+a).length):i.fieldName||r.errors.push("Can't cut group ".concat(c," from field ").concat(s))}return s}},pv=function(e,t){var r=e.get("type"),n=e.getIn(["properties","mode"]);return"rule_group"==r&&"array"==n?fv(e,t):"group"==r||"rule_group"==r?hv(e,t):yv(e,t)},fv=function(e,t){var r=e.get("children1"),n=e.get("properties");return vv(n.toObject(),r,t)},vv=function(e,t,r){var n,o,i=e.operator,a=0==(null!==(n=null===(o=r.operators[i])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1),l=!mv(e,r),s=!gv(t,r);return!(l&&(!a||s))},hv=function(e,t){var r=e.get("children1");return gv(r,t)},gv=function(e,t){return!((null==e?void 0:e.size)>0&&e.filter((function(e){return!pv(e,t)})).size>0)},yv=function(e,t){var r=e.get("properties");return mv((null==r?void 0:r.toObject())||{},t)},mv=function(e,t){return!(bv(e,t,!0).score>=3)},bv=function(e,t){var r,n,o,i=e.field,a=e.fieldSrc,l=(e.fieldType,e.operator),s=e.value,u=e.valueSrc,c=(e.valueType,arguments.length>2&&void 0!==arguments[2]&&arguments[2]),d=null!==(r=null===(n=t.operators[l])||void 0===n?void 0:n.cardinality)&&void 0!==r?r:1,p=null!=u&&u.get?u.toJS():u,f={parts:{},score:0};if(f.parts.field=c?null!=i:Ev(i,a,t),f.parts.operator=!!l,f.parts.value=(null==s||null===(o=s.filter((function(e,r){return Ev(e,null==p?void 0:p[r],t,c)})))||void 0===o?void 0:o.size)>=(c?Math.min(d,1):d),f.score=Object.keys(f.parts).filter((function(e){return!!f.parts[e]})).length,c&&f.score<3){var v=!0;!f.parts.value&&"func"===a&&Ev(i,a,t,!1,v)&&f.score++,f.parts.field||null==s||s.map((function(e,r){"func"===(null==p?void 0:p[r])&&Ev(e,null==p?void 0:p[r],t,!1,v)&&f.score++}))}return f},Ev=function e(t,r,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];if(!o&&"func"==r&&t){var a,l=null===(a=t.get)||void 0===a?void 0:a.call(t,"func"),s=xh(n,l);if(s){var u=t.get("args");for(var c in s.args){var d=s.args[c],p=u?u.get(c):void 0,f=p?p.get("value"):void 0,v=p?p.get("valueSrc"):void 0;if(null==f&&void 0===(null==d?void 0:d.defaultValue)&&(null==d||!d.isOptional))return!1;if(null!=f&&!e(f,v,n,!i||o))return!1}return!0}}return null!=t},Ov=function(e,t,r){return"func"==t?qf(e,r):e},Sv=function e(t){var r=t.get("children1");if(1==(null==r?void 0:r.size)){var n=r.first();return"group"===n.get("type")?e(n):n}return null},Tv=p(4308),_v=p.n(Tv),wv=p(3523),Rv=p.n(wv),Iv=p(502),Av=p.n(Iv);function Cv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Nv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Cv(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Cv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Lv(e,t){return Av().apply(e,t)}var jv={CALL:function(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),o=2;o<r;o++)n[o-2]=arguments[o];return e.call.apply(e,[t].concat(n))},JSX:function(e,t){return{type:e,props:t}},mergeObjects:function(e,t){return Nv(Nv({},e),t)},fromEntries:function(e){return Object.fromEntries(e)},strlen:function(e){return(null==e?void 0:e.length)||0},regexTest:function(e,t,r){return null!=(null==e?void 0:e.match(new RegExp(t,r)))},now:function(){return new Date},date_add:function(e,t,r){return ku()(e).add(t,r).toDate()},toLowerCase:function(e){return e.toLowerCase()},toUpperCase:function(e){return e.toUpperCase()}};function xv(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Pv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Fv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Pv(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Pv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Dv(e,t,r){var n;try{n=Av().apply(e,t)}catch(e){throw e.message="".concat(r.join(".")," :: ").concat(e.message),e}return n}function kv(e,t,r,n){var o;try{o=t.call.apply(t,[e].concat(eo(r)))}catch(e){throw e.message="".concat(n.join(".")," :: ").concat(e.message),e}return o}!function(){for(var e in jv)t=e,r=jv[e],Av().add_operation(t,r);var t,r}();var Mv=["conjunctions","fields","types","operators","widgets","settings","funcs","ctx"],Vv={asyncFetch:{type:"f",args:["search","offset"]},labelYes:{type:"r"},labelNo:{type:"r"},marks:{type:"r",isArr:!0},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]}},Uv=Fv(Fv({},Vv),{},{factory:{type:"rf"},formatValue:{type:"f",args:["val","fieldDef","wgtDef","isForDisplay","op","opDef","rightFieldDef"]},sqlFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelImportValue:{type:"f",args:["val","wgtDef","args"]},mongoFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},elasticSearchFormatValue:{type:"f",args:["queryType","val","op","field","config"]},jsonLogic:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},jsonLogicImport:{type:"f",args:["val"]},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]},toJS:{type:"f",args:["val"]}}),Bv={options:{factory:{type:"rf"}},formatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","isForDisplay","fieldDef"]},mongoFormatOp:{type:"f",args:["field","op","vals","useExpr","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},sqlFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},spelFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},jsonLogic:{type:"f",ignore:"string",args:["field","op","vals","opDef","operatorOptions","fieldDef"]},elasticSearchQueryType:{type:"f",ignore:"string",args:["valueType"]},textSeparators:{type:"r",isArr:!0}},Gv={widgetProps:Uv,opProps:Bv},qv=Fv(Fv({},Vv),{},{fieldSettings:Vv}),Kv=Fv(Fv({},Vv),{},{fieldSettings:Vv,widgets:{x:Gv},mainWidgetProps:Uv}),Wv={locale:{mui:{type:"f",args:[],invokeWith:[],ignore:"jl"}},caseValueField:Kv,canCompareFieldWithField:{type:"f",args:["leftField","leftFieldConfig","rightField","rightFieldConfig","op"]},formatReverse:{type:"f",args:["q","op","reversedOp","operatorDefinition","revOperatorDefinition","isForDisplay"]},sqlFormatReverse:{type:"f",args:["q"]},spelFormatReverse:{type:"f",args:["q"]},formatField:{type:"f",args:["field","parts","label2","fieldDefinition","config","isForDisplay"]},formatSpelField:{type:"f",args:["field","parentField","parts","partsExt","fieldDefinition","config"]},formatAggr:{type:"f",args:["whereStr","aggrField","operator","value","valueSrc","valueType","opDef","operatorOptions","isForDisplay","aggrFieldDef"]},normalizeListValues:{type:"f",args:["listValues","type","fieldSettings"]},renderConfirm:{type:"f",args:["props"]},useConfirm:{type:"f",args:[]},renderField:{type:"rf"},renderOperator:{type:"rf"},renderFunc:{type:"rf"},renderConjs:{type:"rf"},renderButton:{type:"rf"},renderIcon:{type:"rf"},renderButtonGroup:{type:"rf"},renderValueSources:{type:"rf"},renderFieldSources:{type:"rf"},renderProvider:{type:"rf"},renderSwitch:{type:"rf"},renderSwitchPrefix:{type:"r"},renderItem:{type:"rf"},renderBeforeWidget:{type:"rf"},renderAfterWidget:{type:"rf"},renderBeforeActions:{type:"rf"},renderAfterActions:{type:"rf"},renderBeforeCaseValue:{type:"rf"},renderAfterCaseValue:{type:"rf"},renderRuleError:{type:"rf"}},zv={fields:{x:Kv},widgets:{x:Uv},conjunctions:{x:{formatConj:{type:"f",args:["children","conj","not","isForDisplay"]},sqlFormatConj:{type:"f",args:["children","conj","not"]},spelFormatConj:{type:"f",args:["children","conj","not","omitBrackets"]}}},operators:{x:Bv},types:{x:{widgets:{x:Gv}}},funcs:{x:Fv(Fv(Fv({},qv),{renderBrackets:{type:"r",isArr:!0},renderSeps:{type:"r",isArr:!0},jsonLogic:{type:"f",ignore:"string",args:["formattedArgs"]},jsonLogicImport:{type:"f",args:["val"]},spelImport:{type:"f",args:["spel"]},formatFunc:{type:"f",args:["formattedArgs","isForDisplay"]},sqlFormatFunc:{type:"f",args:["formattedArgs"]},mongoFormatFunc:{type:"f",args:["formattedArgs"]},spelFormatFunc:{type:"f",args:["formattedArgs"]}}),{},{args:{x:Fv({},qv)}})},settings:Wv},Hv=function(e){return"object"==Vn(e)&&null!==e&&!Array.isArray(e)},$v=function(e,t){if(e.__fieldNames)throw new Error("Don't apply `compressConfig()` to extended config");var r=Js()(e,Mv);delete r.ctx;for(var n=function e(t,r,n,o){if(Hv(t)){if(Vs(t)&&(t=Ms(t)),"funcs"===n[0]&&!r){var i=n[n.length-1];(r=Nh({funcs:o.BasicFuncs},i,"funcs","subfields")||void 0)&&(t.$$key=i)}if(void 0!==r&&Hv(r))for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(!Object.keys(t).includes(a)||void 0===t[a]&&void 0!==r[a]?t[a]="$$deleted":(t[a]=e(t[a],r[a],[].concat(eo(n),[a]),o),void 0===t[a]&&delete t[a]));for(var l in t)if(Object.prototype.hasOwnProperty.call(t,l)){var s;r&&Object.keys(r).includes(l)||(t[l]=e(t[l],null===(s=r)||void 0===s?void 0:s[l],[].concat(eo(n),[l]),o)),void 0===t[l]&&delete t[l]}0===Object.keys(t).length&&(t=void 0)}else Array.isArray(t)&&t.forEach((function(r,i){t[i]=e(t[i],void 0,[].concat(eo(n),[i]),o)}));if(void 0===r||!Ls(t,r,!0)){if("function"==typeof t)throw new Error("compressConfig: function at ".concat(n.join(".")," should be converted to JsonLogic"));return t}},o=0,i=Mv;o<i.length;o++){var a=i[o];if("ctx"===a);else if("fields"===a)r[a]=Rv()(r[a]),n(r[a],{},[a]);else if("funcs"===a)for(var l in r[a]=Rv()(r[a]||{}),r[a])n(r[a][l],null,[a,l],{BasicFuncs:h});else r[a]=Rv()(r[a]),n(r[a],t[a],[a])}return r},Yv=function(e,t,r){if(!e.settings.useConfigCompress)throw new Error("Please enable `useConfigCompress` in config settings to use decompressConfig()");for(var n={},o=function e(t,r,n){if(Hv(r))for(var o in Hv(t)||(t={}),r)Object.prototype.hasOwnProperty.call(r,o)&&("$$deleted"===r[o]?delete t[o]:t[o]=e(t[o],r[o],[].concat(eo(n),[o])));else t=Array.isArray(r)?Rv()(r):r;return t},i=function e(t,r,n){var i=!1;if(Hv(t)&&Object.prototype.hasOwnProperty.call(t,"$$key")&&t.$$key){var a=Nh({funcs:n.BasicFuncs},t.$$key,"funcs","subfields");if(!a)throw new Error("decompressConfig: basic function not found by key ".concat(t.$$key," at ").concat(r.join(".")));delete t.$$key,t=o(Rv()(a),t,r),i=!0}if(!i)if(Hv(t))for(var l in t)Object.prototype.hasOwnProperty.call(t,l)&&(t[l]=e(t[l],[].concat(eo(r),[l]),n));else if(Array.isArray(t)){var s,u=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return xv(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?xv(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(t);try{for(u.s();!(s=u.n()).done;){var c=s.value;t[c]=e(t[c],[].concat(eo(r),[c]),n)}}catch(e){u.e(e)}finally{u.f()}}return t},a=0,l=Mv;a<l.length;a++){var s=l[a];"ctx"===s?n[s]=_v()({},t.ctx||{},r||{}):"funcs"===s?(n[s]=Rv()(e[s]||{}),i(n[s],[s],{BasicFuncs:h})):"fields"===s?n[s]=Rv()(e[s]||{}):(n[s]=Rv()(t[s]||{}),o(n[s],e[s]||{},[s]))}return n},Qv=function(e){return e.__compliled||(Xv(e=Rv()(e),e,{ctx:e.ctx},zv,[]),Object.defineProperty(e,"__compliled",{enumerable:!1,writable:!1,value:!0})),e};function Xv(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:[];if(t)for(var a in i.length,n){var l=n[a],s="x"===a?i:[].concat(eo(i),[a]);if("r"===l.type){var u=t,c=u[a];if(l.isArr)for(var d in c){var p=eh(c[d],r,[].concat(eo(s),[d]));p!==c[d]&&(o.push("Compiled ".concat(s.join("."),"[").concat(d,"]")),c[d]=p)}else{var f=eh(c,r,s,void 0);f!==c&&(o.push("Compiled R ".concat(s.join("."))),u[a]=f)}}else if("rf"===l.type){var v=t,h=v[a],g=Jv(h,r,s,l.ignore);g!==h&&(o.push("Compiled JL-RF ".concat(s.join("."))),v[a]=g)}else if("f"===l.type){var y,m=t,b=m[a],E=Zv(b,r,s,l.args,l.ignore);l.invokeWith&&E&&"function"==typeof E&&(E=(y=E).call.apply(y,[null].concat(eo(l.invokeWith)))),E!==b&&(o.push("Compiled JL-F ".concat(s.join("."))),m[a]=E)}else if("x"===a)for(var O in t){s=[].concat(eo(i),[O]);var S=t[O];Xv(e,S,r,l,o,s),S.subfields&&Xv(e,S.subfields,r,n,o,s)}else Xv(e,t[a],r,l,o,s)}}function Jv(e,t,r){return Bs(e)?function(n,o){o=o||(null==t?void 0:t.ctx);var i=Dv(e,{props:n,ctx:o},r);return"string"==typeof i&&(i={type:i,props:n}),eh(i,{ctx:o},r)}:"string"==typeof e?function(n,o){o=o||(null==t?void 0:t.ctx);var i=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),o);return i?kv(this,i,[n,o],r):eh({type:e,props:n},{ctx:o},r)}:e}function Zv(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0;return Bs(e)&&"jl"!==o?function(){for(var o=arguments.length,i=new Array(o),a=0;a<o;a++)i[a]=arguments[a];var l=this||(null==t?void 0:t.ctx),s=(n||[]).reduce((function(e,t,r){return Fv(Fv({},e),{},Hn({},t,i[r]))}),{args:i,ctx:l});return Dv(e,s,r)}.bind(null==t?void 0:t.ctx):"string"==typeof e&&"string"!==o?function(){var n=this||(null==t?void 0:t.ctx),o=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),n);if(o){for(var i=arguments.length,a=new Array(i),l=0;l<i;l++)a[l]=arguments[l];return kv(this,o,a,r)}throw new Error("".concat(r.join(".")," :: Function ").concat(e," is not found in ctx"))}.bind(null==t?void 0:t.ctx):e}function eh(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0;if(Us(e)){var o,i=e.type,a=e.props;if("string"!=typeof i)throw new Error("renderReactElement for ".concat(r.join("."),": type should be string"));var l,s=function(e,t){var r;return(null==t||null===(r=t.components)||void 0===r?void 0:r[e])||t.W[e]||t.O[e]}(i,t.ctx)||i.toLowerCase();return void 0!==n&&(a=Fv(Fv({},a),{},{key:n})),null!==(o=a)&&void 0!==o&&o.children&&(l=eh(a.children,t,r),a=Fv(Fv({},a),{},{children:l})),t.ctx.RCE(s,a)}return e instanceof Array?e.map((function(e,n){return eh(e,t,r,""+n)})):e}var th=p(2815),rh=p.n(th),nh={reverseOperatorsForNot:!1,canShortMongoQuery:!0,formatField:function(e,t,r,n,o,i){return i?r:e},caseValueField:{type:"case_value"},fieldSources:["field"],keepInputOnChangeFieldSrc:!0,fieldItemKeysForSearch:["label","path","altLabel","grouplabel"],listKeysForSearch:["title","value"],valueSourcesInfo:{value:{}},fieldSeparator:".",fieldSeparatorDisplay:".",canReorder:!0,canRegroup:!0,canDeleteLocked:!1,canLeaveEmptyGroup:!0,shouldCreateEmptyGroup:!1,exportPreserveGroups:!1,removeEmptyGroupsOnLoad:!0,removeEmptyRulesOnLoad:!0,removeIncompleteRulesOnLoad:!1,removeInvalidMultiSelectValuesOnLoad:!0,showErrorMessage:!1,setOpOnChangeField:["keep","default"],groupOperators:["some","all","none"],defaultGroupConjunction:"AND",locale:{moment:"en"},valueLabel:"Value",valuePlaceholder:"Value",fieldLabel:"Field",operatorLabel:"Operator",funcLabel:"Function",fieldPlaceholder:"Select field",funcPlaceholder:"Select function",operatorPlaceholder:"Select operator",lockLabel:"Lock",lockedLabel:"Locked",deleteLabel:"Delete",addGroupLabel:"Add group",addCaseLabel:"Add condition",addDefaultCaseLabel:"Add default condition",defaultCaseLabel:"Default:",addRuleLabel:"Add rule",addSubRuleLabel:"Add sub rule",delGroupLabel:"Delete",notLabel:"Not",fieldSourcesPopupTitle:"Select source",valueSourcesPopupTitle:"Select value source",removeRuleConfirmOptions:null,removeGroupConfirmOptions:null};function oh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ih(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ih(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function ih(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var ah,lh=0,sh=0,uh={},ch=function(){return ah||(ah=ph({reactIndex:void 0,maxSize:3,canCompile:void 0})),ah},dh=function(e,t){var r;for(var n in uh){var o=uh[n].findExtendedConfig(e,t);if(o){r=o;break}}return r},ph=function(){var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{reactIndex:void 0,maxSize:2,canCompile:!0},r=new Map,n=t.maxSize||2,o=++lh,i=function(e,t){r.size+1>n&&r.delete(r.keys().next().value),r.set(e,t)},a=function(e,t){var n,o=oh(r.keys());try{var i,a=function(){var o=n.value;if(Mv.filter((function(t){return o[t]===e[t]})).length===Mv.length&&(!t||o.__compliled))return{v:r.get(o)}};for(o.s();!(n=o.n()).done;)if(i=a())return i.v}catch(e){o.e(e)}finally{o.f()}var l,s=oh(r.values());try{var u,c=function(){var r=l.value;if(Mv.filter((function(t){return r[t]===e[t]})).length===Mv.length&&(!t||r.__compliled))return{v:r}};for(s.s();!(l=s.n()).done;)if(u=c())return u.v}catch(e){s.e(e)}finally{s.f()}return null};return e={getExtendedConfig:function(e){return r=function(e){return Js()(e,Mv)}(e),a(r)||function(e){var r=yh(e,++sh,t.canCompile);return i(e,r),r}(r);var r},findExtendedConfig:a,getBasicConfig:function(e){var t,n=oh(r.keys());try{var o,i=function(){var n=t.value,o=r.get(n);if(0===Mv.map((function(t){return o[t]===e[t]})).filter((function(e){return!e})).length)return{v:n}};for(n.s();!(t=n.n()).done;)if(o=i())return o.v}catch(e){n.e(e)}finally{n.f()}return e},clearConfigMemo:function(){r.clear(),delete uh[o],ah===e&&(ah=void 0)},configId:sh,storeConfigPair:i,getSize:function(){return r.size},configStore:r,memoId:o,meta:t},void 0===t.reactIndex&&(ah=e),uh[o]=e,e};function fh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return vh(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?vh(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function vh(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function hh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function gh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?hh(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):hh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var yh=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(r=r&&e.settings.useConfigCompress,e.__configId)return e;var n=dh(e,r);if(n)return n;var o=e;(e=r?e.__compliled?Rv()(e):Qv(e):Rv()(e)).settings=rh()({},nh,e.settings,ks),e.__fieldsCntByType={},e.__funcsCntByType={},e.__fieldNames={},function(e,t){for(var r in e)mh(0,e[r],t)}(e.types,e),bh(e.fields,e),Eh(e.funcs,e);var i=e.settings.caseValueField;i&&Oh(i,e,[],!1,!0);var a=e.settings.locale.moment;return a&&ku().locale(a),Object.defineProperty(e,"__configId",{enumerable:!1,writable:!1,value:t||Ss()}),e.__cache={},Ks(e),ch().storeConfigPair(o,e),e};function mh(e,t,r){var n=null,o=null;t.mainWidget=t.mainWidget||Object.keys(t.widgets).filter((function(e){return"field"!=e&&"func"!=e}))[0];var i=t.excludeOperators||[];for(var a in t.widgets){var l=t.widgets[a],s=l.defaultOperator;l.operators&&(n=qs(n,l.operators.filter((function(e){return!i.includes(e)})))),s&&!i.includes(s)&&(o&&a!==t.mainWidget||(o=s)),a==t.mainWidget&&(l.widgetProps=gh(gh({},t.mainWidgetProps||{}),l.widgetProps||{})),t.widgets[a]=l}t.valueSources||(t.valueSources=Object.keys(r.settings.valueSourcesInfo));var u,c=fh(t.valueSources);try{for(c.s();!(u=c.n()).done;){var d=u.value;"value"==d||t.widgets[d]||(t.widgets[d]={})}}catch(e){c.e(e)}finally{c.f()}!t.operators&&n&&(t.operators=Array.from(new Set(n))),!t.defaultOperator&&o&&(t.defaultOperator=o)}function bh(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];for(var n in e){var o=[].concat(eo(r),[n]);Oh(e[n],t,o),e[n].subfields&&bh(e[n].subfields,t,o)}}function Eh(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];if(e){var o=(null==t||null===(r=t.settings)||void 0===r?void 0:r.fieldSeparator)||".";for(var i in e){var a=[].concat(eo(n),[i]),l=a.join(o),s=e[i];if(s.returnType&&(s.type=s.returnType,t.__funcsCntByType[s.returnType]||(t.__funcsCntByType[s.returnType]=0),t.__funcsCntByType[s.returnType]++),Oh(s,t,a,!1),s.args){for(var u in s.args)Oh(s.args[u],t,[].concat(eo(a),[u]),!0);var c,d=!0,p=fh(Object.keys(s.args).reverse());try{for(p.s();!(c=p.n()).done;){var f=c.value,v=s.args[f];!d&&v.isOptional&&($s.info("Arg ".concat(f," for func ").concat(l," can't be optional")),delete v.isOptional),v.isOptional||(d=!1)}}catch(e){p.e(e)}finally{p.f()}}s.subfields&&Eh(s.subfields,t,[].concat(eo(n),[i]))}}}function Oh(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]&&arguments[4],a=t.settings,l=a.showLabels,s=a.fieldSeparator;s=null!==(r=s)&&void 0!==r?r:".";var u=n[n.length-1],c=o?n.slice(0,n.length-1).join(s):n.join(s),d=!!e.returnType,p=e.type||e.returnType,f=t.types[p],v=e.excludeOperators||[],h=(e.operators||(null==f?void 0:f.operators)||[]).filter((function(e){return!v.includes(e)})),g=e.defaultOperator||(null==f?void 0:f.defaultOperator);v.includes(g)&&(g=void 0);var y=!!g&&g==e.defaultOperator;if(y&&(e.ownDefaultOperator=e.defaultOperator),f){o||d||i||(t.__fieldsCntByType[p]||(t.__fieldsCntByType[p]=0),t.__fieldsCntByType[p]++),o&&(e._isFuncArg=!0,e._argKey=u,e._funcKey=c),d&&(e._isFunc=!0,e._funcKey=c),i&&(e._isCaseValue=!0),function(e,t,r){for(var n,o,i=0,a=["listValues","treeValues","allowCustomValues","validateValue"];i<a.length;i++){var l=a[i];e[l]&&(e.fieldSettings||(e.fieldSettings={}),e.fieldSettings[l]=e[l],delete e[l])}null!==(n=e.fieldSettings)&&void 0!==n&&n.listValues&&t.settings.normalizeListValues&&(e.fieldSettings.listValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.listValues,r,e.fieldSettings)),null!==(o=e.fieldSettings)&&void 0!==o&&o.treeValues&&t.settings.normalizeListValues&&(e.fieldSettings.treeValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.treeValues,r,e.fieldSettings))}(e,t,p);var m=["widgets","operators","defaultOperator"];Object.keys(f).filter((function(e){return!m.includes(e)})).map((function(t){e[t]||(e[t]=Is(f[t]))}));var b=f.excludeOperators||[];e.operators&&(b=b.filter((function(t){return!e.operators.includes(t)}))),e.widgets||(e.widgets={});var E=function(){var t=gh({},e.widgets[O]||{}),r=f.widgets[O]||{};if(!o){var n=t.defaultOperator,i=[].concat(eo(v),eo(b)),a=e.preferWidgets&&("field"===O||e.preferWidgets.includes(O))||i.length>0;if(t.operators){var s=t.operators.filter((function(e){return!i.includes(e)}));t.operators=s,h=qs(h,s)}else if(a&&r.operators){var c=r.operators.filter((function(e){return!i.includes(e)}));t.operators=c,h=qs(h,c)}n&&!i.includes(n)&&(g&&(y||O!==e.mainWidget)||(g=n))}O===e.mainWidget?t.widgetProps=gh(gh(gh({},r.widgetProps||{}),e.mainWidgetProps||{}),t.widgetProps||{}):t.widgetProps=gh(gh({},r.widgetProps||{}),t.widgetProps||{});var d=Array.from(new Set([].concat(eo(Object.keys(r.opProps||{})),eo(Object.keys(t.opProps||{})))));if(d.length){var p,m={},E=fh(d);try{for(E.s();!(p=E.n()).done;){var S,T,_=p.value;m[_]=gh(gh({},(null===(S=r.opProps)||void 0===S?void 0:S[_])||{}),(null===(T=t.opProps)||void 0===T?void 0:T[_])||{})}}catch(e){E.e(e)}finally{E.f()}t.opProps=m}var w=t,R=w.valueLabel,I=w.valuePlaceholder;o&&(R||(t.valueLabel=e.label||u),I||l||(t.valuePlaceholder=e.label||u)),t=gh(gh({},r),t),e.widgets[O]=t};for(var O in f.widgets)E();if(o||(e.operators||(e.operators=Array.from(new Set(h))),e.defaultOperator||(e.defaultOperator=g)),!o&&!d&&!i){var S=function(e,t){if(!t)return{};var r=e.settings.fieldSeparator,n=eo(t).reduce((function(t,n,o,i){var a=t.computedPath,l=t.computed,s=t.inGroup,u=[].concat(eo(i.slice(0,o)),[n]),c=Nh(e,u);return"!group"===(null==c?void 0:c.type)&&o<i.length-1?(s=u.join(r),a=[]):null!=c&&c.fieldName?(l=!0,a=[c.fieldName]):a=[].concat(eo(a),[n]),{computedPath:a,computed:l,inGroup:s}}),{computedPath:[],computed:!1,inGroup:void 0}),o=n.computedPath,i=n.computed,a=n.inGroup;return i?{fieldName:o.join(r),inGroup:a}:{}}(t,n),T=S.fieldName,_=S.inGroup;T&&(e.fieldName=T,t.__fieldNames[T]||(t.__fieldNames[T]=[]),t.__fieldNames[T].push({fullPath:n,inGroup:_}))}}else e.disabled=!0}function Sh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Th(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Sh(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Sh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var _h=Qs().mark(Ih),wh=Qs().mark(Ah),Rh=_s;function Ih(e){return Qs().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Ch(e,e.funcs||{},[]),"t0",1);case 1:case"end":return t.stop()}}),_h)}function Ah(e){return Qs().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(Ch(e,e.fields||{},[]),"t0",1);case 1:case"end":return t.stop()}}),wh)}function Ch(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";return Qs().mark((function o(i){var a,l,s;return Qs().wrap((function(o){for(;;)switch(o.prev=o.next){case 0:a=(null==e||null===(i=e.settings)||void 0===i?void 0:i.fieldSeparator)||".",o.t0=Qs().keys(t);case 2:if((o.t1=o.t0()).done){o.next=13;break}if(l=o.t1.value,!(s=t[l])[n]){o.next=9;break}return o.delegateYield(Ch(e,s[n],[].concat(eo(r),[l]),n),"t2",7);case 7:o.next=11;break;case 9:return o.next=11,[[].concat(eo(r),[l]).join(a),s];case 11:o.next=2;break;case 13:case"end":return o.stop()}}),o)}))()}var Nh=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"fields",i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";if(!t)return null;if("!case_value"===t)return null==e||null===(n=e.settings)||void 0===n?void 0:n.caseValueField;var a=(null==e||null===(r=e.settings)||void 0===r?void 0:r.fieldSeparator)||".",l=kh(t,e),s=e[o];if(!s)return null;for(var u=s,c=null,d=[],p=0;p<l.length;p++){var f=l[p];d.push(f),c=u[d.join(a)],p<l.length-1&&(c&&c[i]?(u=c[i],d=[]):c=null)}return c},Lh=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=e.settings.fieldSeparator,a=[o].concat(eo(t.split(i))).filter((function(e){return null!=e})),l=t;return((null===(r=e.__fieldNames[l])||void 0===r||null===(n=r.find)||void 0===n||null===(n=n.call(r,(function(e){var t=e.inGroup;return!t||(null==o?void 0:o.startsWith(t))})))||void 0===n?void 0:n.fullPath)||a).join(i)},jh=function(e,t){if(!t)return null;var r=Nh(e,t,"funcs","subfields");if(!r)return null;var n=r.returnType,o=r.args;return{returnType:n,args:Object.fromEntries(Object.entries(o||{}).map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return[r,Js()(n,["type","valueSources","defaultValue","fieldSettings","isOptional","_funcKey","_argKey","_isFuncArg"])]})))}},xh=function(e,t){return t&&Nh(e,t,"funcs","subfields")||null},Ph=function(e,t,r){var n=xh(e,t);return n&&(n.args&&n.args[r]||null)||null},Fh=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return!1;var o=(null==n||null===(r=n.settings)||void 0===r?void 0:r.fieldSeparator)||".",i=Dh(e,n),a=Dh(t,n);return i.startsWith(a+o)},Dh=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if("string"==typeof e)return e;var n=(null==r||null===(t=r.settings)||void 0===t?void 0:t.fieldSeparator)||".";return kh(e,r).join(n)},kh=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!e)return[];if(Array.isArray(e))return e;var i,a=(null==o||null===(t=o.settings)||void 0===t?void 0:t.fieldSeparator)||".";return null!=e&&e.func?Array.isArray(e.func)?e.func:e.func.split(a):null!=e&&null!==(r=e.get)&&void 0!==r&&r.call(e,"func")?null==e||null===(i=e.get)||void 0===i?void 0:i.call(e,"func").split(a):(null==e||null===(n=e.split)||void 0===n?void 0:n.call(e,a))||[]},Mh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!e)return null;var n=t.settings.fieldSeparator,o=kh(e,t);return r?o:o.map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return e.join(n)}))},Vh=function(e){var t;if("string"==typeof e||Array.isArray(e))return"field:".concat(Dh(e));if("object"===Vn(e)&&e){if(e._funcKey&&e._argKey)return"arg:".concat(Dh(e._funcKey),"__").concat(e._argKey);if(e._funcKey)return"func:".concat(Dh(e._funcKey));if(e.func&&e.arg)return"arg:".concat(Dh(e.func),"__").concat(e.arg);if(e.func)return"func:".concat(Dh(e.func));if(e.type)return null}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?"arg:".concat(Dh(e.get("func")),"__").concat(e.get("arg")):"func:".concat(Dh(e.get("func"))):null},Uh=function(e,t,r){var n;return null===(n=e.__cache)||void 0===n||null===(n=n[t])||void 0===n?void 0:n[r]},Bh=function(e,t,r,n){e.__cache&&r&&(e.__cache[t]||(e.__cache[t]={}),e.__cache[t][r]=n)},Gh=function(e){var t;if(!e)return null;if("object"===Vn(e)){if(!e.func&&e.type)return"field";if(e.func)return e.func&&e.arg?null:"func"}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?null:"func":"field"},qh=function(e,t){var r;if(!t)return null;if("object"==Vn(t)){if(!t.func&&t.type)return t;if(t.func)return t.func&&t.arg?Ph(e,t.func,t.arg):xh(e,t.func)}return null!=t&&null!==(r=t.get)&&void 0!==r&&r.call(t,"func")?null!=t&&t.get("arg")?Ph(e,t.get("func"),t.get("arg")):xh(e,t.get("func")):Nh(e,t)||null},Kh=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return null;var n=e.operators[t];if(r){var o,i,a=Vh(r),l=a?"".concat(a,"__").concat(t):null,s=Uh(e,"getOperatorConfig",l);if(s)return s;var u=qh(e,r),c=cv(e,r,t,null),d=e.widgets[c]||{},p=(u&&u.widgets?u.widgets[c]:{})||{},f=(null===(o=d.opProps)||void 0===o?void 0:o[t])||{},v=(null===(i=p.opProps)||void 0===i?void 0:i[t])||{},h=Th(Th(Th({},n),f),v);return Bh(e,"getOperatorConfig",l,h),h}return n},Wh=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{};if(!t)return null;var l=qh(e,t),s=Vh(t);o||(o=cv(e,t,n,i));var u=s?"".concat(s,"__").concat(n,"__").concat(o,"__").concat(i):null,c=Uh(e,"getFieldWidgetConfig",u);if(c)return c;var d=e.widgets[o]||{},p=(null==l||null===(r=l.widgets)||void 0===r?void 0:r[o])||{},f=p.widgetProps||{},v="value"!==i&&i?{}:null==l?void 0:l.fieldSettings,h=Th(Th(Th(Th({},d),p),f),v);return Bh(e,"getFieldWidgetConfig",u,h),a.forExport&&(h=As(h,"factory")),h},zh=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=e.settings.fieldSeparator,n=kh(t,e),o=t?Nh(e,t):e,i=null,a=[];do{var l,s=o===e?e.fields:null===(l=o)||void 0===l?void 0:l.subfields;if(!s||!Object.keys(s).length){o=i=null;break}i=Object.keys(s)[0],a.push(i),o=s[i]}while("!struct"==o.type||"!group"==o.type);return(n||[]).concat(a).join(r)};function Hh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function $h(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Hh(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Hh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Yh=function(e,t){var r={usedFields:[]},n=Qh(e,t,r);if(n)return $h($h({},n),r)},Qh=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?Xh(e,t,r):"rule"===n?Jh(e,t,r):void 0}},Xh=function(e,t,r){var n=e.get("properties")||new xa,o=e.get("children1"),i=e.get("id"),a=o.map((function(e){return Qh(e,t,r)})).filter((function(e){return void 0!==e}));if(a.size){var l=n.get("conjunction");l||(l=wd(t));var s=n.get("not");return{id:i,rules:a.toList(),condition:l.toUpperCase(),not:s}}},Jh=function(e,t,r){var n,o=e.get("properties")||new xa,i=e.get("id"),a=o.get("operator"),l=o.get("operatorOptions"),s=o.get("field"),u=o.get("value"),c=o.get("valueSrc"),d=o.get("valueType"),p=u.filter((function(e){return void 0===e})).size>0;if(null!=s&&null!=a&&!p){var f=qh(t,s)||{},v=Kh(t,a,s)||{},h=f.type||"undefined",g=Cs(v),y=t.types[f.type]||{},m=dv(s,t,r);if(!(u.size<g)){-1==r.usedFields.indexOf(s)&&r.usedFields.push(s),u=u.toArray(),c=c.toArray(),d=(null===(n=d)||void 0===n?void 0:n.toArray())||[];for(var b=[],E=0;E<u.length;E++){var O={type:d[E],value:u[E]};if(b.push(O),"field"==c[E]){var S=u[E];-1==r.usedFields.indexOf(S)&&r.usedFields.push(S)}}var T=l?l.toJS():null;T&&!Object.keys(T).length&&(T=null);var _={id:i,fieldName:m,type:h,input:y.mainWidget,operator:a};return T&&(_.operatorOptions=T),_.values=b,_}}};function Zh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function eg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Zh(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Zh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function tg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return rg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?rg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function rg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var ng=function(e,t){var r,n={usedFields:[],errors:[]},o=yh(t,void 0,!1),i=og(e,o,n,!1,!0),a=n.errors,l=n.usedFields,s=(o.settings.fieldSeparator,{}),u=tg(l);try{for(u.s();!(r=u.n()).done;)for(var c=r.value,d=kh(c,t),p=(qh(o,c),s),f=0;f<d.length;f++){var v=d[f],h=qh(o,d.slice(0,f+1))||{};f!=d.length-1?"!group"==h.type&&"struct"!=h.mode?(p[v]||(p[v]=[{}]),p=p[v][0]):(p[v]||(p[v]={}),p=p[v]):p[v]||(p[v]=null)}}catch(e){u.e(e)}finally{u.f()}return{errors:a,logic:i,data:s}},og=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(e){var a,l=e.get("type"),s=(e.get("properties")||new xa).get("isLocked"),u=t.settings.jsonLogic.lockedOp;return"group"===l||"rule_group"===l?a=ig(e,t,r,n,o,i):"rule"===l?a=ag(e,t,r,n,i):"switch_group"==l?a=lg(e,t,r,n):"case_group"==l&&(a=sg(e,t,r,n,i)),s&&a&&u&&(a=Hn({},u,a)),a}},ig=function(e,t,r){var n,o,i,a,l,s,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]&&arguments[4],d=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,p=e.get("type"),f=e.get("properties")||new xa,v=f.get("mode"),h=e.get("children1")||new nl,g=f.get("field"),y=qh(t,g),m=f.get("conjunction");m||(m=wd(t));var b=t.conjunctions[m].jsonLogicConj||m.toLowerCase(),E=!!f.get("not"),O="rule_group"===p&&!c,S=O&&"struct"!=v,T=S?g:d,_=f.get("operator"),w=_&&Kh(t,_,g)||null,R=ug(t,f,r,_,d),I=O&&(!_||0==(null===(n=w)||void 0===n?void 0:n.cardinality)),A=O&&(null==h?void 0:h.size)>0,C=(O&&null!=h&&h.size,E),N=!1;A?(N=E,C=u):u&&(C=!C);var L=!1,j=null===(o=w)||void 0===o?void 0:o.reversedOp,x=Kh(t,j,g),P=!(null!==(i=w)&&void 0!==i&&i.jsonLogic||null===(a=x)||void 0===a||!a.jsonLogic),F=!(null===(l=x)||void 0===l||!l.jsonLogic),D=null===(s=Sv(e))||void 0===s?void 0:s.get("type");if(!!t.settings.reverseOperatorsForNot&&(!O&&C&&"rule"===D||N&&1===(null==h?void 0:h.size))&&(A?N=!N:C=!C,L=!0),C&&O&&F&&(t.settings.reverseOperatorsForNot||P)){C=!C;var k=[j,_];_=k[0],j=k[1];var M=[x,w];w=M[0],x=M[1]}var V=h.map((function(e){return og(e,t,r,L,!1,T)})).filter((function(e){return void 0!==e})),U=!!t.settings.exportPreserveGroups;if(S&&!I){if(null==R)return}else if(!V.size&&!U)return;var B=c||U||1!=V.size;B||!E||L||(B=h.some((function(e){var r,n,o,i,a=null===(r=e.get("properties"))||void 0===r?void 0:r.get("operator"),l=null===(n=t.operators)||void 0===n||null===(n=n[a])||void 0===n?void 0:n.reversedOp;return null!==(o=null===(i=t.operators)||void 0===i||null===(i=i[l])||void 0===i?void 0:i._jsonLogicIsExclamationOp)&&void 0!==o&&o})));var G={};if(B?G[b]=V.toList().toJS():G=V.first(),N&&(G={"!":G}),S){var q=pg(r,t,g,d);if(I)G=Hn({},_||"some",[q,G]);else{var K=V.size?{filter:[q,G]}:q;G=fg(t,f,{reduce:[K,{"+":[1,{var:"accumulator"}]},0]},R,_,null,y)}}return C&&(G={"!":G}),G},ag=function(e,t,r){var n,o,i,a,l,s,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d=e.get("properties")||new xa,p=d.get("field"),f=d.get("fieldSrc"),v=d.get("operator"),h=d.get("operatorOptions");if((h=h?h.toJS():null)&&!Object.keys(h).length&&(h=null),null!=p&&null!=v){var g=qh(t,p),y=Kh(t,v,p),m=null===(n=y)||void 0===n?void 0:n.reversedOp,b=Kh(t,m,p);if(null!==(o=y)&&void 0!==o&&o.jsonLogic||null!==(i=b)&&void 0!==i&&i.jsonLogic){var E=u,O=!(null!==(a=y)&&void 0!==a&&a.jsonLogic||null===(l=b)||void 0===l||!l.jsonLogic),S=!(null===(s=b)||void 0===s||!s.jsonLogic)&&(!!t.settings.reverseOperatorsForNot||O);if(E&&S||O){E=!E;var T=[m,v];v=T[0],m=T[1];var _=[b,y];y=_[0],b=_[1]}var w=ug(t,d,r,v,c);if(void 0!==w){var R="func"===f?dg(r,t,p,c):pg(r,t,p,c);if(void 0!==R)return fg(t,d,R,w,v,h,g,E)}}else r.errors.push("Operator ".concat(v," is not supported"))}},lg=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=e.get("children1");if(o){for(var i=o.map((function(e){return sg(e,t,r,n,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray(),a=[],l=0;l<i.length;l++)l===i.length-1||i[l][0]?(a.push(i[l]),l===i.length-1&&i[l][0]&&a.push([void 0,null])):r.errors.push("No condition for case ".concat(l));if(a.length){if(1===a.length){var s=Jn(a[0],2),u=(s[0],s[1]);return null==u&&(u=null),u}for(var c={if:[]},d=c.if,p=Jn(a[a.length-1],2),f=(p[0],p[1]),v=0;v<a.length-1;v++){var h=v===a.length-2,g=Jn(a[v],2),y=g[0],m=g[1];null==m&&(m=null),null==y&&(y=!0),d.push(y),d.push(m),h?d.push(f):(d.push({if:[]}),d=d[d.length-1].if)}return c}}},sg=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=e.get("type");if("case_group"==i){var a=e.get("properties")||new xa;return[ig(e,t,r,n,o),ug(t,a,r,null,o,"!case_value")]}r.errors.push("Unexpected child of type ".concat(i," inside switch"))},ug=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),l=t.get("valueSrc"),s=t.get("valueType");("!case_value"==i||s&&"case_value"==s.get(0))&&(a="!case_value");var u=qh(e,a),c=Kh(e,n,a),d=Cs(c),p=t.get("value"),f=t.get("asyncListValues");if(null!=p){var v=[],h=[],g=r.usedFields,y=p.map((function(t,i){var d=l?l.get(i):null,p=s?s.get(i):null,g=Ov(t,d,e),y=cv(e,a,n,d),m=Wh(e,a,n,y,d,{forExport:!0}),b=cg(r,e,g,d,p,m,u,n,c,o,f);return void 0!==b&&(v.push(d),h.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;if(!(y.size<d||m))return d>1?y.toArray():1==d?y.first():null;r.usedFields=g}},cg=function(e,t,r,n,o,i,a,l,s){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"==n)d=pg(e,t,r,u);else if("func"==n)d=dg(e,t,r,u);else if("function"==typeof(null==i?void 0:i.jsonLogic)){var p=i.jsonLogic,f=[r,eg(eg({},a?Js()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),As(i,_s)];l&&(f.push(l),f.push(s)),d=p.call.apply(p,[t.ctx].concat(f))}else d=r;return d}},dg=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),l=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),s=xh(t,a),u=kh(a,t),c=u[u.length-1];if(s)if(null!=s&&s.jsonLogic){var d={},p=[],f=[];for(var v in s.args){var h,g=s.args[v],y=qh(t,g),m=g.defaultValue,b=g.isOptional,E=null!=m&&m.func?"func":"value",O=l?l.get(v):void 0,S=O?O.get("value"):void 0,T=O?O.get("valueSrc"):void 0;"func"!==T&&null!==(h=S)&&void 0!==h&&h.toJS&&(S=S.toJS());var _=null,w=cv(t,g,_,T),R=Wh(t,g,_,w,T,{forExport:!0}),I=cg(e,t,S,T,g.type,R,y,null,null,i);if(null!=S&&void 0===I)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(v," for func ").concat(a)));var A=void 0;if(void 0===I&&!b&&null!=m){var C=cv(t,g,_,E),N=Wh(t,g,_,C,E,{forExport:!0});if(void 0===(A=cg(e,t,m,E,g.type,N,y,null,null,i)))return void("func"!=E&&e.errors.push("Can't format default value of arg ".concat(v," for func ").concat(a)))}var L=null!=I?I:A;if(void 0!==L){if(p.length){var j,x=tg(p);try{for(x.s();!(j=x.n()).done;)d[j.value]=void 0}catch(e){x.e(e)}finally{x.f()}p=[]}d[v]=L}else b||f.push(v),p.push(v)}if(!f.length){var P,F=Object.values(d);if("function"==typeof s.jsonLogic){var D=s.jsonLogic,k=[d];P=D.call.apply(D,[t.ctx].concat(k))}else{var M=s.jsonLogic||c;if(s.jsonLogicIsMethod){var V=F[0],U=F.slice(1);P=U.length?{method:[V,M,U]}:{method:[V,M]}}else P=Hn({},M,F)}return P}}else e.errors.push("Func ".concat(a," is not supported"));else e.errors.push("Func ".concat(a," is not defined in config"))},pg=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=t.settings,a=i.fieldSeparator,l=i.jsonLogic;if(r){Array.isArray(r)&&(r=r.join(a));var s=qh(t,r)||{},u=dv(r,t,e,o);n=Hn({},s.jsonLogicVar||("!group"==s.type?l.groupVarKey:"var"),u),-1==e.usedFields.indexOf(r)&&e.usedFields.push(r)}return n},fg=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=arguments.length>7&&void 0!==arguments[7]&&arguments[7],s=t.get("field"),u=Kh(e,o,s)||{},c="function"==typeof u.jsonLogic?u.jsonLogic:function(e,t,r,n){var o=e,i=Cs(t);"string"==typeof t.jsonLogic&&(o=t.jsonLogic);var a=["<","<=",">",">="],l=["==","!="];return function(e,t,s,u,c){return 0==i&&l.includes(o)?Hn({},o,[r,null]):0==i?Hn({},o,r):1==i?Hn({},o,[r,n]):2==i&&a.includes(o)?Hn({},o,[n[0],r,n[1]]):Hn({},o,[r].concat(eo(n)))}}(o,u,r,n),d=[r,o,n,As(u,ws),i,a],p=c.call.apply(c,[e.ctx].concat(d));return l&&(p={"!":p}),p};function vg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return hg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?hg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function hg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function gg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function yg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?gg(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):gg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var mg=function(e){return"object"==Vn(e)&&null!==e&&!Array.isArray(e)},bg=function(e,t){return Eg(e,t,!1)},Eg=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=yh(t,void 0,!1),i=Og([],e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to MongoDb:",n.errors),i)},Og=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0;if(t){var s=t.get("type");return"group"===s||"rule_group"===s?Sg(e,t,r,n,o,i,a,l):"rule"===s?Tg(e,t,r,n,o,i,a,l):void 0}},Sg=function(e,t,r,n){var o,i,a,l,s,u,c,d,p=arguments.length>4&&void 0!==arguments[4]&&arguments[4],f=t.get("type"),v=t.get("properties")||new xa,h=!!v.get("not"),g=t.get("children1")||new nl,y=r.settings,m=y.canShortMongoQuery,b=y.fieldSeparator,E=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,O=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),S=E&&O,T="rule_group"===f,_=T?v.get("field"):null,w=T?v.get("operator"):null,R=w&&Kh(r,w,_)||null,I=w?null!==(o=null===(i=R)||void 0===i?void 0:i.cardinality)&&void 0!==o?o:1:void 0,A=dv(_,r,n,S),C=(qh(r,_)||{}).mode,N=_&&"array"===C&&I>=1,L=T&&(null==g?void 0:g.size)>0,j=(T&&null!=g&&g.size,!1),x=h,P=!1;L?(P=h,x=p):p&&(x=!x);var F=null===(a=R)||void 0===a?void 0:a.reversedOp,D=Kh(r,F,_),k=!(null!==(l=R)&&void 0!==l&&l.mongoFormatOp||null===(s=D)||void 0===s||!s.mongoFormatOp),M=!(null===(u=D)||void 0===u||!u.mongoFormatOp),V=null===(c=Sv(t))||void 0===c?void 0:c.get("type");if(!!r.settings.reverseOperatorsForNot&&(!T&&x&&"rule"===V||P&&1===(null==g?void 0:g.size))&&(L?P=!P:x=!x,j=!0),x&&T&&M&&(r.settings.reverseOperatorsForNot||k)){x=!x;var U=[F,w];w=U[0],F=U[1];var B=[D,R];R=B[0],D=B[1]}var G=v.get("conjunction");G||(G=wd(r));var q=r.conjunctions[G];if(q){var K=q.reversedConj;x&&"or"===(null===(d=G)||void 0===d?void 0:d.toLowerCase())&&K&&!T&&r.settings.canShortMongoQuery&&r.settings.reverseOperatorsForNot&&(G=K,q=r.conjunctions[G],x=!x,j=!0);var W=q.mongoConj,z=g.map((function(o){return Og([].concat(eo(e),[t]),o,r,n,j,"array"!=C,"array"==C?function(e){return"$$el".concat(b).concat(e)}:void 0)})).filter((function(e){return void 0!==e}));if(N||z.size){var H;if(1==z.size)H=z.first();else if(z.size>1){var $=z.toList().toJS();m&&"$and"==W&&(H=$.reduce((function(e,t){if(e){for(var r in t){if("$"==r[0]){e=void 0;break}if(null==e[r])e[r]=t[r];else{var n=e[r],o=t[r];if(mg(n)||(n={$eq:n}),mg(o)||(o={$eq:o}),Object.keys(n)[0]==Object.keys(o)[0]){e=void 0;break}e[r]=Object.assign({},n,o)}}return e}}),{})),H||(H=Hn({},W,$))}if(_)if("array"==C){var Y={$size:{$ifNull:["$"+A,[]]}},Q=H?{$size:{$ifNull:[{$filter:{input:"$"+A,as:"el",cond:H}},[]]}}:Y;H={$expr:H=Og(e,t.set("type","rule"),r,n,P,!1,(function(e){return Q}),Y)}}else H=Hn({},A,{$elemMatch:H});return x&&(H={$not:H}),H}}},Tg=function(e,t,r,n){var o,i,a,l,s,u,c,d=arguments.length>4&&void 0!==arguments[4]&&arguments[4],p=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],f=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,v=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0,h=t.get("properties")||new xa,g=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,y=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),m=g&&y,b=h.get("operator"),E=h.get("operatorOptions"),O=h.get("field"),S=h.get("fieldSrc"),T=h.get("value"),_=h.get("valueSrc"),w=h.get("valueType"),R=h.get("asyncListValues");if(null!=O&&null!=b&&void 0!==T){var I=qh(r,O),A=Kh(r,b,O),C=null===(o=A)||void 0===o?void 0:o.reversedOp,N=Kh(r,C,O),L=Cs(A);if(null!==(i=A)&&void 0!==i&&i.mongoFormatOp||null!==(a=N)&&void 0!==a&&a.mongoFormatOp){var j,x=d,P=!(null!==(l=A)&&void 0!==l&&l.mongoFormatOp||null===(s=N)||void 0===s||!s.mongoFormatOp);if(null!==(u=N)&&void 0!==u&&u.mongoFormatOp&&(r.settings.reverseOperatorsForNot||P)&&x||P){var F=[C,b];b=F[0],C=F[1];var D=[N,A];A=D[0],N=D[1],x=!x}var k=!1;if("func"==S){var M=Jn(Rg(n,r,O,m),2);j=M[0],k=M[1]}else j=dv(O,r,n,m),f&&(k=!0,j=f(j));if(null!=j){var V,U=[],B=[];if(null!=T){var G=T.map((function(e,t){var o=_?_.get(t):null,i=w?w.get(t):null,a=Ov(e,o,r),l=cv(r,O,b,o),s=Wh(r,O,b,l,o,{forExport:!0}),u=Jn(_g(n,r,a,o,i,s,I,m,b,A,R),2),c=u[0],d=u[1];return void 0!==c&&(k=k||d,U.push(o),B.push(i)),c})),q=G.filter((function(e){return void 0===e})).size>0;if(G.size<L||q)return;V=L>1?G.toArray():1==L?G.first():null}var K=k&&p,W=null===(c=A)||void 0===c?void 0:c.mongoFormatOp,z=[j,b,void 0!==v&&null==V?v:V,k,U.length>1?U:U[0],B.length>1?B:B[0],As(A,ws),E,I],H=W.call.apply(W,[r.ctx].concat(z));return K&&(H={$expr:H}),x&&(H={$not:H}),H}}else n.errors.push("Operator ".concat(b," is not supported"))}},_g=function(e,t,r,n,o,i,a,l,s,u,c){if(void 0===r)return[void 0,!1];var d,p=!1;if("field"==n){var f=Jn(wg(e,t,r,l),2);d=f[0],p=f[1]}else if("func"==n){var v=Jn(Rg(e,t,r,l),2);d=v[0],p=v[1]}else if("function"==typeof(null==i?void 0:i.mongoFormatValue)){var h=i.mongoFormatValue,g=[r,yg(yg({},a?Js()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),As(i,_s)];s&&(g.push(s),g.push(u)),d=h.call.apply(h,[t.ctx].concat(g))}else d=r;return[d,p]},wg=function(e,t,r,n){var o,i=t.settings.fieldSeparator;if(r){var a=qh(t,r)||{},l=kh(r,t),s=nv(r,t),u=s?s.join(i):null;o="$"+(0,t.settings.formatField)(dv(r,t,e,n),l,u,a,t,!1)}return[o,!0]},Rg=function(e,t,r,n){var o,i,a,l=null===(o=r.get)||void 0===o?void 0:o.call(r,"func"),s=null===(i=r.get)||void 0===i?void 0:i.call(r,"args"),u=xh(t,l);if(!u)return e.errors.push("Func ".concat(l," is not defined in config")),[void 0,!1];var c=kh(l,t),d=c[c.length-1],p=u.mongoFunc||d,f=u.mongoArgsAsObject,v={},h=0,g=void 0,y=[],m=[];for(var b in u.args){var E;h++;var O=u.args[b],S=qh(t,O),T=O.defaultValue,_=O.isOptional,w=null!=T&&T.func?"func":"value",R=s?s.get(b):void 0,I=R?R.get("value"):void 0,A=R?R.get("valueSrc"):void 0;"func"!==A&&null!==(E=I)&&void 0!==E&&E.toJS&&(I=I.toJS());var C=R?R.get("asyncListValues"):void 0,N=null,L=cv(t,O,N,A),j=Wh(t,O,N,L,A,{forExport:!0}),x=Jn(_g(e,t,I,A,O.type,j,S,n,null,null,C),2),P=x[0];if(x[1],null!=I&&void 0===P)return"func"!=A&&e.errors.push("Can't format value of arg ".concat(b," for func ").concat(l)),[void 0,!1];var F=void 0;if(void 0===P&&!_&&null!=T){var D=cv(t,O,N,w),k=Wh(t,O,N,D,w,{forExport:!0}),M=Jn(_g(e,t,T,w,O.type,k,S,n,null,null,C),2);if(F=M[0],M[1],void 0===F)return"func"!=w&&e.errors.push("Can't format default value of arg ".concat(b," for func ").concat(l)),[void 0,!1]}var V=null!=P?P:F;if(void 0!==V){if(y.length){var U,B=vg(y);try{for(B.s();!(U=B.n()).done;)v[U.value]=void 0}catch(e){B.e(e)}finally{B.f()}y=[]}v[b]=V,g=V}else _||m.push(b),y.push(b)}if(m.length)return[void 0,!1];if("function"==typeof u.mongoFormatFunc){var G=u.mongoFormatFunc,q=[v];a=G.call.apply(G,[t.ctx].concat(q))}else{if(null===u.mongoFormatFunc)return e.errors.push("Functon ".concat(p," is not supported")),[void 0,!1];a=Hn({},p,f?v:1==h&&void 0!==g?g:Object.values(v))}return[a,!0]};function Ig(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Ag(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Ag(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function Ag(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Cg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Ng(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Cg(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Cg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Lg=function(e,t){return jg(e,t,!1)},jg=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=yh(t,void 0,!1),i=xg(e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SQL:",n.errors),i)},xg=function(e,t,r){if(e){var n=e.get("type");return e.get("children1"),"group"===n||"rule_group"===n?Pg(e,t,r):"rule"===n?Fg(e,t,r):void 0}},Pg=function(e,t,r){var n=e.get("type"),o=e.get("properties")||new xa,i=e.get("children1")||new nl,a="rule_group"===n?o.get("field"):null;"array"==(qh(t,a)||{}).mode&&r.errors.push("Aggregation is not supported for ".concat(a));var l=o.get("not"),s=i.map((function(e){return xg(e,t,r)})).filter((function(e){return void 0!==e}));if(s.size){var u=o.get("conjunction");return u||(u=wd(t)),t.conjunctions[u].sqlFormatConj.call(t.ctx,s,u,l)}},Fg=function(e,t,r){var n=e.get("properties")||new xa,o=n.get("field"),i=n.get("fieldSrc"),a=n.get("operator"),l=n.get("operatorOptions"),s=n.get("valueSrc"),u=n.get("valueType"),c=n.get("value"),d=n.get("asyncListValues");if(null!=o&&null!=a){var p=qh(t,o)||{},f=Kh(t,a,o)||{},v=f.reversedOp,h=Kh(t,v,o)||{},g=Cs(f),y=!1,m=f.sqlOp||f.sqlFormatOp,b=h.sqlOp||h.sqlFormatOp;if(m||b){if(!m&&b){y=!0;var E=[v,a];a=E[0],v=E[1];var O=[h,f];f=O[0],h=O[1]}var S,T=[],_=[];if(null!=c){var w=c.map((function(e,n){var i=s?s.get(n):null,l=u?u.get(n):null,c=Ov(e,i,t),v=cv(t,o,a,i),h=Wh(t,o,a,v,i,{forExport:!0}),g=Dg(r,t,c,i,l,h,p,a,f,d);return void 0!==g&&(T.push(i),_.push(l)),g}));if(w.filter((function(e){return void 0===e})).size>0||w.size<g)return;S=1==g?w.first():w}var R=f.sqlFormatOp||function(e,t){var r,n=t.sqlOp||e,o=Cs(t);return 0==o?r=function(e,t,r,o,i,a,l,s){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,l,s){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,l,s){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(n," ").concat(d," AND ").concat(p)}),r}(a,f);if(R){var I="func"==i?Mg(r,t,o):kg(r,t,o);if(null!=I){var A,C=[I,a,S,T.length>1?T:T[0],_.length>1?_:_[0],As(f,ws),l,p];if(A=R.call.apply(R,[t.ctx].concat(C)),y&&(A=t.settings.sqlFormatReverse.call(t.ctx,A)),void 0!==A)return A;r.errors.push("Operator ".concat(a," is not supported for value source ").concat(T.join(", ")))}}else r.errors.push("Operator ".concat(a," is not supported"))}else r.errors.push("Operator ".concat(a," is not supported"))}},Dg=function(e,t,r,n,o,i,a,l,s,u){if(void 0!==r){var c;if("field"==n)c=kg(e,t,r);else if("func"==n)c=Mg(e,t,r);else if("function"==typeof(null==i?void 0:i.sqlFormatValue)){var d=i.sqlFormatValue,p=[r,Ng(Ng({},Js()(a,["fieldSettings","listValues"])),{},{asyncListValues:u}),As(i,_s)];if(l&&(p.push(l),p.push(s)),"field"==n){var f=qh(t,r)||{};p.push(f)}c=d.call.apply(d,[t.ctx].concat(p))}else c=Array.isArray(r)?r.map((function(e){return fc.escape(e)})):fc.escape(r);return c}},kg=function(e,t,r){if(r){var n=t.settings.fieldSeparator,o=qh(t,r)||{},i=kh(r,t),a=nv(r,t),l=a?a.join(n):null;return(0,t.settings.formatField)(dv(r,t,e,null,{useTableName:!0}),i,l,o,t)}},Mg=function(e,t,r){var n,o,i=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),a=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=xh(t,i);if(l){var s=kh(i,t),u=s[s.length-1],c=l.sqlFunc||u,d={},p=[],f=[];for(var v in l.args){var h,g=l.args[v],y=qh(t,g),m=g.defaultValue,b=g.isOptional,E=null!=m&&m.func?"func":"value",O=a?a.get(v):void 0,S=O?O.get("value"):void 0,T=O?O.get("valueSrc"):void 0;"func"!==T&&null!==(h=S)&&void 0!==h&&h.toJS&&(S=S.toJS());var _=O?O.get("asyncListValues"):void 0,w=Dg(e,t,S,T,g.type,y,g,null,null,_);if(null!=S&&void 0===w)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(v," for func ").concat(i)));var R=void 0;if(void 0===w&&!b&&null!=m&&void 0===(R=Dg(e,t,m,E,g.type,y,g,null,null,_)))return void("func"!=E&&e.errors.push("Can't format default value of arg ".concat(v," for func ").concat(i)));var I=null!=w?w:R;if(void 0!==I){if(p.length){var A,C=Ig(v);try{for(C.s();!(A=C.n()).done;)d[A.value]=void 0}catch(e){C.e(e)}finally{C.f()}p=[]}d[v]=I}else b||f.push(v),p.push(v)}if(!f.length){var N;if("function"==typeof l.sqlFormatFunc){var L=l.sqlFormatFunc,j=[d];N=L.call.apply(L,[t.ctx].concat(j))}else{var x=Object.entries(d).map((function(e){var t=Jn(e,2);return t[0],t[1]})).join(", ");N="".concat(c,"(").concat(x,")")}return N}}else e.errors.push("Func ".concat(i," is not defined in config"))};function Vg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Ug(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Vg(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Vg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Bg(e,t,r,n,o,i){if(e&&r&&null!=t){var a=r,l=n.operators[a];if(l){var s=l.elasticSearchQueryType,u=!1;!s&&l.reversedOp&&(u=!0,a=l.reversedOp,s=(l=n.operators[a]).elasticSearchQueryType);var c=cv(n,e,a,o),d=n.widgets[c];if(d){var p,f,v=d.elasticSearchFormatValue;if(p="function"==typeof s?s(c):s)return f="function"==typeof v?v(p,t,a,e,n):function(e,t,r,n,o,i){var a=function(e,t){return e}(n);switch(e){case"filter":return{script:o.operators[r].elasticSearchScript(n,t)};case"exists":return{field:n};case"match":return Hn({},a,t[0]);case"term":return Hn({},n,i===Gg?{value:t[0]}:t[0]);case"geo_bounding_box":return Hn({},n,function(e){if(null==e)return null;var t=e.split(",").map(Number);return{top_left:{lat:t[0],lon:t[1]},bottom_right:{lat:t[2],lon:t[3]}}}(t[0]));case"range":return Hn({},n,function(e,t){if(e.length>1)return{gte:"".concat(e[0]),lte:"".concat(e[1])};var r=e[0];switch(t){case"on_date":case"not_on_date":case"equal":case"select_equals":case"not_equal":return{gte:"".concat(r,"||/d"),lte:"".concat(r,"||+1d")};case"less_or_equal":return{lte:"".concat(r)};case"greater_or_equal":return{gte:"".concat(r)};case"less":return{lt:"".concat(r)};case"greater":return{gt:"".concat(r)};default:return}}(t,r));case"wildcard":return Hn({},n,function(e){return{value:"*"+e+"*"}}(t[0]));case"regexp":return Hn({},n,function(e){return{value:e}}(t[0]));default:return}}(p,t,a,e,n,i),u?{bool:{must_not:Hn({},p,Ug({},f))}}:Hn({},p,Ug({},f))}}}}var Gg="ES_7_SYNTAX",qg="ES_6_SYNTAX";function Kg(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:qg,n=yh(t,void 0,!1);if(e){var o=e.get("type"),i=e.get("properties")||new Map;if("rule"===o&&i.get("field")){var a,l,s,u=i.get("operator"),c=i.get("field"),d=i.get("fieldSrc"),p=null===(a=i.get("value"))||void 0===a?void 0:a.toJS(),f=(null===(l=i.get("valueType"))||void 0===l||l.get(0),null===(s=i.get("valueSrc"))||void 0===s?void 0:s.get(0));if("func"===f||"func"==d)return;return p&&Array.isArray(p[0])?p[0].map((function(e){return Bg(c,[e],u,n,f,r)})):Bg(c,p,u,n,f,r)}if("group"===o||"rule_group"===o){var v=i.get("not"),h=i.get("conjunction");return h||(h=wd(n)),function(e,t,r,n,o,i){if(e&&e.size){var a=e.valueSeq().toArray(),l=function(e,t){switch(e){case"AND":return t?"must_not":"must";case"OR":return t?"should_not":"should";case"NOT":return t?"must":"must_not";default:return}}(t,r),s=a.map((function(e){return n(e,o,i)})).filter((function(e){return void 0!==e}));if(s.length)return{bool:Hn({},l,s.flat(1/0))}}}(e.get("children1"),h,v,Kg,n,r)}}}function Wg(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r={};for(var n in e)if({}.hasOwnProperty.call(e,n)){if(t.includes(n))continue;r[n]=e[n]}return r}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.includes(r)||{}.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}function zg(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}var Hg=["title","value","disabled","groupTitle","grouplabel","renderTitle","children","label","isCustom","isHidden"];function $g(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Yg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Qg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Yg(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Yg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Xg=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1e3;return function(){var n,o=(n=Qs().mark((function n(o,i,a){var l,s,u,c,d,p;return Qs().wrap((function(n){for(;;)switch(n.prev=n.next){case 0:if(l=null!=(null==a?void 0:a.pageSize)?a.pageSize:t,s=uu(e).filter((function(e){var t=e.title,r=e.value;return null==o||-1!=t.toUpperCase().indexOf(o.toUpperCase())||-1!="".concat(r).toUpperCase().indexOf(o.toUpperCase())})),l&&Math.ceil(s.length/l),u=i||0,l&&Math.ceil(u/l),c=l?s.slice(u,u+l):s,d=l?u+c.length:null,p=!!l&&d<s.length,!r){n.next=11;break}return n.next=11,Gs(r);case 11:return n.abrupt("return",{values:c,hasMore:p});case 12:case"end":return n.stop()}}),n)})),function(){var e=this,t=arguments;return new Promise((function(r,o){var i=n.apply(e,t);function a(e){zg(i,r,o,a,l,"next",e)}function l(e){zg(i,r,o,a,l,"throw",e)}a(void 0)}))});return function(e,t,r){return o.apply(this,arguments)}}()},Jg=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(!t)return e;var o=e||[],i=t.filter((function(e){return null==o.find((function(t){return""+t.value==""+e.value}))})).map((function(e){return n?Qg(Qg({},e),{},{isHidden:!0}):e}));return r?[].concat(eo(i),eo(o)):[].concat(eo(o),eo(i))},Zg=function(e,t,r){var n,o=null==e||""==e?void 0:null!==(n=null==e?void 0:e.value)&&void 0!==n?n:e,i=hu(o,t),a=r&&!i?su(o):void 0,l=i||a;return[o,l?[l]:void 0]},ey=function(e,t,r){var n=e.map((function(e,n){var o,i=null==e||""==e?void 0:null!==(o=null==e?void 0:e.value)&&void 0!==o?o:e,a=hu(i,t),l=r&&!a?su(i):void 0;return a||l})).filter((function(e){return null!=e})),o=n.map((function(e){var t;return null!==(t=null==e?void 0:e.value)&&void 0!==t?t:e}));return o.length||(o=void 0),[o,n]},ty=function(e){if(null==e)return null;var t=e.title,r=e.value,n=e.disabled,o=e.groupTitle,i=e.grouplabel,a=e.renderTitle,l=e.children,s=e.label,u=e.isCustom,c=e.isHidden,d=Wg(e,Hg),p={value:r,title:t||s||l};return n&&(p.disabled=n),u&&(p.isCustom=u),c&&(p.isHidden=c),(o||i)&&(p.groupTitle=o||i),a&&(p.renderTitle=a),Qg(Qg({},p),d)},ry=function(e){var t,r=[],n=[],o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return $g(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?$g(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(e);try{var i=function(){var e=t.value,o=function(e,t){if(e.findLastIndex)return e.findLastIndex(t);var r=eo(e).reverse().findIndex(t);return-1==r?-1:e.length-1-r}(r,(function(t){var r,n;return(null!==(r=t.groupTitle)&&void 0!==r?r:"")==(null!==(n=e.groupTitle)&&void 0!==n?n:"")}));null==e.groupTitle||n.includes(e.groupTitle)||(n.push(e.groupTitle),1===n.length&&(r=r.map((function(e){return Qg(Qg({},e),{},{groupTitle:""})})))),null==e.groupTitle&&n.length&&(e=Qg(Qg({},e),{},{groupTitle:""})),-1!=o?r.splice(o+1,0,e):r.push(e)};for(o.s();!(t=o.n()).done;)i()}catch(e){o.e(e)}finally{o.f()}return r},ny={label:"Now",returnType:"datetime",jsonLogic:"now",jsonLogicCustomOps:{now:{}},spelFunc:"T(java.time.LocalDateTime).now()",sqlFormatFunc:function(){return"NOW()"},mongoFormatFunc:function(){return new Date},formatFunc:function(){return"NOW"}},oy={label:"Relative",returnType:"datetime",renderBrackets:["",""],renderSeps:["","",""],spelFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim,i=r+(o.charAt(0).toUpperCase()+o.slice(1)+"s");return"".concat(t,".").concat(i,"(").concat(n,")")},spelImport:function(e){var t,r,n,o,i=null===(t=e.methodName)||void 0===t?void 0:t.match(/^(minus|plus)(\w+)s$/);if(i&&(o=i[2].toLowerCase(),r=i[1],["minus","plus"].includes(r)&&["day","week","month","year"].includes(o)))return r={type:"string",val:r},o={type:"string",val:o},n=e.args[0],{date:e.obj,op:r,val:n,dim:o}},jsonLogic:function(e){var t=e.date,r=e.op;return{date_add:[t,e.val*("minus"==r?-1:1),e.dim]}},jsonLogicImport:function(e){var t=e.date_add[0],r=Math.abs(e.date_add[1]);return[t,e.date_add[1]>=0?"plus":"minus",r,e.date_add[2]]},jsonLogicCustomOps:{date_add:{}},sqlFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return"DATE_ADD(".concat(t,", INTERVAL ").concat(parseInt(n)*("minus"==r?-1:1)," ").concat(o.replace(/^'|'$/g,""),")")},mongoFormatFunc:null,formatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return n?"".concat(t," ").concat("minus"==r?"-":"+"," ").concat(n," ").concat(o):t},args:{date:{label:"Date",type:"datetime",defaultValue:{func:"NOW",args:[]},valueSources:["func","field","value"],spelEscapeForFormat:!0},op:{label:"Op",type:"select",defaultValue:"plus",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{plus:"+",minus:"-"}},spelEscapeForFormat:!1},val:{label:"Value",type:"number",fieldSettings:{min:0},defaultValue:0,valueSources:["value"],spelEscapeForFormat:!1},dim:{label:"Dimension",type:"select",defaultValue:"day",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{day:"day",week:"week",month:"month",year:"year"}},spelEscapeForFormat:!1}}},iy={label:"Lowercase",mongoFunc:"$toLower",jsonLogic:"toLowerCase",spelFunc:"${str}.toLowerCase()",jsonLogicCustomOps:{toLowerCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},ay={label:"Uppercase",mongoFunc:"$toUpper",jsonLogic:"toUpperCase",spelFunc:"${str}.toUpperCase()",jsonLogicCustomOps:{toUpperCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},ly={label:"Linear regression",returnType:"number",formatFunc:function(e,t){var r=e.coef,n=e.bias,o=e.val;return"(".concat(r," * ").concat(o," + ").concat(n,")")},sqlFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelImport:function(e){var t,r;if("op-plus"===e.type){var n=Jn(e.children,2);if(r=n[0],t=n[1],"op-multiply"===r.type){var o=Jn(r.children,2);return{coef:o[0],val:o[1],bias:t}}}},mongoFormatFunc:function(e){var t=e.coef,r=e.bias;return{$sum:[{$multiply:[t,e.val]},r]}},jsonLogic:function(e){var t=e.coef,r=e.bias;return{"+":[{"*":[t,e.val]},r]}},jsonLogicImport:function(e){return[e["+"][0]["*"][0],e["+"][0]["*"][1],e["+"][1]]},renderBrackets:["",""],renderSeps:[" * "," + "],args:{coef:{label:"Coef",type:"number",defaultValue:1,valueSources:["value"]},val:{label:"Value",type:"number",valueSources:["value","field"]},bias:{label:"Bias",type:"number",defaultValue:0,valueSources:["value"]}}},sy={utils:{SqlString:fc,moment:ku(),mongoFormatOp1:function(e,t,r,n,o,i,a,l,s,u,c,d){var p="string"!=typeof n||n.startsWith("$")?n:"$"+n,f=t(i,d);if(void 0!==f)return r?a||e&&"$eq"!=e?a?{$not:Hn({},e,[p,f])}:Hn({},n,{$not:Hn({},e,f)}):Hn({},n,{$ne:f}):a||e&&"$eq"!=e?a?Hn({},e,[p,f]):Hn({},n,Hn({},e,f)):Hn({},n,f)},mongoFormatOp2:function(e,t,r,n,o,i,a,l,s,u,c){var d="string"!=typeof r||r.startsWith("$")?r:"$"+r;return t?i?{$not:{$and:[Hn({},e[0],[d,o[0]]),Hn({},e[1],[d,o[1]])]}}:Hn({},r,{$not:Hn(Hn({},e[0],o[0]),e[1],o[1])}):i?{$and:[Hn({},e[0],[d,o[0]]),Hn({},e[1],[d,o[1]])]}:Hn({},r,Hn(Hn({},e[0],o[0]),e[1],o[1]))},mongoEmptyValue:hc,escapeRegExp:Ds,sqlEmptyValue:vc,stringifyForDisplay:Ec,getTitleInListValues:du,spelEscape:yc,spelFixList:gc,wrapWithBrackets:Oc}};const uy=sy;function cy(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function dy(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function py(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?dy(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):dy(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var fy={equal:{label:"==",labelForFormat:"==",sqlOp:"=",spelOp:"==",spelOps:["==","eq"],reversedOp:"not_equal",formatOp:function(e,t,r,n,o,i,a,l,s){var u=l?"=":i.label;return"boolean"==o&&l?"No"==r?"NOT ".concat(e):"".concat(e):"".concat(e," ").concat(u," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},jsonLogic:"==",elasticSearchQueryType:"term"},not_equal:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",spelOp:"!=",spelOps:["!=","ne"],reversedOp:"equal",formatOp:function(e,t,r,n,o,i,a,l,s){return"boolean"==o&&l?"No"==r?"".concat(e):"NOT ".concat(e):"".concat(e," ").concat(i.label," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},jsonLogic:"!="},less:{label:"<",labelForFormat:"<",sqlOp:"<",spelOp:"<",spelOps:["<","lt"],reversedOp:"greater_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lt",function(e){return e},!1].concat(r))},jsonLogic:"<",elasticSearchQueryType:"range"},less_or_equal:{label:"<=",labelForFormat:"<=",sqlOp:"<=",spelOp:"<=",spelOps:["<=","le"],reversedOp:"greater",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lte",function(e){return e},!1].concat(r))},jsonLogic:"<=",elasticSearchQueryType:"range"},greater:{label:">",labelForFormat:">",sqlOp:">",spelOp:">",spelOps:[">","gt"],reversedOp:"less_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return e},!1].concat(r))},jsonLogic:">",elasticSearchQueryType:"range"},greater_or_equal:{label:">=",labelForFormat:">=",sqlOp:">=",spelOp:">=",spelOps:[">=","ge"],reversedOp:"less",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gte",function(e){return e},!1].concat(r))},jsonLogic:">=",elasticSearchQueryType:"range"},like:{label:"Contains",labelForFormat:"Contains",reversedOp:"not_like",sqlOp:"LIKE",spelOp:"${0}.contains(${1})",valueTypes:["text"],mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:function(e,t,r){return{in:[r,e]}},jsonLogic2:"#in",valueSources:["value"],elasticSearchQueryType:"regexp"},not_like:{isNotOp:!0,label:"Not contains",reversedOp:"like",labelForFormat:"Not Contains",sqlOp:"NOT LIKE",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!0].concat(n))},jsonLogic:function(e,t,r){return{"!":{in:[r,e]}}},jsonLogic2:"#!in",_jsonLogicIsExclamationOp:!0,valueSources:["value"]},starts_with:{label:"Starts with",labelForFormat:"Starts with",sqlOp:"LIKE",spelOp:"${0}.startsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?"^"+t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},ends_with:{label:"Ends with",labelForFormat:"Ends with",sqlOp:"LIKE",spelOp:"${0}.endsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e)+"$":void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},between:{label:"Between",labelForFormat:"BETWEEN",sqlOp:"BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,l){var s=r.first(),u=r.get(1);return l?"".concat(e," BETWEEN ").concat(s," AND ").concat(u):"".concat(e," >= ").concat(s," && ").concat(e," <= ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,l){var s=r[0],u=r[1];return"".concat(e," >= ").concat(s," && ").concat(e," <= ").concat(u)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!1].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"not_between",jsonLogic:"<=",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null},elasticSearchQueryType:function(e){return"time"===e?"filter":"range"}},not_between:{isNotOp:!0,label:"Not between",labelForFormat:"NOT BETWEEN",sqlOp:"NOT BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,l){var s=r.first(),u=r.get(1);return l?"".concat(e," NOT BETWEEN ").concat(s," AND ").concat(u):"(".concat(e," < ").concat(s," || ").concat(e," > ").concat(u,")")},spelFormatOp:function(e,t,r,n,o,i,a,l){var s=r[0],u=r[1];return"(".concat(e," < ").concat(s," || ").concat(e," > ").concat(u,")")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!0].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"between",jsonLogic:function(e,t,r){return{"!":{"<=":[Array.isArray(r)?r[0]:r,e,Array.isArray(r)?r[1]:r]}}},jsonLogic2:"!<=",_jsonLogicIsExclamationOp:!0,validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null}},is_empty:{label:"Is empty",labelForFormat:"IS EMPTY",cardinality:0,reversedOp:"is_not_empty",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS EMPTY"):"!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var s=this.utils.sqlEmptyValue(l);return"COALESCE(".concat(e,", ").concat(s,") = ").concat(s)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," <= ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!"},is_not_empty:{isNotOp:!0,label:"Is not empty",labelForFormat:"IS NOT EMPTY",cardinality:0,reversedOp:"is_empty",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NOT EMPTY"):"!!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var s=this.utils.sqlEmptyValue(l);return"COALESCE(".concat(e,", ").concat(s,") <> ").concat(s)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," > ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!!",elasticSearchQueryType:"exists"},is_null:{label:"Is null",labelForFormat:"IS NULL",sqlOp:"IS NULL",cardinality:0,reversedOp:"is_not_null",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NULL"):"!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," == null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return null},!1].concat(r))},jsonLogic:"=="},is_not_null:{label:"Is not null",labelForFormat:"IS NOT NULL",sqlOp:"IS NOT NULL",cardinality:0,reversedOp:"is_null",formatOp:function(e,t,r,n,o,i,a,l){return l?"".concat(e," IS NOT NULL"):"!!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," != null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return null},!1].concat(r))},jsonLogic:"!=",elasticSearchQueryType:"exists"},select_equals:{label:"==",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,l){var s=l?"=":"==";return"".concat(e," ").concat(s," ").concat(r)},spelOp:"==",spelOps:["==","eq"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"select_not_equals",jsonLogic:"==",elasticSearchQueryType:"term"},select_not_equals:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,l){return"".concat(e," != ").concat(r)},spelOp:"!=",spelOps:["!=","ne"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"select_equals",jsonLogic:"!="},select_any_in:{label:"Any in",labelForFormat:"IN",sqlOp:"IN",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):"".concat(e," IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):void 0},valueTypes:["multiselect"],spelOp:"${1}.contains(${0})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))},reversedOp:"select_not_any_in",jsonLogic:"in",elasticSearchQueryType:"term"},select_not_any_in:{isNotOp:!0,label:"Not in",labelForFormat:"NOT IN",sqlOp:"NOT IN",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):"".concat(e," NOT IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e){return e},!1].concat(r))},reversedOp:"select_any_in",jsonLogic:function(e,t,r){return{"!":{in:[e,r]}}},jsonLogic2:"!in",_jsonLogicIsExclamationOp:!0},multiselect_contains:{label:"Contains",labelForFormat:"CONTAINS",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," CONTAINS [").concat(r.join(", "),"]"):"".concat(e," CONTAINS ").concat(r)},reversedOp:"multiselect_not_contains",jsonLogic2:"some-in",jsonLogic:function(e,t,r){return{some:[e,{in:[{var:""},r]}]}},spelOp:"T(CollectionUtils).containsAny(${0}, ${1})",elasticSearchQueryType:"term",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))}},multiselect_not_contains:{isNotOp:!0,label:"Not contains",labelForFormat:"NOT CONTAINS",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," NOT CONTAINS [").concat(r.join(", "),"]"):"".concat(e," NOT CONTAINS ").concat(r)},reversedOp:"multiselect_contains",jsonLogic2:"!some-in",jsonLogic:function(e,t,r){return{"!":{some:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},multiselect_equals:{label:"Equals",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,l){var s=l?"=":"==";return"value"==n?"".concat(e," ").concat(s," [").concat(r.join(", "),"]"):"".concat(e," ").concat(s," ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var s=this;return"value"==n?"".concat(e," = '").concat(r.map((function(e){return s.utils.SqlString.trim(e)})).join(","),"'"):void 0},spelOp:"${0}.equals(${1})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"multiselect_not_equals",jsonLogic2:"all-in",jsonLogic:function(e,t,r){return{all:[e,{in:[{var:""},r]}]}},elasticSearchQueryType:"term"},multiselect_not_equals:{isNotOp:!0,label:"Not equals",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,l){return"value"==n?"".concat(e," != [").concat(r.join(", "),"]"):"".concat(e," != ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var s=this;return"value"==n?"".concat(e," != '").concat(r.map((function(e){return s.utils.SqlString.trim(e)})).join(","),"'"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"multiselect_equals",jsonLogic2:"!all-in",jsonLogic:function(e,t,r){return{"!":{all:[e,{in:[{var:""},r]}]}}},_jsonLogicIsExclamationOp:!0},proximity:{label:"Proximity search",cardinality:2,valueLabels:[{label:"Word 1",placeholder:"Enter first word"},{label:"Word 2",placeholder:"Enter second word"}],textSeparators:[],formatOp:function(e,t,r,n,o,i,a,l){var s=r.first(),u=r.get(1),c=null==a?void 0:a.get("proximity");return"".concat(e," ").concat(s," NEAR/").concat(c," ").concat(u)},sqlFormatOp:function(e,t,r,n,o,i,a,l){var s=r.first(),u=r.get(1),c=this.utils.SqlString.trim(s),d=this.utils.SqlString.trim(u),p=null==a?void 0:a.get("proximity");return"CONTAINS(".concat(e,", 'NEAR((").concat(c,", ").concat(d,"), ").concat(p,")')")},mongoFormatOp:void 0,jsonLogic:void 0,options:{optionLabel:"Near",optionTextBefore:"Near",optionPlaceholder:"Select words between",minProximity:2,maxProximity:10,defaults:{proximity:2}}},some:{label:"Some",labelForFormat:"SOME",cardinality:0,jsonLogic:"some",spelFormatOp:function(e){return"".concat(e," > 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return 0},!1].concat(r))}},all:{label:"All",labelForFormat:"ALL",cardinality:0,jsonLogic:"all",spelFormatOp:function(e,t,r){return"".concat(e," == ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))}},none:{label:"None",labelForFormat:"NONE",cardinality:0,jsonLogic:"none",spelFormatOp:function(e){return"".concat(e," == 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return 0},!1].concat(r))}}},vy={text:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"String",valuePlaceholder:"Enter string",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},textarea:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"Text",valuePlaceholder:"Enter text",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e},fullWidth:!0},number:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r){var n=r.step&&!Number.isInteger(r.step);return this.utils.spelEscape(e,n)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},slider:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number or move slider",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},select:{type:"select",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=this.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e);return n?this.utils.stringifyForDisplay(o):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},multiselect:{type:"multiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=e.map((function(e){return o.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e)}));return n?i.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e,t,r,n,o){var i=o&&o.spelOp&&o.spelOp.startsWith("${1}"),a=this.utils.spelEscape(e);return i&&(a=this.utils.spelFixList(a)),a},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},date:{type:"date",jsType:"string",valueSrc:"value",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD",valueLabel:"Date",valuePlaceholder:"Enter date",valueLabels:[{label:"Date from",placeholder:"Enter date from"},{label:"Date to",placeholder:"Enter date to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("YYYY-MM-DD"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD");return"T(java.time.LocalDate).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDate"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o,i,a;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&null!==(n=r.fmt)&&void 0!==n&&null!==(n=n.value)&&void 0!==n&&null!==(o=n.includes)&&void 0!==o&&o.call(n," ")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&null!==(a=i.toLowerCase)&&void 0!==a&&a.call(i).includes("hh:mm"))return[void 0,"Invalid date format ".concat(JSON.stringify(r.fmt))];var l=this.utils.moment(e.value,this.utils.moment.ISO_8601);return l.isValid()?[l.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},time:{type:"time",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",valueFormat:"HH:mm:ss",use12Hours:!1,valueLabel:"Time",valuePlaceholder:"Enter time",valueLabels:[{label:"Time from",placeholder:"Enter time from"},{label:"Time to",placeholder:"Enter time to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("HH:mm:ss"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("HH:mm:ss");return"T(java.time.LocalTime).parse('".concat(i,"')")},spelImportFuncs:["T(java.time.LocalTime).parse(${v})"],spelImportValue:function(e,t,r){var n,o,i;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&r.fmt&&(null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.toLowerCase)||void 0===o||!o.call(n).includes("hh:mm")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&i.includes(" ")))return[void 0,"Invalid time format ".concat(JSON.stringify(r.fmt))];var a=this.utils.moment(e.value,"HH:mm:ss");return a.isValid()?[a.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?60*r.get("hour")*60+60*r.get("minute")+r.get("second"):void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},elasticSearchFormatValue:function(e,t,r,n){return{script:{script:{source:"doc[".concat(n,"][0].getHour() >== params.min && doc[").concat(n,"][0].getHour() <== params.max"),params:{min:t[0],max:t[1]}}}}}},datetime:{type:"datetime",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD HH:mm:ss",use12Hours:!1,valueLabel:"Datetime",valuePlaceholder:"Enter datetime",valueLabels:[{label:"Datetime from",placeholder:"Enter datetime from"},{label:"Datetime to",placeholder:"Enter datetime to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat+" "+r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.toDate())},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD HH:mm:ss");return"T(java.time.LocalDateTime).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd HH:mm:ss","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDateTime"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o;if(!t)return[void 0,"No widget def to get value format"];if(null==r||null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.includes)||void 0===o||!o.call(n," "))return[void 0,"Invalid datetime format ".concat(JSON.stringify(r.fmt))];var i=this.utils.moment(e.value,this.utils.moment.ISO_8601);return i.isValid()?[i.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},boolean:{type:"boolean",jsType:"boolean",valueSrc:"value",labelYes:"Yes",labelNo:"No",formatValue:function(e,t,r,n){return n?e?"Yes":"No":JSON.stringify(!!e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},defaultValue:!1,toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},field:{valueSrc:"field",formatValue:function(e,t,r,n,o,i,a){return n&&a.label||e},sqlFormatValue:function(e,t,r,n,o,i){return e},spelFormatValue:function(e,t,r,n,o){return e},valueLabel:"Field to compare",valuePlaceholder:"Select field to compare"},func:{valueSrc:"func",valueLabel:"Function",valuePlaceholder:"Select function"},case_value:{valueSrc:"value",type:"case_value",spelFormatValue:function(e){return this.utils.spelEscape(""===e?null:e)},spelImportValue:function(e){return[e.value,[]]},jsonLogic:function(e){return""===e?null:e}}},hy=py(py({},nh),{},{convertableWidgets:{number:["slider","rangeslider"],slider:["number","rangeslider"],rangeslider:["number","slider"],text:["textarea"],textarea:["text"]},formatSpelField:function(e,t,r,n,o,i){var a=this,l=n.map((function(e,t){var r=e.key,n=e.parent,o=e.fieldSeparator;return 0==t?"[map]"==n?"#this[".concat(a.utils.spelEscape(r),"]"):r:"map"==n||"[map]"==n?"[".concat(a.utils.spelEscape(r),"]"):"".concat(o).concat(r)})).join("");return o.fieldName&&(l=e),o.isSpelVariable&&(l="#"+l),l},sqlFormatReverse:function(e){if(null!=e)return"NOT"+this.utils.wrapWithBrackets(e)},spelFormatReverse:function(e){if(null!=e)return"!"+this.utils.wrapWithBrackets(e)},formatReverse:function(e,t,r,n,o,i){if(null!=e)return i?"NOT "+this.utils.wrapWithBrackets(e):"!"+this.utils.wrapWithBrackets(e)},formatAggr:function(e,t,r,n,o,i,a,l,s,u){var c=a.labelForFormat,d=a.cardinality;if(0==d){var p=e?" HAVE ".concat(e):"";return"".concat(c," OF ").concat(t).concat(p)}if(null==d||1==d){var f=e?" WHERE ".concat(e):"";return"COUNT OF ".concat(t).concat(f," ").concat(c," ").concat(n)}if(2==d){var v=e?" WHERE ".concat(e):"",h=n.first(),g=n.get(1);return"COUNT OF ".concat(t).concat(v," ").concat(c," ").concat(h," AND ").concat(g)}},jsonLogic:{groupVarKey:"var",altVarKey:"var",lockedOp:"locked"},canCompareFieldWithField:function(e,t,r,n){return!0},valueSourcesInfo:{value:{label:"Value"},field:{label:"Field",widget:"field"},func:{label:"Function",widget:"func"}}}),gy=function(e,t){var r,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o={rangeslider:by,treeselect:Ey,treemultiselect:Oy,rangeable__date:my("date","date")},i=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return cy(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?cy(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(t);try{for(i.s();!(r=i.n()).done;){var a=r.value,l=o[a];if(!l)throw new Error("Can't ".concat(n?"add":"remove"," mixin ").concat(a));e=l(e,n)}}catch(e){i.e(e)}finally{i.f()}return e},yy=function(e,t){return gy(e,t,!0)},my=function(e,t){return function(r){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=r.types;return o=py(py({},o),{},Hn({},e,py(py({},o[e]),{},{widgets:py({},o[e].widgets)}))),n?o[e].widgets[t]=py({opProps:{between:{isSpecialRange:!0,textSeparators:[null,null]},not_between:{isSpecialRange:!0,textSeparators:[null,null]}}},o[e].widgets[t]):delete o[e].widgets[t],py(py({},r),{},{types:o})}},by=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=py({},r),t?r.rangeslider=py({type:"number",jsType:"number",valueSrc:"value",valueLabel:"Range",valuePlaceholder:"Select range",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},singleWidget:"slider",toJS:function(e,t){return e}},r.rangeslider):delete r.rangeslider,n=py(py({},n),{},{number:py(py({},n.number),{},{widgets:py({},n.number.widgets)})}),t?n.number.widgets.rangeslider=py({opProps:{between:{isSpecialRange:!0},not_between:{isSpecialRange:!0}},operators:["between","not_between","is_null","is_not_null"]},n.number.widgets.rangeslider):delete n.number.widgets.rangeslider,py(py({},e),{},{widgets:r,types:n})},Ey=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=py({},r),t?r.treeselect=py({type:"treeselect",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,i=this.utils.getTitleInListValues(o,e);return n?this.utils.stringifyForDisplay(i):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treeselect):delete r.treeselect,n=py({},n),t?n.treeselect=py({mainWidget:"treeselect",defaultOperator:"select_equals",widgets:{treeselect:{operators:["select_equals","select_not_equals"]},treemultiselect:{operators:["select_any_in","select_not_any_in"]}}},n.treeselect):delete n.treeselect,py(py({},e),{},{widgets:r,types:n})},Oy=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=py({},r),t?r.treemultiselect=py({type:"treemultiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,a=e.map((function(e){return o.utils.getTitleInListValues(i,e)}));return n?a.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treemultiselect):delete r.treemultiselect,n=py({},n),t?n.treemultiselect=py({defaultOperator:"multiselect_equals",widgets:{treemultiselect:{operators:["multiselect_equals","multiselect_not_equals"]}}},n.treemultiselect):delete n.treemultiselect,py(py({},e),{},{widgets:r,types:n})},Sy={addMixins:yy,removeMixins:function(e,t){return gy(e,t,!1)}},Ty={conjunctions:{AND:{label:"And",mongoConj:"$and",jsonLogicConj:"and",sqlConj:"AND",spelConj:"and",spelConjs:["and","&&"],reversedConj:"OR",formatConj:function(e,t,r,n){var o=e.size>1?e.join(" "+(n?"AND":"&&")+" "):e.first();return(e.size>1||r)&&(o=this.utils.wrapWithBrackets(o)),r&&(o="NOT "+o),o},sqlFormatConj:function(e,t,r){var n=e.size>1?e.join(" AND "):e.first();return(e.size>1||r)&&(n=this.utils.wrapWithBrackets(n)),r&&(n="NOT "+n),n},spelFormatConj:function(e,t,r,n){r&&(n=!1);var o=e.size>1?e.join(" && "):e.first();return(e.size>1||r)&&!n&&(o=this.utils.wrapWithBrackets(o)),r&&(o="!"+o),o}},OR:{label:"Or",mongoConj:"$or",jsonLogicConj:"or",sqlConj:"OR",spelConj:"or",spelConjs:["or","||"],reversedConj:"AND",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"OR":"||")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" OR ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" || ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}}},operators:fy,widgets:vy,types:{text:{defaultOperator:"equal",mainWidget:"text",widgets:{text:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","proximity","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},textarea:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},field:{operators:["equal","not_equal","proximity"]}}},number:{defaultOperator:"equal",mainWidget:"number",widgets:{number:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]},slider:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","is_null","is_not_null"]}}},date:{defaultOperator:"equal",widgets:{date:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},time:{defaultOperator:"equal",widgets:{time:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},datetime:{defaultOperator:"equal",widgets:{datetime:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},select:{mainWidget:"select",defaultOperator:"select_equals",widgets:{select:{operators:["select_equals","select_not_equals","is_null","is_not_null"]},multiselect:{operators:["select_any_in","select_not_any_in","is_null","is_not_null"]}}},multiselect:{defaultOperator:"multiselect_equals",widgets:{multiselect:{operators:["multiselect_contains","multiselect_not_contains","multiselect_equals","multiselect_not_equals","is_null","is_not_null"]}}},boolean:{defaultOperator:"equal",widgets:{boolean:{operators:["equal","not_equal","is_null","is_not_null"],widgetProps:{}},field:{operators:["equal","not_equal"]}}},"!group":{defaultOperator:"some",mainWidget:"number",widgets:{number:{widgetProps:{min:0},operators:["some","all","none","equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between"],opProps:{equal:{label:"Count =="},not_equal:{label:"Count !="},less:{label:"Count <"},less_or_equal:{label:"Count <="},greater:{label:"Count >"},greater_or_equal:{label:"Count >="},between:{label:"Count between"},not_between:{label:"Count not between"}}}}},case_value:{mainWidget:"case_value",widgets:{case_value:{widgetProps:{}}}}},settings:hy,ctx:uy};const _y=Ty=yy(Ty,["rangeslider","treeselect","treemultiselect"]);var wy="ADD_GROUP",Ry="ADD_CASE_GROUP",Iy="REMOVE_GROUP",Ay="SET_CONJUNCTION",Cy="SET_NOT",Ny="ADD_RULE",Ly="REMOVE_RULE",jy="SET_FIELD",xy="SET_FIELD_SRC",Py="SET_OPERATOR",Fy="SET_VALUE",Dy="SET_VALUE_SRC",ky="SET_FUNC_VALUE",My="SET_OPERATOR_OPTION",Vy="SET_LOCK",Uy="SET_TREE",By="MOVE_ITEM",Gy="after",qy="before",Ky="append",Wy="prepend",zy="SET_DRAG_PROGRESS",Hy="SET_DRAG_START",$y="SET_DRAG_END",Yy=p(1612),Qy=p.n(Yy);function Xy(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Jy(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Xy(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Xy(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Zy(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return em(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?em(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}function em(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var tm=function(e,t,r,n,o,i){var a,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(gu(t)))return e;var u=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,c=i.settings.shouldCreateEmptyGroup,d=t.push(u),p=!c,f=!(null==s||!s.isDefaultCase),v=e;return(e=rm(e,t,r,u,Rd(i).merge(ys(o)||{}),i,l))!==v&&(l||f||(e=e.setIn(gu(d,"children1"),new Es.OrderedMap),p&&(e=rm(e,d,"rule",Ss(),Td(i),i))),e=Eu(e)),e},rm=function(e,t,r,n,o,i){var a,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("switch_group"===r)throw new Error("Can't add switch_group programmatically");var s=e.getIn(gu(t));if(!s)return e;var u,c,d=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,p=i.settings,f=p.maxNumberOfCases,v=p.maxNumberOfRules,h=p.maxNesting,g="switch_group"===e.get("type"),y=g?e.getIn(gu(t.take(2))):null,m=gu(t,"children1"),b=e.getIn(m),E=!!b&&b.size,O=E?b.size:null;"case_group"===r?(u=O,c=f):"group"===r?(u=t.size,c=h):"rule_group"===(null==s?void 0:s.get("type"))||(u=_u(g?y:e),c=v);var S=!c||!u||u<c,T={type:r,id:d,properties:o};lm(i,T,l);var _="case_group"===r&&E&&null==b.last().get("children1");if(S){var w=new Es.OrderedMap(Hn({},d,new Es.Map(T)));if(E)if(_){var R=b.last(),I=new Es.OrderedMap(Hn(Hn({},d,new Es.Map(T)),R.get("id"),R));e=(e=e.deleteIn(gu(m,"children1",R.get("id")))).mergeIn(m,I)}else e=e.mergeIn(m,w);else e=e.setIn(m,w);e=Eu(e)}return e},nm=function(e,t){return e=e.deleteIn(gu(t)),Eu(e)},om=function(e,t,r,n,o){var i,a,l,s,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},c=e.getIn(gu(t));if(!c)return{state:e};var d=u.isEndValue,p=u.canDropArgs;if(!r)return{state:e=nm(e,t)};var f=n.settings,v=f.fieldSeparator,h=f.setOpOnChangeField,g=f.showErrorMessage;Array.isArray(r)&&(r=r.join(v));var y=c.get("type"),m=c.get("properties"),b="rule_group"==y,E=null==m?void 0:m.get("fieldSrc"),O=qh(n,r);if(!O)return console.warn("No config for LHS ".concat(r)),{state:e};var S=O.type;"!group"!==S&&"!struct"!==S||(S=null);var T=null==m?void 0:m.get("operator"),_=null==m?void 0:m.get("operatorOptions"),w=null==m?void 0:m.get("field"),R="!group"==O.type,I=R&&"array"==O.mode,A=b!=R,C=O&&-1!==(null===(i=O.operators)||void 0===i?void 0:i.indexOf(T))?T:null,N="func"===E&&(null==w||null===(a=w.get)||void 0===a?void 0:a.call(w,"func"))===(null===(l=r)||void 0===l||null===(s=l.get)||void 0===s?void 0:s.call(l,"func"))&&!!C,L=null,j="func"===E?Jf(n,S):Zf(n,r);if(j&&1==j.length)L=j[0];else if(N)L=C;else if(j&&j.length>1){var x,P=Zy(h);try{for(P.s();!(x=P.n()).done;){var F=x.value;if("keep"!=F||A?"default"==F?L=Od(n,r,!1):"first"==F&&(L=ev(n,r)):L=C,L)break}}catch(e){P.e(e)}finally{P.f()}}if(!R&&!O.operators)return console.warn("Type ".concat(O.type," is not supported")),{state:e};b&&!R&&(e=(e=(e=e.setIn(gu(t,"type"),"rule")).deleteIn(gu(t,"children1"))).setIn(gu(t,"properties"),new Es.OrderedMap)),m||(e=e.setIn(gu(t,"properties"),new Es.OrderedMap));var D=!g;if(R){e=e.setIn(gu(t,"type"),"rule_group");var k=Bf(n,n,m,r,L,"field",D,d,p),M=(k.canReuseValue,k.newValue),V=k.newValueSrc,U=k.newValueType,B=k.operatorCardinality,G=Rd(n,O).merge({field:r,fieldSrc:"field",mode:O.mode});I&&(G=G.merge({operator:L,value:M,valueSrc:V,valueType:U})),e=(e=e.setIn(gu(t,"children1"),new Es.OrderedMap)).setIn(gu(t,"properties"),G),O.initialEmptyWhere&&1==B||(e=rm(e,t,"rule",Ss(),Td(n,r),n)),e=Eu(e)}else e=e.updateIn(gu(t,"properties"),(function(e){return e.withMutations((function(e){var t=Bf(n,n,e,r,L,"field",D,d,p),o=t.canReuseValue,i=t.newValue,a=t.newValueSrc,l=t.newValueType,s=t.newValueError,u=t.newFieldError,c=t.fixedField,f=r;c!==r&&(f=c),g&&(e=(e=e.set("fieldError",u)).set("valueError",s));var v=o?_:Sd(n,L,f);return e=e.set("field",f).delete("fieldType").set("fieldSrc",E).set("operator",L).set("operatorOptions",v).set("value",i).set("valueSrc",a).set("valueType",l),o||(e=e.delete("asyncListValues")),e}))}));return{state:e}},im=function(e,t,r,n,o,i,a){var l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(gu(t)))return{state:e};var s=l.canDropArgs,u=l.isEndValue,c=i.settings,d=c.fieldSeparator,p=c.showErrorMessage,f=e.getIn(gu(t,"properties","valueSrc",r+""))||null;"field"===f&&Array.isArray(n)&&(n=n.join(d));var v=e.getIn(gu(t,"properties","field"))||null,h=e.getIn(gu(t,"properties","operator"))||null,g=Kh(i,h,v),y=h?Cs(g):null,m=o||tv(n,f,i),b=Jn(Df(i,v,v,h,n,m,f,a,!p,u,s),2),E=b[0],O=b[1],S=null==O?void 0:O.find((function(e){return!e.fixed&&!e.ignore})),T=S?Ef(S):null,_=E!==n;_&&(n=E),e=am(e,t,i,y);var w=Array.from({length:y},(function(o,i){return i==r?n:e.getIn(gu(t,"properties","value",i+""))||null})),R=Array.from({length:y},(function(r,n){return e.getIn(gu(t,"properties","valueSrc",n+""))||null})),I=Uf(i,v,h,w,R),A=I?Ef(I):null;return(!!p||!T&&!A||_)&&(e=e.deleteIn(gu(t,"properties","asyncListValues")),void 0===n?e=(e=e.setIn(gu(t,"properties","value",r),void 0)).setIn(gu(t,"properties","valueType",r),null):(a&&(e=e.setIn(gu(t,"properties","asyncListValues"),a)),e=(e=e.setIn(gu(t,"properties","value",r),n)).setIn(gu(t,"properties","valueType",r),m))),p&&(e.getIn(gu(t,"properties","valueError"))||(e=e.setIn(gu(t,"properties","valueError"),new Es.List(new Array(y)))),e=e.setIn(gu(t,"properties","valueError",r),T),y>=2&&(e=e.setIn(gu(t,"properties","valueError",y),A))),{state:e}},am=function(e,t,r,n){if(!n){var o=e.getIn(gu(t,"properties","field"))||null,i=e.getIn(gu(t,"properties","operator"))||null,a=Kh(r,i,o);n=i?Cs(a):null}for(var l=0,s=["value","valueType","valueError","valueSrc"];l<s.length;l++){var u=s[l];e.getIn(gu(t,"properties",u))||(e=e.setIn(gu(t,"properties",u),new Es.List(n?Array.from({length:n}):[])))}return e},lm=function e(t,r,n){n&&Array.isArray(n)&&(r.children1=new Es.OrderedMap(n.reduce((function(r,n){var o,i=null!==(o=n.id)&&void 0!==o?o:Ss(),a=Jy(Jy({},n),{},{properties:Id(t,n).merge(ys(n.properties)||{}),id:i});return e(t,a,a.children1),Jy(Jy({},r),{},Hn({},i,new Es.Map(a)))}),{})))},sm={dragging:{id:null,x:null,y:null,w:null,h:null},mousePos:{},dragStart:{id:null}},um=function(e,t){return{type:Uy,tree:t,config:e}},cm=function(e,t,r){var n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;return{type:Ny,ruleType:arguments.length>3&&void 0!==arguments[3]?arguments[3]:"rule",children:arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,path:Ps(t),id:Ss(),properties:Td(e,n).merge(ys(r)||{}),config:e}},dm=function(e,t){return{type:Ly,path:Ps(t),config:e}},pm=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Ry,path:Ps(t),children:n,id:Ss(),properties:Rd(e).merge(ys(r)||{}),config:e,meta:{isDefaultCase:!0}}},fm=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:Ry,path:Ps(t),children:n,id:Ss(),properties:Rd(e).merge(ys(r)||{}),config:e}},vm=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:wy,path:Ps(t),children:n,id:Ss(),properties:Rd(e).merge(ys(r)||{}),config:e}},hm=function(e,t){return{type:Iy,path:Ps(t),config:e}},gm=function(e,t,r,n){return{type:By,fromPath:Ps(t),toPath:Ps(r),placement:n,config:e}},ym=function(e,t,r){return{type:Ay,path:Ps(t),conjunction:r}},mm=function(e,t,r){return{type:Cy,path:Ps(t),not:r}},bm=function(e,t,r){return{type:Vy,path:Ps(t),lock:r}},Em=function(e,t,r,n,o){return{type:jy,path:Ps(t),field:r,config:e,asyncListValues:n,_meta:o}},Om=function(e,t,r){return{type:xy,path:Ps(t),srcKey:r,config:e}},Sm=function(e,t,r){return{type:Py,path:Ps(t),operator:r,config:e}},Tm=function(e,t,r,n,o,i,a){return{type:Fy,path:Ps(t),delta:r,value:n,valueType:o,asyncListValues:i,config:e,_meta:a}},_m=function(e,t,r,n,o){return{type:Dy,path:Ps(t),delta:r,srcKey:n,config:e,_meta:o}},wm=function(e,t,r,n,o,i,a,l,s){return{type:ky,path:Ps(t),delta:r,parentFuncs:n,argKey:o,value:i,valueType:a,asyncListValues:l,config:e,_meta:s}},Rm=function(e,t,r,n){return{type:My,path:Ps(t),name:r,value:n,config:e}};function Im(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Am(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Im(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Im(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Cm=Am(Am(Am({},v),{},{Export:c,Import:o,ConfigMixins:Sy},c),o),Nm=p(7028),Lm=p.n(Nm);const jm=function(e,t,r,n,o){var i=Jy({tree:t},sm);return function(){var t,a,l=arguments.length>0&&void 0!==arguments[0]?arguments[0]:i,s=arguments.length>1?arguments[1]:void 0,u=null!==(t=null!==(a=null==o?void 0:o())&&void 0!==a?a:null==s?void 0:s.config)&&void 0!==t?t:e,c={},d=function(e,t){if(!e||!e.type)return null;var r,n=[Uy,Hy,zy,$y],o=Qy()(ru()(e,["config","asyncListValues"]),Fs),i=e.path&&function(e,t){return e.getIn(gu(t,"properties","field"))||null}(t.tree,e.path)||e.field;return i&&(null!==(r=i)&&void 0!==r&&r.toJS&&(i=i.toJS()),o.affectedField=i),(n.includes(e.type)||0==e.type.indexOf("@@redux"))&&(o=null),o}(s,l);switch(null==s?void 0:s.type){case Uy:var p=r(u,s.tree);c.tree=p;break;case Ry:c.tree=tm(l.tree,s.path,"case_group",s.id,s.properties,u,s.children,s.meta);break;case wy:c.tree=tm(l.tree,s.path,"group",s.id,s.properties,u,s.children,s.meta);break;case Iy:c.tree=function(e,t,r){if(!e.getIn(gu(t)))return e;e=nm(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.slice(0,-1);return Au(e,o)||n||(e=Ou(e),!Iu(e)||n)||(e=rm(e,new Es.List,"rule",Ss(),Td(r,void 0,void 0,!1,!1),r)),Eu(e)}(l.tree,s.path,u);break;case Ny:c.tree=rm(l.tree,s.path,s.ruleType,s.id,s.properties,u,s.children);break;case Ly:c.tree=function(e,t,r){if(!e.getIn(gu(t)))return e;e=nm(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.pop(),i=e.getIn(gu(o)),a=i.getIn(["properties","field"]),l=i.getIn(["properties","operator"]),s=a?qh(r,a):null,u=l?Kh(r,l,a):null,c=a&&l&&0!=u.cardinality,d="rule_group"==i.get("type"),p=!Au(e,o),f=d?c&&s.initialEmptyWhere:n;return p&&!f&&(d&&(e=e.deleteIn(gu(o))),e=Ou(e),Iu(e)&&!n)&&(e=rm(e,new Es.List,"rule",Ss(),Td(r,void 0,void 0,!1,!1),r)),Eu(e)}(l.tree,s.path,u);break;case Ay:c.tree=function(e,t,r){return e.getIn(gu(t))?e=e.setIn(gu(t,"properties","conjunction"),r):e}(l.tree,s.path,s.conjunction);break;case Cy:c.tree=function(e,t,r){return e.getIn(gu(t))?e=e.setIn(gu(t,"properties","not"),r):e}(l.tree,s.path,s.not);break;case jy:var f=om(l.tree,s.path,s.field,u,s.asyncListValues,s._meta).state;c.tree=f;break;case xy:c.tree=function(e,t,r,n){var o=e.getIn(gu(t));if(!o)return e;var i=n.settings.keepInputOnChangeFieldSrc,a=o.get("properties"),l=null==a?void 0:a.get("field"),s=null==a?void 0:a.get("fieldType"),u=qh(n,l),c=(null==u?void 0:u.type)||s;c&&"!group"!==c&&"!struct"!==c||(c=null);var d=!Xf.includes(c);return(e=i&&!pv(o,n)&&d?(e=(e=e.setIn(gu(t,"properties","field"),null)).deleteIn(gu(t,"properties","fieldError"))).setIn(gu(t,"properties","fieldType"),c):e.setIn(gu(t,"properties"),Td(n,null,null,!1))).setIn(gu(t,"properties","fieldSrc"),r)}(l.tree,s.path,s.srcKey,u);break;case Vy:c.tree=function(e,t,r){return e.getIn(gu(t))?e=bu(e.setIn(gu(t,"properties","isLocked"),r)):e}(l.tree,s.path,s.lock);break;case Py:c.tree=function(e,t,r,n){var o=e.getIn(gu(t));if(!o)return e;var i=n.settings.showErrorMessage,a=o.get("properties"),l=o.get("children1"),s=a.get("field"),u=(a.get("fieldSrc"),qh(n,s)),c="!group"==(null==u?void 0:u.type),d=Kh(n,r,s),p=d?Cs(d):null;return e=e.updateIn(gu(t,"properties"),(function(e){return e.withMutations((function(e){var t=e.get("field"),o=e.get("operatorOptions"),a=(e.get("value",new Es.List),e.get("valueSrc",new Es.List),e.get("operator"),Bf(n,n,e,t,r,"operator",!0)),l=a.canReuseValue,s=a.newValue,u=a.newValueSrc,c=a.newValueType,d=a.newValueError;i&&(e=e.set("valueError",d));var p=l?o:Sd(n,r,t);return l||(e=e.delete("asyncListValues")),e.set("operator",r).set("operatorOptions",p).set("value",s).set("valueSrc",u).set("valueType",c)}))})),c&&0==p&&0==l.size&&(e=rm(e,t,"rule",Ss(),Td(n,s),n)),e}(l.tree,s.path,s.operator,u);break;case Fy:var v=im(l.tree,s.path,s.delta,s.value,s.valueType,u,s.asyncListValues,s._meta).state;c.tree=v;break;case ky:var h=function(e,t,r,n,o,i,a,l,s){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:{},c=t.getIn(gu(r));if(!c)return t;var d,p=-1===n,f=c.get("properties"),v=f.get("field"),h=f.get("value"),g=[],y=p?v:h.getIn([n]),m=Zy(o||[]);try{for(m.s();!(d=m.n()).done;){var b=Jn(d.value,2),E=b[0],O=b[1];if(g.push([E,O,y]),E!==y.get("func")){var S=g.map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")||"root";throw new Error("In ".concat(p?"LHS":"RHS"," for path ").concat(S," expected func key ").concat(E," but got ").concat(parent.get("func")))}y=y.getIn(["args",O,"value"])}}catch(e){m.e(e)}finally{m.f()}if(i){var T=y.get("func"),_=xh(e,T).args[i];y="!valueSrc"===l?Yf(y,i,a,_,e):$f(y,i,a,_,e)}else y=Kf(y,a,e,!0),u.canDropArgs=!0;for(var w=y;g.length;){var R=Jn(g.pop(),3),I=R[0],A=R[1],C=R[2],N=xh(e,I).args[A];w=$f(C,A,w,N,e)}return p?om(t,r,w,e,s,u):im(t,r,n,w,void 0,e,s,u)}(u,l.tree,s.path,s.delta,s.parentFuncs,s.argKey,s.value,s.valueType,s.asyncListValues,s._meta),g=h.state;c.tree=g;break;case Dy:c.tree=function(e,t,r,n,o){if(!e.getIn(gu(t)))return e;var i=o.settings.showErrorMessage,a=e.getIn(gu(t,"properties","field"))||null,l=e.getIn(gu(t,"properties","operator"))||null,s=Kh(o,l,a),u=l?Cs(s):null;if(e=(e=(e=(e=am(e,t,o,u)).setIn(gu(t,"properties","value",r+""),void 0)).setIn(gu(t,"properties","valueType",r+""),null)).deleteIn(gu(t,"properties","asyncListValues")),i&&(e=e.setIn(gu(t,"properties","valueError",r),null),s.validateValues&&(e=e.setIn(gu(t,"properties","valueError",u),null))),e=void 0===n?e.setIn(gu(t,"properties","valueSrc",r+""),null):e.setIn(gu(t,"properties","valueSrc",r+""),n),n){var c=e.getIn(gu(t,"properties")),d=Bf(o,o,c,a,l,"valueSrc",!0),p=d.canReuseValue,f=d.newValue,v=d.newValueSrc,h=d.newValueType;d.newValueError,p||v.get(r)!=n||(e=(e=e.setIn(gu(t,"properties","value",r+""),f.get(r))).setIn(gu(t,"properties","valueType",r+""),h.get(r)))}return e}(l.tree,s.path,s.delta,s.srcKey,u,s._meta);break;case My:c.tree=function(e,t,r,n){return e.getIn(gu(t))?e.setIn(gu(t,"properties","operatorOptions",r),n):e}(l.tree,s.path,s.name,s.value);break;case By:c.tree=function(e,t,r,n,o){var i=mu(e,t),a=t.pop(),l=t.size>1?mu(e,a):null,s=l?l.get("children1"):null,u=mu(e,r),c=n==Ky||n==Wy?r:r.pop(),d=n==Ky||n==Wy?u:r.size>1?mu(e,c):null,p=d?d.get("children1"):null;if(!l||!d||!i)return e;var f=l.get("id")==d.get("id"),v=c.size<a.size&&Ns(c.toArray(),a.toArray().slice(0,c.size)),h=c.size>a.size&&Ns(a.toArray(),c.toArray().slice(0,a.size)),g=null,y=null;v?g=Es.List(a.toArray().slice(c.size)):h&&(y=Es.List(c.toArray().slice(a.size)));var m=p,b=s;return h||(b=b.delete(i.get("id"))),f?m=b:v&&(m=m.updateIn(yu(g,"children1"),(function(e){return b}))),n==qy||n==Gy?m=Es.OrderedMap().withMutations((function(e){var t,r=Zy(m.entries());try{for(r.s();!(t=r.n()).done;){var o=Jn(t.value,2),a=o[0],l=o[1];a==(null==u?void 0:u.get("id"))&&n==qy&&e.set(i.get("id"),i),e.set(a,l),a==(null==u?void 0:u.get("id"))&&n==Gy&&e.set(i.get("id"),i)}}catch(e){r.e(e)}finally{r.f()}})):n==Ky?m=m.merge(Es.OrderedMap(Hn({},i.get("id"),i))):n==Wy&&(m=Es.OrderedMap(Hn({},i.get("id"),i)).merge(m)),h&&(b=(b=b.updateIn(yu(y,"children1"),(function(e){return m}))).delete(i.get("id"))),f||v||(e=e.updateIn(gu(a,"children1"),(function(e){return b}))),h||(e=e.updateIn(gu(c,"children1"),(function(e){return m}))),Eu(e)}(l.tree,s.fromPath,s.toPath,s.placement);break;case Hy:c.dragStart=s.dragStart,c.dragging=s.dragging,c.mousePos=s.mousePos;break;case zy:c.mousePos=s.mousePos,c.dragging=s.dragging;break;case $y:c.tree=function(e,t){return t.settings.canLeaveEmptyGroup||(e=Ou(e)),e}(l.tree,u),c=Jy(Jy({},c),sm)}return d&&(c.__lastAction=d),n&&c.tree&&l.tree&&n(l.tree),Jy(Jy(Jy({},l),{__lastAction:void 0}),c)}},xm=ye().createContext();var Pm=p(7694),Fm=p(200),Dm="after",km="before",Mm="append",Vm="prepend",Um=function(e,t){return{type:"SET_DRAG_PROGRESS",mousePos:e,dragging:t}},Bm=function(e,t,r){return{type:"SET_DRAG_START",dragStart:e,dragging:t,mousePos:r}},Gm=function(){return{type:"SET_DRAG_END"}},qm=g,Km=y,Wm=m,zm=function(e,t,r){if(!t||!e||e.length<=t)return e;var n=e.substr(0,t-1);return(r?n.substr(0,n.lastIndexOf(" ")):n)+"..."},Hm=function(e,t){return e===t||(null==e?void 0:e.equals(t))},$m=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?$m(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):e&&"function"==typeof e.equals?e.equals(t):"object"===Vn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var l=n[a];if(!(r?$m(e[l],t[l],r):e[l]===t[l]))return!1}return!0}(e,t,r):e===t)},Ym=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}}(),Qm=Cm.Validation.validateAndFixTree,Xm=function e(t){if(t){var r,n=(r=t)._reactRootContainer?"root":Object.getOwnPropertyNames(r).filter((function(e){return e.startsWith("__reactContainer")})).length>0?"container":void 0;return void 0!==n?n:e(t.parentNode)}},Jm=function(e){return"root"===Xm(e)},Zm=function(e,t){return function(r,n){var o=e.props,i=e.state,a=r!=o||n!=i;if(a&&i==n&&o!=r){var l=[];for(var s in r){var u=r[s]!=o[s];u&&("ignore"==t[s]?u=!1:"shallow_deep"==t[s]?u=!$m(r[s],o[s],!0):"shallow"==t[s]?u=!$m(r[s],o[s]):"function"==typeof t[s]&&(u=t[s](r[s],o[s],r,o))),u&&l.push(s)}l.length||(a=!1)}return a}},eb=function(e){return function(t,r){return!$m(e.props,t)||!$m(e.state,r)}},tb=function(e){if(e.shouldComponentUpdate||(e.shouldComponentUpdate=eb(e)),16==(r=ye().version.split(".").map(parseInt.bind(null,10)))[0]&&r[1]<3||r[0]<16)e.componentWillReceiveProps=function(t){e.onPropsChanged(t)};else{var t=e.shouldComponentUpdate;e.shouldComponentUpdate=function(r,n){return!$m(e.props,r)&&e.onPropsChanged(r),t.call(e,r,n)}.bind(e)}var r},rb=function(e,t,r){return Qy()(e,(function(e){return function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return r(e.apply(void 0,[t].concat(o)))}}))};function nb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function ob(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?nb(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):nb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function ib(e,t,r){return t=Kn(t),qn(e,ab()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function ab(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(ab=function(){return!!e})()}var lb=function(e){function t(e){var r;Mn(this,t),(r=ib(this,t,[e])).shouldComponentUpdate=Zm(r,{tree:function(e){return e!==r.oldValidatedTree||r.oldValidatedTree!==r.validatedTree}}),tb(r),r._updateActions(e),r.validatedTree=e.getMemoizedTree(e.config,e.tree,void 0,e.sanitizeTree),r.oldValidatedTree=r.validatedTree;var n=e.getBasicConfig(e.config);return e.onInit&&e.onInit(r.validatedTree,n,void 0,r.actions),r}return zn(t,e),Gn(t,[{key:"_updateActions",value:function(e){var t=e.config,r=e.dispatch;this.actions=rb(ob(ob(ob({},qm),Km),Wm),t,r)}},{key:"onPropsChanged",value:function(e){var t=e.onChange,r=this.props.config,n=e.tree,o=(this.props.tree,e.config);if(this.oldValidatedTree=this.validatedTree,this.validatedTree=n,r!==o&&(this._updateActions(e),this.validatedTree=e.getMemoizedTree(o,n,r)),!Hm(this.validatedTree,this.oldValidatedTree)){var i=e.getBasicConfig(o);t&&t(this.validatedTree,i,e.__lastAction,this.actions)}}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.renderBuilder,n=e.dispatch;return r({tree:this.validatedTree,actions:this.actions,config:t,dispatch:n})}}])}(ge.Component);lb.propTypes={config:Lm().object.isRequired,onChange:Lm().func,onInit:Lm().func,renderBuilder:Lm().func,tree:Lm().any};var sb=(0,Fm.connect)((function(e){return{tree:e.tree,__lastAction:e.__lastAction}}),null,null,{context:xm})(lb);sb.displayName="ConnectedQuery";const ub=sb;function cb(e,t,r){return t=Kn(t),qn(e,db()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function db(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(db=function(){return!!e})()}var pb=Cm.DefaultUtils.defaultRoot,fb=Cm.ConfigUtils.createConfigMemo,vb=function(e){function t(e,r){var n,o,i;Mn(this,t),(i=cb(this,t,[e,r])).setLastTree=function(e){i.prevTree&&(i.prevprevTree=i.prevTree),i.prevTree=e},i.getConfig=function(){return i.config},i.shouldComponentUpdate=Zm(i,{value:function(e,t){return!1}}),tb(i);var a=fb({reactIndex:null!==(n=null===(o=i._reactInternals)||void 0===o?void 0:o.index)&&void 0!==n?n:-1,maxSize:2,canCompile:!0}),l=a.getExtendedConfig,s=a.getBasicConfig,u=a.clearConfigMemo;i.getMemoizedConfig=l,i.getBasicConfig=s,i.clearConfigMemo=u,i.getMemoizedTree=function(){var e,t,r;return function(n,o){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return o?n.__configId===r&&(Hm(o,e)||Hm(o,t))?t:(r=n.__configId,e=o,t=!1===a?Qm(o,null,n,i||n,!1,!1,!1):Qm(o,null,n,i||n)):null}}();var c=i.getMemoizedConfig(e),d=c.settings.shouldCreateEmptyGroup,p=pb(c,!d),f=!!e.value,v=e.value||p,h=i.getMemoizedTree(c,v,void 0,f),g=jm(c,h,i.getMemoizedTree,i.setLastTree,i.getConfig),y=(0,Pm.createStore)(g);return i.config=c,i.state={store:y},i.QueryWrapper=function(e){return c.settings.renderProvider(e,c.ctx)},i}return zn(t,e),Gn(t,[{key:"componentWillUnmount",value:function(){this.clearConfigMemo()}},{key:"onPropsChanged",value:function(e){var t=this.props,r=this.config,n=this.getMemoizedConfig(e),o=r!==n,i=this.state.store.getState().tree,a=!Hm(e.value,this.props.value)&&!Hm(e.value,i),l=a?e.value||pb(e):i,s=a&&!Hm(e.value,this.prevTree)&&!Hm(e.value,this.prevprevTree);if(this.sanitizeTree=s||o,o&&(t.settings.renderProvider!==e.settings.renderProvider&&(this.QueryWrapper=function(e){return n.settings.renderProvider(e,n.ctx)}),this.config=n),a||o){var u=this.getMemoizedTree(n,l,r,this.sanitizeTree);this.state.store.dispatch(qm.setTree(n,u))}}},{key:"render",value:function(){var e=this.props,t=e.renderBuilder,r=e.get_children,n=e.onChange,o=e.onInit,i=this.state.store,a=this.config,l=this.QueryWrapper;return ye().createElement(l,{config:a},ye().createElement(Fm.Provider,{store:i,context:xm},ye().createElement(ub,{config:a,getMemoizedTree:this.getMemoizedTree,getBasicConfig:this.getBasicConfig,sanitizeTree:this.sanitizeTree,onChange:n,onInit:o,renderBuilder:t||r})))}}])}(ge.Component);function hb(){return hb=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)({}).hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},hb.apply(null,arguments)}vb.propTypes={conjunctions:Lm().object.isRequired,fields:Lm().object.isRequired,types:Lm().object.isRequired,operators:Lm().object.isRequired,widgets:Lm().object.isRequired,settings:Lm().object.isRequired,ctx:Lm().object.isRequired,onChange:Lm().func,onInit:Lm().func,renderBuilder:Lm().func,value:Lm().any};var gb=p(2584),yb=p.n(gb);function mb(e,t,r){return t=Kn(t),qn(e,bb()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function bb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(bb=function(){return!!e})()}var Eb=Cm.ConfigUtils.getFieldConfig;function Ob(e,t,r){return t=Kn(t),qn(e,Sb()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function Sb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Sb=function(){return!!e})()}var Tb=Cm.clone,_b=Cm.TreeUtils.getFlatTree,wb=!1,Rb=["isDraggingTempo","isDraggingMe","dragging"];function Ib(e,t,r){return t=Kn(t),qn(e,Ab()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function Ab(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Ab=function(){return!!e})()}const Cb=function(e){return function(t){var r;return r=function(r){function n(e){var t;return Mn(this,n),(t=Ib(this,n,[e])).handleDraggerMouseDown=function(e){var r=t.props.id,n=t.wrapper.current;t.props.onDragStart&&t.props.onDragStart(r,n,e)},t.wrapper=ye().createRef(),t}return zn(n,r),Gn(n,[{key:"render",value:function(){var r=this.props,n=r.isDraggingTempo,o=r.isDraggingMe,i=r.dragging,a=Wg(r,Rb),l=a.isTrueLocked,s={};o&&n&&(wb||(s={top:i.y,left:i.x,width:i.w}));var u=yb()(e,"group-or-rule",o&&n?"qb-draggable":null,o&&!n?"qb-placeholder":null,l?"locked":null);return ye().createElement("div",{className:u,style:s,ref:this.wrapper,"data-id":this.props.id},ye().createElement(t,hb({handleDraggerMouseDown:this.handleDraggerMouseDown,isDraggingMe:o,isDraggingTempo:n},a)))}}])}(ge.PureComponent),r.propTypes={isDraggingTempo:Lm().bool,isDraggingMe:Lm().bool,onDragStart:Lm().func,dragging:Lm().object,isLocked:Lm().bool,isTrueLocked:Lm().bool},r}};var Nb=p(3790),Lb=p.n(Nb),jb=p(350),xb=p.n(jb);function Pb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Fb(e,t,r){return t=Kn(t),qn(e,Db()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function Db(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Db=function(){return!!e})()}var kb=Cm.ConfigUtils,Mb=kb.getFieldConfig,Vb=kb.getOperatorConfig,Ub=function(e){function t(e){var r;return Mn(this,t),(r=Fb(this,t,[e])).shouldComponentUpdate=Zm(r,{selectedField:function(e,t){return!1}}),tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","selectedField","selectedFieldSrc","selectedFieldType","selectedOperator"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.selectedField,o=e.selectedFieldType,i=e.selectedOperator,a=Mb(r,n),l=eo((null==a?void 0:a.operators)||(null===(t=r.types[o])||void 0===t?void 0:t.operators)||[]);n||l.includes(i)||l.push(i);var s=Qy()(xb()(r.operators,(function(e,t){return-1!==(null==l?void 0:l.indexOf(t))})),(function(e,t){return Vb(r,t,n)})),u=this.buildOptions(r,s,l),c=s[i]||{},d=i?[i]:null;return{placeholder:this.props.config.settings.operatorPlaceholder,items:u,selectedKey:i,selectedKeys:d,selectedPath:d,selectedLabel:c.label,selectedAltLabel:c.label2||c.tooltip,selectedOpts:c,fieldConfig:a}}},{key:"buildOptions",value:function(e,t,r){return t&&r?Lb()(t).sort((function(e,t){return r.indexOf(e)-r.indexOf(t)})).map((function(e){var r=t[e];return{key:e,path:e,label:r.label,altLabel:r.label2,tooltip:r.tooltip}})):null}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setOperator,o=e.readonly,i=e.id,a=e.groupId,l=t.settings.renderOperator,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Pb(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Pb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:n},this.meta);return s.items?l(s,t.ctx):null}}])}(ge.Component);Ub.propTypes={id:Lm().string,groupId:Lm().string,config:Lm().object.isRequired,selectedField:Lm().any,selectedFieldId:Lm().string,selectedFieldType:Lm().string,selectedFieldSrc:Lm().string,selectedOperator:Lm().string,readonly:Lm().bool,customProps:Lm().object,setOperator:Lm().func.isRequired};var Bb=["children"],Gb=function(e){var t=e.children,r=Wg(e,Bb);return ye().createElement("div",r,t)},qb=function(){},Kb=function(){return ye().createElement("svg",{xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",width:"18px",height:"18px"},ye().createElement("path",{d:"M0 0h24v24H0V0z",fill:"none"}),ye().createElement("path",{d:"M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"}))},Wb=function(e){return function(t){var r=t.config.settings.useConfirm,n=r?r.call(t.config.ctx,t.config.ctx):null;return ye().createElement(e,hb({},t,{confirmFn:n}))}},zb=function(e){var t=e.id,r=e.isLHS,n=e.delta;return[t,r?"L":"R",r?-1:n||0,(e.parentFuncs||[]).map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")].join(":")},Hb=function(e,t){var r;return"function"==typeof t?(r=function(r){return null==t?void 0:t(r,e.ctx)}).displayName=t.name:r=t,r};function $b(e,t,r){return t=Kn(t),qn(e,Yb()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function Yb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Yb=function(){return!!e})()}var Qb=function(e){function t(){return Mn(this,t),$b(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.setOperator,l=e.selectedFieldId,s=e.showOperator,u=e.showOperatorLabel,c=e.selectedFieldWidgetConfig,d=e.readonly,p=e.id,f=e.groupId;return[s&&ye().createElement(Gb,{key:"operators-for-"+l,className:"rule--operator"},t.settings.showLabels&&ye().createElement("label",{className:"rule--label"},t.settings.operatorLabel),ye().createElement(Ub,{key:"operator",config:t,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,selectedFieldId:l,selectedOperator:i,setOperator:a,customProps:t.settings.customOperatorSelectProps,readonly:d,id:p,groupId:f})),u&&ye().createElement(Gb,{key:"operators-for-"+l,className:"rule--operator"},ye().createElement("div",{className:"rule--operator-wrapper"},t.settings.showLabels?ye().createElement("label",{className:"rule--label"}," "):null,ye().createElement("div",{className:"rule--operator-text-wrapper"},ye().createElement("span",{className:"rule--operator-text"},c.operatorInlineLabel))))]}}])}(ge.PureComponent);function Xb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Jb(e,t,r){return t=Kn(t),qn(e,Zb()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function Zb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Zb=function(){return!!e})()}var eE=Cm.RuleUtils.getFieldPathLabels,tE=Cm.ConfigUtils,rE=tE.getFieldConfig,nE=tE.getFieldParts,oE=tE.getFieldPathParts,iE=function(e){function t(e){var r;return Mn(this,t),(r=Jb(this,t,[e])).setField=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=r.props.id;if(!n.widgetId){var i=[o,"L",-1].join(":");n.widgetId=i}r.props.setField(e,t,n)},tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","config","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.config,o=e.parentField,i=t,a=n.settings,l=a.maxLabelsLength,s=a.fieldSeparatorDisplay,u=a.fieldPlaceholder,c=(a.fieldSeparator,!!t),d=c?null:zm(u,l),p=c?rE(n,i):null,f=p||{},v=oE(i,n),h=oE(i,n,!0),g=this.getFieldLabel(p,i,n),y=eE(i,n),m=y?y.join(s):null;(m==g||o)&&(m=null);var b=f.label2||f.tooltip,E=nE(o,n),O=o?rE(n,o):null,S=o?O&&O.subfields:n.fields,T=!c&&r,_=this.buildOptions(E,n,S,T,E),w=T?"Please select field":null;return i&&"object"===Vn(i)&&(i=void 0),{placeholder:d,items:_,parentField:o,selectedKey:i,selectedKeys:v,selectedPath:h,selectedLabel:g,selectedOpts:f,selectedAltLabel:b,selectedFullLabel:m,errorText:w}}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=nE(t,r),i=(null==e?void 0:e.label)||eu()(o);return zm(i,n)}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(!r)return null;var l=t.settings,s=l.fieldSeparator,u=l.fieldSeparatorDisplay,c=null!=i&&i.length?i.join(s)+s:"",d=function e(t){return Object.keys(t||{}).reduce((function(r,n){var i=t[n];return"!struct"===i.type?r+e(i.subfields):r+(i.type===o?1:0)}),0)};return Lb()(r).map((function(l){var s=[].concat(eo(null!=i?i:[]),[l]),p=r[l],f=n.getFieldLabel(p,s,t),v=eE(s,t).join(u);(v==f||null!=e&&e.length)&&(v=null);var h=p.label2,g=p.tooltip,y=p.disabled;if(!p.hideForSelect){if("!struct"==p.type){var m=n.buildOptions(e,t,p.subfields,o,s,{label:f,tooltip:g}),b=d(p.subfields)>0;return{disabled:y,key:l,path:c+l,label:f,fullLabel:v,altLabel:h,tooltip:g,items:m,matchesType:b}}var E=void 0!==o?p.type===o:void 0;return{disabled:y,key:l,path:c+l,label:f,fullLabel:v,altLabel:h,tooltip:g,grouplabel:null==a?void 0:a.label,group:a,matchesType:E}}})).filter((function(e){return!!e}))}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setFieldSrc,o=e.readonly,i=e.id,a=e.groupId,l=t.settings.renderField,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Xb(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Xb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:this.setField,setFieldSrc:n},this.meta);return l(s,t.ctx)}}])}(ge.Component);function aE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function lE(e,t,r){return t=Kn(t),qn(e,sE()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function sE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(sE=function(){return!!e})()}iE.propTypes={id:Lm().string,groupId:Lm().string,config:Lm().object.isRequired,selectedField:Lm().any,selectedFieldSrc:Lm().string,selectedFieldType:Lm().string,parentField:Lm().string,customProps:Lm().object,readonly:Lm().bool,setField:Lm().func.isRequired,setFieldSrc:Lm().func};var uE=Cm.clone,cE=Cm.ConfigUtils,dE=cE.getFieldConfig,pE=cE.getFuncConfig,fE=cE.getFieldParts,vE=cE.getFieldPathParts,hE=Cm.RuleUtils,gE=hE.getFuncPathLabels,yE=hE.getWidgetForFieldOp,mE=Cm.OtherUtils.shallowEqual,bE=function(e){function t(e){var r;return Mn(this,t),r=lE(this,t,[e]),tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldType","fieldSrc","operator","isFuncArg","isLHS","parentFuncs"].map((function(r){return"parentFuncs"===r?!mE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0;(!this.meta||["config","field","fieldType","fieldSrc","value","isLHS"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r&&(this.items=this.getItems(e,this.meta))}},{key:"getItems",value:function(e,t){var r=e.config,n=e.field,o=e.fieldType,i=e.isLHS,a=e.operator,l=e.parentFuncs,s=e.fieldDefinition,u=e.isFuncArg,c=t.lookingForFieldType,d=r.settings.canUseFuncForField,p=this.filterFuncs(r,r.funcs,n,o,i,a,d,l,u,s);return this.buildOptions(r,p,c)}},{key:"getMeta",value:function(e){var t=e.config,r=(e._field,e.fieldType),n=e.value,o=e.isLHS,i=e.isFuncArg,a=t.settings,l=a.funcPlaceholder,s=a.fieldSeparatorDisplay,u=n,c=!!n,d=c?null:l,p=c?pE(t,u):null,f=p||{},v=vE(u,t),h=vE(u,t,!0),g=this.getFuncLabel(p,u,t),y=gE(u,t),m=y?y.join(s):null;m==g&&(m=null);var b=o&&!i&&!c&&r;return{placeholder:d,selectedKey:u,selectedKeys:v,selectedPath:h,selectedLabel:g,selectedOpts:f,selectedFullLabel:m,errorText:b?"Please select function":null,lookingForFieldType:b}}},{key:"filterFuncs",value:function(e,t,r,n,o,i,a,l,s,u){t=uE(t);var c,d=e.settings.fieldSeparator,p=dE(e,r),f=p,v=yE(e,r,i,"value");return v&&e.widgets[v],s?(f=u,c=null==u?void 0:u.type):p?c=p.type:o||(c=n),function t(n,o){for(var s in n){var u=n[s].subfields,v=(o||[]).concat(s),h=v.join(d),g=pE(e,h);if("!struct"==g.type)0==t(u,v)&&delete n[s];else{var y,m=!c||g.returnType==c;null!==(y=f)&&void 0!==y&&y.funcs&&(m=m&&f.funcs.includes(h)),a&&(m=m&&a(r,p,h,g,i)),!g.allowSelfNesting&&l&&l.map((function(e){var t=Jn(e,2),r=t[0];return t[1],r})).includes(h)&&(m=!1),m||delete n[s]}}return Lb()(n).length}(t,[]),t}},{key:"buildOptions",value:function(e,t){var r=this,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!t)return null;var a=e.settings,l=a.fieldSeparator,s=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(l)+l:"",c=function e(t){return Object.keys(t||{}).reduce((function(r,o){var i=t[o];return"!struct"===i.type?r+e(i.subfields):r+(i.type===n?1:0)}),0)};return Lb()(t).map((function(a){var l=[].concat(eo(null!=o?o:[]),[a]),d=t[a],p=r.getFuncLabel(d,l,e),f=gE(l,e).join(s);f==p&&(f=null);var v=d.tooltip;if("!struct"==d.type){var h=r.buildOptions(e,d.subfields,n,l,{label:p,tooltip:v}),g=c(d.subfields)>0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:v,items:h,matchesType:g}}var y=void 0!==n?d.returnType===n:void 0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:v,grouplabel:null==i?void 0:i.label,group:i,matchesType:y}}))}},{key:"getFuncLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=fE(t,r),i=(null==e?void 0:e.label)||eu()(o);return zm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,l=t.settings.renderFunc,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?aE(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):aE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,readonly:o,setField:n,items:this.items,id:i,groupId:a},this.meta);return l(s,t.ctx)}}])}(ge.Component);bE.propTypes={id:Lm().string,groupId:Lm().string,config:Lm().object.isRequired,field:Lm().any,fieldType:Lm().string,fieldSrc:Lm().string,operator:Lm().string,customProps:Lm().object,value:Lm().string,setValue:Lm().func.isRequired,readonly:Lm().bool,parentFuncs:Lm().array,fieldDefinition:Lm().object,isFuncArg:Lm().bool,isLHS:Lm().bool};var EE=p(2285),OE=p.n(EE),SE=["widgetFactory"],TE=["factory"];function _E(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function wE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_E(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_E(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var RE=Cm.ListUtils.getTitleInListValues,IE=Cm.ConfigUtils._widgetDefKeysToOmit,AE=Cm.TreeUtils,CE=AE._fixImmutableValue,NE=AE.isImmutable,LE=(0,ge.memo)((function(e){var t=e.widgetFactory,r=Wg(e,SE),n=r.config,o=r.isFuncArg,i=r.fieldDefinition||{},a=i.fieldSettings,l=i.defaultValue,s=i.valueSources,u=o&&1==(null==s?void 0:s.length)&&"const"===(null==s?void 0:s[0]),c=(null==a?void 0:a.treeValues)||(null==a?void 0:a.listValues);return u&&l?"boolean"==typeof l?l?r.labelYes||"YES":r.labelNo||"NO":c?Array.isArray(l)?l.map((function(e){return RE(c,e)||e})).join(", "):RE(c,l)||l:""+l:t?t(r,n.ctx):"?"}));LE.displayName="WidgetFactoryMemo";var jE=function(e){var t=e.delta,r=e.isFuncArg,n=e.valueSrc,o=e.value,i=e.valueError,a=e.fieldError,l=e.asyncListValues,s=e.isSpecialRange,u=e.fieldDefinition,c=e.widget,d=e.widgetDefinition,p=e.widgetValueLabel,f=e.valueLabels,v=e.textSeparators,h=e.setValue,g=e.setFuncValue,y=e.config,m=e.field,b=e.fieldSrc,E=e.fieldPath,O=e.fieldType,S=e.isLHS,T=e.operator,_=e.readonly,w=e.parentField,R=e.parentFuncs,I=e.id,A=e.groupId,C=e.widgetId,N=d.factory,L=Wg(d,TE),j=o?o.map((function(e){return CE(e)})):void 0,x=(0,ge.useMemo)((function(){if(s){var e=[null==j?void 0:j.get(0),null==j?void 0:j.get(1)];return void 0===e[0]&&void 0===e[1]&&(e=void 0),e}return null==j?void 0:j.get(t)}),[s,o]),P=(0,ge.useMemo)((function(){return i?s?[i.get(0),i.get(1),i.get(2)]:null==i?void 0:i.get(t):null}),[s,o]),F=S?a:P,D=(u||{}).fieldSettings,k=p.label,M=p.placeholder,V=f?f.placeholder:null,U=NE(m)?null:m,B=ru()(wE(wE(wE({},L),D),{},{config:y,field:U,fieldPath:E,fieldSrc:b,fieldType:O,isLHS:S,parentField:w,parentFuncs:R,fieldDefinition:u,operator:T,delta:t,isSpecialRange:s,isFuncArg:r,value:x,valueSrc:n,valueError:P,fieldError:a,errorMessage:F,label:k,placeholder:M,placeholders:V,textSeparators:v,setValue:h,setFuncValue:g,readonly:_,asyncListValues:l,id:I,groupId:A,widgetId:C,widgetFactory:N,widget:c}),[].concat(eo(IE),["toJS"]));return ye().createElement(LE,hb({widgetFactory:N},B))};jE.displayName="WidgetFactory";const xE=jE;function PE(e,t,r){return t=Kn(t),qn(e,FE()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function FE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(FE=function(){return!!e})()}var DE=Cm.ConfigUtils,kE=DE.getFieldConfig,ME=DE.getOperatorConfig,VE=DE.getFieldWidgetConfig,UE=Cm.RuleUtils,BE=UE.getValueSourcesForFieldOp,GE=UE.getWidgetForFieldOp,qE=UE.getValueLabel,KE=Cm.DefaultUtils.createListWithOneElement,WE=Cm.OtherUtils.shallowEqual,zE=(Cm.TreeUtils.isImmutable,{cardinality:1}),HE=function(e){function t(e){var r;return Mn(this,t),(r=PE(this,t,[e]))._setValue=function(e,t,n,o,i,a){var l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:{};if(l.widgetId||(l.widgetId=o),e&&Array.isArray(i)){var s=[r.props.value.get(0),r.props.value.get(1)];s[0]!=i[0]&&r.props.setValue(0,i[0],n,a,l),s[1]!=i[1]&&r.props.setValue(1,i[1],n,a,l)}else r.props.setValue(t,i,n,a,l)},r._setValueSrc=function(e,t,n){var o={widgetId:t};r.props.setValueSrc(e,n,o)},r.renderWidget=function(e,t,r){var n=r.config,o=r.isFuncArg,i=r.leftField,a=r.operator,l=r.value,s=r.valueError,u=r.fieldError,c=r.readonly,d=r.parentField,p=r.parentFuncs,f=r.id,v=r.groupId,h=r.fieldSrc,g=r.fieldType,y=r.isLHS,m=r.setFuncValue,b=n.settings,E=t.widgets,O=t.iValues,S=t.aField,T=t.valueSources,_=o?O:l,w=o?i:S,R=E[e],I=R.valueSrc,A=R.valueLabel,C=R.widgetId,N=T.length>1&&!c,L=b.showLabels?ye().createElement("label",{key:"label-"+C,className:"rule--label"},A.label):null;return ye().createElement("div",{key:"wrapper-"+C,className:yb()("func"===I?"widget--func":"widget--widget",N?"widget--has-valuerscs":"widget--has-no-valuerscs")},"func"===I?null:L,ye().createElement(xE,hb({key:C,id:f,groupId:v,widgetId:C,valueSrc:I,delta:e,value:_,valueError:s,fieldError:u,isFuncArg:o,isLHS:y},Js()(t,["isSpecialRange","fieldDefinition","asyncListValues"]),Js()(E[e],["widget","widgetDefinition","widgetValueLabel","valueLabels","textSeparators","setValue"]),{setFuncValue:m,config:n,field:w,fieldSrc:h,fieldType:g,parentField:d,parentFuncs:p,operator:a,readonly:c})))},r.renderValueSources=function(e,t,n){var o=n.config,i=n.isFuncArg,a=n.leftField,l=n.operator,s=n.readonly,u=o.settings,c=t.valueSources,d=t.widgets,p=t.aField,f=t.valueSourcesOptions,v=i?a:p,h=d[e],g=h.valueSrc,y=h.setValueSrc,m=r.ValueSources,b=u.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return c.length>1&&!s&&ye().createElement("div",{key:"wrapper-valuesrc-"+e,className:"widget--valuesrc"},b,ye().createElement(m,{key:"valuesrc-"+e,delta:e,valueSources:f,valueSrc:g,config:o,field:v,operator:l,setValueSrc:y,readonly:s,title:u.valueSourcesPopupTitle}))},r.renderSep=function(e,t,r){var n=r.config,o=t.widgets,i=n.settings,a=o[e].sepText,l=i.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return a&&ye().createElement("div",{key:"widget-separators-"+e,className:yb()("widget--sep",0==e&&"widget--sep-first")},l,ye().createElement("span",null,a))},r.renderWidgetDelta=function(e){return[r.renderSep(e,r.meta,r.props),r.renderValueSources(e,r.meta,r.props),r.renderWidget(e,r.meta,r.props)]},tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config),n=["config","id","parentFuncs","field","fieldId","fieldSrc","fieldType","fieldFunc","fieldArg","leftField","operator","valueSrc","asyncListValues","isLHS","isFuncArg","isForRuleGroup","isCaseValue","value"].filter((function(r){return"parentFuncs"===r?!WE(e[r],t[r],!0):"field"===r?e.fieldId!==t.fieldId:e[r]!==t[r]}));if((!this.meta||n.length>0)&&(this.meta=this.getMeta(e,n)),r){var o=e.config,i=o.settings.renderValueSources;this.ValueSources=Hb(o,i)}}},{key:"getMeta",value:function(e){var t,r,n,o,i=this,a=e.config,l=e.field,s=(e.fieldSrc,e.fieldType),u=e.fieldFunc,c=e.fieldArg,d=e.operator,p=e.valueSrc,f=e.value,v=e.isForRuleGroup,h=e.isCaseValue,g=e.isFuncArg,y=(e.leftField,e.asyncListValues),m=e.parentFuncs,b=e.isLHS,E=e.id,O=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],S=a.settings.valueSourcesInfo,T=g?{func:u,arg:c}:l,_=!l&&s,w=p,R=f;(g||v||h)&&(w=KE(p),R=KE(f));var I=kE(a,T);!I&&_&&(I=a.types[s]);var A,C=GE(a,T,d);!C&&_&&(C=null===(A=a.types[s])||void 0===A?void 0:A.mainWidget);var N=g?zE:ME(a,d,T);if((null==I||null==N)&&!h)return null;var L,j,x=null==N?void 0:N.isSpecialRange,P=x&&("field"===(null===(t=w)||void 0===t?void 0:t.get(0))||"field"===(null===(r=w)||void 0===r?void 0:r.get(1))),F=x&&!P,D=F?1:null!==(j=null==(L=N)?void 0:L.cardinality)&&void 0!==j?j:1;if(0===D)return null;var k=null===(n=this.meta)||void 0===n?void 0:n.valueSources,M=null===(o=this.meta)||void 0===o?void 0:o.valueSourcesOptions;k&&!["field","operator","config","fieldDefinition","isForRuleGroup"].filter((function(e){return O.includes(e)})).length||(k=BE(a,T,d,I),v&&(k=["value"]),T||(k=Object.keys(S)),M=k.map((function(e){return[e,{label:S[e].label}]})));var V=OE()(0,D).map((function(e){var t,r,n,o,l=null===(t=i.meta)||void 0===t||null===(t=t.widgets)||void 0===t?void 0:t[e],s=(null===(r=w)||void 0===r?void 0:r.get(e))||null,u=GE(a,T,d,s),c=VE(a,T,d,u,s);P&&(u=c.singleWidget,c=VE(a,T,d,u,s)),!c&&_&&(u=["func","field"].includes(s)?s:C,c=a.widgets[u]);var p=null===(n=c)||void 0===n?void 0:n.type,f=qE(a,T,d,e,s,F),v=qE(a,T,d,e,null,F),h=null!=N&&N.textSeparators?null==N?void 0:N.textSeparators[e]:null,g=null,y=null;x&&(g={placeholder:[(g=[qE(a,T,d,0),qE(a,T,d,1)])[0].placeholder,g[1].placeholder],label:[g[0].label,g[1].label]},y=null==N?void 0:N.textSeparators);var O=zb({id:E,isLHS:b,delta:e,parentFuncs:m}),S=O+":VS",R=null==l?void 0:l.setValueSrc;R&&(null==l?void 0:l.widgetId)===O||(R=i._setValueSrc.bind(i,e,S));var I=null==l?void 0:l.setValue;return I&&(null==l?void 0:l.widgetId)===O&&(null==l?void 0:l.widgetType)===p&&(null===(o=i.meta)||void 0===o?void 0:o.isSpecialRange)===x||(I=i._setValue.bind(i,x,e,p,O)),{valueSrc:s,valueLabel:f,widget:u,sepText:h,widgetDefinition:c,widgetValueLabel:v,valueLabels:g,textSeparators:y,setValueSrc:R,setValue:I,widgetId:O,widgetType:p}}));return{defaultWidget:C,fieldDefinition:I,operatorDefinition:N,isSpecialRange:F,cardinality:D,valueSources:k,valueSourcesOptions:M,widgets:V,iValues:R,aField:T,asyncListValues:y}}},{key:"render",value:function(){if(!this.meta)return null;var e=this.meta,t=e.defaultWidget,r=e.cardinality;if(!t)return null;var n=t;return ye().createElement(Gb,{className:"rule--widget rule--widget--".concat(n.toUpperCase()),key:"widget-col-"+n},OE()(0,r).map(this.renderWidgetDelta))}}])}(ge.Component);function $E(e,t,r){return t=Kn(t),qn(e,YE()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function YE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(YE=function(){return!!e})()}HE.propTypes={config:Lm().object.isRequired,value:Lm().any,valueSrc:Lm().any,valueError:Lm().any,fieldError:Lm().string,field:Lm().any,fieldSrc:Lm().string,fieldType:Lm().string,fieldId:Lm().string,operator:Lm().string,readonly:Lm().bool,asyncListValues:Lm().array,id:Lm().string,groupId:Lm().string,setValue:Lm().func,setValueSrc:Lm().func,setFuncValue:Lm().func,isFuncArg:Lm().bool,fieldFunc:Lm().string,fieldArg:Lm().string,leftField:Lm().any,isForRuleGroup:Lm().bool,parentField:Lm().string,parentFuncs:Lm().array,isLHS:Lm().bool,isCaseValue:Lm().bool};var QE=Cm.ConfigUtils.getFuncConfig,XE=Cm.OtherUtils.shallowEqual,JE=function(e){function t(e){var r;return Mn(this,t),(r=$E(this,t,[e])).setFunc=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=r.props,o=n.isLHS,i=n.delta,a=n.parentFuncs,l=n.id;if(!t.widgetId){var s=zb({id:l,isLHS:o,delta:i,parentFuncs:a});t.widgetId=s}r.props.setFuncValue(o?-1:i||0,a,null,e,"!func",void 0,t)},r.setArgValue=function(e,t,n,o,i){var a=r.props,l=(a.config,a.delta),s=a.isLHS,u=a.parentFuncs;r.props.setFuncValue(s?-1:l||0,u,e,t,n,o,i)},r.setArgValueSrc=function(e,t,n){var o=r.props,i=(o.config,o.delta),a=o.isLHS,l=o.parentFuncs;r.props.setFuncValue(a?-1:i||0,l,e,t,"!valueSrc",void 0,n)},r.renderFuncSelect=function(){var e,t,n=r.props,o=n.config,i=n.field,a=n.fieldType,l=n.fieldSrc,s=n.isLHS,u=n.operator,c=n.customProps,d=n.value,p=n.readonly,f=n.parentFuncs,v=n.id,h=n.groupId,g=n.isFuncArg,y=n.fieldDefinition,m={value:null!==(e=null==d||null===(t=d.get)||void 0===t?void 0:t.call(d,"func"))&&void 0!==e?e:null,setValue:r.setFunc,config:o,field:i,fieldType:a,fieldSrc:l,isLHS:s,operator:u,customProps:c,readonly:p,parentFuncs:f,isFuncArg:g,fieldDefinition:y,id:v,groupId:h},b=o.settings,E=b.showLabels,O=b.funcLabel,S=E?ye().createElement("label",{className:"rule--label"},O):null;return ye().createElement(Gb,{key:"func",className:"rule--func"},S,ye().createElement(bE,m))},r.renderArgLabel=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=t.label,l=r.props.config,s=n&&1==n.length&&"const"==n[0];return l.settings.showLabels||"boolean"!=o&&!s||!i?null:ye().createElement(Gb,{className:"rule--func--arg-label"},a||e)},r.renderArgLabelSep=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=r.props.config,l=n&&1==n.length&&"const"==n[0];return a.settings.showLabels||"boolean"!=o&&!l||!i?null:ye().createElement(Gb,{className:"rule--func--arg-label-sep"},":")},r.renderArgVal=function(e,t,n){var o=r.props,i=o.config,a=o.field,l=o.fieldType,s=o.fieldSrc,u=o.isLHS,c=(o.operator,o.value),d=o.readonly,p=o.parentFuncs,f=o.id,v=o.groupId,h=o.fieldError,g=o.valueError,y=o.setFuncValue,m=c?c.getIn(["args",t]):null,b=m?m.get("value"):void 0,E=1==n.valueSources.length?n.valueSources[0]:void 0,O={config:i,fieldFunc:e,fieldArg:t,leftField:a,fieldType:l,fieldSrc:s,fieldError:h,valueError:g,isLHS:u,operator:null,value:b,valueSrc:m?m.get("valueSrc")||E||"value":E,setValue:r.setArgValue,setValueSrc:r.setArgValueSrc,setFuncValue:y,funcKey:e,argKey:t,argDefinition:n,readonly:d,parentFuncs:p,id:f,groupId:v};return ye().createElement(Gb,{className:"rule--func--arg-value"},ye().createElement(ZE,O))},r.renderArgSep=function(e,t,r,n){var o=n.renderSeps;return r?ye().createElement(Gb,{className:"rule--func--arg-sep"},o?o[r-1]:", "):null},r.renderBracketBefore=function(e){var t=e.renderBrackets;return ye().createElement(Gb,{key:"before_args",className:"rule--func--bracket-before"},t?t[0]:"(")},r.renderBracketAfter=function(e){var t=e.renderBrackets;return ye().createElement(Gb,{key:"after_args",className:"rule--func--bracket-after"},t?t[1]:")")},r.renderFuncArgs=function(){var e=r.meta,t=e.funcDefinition,n=e.funcKey;if(!n)return null;var o=(t||{}).args;return o?ye().createElement(ye().Fragment,null,r.renderBracketBefore(t),ye().createElement(Gb,{key:"args-".concat(n),className:"rule--func--args rule--func--".concat(n,"--args")},Object.keys(o).map((function(e,i){return ye().createElement(Gb,{key:"arg-".concat(e,"-").concat(i),className:"rule--func--arg rule--func--".concat(n,"--arg--").concat(e)},r.renderArgSep(e,o[e],i,t),r.renderArgLabel(e,o[e]),r.renderArgLabelSep(e,o[e]),r.renderArgVal(n,e,o[e]))}))),r.renderBracketAfter(t)):null},tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","operator","value","fieldSrc","fieldType","isLHS"].map((function(r){return"parentFuncs"===r?!XE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r,n=e.config,o=(e.field,e.operator,e.value),i=null!==(t=null==o||null===(r=o.get)||void 0===r?void 0:r.call(o,"func"))&&void 0!==t?t:null;return{funcDefinition:i?QE(n,i):null,funcKey:i}}},{key:"render",value:function(){var e=this.props.parentFuncs,t=e?e.map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return"".concat(r,"_").concat(n)})).join("-"):"root",r=(null==e?void 0:e.length)||0;return ye().createElement(Gb,{className:"rule--func--wrapper rule--func--wrapper--under-".concat(t," rule--func--wrapper--lev-").concat(r)},this.renderFuncSelect(),this.renderFuncArgs())}}])}(ge.Component);JE.propTypes={id:Lm().string,groupId:Lm().string,config:Lm().object.isRequired,field:Lm().any,fieldSrc:Lm().string,fieldType:Lm().string,fieldError:Lm().string,operator:Lm().string,customProps:Lm().object,value:Lm().object,setValue:Lm().func.isRequired,setFuncValue:Lm().func,readonly:Lm().bool,parentFuncs:Lm().array,fieldDefinition:Lm().object,isFuncArg:Lm().bool,isLHS:Lm().bool,valueError:Lm().string};var ZE=function(e){function t(e){var r;return Mn(this,t),(r=$E(this,t,[e])).setValue=function(e,t,n,o,i){var a=r.props;(0,a.setValue)(a.argKey,t,n,o,i)},r.setValueSrc=function(e,t,n){var o=r.props;(0,o.setValueSrc)(o.argKey,t,n)},tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["parentFuncs","funcKey","argKey"].map((function(r){return"parentFuncs"===r?!XE(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.parentFuncs,r=e.funcKey,n=e.argKey;return{parentFuncs:[].concat(eo(t||[]),[[r,n]])}}},{key:"render",value:function(){var e=this.meta.parentFuncs;return ye().createElement(HE,hb({},this.props,{setValue:this.setValue,setValueSrc:this.setValueSrc,isFuncArg:!0,parentFuncs:e}))}}])}(ge.Component);function eO(e,t,r){return t=Kn(t),qn(e,tO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function tO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(tO=function(){return!!e})()}ZE.propTypes={funcKey:Lm().string.isRequired,argKey:Lm().string.isRequired,setValue:Lm().func.isRequired,setValueSrc:Lm().func.isRequired,readonly:Lm().bool,isLHS:Lm().bool,parentFuncs:Lm().array,id:Lm().string,groupId:Lm().string};var rO=function(e){function t(e){var r;return Mn(this,t),(r=eO(this,t,[e])).renderField=function(){var e=r.props,t=e.config,n=e.classname,o=e.selectedField,i=e.selectedFieldSrc,a=e.selectedFieldType,l=e.setField,s=e.setFuncValue,u=e.parentField,c=e.readonly,d=e.id,p=e.groupId,f=e.fieldError,v=e.valueError;if(!["func","field"].includes(i))return"?";var h="func"===i?ye().createElement(JE,{isLHS:!0,config:t,value:o,fieldSrc:i,fieldType:a,fieldError:f,valueError:v,parentField:u,setValue:l,setFuncValue:s,readonly:c,id:d,groupId:p,key:"field-func-"+d}):ye().createElement(iE,{config:t,selectedField:o,selectedFieldSrc:i,selectedFieldType:a,parentField:u,setField:l,customProps:t.settings.customFieldSelectProps,readonly:c,id:d,groupId:p,key:"field-"+d}),g="func"===i?t.settings.funcLabel:t.settings.fieldLabel,y=t.settings.showLabels&&"func"!==i&&ye().createElement("label",{className:"rule--label"},g);return ye().createElement("div",{key:i,className:n},y,h)},r.renderFieldSources=function(){if(!r.meta)return null;var e=r.props,t=e.config,n=e.readonly,o=e.selectedFieldSrc,i=e.setFieldSrc,a=e.id,l=r.meta.fieldSourcesOptions,s=t.settings,u=r.ValueSources,c=s.showLabels?ye().createElement("label",{className:"rule--label"}," "):null;return l.length>1&&!n&&ye().createElement("div",{key:"fieldsrc",className:"rule--fieldsrc"},c,ye().createElement(u,{key:"fieldsrc-"+a,valueSources:l,valueSrc:o,config:t,setValueSrc:i,readonly:n,title:s.fieldSourcesPopupTitle}))},tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config);if((!this.meta||["config"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r){var n=e.config,o=n.settings.renderValueSources;this.ValueSources=function(e){return o(e,n.ctx)}}}},{key:"getMeta",value:function(e){var t=e.config.settings,r=t.valueSourcesInfo;return{fieldSourcesOptions:t.fieldSources.map((function(e){return[e,{label:r[e].label}]}))}}},{key:"render",value:function(){var e=this.props,t=(e.classname,e.canSelectFieldSource),r=t&&this.renderFieldSources(),n=this.renderField();return t?ye().createElement(Gb,{className:"rule--field-wrapper"},r,n):n}}])}(ge.Component),nO=["factory"];function oO(e,t,r){return t=Kn(t),qn(e,iO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function iO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(iO=function(){return!!e})()}var aO=Cm.ConfigUtils.getOperatorConfig,lO=function(e){function t(){return Mn(this,t),oO(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){if(!this.props.selectedOperator)return null;var e=aO(this.props.config,this.props.selectedOperator,this.props.selectedField);if(void 0===e.options)return null;var t=e.options,r=t.factory,n=Wg(t,nO),o=r(Object.assign({},n,{config:this.props.config,field:this.props.selectedField,fieldSrc:this.props.selectedFieldSrc,operator:this.props.selectedOperator,options:this.props.operatorOptions,setOption:this.props.setOperatorOption,readonly:this.props.readonly}),this.props.config.ctx),i=this.props.selectedOperator;return ye().createElement("div",{className:"rule--operator rule--operator--".concat(i.toUpperCase())},o)}}])}(ge.PureComponent);function sO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function uO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?sO(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):sO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function cO(e,t,r){return t=Kn(t),qn(e,dO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function dO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(dO=function(){return!!e})()}lO.propTypes={config:Lm().object.isRequired,operatorOptions:Lm().any.isRequired,selectedField:Lm().any,selectedFieldSrc:Lm().string,selectedOperator:Lm().string.isRequired,readonly:Lm().bool,setOperatorOption:Lm().func.isRequired};var pO=Cm.ConfigUtils,fO=pO.getFieldConfig,vO=pO.getOperatorConfig,hO=pO.getFieldWidgetConfig,gO=pO.getFieldId,yO=Cm.RuleUtils.isEmptyRuleProperties,mO=function(e){function t(e){var r;return Mn(this,t),r=cO(this,t,[e]),tb(r),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props,n=!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if((!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","selectedOperator","config","reordableNodesCnt","isLocked"].map((function(t){return e[t]!==r[t]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),n){var o=e.config,i=o.settings,a=i.renderIcon,l=i.renderButton,s=i.renderButtonGroup,u=i.renderSwitch,c=i.renderBeforeWidget,d=i.renderAfterWidget,p=i.renderRuleError;this.Icon=Hb(o,a),this.Btn=Hb(o,l),this.BtnGrp=Hb(o,s),this.Switch=Hb(o,u),this.BeforeWidget=Hb(o,c),this.AfterWidget=Hb(o,d),this.RuleError=Hb(o,p)}this.doRemove=function(){t.props.removeSelf()}}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.selectedOperator,o=e.config,i=e.reordableNodesCnt,a=e.isLocked,l=o.settings.keepInputOnChangeFieldSrc,s=gO(t,o),u=fO(o,t),c=u&&"!struct"===u.type,d=!!t||l&&r,p=d&&n,f=vO(o,n,t),v=f&&null!=f.options,h=hO(o,t,n,null,null)||{},g=h.hideOperator;return{selectedFieldId:s,selectedFieldWidgetConfig:h,showDragIcon:o.settings.canReorder&&i>1&&!a,showOperator:d&&!g,showOperatorLabel:d&&g&&h.operatorInlineLabel,showWidget:p&&!c,showOperatorOptions:p&&v}}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeRuleConfirmOptions;i&&!this.isEmptyCurrentRule()?o.call(r.ctx,uO(uO({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"_buildWidgetProps",value:function(e,t){var r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.operatorOptions,l=e.value,s=e.valueType,u=e.valueSrc,c=e.asyncListValues,d=e.valueError,p=e.fieldError,f=e.parentField;return{field:r,fieldSrc:n,fieldType:o,fieldId:t.selectedFieldId,operator:i,operatorOptions:a,value:l,valueType:s,valueSrc:u,asyncListValues:c,valueError:d,fieldError:p,parentField:f}}},{key:"isEmptyCurrentRule",value:function(){var e=this.props.config,t=this._buildWidgetProps(this.props,this.meta);return yO(t,e)}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.parentField,o=e.groupId,i=e.id,a=e.selectedFieldSrc,l=e.selectedField,s=e.selectedFieldType,u=e.setField,c=e.setFuncValue,d=e.setFieldSrc,p=e.fieldError,f=t.settings.immutableFieldsMode,v=this.meta.selectedFieldId;return ye().createElement(rO,{key:"field",classname:yb()("func"==a?"rule--field--func":"rule--field"),config:t,canSelectFieldSource:!n,selectedField:l,selectedFieldSrc:a,selectedFieldType:s,selectedFieldId:v,fieldError:p,setField:f?qb:u,setFuncValue:f?qb:c,setFieldSrc:f?qb:d,parentField:n,readonly:f||r,id:i,groupId:o})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta,o=n.selectedFieldId,i=n.selectedFieldWidgetConfig,a=n.showOperator,l=n.showOperatorLabel,s=t.settings.immutableOpsMode;return ye().createElement(Qb,{key:"operator",config:t,selectedField:this.props.selectedField,selectedFieldSrc:this.props.selectedFieldSrc,selectedFieldType:this.props.selectedFieldType,selectedFieldId:o,selectedOperator:this.props.selectedOperator,setOperator:s?qb:this.props.setOperator,showOperator:a,showOperatorLabel:l,selectedFieldWidgetConfig:i,readonly:s||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta.showWidget,o=t.settings.immutableValuesMode;if(!n)return null;var i=ye().createElement(HE,hb({key:"values"},this._buildWidgetProps(this.props,this.meta),{config:t,setValue:o?qb:this.props.setValue,setValueSrc:o?qb:this.props.setValueSrc,setFuncValue:o?qb:this.props.setFuncValue,readonly:o||r,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(Gb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},i)}},{key:"renderOperatorOptions",value:function(){var e=this.props.config,t=this.meta.showOperatorOptions,r=e.settings,n=r.immutableOpsMode,o=r.immutableValuesMode;if(!t)return null;var i=ye().createElement(lO,{key:"operatorOptions",selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,operatorOptions:this.props.operatorOptions,setOperatorOption:n?qb:this.props.setOperatorOption,config:e,readonly:o});return ye().createElement(Gb,{key:"op-options-for-"+this.props.selectedOperator,className:"rule--operator-options"},i)}},{key:"renderBeforeWidget",value:function(){var e=this.BeforeWidget;return e?ye().createElement(Gb,{key:"before-widget-for-"+this.props.selectedOperator,className:"rule--before-widget"},ye().createElement(e,this.props)):null}},{key:"renderAfterWidget",value:function(){var e=this.AfterWidget;return e?ye().createElement(Gb,{key:"after-widget-for-"+this.props.selectedOperator,className:"rule--after-widget"},ye().createElement(e,this.props)):null}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=e.fieldError,o=t.settings.showErrorMessage,i=this.RuleError,a=[n].concat(eo((null==r?void 0:r.toArray())||[])).filter((function(e){return!!e})).shift()||null;return o&&a&&ye().createElement("div",{className:"rule--error"},i?ye().createElement(i,{error:a}):a)}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.meta.showDragIcon,r=this.Icon,n=ye().createElement(r,{type:"drag"});return t&&ye().createElement("div",{key:"rule-drag-icon",onMouseDown:e,className:"qb-drag-handler rule--drag-handler"},n)}},{key:"renderDel",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings,o=n.deleteLabel,i=n.immutableGroupsMode,a=n.canDeleteLocked,l=this.Icon,s=this.Btn;return!i&&(!r||r&&a)&&ye().createElement(s,{key:"rule-del",type:"delRule",onClick:this.removeSelf,label:o,config:t,renderIcon:l})}},{key:"renderLock",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.isTrueLocked,o=e.id,i=t.settings,a=i.lockLabel,l=i.lockedLabel,s=i.showLock,u=this.Switch;return s&&!(r&&!n)&&ye().createElement(u,{key:"rule-lock",type:"lock",id:o,value:r,setValue:this.setLock,label:a,checkedLabel:l,hideLabel:!0,config:t})}},{key:"render",value:function(){var e=this.meta,t=e.showOperatorOptions,r=e.selectedFieldWidgetConfig,n=this.props,o=n.valueSrc,i=n.value,a=n.config,l="value"==(null==o?void 0:o.first())&&!t&&1==i.size&&r.fullWidth,s=this.BtnGrp,u=[this.renderField(),this.renderOperator(),this.renderBeforeWidget(),this.renderWidget(),this.renderAfterWidget(),this.renderOperatorOptions()],c=ye().createElement("div",{key:"rule-body",className:yb()("rule--body",l&&"can--shrink--value")},u),d=this.renderError(),p=this.renderDrag(),f=this.renderLock(),v=this.renderDel();return ye().createElement(ye().Fragment,null,p,ye().createElement("div",{key:"rule-body-wrapper",className:"rule--body--wrapper"},c,d),ye().createElement("div",{key:"rule-header-wrapper",className:"rule--header"},ye().createElement(s,{key:"rule-header-group",config:a},f,v)))}}])}(ge.Component);mO.propTypes={id:Lm().string.isRequired,groupId:Lm().string,selectedField:Lm().any,selectedFieldSrc:Lm().string,selectedFieldType:Lm().string,selectedOperator:Lm().string,operatorOptions:Lm().object,config:Lm().object.isRequired,value:Lm().any,valueSrc:Lm().any,valueType:Lm().any,asyncListValues:Lm().array,isDraggingMe:Lm().bool,isDraggingTempo:Lm().bool,parentField:Lm().string,valueError:Lm().any,fieldError:Lm().string,isLocked:Lm().bool,isTrueLocked:Lm().bool,handleDraggerMouseDown:Lm().func,setField:Lm().func,setFieldSrc:Lm().func,setOperator:Lm().func,setOperatorOption:Lm().func,setLock:Lm().func,removeSelf:Lm().func,setValue:Lm().func,setValueSrc:Lm().func,setFuncValue:Lm().func,reordableNodesCnt:Lm().number,totalRulesCnt:Lm().number,parentReordableNodesCnt:Lm().number};const bO=function(e){var t=(0,Fm.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:xm})(function(e){var t;return t=function(t){function r(e){var t;return Mn(this,r),(t=mb(this,r,[e])).dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeRule(t.props.path)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.setField=function(e,r,n){t.props.actions.setField(t.props.path,e,r,n)},t.setFieldSrc=function(e){t.props.actions.setFieldSrc(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setOperatorOption=function(e,r){t.props.actions.setOperatorOption(t.props.path,e,r)},t.setValue=function(e,r,n,o,i){t.props.actions.setValue(t.props.path,e,r,n,o,i)},t.setValueSrc=function(e,r,n){t.props.actions.setValueSrc(t.props.path,e,r,n)},t.setFuncValue=function(e,r,n,o,i,a,l){t.props.actions.setFuncValue(t.props.path,e,r,n,o,i,a,l)},t.pureShouldComponentUpdate=eb(t),t.dummyFn.isDummyFn=!0,t}return zn(r,t),Gn(r,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var l in e){var s=e[l]!=r[l];"dragging"!=l||i||(s=!1),s&&a.push(l)}a.length||(o=!1)}return o}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=Eb(this.props.config,this.props.field),n=this.props.fieldType||(null==r?void 0:r.type)||null,o=this.props.config.settings.showErrorMessage,i=(r&&r.type,!t&&this.props.isDraggingTempo),a=this.props,l=a.valueError,s=null!=([a.fieldError].concat(eo((null==l?void 0:l.toArray())||[])).filter((function(e){return!!e})).shift()||null)&&o;return ye().createElement("div",{className:yb()("group-or-rule-container","rule-container",s?"rule-with-error":null),"data-id":this.props.id},[t?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,setField:this.dummyFn,setFieldSrc:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setOperatorOption:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:i,onDragStart:this.props.onDragStart,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,setField:i?this.dummyFn:this.setField,setFieldSrc:i?this.dummyFn:this.setFieldSrc,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setOperatorOption:i?this.dummyFn:this.setOperatorOption,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ge.Component),t.propTypes={id:Lm().string.isRequired,groupId:Lm().string,config:Lm().object.isRequired,path:Lm().any.isRequired,operator:Lm().string,field:Lm().any,fieldSrc:Lm().string,fieldType:Lm().string,actions:Lm().object.isRequired,onDragStart:Lm().func,value:Lm().any,valueSrc:Lm().any,asyncListValues:Lm().array,valueError:Lm().any,fieldError:Lm().string,operatorOptions:Lm().object,reordableNodesCnt:Lm().number,parentField:Lm().string,isLocked:Lm().bool,isTrueLocked:Lm().bool,dragging:Lm().object,isDraggingTempo:Lm().bool},t}(e));return t.displayName="ConnectedRuleContainer",t}(Cb("rule")(Wb(mO)));var EO=p(3547),OO=p.n(EO);function SO(e,t,r){return t=Kn(t),qn(e,TO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function TO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(TO=function(){return!!e})()}var _O=Cm.DefaultUtils.defaultGroupConjunction;const wO=function(e,t){var r=(0,Fm.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:xm})(function(e,t){var r;return r=function(r){function n(e){var r;return Mn(this,n),(r=SO(this,n,[e]))._selectedConjunction=function(e){return(e=e||r.props).conjunction||_O(e.config,e.field)},r.setConjunction=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setConjunction(r.props.path,e)},r.setNot=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setNot(r.props.path,e)},r.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setLock(r.props.path,e)},r.dummyFn=function(){},r.removeSelf=function(){r.props.actions.removeGroup(r.props.path)},r.addGroup=function(){r.props.actions.addGroup(r.props.path)},r.addCaseGroup=function(){r.props.actions.addCaseGroup(r.props.path)},r.addDefaultCaseGroup=function(){r.props.actions.addDefaultCaseGroup(r.props.path)},r.addRule=function(){var e="rule_group"==t?r.props.field:null;r.props.actions.addRule(r.props.path,void 0,void 0,void 0,e)},r.setField=function(e,t,n){r.props.actions.setField(r.props.path,e,t,n)},r.setOperator=function(e){r.props.actions.setOperator(r.props.path,e)},r.setValue=function(e,t,n,o,i){r.props.actions.setValue(r.props.path,e,t,n,o,i)},r.setValueSrc=function(e,t,n){r.props.actions.setValueSrc(r.props.path,e,t,n)},r.setFuncValue=function(e,t,n,o,i,a,l){r.props.actions.setFuncValue(r.props.path,e,t,n,o,i,a,l)},r.pureShouldComponentUpdate=eb(r),tb(r),r.selectedConjunction=r._selectedConjunction(e),r.conjunctionOptions=r._getConjunctionOptions(e),r.dummyFn.isDummyFn=!0,r}return zn(n,r),Gn(n,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var l in e){var s=e[l]!=r[l];"dragging"!=l||i||(s=!1),s&&a.push(l)}a.length||(o=!1)}return o}},{key:"onPropsChanged",value:function(e){var t=e.config,r=(e.id,e.conjunction),n=this.props.config,o=this.props.conjunction;n==t&&o==r||(this.selectedConjunction=this._selectedConjunction(e),this.conjunctionOptions=this._getConjunctionOptions(e))}},{key:"_getConjunctionOptions",value:function(e){var t=this;return Qy()(e.config.conjunctions,(function(r,n){return{id:"conjunction-".concat(e.id,"-").concat(n),name:"conjunction[".concat(e.id,"]"),key:n,label:r.label,checked:n===t._selectedConjunction(e)}}))}},{key:"render",value:function(){var t=this.props.config.settings.showErrorMessage,r=this.props.dragging.id==this.props.id,n=this.props.path.size,o=this.props.config.settings.maxNesting,i=!r&&this.props.isDraggingTempo,a=this.props.fieldType||null,l=this.props.valueError,s=null!=(eo((null==l?void 0:l.toArray())||[]).filter((function(e){return!!e})).shift()||null)&&t,u=void 0===o||n<o,c=1==n;return ye().createElement("div",{className:yb()("group-or-rule-container","group-container",s?"group-with-error":null),"data-id":this.props.id},[r?ye().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:this.dummyFn,setNot:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,addGroup:this.dummyFn,addCaseGroup:this.dummyFn,addDefaultCaseGroup:this.dummyFn,addRule:this.dummyFn,setField:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,ye().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:r,isDraggingTempo:i,onDragStart:this.props.onDragStart,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:i?this.dummyFn:this.setConjunction,setNot:i?this.dummyFn:this.setNot,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,addGroup:i?this.dummyFn:this.addGroup,addCaseGroup:i?this.dummyFn:this.addCaseGroup,addDefaultCaseGroup:i?this.dummyFn:this.addDefaultCaseGroup,addRule:i?this.dummyFn:this.addRule,setField:i?this.dummyFn:this.setField,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ge.Component),r.propTypes={config:Lm().object.isRequired,actions:Lm().object.isRequired,path:Lm().any.isRequired,id:Lm().string.isRequired,groupId:Lm().string,not:Lm().bool,conjunction:Lm().string,children1:Lm().any,onDragStart:Lm().func,reordableNodesCnt:Lm().number,field:Lm().any,fieldSrc:Lm().string,fieldType:Lm().string,parentField:Lm().string,value:Lm().any,valueSrc:Lm().any,valueError:Lm().any,isLocked:Lm().bool,isTrueLocked:Lm().bool,dragging:Lm().object,isDraggingTempo:Lm().bool},r}(e,t));return r.displayName="ConnectedGroupContainer",r};function RO(e,t,r){return t=Kn(t),qn(e,IO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function IO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(IO=function(){return!!e})()}var AO={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},CO=function(e){function t(){return Mn(this,t),RO(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.removeSelf,i=e.setLock,a=e.isLocked,l=e.isTrueLocked,s=e.id,u=e.canAddGroup,c=e.canAddRule,d=e.canDeleteGroup,p=t.settings,f=p.immutableGroupsMode,v=p.addRuleLabel,h=p.addGroupLabel,g=p.delGroupLabel,y=p.groupActionsPosition,m=p.renderButton,b=p.renderIcon,E=p.renderSwitch,O=p.renderButtonGroup,S=p.lockLabel,T=p.lockedLabel,_=p.showLock,w=p.canDeleteLocked,R=function(e){return b(e,t.ctx)},I=function(e){return m(e,t.ctx)},A=function(e){return E(e,t.ctx)},C=function(e){return O(e,t.ctx)},N=AO[y||"topRight"],L=_&&!(a&&!l)&&ye().createElement(A,{type:"lock",id:s,value:a,setValue:i,label:S,checkedLabel:T,config:t}),j=!f&&c&&!a&&ye().createElement(I,{type:"addRule",onClick:r,label:v,readonly:a,config:t,renderIcon:R}),x=!f&&u&&!a&&ye().createElement(I,{type:"addGroup",onClick:n,label:h,readonly:a,config:t,renderIcon:R}),P=!f&&d&&(!a||a&&w)&&ye().createElement(I,{type:"delGroup",onClick:o,label:g,config:t,renderIcon:R});return ye().createElement("div",{className:"group--actions ".concat(N)},ye().createElement(C,{config:t},L,j,x,P))}}])}(ge.PureComponent);function NO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function LO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?NO(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):NO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function jO(e,t,r){return t=Kn(t),qn(e,xO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function xO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(xO=function(){return!!e})()}var PO=Cm.RuleUtils.isEmptyGroupChildren,FO=function(e){function t(e){var r;return Mn(this,t),(r=jO(this,t,[e])).childrenClassName=function(){return""},r.renderBeforeActions=function(){var e=r.BeforeActions;return null==e?null:ye().createElement(e,hb({key:"group-actions-before"},r.props))},r.renderAfterActions=function(){var e=r.AfterActions;return null==e?null:ye().createElement(e,hb({key:"group-actions-after"},r.props))},tb(r),r.onPropsChanged(e),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.renderItem=r.renderItem.bind(r),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props;if(!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config)){var n=e.config,o=n.settings,i=o.renderIcon,a=o.renderConjs,l=o.renderBeforeActions,s=o.renderAfterActions;this.Icon=Hb(n,i),this.Conjs=Hb(n,a),this.BeforeActions=Hb(n,l),this.AfterActions=Hb(n,s)}this.doRemove=function(){t.props.removeSelf()}}},{key:"isGroupTopPosition",value:function(){return OO()(this.props.config.settings.groupActionsPosition||"topRight","top")}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeGroupConfirmOptions;i&&!this.isEmptyCurrentGroup()?o.call(r.ctx,LO(LO({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config;return PO(t,r)}},{key:"showNot",value:function(){return this.props.config.settings.showNot}},{key:"showConjs",value:function(){var e=this.props,t=e.conjunctionOptions;return e.children1,e.config,Object.keys(t).length>1||this.showNot()}},{key:"isNoChildren",value:function(){var e=this.props.children1;return!e||0==e.size}},{key:"isOneChild",value:function(){var e=this.props.children1;return!e||e.size<2}},{key:"renderChildrenWrapper",value:function(){return this.props.children1&&ye().createElement("div",{key:"group-children",className:yb()("group--children",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isOneChild()?"one--child":"",this.childrenClassName())},this.renderChildren())}},{key:"renderHeaderWrapper",value:function(){var e=this.isGroupTopPosition();return ye().createElement("div",{key:"group-header",className:yb()("group--header",this.isOneChild()?"one--child":"",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"")},this.renderHeader(),e&&this.renderBeforeActions(),e&&this.renderActions(),e&&this.renderAfterActions())}},{key:"renderFooterWrapper",value:function(){return!this.isGroupTopPosition()&&ye().createElement("div",{key:"group-footer",className:"group--footer"},this.renderBeforeActions(),this.renderActions(),this.renderAfterActions())}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(CO,{key:"group-actions",config:t,addRule:r,addGroup:n,canAddGroup:this.canAddGroup(),canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"canAddGroup",value:function(){return this.props.allowFurtherNesting}},{key:"canAddRule",value:function(){var e=this.props.config.settings.maxNumberOfRules,t=this.props.totalRulesCnt;return!e||t<e}},{key:"canDeleteGroup",value:function(){return!this.props.isRoot}},{key:"renderChildren",value:function(){var e=this.props.children1;return e?e.valueSeq().toArray().map(this.renderItem):null}},{key:"renderItem",value:function(e){if(e){var t=this.props,r=t.config,n=t.actions,o=t.onDragStart,i=t.isLocked,a="group"==e.get("type")&&null!=e.getIn(["properties","field"])?"rule_group":e.get("type");return ye().createElement(jS,hb({},this.extraPropsForItem(e),{key:e.get("id"),id:e.get("id"),groupId:t.id,path:e.get("path"),type:a,properties:e.get("properties"),config:r,actions:n,children1:e.get("children1"),reordableNodesCnt:this.reordableNodesCntForItem(e),totalRulesCnt:this.totalRulesCntForItem(e),parentReordableNodesCnt:this.reordableNodesCnt(),onDragStart:o,isDraggingTempo:this.props.isDraggingTempo,isParentLocked:i}))}}},{key:"extraPropsForItem",value:function(e){return{}}},{key:"reordableNodesCnt",value:function(){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.reordableNodesCnt()}},{key:"showDragIcon",value:function(){var e=this.props,t=e.config,r=e.isRoot,n=e.isLocked,o=this.reordableNodesCnt();return t.settings.canReorder&&!r&&o>1&&!n}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.Icon,r=ye().createElement(t,{type:"drag"});return this.showDragIcon()&&ye().createElement("div",{key:"group-drag-icon",onMouseDown:e,className:"qb-drag-handler group--drag-handler"},r)}},{key:"conjunctionOptions",value:function(){return this.props.conjunctionOptions}},{key:"renderConjs",value:function(){var e=this.props,t=e.config,r=e.children1,n=e.id,o=e.selectedConjunction,i=e.setConjunction,a=e.not,l=e.setNot,s=e.isLocked,u=t.settings,c=u.immutableGroupsMode,d=(u.renderConjs,u.showNot,u.notLabel),p=this.conjunctionOptions();if(!this.showConjs())return null;if(!r||!r.size)return null;var f={disabled:this.isOneChild(),readonly:c||s,selectedConjunction:o,setConjunction:c?qb:i,conjunctionOptions:p,config:t,not:a||!1,id:n,setNot:c?qb:l,notLabel:d,showNot:this.showNot(),isLocked:s},v=this.Conjs;return ye().createElement(v,hb({key:"group-conjs"},f))}},{key:"renderHeader",value:function(){return ye().createElement("div",{key:"group-conjunctions",className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"render",value:function(){return ye().createElement(ye().Fragment,null,this.renderHeaderWrapper(),this.renderChildrenWrapper(),this.renderFooterWrapper())}}])}(ge.Component);FO.propTypes={reordableNodesCnt:Lm().number,conjunctionOptions:Lm().object.isRequired,allowFurtherNesting:Lm().bool.isRequired,isRoot:Lm().bool.isRequired,not:Lm().bool,selectedConjunction:Lm().string,config:Lm().object.isRequired,id:Lm().string.isRequired,groupId:Lm().string,path:Lm().any,children1:Lm().any,isDraggingMe:Lm().bool,isDraggingTempo:Lm().bool,isLocked:Lm().bool,isTrueLocked:Lm().bool,handleDraggerMouseDown:Lm().func,onDragStart:Lm().func,addRule:Lm().func.isRequired,addGroup:Lm().func.isRequired,removeSelf:Lm().func.isRequired,setConjunction:Lm().func.isRequired,setNot:Lm().func.isRequired,setLock:Lm().func.isRequired,actions:Lm().object.isRequired};const DO=wO(Cb("group")(Wb(FO)),"group");function kO(){return kO="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,r){var n=function(e,t){for(;!{}.hasOwnProperty.call(e,t)&&null!==(e=Kn(e)););return e}(e,t);if(n){var o=Object.getOwnPropertyDescriptor(n,t);return o.get?o.get.call(arguments.length<3?e:r):o.value}},kO.apply(null,arguments)}function MO(e,t,r){return t=Kn(t),qn(e,VO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function VO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(VO=function(){return!!e})()}var UO=function(e){function t(){return Mn(this,t),MO(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,l=e.isLocked,s=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addRuleLabel,f=c.delGroupLabel,v=c.renderButton,h=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,E=c.showLock,O=c.canDeleteLocked,S=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=E&&!(l&&!s)&&ye().createElement(_,{type:"lock",id:u,value:l,setValue:a,label:m,checkedLabel:b,hideLabel:!0,config:t}),I=!d&&n&&!l&&ye().createElement(T,{type:"addRuleGroup",onClick:r,label:p,readonly:l,config:t,renderIcon:S}),A=!d&&o&&(!l||l&&O)&&ye().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions"},ye().createElement(w,{config:t},R,I,A))}}])}(ge.PureComponent);function BO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function GO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?BO(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):BO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function qO(e,t,r){return t=Kn(t),qn(e,KO()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function KO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(KO=function(){return!!e})()}var WO=function(e){function t(e){var r;return Mn(this,t),(r=qO(this,t,[e])).childrenClassName=function(){return"rule_group--children"},r.renderHeaderWrapper=function(){return null},r.renderFooterWrapper=function(){return null},r.renderConjs=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!1},r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){kO(Kn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"renderChildrenWrapper",value:function(){return ye().createElement(ye().Fragment,null,this.renderDrag(),this.renderField(),this.renderActions(),kO(Kn(t.prototype),"renderChildrenWrapper",this).call(this))}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFuncValue,l=e.setFieldSrc,s=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(rO,{key:"field",classname:"group--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:a,setFieldSrc:l,parentField:s,readonly:p||d,id:u,groupId:c})}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(UO,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(FO);WO.propTypes=GO(GO({},FO.propTypes),{},{selectedField:Lm().any,selectedFieldSrc:Lm().string,parentField:Lm().string,setField:Lm().func,setFieldSrc:Lm().func});const zO=wO(Cb("group rule_group")(Wb(WO)),"rule_group");function HO(e,t,r){return t=Kn(t),qn(e,$O()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function $O(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return($O=function(){return!!e})()}var YO=function(e){function t(){return Mn(this,t),HO(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,l=e.isLocked,s=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addSubRuleLabel,f=c.delGroupLabel,v=c.renderButton,h=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,E=c.showLock,O=c.canDeleteLocked,S=function(e){return h(e,t.ctx)},T=function(e){return v(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=E&&!(l&&!s)&&ye().createElement(_,{type:"lock",id:u,value:l,setValue:a,label:m,checkedLabel:b,config:t}),I=!d&&n&&!l&&ye().createElement(T,{type:"addRuleGroupExt",onClick:r,label:p,readonly:l,config:t,renderIcon:S}),A=!d&&o&&(!l||l&&O)&&ye().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions group--actions--tr"},ye().createElement(w,{config:t},R,I,A))}}])}(ge.PureComponent);function QO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function XO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?QO(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):QO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function JO(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function ZO(e,t,r){return t=Kn(t),qn(e,eS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function eS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(eS=function(){return!!e})()}var tS=Cm.ConfigUtils,rS=tS.getFieldConfig,nS=tS.getFieldWidgetConfig,oS=Cm.RuleUtils.isEmptyRuleGroupExtPropertiesAndChildren,iS=function(e){function t(e){var r;return Mn(this,t),(r=ZO(this,t,[e])).childrenClassName=function(){return"rule_group_ext--children"},r.renderFooterWrapper=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!0},r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){kO(Kn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:yb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderGroupField(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderGroupField",value:function(){return ye().createElement("div",{className:"group--field--count--rule"},this.renderField(),this.renderOperator(),this.renderWidget(),this.renderError())}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings,o=n.renderRuleError,i=n.showErrorMessage,a=eo((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return i&&a&&ye().createElement("div",{className:"rule_group--error"},o?o({error:a},t.ctx):a)}},{key:"showNot",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,rS(t,r)||{});return null!=n.showNot?n.showNot:t.settings.showNot}},{key:"conjunctionOptions",value:function(){var e=this.props,r=e.config,n=e.selectedField,o=(e.selectedOperator,rS(r,n)||{}),i=kO(Kn(t.prototype),"conjunctionOptions",this).call(this);if(o.conjunctions){var a,l={},s=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return JO(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?JO(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,l=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){l=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(l)throw i}}}}(o.conjunctions);try{for(s.s();!(a=s.n()).done;){var u=a.value,c=i[u];c&&(l[u]=c)}}catch(e){s.e(e)}finally{s.f()}i=l}return i}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFieldSrc,l=e.setFuncValue,s=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return ye().createElement(rO,{key:"field",classname:"rule--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:l,setFieldSrc:a,parentField:s,readonly:p||d,id:u,groupId:c})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedOperator,i=(e.setField,e.setOperator),a=e.isLocked,l=t.settings.immutableFieldsMode,s=nS(t,r,o)||{},u=s.hideOperator,c=r&&u&&s.operatorInlineLabel,d=r&&!u;return ye().createElement(Qb,{key:"operator",classname:"group--operator",config:t,selectedField:r,selectedFieldSrc:n,selectedOperator:o,setOperator:i,showOperator:d,showOperatorLabel:c,selectedFieldWidgetConfig:s,readonly:l||a,id:this.props.id,groupId:this.props.groupId})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config,n=this._buildWidgetProps(this.props);return oS(n,t,r)}},{key:"_buildWidgetProps",value:function(e){var t=e.selectedField,r=e.selectedFieldSrc,n=e.selectedFieldType,o=e.selectedOperator,i=e.operatorOptions,a=e.value,l=e.valueType,s=(e.valueSrc,e.asyncListValues,e.valueError);return e.fieldError,{field:t,fieldSrc:r,fieldType:n,operator:o,operatorOptions:i,value:a,valueType:l,valueSrc:["value"],valueError:s,fieldError:null,parentField:e.parentField}}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.isLocked,i=t.settings.immutableValuesMode;if(!r||!n)return null;var a=ye().createElement(HE,hb({key:"values",isForRuleGroup:!0},this._buildWidgetProps(this.props),{config:t,setValue:i?qb:this.props.setValue,setValueSrc:qb,readonly:i||o,id:this.props.id,groupId:this.props.groupId}));return ye().createElement(Gb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return ye().createElement(YO,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(FO);iS.propTypes=XO(XO({},FO.propTypes),{},{selectedField:Lm().any,selectedFieldSrc:Lm().string,selectedOperator:Lm().string,value:Lm().any,parentField:Lm().string,setField:Lm().func,setFieldSrc:Lm().func,setOperator:Lm().func,setValue:Lm().func,valueError:Lm().any});const aS=wO(Cb("group rule_group_ext")(Wb(iS)),"rule_group");function lS(e,t,r){return t=Kn(t),qn(e,sS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function sS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(sS=function(){return!!e})()}var uS={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},cS=function(e){function t(){return Mn(this,t),lS(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.setLock,i=e.isLocked,a=e.isTrueLocked,l=e.id,s=e.canAddGroup,u=e.canAddDefault,c=t.settings,d=c.immutableGroupsMode,p=c.addCaseLabel,f=c.addDefaultCaseLabel,v=c.groupActionsPosition,h=c.renderButton,g=c.renderIcon,y=c.renderSwitch,m=c.renderButtonGroup,b=c.lockLabel,E=c.lockedLabel,O=c.showLock,S=function(e){return g(e,t.ctx)},T=function(e){return h(e,t.ctx)},_=function(e){return y(e,t.ctx)},w=function(e){return m(e,t.ctx)},R=uS[v||"topRight"],I=O&&!(i&&!a)&&ye().createElement(_,{type:"lock",id:l,value:i,setValue:o,label:b,checkedLabel:E,config:t}),A=!d&&s&&!i&&ye().createElement(T,{type:"addCaseGroup",onClick:r,label:p,readonly:i,config:t,renderIcon:S}),C=!d&&u&&!i&&ye().createElement(T,{type:"addDefaultCaseGroup",onClick:n,label:f,readonly:i,config:t,renderIcon:S});return ye().createElement("div",{className:"group--actions ".concat(R)},ye().createElement(w,{config:t},I,A,C))}}])}(ge.PureComponent);function dS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function pS(e,t,r){return t=Kn(t),qn(e,fS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function fS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(fS=function(){return!!e})()}var vS=Cm.TreeUtils,hS=vS.getTotalReordableNodesCountInTree,gS=vS.getTotalRulesCountInTree,yS=function(e){function t(e){var r;return Mn(this,t),(r=pS(this,t,[e])).childrenClassName=function(){return"switch_group--children"},r.renderFooterWrapper=function(){return null},r.hasDefaultCase=function(){var e;return(null===(e=r.props.children1)||void 0===e?void 0:e.size)&&r.props.children1.filter((function(e){return null==e.get("children1")})).size>0},r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){kO(Kn(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"canAddGroup",value:function(){var e,t=this.props.config.settings.maxNumberOfCases,r=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return!t||r<t}},{key:"canAddRule",value:function(){return!1}},{key:"reordableNodesCnt",value:function(){var e,t=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return this.hasDefaultCase()&&t--,t}},{key:"totalRulesCntForItem",value:function(e){return gS(e)}},{key:"reordableNodesCntForItem",value:function(e){var t;if(this.props.isLocked)return 0;var r=this.props.config.settings,n=r.canLeaveEmptyCase,o=r.canRegroupCases,i=(null===(t=this.props.children1)||void 0===t?void 0:t.size)||0;this.hasDefaultCase()&&i--;var a=hS(e);return 1==a&&o&&n&&i>1&&(a=111),a}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:yb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag")},this.renderHeader(),this.renderActions())}},{key:"renderHeader",value:function(){return ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderConjs",value:function(){return this.props.config.settings.renderSwitchPrefix||null}},{key:"showNot",value:function(){return!1}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(cS,{config:t,addCaseGroup:r,addDefaultCaseGroup:n,canAddDefault:!this.hasDefaultCase(),canAddGroup:this.canAddGroup(),setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}}])}(FO);yS.propTypes=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?dS(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):dS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},FO.propTypes);const mS=wO(Cb("group switch_group")(Wb(yS)),"switch_group");function bS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function ES(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?bS(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):bS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function OS(e,t,r){return t=Kn(t),qn(e,SS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function SS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(SS=function(){return!!e})()}var TS=function(e){function t(e){var r;return Mn(this,t),(r=OS(this,t,[e])).childrenClassName=function(){return"case_group--children"},r.renderFooterWrapper=function(){return null},r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var r=this.props,n=!this.renderBeforeCaseValue||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if(kO(Kn(t.prototype),"onPropsChanged",this).call(this,e),n){var o=e.config,i=o.settings,a=i.renderBeforeCaseValue,l=i.renderAfterCaseValue,s=i.renderRuleError;this.BeforeCaseValue=Hb(o,a),this.AfterCaseValue=Hb(o,l),this.RuleError=Hb(o,s)}}},{key:"isDefaultCase",value:function(){return null==this.props.children1}},{key:"reordableNodesCnt",value:function(){return this.props.parentReordableNodesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"showDragIcon",value:function(){return!this.isDefaultCase()&&kO(Kn(t.prototype),"showDragIcon",this).call(this)}},{key:"renderHeaderWrapper",value:function(){return ye().createElement("div",{key:"group-header",className:yb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeaderLeft(),this.renderHeaderCenter(),this.renderActions())}},{key:"renderChildrenWrapper",value:function(){return this.isDefaultCase()?null:ye().createElement("div",{className:"case_group--body"},this.renderCondition(),this.renderBeforeValue(),this.renderValue(),this.renderAfterValue())}},{key:"renderHeaderLeft",value:function(){return this.isDefaultCase()?this.props.config.settings.defaultCaseLabel||"":ye().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag(),this.renderError())}},{key:"renderCondition",value:function(){return this.isDefaultCase()?null:kO(Kn(t.prototype),"renderChildrenWrapper",this).call(this)}},{key:"renderHeaderCenter",value:function(){return this.isDefaultCase()?ye().createElement("div",null,this.renderValue(),this.renderError()):null}},{key:"canAddGroup",value:function(){return!this.isDefaultCase()&&kO(Kn(t.prototype),"canAddGroup",this).call(this)}},{key:"canAddRule",value:function(){return!this.isDefaultCase()&&kO(Kn(t.prototype),"canAddRule",this).call(this)}},{key:"renderBeforeValue",value:function(){var e=this.BeforeCaseValue;return null==e?null:ye().createElement(e,hb({key:"values-before"},this.props))}},{key:"renderAfterValue",value:function(){var e=this.AfterCaseValue;return null==e?null:ye().createElement(e,hb({key:"values-after"},this.props))}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings.showErrorMessage,o=this.RuleError,i=eo((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return n&&i&&ye().createElement("div",{className:"rule--error"},o?ye().createElement(o,{error:i}):i)}},{key:"renderValue",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.value,o=e.valueSrc,i=e.valueError,a=e.setValue,l=e.setValueSrc,s=e.setFuncValue,u=e.id,c=t.settings.immutableValuesMode,d=ye().createElement(HE,{key:"values",isCaseValue:!0,field:"!case_value",operator:null,value:n,valueSrc:null!=o?o:"value",valueError:i,fieldError:null,config:t,setValue:c?qb:a,setValueSrc:c?qb:l,setFuncValue:c?qb:s,readonly:c||r,id:u,groupId:null});return ye().createElement(Gb,{className:"case_group--value"},d)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addGroup,n=e.addRule,o=e.isLocked,i=e.isTrueLocked,a=e.id;return ye().createElement(CO,{config:t,addGroup:r,addRule:n,canAddRule:this.canAddRule(),canAddGroup:this.canAddGroup(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.value,r=e&&e.size?e.get(0):null,n=null!=r&&(!Array.isArray(r)||r.length>0);return kO(Kn(t.prototype),"isEmptyCurrentGroup",this).call(this)&&!n}}])}(FO);TS.propTypes=ES(ES({},FO.propTypes),{},{parentReordableNodesCnt:Lm().number,value:Lm().any,setValue:Lm().func});const _S=wO(Cb("group case_group")(Wb(TS)),"case_group");var wS=["type"];function RS(e,t,r){return t=Kn(t),qn(e,IS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function IS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(IS=function(){return!!e})()}function AS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function CS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?AS(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):AS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var NS=function(e){var t,r=(null===(t=e.properties)||void 0===t?void 0:t.toObject())||{},n=CS({},r);return e.isParentLocked&&(n.isLocked=!0),r.isLocked&&(n.isTrueLocked=!0),n},LS={rule:function(e){return ye().createElement(bO,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,config:e.config,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},group:function(e){return ye().createElement(DO,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group:function(e){return ye().createElement(zO,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group_ext:function(e){return ye().createElement(aS,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},switch_group:function(e){return ye().createElement(mS,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},case_group:function(e){return ye().createElement(_S,hb({},NS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))}},jS=function(e){function t(){return Mn(this,t),RS(this,t,arguments)}return zn(t,e),Gn(t,[{key:"render",value:function(){var e,t=this.props,r=t.type,n=Wg(t,wS),o="array"==(null===(e=n.properties)||void 0===e?void 0:e.get("mode"))?"_ext":"",i=n.config.settings.renderItem,a=LS[r+o];return i?i(CS(CS({},n),{},{type:r,itemComponent:a}),n.config.ctx):a?a(n):null}}])}(ge.PureComponent);function xS(e,t,r){return t=Kn(t),qn(e,PS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function PS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(PS=function(){return!!e})()}jS.propTypes={config:Lm().object.isRequired,id:Lm().string.isRequired,groupId:Lm().string,type:Lm().oneOf(["rule","group","rule_group","switch_group","case_group"]).isRequired,path:Lm().any.isRequired,properties:Lm().any,children1:Lm().any,actions:Lm().object.isRequired,reordableNodesCnt:Lm().number,onDragStart:Lm().func,parentField:Lm().string,isDraggingTempo:Lm().bool,isParentLocked:Lm().bool};var FS=Cm.TreeUtils,DS=FS.getTotalReordableNodesCountInTree,kS=FS.getTotalRulesCountInTree,MS=Cm.DefaultUtils,VS=MS.createListWithOneElement,US=MS.emptyProperties,BS=function(e){function t(e){var r;return Mn(this,t),(r=xS(this,t,[e])).pureShouldComponentUpdate=eb(r),r._updPath(e),r}return zn(t,e),Gn(t,[{key:"shouldComponentUpdate",value:function(e,t){return this.pureShouldComponentUpdate(e,t)}},{key:"_updPath",value:function(e){var t=e.tree.get("id");this.path=VS(t)}},{key:"render",value:function(){var e=this.props,t=e.tree,r=e.config,n=e.actions,o=e.onDragStart,i=t.get("type"),a="switch_group"==i,l=a?null:DS(t),s=a?null:kS(t),u=t.get("id");return ye().createElement(jS,{key:u,id:u,path:this.path,type:i,properties:t.get("properties")||US(),config:r,actions:n,children1:t.get("children1")||US(),reordableNodesCnt:l,totalRulesCnt:s,parentReordableNodesCnt:0,onDragStart:o})}}])}(ge.Component);BS.propTypes={tree:Lm().any.isRequired,config:Lm().object.isRequired,actions:Lm().object.isRequired,onDragStart:Lm().func};const GS=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(0,Fm.connect)((function(e){return{dragging:e.dragging,dragStart:e.dragStart,mousePos:e.mousePos}}),{setDragStart:Bm,setDragProgress:Um,setDragEnd:Gm},null,{context:xm})(function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return t=function(t){function n(e){var t;return Mn(this,n),(t=Ob(this,n,[e]))._getEventTarget=function(e,t){return e&&e.__mocked_window||document.body||window},t.onDragStart=function(e,r,n){var o=r.closest(".query-builder");void 0===t._isUsingLegacyReactDomRender&&(t._isUsingLegacyReactDomRender=Jm(o)),document.body.classList.add("qb-dragging"),o.classList.add("qb-dragging");var i,a=o.closest(".query-builder-container")||o,l=(a=t._getScrollParent(a)||document.body).scrollTop,s=(t._getDraggableNodeEl(o),t._getPlaceholderNodeEl(o),o.querySelectorAll(".group--children")),u=s.length?s[0]:null;u&&(i=window.getComputedStyle(u,null).getPropertyValue("padding-left"),i=parseInt(i));var c={id:e,x:r.offsetLeft,y:r.offsetTop,w:r.offsetWidth,h:r.offsetHeight,itemInfo:t.tree.items[e],paddingLeft:i},d={id:e,x:r.offsetLeft,y:r.offsetTop,scrollTop:l,clientX:n.clientX,clientY:n.clientY,itemInfo:Tb(t.tree.items[e]),treeEl:o,treeElContainer:a},p={clientX:n.clientX,clientY:n.clientY},f=t._getEventTarget(n,d);t.eventTarget=f,f.addEventListener("mousemove",t.onDrag),f.addEventListener("mouseup",t.onDragEnd),t.props.setDragStart(d,c,p)},t.onDrag=function(e){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=Object.assign({},t.props.dragging),i=t.props.dragStart,a=o.paddingLeft,l=i.treeElContainer.scrollTop;if(o.itemInfo=t.tree.items[o.id],o.itemInfo){var s={clientX:e.clientX,clientY:e.clientY},u={clientX:i.clientX,clientY:i.clientY};if(e.__mock_dom){var c=i.treeEl,d=t._getDraggableNodeEl(c),p=t._getPlaceholderNodeEl(c);e.__mock_dom({treeEl:c,dragEl:d,plhEl:p})}if(!i.plX){var f=i.treeEl,v=t._getPlaceholderNodeEl(f);v&&(i.plX=v.getBoundingClientRect().left+window.scrollX,i.plY=v.getBoundingClientRect().top+window.scrollY)}var h=i.x,g=i.y,y=i.clientX,m=i.clientY,b=i.scrollTop,E={x:h+(e.clientX-y),y:g+(e.clientY-m)+(l-b)};o.x=E.x,o.y=E.y,o.paddingLeft=a,o.mousePos=s,o.startMousePos=u,t.props.setDragProgress(s,o),n&&t.handleDrag(o,e,r)||e.preventDefault&&e.preventDefault()}},t.onDragEnd=function(){var e=t.props.dragStart.treeEl;t.props.setDragEnd(),e.classList.remove("qb-dragging"),document.body.classList.remove("qb-dragging"),t._cacheEls={};var r=t.eventTarget||t._getEventTarget();r.removeEventListener("mousemove",t.onDrag),r.removeEventListener("mouseup",t.onDragEnd)},t.pureShouldComponentUpdate=eb(t),tb(t),t.onPropsChanged(e),t}return zn(n,t),Gn(n,[{key:"onPropsChanged",value:function(e){this.tree=_b(e.tree)}},{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=[];for(var a in e)e[a]!=r[a]&&"dragging"!=a&&"mousePos"!=a&&i.push(a);i.length||(o=!1)}return o}},{key:"componentDidUpdate",value:function(e,t){var r=this.props.dragging,n=this.props.dragStart;if(wb=!1,n&&n.id&&(r.itemInfo=this.tree.items[r.id],r.itemInfo&&(r.itemInfo.index!=n.itemInfo.index||r.itemInfo.parent!=n.itemInfo.parent))){var o=n.treeEl,i=n.treeElContainer,a=this._getPlaceholderNodeEl(o,!0);if(a){var l=a.getBoundingClientRect().left+window.scrollX,s=a.getBoundingClientRect().top+window.scrollY,u=n.plX,c=n.plY,d=i.scrollTop;n.plX=l,n.plY=s,n.itemInfo=Tb(r.itemInfo),n.y=a.offsetTop,n.x=a.offsetLeft,n.clientY+=s-c,n.clientX+=l-u,i!=document.body&&(n.scrollTop=d),this.onDrag(this.props.mousePos,!1)}}}},{key:"_getNodeElById",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==t)return null;this._cacheEls||(this._cacheEls={});var n=this._cacheEls[t];return n&&document.contains(n)&&!r||(n=e.querySelector('.group-or-rule-container[data-id="'+t+'"]'),this._cacheEls[t]=n),n}},{key:"_getDraggableNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.draggable;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-draggable");return r=n.length?n[0]:null,this._cacheEls.draggable=r,r}},{key:"_getPlaceholderNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.placeholder;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-placeholder");return r=n.length?n[0]:null,this._cacheEls.placeholder=r,r}},{key:"_isScrollable",value:function(e){var t=window.getComputedStyle(e)["overflow-y"];return("scroll"===t||"auto"===t)&&e.scrollHeight>e.offsetHeight}},{key:"_getScrollParent",value:function(e){return null==e?null:e===document.body||this._isScrollable(e)?e:this._getScrollParent(e.parentNode)}},{key:"handleDrag",value:function(e,t,r){var n,o,i,a,l=this,s=e.itemInfo,u=e.paddingLeft,c=null,d=this.props.dragStart.treeEl,p=e.id,f=this._getDraggableNodeEl(d),v=this._getPlaceholderNodeEl(d);if(f&&v){if(n=f.getBoundingClientRect(),!(o=v.getBoundingClientRect()).width)return;var h={hrz:0,vrt:0};n.top<o.top?h.vrt=-1:n.bottom>o.bottom&&(h.vrt=1),n.left>o.left?h.hrz=1:n.left<o.left&&(h.hrz=-1);var g,y={x:(a=d.getBoundingClientRect()).left+(a.right-a.left)/2,y:h.vrt>=0?n.bottom:n.top};if(t.__mocked_hov_container)g=t.__mocked_hov_container;else{var m=document.elementFromPoint(y.x,y.y-1);if(!(g=m?m.closest(".group-or-rule-container"):null)&&m&&m.classList.contains("query-builder-container")){var b,E=null==m||null===(b=m.firstChild)||void 0===b?void 0:b.firstChild;E&&E.classList.contains("group-or-rule-container")&&(g=E)}}if(g){var O=g.classList.contains("group-container"),S=g.getAttribute("data-id"),T=g,_=!1,w=!1;if(T){var R=(i=T.getBoundingClientRect()).bottom-i.top,I=this.tree.items[S];if(!I)throw new Error("There is an issue with rendering. If you use Next.js, please check getServerSideProps() method.");var A=null,C=null,N=null,L=null;if(0==h.vrt)N=s,(C=v)&&(A=C.getBoundingClientRect());else if(O){if(h.vrt>0){var j=g.getElementsByClassName("group--header"),x=j.length?j[0]:null;if(x){var P=x.getBoundingClientRect(),F=P.bottom-P.top;n.bottom-P.top>3*F/4&&I.top>e.itemInfo.top&&(N=I,A=P,C=x,w=!0)}}else h.vrt<0&&I.lev>=s.lev&&i.bottom-n.top>=2&&I.top<e.itemInfo.top&&(N=I,A=i,C=T,_=!0);(h.vrt<0?i.bottom-n.top>R-5:n.bottom-i.top>R-5)&&(w||_||(N=I,A=i,C=T),L=I)}else(h.vrt<0?i.bottom-n.top>R/2:n.bottom-i.top>R/2)&&(N=I,A=i,C=T);var D=N&&N.id==p;if(A){var k=n.left-a.left,M=(A.left,a.left,Math.max(0,Math.round(k/u))),V=[],U=[];if(D);else{if(O&&(_?V.push([Mm,N,N.lev+1]):w&&V.push([Vm,N,N.lev+1]),L)){var B=0==L.lev,G="case_group"==L.type&&"case_group"!=s.type,q=L.prev&&this.tree.items[L.prev].caseId,K=L.next&&this.tree.items[L.next].caseId;s.caseId==q&&(q=null),s.caseId==K&&(K=null);var W=q&&this.tree.items[q],z=K&&this.tree.items[K];h.vrt>0?B?U.push([Mm,L,L.lev+1]):G&&z?U.push([Vm,z,z.lev+1]):U.push([Dm,L,L.lev]):h.vrt<0&&(B?U.push([Vm,L,L.lev+1]):G&&W?U.push([Mm,W,W.lev+1]):U.push([km,L,L.lev]))}_||w||(h.vrt<0?V.push([km,N,N.lev]):h.vrt>0&&V.push([Dm,N,N.lev]))}var H=function(e){var t=e[1],r=s.caseId?l.tree.items[s.caseId]:null,n=t.caseId?l.tree.items[t.caseId]:null;return[].concat(eo(e),[r,n])};V=V.map(H),U=U.map(H);var $=null,Y=(V=V.filter((function(e){var t=e[0],r=e[1];if((t==km||t==Dm)&&null==r.parent)return!1;if(r.collapsed&&(t==Mm||t==Vm))return!1;var n=r.id==s.id;if(!n)for(var o=r;o.parent;)if((o=l.tree.items[o.parent]).id==s.id){n=!0;break}return!n})).map((function(e){var t=e[0],r=e[1],n=(e[2],e[3],e[4],null);return(n=t==Mm||t==Vm?r:l.tree.items[r.parent])&&null==n.parent&&(n=null),e[5]=n,e}))).filter((function(e){return l.canMove(s,e[1],e[0],e[3],e[4],e[5],r)}));0==Y.length&&U.length>0&&(Y=U.filter((function(e){return l.canMove(s,e[1],e[0],e[3],e[4],e[5],r)})));var Q=Y.map((function(e){return e[2]})),X=s.lev,J=Q.concat(X),Z=null;-1!=J.indexOf(M)?Z=M:M>Math.max.apply(Math,eo(J))?Z=Math.max.apply(Math,eo(J)):M<Math.min.apply(Math,eo(J))&&(Z=Math.min.apply(Math,eo(J))),$=Y.find((function(e){return e[2]==Z})),D||$||!Y.length||($=Y[0]),c=$}}}else Ym.log("out of tree bounds!")}return!!c&&(this.move(s,c[1],c[0],c[3]),!0)}},{key:"canMove",value:function(e,t,r,n,o,i,a){if(!e||!t)return!1;if(e.id===t.id)return!1;var l=this.props.config.settings,s=l.canRegroup,u=l.canRegroupCases,c=l.maxNesting,d=l.maxNumberOfRules,p=l.canLeaveEmptyCase,f=(i?i.lev+1:t.lev)+(e.depth||0),v=r==km||r==Dm,h=r==Vm||r==Mm,g=v&&1==t.lev||h&&0==t.lev,y=e.parent!=t.parent,m=h||y,b="case_group"==e.type&&!g||"rule_group"==e.parentType||"rule_group"==t.type||"rule_group"==t.parentType||"case_group"!=e.type&&"case_group"==t.type&&v||"case_group"!=e.type&&"switch_group"==t.type||!u&&e.caseId!=t.caseId,E=t.isLocked||e.isLocked||i&&i.isLocked;if(c&&f>c)return!1;if(m&&(!s||b||E))return!1;if("case_group"!=e.type&&e.caseId!=t.caseId){var O=!!n&&2==n._height,S=o?o.atomicRulesCountInCase+1:0;if(d&&S>d)return!1;if(O&&!p)return!1}if("case_group"==e.type&&(e.isDefaultCase||t.isDefaultCase||"switch_group"==t.type&&r==Mm))return!1;var T=!0;return a&&(T=a(e.node.toJS(),t.node.toJS(),r,i?i.node.toJS():null)),T}},{key:"move",value:function(e,t,r,n){this._isUsingLegacyReactDomRender||(wb=!0),this.props.actions.moveItem(e.path,t.path,r)}},{key:"render",value:function(){return ye().createElement(e,hb({},this.props,{onDragStart:this.onDragStart}))}}])}(ge.Component),t.propTypes={tree:Lm().any.isRequired,actions:Lm().object.isRequired},t}(e,t));return r.displayName="ConnectedSortableContainer",r}(BS);function qS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function KS(e,t,r){return t=Kn(t),qn(e,WS()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function WS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(WS=function(){return!!e})()}var zS=Cm.clone,HS=Cm.ConfigUtils,$S=HS.getFieldConfig,YS=HS.getFieldParts,QS=HS.getFieldPathParts,XS=Cm.RuleUtils,JS=XS.getFieldPathLabels,ZS=XS.getWidgetForFieldOp,eT=function(e){function t(e){var r;return Mn(this,t),r=KS(this,t,[e]),tb(r),r.onPropsChanged(e),r}return zn(t,e),Gn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldSrc","fieldType","operator","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0,n=!this.meta||["config","field","fieldSrc","fieldType","operator","value","placeholder","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;r&&(this.items=this.getItems(e)),n&&(this.meta=this.getMeta(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.fieldType,o=e.operator,i=e.parentField,a=e.isFuncArg,l=e.fieldDefinition,s=t.settings.canCompareFieldWithField,u=YS(i,t),c=i?$S(t,i):null,d=i?null==c?void 0:c.subfields:t.fields,p=this.filterFields(t,d,r,i,u,o,s,a,l,n);return this.buildOptions(u,t,p,u)}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.field,o=(e.fieldType,e.operator,e.value),i=e.placeholder,a=e.isFuncArg,l=e.parentField,s=r.settings,u=s.fieldPlaceholder,c=s.fieldSeparatorDisplay,d=o,p=!!o,f=n?$S(r,n):{},v=null==f||null===(t=f.widgets)||void 0===t?void 0:t.field,h=(null==v?void 0:v.widgetProps)||{},g=p?null:a&&i||h.valuePlaceholder||u,y=p?$S(r,d):null,m=y||{},b=QS(d,r),E=QS(d,r,!0),O=this.getFieldLabel(y,d,r),S=JS(d,r),T=S?S.join(c):null;return(T==O||l)&&(T=null),{placeholder:g,selectedKey:d,selectedKeys:b,selectedPath:E,selectedLabel:O,selectedOpts:m,selectedAltLabel:m.label2||m.tooltip,selectedFullLabel:T}}},{key:"filterFields",value:function(e,t,r,n,o,i,a,l,s,u){t=zS(t);var c,d=e.settings.fieldSeparator,p=$S(e,r),f=ZS(e,r,i,"value");return e.widgets[f],c=l?null==s?void 0:s.type:p?p.type:u,function t(n,o){for(var s in n){var u=n[s].subfields,f=(o||[]).concat(s),v=f.join(d),h=$S(e,v);if(h)if("!struct"==h.type||"!group"==h.type)0==t(u,f)&&delete n[s];else{var g=!(c&&h.type!=c||!l&&v==r),y=a||e.settings.canCompareFieldWithField;y&&(g=g&&y(r,p,v,h,i)),g||delete n[s]}else delete n[s]}return Lb()(n).length}(t,o||[]),t}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,l=a.fieldSeparator,s=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(l)+l:"";return Lb()(r).map((function(a){var l=[].concat(eo(null!=o?o:[]),[a]),c=r[a],d=n.getFieldLabel(c,l,t),p=JS(l,t).join(s);(p==d||e)&&(p=null);var f=c.label2,v=c.tooltip;if(!c.hideForCompare)return"!struct"==c.type||"!group"==c.type?{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:v,items:n.buildOptions(e,t,c.subfields,l,{label:d,tooltip:v})}:{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:v,grouplabel:null==i?void 0:i.label,group:i}})).filter((function(e){return!!e}))}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=YS(t,r),i=(null==e?void 0:e.label)||eu()(o);return zm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,l=t.settings.renderField,s=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?qS(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):qS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({isValueField:!0,config:t,customProps:r,setField:n,readonly:o,items:this.items,id:i,groupId:a},this.meta);return l(s,t.ctx)}}])}(ge.Component);eT.propTypes={id:Lm().string,groupId:Lm().string,setValue:Lm().func.isRequired,config:Lm().object.isRequired,field:Lm().any,fieldSrc:Lm().string,fieldType:Lm().string,value:Lm().string,operator:Lm().string,customProps:Lm().object,readonly:Lm().bool,parentField:Lm().string,fieldDefinition:Lm().object,isFuncArg:Lm().bool};const tT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.labelYes),o=e.labelNo,i=e.readonly,a=(e.widgetId,e.customProps),l=void 0===a?{}:a,s=l.radioYes||{},u=l.radioNo||{},c=function(e){return r("true"==e.target.value)};return ye().createElement(ye().Fragment,null,ye().createElement("input",hb({type:"radio",value:!0,checked:!!t,disabled:i,onChange:c},s))," ",n,ye().createElement("input",hb({type:"radio",value:!1,checked:!t,disabled:i,onChange:c},u))," ",o)},rT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=e.customProps,l=t||"";return ye().createElement("input",hb({type:"text",value:l,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i},a))},nT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=(e.maxRows,e.fullWidth),l=e.customProps,s=t||"";return ye().createElement("textarea",hb({value:s,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i,style:{width:a?"100%":void 0}},l))};Cm.moment;const oT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.readonly),o=e.customProps;return ye().createElement("input",hb({type:"date",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))},iT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.use12Hours,e.readonly),o=e.customProps;return ye().createElement("input",hb({type:"time",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))};var aT=Cm.moment;const lT=function(e){var t,r=e.value,n=e.setValue,o=(e.config,e.valueFormat),i=(e.use12Hours,e.readonly),a=e.customProps;return t=r?aT(r).format("YYYY-MM-DDTHH:mm"):"",ye().createElement("input",hb({type:"datetime-local",value:t,disabled:i,onChange:function(e){var t=e.target.value;t=""==t?void 0:aT(new Date(t)).format(o),n(t)}},a))};var sT=Cm.ListUtils.mapListValues;const uT=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps;return ye().createElement("select",hb({multiple:!0,onChange:function(e){return n(function(e){for(var t=[],r=e.options,n=0;n<r.length;n++){var o=r[n];o.selected&&t.push(o.value)}return t.length||(t=void 0),t}(e.target))},value:r,disabled:o},ru()(i,["showSearch","input","showCheckboxes"])),sT(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))};var cT=Cm.ListUtils.mapListValues;const dT=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps,a=null!=r;return ye().createElement("select",hb({onChange:function(e){return n(e.target.value)},value:a?r:"",disabled:o},ru()(i,["showSearch","input"])),!a&&ye().createElement("option",{disabled:!0,value:""}),cT(t,(function(e){var t=e.title,r=e.value;return ye().createElement("option",{key:r,value:r},t)})))},pT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,l=e.placeholder,s=e.customProps,u=null==t?"":t;return ye().createElement("input",hb({type:"number",value:u,placeholder:l,disabled:n,min:o,max:i,step:a,onChange:function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)}},s))},fT=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,l=e.placeholder,s=e.customProps,u=void 0===s?{}:s,c=u.input||{},d=u.slider||u,p=function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)},f=null==t?"":t;return ye().createElement("div",{style:{display:"inline-flex"}},ye().createElement("input",hb({key:"number",type:"number",value:f,placeholder:l,disabled:n,min:o,max:i,step:a,onChange:p},c)),ye().createElement("input",hb({key:"range",type:"range",value:f,disabled:n,min:o,max:i,step:a,onChange:p},d)))},vT=function(e){var t=e.items,r=e.setField,n=e.selectedKey,o=e.readonly,i=e.errorText,a=null!=n;return ye().createElement("select",{onChange:function(e){return r(e.target.value)},value:a?n:"",disabled:o,style:{color:i?"red":null}},!a&&ye().createElement("option",{disabled:!0,value:""}),function e(t){return t.map((function(t){var r=t.items,n=t.path,o=t.label,i=t.disabled,a=t.matchesType;if(r)return ye().createElement("optgroup",{disabled:i,key:n,label:o},e(r));var l=a?{fontWeight:"bold"}:{};return ye().createElement("option",{disabled:i,key:n,value:n,style:l},o)}))}(t))},hT=function(e){var t,r=e.id,n=e.not,o=e.setNot,i=e.conjunctionOptions,a=e.setConjunction,l=e.disabled,s=e.readonly,u=e.config,c=e.showNot,d=e.notLabel,p=Object.keys(i).length,f=l,v=u.settings.forceShowConj||p>1&&!f,h=function(e){return a(e.target.value)};return[c&&(t="not",[ye().createElement("input",{key:r+t,type:"checkbox",id:r+t,checked:n,disabled:s,onChange:function(e){return o(e.target.checked)}}),ye().createElement("label",{key:r+t+"label",htmlFor:r+t},d||"NOT")]),v&&Object.keys(i).map((function(e){var t=i[e],r=t.id,n=t.name,o=t.label,u=t.checked,c=a.isDummyFn?"__dummy":"";return!s&&!l||u?[ye().createElement("input",{key:r+c,type:"radio",id:r+c,name:n+c,checked:u,disabled:s||l,value:e,onChange:h}),ye().createElement("label",{key:r+c+"label",htmlFor:r+c},o)]:null}))]};var gT={addRuleGroup:"+",addRuleGroupExt:"+",delGroup:"x",delRuleGroup:"x",delRule:"x"};const yT=function(e){var t=e.type,r=e.label,n=e.onClick,o=e.readonly,i=r||gT[t];return ye().createElement("button",{onClick:n,type:"button",disabled:o},i)},mT=function(e){var t=e.type,r={}[t]||null;return r||"drag"!==t||(r=ye().createElement(Kb,null)),r},bT=function(e){var t=e.children;return e.config,ye().createElement(ye().Fragment,null,t)},ET=function(e){e.config;var t=e.valueSources,r=e.valueSrc,n=(e.title,e.setValueSrc),o=e.readonly;return ye().createElement("select",{onChange:function(e){return n(e.target.value)},value:r||"",disabled:o},function(e){return e.map((function(e){var t=Jn(e,2),r=t[0],n=t[1];return ye().createElement("option",{key:r,value:r},n.label)}))}(t))},OT=function(e){var t=e.value,r=e.setValue,n=e.label,o=e.id,i=(e.config,e.type);return[ye().createElement("input",{key:o+i,type:"checkbox",id:o+i,checked:!!t,onChange:function(e){return r(e.target.checked)}}),ye().createElement("label",{key:o+i+"label",htmlFor:o+i},n)]},ST=function(e){var t=e.onOk,r=(e.okText,e.cancelText,e.title);confirm(r)&&t()};var TT=function(e){return e.config,e.children};function _T(e,t,r){return t=Kn(t),qn(e,wT()?Reflect.construct(t,r||[],Kn(e).constructor):t.apply(e,r))}function wT(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(wT=function(){return!!e})()}var RT=function(e){function t(){var e;Mn(this,t);for(var r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=_T(this,t,[].concat(n))).handleChange=function(t){e.props.setOption("proximity",parseInt(t))},e}return zn(t,e),Gn(t,[{key:"render",value:function(){var e=this.props,t=e.defaults,r=e.options,n=e.config,o=e.optionLabel,i=e.optionPlaceholder,a=e.customProps,l=e.minProximity,s=e.maxProximity,u=e.optionTextBefore,c=e.readonly,d=n.settings,p=n.widgets,f=n.ctx,v=t?t.proximity:void 0,h=d.showLabels,g=r.get("proximity",v),y=OE()(l,s+1).map((function(e){return{title:e,value:e}})),m=p.select.factory,b=function(e){return m(e,f)};return ye().createElement("div",{className:"operator--PROXIMITY"},ye().createElement("div",{className:"operator--options"},h&&ye().createElement("label",{className:"rule--label"},o),!h&&u&&ye().createElement("div",{className:"operator--options--sep"},ye().createElement("span",null,u)),ye().createElement(b,hb({config:n,value:g,listValues:y,setValue:this.handleChange,readonly:c,placeholder:i},a))),ye().createElement("div",{className:"operator--widgets"},this.props.children))}}])}(ge.PureComponent);function IT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function AT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?IT(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):IT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}RT.propTypes={config:Lm().object.isRequired,setOption:Lm().func.isRequired,options:Lm().any.isRequired,minProximity:Lm().number,maxProximity:Lm().number,optionPlaceholder:Lm().string,optionTextBefore:Lm().string,optionLabel:Lm().string,customProps:Lm().object,readonly:Lm().bool},RT.defaultProps={customProps:{},minProximity:2,maxProximity:10,optionPlaceholder:"Select words between",optionLabel:"Words between",optionTextBefore:null};var CT={conjunctions:AT({},_y.conjunctions),operators:AT(AT({},_y.operators),{},{proximity:AT(AT({},_y.operators.proximity),{},{options:AT(AT({},_y.operators.proximity.options),{},{factory:function(e,t){return(0,t.RCE)(t.O.ProximityOperator,e)}})})}),widgets:{text:AT(AT({},_y.widgets.text),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}}),textarea:AT(AT({},_y.widgets.textarea),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextAreaWidget,e)}}),number:AT(AT({},_y.widgets.number),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaNumberWidget,e)}}),slider:AT(AT({},_y.widgets.slider),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSliderWidget,e)}}),select:AT(AT({},_y.widgets.select),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSelectWidget,e)}}),multiselect:AT(AT({},_y.widgets.multiselect),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaMultiSelectWidget,e)}}),date:AT(AT({},_y.widgets.date),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateWidget,e)}}),time:AT(AT({},_y.widgets.time),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTimeWidget,e)}}),datetime:AT(AT({},_y.widgets.datetime),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateTimeWidget,e)}}),boolean:AT(AT({},_y.widgets.boolean),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaBooleanWidget,e)}}),field:AT(AT({},_y.widgets.field),{},{factory:function(e,t){return(0,t.RCE)(t.W.ValueFieldWidget,e)},customProps:{showSearch:!0}}),func:AT(AT({},_y.widgets.func),{},{factory:function(e,t){return(0,t.RCE)(t.W.FuncWidget,e)},customProps:{}}),case_value:AT(AT({},_y.widgets.case_value),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}})},types:AT(AT({},_y.types),{},{select:AT(AT({},_y.types.select),{},{widgets:AT(AT({},_y.types.select.widgets),{},{select:AT(AT({},_y.types.select.widgets.select),{},{widgetProps:{customProps:{showSearch:!0}}})})})}),settings:AT(AT({},_y.settings),{},{renderField:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderOperator:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderFunc:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderConjs:function(e,t){return(0,t.RCE)(t.W.VanillaConjs,e)},renderSwitch:function(e,t){return(0,t.RCE)(t.W.VanillaSwitch,e)},renderButton:function(e,t){return(0,t.RCE)(t.W.VanillaButton,e)},renderIcon:function(e,t){return(0,t.RCE)(t.W.VanillaIcon,e)},renderButtonGroup:function(e,t){return(0,t.RCE)(t.W.VanillaButtonGroup,e)},renderProvider:function(e,t){return(0,t.RCE)(t.W.VanillaProvider,e)},renderValueSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderFieldSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderConfirm:function(e,t){return(0,t.W.vanillaConfirm)(e)},renderSwitchPrefix:"IF",renderBeforeCaseValue:function(e,t){return(0,t.RCE)("span",{children:[" then "]})},customFieldSelectProps:{showSearch:!0},customOperatorSelectProps:{},defaultSliderWidth:"200px",defaultSelectWidth:"200px",defaultSearchWidth:"100px",defaultMaxRows:5,renderSize:"small",maxLabelsLength:100,showLock:!1,showNot:!0,forceShowConj:!1,groupActionsPosition:"topRight"}),ctx:AT(AT({},_y.ctx),{},{W:AT({},E),O:AT({},O),RCE:function(e,t){return ye().createElement(e,t)}})};const NT=CT=Cm.ConfigMixins.removeMixins(CT,["rangeslider","treeselect","treemultiselect"]);p(9517);var LT=Cm.Autocomplete,jT=(LT.mergeListValues,LT.listValueToOption,LT.optionToListValue,LT.optionsToListValues,LT.fixListValuesGroupOrder,Cm.ListUtils);function xT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function PT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?xT(Object(r),!0).forEach((function(t){Hn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):xT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}jT.mapListValues,jT.listValuesToArray,jT.getListValue,jT.makeCustomListValue,jT.searchListValue,jT.getItemInListValues;const FT=PT(PT({},Cm),{},{ReactUtils:b,DragIcon:Kb});function DT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function kT(){return kT=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},kT.apply(this,arguments)}function MT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){DT(e,t,r[t])}))}return e}function VT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const UT={id:FT.uuid(),type:"group"},BT="timeFilter",GT=[BT],qT=VT(MT({},NT.widgets),{text:VT(MT({},NT.widgets.text),{factory:function(e){return(0,he.jsx)(_e.Input,{value:(null==e?void 0:e.value)||"",placeholder:null==e?void 0:e.placeholder,onChange:t=>null==e?void 0:e.setValue(t.currentTarget.value)})}}),number:VT(MT({},NT.widgets.number),{factory:function(e){return(0,he.jsx)(_e.Input,{value:null==e?void 0:e.value,placeholder:null==e?void 0:e.placeholder,type:"number",onChange:t=>null==e?void 0:e.setValue(Number.parseInt(t.currentTarget.value,10))})}}),datetime:VT(MT({},NT.widgets.datetime),{factory:function(e){if("macros"===(null==e?void 0:e.operator))return(0,he.jsx)(_e.Select,{id:e.id,"aria-label":"Macros value selector",menuShouldPortal:!0,options:GT.map(T.toOption),value:null==e?void 0:e.value,onChange:t=>e.setValue(t.value)});const t=(0,T.dateTime)(null==e?void 0:e.value).isValid()?(0,T.dateTime)(null==e?void 0:e.value).utc():void 0;return(0,he.jsx)(_e.DateTimePicker,{onChange:t=>{null==e||e.setValue(null==t?void 0:t.format(NT.widgets.datetime.valueFormat))},date:t})},sqlFormatValue:(e,t,r,n,o,i)=>{if("macros"===n)return GT.includes(e)?e:void 0;if("string"==typeof NT.widgets.datetime.sqlFormatValue||"object"==typeof NT.widgets.datetime.sqlFormatValue)return;const a=NT.widgets.datetime.sqlFormatValue;return(null==a?void 0:a.call(NT.ctx,e,t,r,n,o,i))||""}})}),KT=VT(MT({},NT.settings),{canRegroup:!1,maxNesting:1,canReorder:!1,showNot:!1,addRuleLabel:"Add",deleteLabel:"Remove",renderConjs:function(e){return(0,he.jsx)(_e.Select,{id:null==e?void 0:e.id,"aria-label":"Conjunction","data-testid":Pe.components.SQLQueryEditor.filterConjunction,menuShouldPortal:!0,options:(null==e?void 0:e.conjunctionOptions)?Object.keys(null==e?void 0:e.conjunctionOptions).map(T.toOption):void 0,value:null==e?void 0:e.selectedConjunction,onChange:t=>null==e?void 0:e.setConjunction(t.value)})},renderField:function(e){var t;const r=(null==e||null===(t=e.config)||void 0===t?void 0:t.fields)||{};return(0,he.jsx)(_e.Select,{id:null==e?void 0:e.id,width:25,"aria-label":"Field","data-testid":Pe.components.SQLQueryEditor.filterField,menuShouldPortal:!0,options:null==e?void 0:e.items.map((e=>{var t,n;const o=null===(n=r[e.key].mainWidgetProps)||void 0===n||null===(t=n.customProps)||void 0===t?void 0:t.icon;return{label:e.label,value:e.key,icon:o}})),value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.label)}})},renderButton:function(e){return(0,he.jsx)(_e.Button,{type:"button",title:`${null==e?void 0:e.label} filter`,onClick:null==e?void 0:e.onClick,variant:"secondary",size:"md",icon:"Add"===(null==e?void 0:e.label)?"plus":"times"})},renderOperator:function(e){return(0,he.jsx)(_e.Select,{options:null==e?void 0:e.items.map((e=>({label:e.label,value:e.key}))),"aria-label":"Operator","data-testid":Pe.components.SQLQueryEditor.filterOperator,menuShouldPortal:!0,value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.value||"")}})}}),WT=function(e){const t=kT({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e.operators));return VT(MT({},t),{select_any_in:VT(MT({},t.select_any_in),{sqlFormatOp:(e,r,n,o,i,a,l,s)=>(()=>{const e=t.select_any_in.sqlFormatOp;return JT(e)?e:XT})()(e,r,ZT(n),o,i,a,l,s)}),select_not_any_in:VT(MT({},t.select_not_any_in),{sqlFormatOp:(e,r,n,o,i,a,l,s)=>(()=>{const e=t.select_not_any_in.sqlFormatOp;return JT(e)?e:XT})()(e,r,ZT(n),o,i,a,l,s)}),macros:{label:"Macros",sqlFormatOp:(e,t,r)=>r===BT?`$__timeFilter(${e})`:r}})}(NT),zT=NT.types.text.widgets.text,HT=[...zT.operators||[],"select_any_in","select_not_any_in"],$T=VT(MT({},zT),{operators:HT}),YT=VT(MT({},NT.types),{text:VT(MT({},NT.types.text),{widgets:VT(MT({},NT.types.text.widgets),{text:$T})}),datetime:VT(MT({},NT.types.datetime),{widgets:VT(MT({},NT.types.datetime.widgets),{datetime:VT(MT({},NT.types.datetime.widgets.datetime),{operators:["macros",...NT.types.datetime.widgets.datetime.operators||[]]})})})}),QT=VT(MT({},NT),{widgets:qT,settings:KT,operators:WT,types:YT}),XT=()=>"",JT=e=>"function"==typeof e;function ZT(e){return(0,fe.isString)(e)?e.split(","):e}function e_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function t_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){e_(e,t,r[t])}))}return e}function r_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function n_({sql:e,config:t,onSqlChange:r}){const[n,o]=(0,ge.useState)(),i=(0,ge.useMemo)((()=>t_({},QT,t)),[t]);(0,ge.useEffect)((()=>{if(!n){var t;const r=FT.checkTree(FT.loadTree(null!==(t=e.whereJsonTree)&&void 0!==t?t:UT),i);o(r)}}),[i,e.whereJsonTree,n]),(0,ge.useEffect)((()=>{e.whereJsonTree||o(FT.checkTree(FT.loadTree(UT),i))}),[i,e.whereJsonTree]);const a=(0,ge.useCallback)(((t,n)=>{o(t);const i=r_(t_({},e),{whereJsonTree:FT.getTree(t),whereString:FT.sqlFormat(t,n)});r(i)}),[r,e]);return n?(0,he.jsx)(vb,r_(t_({},i),{value:n,onChange:a,renderBuilder:e=>(0,he.jsx)(GS,t_({},e))})):null}function o_(e){return`\n    display: flex;\n    gap: 8px;\n    flex-direction: ${e};`}function i_(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function a_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){i_(i,n,o,a,l,"next",e)}function l(e){i_(i,n,o,a,l,"throw",e)}a(void 0)}))}}function l_({query:e,fields:t,onQueryChange:r,db:n}){const o=(0,kn.A)(a_((function*(){return function(e){const t={};for(const r of e)t[r.value]={type:r.raqbFieldType||"text",valueSources:["value"],mainWidgetProps:{customProps:{icon:r.icon}}};return t}(t)})),[t]),{onSqlChange:i}=rn({query:e,onQueryChange:r,db:n});return(0,he.jsx)(n_,{config:{fields:o.value||{}},sql:e.sql,onSqlChange:e=>{!function(e,t){var r,n;t.some((t=>(t=>{var r,n;return"multi"in t&&t.multi&&((null===(r=e.whereString)||void 0===r?void 0:r.includes(`\${${t.name}}`))||(null===(n=e.whereString)||void 0===n?void 0:n.includes(`$${t.name}`)))})(t)))&&(e.whereString=null===(r=e.whereString)||void 0===r?void 0:r.replaceAll("')",")"),e.whereString=null===(n=e.whereString)||void 0===n?void 0:n.replaceAll("('","("))}(e,(0,pe.getTemplateSrv)().getVariables()),i(e)}},JSON.stringify(o.value))}function s_(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function u_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){s_(i,n,o,a,l,"next",e)}function l(e){s_(i,n,o,a,l,"throw",e)}a(void 0)}))}}Fe.injectGlobal`
  .group--header {
    ${o_("row")}
  }

  .group-or-rule {
    ${o_("column")}
    .rule {
      flex-direction: row;
    }
  }

  .rule--body {
    ${o_("row")}
  }

  .group--children {
    ${o_("column")}
  }

  .group--conjunctions:empty {
    display: none;
  }
`;const c_=({query:e,db:t,queryRowFilter:r,onChange:n,onValidate:o,range:i})=>{var a;const l=Oe(u_((function*(){return yield t.fields(e)})),[t,e.dataset,e.table]);return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsxs)(Qr,{children:[(0,he.jsx)(ot,{children:(0,he.jsx)(Dn,{fields:l.value||[],query:e,onQueryChange:n,db:t})}),r.filter&&(0,he.jsx)(ot,{children:(0,he.jsx)(ft,{label:"Filter by column value",optional:!0,children:(0,he.jsx)(l_,{fields:l.value||[],query:e,onQueryChange:n,db:t})})}),r.group&&(0,he.jsx)(ot,{children:(0,he.jsx)(ft,{label:"Group by column",children:(0,he.jsx)(En,{fields:l.value||[],query:e,onQueryChange:n,db:t})})}),r.order&&(0,he.jsx)(ot,{children:(0,he.jsx)(Rn,{fields:l.value||[],query:e,onQueryChange:n,db:t})}),r.preview&&e.rawSql&&(0,he.jsx)(ot,{children:(0,he.jsx)(Zr,{rawSql:e.rawSql,datasourceType:null===(a=e.datasource)||void 0===a?void 0:a.type})})]}),(0,he.jsx)(Hr,{db:t,query:e,onValidate:o,range:i})]})};function d_(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function p_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){d_(i,n,o,a,l,"next",e)}function l(e){d_(i,n,o,a,l,"throw",e)}a(void 0)}))}}function f_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function v_({datasource:e,query:t,onChange:r,onRunQuery:n,range:o,queryHeaderProps:i}){var a,l,s,u,c,d;const[p,f]=(0,ge.useState)(!0),v=e.getDB(),{preconfiguredDatabase:h}=e;var g;const y=null!==(g=null==i?void 0:i.dialect)&&void 0!==g?g:"other",{loading:m,error:b}=Oe(p_((function*(){return()=>{void 0!==e.getDB(e.id).init&&e.getDB(e.id).init()}})),[e]),E=Ce(t),[O,S]=(0,ge.useState)({filter:!!(null===(a=E.sql)||void 0===a?void 0:a.whereString),group:!!(null===(u=E.sql)||void 0===u||null===(s=u.groupBy)||void 0===s||null===(l=s[0])||void 0===l?void 0:l.property.name),order:!!(null===(d=E.sql)||void 0===d||null===(c=d.orderBy)||void 0===c?void 0:c.property.name),preview:!0}),[T,_]=(0,ge.useState)(E);(0,ge.useEffect)((()=>()=>{void 0!==e.getDB(e.id).dispose&&e.getDB(e.id).dispose()}),[e]);const w=(0,ge.useCallback)((e=>{h_(e)&&n&&n()}),[n]),R=(e,t=!0)=>{var n,o,i,a;_(e),r(e),we(null===(n=e.sql)||void 0===n?void 0:n.columns)&&(null===(o=e.sql)||void 0===o?void 0:o.columns.some((e=>e.name)))&&!O.group&&S((i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){f_(e,t,r[t])}))}return e}({},O),a=null!=(a={group:!0})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i)),t&&w(e)};return m||b?null:(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(At,{db:v,preconfiguredDataset:h,onChange:e=>{_(e),r(e)},onRunQuery:n,onQueryRowChange:S,queryRowFilter:O,query:E,isQueryRunnable:p,dialect:y}),(0,he.jsx)(_e.Space,{v:.5}),E.editorMode!==de.Code&&(0,he.jsx)(c_,{db:v,query:E,onChange:e=>R(e,!1),queryRowFilter:O,onValidate:f,range:o}),E.editorMode===de.Code&&(0,he.jsx)($r,{db:v,query:E,queryToValidate:T,onChange:R,onRunQuery:n,onValidate:f,range:o})]})}const h_=e=>Boolean(e.rawSql);function g_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function y_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){g_(e,t,r[t])}))}return e}function m_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function b_(e){const t="string"==typeof e.rawQuery?e.rawQuery:null;if(!t)return e;var r;const n=Ce(m_(y_({refId:"Annotation"},null!==(r=e.target)&&void 0!==r?r:{}),{rawSql:t}));return m_(y_({},e),{rawQuery:void 0,workspace:void 0,subscription:void 0,queryType:void 0,target:n})}function E_(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function O_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){E_(i,n,o,a,l,"next",e)}function l(e){E_(i,n,o,a,l,"throw",e)}a(void 0)}))}}function S_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function T_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){S_(e,t,r[t])}))}return e}function __(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class w_ extends pe.DataSourceWithBackend{getResponseParser(){return this.responseParser}interpolateVariablesInQueries(e,t){let r=e;return e&&e.length>0&&(r=e.map((e=>__(T_({},e),{datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),rawQuery:!0})))),r}filterQuery(e){return!e.hide}applyTemplateVariables(e,t){return{refId:e.refId,datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),format:e.format}}query(e){if(yt()){const t=this.checkForDatabaseIssue(e);if(t){const e=new Error(t);return(0,R.throwError)((()=>e))}}return e.targets.forEach((t=>{var r;e.app!==T.CoreApp.Dashboard&&e.app!==T.CoreApp.PanelViewer&&(0,pe.reportInteraction)("grafana_sql_query_executed",{datasource:null===(r=t.datasource)||void 0===r?void 0:r.type,editorMode:t.editorMode,format:t.format,app:e.app})})),super.query(e)}checkForDatabaseIssue(e){if("postgres"===this.type&&!this.preconfiguredDatabase)return"You do not currently have a default database configured for this data source. Postgres requires a default\n             database with which to connect. Please configure one through the Data Sources Configuration page, or if you\n             are using a provisioning file, update that configuration file with a default database.";if(e.app!==T.CoreApp.Explore&&this.preconfiguredDatabase)for(const t of e.targets)if(t.editorMode===de.Builder&&t.dataset!==this.preconfiguredDatabase)return"The configuration for this panel's data source has been modified. The previous database used in this panel's\n                   saved query is no longer available. Please update the query to use the new database option.\n                   Previous query parameters will be preserved until the query is updated."}metricFindQuery(e,t){var r=this;return O_((function*(){const n=null==t?void 0:t.range;if(null==n)return[];let o="tempvar";t&&t.variable&&t.variable.name&&(o=t.variable.name);const i=T_({},null==t?void 0:t.scopedVars,(0,T.getSearchFilterScopedVar)({query:e,wildcardChar:"%",options:t})),a=r.templateSrv.replace(e,i,r.interpolateVariable),l={refId:o,datasource:r.getRef(),rawSql:a,format:S.Table};let s;try{s=yield r.runMetaQuery(l,n)}catch(e){throw console.error(e),new Error("error when executing the sql query")}return r.getResponseParser().transformMetricFindResponse(s)}))()}runSql(e,t){var r=this;return O_((function*(){const n=(0,T.getDefaultTimeRange)(),o=yield r.runMetaQuery({rawSql:e,format:S.Table,refId:null==t?void 0:t.refId},n);return new T.DataFrameView(o)}))()}runMetaQuery(e,t){const r=e.refId||"meta",n=[__(T_({},e),{datasource:e.datasource||this.getRef(),refId:r})];return(0,R.lastValueFrom)((0,pe.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",headers:this.getRequestHeaders(),data:{from:t.from.valueOf().toString(),to:t.to.valueOf().toString(),queries:n},requestId:r}).pipe(re((e=>{var t;return null!==(t=(0,pe.toDataQueryResponse)(e,n).data[0])&&void 0!==t?t:{fields:[]}}))))}targetContainsTemplate(e){let t=e.rawSql;return An.forEach((e=>{t=(null==t?void 0:t.replace(e,""))||""})),this.templateSrv.containsTemplate(t)}constructor(e,t=(0,pe.getTemplateSrv)()){super(e),S_(this,"templateSrv",void 0),S_(this,"id",void 0),S_(this,"responseParser",void 0),S_(this,"name",void 0),S_(this,"interval",void 0),S_(this,"db",void 0),S_(this,"preconfiguredDatabase",void 0),S_(this,"interpolateVariable",void 0),this.templateSrv=t,this.interpolateVariable=(e,t)=>"string"==typeof e?t.multi||t.includeAll?this.getQueryModel().quoteLiteral(e):String(e).replace(/'/g,"''"):"number"==typeof e?e:Array.isArray(e)?e.map((e=>this.getQueryModel().quoteLiteral(e))).join(","):e,this.name=e.name,this.responseParser=new ve,this.id=e.id;const r=e.jsonData||{};var n;this.interval=r.timeInterval||"1m",this.db=this.getDB(),this.preconfiguredDatabase=null!==(n=r.database)&&void 0!==n?n:"",this.annotations={prepareAnnotation:b_,QueryEditor:v_}}}var R_=Object.defineProperty,I_=Object.defineProperties,A_=Object.getOwnPropertyDescriptors,C_=Object.getOwnPropertySymbols,N_=Object.prototype.hasOwnProperty,L_=Object.prototype.propertyIsEnumerable,j_=(e,t,r)=>t in e?R_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,x_=(e,t)=>{for(var r in t||(t={}))N_.call(t,r)&&j_(e,r,t[r]);if(C_)for(var r of C_(t))L_.call(t,r)&&j_(e,r,t[r]);return e};const P_=({children:e,title:t,description:r,isCollapsible:n=!1,isInitiallyOpen:o=!0,kind:i="section",className:a})=>{const{colors:l,typography:s,spacing:u}=(0,_e.useTheme2)(),[c,d]=(0,ge.useState)(!n||o),p=c?"angle-up":"angle-down",f="sub-section"===i,v=`${c?"Collapse":"Expand"} section ${t}`,h={header:(0,Fe.css)({display:"flex",justifyContent:"space-between",alignItems:"center"}),title:(0,Fe.css)({margin:0}),subtitle:(0,Fe.css)({margin:0,fontWeight:s.fontWeightRegular}),descriptionText:(0,Fe.css)((g=x_({marginTop:u(f?.25:.5),marginBottom:0},s.bodySmall),y={color:l.text.secondary},I_(g,A_(y)))),content:(0,Fe.css)({marginTop:u(2)})};var g,y;return ye().createElement("div",{className:a},ye().createElement("div",{className:h.header},"section"===i?ye().createElement("h3",{className:h.title},t):ye().createElement("h6",{className:h.subtitle},t),n&&ye().createElement(_e.IconButton,{name:p,onClick:()=>d(!c),type:"button",size:"xl","aria-label":v})),r&&ye().createElement("p",{className:h.descriptionText},r),c&&ye().createElement("div",{className:h.content},e))};var F_=Object.defineProperty,D_=Object.defineProperties,k_=Object.getOwnPropertyDescriptors,M_=Object.getOwnPropertySymbols,V_=Object.prototype.hasOwnProperty,U_=Object.prototype.propertyIsEnumerable,B_=(e,t,r)=>t in e?F_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const G_=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)V_.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&M_)for(var n of M_(e))t.indexOf(n)<0&&U_.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return ye().createElement(P_,(t=((e,t)=>{for(var r in t||(t={}))V_.call(t,r)&&B_(e,r,t[r]);if(M_)for(var r of M_(t))U_.call(t,r)&&B_(e,r,t[r]);return e})({},o),D_(t,k_({kind:"sub-section"}))),n)};function q_({value:e,defaultValue:t,onChange:r,width:n}){const[o,i]=(0,ge.useState)(!1);return(0,he.jsx)(_e.Input,{type:"number",placeholder:String(t),value:o?"":e,onChange:e=>{var n;if(""===(null===(n=e.currentTarget.value)||void 0===n?void 0:n.trim()))i(!0),r(t);else{i(!1);const t=Number(e.currentTarget.value);Number.isNaN(t)||r(t)}},width:n})}function K_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function W_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){K_(e,t,r[t])}))}return e}const z_=e=>{const{onOptionsChange:t,options:r}=e,n=r.jsonData,o=void 0!==n.maxIdleConnsAuto&&n.maxIdleConnsAuto,i=e=>{const o=(i=W_({},r),a=null!=(a={jsonData:W_({},n,e)})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;return t(o)},a=e=>t=>{i({[e]:t})};return(0,he.jsxs)(G_,{title:"Connection limits",children:[(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Max open"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["The maximum number of open connections to the database. If ",(0,he.jsx)("i",{children:"Max idle connections"})," is greater than 0 and the ",(0,he.jsx)("i",{children:"Max open connections"})," is less than ",(0,he.jsx)("i",{children:"Max idle connections"}),", then",(0,he.jsx)("i",{children:"Max idle connections"})," will be reduced to match the ",(0,he.jsx)("i",{children:"Max open connections"})," limit. If set to 0, there is no limit on the number of open connections."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(q_,{value:n.maxOpenConns,defaultValue:pe.config.sqlConnectionLimits.maxOpenConns,onChange:e=>{var t;t=e,i(o&&t?{maxOpenConns:t,maxIdleConns:t}:{maxOpenConns:t})},width:40})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Auto max idle"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["If enabled, automatically set the number of ",(0,he.jsx)("i",{children:"Maximum idle connections"})," to the same value as",(0,he.jsx)("i",{children:" Max open connections"}),". If the number of maximum open connections is not set it will be set to the default (",pe.config.sqlConnectionLimits.maxIdleConns,")."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.Switch,{value:o,onChange:()=>{let e,t;o?(t=n.maxOpenConns,e=n.maxIdleConns):void 0!==n.maxOpenConns&&(t=n.maxOpenConns,e=n.maxOpenConns),i({maxIdleConnsAuto:!o,maxIdleConns:e,maxOpenConns:t})}})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Max idle"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["The maximum number of connections in the idle connection pool.If ",(0,he.jsx)("i",{children:"Max open connections"})," is greater than 0 but less than the ",(0,he.jsx)("i",{children:"Max idle connections"}),", then the ",(0,he.jsx)("i",{children:"Max idle connections"})," ","will be reduced to match the ",(0,he.jsx)("i",{children:"Max open connections"})," limit. If set to 0, no idle connections are retained."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:o?(0,he.jsx)(_e.InlineLabel,{width:40,children:r.jsonData.maxIdleConns}):(0,he.jsx)(q_,{value:n.maxIdleConns,defaultValue:pe.config.sqlConnectionLimits.maxIdleConns,onChange:e=>{a("maxIdleConns")(e)},width:40})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Max lifetime"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"The maximum amount of time in seconds a connection may be reused. If set to 0, connections are reused forever."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(q_,{value:n.connMaxLifetime,defaultValue:pe.config.sqlConnectionLimits.connMaxLifetime,onChange:e=>{a("connMaxLifetime")(e)},width:40})})]})},H_=()=>{const e=(0,_e.useStyles2)($_);return(0,he.jsx)("hr",{className:e.horizontalDivider})},$_=e=>({horizontalDivider:(0,Fe.css)({borderTop:`1px solid ${e.colors.border.weak}`,margin:e.spacing(2,0),width:"100%"})}),Y_=e=>{const{editorProps:t,showCACert:r,showKeyPair:n=!0}=e,{secureJsonFields:o}=t.options;return(0,he.jsxs)(he.Fragment,{children:[n?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Client Certificate"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"To authenticate with an TLS/SSL client certificate, provide the client certificate here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsClientCert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientCert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientCert")}})}):null,r?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Root Certificate"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"If the selected TLS/SSL mode requires a server root certificate, provide it here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsCACert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsCACert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsCACert")}})}):null,n?(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(_e.Stack,{gap:.5,children:[(0,he.jsx)("span",{children:"TLS/SSL Client Key"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsx)("span",{children:"To authenticate with a client TLS/SSL certificate, provide the key here."}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.SecretTextArea,{placeholder:"-----BEGIN RSA PRIVATE KEY-----",cols:45,rows:7,isConfigured:o&&o.tlsClientKey,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientKey"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientKey")}})}):null]})},Q_=(0,pe.createMonitoringLogger)("features.plugins.sql");function X_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function J_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){X_(e,t,r[t])}))}return e}function Z_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function ew(e){return{ulPadding:(0,Fe.css)({margin:e.spacing(1,0),paddingLeft:e.spacing(5)})}}function tw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function rw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){tw(e,t,r[t])}))}return e}function nw(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function ow(e){switch(e){case"TIME":case"DATETIME":case"TIMESTAMP":return"clock-nine";case"BOOLEAN":return"toggle-off";case"INTEGER":case"FLOAT":case"FLOAT64":case"INT":case"SMALLINT":case"BIGINT":case"TINYINT":case"BYTEINT":case"INT64":case"NUMERIC":case"DECIMAL":return"calculator-alt";case"CHAR":case"VARCHAR":case"STRING":case"BYTES":case"TEXT":case"TINYTEXT":case"MEDIUMTEXT":case"LONGTEXT":return"text";case"GEOGRAPHY":return"map";default:return}}function iw({sql:e,dataset:t,table:r}){var n,o,i,a;let l="";return e&&we(e.columns)?(l+=`SELECT ${e.columns.map((e=>{let t="";var r;if(e.name&&e.alias)t+=`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>`${e.name}`))}) AS ${e.alias}`;else if(e.name){var n;t+=`${e.name}(${null===(n=e.parameters)||void 0===n?void 0:n.map((e=>`${e.name}`))})`}else if(e.alias){var o;t+=`${null===(o=e.parameters)||void 0===o?void 0:o.map((e=>`${e.name}`))} AS ${e.alias}`}else{var i;t+=`${null===(i=e.parameters)||void 0===i?void 0:i.map((e=>`${e.name}`))}`}return t})).join(", ")} `,t&&r&&(l+=`FROM ${t}.${r} `),e.whereString&&(l+=`WHERE ${e.whereString} `),(null===(o=e.groupBy)||void 0===o||null===(n=o[0])||void 0===n?void 0:n.property.name)&&(l+=`GROUP BY ${e.groupBy.map((e=>e.property.name)).filter((e=>!(0,fe.isEmpty)(e))).join(", ")} `),(null===(i=e.orderBy)||void 0===i?void 0:i.property.name)&&(l+=`ORDER BY ${e.orderBy.property.name} `),(null===(a=e.orderBy)||void 0===a?void 0:a.property.name)&&e.orderByDirection&&(l+=`${e.orderByDirection} `),void 0!==e.limit&&e.limit>=0&&(l+=`LIMIT ${e.limit} `),l):l}function aw(e){return function(e){const t=/^[a-zA-Z_][a-zA-Z0-9_$]*$/g.test(e);return!sw.includes(e.toUpperCase())&&t}(e)?e:`\`${e}\``}function lw(e){return"'"+e.replace(/'/g,"''")+"'"}const sw=["ACCESSIBLE","ADD","ALL","ALTER","ANALYZE","AND","AS","ASC","ASENSITIVE","BEFORE","BETWEEN","BIGINT","BINARY","BLOB","BOTH","BY","CALL","CASCADE","CASE","CHANGE","CHAR","CHARACTER","CHECK","COLLATE","COLUMN","CONDITION","CONSTRAINT","CONTINUE","CONVERT","CREATE","CROSS","CUBE","CUME_DIST","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATABASES","DAY_HOUR","DAY_MICROSECOND","DAY_MINUTE","DAY_SECOND","DEC","DECIMAL","DECLARE","DEFAULT","DELAYED","DELETE","DENSE_RANK","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DOUBLE","DROP","DUAL","EACH","ELSE","ELSEIF","EMPTY","ENCLOSED","ESCAPED","EXCEPT","EXISTS","EXIT","EXPLAIN","FALSE","FETCH","FIRST_VALUE","FLOAT","FLOAT4","FLOAT8","FOR","FORCE","FOREIGN","FROM","FULLTEXT","FUNCTION","GENERATED","GET","GRANT","GROUP","GROUPING","GROUPS","HAVING","HIGH_PRIORITY","HOUR_MICROSECOND","HOUR_MINUTE","HOUR_SECOND","IF","IGNORE","IN","INDEX","INFILE","INNER","INOUT","INSENSITIVE","INSERT","INT","INT1","INT2","INT3","INT4","INT8","INTEGER","INTERSECT","INTERVAL","INTO","IO_AFTER_GTIDS","IO_BEFORE_GTIDS","IS","ITERATE","JOIN","JSON_TABLE","KEY","KEYS","KILL","LAG","LAST_VALUE","LATERAL","LEAD","LEADING","LEAVE","LEFT","LIKE","LIMIT","LINEAR","LINES","LOAD","LOCALTIME","LOCALTIMESTAMP","LOCK","LONG","LONGBLOB","LONGTEXT","LOOP","LOW_PRIORITY","MASTER_BIND","MASTER_SSL_VERIFY_SERVER_CERT","MATCH","MAXVALUE","MEDIUMBLOB","MEDIUMINT","MEDIUMTEXT","MIDDLEINT","MINUTE_MICROSECOND","MINUTE_SECOND","MOD","MODIFIES","NATURAL","NOT","NO_WRITE_TO_BINLOG","NTH_VALUE","NTILE","NULL","NUMERIC","OF","ON","OPTIMIZE","OPTIMIZER_COSTS","OPTION","OPTIONALLY","OR","ORDER","OUT","OUTER","OUTFILE","OVER","PARTITION","PERCENT_RANK","PRECISION","PRIMARY","PROCEDURE","PURGE","RANGE","RANK","READ","READS","READ_WRITE","REAL","RECURSIVE","REFERENCES","REGEXP","RELEASE","RENAME","REPEAT","REPLACE","REQUIRE","RESIGNAL","RESTRICT","RETURN","REVOKE","RIGHT","RLIKE","ROW","ROWS","ROW_NUMBER","SCHEMA","SCHEMAS","SECOND_MICROSECOND","SELECT","SENSITIVE","SEPARATOR","SET","SHOW","SIGNAL","SMALLINT","SPATIAL","SPECIFIC","SQL","SQLEXCEPTION","SQLSTATE","SQLWARNING","SQL_BIG_RESULT","SQL_CALC_FOUND_ROWS","SQL_SMALL_RESULT","SSL","STARTING","STORED","STRAIGHT_JOIN","SYSTEM","TABLE","TERMINATED","THEN","TINYBLOB","TINYINT","TINYTEXT","TO","TRAILING","TRIGGER","TRUE","UNDO","UNION","UNIQUE","UNLOCK","UNSIGNED","UPDATE","USAGE","USE","USING","UTC_DATE","UTC_TIME","UTC_TIMESTAMP","VALUES","VARBINARY","VARCHAR","VARCHARACTER","VARYING","VIRTUAL","WHEN","WHERE","WHILE","WINDOW","WITH","WRITE","XOR","YEAR_MONTH","ZEROFILL"];function uw(e){return lw(function(e){return'"'===e[0]&&'"'===e[e.length-1]?e.substring(1,e.length-1).replace(/""/g,'"'):"`"===e[0]&&"`"===e[e.length-1]?e.substring(1,e.length-1):e}(e))}function cw(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function dw(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){cw(i,n,o,a,l,"next",e)}function l(e){cw(i,n,o,a,l,"throw",e)}a(void 0)}))}}function pw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function fw(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){pw(e,t,r[t])}))}return e}function vw(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const hw=({getMeta:e})=>(t,r)=>vw(fw({},r&&_r(0,r)),{customStatementPlacement:mw,customSuggestionKinds:bw(e)}),gw="afterDatabase",yw="FROM",mw=()=>[{id:gw,resolve:(e,t,r)=>{var n;return Boolean((null==e?void 0:e.is(ie.Delimiter,"."))&&(null==t?void 0:t.value)===yw&&((null==r?void 0:r.is(ie.IdentifierQuote))||(null==r?void 0:r.isIdentifier()))&&1===(null==e||null===(n=e.getPreviousUntil(ie.Keyword,[ie.IdentifierQuote],yw))||void 0===n?void 0:n.filter((e=>e.isIdentifier())).length))}}],bw=e=>()=>{return[{id:le.Tables,overrideDefault:!0,suggestionsResolver:(t=dw((function*(t){const r=Ow(t.currentToken);return(yield e({schema:r})).map(Ew(t))})),function(e){return t.apply(this,arguments)})},{id:le.Columns,overrideDefault:!0,suggestionsResolver:function(){var t=dw((function*(t){const r=Sw(t.currentToken),n=Ow(r),o=function(e){const t=null==e?void 0:e.getNextOfType(ie.Identifier);return null==t?void 0:t.value}(r);return n&&o?(yield e({schema:n,table:o})).map(Ew(t)):[]}));return function(e){return t.apply(this,arguments)}}()},{id:"tablesWithinDatabase",applyTo:[gw],suggestionsResolver:function(){var t=dw((function*(t){const r=Ow(t.currentToken);return(yield e({schema:r})).map(Ew(t))}));return function(e){return t.apply(this,arguments)}}()}];var t};function Ew(e){return function(t){var r;return{label:t.name,insertText:null!==(r=t.completion)&&void 0!==r?r:t.name,command:{id:"editor.action.triggerSuggest",title:""},kind:ue.Field,sortText:se.High,range:vw(fw({},e.range),{startColumn:e.range.endColumn,endColumn:e.range.endColumn})}}}function Ow(e){return(null==e?void 0:e.isIdentifier())&&"."!==e.value[e.value.length-1]?e.value:(null==e?void 0:e.is(ie.Delimiter,"."))?null===(t=e.getPreviousOfType(ie.Identifier))||void 0===t?void 0:t.value:(null==e?void 0:e.is(ie.IdentifierQuote))?(null===(r=e.getPreviousOfType(ie.Identifier))||void 0===r?void 0:r.value)||(null===(n=e.getNextOfType(ie.Identifier))||void 0===n?void 0:n.value):void 0;var t,r,n}const Sw=e=>{var t;const r=(e=>{var t;const r=null!==(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,"SELECT"))&&void 0!==t?t:null;return null==r?void 0:r.getNextOfType(ie.Keyword,yw)})(e),n=null==r?void 0:r.getNextOfType(ie.Identifier);return(null==n?void 0:n.isKeyword())&&(null===(t=n.next)||void 0===t?void 0:t.is(ie.Parenthesis,"("))?null:n};function Tw(e,t,r,n,o,i,a){try{var l=e[i](a),s=l.value}catch(e){return void r(e)}l.done?t(s):Promise.resolve(s).then(n,o)}function _w(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Tw(i,n,o,a,l,"next",e)}function l(e){Tw(i,n,o,a,l,"throw",e)}a(void 0)}))}}function ww(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}var Rw=Object.defineProperty,Iw=Object.defineProperties,Aw=Object.getOwnPropertyDescriptors,Cw=Object.getOwnPropertySymbols,Nw=Object.prototype.hasOwnProperty,Lw=Object.prototype.propertyIsEnumerable,jw=(e,t,r)=>t in e?Rw(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,xw=(e,t)=>{for(var r in t||(t={}))Nw.call(t,r)&&jw(e,r,t[r]);if(Cw)for(var r of Cw(t))Lw.call(t,r)&&jw(e,r,t[r]);return e};const Pw=({dataSourceName:e,docsLink:t,hasRequiredFields:r=!0,className:n})=>{const o=(0,_e.useTheme2)(),i={container:(0,Fe.css)({p:{margin:0},"p + p":{marginTop:o.spacing(2)}}),text:(0,Fe.css)((a=xw({},o.typography.body),l={color:o.colors.text.secondary,a:(0,Fe.css)({color:o.colors.text.link,textDecoration:"underline","&:hover":{textDecoration:"none"}})},Iw(a,Aw(l))))};var a,l;return ye().createElement("div",{className:(0,Fe.cx)(i.container,n)},ye().createElement("p",{className:i.text},"Before you can use the ",e," data source, you must configure it below or in the config file. For detailed instructions,"," ",ye().createElement("a",{href:t,target:"_blank",rel:"noreferrer"},"view the documentation"),"."),r&&ye().createElement("p",{className:i.text},ye().createElement("i",null,"Fields marked with * are required")))};var Fw=Object.defineProperty,Dw=Object.defineProperties,kw=Object.getOwnPropertyDescriptors,Mw=Object.getOwnPropertySymbols,Vw=Object.prototype.hasOwnProperty,Uw=Object.prototype.propertyIsEnumerable,Bw=(e,t,r)=>t in e?Fw(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Gw=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)Vw.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Mw)for(var n of Mw(e))t.indexOf(n)<0&&Uw.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return ye().createElement(P_,(t=((e,t)=>{for(var r in t||(t={}))Vw.call(t,r)&&Bw(e,r,t[r]);if(Mw)for(var r of Mw(t))Uw.call(t,r)&&Bw(e,r,t[r]);return e})({},o),Dw(t,kw({kind:"section"}))),n)};function qw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Kw=new T.DataSourcePlugin(class extends w_{getQueryModel(){return{quoteLiteral:lw}}getSqlLanguageDefinition(){if(void 0!==this.sqlLanguageDefinition)return this.sqlLanguageDefinition;const e={getMeta:e=>this.fetchMeta(e)};return this.sqlLanguageDefinition={id:"mysql",completionProvider:hw(e),formatter:Jr},this.sqlLanguageDefinition}fetchDatasets(){var e=this;return _w((function*(){return(yield e.runSql("SELECT DISTINCT TABLE_SCHEMA from information_schema.TABLES where TABLE_TYPE != 'SYSTEM VIEW' ORDER BY TABLE_SCHEMA",{refId:"datasets"})).map((e=>aw(e[0])))}))()}fetchTables(e){var t=this;return _w((function*(){const r=yield t.runSql(function(e){return`SELECT table_name FROM information_schema.tables WHERE table_schema = ${void 0!==e?uw(e):"database()"} ORDER BY table_name`}(e),{refId:"tables"});return r.map((e=>aw(e[0])))}))()}fetchFields(e){var t=this;return _w((function*(){if(!e.dataset||!e.table)return[];const r=function(e,t){let r="SELECT column_name, data_type FROM information_schema.columns WHERE ";return r+=function(e,t){let r="";if(e.includes(".")){const t=e.split(".");return r="table_schema = "+uw(t[0]),r+=" AND table_name = "+uw(t[1]),r}return r=`table_schema = ${void 0!==t?uw(t):"database()"} AND table_name = `+uw(e),r}(e,t),r+=" ORDER BY column_name",r}(e.table,e.dataset);return function(e){const t=[];for(const n of e){var r;let e="text";switch(null===(r=n.type)||void 0===r?void 0:r.toUpperCase()){case"BOOLEAN":case"BOOL":e="boolean";break;case"BYTES":case"VARCHAR":case"GEOGRAPHY":e="text";break;case"FLOAT":case"FLOAT64":case"INT":case"INTEGER":case"INT64":case"NUMERIC":case"BIGNUMERIC":e="number";break;case"DATE":e="date";break;case"DATETIME":case"TIMESTAMP":e="datetime";break;case"TIME":e="time"}t.push(nw(rw({},n),{raqbFieldType:e,icon:ow(n.type.toUpperCase())}))}return t}((yield t.runSql(r,{refId:"fields"})).map((e=>({name:e[0],text:e[0],value:aw(e[0]),type:e[1],label:e[0]}))))}))()}fetchMeta(e){var t=this;return _w((function*(){const r=t.instanceSettings.jsonData.database;return!(null==e?void 0:e.schema)&&r?(yield t.fetchTables(r)).map((e=>({name:e,completion:`${r}.${e}`,kind:ue.Class}))):(null==e?void 0:e.schema)||r?(null==e?void 0:e.table)||r&&!(null==e?void 0:e.schema)?(null==e?void 0:e.table)&&e.schema?(yield t.fetchFields({dataset:e.schema,table:e.table})).map((e=>({name:e.name,completion:e.value,kind:ue.Field}))):[]:(yield t.fetchTables(null==e?void 0:e.schema)).map((e=>({name:e,completion:e,kind:ue.Class}))):(yield t.fetchDatasets()).map((e=>({name:e,completion:`${e}.`,kind:ue.Module})))}))()}getDB(){return void 0!==this.db?this.db:{datasets:()=>this.fetchDatasets(),tables:e=>this.fetchTables(e),fields:e=>this.fetchFields(e),validateQuery:(e,t)=>Promise.resolve({query:e,error:"",isError:!1,isValid:!0}),dsID:()=>this.id,toRawSql:iw,functions:()=>["VARIANCE","STDDEV"],getEditorLanguageDefinition:()=>this.getSqlLanguageDefinition()}}constructor(e){super(e),ww(this,"instanceSettings",void 0),ww(this,"sqlLanguageDefinition",void 0),this.instanceSettings=e}}).setQueryEditor(v_).setQueryEditorHelp((function(){const e=(0,_e.useStyles2)(ew);return(0,he.jsxs)("div",{children:[(0,he.jsx)("h2",{children:"MySQL cheat sheet"}),"Time series:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"return column named time or time_sec (in UTC), as a unix time stamp or any sql native date data type. You can use the macros below."}),(0,he.jsx)("li",{children:"return column(s) with numeric datatype as values"})]}),"Optional:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsxs)("li",{children:["return column named ",(0,he.jsx)("i",{children:"metric"})," to represent the series name."]}),(0,he.jsx)("li",{children:"If multiple value columns are returned the metric column is used as prefix."}),(0,he.jsx)("li",{children:"If no column named metric is found the column name of the value column is used as series name"})]}),(0,he.jsx)("p",{children:"Resultsets of time series queries need to be sorted by time."}),"Table:",(0,he.jsx)("ul",{className:e.ulPadding,children:(0,he.jsx)("li",{children:"return any set of columns"})}),"Macros:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"$__time(column) -> UNIX_TIMESTAMP(column) as time_sec"}),(0,he.jsx)("li",{children:"$__timeEpoch(column) -> UNIX_TIMESTAMP(column) as time_sec"}),(0,he.jsx)("li",{children:"$__timeFilter(column) -> column BETWEEN FROM_UNIXTIME(1492750877) AND FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__unixEpochFilter(column) -> time_unix_epoch > 1492750877 AND time_unix_epoch < 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochNanoFilter(column) -> column >= 1494410783152415214 AND column <= 1494497183142514872"}),(0,he.jsx)("li",{children:"$__timeGroup(column,'5m'[, fillvalue]) -> cast(cast(UNIX_TIMESTAMP(column)/(300) as signed)*300 as signed) by setting fillvalue grafana will fill in missing values according to the interval fillvalue can be either a literal value, NULL or previous; previous will fill in the previous seen value or NULL if none has been seen yet"}),(0,he.jsx)("li",{children:"$__timeGroupAlias(column,'5m') -> cast(cast(UNIX_TIMESTAMP(column)/(300) as signed)*300 as signed) AS \"time\""}),(0,he.jsx)("li",{children:"$__unixEpochGroup(column,'5m') -> column DIV 300 * 300"}),(0,he.jsx)("li",{children:"$__unixEpochGroupAlias(column,'5m') -> column DIV 300 * 300 AS \"time\""})]}),(0,he.jsx)("p",{children:"Example of group by and order by with $__timeGroup:"}),(0,he.jsx)("pre",{children:(0,he.jsxs)("code",{children:["$__timeGroupAlias(timestamp_col, '1h'), sum(value_double) as value",(0,he.jsx)("br",{}),"FROM yourtable",(0,he.jsx)("br",{}),"GROUP BY 1",(0,he.jsx)("br",{}),"ORDER BY 1",(0,he.jsx)("br",{})]})}),"Or build your own conditionals using these macros which just return the values:",(0,he.jsxs)("ul",{className:e.ulPadding,children:[(0,he.jsx)("li",{children:"$__timeFrom() -> FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__timeTo() -> FROM_UNIXTIME(1492750877)"}),(0,he.jsx)("li",{children:"$__unixEpochFrom() -> 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochTo() -> 1492750877"}),(0,he.jsx)("li",{children:"$__unixEpochNanoFrom() -> 1494410783152415214"}),(0,he.jsx)("li",{children:"$__unixEpochNanoTo() -> 1494497183142514872"})]})]})})).setConfigEditor((e=>{const[t,r]=(0,ge.useState)(!0),{options:n,onOptionsChange:o}=e,i=n.jsonData;!function({onOptionsChange:e,options:t}){(0,ge.useEffect)((()=>{const r=t.jsonData;let n=J_({},t),o=!1;if(t.database&&(Q_.logDebug(`Migrating from options.database with value ${t.database} for ${t.name}`),n.database="",n.jsonData=Z_(J_({},r),{database:t.database}),o=!0),void 0===r.maxOpenConns&&void 0===r.maxIdleConns&&void 0===r.maxIdleConnsAuto){const{maxOpenConns:e,maxIdleConns:t}=pe.config.sqlConnectionLimits;Q_.logDebug(`Setting default max open connections to ${e} and setting max idle connection to ${t}`),n.jsonData=Z_(J_({},n.jsonData),{maxOpenConns:e,maxIdleConns:t,maxIdleConnsAuto:!0}),o=!0}if(void 0===r.connMaxLifetime){const{connMaxLifetime:e}=pe.config.sqlConnectionLimits;n.jsonData=Z_(J_({},n.jsonData),{connMaxLifetime:e}),o=!0}o&&e(n)}),[e,t])}(e);const a=e=>t=>{o(function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){qw(e,t,r[t])}))}return e}({},n,{[e]:t.currentTarget.value}))},l=t=>r=>{(0,T.updateDatasourcePluginJsonDataOption)(e,t,r.currentTarget.checked)},s=40;return(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(Pw,{dataSourceName:"MySQL",docsLink:"https://grafana.com/docs/grafana/latest/datasources/mysql/",hasRequiredFields:!0}),(0,he.jsx)(H_,{}),(0,he.jsxs)(_e.Collapse,{collapsible:!0,label:"User Permission",isOpen:t,onToggle:()=>r((e=>!e)),children:["The database user should only be granted SELECT permissions on the specified database & tables you want to query. ",(0,he.jsx)("br",{}),"Grafana does not validate that queries are safe so queries can contain any SQL statement. For example, statements like ",(0,he.jsx)("code",{children:"USE otherdb;"})," and ",(0,he.jsx)("code",{children:"DROP TABLE user;"})," would be executed. ",(0,he.jsx)("br",{}),"To protect against this we ",(0,he.jsx)("strong",{children:"Highly"})," recommend you create a specific MySQL user with restricted permissions. Check out the docs for more information."]}),(0,he.jsx)(H_,{}),(0,he.jsxs)(Gw,{title:"Connection",children:[(0,he.jsx)(_e.Field,{label:"Host URL",required:!0,children:(0,he.jsx)(_e.Input,{width:s,name:"host",type:"text",value:n.url||"",placeholder:"localhost:3306",onChange:a("url")})}),(0,he.jsx)(_e.Field,{label:"Database name",children:(0,he.jsx)(_e.Input,{width:s,name:"database",value:i.database||"",placeholder:"Database",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"database")})})]}),(0,he.jsx)(H_,{}),(0,he.jsxs)(Gw,{title:"Authentication",children:[(0,he.jsx)(_e.Field,{label:"Username",required:!0,children:(0,he.jsx)(_e.Input,{width:s,value:n.user||"",placeholder:"Username",onChange:a("user")})}),(0,he.jsx)(_e.Field,{label:"Password",children:(0,he.jsx)(_e.SecretInput,{width:s,placeholder:"Password",isConfigured:n.secureJsonFields&&n.secureJsonFields.password,onReset:()=>{(0,T.updateDatasourcePluginResetOption)(e,"password")},onBlur:(0,T.onUpdateDatasourceSecureJsonDataOption)(e,"password")})}),(0,he.jsx)(_e.Field,{label:"Use TLS Client Auth",description:"Enables TLS authentication using client cert configured in secure json data.",children:(0,he.jsx)(_e.Switch,{onChange:l("tlsAuth"),value:i.tlsAuth||!1})}),(0,he.jsx)(_e.Field,{label:"With CA Cert",description:"Needed for verifying self-signed TLS Certs.",children:(0,he.jsx)(_e.Switch,{onChange:l("tlsAuthWithCACert"),value:i.tlsAuthWithCACert||!1})}),(0,he.jsx)(_e.Field,{label:"Skip TLS Verification",description:"When enabled, skips verification of the MySQL server's TLS certificate chain and host name.",children:(0,he.jsx)(_e.Switch,{onChange:l("tlsSkipVerify"),value:i.tlsSkipVerify||!1})}),(0,he.jsx)(_e.Field,{label:"Allow Cleartext Passwords",description:"Allows using the cleartext client side plugin if required by an account.",children:(0,he.jsx)(_e.Switch,{onChange:l("allowCleartextPasswords"),value:i.allowCleartextPasswords||!1})})]}),i.tlsAuth||i.tlsAuthWithCACert?(0,he.jsxs)(he.Fragment,{children:[(0,he.jsx)(H_,{}),(0,he.jsx)(Gw,{title:"TLS/SSL Auth Details",children:i.tlsAuth||i.tlsAuthWithCACert?(0,he.jsx)(Y_,{showCACert:i.tlsAuthWithCACert,showKeyPair:i.tlsAuth,editorProps:e,labelWidth:s}):null})]}):null,(0,he.jsx)(H_,{}),(0,he.jsxs)(Gw,{title:"Additional settings",isCollapsible:!0,children:[(0,he.jsxs)(G_,{title:"MySQL Options",children:[(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Session timezone"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["Specify the timezone used in the database session, such as ",(0,he.jsx)("code",{children:"Europe/Berlin"})," or",(0,he.jsx)("code",{children:"+02:00"}),". Required if the timezone of the database (or the host of the database) is set to something other than UTC. Set this to ",(0,he.jsx)("code",{children:"+00:00"})," so Grafana can handle times properly. Set the value used in the session with ",(0,he.jsx)("code",{children:"SET time_zone='...'"}),". If you leave this field empty, the timezone will not be updated. You can find more information in the MySQL documentation."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,he.jsx)(_e.Input,{width:s,value:i.timezone||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"timezone"),placeholder:"Europe/Berlin or +02:00"})}),(0,he.jsx)(_e.Field,{label:(0,he.jsx)(_e.Label,{children:(0,he.jsxs)(rt,{gap:.5,children:[(0,he.jsx)("span",{children:"Min time interval"}),(0,he.jsx)(_e.Tooltip,{content:(0,he.jsxs)("span",{children:["A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example",(0,he.jsx)("code",{children:"1m"})," if your data is written every minute."]}),children:(0,he.jsx)(_e.Icon,{name:"info-circle",size:"sm"})})]})}),description:"A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example 1m if your data is written every minute.",children:(0,he.jsx)(_e.Input,{width:s,placeholder:"1m",value:i.timeInterval||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"timeInterval")})})]}),(0,he.jsx)(z_,{options:n,onOptionsChange:o}),pe.config.secureSocksDSProxyEnabled&&(0,he.jsx)(_e.SecureSocksProxySettings,{options:n,onOptionsChange:o})]})]})}))})(),f})()));
//# sourceMappingURL=module.js.map